/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG form generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/





























#include "../N1E1ElementwiseCurlCurlPlusMass.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void N1E1ElementwiseCurlCurlPlusMass::computeInverseDiagonalOperatorValues_macro_3D( walberla::float64 * RESTRICT  _data_alpha, walberla::float64 * RESTRICT  _data_beta, walberla::float64 * RESTRICT  _data_invDiag_, walberla::float64 macro_vertex_coord_id_0comp0, walberla::float64 macro_vertex_coord_id_0comp1, walberla::float64 macro_vertex_coord_id_0comp2, walberla::float64 macro_vertex_coord_id_1comp0, walberla::float64 macro_vertex_coord_id_1comp1, walberla::float64 macro_vertex_coord_id_1comp2, walberla::float64 macro_vertex_coord_id_2comp0, walberla::float64 macro_vertex_coord_id_2comp1, walberla::float64 macro_vertex_coord_id_2comp2, walberla::float64 macro_vertex_coord_id_3comp0, walberla::float64 macro_vertex_coord_id_3comp1, walberla::float64 macro_vertex_coord_id_3comp2, int64_t micro_edges_per_macro_edge, walberla::float64 micro_edges_per_macro_edge_float ) const
{
    {
       const walberla::float64 tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const walberla::float64 tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const walberla::float64 tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const walberla::float64 tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const walberla::float64 tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const walberla::float64 tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const walberla::float64 tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const walberla::float64 tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const walberla::float64 tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const walberla::float64 tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const walberla::float64 p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const walberla::float64 p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const walberla::float64 p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const walberla::float64 p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const walberla::float64 p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const walberla::float64 p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const walberla::float64 p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const walberla::float64 p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const walberla::float64 p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const walberla::float64 p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const walberla::float64 p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const walberla::float64 p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const walberla::float64 jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const walberla::float64 jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const walberla::float64 jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const walberla::float64 jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const walberla::float64 jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const walberla::float64 tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const walberla::float64 jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const walberla::float64 tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const walberla::float64 jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const walberla::float64 jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const walberla::float64 tmp_coords_jac_11_GREEN_DOWN = jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
       const walberla::float64 jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const walberla::float64 tmp_coords_jac_10_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const walberla::float64 tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const walberla::float64 tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_0_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
       const walberla::float64 tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_0_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_0_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_1_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_1_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_2_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_2_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const walberla::float64 abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       const walberla::float64 tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const walberla::float64 tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const walberla::float64 tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const walberla::float64 tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const walberla::float64 tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const walberla::float64 tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const walberla::float64 tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const walberla::float64 p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const walberla::float64 p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const walberla::float64 p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const walberla::float64 p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const walberla::float64 p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const walberla::float64 p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const walberla::float64 p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const walberla::float64 p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const walberla::float64 p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const walberla::float64 p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const walberla::float64 p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const walberla::float64 p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const walberla::float64 jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const walberla::float64 jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const walberla::float64 jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const walberla::float64 jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const walberla::float64 jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const walberla::float64 tmp_coords_jac_11_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const walberla::float64 jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const walberla::float64 tmp_coords_jac_9_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const walberla::float64 jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const walberla::float64 jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const walberla::float64 tmp_coords_jac_8_GREEN_UP = jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP;
       const walberla::float64 jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const walberla::float64 tmp_coords_jac_7_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const walberla::float64 tmp_coords_jac_10_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const walberla::float64 tmp_coords_jac_12_GREEN_UP = jac_affine_0_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_0_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_0_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
       const walberla::float64 tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const walberla::float64 jac_affine_inv_0_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
       const walberla::float64 jac_affine_inv_0_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_2_1_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const walberla::float64 jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const walberla::float64 jac_affine_inv_1_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const walberla::float64 jac_affine_inv_1_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const walberla::float64 jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const walberla::float64 jac_affine_inv_2_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const walberla::float64 jac_affine_inv_2_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const walberla::float64 jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const walberla::float64 abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       const walberla::float64 tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const walberla::float64 tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const walberla::float64 tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const walberla::float64 tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const walberla::float64 tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const walberla::float64 tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const walberla::float64 tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const walberla::float64 tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const walberla::float64 p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const walberla::float64 p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const walberla::float64 p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const walberla::float64 p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const walberla::float64 p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const walberla::float64 p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const walberla::float64 p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const walberla::float64 p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const walberla::float64 p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const walberla::float64 p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const walberla::float64 p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const walberla::float64 p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const walberla::float64 jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const walberla::float64 jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const walberla::float64 jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const walberla::float64 jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const walberla::float64 jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const walberla::float64 jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const walberla::float64 jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const walberla::float64 jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_11_BLUE_DOWN = jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
       const walberla::float64 jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_10_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_0_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_0_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_0_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_1_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_1_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_2_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_2_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const walberla::float64 abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       const walberla::float64 tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const walberla::float64 tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const walberla::float64 tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const walberla::float64 tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const walberla::float64 tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const walberla::float64 tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const walberla::float64 tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const walberla::float64 p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const walberla::float64 p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const walberla::float64 p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const walberla::float64 p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const walberla::float64 p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const walberla::float64 p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const walberla::float64 p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const walberla::float64 p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const walberla::float64 p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const walberla::float64 p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const walberla::float64 p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const walberla::float64 p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const walberla::float64 jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const walberla::float64 jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const walberla::float64 jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const walberla::float64 jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const walberla::float64 jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const walberla::float64 tmp_coords_jac_11_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const walberla::float64 jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const walberla::float64 tmp_coords_jac_9_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const walberla::float64 jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const walberla::float64 jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const walberla::float64 tmp_coords_jac_8_BLUE_UP = jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP;
       const walberla::float64 jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const walberla::float64 tmp_coords_jac_7_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const walberla::float64 tmp_coords_jac_10_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const walberla::float64 tmp_coords_jac_12_BLUE_UP = jac_affine_0_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_0_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_0_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
       const walberla::float64 tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const walberla::float64 jac_affine_inv_0_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
       const walberla::float64 jac_affine_inv_0_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_2_1_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const walberla::float64 jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const walberla::float64 jac_affine_inv_1_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const walberla::float64 jac_affine_inv_1_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const walberla::float64 jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const walberla::float64 jac_affine_inv_2_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const walberla::float64 jac_affine_inv_2_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const walberla::float64 jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const walberla::float64 abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       const walberla::float64 tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const walberla::float64 tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const walberla::float64 tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const walberla::float64 tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const walberla::float64 tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const walberla::float64 tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const walberla::float64 tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const walberla::float64 tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const walberla::float64 tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const walberla::float64 tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const walberla::float64 p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const walberla::float64 p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const walberla::float64 p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const walberla::float64 p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const walberla::float64 p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const walberla::float64 p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const walberla::float64 p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const walberla::float64 p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const walberla::float64 p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const walberla::float64 p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const walberla::float64 p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const walberla::float64 p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const walberla::float64 jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const walberla::float64 jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const walberla::float64 jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const walberla::float64 jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const walberla::float64 jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const walberla::float64 jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const walberla::float64 jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const walberla::float64 jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_14_WHITE_DOWN = jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
       const walberla::float64 jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_13_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_0_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_0_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_0_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_1_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_1_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_2_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_2_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const walberla::float64 abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       const walberla::float64 tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const walberla::float64 p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const walberla::float64 p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const walberla::float64 p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const walberla::float64 p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const walberla::float64 p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const walberla::float64 p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const walberla::float64 p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const walberla::float64 p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const walberla::float64 p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const walberla::float64 p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const walberla::float64 p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const walberla::float64 p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const walberla::float64 jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const walberla::float64 jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const walberla::float64 jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const walberla::float64 jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const walberla::float64 jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const walberla::float64 tmp_coords_jac_5_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const walberla::float64 jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const walberla::float64 tmp_coords_jac_3_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const walberla::float64 jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const walberla::float64 jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const walberla::float64 tmp_coords_jac_2_WHITE_UP = jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP;
       const walberla::float64 jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const walberla::float64 tmp_coords_jac_1_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const walberla::float64 tmp_coords_jac_4_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const walberla::float64 tmp_coords_jac_6_WHITE_UP = jac_affine_0_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_0_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_0_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
       const walberla::float64 tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const walberla::float64 jac_affine_inv_0_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
       const walberla::float64 jac_affine_inv_0_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_2_1_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const walberla::float64 jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const walberla::float64 jac_affine_inv_1_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const walberla::float64 jac_affine_inv_1_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const walberla::float64 jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const walberla::float64 jac_affine_inv_2_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const walberla::float64 jac_affine_inv_2_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const walberla::float64 jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const walberla::float64 abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       const walberla::float64 tmp_kernel_op_0 = -0.17842745903238022;
       const walberla::float64 tmp_kernel_op_1 = tmp_kernel_op_0 + 0.039933048641498423;
       const walberla::float64 tmp_kernel_op_2 = -tmp_kernel_op_1 - 0.01482761006242336;
       const walberla::float64 tmp_kernel_op_4 = 1.0 / (abs_det_jac_affine_WHITE_UP);
       const walberla::float64 tmp_kernel_op_5 = tmp_kernel_op_4*((jac_affine_0_0_WHITE_UP*jac_affine_0_0_WHITE_UP)*4.0 + (jac_affine_1_0_WHITE_UP*jac_affine_1_0_WHITE_UP)*4.0 + (jac_affine_2_0_WHITE_UP*jac_affine_2_0_WHITE_UP)*4.0);
       const walberla::float64 tmp_kernel_op_6 = jac_affine_inv_1_0_WHITE_UP*0.01482761006242336;
       const walberla::float64 tmp_kernel_op_7 = jac_affine_inv_1_1_WHITE_UP*0.01482761006242336;
       const walberla::float64 tmp_kernel_op_8 = jac_affine_inv_1_2_WHITE_UP*0.01482761006242336;
       const walberla::float64 tmp_kernel_op_10 = -0.84406687950081394;
       const walberla::float64 tmp_kernel_op_11 = tmp_kernel_op_10 + 0.3817653560693467;
       const walberla::float64 tmp_kernel_op_12 = -tmp_kernel_op_11 - 0.0048399363458717648;
       const walberla::float64 tmp_kernel_op_14 = jac_affine_inv_1_0_WHITE_UP*0.0048399363458717648;
       const walberla::float64 tmp_kernel_op_15 = jac_affine_inv_1_1_WHITE_UP*0.0048399363458717648;
       const walberla::float64 tmp_kernel_op_16 = jac_affine_inv_1_2_WHITE_UP*0.0048399363458717648;
       const walberla::float64 tmp_kernel_op_18 = -0.81997030648963465;
       const walberla::float64 tmp_kernel_op_19 = tmp_kernel_op_18 + 0.0069232355736274674;
       const walberla::float64 tmp_kernel_op_20 = -tmp_kernel_op_19 - 0.44773255210137269;
       const walberla::float64 tmp_kernel_op_22 = jac_affine_inv_1_0_WHITE_UP*0.44773255210137269;
       const walberla::float64 tmp_kernel_op_23 = jac_affine_inv_1_1_WHITE_UP*0.44773255210137269;
       const walberla::float64 tmp_kernel_op_24 = jac_affine_inv_1_2_WHITE_UP*0.44773255210137269;
       const walberla::float64 tmp_kernel_op_26 = -0.78392357081515218;
       const walberla::float64 tmp_kernel_op_27 = tmp_kernel_op_26 + 0.43070170707783612;
       const walberla::float64 tmp_kernel_op_28 = -tmp_kernel_op_27 - 0.35284634870858678;
       const walberla::float64 tmp_kernel_op_30 = jac_affine_inv_1_0_WHITE_UP*0.35284634870858678;
       const walberla::float64 tmp_kernel_op_31 = jac_affine_inv_1_1_WHITE_UP*0.35284634870858678;
       const walberla::float64 tmp_kernel_op_32 = jac_affine_inv_1_2_WHITE_UP*0.35284634870858678;
       const walberla::float64 tmp_kernel_op_34 = tmp_kernel_op_4*((jac_affine_0_1_WHITE_UP*jac_affine_0_1_WHITE_UP)*4.0 + (jac_affine_1_1_WHITE_UP*jac_affine_1_1_WHITE_UP)*4.0 + (jac_affine_2_1_WHITE_UP*jac_affine_2_1_WHITE_UP)*4.0);
       const walberla::float64 tmp_kernel_op_35 = jac_affine_inv_0_0_WHITE_UP*0.01482761006242336;
       const walberla::float64 tmp_kernel_op_36 = jac_affine_inv_0_1_WHITE_UP*0.01482761006242336;
       const walberla::float64 tmp_kernel_op_37 = jac_affine_inv_0_2_WHITE_UP*0.01482761006242336;
       const walberla::float64 tmp_kernel_op_38 = jac_affine_inv_0_0_WHITE_UP*0.0048399363458717648;
       const walberla::float64 tmp_kernel_op_39 = jac_affine_inv_0_1_WHITE_UP*0.0048399363458717648;
       const walberla::float64 tmp_kernel_op_40 = jac_affine_inv_0_2_WHITE_UP*0.0048399363458717648;
       const walberla::float64 tmp_kernel_op_41 = jac_affine_inv_0_0_WHITE_UP*0.44773255210137269;
       const walberla::float64 tmp_kernel_op_42 = jac_affine_inv_0_1_WHITE_UP*0.44773255210137269;
       const walberla::float64 tmp_kernel_op_43 = jac_affine_inv_0_2_WHITE_UP*0.44773255210137269;
       const walberla::float64 tmp_kernel_op_44 = jac_affine_inv_0_0_WHITE_UP*0.35284634870858678;
       const walberla::float64 tmp_kernel_op_45 = jac_affine_inv_0_1_WHITE_UP*0.35284634870858678;
       const walberla::float64 tmp_kernel_op_46 = jac_affine_inv_0_2_WHITE_UP*0.35284634870858678;
       const walberla::float64 tmp_kernel_op_47 = tmp_kernel_op_4*((jac_affine_0_2_WHITE_UP*jac_affine_0_2_WHITE_UP)*4.0 + (jac_affine_1_2_WHITE_UP*jac_affine_1_2_WHITE_UP)*4.0 + (jac_affine_2_2_WHITE_UP*jac_affine_2_2_WHITE_UP)*4.0);
       const walberla::float64 tmp_kernel_op_48 = jac_affine_inv_0_0_WHITE_UP*0.039933048641498423;
       const walberla::float64 tmp_kernel_op_49 = jac_affine_inv_0_1_WHITE_UP*0.039933048641498423;
       const walberla::float64 tmp_kernel_op_50 = jac_affine_inv_0_2_WHITE_UP*0.039933048641498423;
       const walberla::float64 tmp_kernel_op_51 = jac_affine_inv_0_0_WHITE_UP*0.3817653560693467;
       const walberla::float64 tmp_kernel_op_52 = jac_affine_inv_0_1_WHITE_UP*0.3817653560693467;
       const walberla::float64 tmp_kernel_op_53 = jac_affine_inv_0_2_WHITE_UP*0.3817653560693467;
       const walberla::float64 tmp_kernel_op_54 = jac_affine_inv_0_0_WHITE_UP*0.0069232355736274674;
       const walberla::float64 tmp_kernel_op_55 = jac_affine_inv_0_1_WHITE_UP*0.0069232355736274674;
       const walberla::float64 tmp_kernel_op_56 = jac_affine_inv_0_2_WHITE_UP*0.0069232355736274674;
       const walberla::float64 tmp_kernel_op_57 = jac_affine_inv_0_0_WHITE_UP*0.43070170707783612;
       const walberla::float64 tmp_kernel_op_58 = jac_affine_inv_0_1_WHITE_UP*0.43070170707783612;
       const walberla::float64 tmp_kernel_op_59 = jac_affine_inv_0_2_WHITE_UP*0.43070170707783612;
       const walberla::float64 tmp_kernel_op_60 = jac_affine_0_0_WHITE_UP*2.0;
       const walberla::float64 tmp_kernel_op_61 = jac_affine_0_1_WHITE_UP*2.0;
       const walberla::float64 tmp_kernel_op_62 = jac_affine_1_0_WHITE_UP*2.0;
       const walberla::float64 tmp_kernel_op_63 = jac_affine_1_1_WHITE_UP*2.0;
       const walberla::float64 tmp_kernel_op_64 = jac_affine_2_0_WHITE_UP*2.0;
       const walberla::float64 tmp_kernel_op_65 = jac_affine_2_1_WHITE_UP*2.0;
       const walberla::float64 tmp_kernel_op_66 = tmp_kernel_op_4*(((-tmp_kernel_op_60 + tmp_kernel_op_61)*(-tmp_kernel_op_60 + tmp_kernel_op_61)) + ((-tmp_kernel_op_62 + tmp_kernel_op_63)*(-tmp_kernel_op_62 + tmp_kernel_op_63)) + ((-tmp_kernel_op_64 + tmp_kernel_op_65)*(-tmp_kernel_op_64 + tmp_kernel_op_65)));
       const walberla::float64 tmp_kernel_op_67 = -tmp_kernel_op_1;
       const walberla::float64 tmp_kernel_op_68 = -tmp_kernel_op_11;
       const walberla::float64 tmp_kernel_op_69 = -tmp_kernel_op_19;
       const walberla::float64 tmp_kernel_op_70 = -tmp_kernel_op_27;
       const walberla::float64 tmp_kernel_op_71 = jac_affine_0_2_WHITE_UP*-2.0;
       const walberla::float64 tmp_kernel_op_72 = jac_affine_1_2_WHITE_UP*-2.0;
       const walberla::float64 tmp_kernel_op_73 = jac_affine_2_2_WHITE_UP*-2.0;
       const walberla::float64 tmp_kernel_op_74 = tmp_kernel_op_4*(((tmp_kernel_op_60 + tmp_kernel_op_71)*(tmp_kernel_op_60 + tmp_kernel_op_71)) + ((tmp_kernel_op_62 + tmp_kernel_op_72)*(tmp_kernel_op_62 + tmp_kernel_op_72)) + ((tmp_kernel_op_64 + tmp_kernel_op_73)*(tmp_kernel_op_64 + tmp_kernel_op_73)));
       const walberla::float64 tmp_kernel_op_75 = -tmp_kernel_op_0 - 0.01482761006242336;
       const walberla::float64 tmp_kernel_op_76 = -tmp_kernel_op_10 - 0.0048399363458717648;
       const walberla::float64 tmp_kernel_op_77 = -tmp_kernel_op_18 - 0.44773255210137269;
       const walberla::float64 tmp_kernel_op_78 = -tmp_kernel_op_26 - 0.35284634870858678;
       const walberla::float64 tmp_kernel_op_79 = tmp_kernel_op_4*(((-tmp_kernel_op_61 - tmp_kernel_op_71)*(-tmp_kernel_op_61 - tmp_kernel_op_71)) + ((-tmp_kernel_op_63 - tmp_kernel_op_72)*(-tmp_kernel_op_63 - tmp_kernel_op_72)) + ((-tmp_kernel_op_65 - tmp_kernel_op_73)*(-tmp_kernel_op_65 - tmp_kernel_op_73)));
       const walberla::float64 tmp_kernel_op_80 = 0.94523934129607823;
       const walberla::float64 tmp_kernel_op_81 = 0.61339470758478154;
       const walberla::float64 tmp_kernel_op_82 = 0.54534421232499986;
       const walberla::float64 tmp_kernel_op_83 = 0.21645194421357716;
       const walberla::float64 Dummy_4315 = 1.0 / (abs_det_jac_affine_WHITE_DOWN);
       const walberla::float64 Dummy_4316 = Dummy_4315*((jac_affine_0_0_WHITE_DOWN*jac_affine_0_0_WHITE_DOWN)*4.0 + (jac_affine_1_0_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN)*4.0 + (jac_affine_2_0_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN)*4.0);
       const walberla::float64 Dummy_4317 = jac_affine_inv_1_0_WHITE_DOWN*0.01482761006242336;
       const walberla::float64 Dummy_4318 = jac_affine_inv_1_1_WHITE_DOWN*0.01482761006242336;
       const walberla::float64 Dummy_4319 = jac_affine_inv_1_2_WHITE_DOWN*0.01482761006242336;
       const walberla::float64 Dummy_4322 = jac_affine_inv_1_0_WHITE_DOWN*0.0048399363458717648;
       const walberla::float64 Dummy_4323 = jac_affine_inv_1_1_WHITE_DOWN*0.0048399363458717648;
       const walberla::float64 Dummy_4324 = jac_affine_inv_1_2_WHITE_DOWN*0.0048399363458717648;
       const walberla::float64 Dummy_4327 = jac_affine_inv_1_0_WHITE_DOWN*0.44773255210137269;
       const walberla::float64 Dummy_4328 = jac_affine_inv_1_1_WHITE_DOWN*0.44773255210137269;
       const walberla::float64 Dummy_4329 = jac_affine_inv_1_2_WHITE_DOWN*0.44773255210137269;
       const walberla::float64 Dummy_4332 = jac_affine_inv_1_0_WHITE_DOWN*0.35284634870858678;
       const walberla::float64 Dummy_4333 = jac_affine_inv_1_1_WHITE_DOWN*0.35284634870858678;
       const walberla::float64 Dummy_4334 = jac_affine_inv_1_2_WHITE_DOWN*0.35284634870858678;
       const walberla::float64 Dummy_4336 = Dummy_4315*((jac_affine_0_1_WHITE_DOWN*jac_affine_0_1_WHITE_DOWN)*4.0 + (jac_affine_1_1_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN)*4.0 + (jac_affine_2_1_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN)*4.0);
       const walberla::float64 Dummy_4337 = jac_affine_inv_0_0_WHITE_DOWN*0.01482761006242336;
       const walberla::float64 Dummy_4338 = jac_affine_inv_0_1_WHITE_DOWN*0.01482761006242336;
       const walberla::float64 Dummy_4339 = jac_affine_inv_0_2_WHITE_DOWN*0.01482761006242336;
       const walberla::float64 Dummy_4340 = jac_affine_inv_0_0_WHITE_DOWN*0.0048399363458717648;
       const walberla::float64 Dummy_4341 = jac_affine_inv_0_1_WHITE_DOWN*0.0048399363458717648;
       const walberla::float64 Dummy_4342 = jac_affine_inv_0_2_WHITE_DOWN*0.0048399363458717648;
       const walberla::float64 Dummy_4343 = jac_affine_inv_0_0_WHITE_DOWN*0.44773255210137269;
       const walberla::float64 Dummy_4344 = jac_affine_inv_0_1_WHITE_DOWN*0.44773255210137269;
       const walberla::float64 Dummy_4345 = jac_affine_inv_0_2_WHITE_DOWN*0.44773255210137269;
       const walberla::float64 Dummy_4346 = jac_affine_inv_0_0_WHITE_DOWN*0.35284634870858678;
       const walberla::float64 Dummy_4347 = jac_affine_inv_0_1_WHITE_DOWN*0.35284634870858678;
       const walberla::float64 Dummy_4348 = jac_affine_inv_0_2_WHITE_DOWN*0.35284634870858678;
       const walberla::float64 Dummy_4349 = Dummy_4315*((jac_affine_0_2_WHITE_DOWN*jac_affine_0_2_WHITE_DOWN)*4.0 + (jac_affine_1_2_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN)*4.0 + (jac_affine_2_2_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN)*4.0);
       const walberla::float64 Dummy_4350 = jac_affine_inv_0_0_WHITE_DOWN*0.039933048641498423;
       const walberla::float64 Dummy_4351 = jac_affine_inv_0_1_WHITE_DOWN*0.039933048641498423;
       const walberla::float64 Dummy_4352 = jac_affine_inv_0_2_WHITE_DOWN*0.039933048641498423;
       const walberla::float64 Dummy_4353 = jac_affine_inv_0_0_WHITE_DOWN*0.3817653560693467;
       const walberla::float64 Dummy_4354 = jac_affine_inv_0_1_WHITE_DOWN*0.3817653560693467;
       const walberla::float64 Dummy_4355 = jac_affine_inv_0_2_WHITE_DOWN*0.3817653560693467;
       const walberla::float64 Dummy_4356 = jac_affine_inv_0_0_WHITE_DOWN*0.0069232355736274674;
       const walberla::float64 Dummy_4357 = jac_affine_inv_0_1_WHITE_DOWN*0.0069232355736274674;
       const walberla::float64 Dummy_4358 = jac_affine_inv_0_2_WHITE_DOWN*0.0069232355736274674;
       const walberla::float64 Dummy_4359 = jac_affine_inv_0_0_WHITE_DOWN*0.43070170707783612;
       const walberla::float64 Dummy_4360 = jac_affine_inv_0_1_WHITE_DOWN*0.43070170707783612;
       const walberla::float64 Dummy_4361 = jac_affine_inv_0_2_WHITE_DOWN*0.43070170707783612;
       const walberla::float64 Dummy_4362 = jac_affine_0_0_WHITE_DOWN*2.0;
       const walberla::float64 Dummy_4363 = jac_affine_0_1_WHITE_DOWN*2.0;
       const walberla::float64 Dummy_4364 = jac_affine_1_0_WHITE_DOWN*2.0;
       const walberla::float64 Dummy_4365 = jac_affine_1_1_WHITE_DOWN*2.0;
       const walberla::float64 Dummy_4366 = jac_affine_2_0_WHITE_DOWN*2.0;
       const walberla::float64 Dummy_4367 = jac_affine_2_1_WHITE_DOWN*2.0;
       const walberla::float64 Dummy_4368 = Dummy_4315*(((-Dummy_4362 + Dummy_4363)*(-Dummy_4362 + Dummy_4363)) + ((-Dummy_4364 + Dummy_4365)*(-Dummy_4364 + Dummy_4365)) + ((-Dummy_4366 + Dummy_4367)*(-Dummy_4366 + Dummy_4367)));
       const walberla::float64 Dummy_4369 = jac_affine_0_2_WHITE_DOWN*-2.0;
       const walberla::float64 Dummy_4370 = jac_affine_1_2_WHITE_DOWN*-2.0;
       const walberla::float64 Dummy_4371 = jac_affine_2_2_WHITE_DOWN*-2.0;
       const walberla::float64 Dummy_4372 = Dummy_4315*(((Dummy_4362 + Dummy_4369)*(Dummy_4362 + Dummy_4369)) + ((Dummy_4364 + Dummy_4370)*(Dummy_4364 + Dummy_4370)) + ((Dummy_4366 + Dummy_4371)*(Dummy_4366 + Dummy_4371)));
       const walberla::float64 Dummy_4373 = Dummy_4315*(((-Dummy_4363 - Dummy_4369)*(-Dummy_4363 - Dummy_4369)) + ((-Dummy_4365 - Dummy_4370)*(-Dummy_4365 - Dummy_4370)) + ((-Dummy_4367 - Dummy_4371)*(-Dummy_4367 - Dummy_4371)));
       const walberla::float64 Dummy_4389 = 1.0 / (abs_det_jac_affine_BLUE_UP);
       const walberla::float64 Dummy_4390 = Dummy_4389*((jac_affine_0_0_BLUE_UP*jac_affine_0_0_BLUE_UP)*4.0 + (jac_affine_1_0_BLUE_UP*jac_affine_1_0_BLUE_UP)*4.0 + (jac_affine_2_0_BLUE_UP*jac_affine_2_0_BLUE_UP)*4.0);
       const walberla::float64 Dummy_4391 = jac_affine_inv_1_0_BLUE_UP*0.01482761006242336;
       const walberla::float64 Dummy_4392 = jac_affine_inv_1_1_BLUE_UP*0.01482761006242336;
       const walberla::float64 Dummy_4393 = jac_affine_inv_1_2_BLUE_UP*0.01482761006242336;
       const walberla::float64 Dummy_4396 = jac_affine_inv_1_0_BLUE_UP*0.0048399363458717648;
       const walberla::float64 Dummy_4397 = jac_affine_inv_1_1_BLUE_UP*0.0048399363458717648;
       const walberla::float64 Dummy_4398 = jac_affine_inv_1_2_BLUE_UP*0.0048399363458717648;
       const walberla::float64 Dummy_4401 = jac_affine_inv_1_0_BLUE_UP*0.44773255210137269;
       const walberla::float64 Dummy_4402 = jac_affine_inv_1_1_BLUE_UP*0.44773255210137269;
       const walberla::float64 Dummy_4403 = jac_affine_inv_1_2_BLUE_UP*0.44773255210137269;
       const walberla::float64 Dummy_4406 = jac_affine_inv_1_0_BLUE_UP*0.35284634870858678;
       const walberla::float64 Dummy_4407 = jac_affine_inv_1_1_BLUE_UP*0.35284634870858678;
       const walberla::float64 Dummy_4408 = jac_affine_inv_1_2_BLUE_UP*0.35284634870858678;
       const walberla::float64 Dummy_4410 = Dummy_4389*((jac_affine_0_1_BLUE_UP*jac_affine_0_1_BLUE_UP)*4.0 + (jac_affine_1_1_BLUE_UP*jac_affine_1_1_BLUE_UP)*4.0 + (jac_affine_2_1_BLUE_UP*jac_affine_2_1_BLUE_UP)*4.0);
       const walberla::float64 Dummy_4411 = jac_affine_inv_0_0_BLUE_UP*0.01482761006242336;
       const walberla::float64 Dummy_4412 = jac_affine_inv_0_1_BLUE_UP*0.01482761006242336;
       const walberla::float64 Dummy_4413 = jac_affine_inv_0_2_BLUE_UP*0.01482761006242336;
       const walberla::float64 Dummy_4414 = jac_affine_inv_0_0_BLUE_UP*0.0048399363458717648;
       const walberla::float64 Dummy_4415 = jac_affine_inv_0_1_BLUE_UP*0.0048399363458717648;
       const walberla::float64 Dummy_4416 = jac_affine_inv_0_2_BLUE_UP*0.0048399363458717648;
       const walberla::float64 Dummy_4417 = jac_affine_inv_0_0_BLUE_UP*0.44773255210137269;
       const walberla::float64 Dummy_4418 = jac_affine_inv_0_1_BLUE_UP*0.44773255210137269;
       const walberla::float64 Dummy_4419 = jac_affine_inv_0_2_BLUE_UP*0.44773255210137269;
       const walberla::float64 Dummy_4420 = jac_affine_inv_0_0_BLUE_UP*0.35284634870858678;
       const walberla::float64 Dummy_4421 = jac_affine_inv_0_1_BLUE_UP*0.35284634870858678;
       const walberla::float64 Dummy_4422 = jac_affine_inv_0_2_BLUE_UP*0.35284634870858678;
       const walberla::float64 Dummy_4423 = Dummy_4389*((jac_affine_0_2_BLUE_UP*jac_affine_0_2_BLUE_UP)*4.0 + (jac_affine_1_2_BLUE_UP*jac_affine_1_2_BLUE_UP)*4.0 + (jac_affine_2_2_BLUE_UP*jac_affine_2_2_BLUE_UP)*4.0);
       const walberla::float64 Dummy_4424 = jac_affine_inv_0_0_BLUE_UP*0.039933048641498423;
       const walberla::float64 Dummy_4425 = jac_affine_inv_0_1_BLUE_UP*0.039933048641498423;
       const walberla::float64 Dummy_4426 = jac_affine_inv_0_2_BLUE_UP*0.039933048641498423;
       const walberla::float64 Dummy_4427 = jac_affine_inv_0_0_BLUE_UP*0.3817653560693467;
       const walberla::float64 Dummy_4428 = jac_affine_inv_0_1_BLUE_UP*0.3817653560693467;
       const walberla::float64 Dummy_4429 = jac_affine_inv_0_2_BLUE_UP*0.3817653560693467;
       const walberla::float64 Dummy_4430 = jac_affine_inv_0_0_BLUE_UP*0.0069232355736274674;
       const walberla::float64 Dummy_4431 = jac_affine_inv_0_1_BLUE_UP*0.0069232355736274674;
       const walberla::float64 Dummy_4432 = jac_affine_inv_0_2_BLUE_UP*0.0069232355736274674;
       const walberla::float64 Dummy_4433 = jac_affine_inv_0_0_BLUE_UP*0.43070170707783612;
       const walberla::float64 Dummy_4434 = jac_affine_inv_0_1_BLUE_UP*0.43070170707783612;
       const walberla::float64 Dummy_4435 = jac_affine_inv_0_2_BLUE_UP*0.43070170707783612;
       const walberla::float64 Dummy_4436 = jac_affine_0_0_BLUE_UP*2.0;
       const walberla::float64 Dummy_4437 = jac_affine_0_1_BLUE_UP*2.0;
       const walberla::float64 Dummy_4438 = jac_affine_1_0_BLUE_UP*2.0;
       const walberla::float64 Dummy_4439 = jac_affine_1_1_BLUE_UP*2.0;
       const walberla::float64 Dummy_4440 = jac_affine_2_0_BLUE_UP*2.0;
       const walberla::float64 Dummy_4441 = jac_affine_2_1_BLUE_UP*2.0;
       const walberla::float64 Dummy_4442 = Dummy_4389*(((-Dummy_4436 + Dummy_4437)*(-Dummy_4436 + Dummy_4437)) + ((-Dummy_4438 + Dummy_4439)*(-Dummy_4438 + Dummy_4439)) + ((-Dummy_4440 + Dummy_4441)*(-Dummy_4440 + Dummy_4441)));
       const walberla::float64 Dummy_4443 = jac_affine_0_2_BLUE_UP*-2.0;
       const walberla::float64 Dummy_4444 = jac_affine_1_2_BLUE_UP*-2.0;
       const walberla::float64 Dummy_4445 = jac_affine_2_2_BLUE_UP*-2.0;
       const walberla::float64 Dummy_4446 = Dummy_4389*(((Dummy_4436 + Dummy_4443)*(Dummy_4436 + Dummy_4443)) + ((Dummy_4438 + Dummy_4444)*(Dummy_4438 + Dummy_4444)) + ((Dummy_4440 + Dummy_4445)*(Dummy_4440 + Dummy_4445)));
       const walberla::float64 Dummy_4447 = Dummy_4389*(((-Dummy_4437 - Dummy_4443)*(-Dummy_4437 - Dummy_4443)) + ((-Dummy_4439 - Dummy_4444)*(-Dummy_4439 - Dummy_4444)) + ((-Dummy_4441 - Dummy_4445)*(-Dummy_4441 - Dummy_4445)));
       const walberla::float64 Dummy_4463 = 1.0 / (abs_det_jac_affine_BLUE_DOWN);
       const walberla::float64 Dummy_4464 = Dummy_4463*((jac_affine_0_0_BLUE_DOWN*jac_affine_0_0_BLUE_DOWN)*4.0 + (jac_affine_1_0_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN)*4.0 + (jac_affine_2_0_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN)*4.0);
       const walberla::float64 Dummy_4465 = jac_affine_inv_1_0_BLUE_DOWN*0.01482761006242336;
       const walberla::float64 Dummy_4466 = jac_affine_inv_1_1_BLUE_DOWN*0.01482761006242336;
       const walberla::float64 Dummy_4467 = jac_affine_inv_1_2_BLUE_DOWN*0.01482761006242336;
       const walberla::float64 Dummy_4470 = jac_affine_inv_1_0_BLUE_DOWN*0.0048399363458717648;
       const walberla::float64 Dummy_4471 = jac_affine_inv_1_1_BLUE_DOWN*0.0048399363458717648;
       const walberla::float64 Dummy_4472 = jac_affine_inv_1_2_BLUE_DOWN*0.0048399363458717648;
       const walberla::float64 Dummy_4475 = jac_affine_inv_1_0_BLUE_DOWN*0.44773255210137269;
       const walberla::float64 Dummy_4476 = jac_affine_inv_1_1_BLUE_DOWN*0.44773255210137269;
       const walberla::float64 Dummy_4477 = jac_affine_inv_1_2_BLUE_DOWN*0.44773255210137269;
       const walberla::float64 Dummy_4480 = jac_affine_inv_1_0_BLUE_DOWN*0.35284634870858678;
       const walberla::float64 Dummy_4481 = jac_affine_inv_1_1_BLUE_DOWN*0.35284634870858678;
       const walberla::float64 Dummy_4482 = jac_affine_inv_1_2_BLUE_DOWN*0.35284634870858678;
       const walberla::float64 Dummy_4484 = Dummy_4463*((jac_affine_0_1_BLUE_DOWN*jac_affine_0_1_BLUE_DOWN)*4.0 + (jac_affine_1_1_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN)*4.0 + (jac_affine_2_1_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN)*4.0);
       const walberla::float64 Dummy_4485 = jac_affine_inv_0_0_BLUE_DOWN*0.01482761006242336;
       const walberla::float64 Dummy_4486 = jac_affine_inv_0_1_BLUE_DOWN*0.01482761006242336;
       const walberla::float64 Dummy_4487 = jac_affine_inv_0_2_BLUE_DOWN*0.01482761006242336;
       const walberla::float64 Dummy_4488 = jac_affine_inv_0_0_BLUE_DOWN*0.0048399363458717648;
       const walberla::float64 Dummy_4489 = jac_affine_inv_0_1_BLUE_DOWN*0.0048399363458717648;
       const walberla::float64 Dummy_4490 = jac_affine_inv_0_2_BLUE_DOWN*0.0048399363458717648;
       const walberla::float64 Dummy_4491 = jac_affine_inv_0_0_BLUE_DOWN*0.44773255210137269;
       const walberla::float64 Dummy_4492 = jac_affine_inv_0_1_BLUE_DOWN*0.44773255210137269;
       const walberla::float64 Dummy_4493 = jac_affine_inv_0_2_BLUE_DOWN*0.44773255210137269;
       const walberla::float64 Dummy_4494 = jac_affine_inv_0_0_BLUE_DOWN*0.35284634870858678;
       const walberla::float64 Dummy_4495 = jac_affine_inv_0_1_BLUE_DOWN*0.35284634870858678;
       const walberla::float64 Dummy_4496 = jac_affine_inv_0_2_BLUE_DOWN*0.35284634870858678;
       const walberla::float64 Dummy_4497 = Dummy_4463*((jac_affine_0_2_BLUE_DOWN*jac_affine_0_2_BLUE_DOWN)*4.0 + (jac_affine_1_2_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN)*4.0 + (jac_affine_2_2_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN)*4.0);
       const walberla::float64 Dummy_4498 = jac_affine_inv_0_0_BLUE_DOWN*0.039933048641498423;
       const walberla::float64 Dummy_4499 = jac_affine_inv_0_1_BLUE_DOWN*0.039933048641498423;
       const walberla::float64 Dummy_4500 = jac_affine_inv_0_2_BLUE_DOWN*0.039933048641498423;
       const walberla::float64 Dummy_4501 = jac_affine_inv_0_0_BLUE_DOWN*0.3817653560693467;
       const walberla::float64 Dummy_4502 = jac_affine_inv_0_1_BLUE_DOWN*0.3817653560693467;
       const walberla::float64 Dummy_4503 = jac_affine_inv_0_2_BLUE_DOWN*0.3817653560693467;
       const walberla::float64 Dummy_4504 = jac_affine_inv_0_0_BLUE_DOWN*0.0069232355736274674;
       const walberla::float64 Dummy_4505 = jac_affine_inv_0_1_BLUE_DOWN*0.0069232355736274674;
       const walberla::float64 Dummy_4506 = jac_affine_inv_0_2_BLUE_DOWN*0.0069232355736274674;
       const walberla::float64 Dummy_4507 = jac_affine_inv_0_0_BLUE_DOWN*0.43070170707783612;
       const walberla::float64 Dummy_4508 = jac_affine_inv_0_1_BLUE_DOWN*0.43070170707783612;
       const walberla::float64 Dummy_4509 = jac_affine_inv_0_2_BLUE_DOWN*0.43070170707783612;
       const walberla::float64 Dummy_4510 = jac_affine_0_0_BLUE_DOWN*2.0;
       const walberla::float64 Dummy_4511 = jac_affine_0_1_BLUE_DOWN*2.0;
       const walberla::float64 Dummy_4512 = jac_affine_1_0_BLUE_DOWN*2.0;
       const walberla::float64 Dummy_4513 = jac_affine_1_1_BLUE_DOWN*2.0;
       const walberla::float64 Dummy_4514 = jac_affine_2_0_BLUE_DOWN*2.0;
       const walberla::float64 Dummy_4515 = jac_affine_2_1_BLUE_DOWN*2.0;
       const walberla::float64 Dummy_4516 = Dummy_4463*(((-Dummy_4510 + Dummy_4511)*(-Dummy_4510 + Dummy_4511)) + ((-Dummy_4512 + Dummy_4513)*(-Dummy_4512 + Dummy_4513)) + ((-Dummy_4514 + Dummy_4515)*(-Dummy_4514 + Dummy_4515)));
       const walberla::float64 Dummy_4517 = jac_affine_0_2_BLUE_DOWN*-2.0;
       const walberla::float64 Dummy_4518 = jac_affine_1_2_BLUE_DOWN*-2.0;
       const walberla::float64 Dummy_4519 = jac_affine_2_2_BLUE_DOWN*-2.0;
       const walberla::float64 Dummy_4520 = Dummy_4463*(((Dummy_4510 + Dummy_4517)*(Dummy_4510 + Dummy_4517)) + ((Dummy_4512 + Dummy_4518)*(Dummy_4512 + Dummy_4518)) + ((Dummy_4514 + Dummy_4519)*(Dummy_4514 + Dummy_4519)));
       const walberla::float64 Dummy_4521 = Dummy_4463*(((-Dummy_4511 - Dummy_4517)*(-Dummy_4511 - Dummy_4517)) + ((-Dummy_4513 - Dummy_4518)*(-Dummy_4513 - Dummy_4518)) + ((-Dummy_4515 - Dummy_4519)*(-Dummy_4515 - Dummy_4519)));
       const walberla::float64 Dummy_4537 = 1.0 / (abs_det_jac_affine_GREEN_UP);
       const walberla::float64 Dummy_4538 = Dummy_4537*((jac_affine_0_0_GREEN_UP*jac_affine_0_0_GREEN_UP)*4.0 + (jac_affine_1_0_GREEN_UP*jac_affine_1_0_GREEN_UP)*4.0 + (jac_affine_2_0_GREEN_UP*jac_affine_2_0_GREEN_UP)*4.0);
       const walberla::float64 Dummy_4539 = jac_affine_inv_1_0_GREEN_UP*0.01482761006242336;
       const walberla::float64 Dummy_4540 = jac_affine_inv_1_1_GREEN_UP*0.01482761006242336;
       const walberla::float64 Dummy_4541 = jac_affine_inv_1_2_GREEN_UP*0.01482761006242336;
       const walberla::float64 Dummy_4544 = jac_affine_inv_1_0_GREEN_UP*0.0048399363458717648;
       const walberla::float64 Dummy_4545 = jac_affine_inv_1_1_GREEN_UP*0.0048399363458717648;
       const walberla::float64 Dummy_4546 = jac_affine_inv_1_2_GREEN_UP*0.0048399363458717648;
       const walberla::float64 Dummy_4549 = jac_affine_inv_1_0_GREEN_UP*0.44773255210137269;
       const walberla::float64 Dummy_4550 = jac_affine_inv_1_1_GREEN_UP*0.44773255210137269;
       const walberla::float64 Dummy_4551 = jac_affine_inv_1_2_GREEN_UP*0.44773255210137269;
       const walberla::float64 Dummy_4554 = jac_affine_inv_1_0_GREEN_UP*0.35284634870858678;
       const walberla::float64 Dummy_4555 = jac_affine_inv_1_1_GREEN_UP*0.35284634870858678;
       const walberla::float64 Dummy_4556 = jac_affine_inv_1_2_GREEN_UP*0.35284634870858678;
       const walberla::float64 Dummy_4558 = Dummy_4537*((jac_affine_0_1_GREEN_UP*jac_affine_0_1_GREEN_UP)*4.0 + (jac_affine_1_1_GREEN_UP*jac_affine_1_1_GREEN_UP)*4.0 + (jac_affine_2_1_GREEN_UP*jac_affine_2_1_GREEN_UP)*4.0);
       const walberla::float64 Dummy_4559 = jac_affine_inv_0_0_GREEN_UP*0.01482761006242336;
       const walberla::float64 Dummy_4560 = jac_affine_inv_0_1_GREEN_UP*0.01482761006242336;
       const walberla::float64 Dummy_4561 = jac_affine_inv_0_2_GREEN_UP*0.01482761006242336;
       const walberla::float64 Dummy_4562 = jac_affine_inv_0_0_GREEN_UP*0.0048399363458717648;
       const walberla::float64 Dummy_4563 = jac_affine_inv_0_1_GREEN_UP*0.0048399363458717648;
       const walberla::float64 Dummy_4564 = jac_affine_inv_0_2_GREEN_UP*0.0048399363458717648;
       const walberla::float64 Dummy_4565 = jac_affine_inv_0_0_GREEN_UP*0.44773255210137269;
       const walberla::float64 Dummy_4566 = jac_affine_inv_0_1_GREEN_UP*0.44773255210137269;
       const walberla::float64 Dummy_4567 = jac_affine_inv_0_2_GREEN_UP*0.44773255210137269;
       const walberla::float64 Dummy_4568 = jac_affine_inv_0_0_GREEN_UP*0.35284634870858678;
       const walberla::float64 Dummy_4569 = jac_affine_inv_0_1_GREEN_UP*0.35284634870858678;
       const walberla::float64 Dummy_4570 = jac_affine_inv_0_2_GREEN_UP*0.35284634870858678;
       const walberla::float64 Dummy_4571 = Dummy_4537*((jac_affine_0_2_GREEN_UP*jac_affine_0_2_GREEN_UP)*4.0 + (jac_affine_1_2_GREEN_UP*jac_affine_1_2_GREEN_UP)*4.0 + (jac_affine_2_2_GREEN_UP*jac_affine_2_2_GREEN_UP)*4.0);
       const walberla::float64 Dummy_4572 = jac_affine_inv_0_0_GREEN_UP*0.039933048641498423;
       const walberla::float64 Dummy_4573 = jac_affine_inv_0_1_GREEN_UP*0.039933048641498423;
       const walberla::float64 Dummy_4574 = jac_affine_inv_0_2_GREEN_UP*0.039933048641498423;
       const walberla::float64 Dummy_4575 = jac_affine_inv_0_0_GREEN_UP*0.3817653560693467;
       const walberla::float64 Dummy_4576 = jac_affine_inv_0_1_GREEN_UP*0.3817653560693467;
       const walberla::float64 Dummy_4577 = jac_affine_inv_0_2_GREEN_UP*0.3817653560693467;
       const walberla::float64 Dummy_4578 = jac_affine_inv_0_0_GREEN_UP*0.0069232355736274674;
       const walberla::float64 Dummy_4579 = jac_affine_inv_0_1_GREEN_UP*0.0069232355736274674;
       const walberla::float64 Dummy_4580 = jac_affine_inv_0_2_GREEN_UP*0.0069232355736274674;
       const walberla::float64 Dummy_4581 = jac_affine_inv_0_0_GREEN_UP*0.43070170707783612;
       const walberla::float64 Dummy_4582 = jac_affine_inv_0_1_GREEN_UP*0.43070170707783612;
       const walberla::float64 Dummy_4583 = jac_affine_inv_0_2_GREEN_UP*0.43070170707783612;
       const walberla::float64 Dummy_4584 = jac_affine_0_0_GREEN_UP*2.0;
       const walberla::float64 Dummy_4585 = jac_affine_0_1_GREEN_UP*2.0;
       const walberla::float64 Dummy_4586 = jac_affine_1_0_GREEN_UP*2.0;
       const walberla::float64 Dummy_4587 = jac_affine_1_1_GREEN_UP*2.0;
       const walberla::float64 Dummy_4588 = jac_affine_2_0_GREEN_UP*2.0;
       const walberla::float64 Dummy_4589 = jac_affine_2_1_GREEN_UP*2.0;
       const walberla::float64 Dummy_4590 = Dummy_4537*(((-Dummy_4584 + Dummy_4585)*(-Dummy_4584 + Dummy_4585)) + ((-Dummy_4586 + Dummy_4587)*(-Dummy_4586 + Dummy_4587)) + ((-Dummy_4588 + Dummy_4589)*(-Dummy_4588 + Dummy_4589)));
       const walberla::float64 Dummy_4591 = jac_affine_0_2_GREEN_UP*-2.0;
       const walberla::float64 Dummy_4592 = jac_affine_1_2_GREEN_UP*-2.0;
       const walberla::float64 Dummy_4593 = jac_affine_2_2_GREEN_UP*-2.0;
       const walberla::float64 Dummy_4594 = Dummy_4537*(((Dummy_4584 + Dummy_4591)*(Dummy_4584 + Dummy_4591)) + ((Dummy_4586 + Dummy_4592)*(Dummy_4586 + Dummy_4592)) + ((Dummy_4588 + Dummy_4593)*(Dummy_4588 + Dummy_4593)));
       const walberla::float64 Dummy_4595 = Dummy_4537*(((-Dummy_4585 - Dummy_4591)*(-Dummy_4585 - Dummy_4591)) + ((-Dummy_4587 - Dummy_4592)*(-Dummy_4587 - Dummy_4592)) + ((-Dummy_4589 - Dummy_4593)*(-Dummy_4589 - Dummy_4593)));
       const walberla::float64 Dummy_4611 = 1.0 / (abs_det_jac_affine_GREEN_DOWN);
       const walberla::float64 Dummy_4612 = Dummy_4611*((jac_affine_0_0_GREEN_DOWN*jac_affine_0_0_GREEN_DOWN)*4.0 + (jac_affine_1_0_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN)*4.0 + (jac_affine_2_0_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN)*4.0);
       const walberla::float64 Dummy_4613 = jac_affine_inv_1_0_GREEN_DOWN*0.01482761006242336;
       const walberla::float64 Dummy_4614 = jac_affine_inv_1_1_GREEN_DOWN*0.01482761006242336;
       const walberla::float64 Dummy_4615 = jac_affine_inv_1_2_GREEN_DOWN*0.01482761006242336;
       const walberla::float64 Dummy_4618 = jac_affine_inv_1_0_GREEN_DOWN*0.0048399363458717648;
       const walberla::float64 Dummy_4619 = jac_affine_inv_1_1_GREEN_DOWN*0.0048399363458717648;
       const walberla::float64 Dummy_4620 = jac_affine_inv_1_2_GREEN_DOWN*0.0048399363458717648;
       const walberla::float64 Dummy_4623 = jac_affine_inv_1_0_GREEN_DOWN*0.44773255210137269;
       const walberla::float64 Dummy_4624 = jac_affine_inv_1_1_GREEN_DOWN*0.44773255210137269;
       const walberla::float64 Dummy_4625 = jac_affine_inv_1_2_GREEN_DOWN*0.44773255210137269;
       const walberla::float64 Dummy_4628 = jac_affine_inv_1_0_GREEN_DOWN*0.35284634870858678;
       const walberla::float64 Dummy_4629 = jac_affine_inv_1_1_GREEN_DOWN*0.35284634870858678;
       const walberla::float64 Dummy_4630 = jac_affine_inv_1_2_GREEN_DOWN*0.35284634870858678;
       const walberla::float64 Dummy_4632 = Dummy_4611*((jac_affine_0_1_GREEN_DOWN*jac_affine_0_1_GREEN_DOWN)*4.0 + (jac_affine_1_1_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN)*4.0 + (jac_affine_2_1_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN)*4.0);
       const walberla::float64 Dummy_4633 = jac_affine_inv_0_0_GREEN_DOWN*0.01482761006242336;
       const walberla::float64 Dummy_4634 = jac_affine_inv_0_1_GREEN_DOWN*0.01482761006242336;
       const walberla::float64 Dummy_4635 = jac_affine_inv_0_2_GREEN_DOWN*0.01482761006242336;
       const walberla::float64 Dummy_4636 = jac_affine_inv_0_0_GREEN_DOWN*0.0048399363458717648;
       const walberla::float64 Dummy_4637 = jac_affine_inv_0_1_GREEN_DOWN*0.0048399363458717648;
       const walberla::float64 Dummy_4638 = jac_affine_inv_0_2_GREEN_DOWN*0.0048399363458717648;
       const walberla::float64 Dummy_4639 = jac_affine_inv_0_0_GREEN_DOWN*0.44773255210137269;
       const walberla::float64 Dummy_4640 = jac_affine_inv_0_1_GREEN_DOWN*0.44773255210137269;
       const walberla::float64 Dummy_4641 = jac_affine_inv_0_2_GREEN_DOWN*0.44773255210137269;
       const walberla::float64 Dummy_4642 = jac_affine_inv_0_0_GREEN_DOWN*0.35284634870858678;
       const walberla::float64 Dummy_4643 = jac_affine_inv_0_1_GREEN_DOWN*0.35284634870858678;
       const walberla::float64 Dummy_4644 = jac_affine_inv_0_2_GREEN_DOWN*0.35284634870858678;
       const walberla::float64 Dummy_4645 = Dummy_4611*((jac_affine_0_2_GREEN_DOWN*jac_affine_0_2_GREEN_DOWN)*4.0 + (jac_affine_1_2_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN)*4.0 + (jac_affine_2_2_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN)*4.0);
       const walberla::float64 Dummy_4646 = jac_affine_inv_0_0_GREEN_DOWN*0.039933048641498423;
       const walberla::float64 Dummy_4647 = jac_affine_inv_0_1_GREEN_DOWN*0.039933048641498423;
       const walberla::float64 Dummy_4648 = jac_affine_inv_0_2_GREEN_DOWN*0.039933048641498423;
       const walberla::float64 Dummy_4649 = jac_affine_inv_0_0_GREEN_DOWN*0.3817653560693467;
       const walberla::float64 Dummy_4650 = jac_affine_inv_0_1_GREEN_DOWN*0.3817653560693467;
       const walberla::float64 Dummy_4651 = jac_affine_inv_0_2_GREEN_DOWN*0.3817653560693467;
       const walberla::float64 Dummy_4652 = jac_affine_inv_0_0_GREEN_DOWN*0.0069232355736274674;
       const walberla::float64 Dummy_4653 = jac_affine_inv_0_1_GREEN_DOWN*0.0069232355736274674;
       const walberla::float64 Dummy_4654 = jac_affine_inv_0_2_GREEN_DOWN*0.0069232355736274674;
       const walberla::float64 Dummy_4655 = jac_affine_inv_0_0_GREEN_DOWN*0.43070170707783612;
       const walberla::float64 Dummy_4656 = jac_affine_inv_0_1_GREEN_DOWN*0.43070170707783612;
       const walberla::float64 Dummy_4657 = jac_affine_inv_0_2_GREEN_DOWN*0.43070170707783612;
       const walberla::float64 Dummy_4658 = jac_affine_0_0_GREEN_DOWN*2.0;
       const walberla::float64 Dummy_4659 = jac_affine_0_1_GREEN_DOWN*2.0;
       const walberla::float64 Dummy_4660 = jac_affine_1_0_GREEN_DOWN*2.0;
       const walberla::float64 Dummy_4661 = jac_affine_1_1_GREEN_DOWN*2.0;
       const walberla::float64 Dummy_4662 = jac_affine_2_0_GREEN_DOWN*2.0;
       const walberla::float64 Dummy_4663 = jac_affine_2_1_GREEN_DOWN*2.0;
       const walberla::float64 Dummy_4664 = Dummy_4611*(((-Dummy_4658 + Dummy_4659)*(-Dummy_4658 + Dummy_4659)) + ((-Dummy_4660 + Dummy_4661)*(-Dummy_4660 + Dummy_4661)) + ((-Dummy_4662 + Dummy_4663)*(-Dummy_4662 + Dummy_4663)));
       const walberla::float64 Dummy_4665 = jac_affine_0_2_GREEN_DOWN*-2.0;
       const walberla::float64 Dummy_4666 = jac_affine_1_2_GREEN_DOWN*-2.0;
       const walberla::float64 Dummy_4667 = jac_affine_2_2_GREEN_DOWN*-2.0;
       const walberla::float64 Dummy_4668 = Dummy_4611*(((Dummy_4658 + Dummy_4665)*(Dummy_4658 + Dummy_4665)) + ((Dummy_4660 + Dummy_4666)*(Dummy_4660 + Dummy_4666)) + ((Dummy_4662 + Dummy_4667)*(Dummy_4662 + Dummy_4667)));
       const walberla::float64 Dummy_4669 = Dummy_4611*(((-Dummy_4659 - Dummy_4665)*(-Dummy_4659 - Dummy_4665)) + ((-Dummy_4661 - Dummy_4666)*(-Dummy_4661 - Dummy_4666)) + ((-Dummy_4663 - Dummy_4667)*(-Dummy_4663 - Dummy_4667)));
       for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
       for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
       {
          {
             for (int64_t ctr_0 = 0; ctr_0 < (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 += 4)
             {
                const __m256d alpha_dof_0 = _mm256_loadu_pd(& _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d alpha_dof_1 = _mm256_loadu_pd(& _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d alpha_dof_2 = _mm256_loadu_pd(& _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d alpha_dof_3 = _mm256_loadu_pd(& _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d beta_dof_0 = _mm256_loadu_pd(& _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d beta_dof_1 = _mm256_loadu_pd(& _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d beta_dof_2 = _mm256_loadu_pd(& _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d beta_dof_3 = _mm256_loadu_pd(& _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d tmp_kernel_op_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(alpha_dof_1,_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978)),_mm256_mul_pd(alpha_dof_2,_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423))),_mm256_mul_pd(alpha_dof_3,_mm256_set_pd(0.01482761006242336,0.01482761006242336,0.01482761006242336,0.01482761006242336))),_mm256_mul_pd(alpha_dof_0,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)));
                const __m256d tmp_kernel_op_9 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(beta_dof_1,_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978)),_mm256_mul_pd(beta_dof_2,_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423))),_mm256_mul_pd(beta_dof_3,_mm256_set_pd(0.01482761006242336,0.01482761006242336,0.01482761006242336,0.01482761006242336))),_mm256_mul_pd(beta_dof_0,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_set_pd(abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP));
                const __m256d tmp_kernel_op_13 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(alpha_dof_3,_mm256_set_pd(0.0048399363458717648,0.0048399363458717648,0.0048399363458717648,0.0048399363458717648)),_mm256_mul_pd(alpha_dof_1,_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601))),_mm256_mul_pd(alpha_dof_2,_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467))),_mm256_mul_pd(alpha_dof_0,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12)));
                const __m256d tmp_kernel_op_17 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(beta_dof_3,_mm256_set_pd(0.0048399363458717648,0.0048399363458717648,0.0048399363458717648,0.0048399363458717648)),_mm256_mul_pd(beta_dof_1,_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601))),_mm256_mul_pd(beta_dof_2,_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467))),_mm256_mul_pd(beta_dof_0,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12))),_mm256_set_pd(abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP));
                const __m256d tmp_kernel_op_21 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(alpha_dof_1,_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541)),_mm256_mul_pd(alpha_dof_2,_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674))),_mm256_mul_pd(alpha_dof_3,_mm256_set_pd(0.44773255210137269,0.44773255210137269,0.44773255210137269,0.44773255210137269))),_mm256_mul_pd(alpha_dof_0,_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20)));
                const __m256d tmp_kernel_op_25 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(beta_dof_1,_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541)),_mm256_mul_pd(beta_dof_2,_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674))),_mm256_mul_pd(beta_dof_3,_mm256_set_pd(0.44773255210137269,0.44773255210137269,0.44773255210137269,0.44773255210137269))),_mm256_mul_pd(beta_dof_0,_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_set_pd(abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP));
                const __m256d tmp_kernel_op_29 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(alpha_dof_3,_mm256_set_pd(0.35284634870858678,0.35284634870858678,0.35284634870858678,0.35284634870858678)),_mm256_mul_pd(alpha_dof_2,_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612))),_mm256_mul_pd(alpha_dof_1,_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779))),_mm256_mul_pd(alpha_dof_0,_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28)));
                const __m256d tmp_kernel_op_33 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(beta_dof_3,_mm256_set_pd(0.35284634870858678,0.35284634870858678,0.35284634870858678,0.35284634870858678)),_mm256_mul_pd(beta_dof_2,_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612))),_mm256_mul_pd(beta_dof_1,_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779))),_mm256_mul_pd(beta_dof_0,_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28))),_mm256_set_pd(abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP,abs_det_jac_affine_WHITE_UP));
                const __m256d elMatDiag_0 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_15,tmp_kernel_op_15,tmp_kernel_op_15,tmp_kernel_op_15)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_15,tmp_kernel_op_15,tmp_kernel_op_15,tmp_kernel_op_15)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_25,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_33,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_9,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_21,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_29,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5,tmp_kernel_op_5)));
                const __m256d elMatDiag_1 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_9,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_25,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_33,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_45,tmp_kernel_op_45,tmp_kernel_op_45,tmp_kernel_op_45)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_45,tmp_kernel_op_45,tmp_kernel_op_45,tmp_kernel_op_45)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_21,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_29,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34,tmp_kernel_op_34)));
                const __m256d elMatDiag_2 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_9,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_50,tmp_kernel_op_50,tmp_kernel_op_50,tmp_kernel_op_50)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_50,tmp_kernel_op_50,tmp_kernel_op_50,tmp_kernel_op_50)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_25,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_33,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_21,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_29,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47,tmp_kernel_op_47)));
                const __m256d elMatDiag_3 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_9,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35,tmp_kernel_op_35)),_mm256_set_pd(tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6,tmp_kernel_op_6))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36,tmp_kernel_op_36)),_mm256_set_pd(tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7,tmp_kernel_op_7)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37)),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37,tmp_kernel_op_37)),_mm256_set_pd(tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8,tmp_kernel_op_8))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14)),_mm256_set_pd(tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14,tmp_kernel_op_14)),_mm256_set_pd(tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38,tmp_kernel_op_38))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(tmp_kernel_op_15,tmp_kernel_op_15,tmp_kernel_op_15,tmp_kernel_op_15)),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(tmp_kernel_op_15,tmp_kernel_op_15,tmp_kernel_op_15,tmp_kernel_op_15)),_mm256_set_pd(tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39,tmp_kernel_op_39)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16)),_mm256_set_pd(tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16,tmp_kernel_op_16)),_mm256_set_pd(tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40,tmp_kernel_op_40))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_25,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22)),_mm256_set_pd(tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22,tmp_kernel_op_22)),_mm256_set_pd(tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41,tmp_kernel_op_41))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23,tmp_kernel_op_23)),_mm256_set_pd(tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42,tmp_kernel_op_42)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_set_pd(tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24,tmp_kernel_op_24)),_mm256_set_pd(tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43,tmp_kernel_op_43))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_33,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30)),_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30,tmp_kernel_op_30)),_mm256_set_pd(tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44,tmp_kernel_op_44))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31)),_mm256_set_pd(tmp_kernel_op_45,tmp_kernel_op_45,tmp_kernel_op_45,tmp_kernel_op_45)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31,tmp_kernel_op_31)),_mm256_set_pd(tmp_kernel_op_45,tmp_kernel_op_45,tmp_kernel_op_45,tmp_kernel_op_45)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32)),_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32,tmp_kernel_op_32)),_mm256_set_pd(tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46,tmp_kernel_op_46))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_21,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_29,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66,tmp_kernel_op_66)));
                const __m256d elMatDiag_4 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_9,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48,tmp_kernel_op_48))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49,tmp_kernel_op_49)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(tmp_kernel_op_50,tmp_kernel_op_50,tmp_kernel_op_50,tmp_kernel_op_50)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(tmp_kernel_op_50,tmp_kernel_op_50,tmp_kernel_op_50,tmp_kernel_op_50))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51,tmp_kernel_op_51))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52,tmp_kernel_op_52)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53,tmp_kernel_op_53))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_33,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57,tmp_kernel_op_57))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58,tmp_kernel_op_58)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59,tmp_kernel_op_59))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_25,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54,tmp_kernel_op_54))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55,tmp_kernel_op_55)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56,tmp_kernel_op_56))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_21,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_29,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74,tmp_kernel_op_74)));
                const __m256d elMatDiag_5 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_9,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_17,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_25,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_33,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP,jac_affine_inv_1_0_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP,jac_affine_inv_2_0_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP,jac_affine_inv_0_0_WHITE_UP),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP,jac_affine_inv_1_1_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP,jac_affine_inv_2_1_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP,jac_affine_inv_0_1_WHITE_UP),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP,jac_affine_inv_1_2_WHITE_UP)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP,jac_affine_inv_2_2_WHITE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP,jac_affine_inv_0_2_WHITE_UP),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_3,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_13,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_21,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79))),_mm256_mul_pd(_mm256_mul_pd(tmp_kernel_op_29,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79,tmp_kernel_op_79)));
                {
                   {
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_0,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_1,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_2,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_3,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_4,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(elMatDiag_5,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                   }
                }
                const __m256d Dummy_4306 = _mm256_loadu_pd(& _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d Dummy_4307 = _mm256_loadu_pd(& _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d Dummy_4308 = _mm256_loadu_pd(& _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d Dummy_4309 = _mm256_loadu_pd(& _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d Dummy_4310 = _mm256_loadu_pd(& _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d Dummy_4311 = _mm256_loadu_pd(& _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d Dummy_4312 = _mm256_loadu_pd(& _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d Dummy_4313 = _mm256_loadu_pd(& _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d Dummy_4314 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4307,_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978)),_mm256_mul_pd(Dummy_4308,_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423))),_mm256_mul_pd(Dummy_4309,_mm256_set_pd(0.01482761006242336,0.01482761006242336,0.01482761006242336,0.01482761006242336))),_mm256_mul_pd(Dummy_4306,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)));
                const __m256d Dummy_4320 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4311,_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978)),_mm256_mul_pd(Dummy_4312,_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423))),_mm256_mul_pd(Dummy_4313,_mm256_set_pd(0.01482761006242336,0.01482761006242336,0.01482761006242336,0.01482761006242336))),_mm256_mul_pd(Dummy_4310,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_set_pd(abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN));
                const __m256d Dummy_4321 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4309,_mm256_set_pd(0.0048399363458717648,0.0048399363458717648,0.0048399363458717648,0.0048399363458717648)),_mm256_mul_pd(Dummy_4307,_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601))),_mm256_mul_pd(Dummy_4308,_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467))),_mm256_mul_pd(Dummy_4306,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12)));
                const __m256d Dummy_4325 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4313,_mm256_set_pd(0.0048399363458717648,0.0048399363458717648,0.0048399363458717648,0.0048399363458717648)),_mm256_mul_pd(Dummy_4311,_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601))),_mm256_mul_pd(Dummy_4312,_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467))),_mm256_mul_pd(Dummy_4310,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12))),_mm256_set_pd(abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN));
                const __m256d Dummy_4326 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4307,_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541)),_mm256_mul_pd(Dummy_4308,_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674))),_mm256_mul_pd(Dummy_4309,_mm256_set_pd(0.44773255210137269,0.44773255210137269,0.44773255210137269,0.44773255210137269))),_mm256_mul_pd(Dummy_4306,_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20)));
                const __m256d Dummy_4330 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4311,_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541)),_mm256_mul_pd(Dummy_4312,_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674))),_mm256_mul_pd(Dummy_4313,_mm256_set_pd(0.44773255210137269,0.44773255210137269,0.44773255210137269,0.44773255210137269))),_mm256_mul_pd(Dummy_4310,_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_set_pd(abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN));
                const __m256d Dummy_4331 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4309,_mm256_set_pd(0.35284634870858678,0.35284634870858678,0.35284634870858678,0.35284634870858678)),_mm256_mul_pd(Dummy_4308,_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612))),_mm256_mul_pd(Dummy_4307,_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779))),_mm256_mul_pd(Dummy_4306,_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28)));
                const __m256d Dummy_4335 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4313,_mm256_set_pd(0.35284634870858678,0.35284634870858678,0.35284634870858678,0.35284634870858678)),_mm256_mul_pd(Dummy_4312,_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612))),_mm256_mul_pd(Dummy_4311,_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779))),_mm256_mul_pd(Dummy_4310,_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28))),_mm256_set_pd(abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN,abs_det_jac_affine_WHITE_DOWN));
                const __m256d Dummy_4374 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4320,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4317,Dummy_4317,Dummy_4317,Dummy_4317)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4317,Dummy_4317,Dummy_4317,Dummy_4317)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4318,Dummy_4318,Dummy_4318,Dummy_4318)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4318,Dummy_4318,Dummy_4318,Dummy_4318)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4319,Dummy_4319,Dummy_4319,Dummy_4319)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4319,Dummy_4319,Dummy_4319,Dummy_4319)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4325,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4322,Dummy_4322,Dummy_4322,Dummy_4322)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4322,Dummy_4322,Dummy_4322,Dummy_4322)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4323,Dummy_4323,Dummy_4323,Dummy_4323)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4323,Dummy_4323,Dummy_4323,Dummy_4323)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4324,Dummy_4324,Dummy_4324,Dummy_4324)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4324,Dummy_4324,Dummy_4324,Dummy_4324)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4330,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4327,Dummy_4327,Dummy_4327,Dummy_4327)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4327,Dummy_4327,Dummy_4327,Dummy_4327)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4328,Dummy_4328,Dummy_4328,Dummy_4328)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4328,Dummy_4328,Dummy_4328,Dummy_4328)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4329,Dummy_4329,Dummy_4329,Dummy_4329)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4329,Dummy_4329,Dummy_4329,Dummy_4329)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4335,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4332,Dummy_4332,Dummy_4332,Dummy_4332)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4332,Dummy_4332,Dummy_4332,Dummy_4332)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4333,Dummy_4333,Dummy_4333,Dummy_4333)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4333,Dummy_4333,Dummy_4333,Dummy_4333)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4334,Dummy_4334,Dummy_4334,Dummy_4334)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4334,Dummy_4334,Dummy_4334,Dummy_4334)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4314,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4316,Dummy_4316,Dummy_4316,Dummy_4316))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4321,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4316,Dummy_4316,Dummy_4316,Dummy_4316))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4326,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4316,Dummy_4316,Dummy_4316,Dummy_4316))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4331,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4316,Dummy_4316,Dummy_4316,Dummy_4316)));
                const __m256d Dummy_4375 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4320,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4337,Dummy_4337,Dummy_4337,Dummy_4337)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4337,Dummy_4337,Dummy_4337,Dummy_4337)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4338,Dummy_4338,Dummy_4338,Dummy_4338)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4338,Dummy_4338,Dummy_4338,Dummy_4338)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4339,Dummy_4339,Dummy_4339,Dummy_4339)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4339,Dummy_4339,Dummy_4339,Dummy_4339)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4325,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4340,Dummy_4340,Dummy_4340,Dummy_4340)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4340,Dummy_4340,Dummy_4340,Dummy_4340)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4341,Dummy_4341,Dummy_4341,Dummy_4341)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4341,Dummy_4341,Dummy_4341,Dummy_4341)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4342,Dummy_4342,Dummy_4342,Dummy_4342)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4342,Dummy_4342,Dummy_4342,Dummy_4342)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4330,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4343,Dummy_4343,Dummy_4343,Dummy_4343)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4343,Dummy_4343,Dummy_4343,Dummy_4343)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4344,Dummy_4344,Dummy_4344,Dummy_4344)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4344,Dummy_4344,Dummy_4344,Dummy_4344)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4345,Dummy_4345,Dummy_4345,Dummy_4345)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4345,Dummy_4345,Dummy_4345,Dummy_4345)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4335,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4346,Dummy_4346,Dummy_4346,Dummy_4346)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4346,Dummy_4346,Dummy_4346,Dummy_4346)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4347,Dummy_4347,Dummy_4347,Dummy_4347)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4347,Dummy_4347,Dummy_4347,Dummy_4347)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4348,Dummy_4348,Dummy_4348,Dummy_4348)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4348,Dummy_4348,Dummy_4348,Dummy_4348)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4314,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4336,Dummy_4336,Dummy_4336,Dummy_4336))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4321,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4336,Dummy_4336,Dummy_4336,Dummy_4336))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4326,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4336,Dummy_4336,Dummy_4336,Dummy_4336))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4331,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4336,Dummy_4336,Dummy_4336,Dummy_4336)));
                const __m256d Dummy_4376 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4320,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4350,Dummy_4350,Dummy_4350,Dummy_4350)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4350,Dummy_4350,Dummy_4350,Dummy_4350)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4351,Dummy_4351,Dummy_4351,Dummy_4351)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4351,Dummy_4351,Dummy_4351,Dummy_4351)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4352,Dummy_4352,Dummy_4352,Dummy_4352)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4352,Dummy_4352,Dummy_4352,Dummy_4352)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4325,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4353,Dummy_4353,Dummy_4353,Dummy_4353)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4353,Dummy_4353,Dummy_4353,Dummy_4353)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4354,Dummy_4354,Dummy_4354,Dummy_4354)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4354,Dummy_4354,Dummy_4354,Dummy_4354)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4355,Dummy_4355,Dummy_4355,Dummy_4355)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4355,Dummy_4355,Dummy_4355,Dummy_4355)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4330,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4356,Dummy_4356,Dummy_4356,Dummy_4356)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4356,Dummy_4356,Dummy_4356,Dummy_4356)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4357,Dummy_4357,Dummy_4357,Dummy_4357)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4357,Dummy_4357,Dummy_4357,Dummy_4357)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4358,Dummy_4358,Dummy_4358,Dummy_4358)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4358,Dummy_4358,Dummy_4358,Dummy_4358)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4335,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4359,Dummy_4359,Dummy_4359,Dummy_4359)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4359,Dummy_4359,Dummy_4359,Dummy_4359)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4360,Dummy_4360,Dummy_4360,Dummy_4360)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4360,Dummy_4360,Dummy_4360,Dummy_4360)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4361,Dummy_4361,Dummy_4361,Dummy_4361)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4361,Dummy_4361,Dummy_4361,Dummy_4361)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4314,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4349,Dummy_4349,Dummy_4349,Dummy_4349))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4321,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4349,Dummy_4349,Dummy_4349,Dummy_4349))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4326,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4349,Dummy_4349,Dummy_4349,Dummy_4349))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4331,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4349,Dummy_4349,Dummy_4349,Dummy_4349)));
                const __m256d Dummy_4377 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4320,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4317,Dummy_4317,Dummy_4317,Dummy_4317)),_mm256_set_pd(Dummy_4337,Dummy_4337,Dummy_4337,Dummy_4337)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4317,Dummy_4317,Dummy_4317,Dummy_4317)),_mm256_set_pd(Dummy_4337,Dummy_4337,Dummy_4337,Dummy_4337))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4318,Dummy_4318,Dummy_4318,Dummy_4318)),_mm256_set_pd(Dummy_4338,Dummy_4338,Dummy_4338,Dummy_4338)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4318,Dummy_4318,Dummy_4318,Dummy_4318)),_mm256_set_pd(Dummy_4338,Dummy_4338,Dummy_4338,Dummy_4338)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4319,Dummy_4319,Dummy_4319,Dummy_4319)),_mm256_set_pd(Dummy_4339,Dummy_4339,Dummy_4339,Dummy_4339)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4319,Dummy_4319,Dummy_4319,Dummy_4319)),_mm256_set_pd(Dummy_4339,Dummy_4339,Dummy_4339,Dummy_4339))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4325,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4322,Dummy_4322,Dummy_4322,Dummy_4322)),_mm256_set_pd(Dummy_4340,Dummy_4340,Dummy_4340,Dummy_4340)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4322,Dummy_4322,Dummy_4322,Dummy_4322)),_mm256_set_pd(Dummy_4340,Dummy_4340,Dummy_4340,Dummy_4340))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4323,Dummy_4323,Dummy_4323,Dummy_4323)),_mm256_set_pd(Dummy_4341,Dummy_4341,Dummy_4341,Dummy_4341)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4323,Dummy_4323,Dummy_4323,Dummy_4323)),_mm256_set_pd(Dummy_4341,Dummy_4341,Dummy_4341,Dummy_4341)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4324,Dummy_4324,Dummy_4324,Dummy_4324)),_mm256_set_pd(Dummy_4342,Dummy_4342,Dummy_4342,Dummy_4342)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4324,Dummy_4324,Dummy_4324,Dummy_4324)),_mm256_set_pd(Dummy_4342,Dummy_4342,Dummy_4342,Dummy_4342))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4330,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4327,Dummy_4327,Dummy_4327,Dummy_4327)),_mm256_set_pd(Dummy_4343,Dummy_4343,Dummy_4343,Dummy_4343)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4327,Dummy_4327,Dummy_4327,Dummy_4327)),_mm256_set_pd(Dummy_4343,Dummy_4343,Dummy_4343,Dummy_4343))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4328,Dummy_4328,Dummy_4328,Dummy_4328)),_mm256_set_pd(Dummy_4344,Dummy_4344,Dummy_4344,Dummy_4344)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4328,Dummy_4328,Dummy_4328,Dummy_4328)),_mm256_set_pd(Dummy_4344,Dummy_4344,Dummy_4344,Dummy_4344)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4329,Dummy_4329,Dummy_4329,Dummy_4329)),_mm256_set_pd(Dummy_4345,Dummy_4345,Dummy_4345,Dummy_4345)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4329,Dummy_4329,Dummy_4329,Dummy_4329)),_mm256_set_pd(Dummy_4345,Dummy_4345,Dummy_4345,Dummy_4345))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4335,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4332,Dummy_4332,Dummy_4332,Dummy_4332)),_mm256_set_pd(Dummy_4346,Dummy_4346,Dummy_4346,Dummy_4346)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4332,Dummy_4332,Dummy_4332,Dummy_4332)),_mm256_set_pd(Dummy_4346,Dummy_4346,Dummy_4346,Dummy_4346))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4333,Dummy_4333,Dummy_4333,Dummy_4333)),_mm256_set_pd(Dummy_4347,Dummy_4347,Dummy_4347,Dummy_4347)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4333,Dummy_4333,Dummy_4333,Dummy_4333)),_mm256_set_pd(Dummy_4347,Dummy_4347,Dummy_4347,Dummy_4347)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4334,Dummy_4334,Dummy_4334,Dummy_4334)),_mm256_set_pd(Dummy_4348,Dummy_4348,Dummy_4348,Dummy_4348)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4334,Dummy_4334,Dummy_4334,Dummy_4334)),_mm256_set_pd(Dummy_4348,Dummy_4348,Dummy_4348,Dummy_4348))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4314,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4368,Dummy_4368,Dummy_4368,Dummy_4368))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4321,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4368,Dummy_4368,Dummy_4368,Dummy_4368))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4326,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4368,Dummy_4368,Dummy_4368,Dummy_4368))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4331,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4368,Dummy_4368,Dummy_4368,Dummy_4368)));
                const __m256d Dummy_4378 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4320,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4350,Dummy_4350,Dummy_4350,Dummy_4350)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4350,Dummy_4350,Dummy_4350,Dummy_4350))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4351,Dummy_4351,Dummy_4351,Dummy_4351)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4351,Dummy_4351,Dummy_4351,Dummy_4351)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4352,Dummy_4352,Dummy_4352,Dummy_4352)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4352,Dummy_4352,Dummy_4352,Dummy_4352))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4325,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4353,Dummy_4353,Dummy_4353,Dummy_4353)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4353,Dummy_4353,Dummy_4353,Dummy_4353))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4354,Dummy_4354,Dummy_4354,Dummy_4354)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4354,Dummy_4354,Dummy_4354,Dummy_4354)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4355,Dummy_4355,Dummy_4355,Dummy_4355)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4355,Dummy_4355,Dummy_4355,Dummy_4355))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4335,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4359,Dummy_4359,Dummy_4359,Dummy_4359)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4359,Dummy_4359,Dummy_4359,Dummy_4359))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4360,Dummy_4360,Dummy_4360,Dummy_4360)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4360,Dummy_4360,Dummy_4360,Dummy_4360)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4361,Dummy_4361,Dummy_4361,Dummy_4361)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4361,Dummy_4361,Dummy_4361,Dummy_4361))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4330,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4356,Dummy_4356,Dummy_4356,Dummy_4356)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4356,Dummy_4356,Dummy_4356,Dummy_4356))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4357,Dummy_4357,Dummy_4357,Dummy_4357)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4357,Dummy_4357,Dummy_4357,Dummy_4357)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4358,Dummy_4358,Dummy_4358,Dummy_4358)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4358,Dummy_4358,Dummy_4358,Dummy_4358))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4314,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4372,Dummy_4372,Dummy_4372,Dummy_4372))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4321,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4372,Dummy_4372,Dummy_4372,Dummy_4372))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4326,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4372,Dummy_4372,Dummy_4372,Dummy_4372))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4331,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4372,Dummy_4372,Dummy_4372,Dummy_4372)));
                const __m256d Dummy_4379 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4320,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4325,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4330,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4335,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN,jac_affine_inv_1_0_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN,jac_affine_inv_2_0_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN,jac_affine_inv_0_0_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN,jac_affine_inv_1_1_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN,jac_affine_inv_2_1_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN,jac_affine_inv_0_1_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN,jac_affine_inv_1_2_WHITE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN,jac_affine_inv_2_2_WHITE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN,jac_affine_inv_0_2_WHITE_DOWN),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4314,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4373,Dummy_4373,Dummy_4373,Dummy_4373))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4321,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4373,Dummy_4373,Dummy_4373,Dummy_4373))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4326,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4373,Dummy_4373,Dummy_4373,Dummy_4373))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4331,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4373,Dummy_4373,Dummy_4373,Dummy_4373)));
                {
                   {
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(Dummy_4374,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1],_mm256_add_pd(Dummy_4375,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(Dummy_4376,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(Dummy_4377,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(Dummy_4378,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(Dummy_4379,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                   }
                }
                const __m256d Dummy_4380 = _mm256_loadu_pd(& _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d Dummy_4381 = _mm256_loadu_pd(& _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d Dummy_4382 = _mm256_loadu_pd(& _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d Dummy_4383 = _mm256_loadu_pd(& _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d Dummy_4384 = _mm256_loadu_pd(& _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d Dummy_4385 = _mm256_loadu_pd(& _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d Dummy_4386 = _mm256_loadu_pd(& _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d Dummy_4387 = _mm256_loadu_pd(& _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d Dummy_4388 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4381,_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978)),_mm256_mul_pd(Dummy_4382,_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423))),_mm256_mul_pd(Dummy_4383,_mm256_set_pd(0.01482761006242336,0.01482761006242336,0.01482761006242336,0.01482761006242336))),_mm256_mul_pd(Dummy_4380,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)));
                const __m256d Dummy_4394 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4385,_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978)),_mm256_mul_pd(Dummy_4386,_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423))),_mm256_mul_pd(Dummy_4387,_mm256_set_pd(0.01482761006242336,0.01482761006242336,0.01482761006242336,0.01482761006242336))),_mm256_mul_pd(Dummy_4384,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_set_pd(abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP));
                const __m256d Dummy_4395 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4383,_mm256_set_pd(0.0048399363458717648,0.0048399363458717648,0.0048399363458717648,0.0048399363458717648)),_mm256_mul_pd(Dummy_4381,_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601))),_mm256_mul_pd(Dummy_4382,_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467))),_mm256_mul_pd(Dummy_4380,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12)));
                const __m256d Dummy_4399 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4387,_mm256_set_pd(0.0048399363458717648,0.0048399363458717648,0.0048399363458717648,0.0048399363458717648)),_mm256_mul_pd(Dummy_4385,_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601))),_mm256_mul_pd(Dummy_4386,_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467))),_mm256_mul_pd(Dummy_4384,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12))),_mm256_set_pd(abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP));
                const __m256d Dummy_4400 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4381,_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541)),_mm256_mul_pd(Dummy_4382,_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674))),_mm256_mul_pd(Dummy_4383,_mm256_set_pd(0.44773255210137269,0.44773255210137269,0.44773255210137269,0.44773255210137269))),_mm256_mul_pd(Dummy_4380,_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20)));
                const __m256d Dummy_4404 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4385,_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541)),_mm256_mul_pd(Dummy_4386,_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674))),_mm256_mul_pd(Dummy_4387,_mm256_set_pd(0.44773255210137269,0.44773255210137269,0.44773255210137269,0.44773255210137269))),_mm256_mul_pd(Dummy_4384,_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_set_pd(abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP));
                const __m256d Dummy_4405 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4383,_mm256_set_pd(0.35284634870858678,0.35284634870858678,0.35284634870858678,0.35284634870858678)),_mm256_mul_pd(Dummy_4382,_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612))),_mm256_mul_pd(Dummy_4381,_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779))),_mm256_mul_pd(Dummy_4380,_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28)));
                const __m256d Dummy_4409 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4387,_mm256_set_pd(0.35284634870858678,0.35284634870858678,0.35284634870858678,0.35284634870858678)),_mm256_mul_pd(Dummy_4386,_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612))),_mm256_mul_pd(Dummy_4385,_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779))),_mm256_mul_pd(Dummy_4384,_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28))),_mm256_set_pd(abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP,abs_det_jac_affine_BLUE_UP));
                const __m256d Dummy_4448 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4394,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4391,Dummy_4391,Dummy_4391,Dummy_4391)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4391,Dummy_4391,Dummy_4391,Dummy_4391)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4392,Dummy_4392,Dummy_4392,Dummy_4392)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4392,Dummy_4392,Dummy_4392,Dummy_4392)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4393,Dummy_4393,Dummy_4393,Dummy_4393)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4393,Dummy_4393,Dummy_4393,Dummy_4393)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4399,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4396,Dummy_4396,Dummy_4396,Dummy_4396)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4396,Dummy_4396,Dummy_4396,Dummy_4396)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4397,Dummy_4397,Dummy_4397,Dummy_4397)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4397,Dummy_4397,Dummy_4397,Dummy_4397)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4398,Dummy_4398,Dummy_4398,Dummy_4398)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4398,Dummy_4398,Dummy_4398,Dummy_4398)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4404,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4401,Dummy_4401,Dummy_4401,Dummy_4401)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4401,Dummy_4401,Dummy_4401,Dummy_4401)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4402,Dummy_4402,Dummy_4402,Dummy_4402)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4402,Dummy_4402,Dummy_4402,Dummy_4402)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4403,Dummy_4403,Dummy_4403,Dummy_4403)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4403,Dummy_4403,Dummy_4403,Dummy_4403)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4409,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4406,Dummy_4406,Dummy_4406,Dummy_4406)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4406,Dummy_4406,Dummy_4406,Dummy_4406)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4407,Dummy_4407,Dummy_4407,Dummy_4407)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4407,Dummy_4407,Dummy_4407,Dummy_4407)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4408,Dummy_4408,Dummy_4408,Dummy_4408)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4408,Dummy_4408,Dummy_4408,Dummy_4408)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4388,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4390,Dummy_4390,Dummy_4390,Dummy_4390))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4395,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4390,Dummy_4390,Dummy_4390,Dummy_4390))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4400,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4390,Dummy_4390,Dummy_4390,Dummy_4390))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4405,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4390,Dummy_4390,Dummy_4390,Dummy_4390)));
                const __m256d Dummy_4449 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4394,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4411,Dummy_4411,Dummy_4411,Dummy_4411)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4411,Dummy_4411,Dummy_4411,Dummy_4411)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4412,Dummy_4412,Dummy_4412,Dummy_4412)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4412,Dummy_4412,Dummy_4412,Dummy_4412)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4413,Dummy_4413,Dummy_4413,Dummy_4413)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4413,Dummy_4413,Dummy_4413,Dummy_4413)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4399,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4414,Dummy_4414,Dummy_4414,Dummy_4414)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4414,Dummy_4414,Dummy_4414,Dummy_4414)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4415,Dummy_4415,Dummy_4415,Dummy_4415)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4415,Dummy_4415,Dummy_4415,Dummy_4415)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4416,Dummy_4416,Dummy_4416,Dummy_4416)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4416,Dummy_4416,Dummy_4416,Dummy_4416)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4404,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4417,Dummy_4417,Dummy_4417,Dummy_4417)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4417,Dummy_4417,Dummy_4417,Dummy_4417)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4418,Dummy_4418,Dummy_4418,Dummy_4418)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4418,Dummy_4418,Dummy_4418,Dummy_4418)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4419,Dummy_4419,Dummy_4419,Dummy_4419)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4419,Dummy_4419,Dummy_4419,Dummy_4419)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4409,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4420,Dummy_4420,Dummy_4420,Dummy_4420)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4420,Dummy_4420,Dummy_4420,Dummy_4420)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4421,Dummy_4421,Dummy_4421,Dummy_4421)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4421,Dummy_4421,Dummy_4421,Dummy_4421)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4422,Dummy_4422,Dummy_4422,Dummy_4422)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4422,Dummy_4422,Dummy_4422,Dummy_4422)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4388,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4410,Dummy_4410,Dummy_4410,Dummy_4410))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4395,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4410,Dummy_4410,Dummy_4410,Dummy_4410))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4400,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4410,Dummy_4410,Dummy_4410,Dummy_4410))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4405,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4410,Dummy_4410,Dummy_4410,Dummy_4410)));
                const __m256d Dummy_4450 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4394,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4424,Dummy_4424,Dummy_4424,Dummy_4424)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4424,Dummy_4424,Dummy_4424,Dummy_4424)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4425,Dummy_4425,Dummy_4425,Dummy_4425)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4425,Dummy_4425,Dummy_4425,Dummy_4425)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4426,Dummy_4426,Dummy_4426,Dummy_4426)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4426,Dummy_4426,Dummy_4426,Dummy_4426)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4399,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4427,Dummy_4427,Dummy_4427,Dummy_4427)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4427,Dummy_4427,Dummy_4427,Dummy_4427)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4428,Dummy_4428,Dummy_4428,Dummy_4428)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4428,Dummy_4428,Dummy_4428,Dummy_4428)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4429,Dummy_4429,Dummy_4429,Dummy_4429)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4429,Dummy_4429,Dummy_4429,Dummy_4429)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4404,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4430,Dummy_4430,Dummy_4430,Dummy_4430)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4430,Dummy_4430,Dummy_4430,Dummy_4430)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4431,Dummy_4431,Dummy_4431,Dummy_4431)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4431,Dummy_4431,Dummy_4431,Dummy_4431)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4432,Dummy_4432,Dummy_4432,Dummy_4432)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4432,Dummy_4432,Dummy_4432,Dummy_4432)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4409,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4433,Dummy_4433,Dummy_4433,Dummy_4433)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4433,Dummy_4433,Dummy_4433,Dummy_4433)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4434,Dummy_4434,Dummy_4434,Dummy_4434)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4434,Dummy_4434,Dummy_4434,Dummy_4434)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4435,Dummy_4435,Dummy_4435,Dummy_4435)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4435,Dummy_4435,Dummy_4435,Dummy_4435)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4388,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4423,Dummy_4423,Dummy_4423,Dummy_4423))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4395,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4423,Dummy_4423,Dummy_4423,Dummy_4423))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4400,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4423,Dummy_4423,Dummy_4423,Dummy_4423))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4405,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4423,Dummy_4423,Dummy_4423,Dummy_4423)));
                const __m256d Dummy_4451 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4394,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4391,Dummy_4391,Dummy_4391,Dummy_4391)),_mm256_set_pd(Dummy_4411,Dummy_4411,Dummy_4411,Dummy_4411)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4391,Dummy_4391,Dummy_4391,Dummy_4391)),_mm256_set_pd(Dummy_4411,Dummy_4411,Dummy_4411,Dummy_4411))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4392,Dummy_4392,Dummy_4392,Dummy_4392)),_mm256_set_pd(Dummy_4412,Dummy_4412,Dummy_4412,Dummy_4412)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4392,Dummy_4392,Dummy_4392,Dummy_4392)),_mm256_set_pd(Dummy_4412,Dummy_4412,Dummy_4412,Dummy_4412)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4393,Dummy_4393,Dummy_4393,Dummy_4393)),_mm256_set_pd(Dummy_4413,Dummy_4413,Dummy_4413,Dummy_4413)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4393,Dummy_4393,Dummy_4393,Dummy_4393)),_mm256_set_pd(Dummy_4413,Dummy_4413,Dummy_4413,Dummy_4413))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4399,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4396,Dummy_4396,Dummy_4396,Dummy_4396)),_mm256_set_pd(Dummy_4414,Dummy_4414,Dummy_4414,Dummy_4414)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4396,Dummy_4396,Dummy_4396,Dummy_4396)),_mm256_set_pd(Dummy_4414,Dummy_4414,Dummy_4414,Dummy_4414))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4397,Dummy_4397,Dummy_4397,Dummy_4397)),_mm256_set_pd(Dummy_4415,Dummy_4415,Dummy_4415,Dummy_4415)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4397,Dummy_4397,Dummy_4397,Dummy_4397)),_mm256_set_pd(Dummy_4415,Dummy_4415,Dummy_4415,Dummy_4415)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4398,Dummy_4398,Dummy_4398,Dummy_4398)),_mm256_set_pd(Dummy_4416,Dummy_4416,Dummy_4416,Dummy_4416)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4398,Dummy_4398,Dummy_4398,Dummy_4398)),_mm256_set_pd(Dummy_4416,Dummy_4416,Dummy_4416,Dummy_4416))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4404,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4401,Dummy_4401,Dummy_4401,Dummy_4401)),_mm256_set_pd(Dummy_4417,Dummy_4417,Dummy_4417,Dummy_4417)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4401,Dummy_4401,Dummy_4401,Dummy_4401)),_mm256_set_pd(Dummy_4417,Dummy_4417,Dummy_4417,Dummy_4417))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4402,Dummy_4402,Dummy_4402,Dummy_4402)),_mm256_set_pd(Dummy_4418,Dummy_4418,Dummy_4418,Dummy_4418)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4402,Dummy_4402,Dummy_4402,Dummy_4402)),_mm256_set_pd(Dummy_4418,Dummy_4418,Dummy_4418,Dummy_4418)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4403,Dummy_4403,Dummy_4403,Dummy_4403)),_mm256_set_pd(Dummy_4419,Dummy_4419,Dummy_4419,Dummy_4419)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4403,Dummy_4403,Dummy_4403,Dummy_4403)),_mm256_set_pd(Dummy_4419,Dummy_4419,Dummy_4419,Dummy_4419))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4409,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4406,Dummy_4406,Dummy_4406,Dummy_4406)),_mm256_set_pd(Dummy_4420,Dummy_4420,Dummy_4420,Dummy_4420)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4406,Dummy_4406,Dummy_4406,Dummy_4406)),_mm256_set_pd(Dummy_4420,Dummy_4420,Dummy_4420,Dummy_4420))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4407,Dummy_4407,Dummy_4407,Dummy_4407)),_mm256_set_pd(Dummy_4421,Dummy_4421,Dummy_4421,Dummy_4421)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4407,Dummy_4407,Dummy_4407,Dummy_4407)),_mm256_set_pd(Dummy_4421,Dummy_4421,Dummy_4421,Dummy_4421)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4408,Dummy_4408,Dummy_4408,Dummy_4408)),_mm256_set_pd(Dummy_4422,Dummy_4422,Dummy_4422,Dummy_4422)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4408,Dummy_4408,Dummy_4408,Dummy_4408)),_mm256_set_pd(Dummy_4422,Dummy_4422,Dummy_4422,Dummy_4422))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4388,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4442,Dummy_4442,Dummy_4442,Dummy_4442))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4395,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4442,Dummy_4442,Dummy_4442,Dummy_4442))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4400,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4442,Dummy_4442,Dummy_4442,Dummy_4442))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4405,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4442,Dummy_4442,Dummy_4442,Dummy_4442)));
                const __m256d Dummy_4452 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4394,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4424,Dummy_4424,Dummy_4424,Dummy_4424)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4424,Dummy_4424,Dummy_4424,Dummy_4424))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4425,Dummy_4425,Dummy_4425,Dummy_4425)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4425,Dummy_4425,Dummy_4425,Dummy_4425)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4426,Dummy_4426,Dummy_4426,Dummy_4426)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4426,Dummy_4426,Dummy_4426,Dummy_4426))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4399,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4427,Dummy_4427,Dummy_4427,Dummy_4427)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4427,Dummy_4427,Dummy_4427,Dummy_4427))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4428,Dummy_4428,Dummy_4428,Dummy_4428)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4428,Dummy_4428,Dummy_4428,Dummy_4428)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4429,Dummy_4429,Dummy_4429,Dummy_4429)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4429,Dummy_4429,Dummy_4429,Dummy_4429))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4409,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4433,Dummy_4433,Dummy_4433,Dummy_4433)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4433,Dummy_4433,Dummy_4433,Dummy_4433))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4434,Dummy_4434,Dummy_4434,Dummy_4434)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4434,Dummy_4434,Dummy_4434,Dummy_4434)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4435,Dummy_4435,Dummy_4435,Dummy_4435)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4435,Dummy_4435,Dummy_4435,Dummy_4435))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4404,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4430,Dummy_4430,Dummy_4430,Dummy_4430)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4430,Dummy_4430,Dummy_4430,Dummy_4430))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4431,Dummy_4431,Dummy_4431,Dummy_4431)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4431,Dummy_4431,Dummy_4431,Dummy_4431)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4432,Dummy_4432,Dummy_4432,Dummy_4432)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4432,Dummy_4432,Dummy_4432,Dummy_4432))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4388,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4446,Dummy_4446,Dummy_4446,Dummy_4446))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4395,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4446,Dummy_4446,Dummy_4446,Dummy_4446))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4400,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4446,Dummy_4446,Dummy_4446,Dummy_4446))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4405,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4446,Dummy_4446,Dummy_4446,Dummy_4446)));
                const __m256d Dummy_4453 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4394,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4399,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4404,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4409,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP,jac_affine_inv_1_0_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP,jac_affine_inv_2_0_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP,jac_affine_inv_0_0_BLUE_UP),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP,jac_affine_inv_1_1_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP,jac_affine_inv_2_1_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP,jac_affine_inv_0_1_BLUE_UP),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP,jac_affine_inv_1_2_BLUE_UP)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP,jac_affine_inv_2_2_BLUE_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP,jac_affine_inv_0_2_BLUE_UP),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4388,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4447,Dummy_4447,Dummy_4447,Dummy_4447))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4395,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4447,Dummy_4447,Dummy_4447,Dummy_4447))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4400,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4447,Dummy_4447,Dummy_4447,Dummy_4447))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4405,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4447,Dummy_4447,Dummy_4447,Dummy_4447)));
                {
                   {
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(Dummy_4448,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(Dummy_4449,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(Dummy_4450,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(Dummy_4451,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(Dummy_4452,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(Dummy_4453,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                   }
                }
                const __m256d Dummy_4454 = _mm256_loadu_pd(& _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d Dummy_4455 = _mm256_loadu_pd(& _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d Dummy_4456 = _mm256_loadu_pd(& _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d Dummy_4457 = _mm256_loadu_pd(& _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d Dummy_4458 = _mm256_loadu_pd(& _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d Dummy_4459 = _mm256_loadu_pd(& _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d Dummy_4460 = _mm256_loadu_pd(& _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d Dummy_4461 = _mm256_loadu_pd(& _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d Dummy_4462 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4455,_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978)),_mm256_mul_pd(Dummy_4456,_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423))),_mm256_mul_pd(Dummy_4457,_mm256_set_pd(0.01482761006242336,0.01482761006242336,0.01482761006242336,0.01482761006242336))),_mm256_mul_pd(Dummy_4454,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)));
                const __m256d Dummy_4468 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4459,_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978)),_mm256_mul_pd(Dummy_4460,_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423))),_mm256_mul_pd(Dummy_4461,_mm256_set_pd(0.01482761006242336,0.01482761006242336,0.01482761006242336,0.01482761006242336))),_mm256_mul_pd(Dummy_4458,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_set_pd(abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN));
                const __m256d Dummy_4469 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4457,_mm256_set_pd(0.0048399363458717648,0.0048399363458717648,0.0048399363458717648,0.0048399363458717648)),_mm256_mul_pd(Dummy_4455,_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601))),_mm256_mul_pd(Dummy_4456,_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467))),_mm256_mul_pd(Dummy_4454,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12)));
                const __m256d Dummy_4473 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4461,_mm256_set_pd(0.0048399363458717648,0.0048399363458717648,0.0048399363458717648,0.0048399363458717648)),_mm256_mul_pd(Dummy_4459,_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601))),_mm256_mul_pd(Dummy_4460,_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467))),_mm256_mul_pd(Dummy_4458,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12))),_mm256_set_pd(abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN));
                const __m256d Dummy_4474 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4455,_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541)),_mm256_mul_pd(Dummy_4456,_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674))),_mm256_mul_pd(Dummy_4457,_mm256_set_pd(0.44773255210137269,0.44773255210137269,0.44773255210137269,0.44773255210137269))),_mm256_mul_pd(Dummy_4454,_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20)));
                const __m256d Dummy_4478 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4459,_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541)),_mm256_mul_pd(Dummy_4460,_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674))),_mm256_mul_pd(Dummy_4461,_mm256_set_pd(0.44773255210137269,0.44773255210137269,0.44773255210137269,0.44773255210137269))),_mm256_mul_pd(Dummy_4458,_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_set_pd(abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN));
                const __m256d Dummy_4479 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4457,_mm256_set_pd(0.35284634870858678,0.35284634870858678,0.35284634870858678,0.35284634870858678)),_mm256_mul_pd(Dummy_4456,_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612))),_mm256_mul_pd(Dummy_4455,_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779))),_mm256_mul_pd(Dummy_4454,_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28)));
                const __m256d Dummy_4483 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4461,_mm256_set_pd(0.35284634870858678,0.35284634870858678,0.35284634870858678,0.35284634870858678)),_mm256_mul_pd(Dummy_4460,_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612))),_mm256_mul_pd(Dummy_4459,_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779))),_mm256_mul_pd(Dummy_4458,_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28))),_mm256_set_pd(abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN,abs_det_jac_affine_BLUE_DOWN));
                const __m256d Dummy_4522 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4468,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4465,Dummy_4465,Dummy_4465,Dummy_4465)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4465,Dummy_4465,Dummy_4465,Dummy_4465)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4466,Dummy_4466,Dummy_4466,Dummy_4466)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4466,Dummy_4466,Dummy_4466,Dummy_4466)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4467,Dummy_4467,Dummy_4467,Dummy_4467)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4467,Dummy_4467,Dummy_4467,Dummy_4467)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4473,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4470,Dummy_4470,Dummy_4470,Dummy_4470)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4470,Dummy_4470,Dummy_4470,Dummy_4470)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4471,Dummy_4471,Dummy_4471,Dummy_4471)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4471,Dummy_4471,Dummy_4471,Dummy_4471)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4472,Dummy_4472,Dummy_4472,Dummy_4472)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4472,Dummy_4472,Dummy_4472,Dummy_4472)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4478,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4475,Dummy_4475,Dummy_4475,Dummy_4475)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4475,Dummy_4475,Dummy_4475,Dummy_4475)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4476,Dummy_4476,Dummy_4476,Dummy_4476)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4476,Dummy_4476,Dummy_4476,Dummy_4476)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4477,Dummy_4477,Dummy_4477,Dummy_4477)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4477,Dummy_4477,Dummy_4477,Dummy_4477)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4483,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4480,Dummy_4480,Dummy_4480,Dummy_4480)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4480,Dummy_4480,Dummy_4480,Dummy_4480)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4481,Dummy_4481,Dummy_4481,Dummy_4481)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4481,Dummy_4481,Dummy_4481,Dummy_4481)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4482,Dummy_4482,Dummy_4482,Dummy_4482)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4482,Dummy_4482,Dummy_4482,Dummy_4482)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4462,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4464,Dummy_4464,Dummy_4464,Dummy_4464))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4469,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4464,Dummy_4464,Dummy_4464,Dummy_4464))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4474,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4464,Dummy_4464,Dummy_4464,Dummy_4464))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4479,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4464,Dummy_4464,Dummy_4464,Dummy_4464)));
                const __m256d Dummy_4523 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4468,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4485,Dummy_4485,Dummy_4485,Dummy_4485)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4485,Dummy_4485,Dummy_4485,Dummy_4485)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4486,Dummy_4486,Dummy_4486,Dummy_4486)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4486,Dummy_4486,Dummy_4486,Dummy_4486)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4487,Dummy_4487,Dummy_4487,Dummy_4487)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4487,Dummy_4487,Dummy_4487,Dummy_4487)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4473,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4488,Dummy_4488,Dummy_4488,Dummy_4488)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4488,Dummy_4488,Dummy_4488,Dummy_4488)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4489,Dummy_4489,Dummy_4489,Dummy_4489)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4489,Dummy_4489,Dummy_4489,Dummy_4489)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4490,Dummy_4490,Dummy_4490,Dummy_4490)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4490,Dummy_4490,Dummy_4490,Dummy_4490)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4478,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4491,Dummy_4491,Dummy_4491,Dummy_4491)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4491,Dummy_4491,Dummy_4491,Dummy_4491)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4492,Dummy_4492,Dummy_4492,Dummy_4492)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4492,Dummy_4492,Dummy_4492,Dummy_4492)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4493,Dummy_4493,Dummy_4493,Dummy_4493)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4493,Dummy_4493,Dummy_4493,Dummy_4493)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4483,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4494,Dummy_4494,Dummy_4494,Dummy_4494)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4494,Dummy_4494,Dummy_4494,Dummy_4494)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4495,Dummy_4495,Dummy_4495,Dummy_4495)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4495,Dummy_4495,Dummy_4495,Dummy_4495)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4496,Dummy_4496,Dummy_4496,Dummy_4496)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4496,Dummy_4496,Dummy_4496,Dummy_4496)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4462,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4484,Dummy_4484,Dummy_4484,Dummy_4484))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4469,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4484,Dummy_4484,Dummy_4484,Dummy_4484))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4474,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4484,Dummy_4484,Dummy_4484,Dummy_4484))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4479,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4484,Dummy_4484,Dummy_4484,Dummy_4484)));
                const __m256d Dummy_4524 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4468,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4498,Dummy_4498,Dummy_4498,Dummy_4498)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4498,Dummy_4498,Dummy_4498,Dummy_4498)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4499,Dummy_4499,Dummy_4499,Dummy_4499)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4499,Dummy_4499,Dummy_4499,Dummy_4499)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4500,Dummy_4500,Dummy_4500,Dummy_4500)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4500,Dummy_4500,Dummy_4500,Dummy_4500)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4473,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4501,Dummy_4501,Dummy_4501,Dummy_4501)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4501,Dummy_4501,Dummy_4501,Dummy_4501)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4502,Dummy_4502,Dummy_4502,Dummy_4502)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4502,Dummy_4502,Dummy_4502,Dummy_4502)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4503,Dummy_4503,Dummy_4503,Dummy_4503)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4503,Dummy_4503,Dummy_4503,Dummy_4503)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4478,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4504,Dummy_4504,Dummy_4504,Dummy_4504)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4504,Dummy_4504,Dummy_4504,Dummy_4504)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4505,Dummy_4505,Dummy_4505,Dummy_4505)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4505,Dummy_4505,Dummy_4505,Dummy_4505)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4506,Dummy_4506,Dummy_4506,Dummy_4506)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4506,Dummy_4506,Dummy_4506,Dummy_4506)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4483,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4507,Dummy_4507,Dummy_4507,Dummy_4507)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4507,Dummy_4507,Dummy_4507,Dummy_4507)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4508,Dummy_4508,Dummy_4508,Dummy_4508)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4508,Dummy_4508,Dummy_4508,Dummy_4508)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4509,Dummy_4509,Dummy_4509,Dummy_4509)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4509,Dummy_4509,Dummy_4509,Dummy_4509)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4462,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4497,Dummy_4497,Dummy_4497,Dummy_4497))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4469,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4497,Dummy_4497,Dummy_4497,Dummy_4497))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4474,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4497,Dummy_4497,Dummy_4497,Dummy_4497))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4479,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4497,Dummy_4497,Dummy_4497,Dummy_4497)));
                const __m256d Dummy_4525 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4468,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4465,Dummy_4465,Dummy_4465,Dummy_4465)),_mm256_set_pd(Dummy_4485,Dummy_4485,Dummy_4485,Dummy_4485)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4465,Dummy_4465,Dummy_4465,Dummy_4465)),_mm256_set_pd(Dummy_4485,Dummy_4485,Dummy_4485,Dummy_4485))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4466,Dummy_4466,Dummy_4466,Dummy_4466)),_mm256_set_pd(Dummy_4486,Dummy_4486,Dummy_4486,Dummy_4486)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4466,Dummy_4466,Dummy_4466,Dummy_4466)),_mm256_set_pd(Dummy_4486,Dummy_4486,Dummy_4486,Dummy_4486)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4467,Dummy_4467,Dummy_4467,Dummy_4467)),_mm256_set_pd(Dummy_4487,Dummy_4487,Dummy_4487,Dummy_4487)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4467,Dummy_4467,Dummy_4467,Dummy_4467)),_mm256_set_pd(Dummy_4487,Dummy_4487,Dummy_4487,Dummy_4487))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4473,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4470,Dummy_4470,Dummy_4470,Dummy_4470)),_mm256_set_pd(Dummy_4488,Dummy_4488,Dummy_4488,Dummy_4488)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4470,Dummy_4470,Dummy_4470,Dummy_4470)),_mm256_set_pd(Dummy_4488,Dummy_4488,Dummy_4488,Dummy_4488))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4471,Dummy_4471,Dummy_4471,Dummy_4471)),_mm256_set_pd(Dummy_4489,Dummy_4489,Dummy_4489,Dummy_4489)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4471,Dummy_4471,Dummy_4471,Dummy_4471)),_mm256_set_pd(Dummy_4489,Dummy_4489,Dummy_4489,Dummy_4489)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4472,Dummy_4472,Dummy_4472,Dummy_4472)),_mm256_set_pd(Dummy_4490,Dummy_4490,Dummy_4490,Dummy_4490)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4472,Dummy_4472,Dummy_4472,Dummy_4472)),_mm256_set_pd(Dummy_4490,Dummy_4490,Dummy_4490,Dummy_4490))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4478,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4475,Dummy_4475,Dummy_4475,Dummy_4475)),_mm256_set_pd(Dummy_4491,Dummy_4491,Dummy_4491,Dummy_4491)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4475,Dummy_4475,Dummy_4475,Dummy_4475)),_mm256_set_pd(Dummy_4491,Dummy_4491,Dummy_4491,Dummy_4491))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4476,Dummy_4476,Dummy_4476,Dummy_4476)),_mm256_set_pd(Dummy_4492,Dummy_4492,Dummy_4492,Dummy_4492)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4476,Dummy_4476,Dummy_4476,Dummy_4476)),_mm256_set_pd(Dummy_4492,Dummy_4492,Dummy_4492,Dummy_4492)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4477,Dummy_4477,Dummy_4477,Dummy_4477)),_mm256_set_pd(Dummy_4493,Dummy_4493,Dummy_4493,Dummy_4493)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4477,Dummy_4477,Dummy_4477,Dummy_4477)),_mm256_set_pd(Dummy_4493,Dummy_4493,Dummy_4493,Dummy_4493))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4483,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4480,Dummy_4480,Dummy_4480,Dummy_4480)),_mm256_set_pd(Dummy_4494,Dummy_4494,Dummy_4494,Dummy_4494)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4480,Dummy_4480,Dummy_4480,Dummy_4480)),_mm256_set_pd(Dummy_4494,Dummy_4494,Dummy_4494,Dummy_4494))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4481,Dummy_4481,Dummy_4481,Dummy_4481)),_mm256_set_pd(Dummy_4495,Dummy_4495,Dummy_4495,Dummy_4495)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4481,Dummy_4481,Dummy_4481,Dummy_4481)),_mm256_set_pd(Dummy_4495,Dummy_4495,Dummy_4495,Dummy_4495)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4482,Dummy_4482,Dummy_4482,Dummy_4482)),_mm256_set_pd(Dummy_4496,Dummy_4496,Dummy_4496,Dummy_4496)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4482,Dummy_4482,Dummy_4482,Dummy_4482)),_mm256_set_pd(Dummy_4496,Dummy_4496,Dummy_4496,Dummy_4496))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4462,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4516,Dummy_4516,Dummy_4516,Dummy_4516))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4469,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4516,Dummy_4516,Dummy_4516,Dummy_4516))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4474,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4516,Dummy_4516,Dummy_4516,Dummy_4516))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4479,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4516,Dummy_4516,Dummy_4516,Dummy_4516)));
                const __m256d Dummy_4526 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4468,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4498,Dummy_4498,Dummy_4498,Dummy_4498)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4498,Dummy_4498,Dummy_4498,Dummy_4498))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4499,Dummy_4499,Dummy_4499,Dummy_4499)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4499,Dummy_4499,Dummy_4499,Dummy_4499)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4500,Dummy_4500,Dummy_4500,Dummy_4500)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4500,Dummy_4500,Dummy_4500,Dummy_4500))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4473,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4501,Dummy_4501,Dummy_4501,Dummy_4501)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4501,Dummy_4501,Dummy_4501,Dummy_4501))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4502,Dummy_4502,Dummy_4502,Dummy_4502)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4502,Dummy_4502,Dummy_4502,Dummy_4502)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4503,Dummy_4503,Dummy_4503,Dummy_4503)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4503,Dummy_4503,Dummy_4503,Dummy_4503))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4483,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4507,Dummy_4507,Dummy_4507,Dummy_4507)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4507,Dummy_4507,Dummy_4507,Dummy_4507))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4508,Dummy_4508,Dummy_4508,Dummy_4508)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4508,Dummy_4508,Dummy_4508,Dummy_4508)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4509,Dummy_4509,Dummy_4509,Dummy_4509)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4509,Dummy_4509,Dummy_4509,Dummy_4509))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4478,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4504,Dummy_4504,Dummy_4504,Dummy_4504)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4504,Dummy_4504,Dummy_4504,Dummy_4504))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4505,Dummy_4505,Dummy_4505,Dummy_4505)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4505,Dummy_4505,Dummy_4505,Dummy_4505)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4506,Dummy_4506,Dummy_4506,Dummy_4506)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4506,Dummy_4506,Dummy_4506,Dummy_4506))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4462,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4520,Dummy_4520,Dummy_4520,Dummy_4520))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4469,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4520,Dummy_4520,Dummy_4520,Dummy_4520))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4474,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4520,Dummy_4520,Dummy_4520,Dummy_4520))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4479,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4520,Dummy_4520,Dummy_4520,Dummy_4520)));
                const __m256d Dummy_4527 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4468,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4473,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4478,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4483,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN,jac_affine_inv_1_0_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN,jac_affine_inv_2_0_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN,jac_affine_inv_0_0_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN,jac_affine_inv_1_1_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN,jac_affine_inv_2_1_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN,jac_affine_inv_0_1_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN,jac_affine_inv_1_2_BLUE_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN,jac_affine_inv_2_2_BLUE_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN,jac_affine_inv_0_2_BLUE_DOWN),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4462,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4521,Dummy_4521,Dummy_4521,Dummy_4521))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4469,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4521,Dummy_4521,Dummy_4521,Dummy_4521))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4474,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4521,Dummy_4521,Dummy_4521,Dummy_4521))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4479,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4521,Dummy_4521,Dummy_4521,Dummy_4521)));
                {
                   {
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(Dummy_4522,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(Dummy_4523,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(Dummy_4524,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(Dummy_4525,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(Dummy_4526,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(Dummy_4527,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                   }
                }
                const __m256d Dummy_4528 = _mm256_loadu_pd(& _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d Dummy_4529 = _mm256_loadu_pd(& _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d Dummy_4530 = _mm256_loadu_pd(& _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d Dummy_4531 = _mm256_loadu_pd(& _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d Dummy_4532 = _mm256_loadu_pd(& _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d Dummy_4533 = _mm256_loadu_pd(& _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d Dummy_4534 = _mm256_loadu_pd(& _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d Dummy_4535 = _mm256_loadu_pd(& _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d Dummy_4536 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4529,_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978)),_mm256_mul_pd(Dummy_4530,_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423))),_mm256_mul_pd(Dummy_4531,_mm256_set_pd(0.01482761006242336,0.01482761006242336,0.01482761006242336,0.01482761006242336))),_mm256_mul_pd(Dummy_4528,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)));
                const __m256d Dummy_4542 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4533,_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978)),_mm256_mul_pd(Dummy_4534,_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423))),_mm256_mul_pd(Dummy_4535,_mm256_set_pd(0.01482761006242336,0.01482761006242336,0.01482761006242336,0.01482761006242336))),_mm256_mul_pd(Dummy_4532,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_set_pd(abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP));
                const __m256d Dummy_4543 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4531,_mm256_set_pd(0.0048399363458717648,0.0048399363458717648,0.0048399363458717648,0.0048399363458717648)),_mm256_mul_pd(Dummy_4529,_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601))),_mm256_mul_pd(Dummy_4530,_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467))),_mm256_mul_pd(Dummy_4528,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12)));
                const __m256d Dummy_4547 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4535,_mm256_set_pd(0.0048399363458717648,0.0048399363458717648,0.0048399363458717648,0.0048399363458717648)),_mm256_mul_pd(Dummy_4533,_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601))),_mm256_mul_pd(Dummy_4534,_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467))),_mm256_mul_pd(Dummy_4532,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12))),_mm256_set_pd(abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP));
                const __m256d Dummy_4548 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4529,_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541)),_mm256_mul_pd(Dummy_4530,_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674))),_mm256_mul_pd(Dummy_4531,_mm256_set_pd(0.44773255210137269,0.44773255210137269,0.44773255210137269,0.44773255210137269))),_mm256_mul_pd(Dummy_4528,_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20)));
                const __m256d Dummy_4552 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4533,_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541)),_mm256_mul_pd(Dummy_4534,_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674))),_mm256_mul_pd(Dummy_4535,_mm256_set_pd(0.44773255210137269,0.44773255210137269,0.44773255210137269,0.44773255210137269))),_mm256_mul_pd(Dummy_4532,_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_set_pd(abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP));
                const __m256d Dummy_4553 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4531,_mm256_set_pd(0.35284634870858678,0.35284634870858678,0.35284634870858678,0.35284634870858678)),_mm256_mul_pd(Dummy_4530,_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612))),_mm256_mul_pd(Dummy_4529,_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779))),_mm256_mul_pd(Dummy_4528,_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28)));
                const __m256d Dummy_4557 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4535,_mm256_set_pd(0.35284634870858678,0.35284634870858678,0.35284634870858678,0.35284634870858678)),_mm256_mul_pd(Dummy_4534,_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612))),_mm256_mul_pd(Dummy_4533,_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779))),_mm256_mul_pd(Dummy_4532,_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28))),_mm256_set_pd(abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP,abs_det_jac_affine_GREEN_UP));
                const __m256d Dummy_4596 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4542,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4539,Dummy_4539,Dummy_4539,Dummy_4539)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4539,Dummy_4539,Dummy_4539,Dummy_4539)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4540,Dummy_4540,Dummy_4540,Dummy_4540)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4540,Dummy_4540,Dummy_4540,Dummy_4540)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4541,Dummy_4541,Dummy_4541,Dummy_4541)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4541,Dummy_4541,Dummy_4541,Dummy_4541)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4547,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4544,Dummy_4544,Dummy_4544,Dummy_4544)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4544,Dummy_4544,Dummy_4544,Dummy_4544)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4545,Dummy_4545,Dummy_4545,Dummy_4545)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4545,Dummy_4545,Dummy_4545,Dummy_4545)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4546,Dummy_4546,Dummy_4546,Dummy_4546)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4546,Dummy_4546,Dummy_4546,Dummy_4546)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4552,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4549,Dummy_4549,Dummy_4549,Dummy_4549)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4549,Dummy_4549,Dummy_4549,Dummy_4549)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4550,Dummy_4550,Dummy_4550,Dummy_4550)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4550,Dummy_4550,Dummy_4550,Dummy_4550)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4551,Dummy_4551,Dummy_4551,Dummy_4551)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4551,Dummy_4551,Dummy_4551,Dummy_4551)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4557,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4554,Dummy_4554,Dummy_4554,Dummy_4554)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4554,Dummy_4554,Dummy_4554,Dummy_4554)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4555,Dummy_4555,Dummy_4555,Dummy_4555)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4555,Dummy_4555,Dummy_4555,Dummy_4555)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4556,Dummy_4556,Dummy_4556,Dummy_4556)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4556,Dummy_4556,Dummy_4556,Dummy_4556)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4536,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4538,Dummy_4538,Dummy_4538,Dummy_4538))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4543,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4538,Dummy_4538,Dummy_4538,Dummy_4538))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4548,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4538,Dummy_4538,Dummy_4538,Dummy_4538))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4553,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4538,Dummy_4538,Dummy_4538,Dummy_4538)));
                const __m256d Dummy_4597 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4542,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4559,Dummy_4559,Dummy_4559,Dummy_4559)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4559,Dummy_4559,Dummy_4559,Dummy_4559)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4560,Dummy_4560,Dummy_4560,Dummy_4560)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4560,Dummy_4560,Dummy_4560,Dummy_4560)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4561,Dummy_4561,Dummy_4561,Dummy_4561)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4561,Dummy_4561,Dummy_4561,Dummy_4561)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4547,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4562,Dummy_4562,Dummy_4562,Dummy_4562)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4562,Dummy_4562,Dummy_4562,Dummy_4562)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4563,Dummy_4563,Dummy_4563,Dummy_4563)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4563,Dummy_4563,Dummy_4563,Dummy_4563)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4564,Dummy_4564,Dummy_4564,Dummy_4564)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4564,Dummy_4564,Dummy_4564,Dummy_4564)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4552,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4565,Dummy_4565,Dummy_4565,Dummy_4565)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4565,Dummy_4565,Dummy_4565,Dummy_4565)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4566,Dummy_4566,Dummy_4566,Dummy_4566)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4566,Dummy_4566,Dummy_4566,Dummy_4566)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4567,Dummy_4567,Dummy_4567,Dummy_4567)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4567,Dummy_4567,Dummy_4567,Dummy_4567)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4557,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4568,Dummy_4568,Dummy_4568,Dummy_4568)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4568,Dummy_4568,Dummy_4568,Dummy_4568)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4569,Dummy_4569,Dummy_4569,Dummy_4569)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4569,Dummy_4569,Dummy_4569,Dummy_4569)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4570,Dummy_4570,Dummy_4570,Dummy_4570)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4570,Dummy_4570,Dummy_4570,Dummy_4570)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4536,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4558,Dummy_4558,Dummy_4558,Dummy_4558))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4543,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4558,Dummy_4558,Dummy_4558,Dummy_4558))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4548,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4558,Dummy_4558,Dummy_4558,Dummy_4558))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4553,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4558,Dummy_4558,Dummy_4558,Dummy_4558)));
                const __m256d Dummy_4598 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4542,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4572,Dummy_4572,Dummy_4572,Dummy_4572)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4572,Dummy_4572,Dummy_4572,Dummy_4572)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4573,Dummy_4573,Dummy_4573,Dummy_4573)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4573,Dummy_4573,Dummy_4573,Dummy_4573)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4574,Dummy_4574,Dummy_4574,Dummy_4574)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4574,Dummy_4574,Dummy_4574,Dummy_4574)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4547,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4575,Dummy_4575,Dummy_4575,Dummy_4575)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4575,Dummy_4575,Dummy_4575,Dummy_4575)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4576,Dummy_4576,Dummy_4576,Dummy_4576)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4576,Dummy_4576,Dummy_4576,Dummy_4576)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4577,Dummy_4577,Dummy_4577,Dummy_4577)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4577,Dummy_4577,Dummy_4577,Dummy_4577)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4552,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4578,Dummy_4578,Dummy_4578,Dummy_4578)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4578,Dummy_4578,Dummy_4578,Dummy_4578)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4579,Dummy_4579,Dummy_4579,Dummy_4579)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4579,Dummy_4579,Dummy_4579,Dummy_4579)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4580,Dummy_4580,Dummy_4580,Dummy_4580)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4580,Dummy_4580,Dummy_4580,Dummy_4580)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4557,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4581,Dummy_4581,Dummy_4581,Dummy_4581)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4581,Dummy_4581,Dummy_4581,Dummy_4581)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4582,Dummy_4582,Dummy_4582,Dummy_4582)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4582,Dummy_4582,Dummy_4582,Dummy_4582)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4583,Dummy_4583,Dummy_4583,Dummy_4583)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4583,Dummy_4583,Dummy_4583,Dummy_4583)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4536,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4571,Dummy_4571,Dummy_4571,Dummy_4571))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4543,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4571,Dummy_4571,Dummy_4571,Dummy_4571))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4548,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4571,Dummy_4571,Dummy_4571,Dummy_4571))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4553,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4571,Dummy_4571,Dummy_4571,Dummy_4571)));
                const __m256d Dummy_4599 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4542,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4539,Dummy_4539,Dummy_4539,Dummy_4539)),_mm256_set_pd(Dummy_4559,Dummy_4559,Dummy_4559,Dummy_4559)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4539,Dummy_4539,Dummy_4539,Dummy_4539)),_mm256_set_pd(Dummy_4559,Dummy_4559,Dummy_4559,Dummy_4559))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4540,Dummy_4540,Dummy_4540,Dummy_4540)),_mm256_set_pd(Dummy_4560,Dummy_4560,Dummy_4560,Dummy_4560)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4540,Dummy_4540,Dummy_4540,Dummy_4540)),_mm256_set_pd(Dummy_4560,Dummy_4560,Dummy_4560,Dummy_4560)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4541,Dummy_4541,Dummy_4541,Dummy_4541)),_mm256_set_pd(Dummy_4561,Dummy_4561,Dummy_4561,Dummy_4561)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4541,Dummy_4541,Dummy_4541,Dummy_4541)),_mm256_set_pd(Dummy_4561,Dummy_4561,Dummy_4561,Dummy_4561))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4547,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4544,Dummy_4544,Dummy_4544,Dummy_4544)),_mm256_set_pd(Dummy_4562,Dummy_4562,Dummy_4562,Dummy_4562)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4544,Dummy_4544,Dummy_4544,Dummy_4544)),_mm256_set_pd(Dummy_4562,Dummy_4562,Dummy_4562,Dummy_4562))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4545,Dummy_4545,Dummy_4545,Dummy_4545)),_mm256_set_pd(Dummy_4563,Dummy_4563,Dummy_4563,Dummy_4563)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4545,Dummy_4545,Dummy_4545,Dummy_4545)),_mm256_set_pd(Dummy_4563,Dummy_4563,Dummy_4563,Dummy_4563)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4546,Dummy_4546,Dummy_4546,Dummy_4546)),_mm256_set_pd(Dummy_4564,Dummy_4564,Dummy_4564,Dummy_4564)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4546,Dummy_4546,Dummy_4546,Dummy_4546)),_mm256_set_pd(Dummy_4564,Dummy_4564,Dummy_4564,Dummy_4564))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4552,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4549,Dummy_4549,Dummy_4549,Dummy_4549)),_mm256_set_pd(Dummy_4565,Dummy_4565,Dummy_4565,Dummy_4565)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4549,Dummy_4549,Dummy_4549,Dummy_4549)),_mm256_set_pd(Dummy_4565,Dummy_4565,Dummy_4565,Dummy_4565))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4550,Dummy_4550,Dummy_4550,Dummy_4550)),_mm256_set_pd(Dummy_4566,Dummy_4566,Dummy_4566,Dummy_4566)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4550,Dummy_4550,Dummy_4550,Dummy_4550)),_mm256_set_pd(Dummy_4566,Dummy_4566,Dummy_4566,Dummy_4566)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4551,Dummy_4551,Dummy_4551,Dummy_4551)),_mm256_set_pd(Dummy_4567,Dummy_4567,Dummy_4567,Dummy_4567)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4551,Dummy_4551,Dummy_4551,Dummy_4551)),_mm256_set_pd(Dummy_4567,Dummy_4567,Dummy_4567,Dummy_4567))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4557,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4554,Dummy_4554,Dummy_4554,Dummy_4554)),_mm256_set_pd(Dummy_4568,Dummy_4568,Dummy_4568,Dummy_4568)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4554,Dummy_4554,Dummy_4554,Dummy_4554)),_mm256_set_pd(Dummy_4568,Dummy_4568,Dummy_4568,Dummy_4568))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4555,Dummy_4555,Dummy_4555,Dummy_4555)),_mm256_set_pd(Dummy_4569,Dummy_4569,Dummy_4569,Dummy_4569)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4555,Dummy_4555,Dummy_4555,Dummy_4555)),_mm256_set_pd(Dummy_4569,Dummy_4569,Dummy_4569,Dummy_4569)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4556,Dummy_4556,Dummy_4556,Dummy_4556)),_mm256_set_pd(Dummy_4570,Dummy_4570,Dummy_4570,Dummy_4570)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4556,Dummy_4556,Dummy_4556,Dummy_4556)),_mm256_set_pd(Dummy_4570,Dummy_4570,Dummy_4570,Dummy_4570))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4536,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4590,Dummy_4590,Dummy_4590,Dummy_4590))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4543,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4590,Dummy_4590,Dummy_4590,Dummy_4590))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4548,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4590,Dummy_4590,Dummy_4590,Dummy_4590))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4553,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4590,Dummy_4590,Dummy_4590,Dummy_4590)));
                const __m256d Dummy_4600 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4542,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4572,Dummy_4572,Dummy_4572,Dummy_4572)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4572,Dummy_4572,Dummy_4572,Dummy_4572))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4573,Dummy_4573,Dummy_4573,Dummy_4573)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4573,Dummy_4573,Dummy_4573,Dummy_4573)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4574,Dummy_4574,Dummy_4574,Dummy_4574)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4574,Dummy_4574,Dummy_4574,Dummy_4574))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4547,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4575,Dummy_4575,Dummy_4575,Dummy_4575)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4575,Dummy_4575,Dummy_4575,Dummy_4575))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4576,Dummy_4576,Dummy_4576,Dummy_4576)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4576,Dummy_4576,Dummy_4576,Dummy_4576)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4577,Dummy_4577,Dummy_4577,Dummy_4577)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4577,Dummy_4577,Dummy_4577,Dummy_4577))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4557,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4581,Dummy_4581,Dummy_4581,Dummy_4581)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4581,Dummy_4581,Dummy_4581,Dummy_4581))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4582,Dummy_4582,Dummy_4582,Dummy_4582)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4582,Dummy_4582,Dummy_4582,Dummy_4582)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4583,Dummy_4583,Dummy_4583,Dummy_4583)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4583,Dummy_4583,Dummy_4583,Dummy_4583))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4552,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4578,Dummy_4578,Dummy_4578,Dummy_4578)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4578,Dummy_4578,Dummy_4578,Dummy_4578))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4579,Dummy_4579,Dummy_4579,Dummy_4579)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4579,Dummy_4579,Dummy_4579,Dummy_4579)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4580,Dummy_4580,Dummy_4580,Dummy_4580)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4580,Dummy_4580,Dummy_4580,Dummy_4580))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4536,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4594,Dummy_4594,Dummy_4594,Dummy_4594))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4543,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4594,Dummy_4594,Dummy_4594,Dummy_4594))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4548,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4594,Dummy_4594,Dummy_4594,Dummy_4594))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4553,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4594,Dummy_4594,Dummy_4594,Dummy_4594)));
                const __m256d Dummy_4601 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4542,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4547,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4552,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4557,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP,jac_affine_inv_1_0_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP,jac_affine_inv_2_0_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP,jac_affine_inv_0_0_GREEN_UP),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP,jac_affine_inv_1_1_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP,jac_affine_inv_2_1_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP,jac_affine_inv_0_1_GREEN_UP),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP,jac_affine_inv_1_2_GREEN_UP)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP,jac_affine_inv_2_2_GREEN_UP))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP,jac_affine_inv_0_2_GREEN_UP),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4536,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4595,Dummy_4595,Dummy_4595,Dummy_4595))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4543,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4595,Dummy_4595,Dummy_4595,Dummy_4595))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4548,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4595,Dummy_4595,Dummy_4595,Dummy_4595))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4553,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4595,Dummy_4595,Dummy_4595,Dummy_4595)));
                {
                   {
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(Dummy_4596,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(Dummy_4597,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(Dummy_4598,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(Dummy_4599,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(Dummy_4600,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(Dummy_4601,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                   }
                }
                const __m256d Dummy_4602 = _mm256_loadu_pd(& _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d Dummy_4603 = _mm256_loadu_pd(& _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d Dummy_4604 = _mm256_loadu_pd(& _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d Dummy_4605 = _mm256_loadu_pd(& _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d Dummy_4606 = _mm256_loadu_pd(& _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d Dummy_4607 = _mm256_loadu_pd(& _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d Dummy_4608 = _mm256_loadu_pd(& _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]);
                const __m256d Dummy_4609 = _mm256_loadu_pd(& _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]);
                const __m256d Dummy_4610 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4603,_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978)),_mm256_mul_pd(Dummy_4604,_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423))),_mm256_mul_pd(Dummy_4605,_mm256_set_pd(0.01482761006242336,0.01482761006242336,0.01482761006242336,0.01482761006242336))),_mm256_mul_pd(Dummy_4602,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2)));
                const __m256d Dummy_4616 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4607,_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978)),_mm256_mul_pd(Dummy_4608,_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423))),_mm256_mul_pd(Dummy_4609,_mm256_set_pd(0.01482761006242336,0.01482761006242336,0.01482761006242336,0.01482761006242336))),_mm256_mul_pd(Dummy_4606,_mm256_set_pd(tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2,tmp_kernel_op_2))),_mm256_set_pd(abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN));
                const __m256d Dummy_4617 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4605,_mm256_set_pd(0.0048399363458717648,0.0048399363458717648,0.0048399363458717648,0.0048399363458717648)),_mm256_mul_pd(Dummy_4603,_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601))),_mm256_mul_pd(Dummy_4604,_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467))),_mm256_mul_pd(Dummy_4602,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12)));
                const __m256d Dummy_4621 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4609,_mm256_set_pd(0.0048399363458717648,0.0048399363458717648,0.0048399363458717648,0.0048399363458717648)),_mm256_mul_pd(Dummy_4607,_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601))),_mm256_mul_pd(Dummy_4608,_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467))),_mm256_mul_pd(Dummy_4606,_mm256_set_pd(tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12,tmp_kernel_op_12))),_mm256_set_pd(abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN));
                const __m256d Dummy_4622 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4603,_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541)),_mm256_mul_pd(Dummy_4604,_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674))),_mm256_mul_pd(Dummy_4605,_mm256_set_pd(0.44773255210137269,0.44773255210137269,0.44773255210137269,0.44773255210137269))),_mm256_mul_pd(Dummy_4602,_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20)));
                const __m256d Dummy_4626 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4607,_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541)),_mm256_mul_pd(Dummy_4608,_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674))),_mm256_mul_pd(Dummy_4609,_mm256_set_pd(0.44773255210137269,0.44773255210137269,0.44773255210137269,0.44773255210137269))),_mm256_mul_pd(Dummy_4606,_mm256_set_pd(tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20,tmp_kernel_op_20))),_mm256_set_pd(abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN));
                const __m256d Dummy_4627 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4605,_mm256_set_pd(0.35284634870858678,0.35284634870858678,0.35284634870858678,0.35284634870858678)),_mm256_mul_pd(Dummy_4604,_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612))),_mm256_mul_pd(Dummy_4603,_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779))),_mm256_mul_pd(Dummy_4602,_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28)));
                const __m256d Dummy_4631 = _mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(Dummy_4609,_mm256_set_pd(0.35284634870858678,0.35284634870858678,0.35284634870858678,0.35284634870858678)),_mm256_mul_pd(Dummy_4608,_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612))),_mm256_mul_pd(Dummy_4607,_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779))),_mm256_mul_pd(Dummy_4606,_mm256_set_pd(tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28,tmp_kernel_op_28))),_mm256_set_pd(abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN,abs_det_jac_affine_GREEN_DOWN));
                const __m256d Dummy_4670 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4616,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4613,Dummy_4613,Dummy_4613,Dummy_4613)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4613,Dummy_4613,Dummy_4613,Dummy_4613)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4614,Dummy_4614,Dummy_4614,Dummy_4614)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4614,Dummy_4614,Dummy_4614,Dummy_4614)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4615,Dummy_4615,Dummy_4615,Dummy_4615)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4615,Dummy_4615,Dummy_4615,Dummy_4615)),_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4621,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4618,Dummy_4618,Dummy_4618,Dummy_4618)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4618,Dummy_4618,Dummy_4618,Dummy_4618)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4619,Dummy_4619,Dummy_4619,Dummy_4619)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4619,Dummy_4619,Dummy_4619,Dummy_4619)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4620,Dummy_4620,Dummy_4620,Dummy_4620)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4620,Dummy_4620,Dummy_4620,Dummy_4620)),_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4626,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4623,Dummy_4623,Dummy_4623,Dummy_4623)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4623,Dummy_4623,Dummy_4623,Dummy_4623)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4624,Dummy_4624,Dummy_4624,Dummy_4624)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4624,Dummy_4624,Dummy_4624,Dummy_4624)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4625,Dummy_4625,Dummy_4625,Dummy_4625)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4625,Dummy_4625,Dummy_4625,Dummy_4625)),_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4631,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4628,Dummy_4628,Dummy_4628,Dummy_4628)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4628,Dummy_4628,Dummy_4628,Dummy_4628)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4629,Dummy_4629,Dummy_4629,Dummy_4629)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4629,Dummy_4629,Dummy_4629,Dummy_4629)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4630,Dummy_4630,Dummy_4630,Dummy_4630)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4630,Dummy_4630,Dummy_4630,Dummy_4630)),_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4610,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4612,Dummy_4612,Dummy_4612,Dummy_4612))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4617,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4612,Dummy_4612,Dummy_4612,Dummy_4612))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4622,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4612,Dummy_4612,Dummy_4612,Dummy_4612))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4627,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4612,Dummy_4612,Dummy_4612,Dummy_4612)));
                const __m256d Dummy_4671 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4616,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4633,Dummy_4633,Dummy_4633,Dummy_4633)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4633,Dummy_4633,Dummy_4633,Dummy_4633)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4634,Dummy_4634,Dummy_4634,Dummy_4634)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4634,Dummy_4634,Dummy_4634,Dummy_4634)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4635,Dummy_4635,Dummy_4635,Dummy_4635)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4635,Dummy_4635,Dummy_4635,Dummy_4635)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4621,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4636,Dummy_4636,Dummy_4636,Dummy_4636)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4636,Dummy_4636,Dummy_4636,Dummy_4636)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4637,Dummy_4637,Dummy_4637,Dummy_4637)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4637,Dummy_4637,Dummy_4637,Dummy_4637)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4638,Dummy_4638,Dummy_4638,Dummy_4638)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4638,Dummy_4638,Dummy_4638,Dummy_4638)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4626,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4639,Dummy_4639,Dummy_4639,Dummy_4639)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4639,Dummy_4639,Dummy_4639,Dummy_4639)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4640,Dummy_4640,Dummy_4640,Dummy_4640)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4640,Dummy_4640,Dummy_4640,Dummy_4640)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4641,Dummy_4641,Dummy_4641,Dummy_4641)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4641,Dummy_4641,Dummy_4641,Dummy_4641)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4631,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4642,Dummy_4642,Dummy_4642,Dummy_4642)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4642,Dummy_4642,Dummy_4642,Dummy_4642)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4643,Dummy_4643,Dummy_4643,Dummy_4643)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4643,Dummy_4643,Dummy_4643,Dummy_4643)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4644,Dummy_4644,Dummy_4644,Dummy_4644)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4644,Dummy_4644,Dummy_4644,Dummy_4644)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4610,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4632,Dummy_4632,Dummy_4632,Dummy_4632))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4617,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4632,Dummy_4632,Dummy_4632,Dummy_4632))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4622,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4632,Dummy_4632,Dummy_4632,Dummy_4632))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4627,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4632,Dummy_4632,Dummy_4632,Dummy_4632)));
                const __m256d Dummy_4672 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4616,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4646,Dummy_4646,Dummy_4646,Dummy_4646)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4646,Dummy_4646,Dummy_4646,Dummy_4646)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4647,Dummy_4647,Dummy_4647,Dummy_4647)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4647,Dummy_4647,Dummy_4647,Dummy_4647)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4648,Dummy_4648,Dummy_4648,Dummy_4648)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4648,Dummy_4648,Dummy_4648,Dummy_4648)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4621,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4649,Dummy_4649,Dummy_4649,Dummy_4649)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4649,Dummy_4649,Dummy_4649,Dummy_4649)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4650,Dummy_4650,Dummy_4650,Dummy_4650)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4650,Dummy_4650,Dummy_4650,Dummy_4650)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4651,Dummy_4651,Dummy_4651,Dummy_4651)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4651,Dummy_4651,Dummy_4651,Dummy_4651)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4626,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4652,Dummy_4652,Dummy_4652,Dummy_4652)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4652,Dummy_4652,Dummy_4652,Dummy_4652)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4653,Dummy_4653,Dummy_4653,Dummy_4653)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4653,Dummy_4653,Dummy_4653,Dummy_4653)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4654,Dummy_4654,Dummy_4654,Dummy_4654)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4654,Dummy_4654,Dummy_4654,Dummy_4654)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4631,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4655,Dummy_4655,Dummy_4655,Dummy_4655)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4655,Dummy_4655,Dummy_4655,Dummy_4655)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4656,Dummy_4656,Dummy_4656,Dummy_4656)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4656,Dummy_4656,Dummy_4656,Dummy_4656)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN))))),_mm256_mul_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4657,Dummy_4657,Dummy_4657,Dummy_4657)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN))),_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(-1.0,-1.0,-1.0,-1.0),_mm256_set_pd(Dummy_4657,Dummy_4657,Dummy_4657,Dummy_4657)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4610,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4645,Dummy_4645,Dummy_4645,Dummy_4645))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4617,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4645,Dummy_4645,Dummy_4645,Dummy_4645))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4622,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4645,Dummy_4645,Dummy_4645,Dummy_4645))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4627,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4645,Dummy_4645,Dummy_4645,Dummy_4645)));
                const __m256d Dummy_4673 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4616,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4613,Dummy_4613,Dummy_4613,Dummy_4613)),_mm256_set_pd(Dummy_4633,Dummy_4633,Dummy_4633,Dummy_4633)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4613,Dummy_4613,Dummy_4613,Dummy_4613)),_mm256_set_pd(Dummy_4633,Dummy_4633,Dummy_4633,Dummy_4633))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4614,Dummy_4614,Dummy_4614,Dummy_4614)),_mm256_set_pd(Dummy_4634,Dummy_4634,Dummy_4634,Dummy_4634)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4614,Dummy_4614,Dummy_4614,Dummy_4614)),_mm256_set_pd(Dummy_4634,Dummy_4634,Dummy_4634,Dummy_4634)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4615,Dummy_4615,Dummy_4615,Dummy_4615)),_mm256_set_pd(Dummy_4635,Dummy_4635,Dummy_4635,Dummy_4635)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67,tmp_kernel_op_67)),_mm256_set_pd(Dummy_4615,Dummy_4615,Dummy_4615,Dummy_4615)),_mm256_set_pd(Dummy_4635,Dummy_4635,Dummy_4635,Dummy_4635))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4621,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4618,Dummy_4618,Dummy_4618,Dummy_4618)),_mm256_set_pd(Dummy_4636,Dummy_4636,Dummy_4636,Dummy_4636)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4618,Dummy_4618,Dummy_4618,Dummy_4618)),_mm256_set_pd(Dummy_4636,Dummy_4636,Dummy_4636,Dummy_4636))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4619,Dummy_4619,Dummy_4619,Dummy_4619)),_mm256_set_pd(Dummy_4637,Dummy_4637,Dummy_4637,Dummy_4637)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4619,Dummy_4619,Dummy_4619,Dummy_4619)),_mm256_set_pd(Dummy_4637,Dummy_4637,Dummy_4637,Dummy_4637)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4620,Dummy_4620,Dummy_4620,Dummy_4620)),_mm256_set_pd(Dummy_4638,Dummy_4638,Dummy_4638,Dummy_4638)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68,tmp_kernel_op_68)),_mm256_set_pd(Dummy_4620,Dummy_4620,Dummy_4620,Dummy_4620)),_mm256_set_pd(Dummy_4638,Dummy_4638,Dummy_4638,Dummy_4638))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4626,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4623,Dummy_4623,Dummy_4623,Dummy_4623)),_mm256_set_pd(Dummy_4639,Dummy_4639,Dummy_4639,Dummy_4639)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4623,Dummy_4623,Dummy_4623,Dummy_4623)),_mm256_set_pd(Dummy_4639,Dummy_4639,Dummy_4639,Dummy_4639))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4624,Dummy_4624,Dummy_4624,Dummy_4624)),_mm256_set_pd(Dummy_4640,Dummy_4640,Dummy_4640,Dummy_4640)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4624,Dummy_4624,Dummy_4624,Dummy_4624)),_mm256_set_pd(Dummy_4640,Dummy_4640,Dummy_4640,Dummy_4640)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4625,Dummy_4625,Dummy_4625,Dummy_4625)),_mm256_set_pd(Dummy_4641,Dummy_4641,Dummy_4641,Dummy_4641)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69,tmp_kernel_op_69)),_mm256_set_pd(Dummy_4625,Dummy_4625,Dummy_4625,Dummy_4625)),_mm256_set_pd(Dummy_4641,Dummy_4641,Dummy_4641,Dummy_4641))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4631,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4628,Dummy_4628,Dummy_4628,Dummy_4628)),_mm256_set_pd(Dummy_4642,Dummy_4642,Dummy_4642,Dummy_4642)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4628,Dummy_4628,Dummy_4628,Dummy_4628)),_mm256_set_pd(Dummy_4642,Dummy_4642,Dummy_4642,Dummy_4642))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4629,Dummy_4629,Dummy_4629,Dummy_4629)),_mm256_set_pd(Dummy_4643,Dummy_4643,Dummy_4643,Dummy_4643)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4629,Dummy_4629,Dummy_4629,Dummy_4629)),_mm256_set_pd(Dummy_4643,Dummy_4643,Dummy_4643,Dummy_4643)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4630,Dummy_4630,Dummy_4630,Dummy_4630)),_mm256_set_pd(Dummy_4644,Dummy_4644,Dummy_4644,Dummy_4644)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70,tmp_kernel_op_70)),_mm256_set_pd(Dummy_4630,Dummy_4630,Dummy_4630,Dummy_4630)),_mm256_set_pd(Dummy_4644,Dummy_4644,Dummy_4644,Dummy_4644))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4610,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4664,Dummy_4664,Dummy_4664,Dummy_4664))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4617,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4664,Dummy_4664,Dummy_4664,Dummy_4664))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4622,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4664,Dummy_4664,Dummy_4664,Dummy_4664))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4627,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4664,Dummy_4664,Dummy_4664,Dummy_4664)));
                const __m256d Dummy_4674 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4616,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4646,Dummy_4646,Dummy_4646,Dummy_4646)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4646,Dummy_4646,Dummy_4646,Dummy_4646))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4647,Dummy_4647,Dummy_4647,Dummy_4647)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4647,Dummy_4647,Dummy_4647,Dummy_4647)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4648,Dummy_4648,Dummy_4648,Dummy_4648)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.039933048641498423,0.039933048641498423,0.039933048641498423,0.039933048641498423),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75,tmp_kernel_op_75))),_mm256_set_pd(Dummy_4648,Dummy_4648,Dummy_4648,Dummy_4648))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4621,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4649,Dummy_4649,Dummy_4649,Dummy_4649)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4649,Dummy_4649,Dummy_4649,Dummy_4649))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4650,Dummy_4650,Dummy_4650,Dummy_4650)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4650,Dummy_4650,Dummy_4650,Dummy_4650)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4651,Dummy_4651,Dummy_4651,Dummy_4651)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.3817653560693467,0.3817653560693467,0.3817653560693467,0.3817653560693467),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76,tmp_kernel_op_76))),_mm256_set_pd(Dummy_4651,Dummy_4651,Dummy_4651,Dummy_4651))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4631,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4655,Dummy_4655,Dummy_4655,Dummy_4655)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4655,Dummy_4655,Dummy_4655,Dummy_4655))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4656,Dummy_4656,Dummy_4656,Dummy_4656)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4656,Dummy_4656,Dummy_4656,Dummy_4656)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4657,Dummy_4657,Dummy_4657,Dummy_4657)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.43070170707783612,0.43070170707783612,0.43070170707783612,0.43070170707783612),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78,tmp_kernel_op_78))),_mm256_set_pd(Dummy_4657,Dummy_4657,Dummy_4657,Dummy_4657))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4626,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4652,Dummy_4652,Dummy_4652,Dummy_4652)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4652,Dummy_4652,Dummy_4652,Dummy_4652))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4653,Dummy_4653,Dummy_4653,Dummy_4653)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4653,Dummy_4653,Dummy_4653,Dummy_4653)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4654,Dummy_4654,Dummy_4654,Dummy_4654)),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.0069232355736274674,0.0069232355736274674,0.0069232355736274674,0.0069232355736274674),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77,tmp_kernel_op_77))),_mm256_set_pd(Dummy_4654,Dummy_4654,Dummy_4654,Dummy_4654))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4610,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4668,Dummy_4668,Dummy_4668,Dummy_4668))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4617,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4668,Dummy_4668,Dummy_4668,Dummy_4668))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4622,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4668,Dummy_4668,Dummy_4668,Dummy_4668))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4627,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4668,Dummy_4668,Dummy_4668,Dummy_4668)));
                const __m256d Dummy_4675 = _mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_mul_pd(Dummy_4616,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.82157254096761978,0.82157254096761978,0.82157254096761978,0.82157254096761978),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80,tmp_kernel_op_80)))))),_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_mul_pd(_mm256_mul_pd(Dummy_4621,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.15593312049918601,0.15593312049918601,0.15593312049918601,0.15593312049918601),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81,tmp_kernel_op_81)))))),_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4626,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.18002969351036541,0.18002969351036541,0.18002969351036541,0.18002969351036541),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82,tmp_kernel_op_82)))))),_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4631,_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN,jac_affine_inv_1_0_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN,jac_affine_inv_2_0_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN,jac_affine_inv_0_0_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83)))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN,jac_affine_inv_1_1_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN,jac_affine_inv_2_1_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN,jac_affine_inv_0_1_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))))),_mm256_mul_pd(_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83))),_mm256_add_pd(_mm256_add_pd(_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN,jac_affine_inv_1_2_GREEN_DOWN)),_mm256_mul_pd(_mm256_set_pd(0.21607642918484779,0.21607642918484779,0.21607642918484779,0.21607642918484779),_mm256_set_pd(jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN,jac_affine_inv_2_2_GREEN_DOWN))),_mm256_mul_pd(_mm256_set_pd(jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN,jac_affine_inv_0_2_GREEN_DOWN),_mm256_set_pd(tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83,tmp_kernel_op_83)))))),_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4610,_mm256_set_pd(0.016934591412496779,0.016934591412496779,0.016934591412496779,0.016934591412496779)),_mm256_set_pd(Dummy_4669,Dummy_4669,Dummy_4669,Dummy_4669))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4617,_mm256_set_pd(0.046462929447761363,0.046462929447761363,0.046462929447761363,0.046462929447761363)),_mm256_set_pd(Dummy_4669,Dummy_4669,Dummy_4669,Dummy_4669))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4622,_mm256_set_pd(0.05008682322282932,0.05008682322282932,0.05008682322282932,0.05008682322282932)),_mm256_set_pd(Dummy_4669,Dummy_4669,Dummy_4669,Dummy_4669))),_mm256_mul_pd(_mm256_mul_pd(Dummy_4627,_mm256_set_pd(0.053182322583579168,0.053182322583579168,0.053182322583579168,0.053182322583579168)),_mm256_set_pd(Dummy_4669,Dummy_4669,Dummy_4669,Dummy_4669)));
                {
                   {
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(Dummy_4670,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(Dummy_4671,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1],_mm256_add_pd(Dummy_4672,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(Dummy_4673,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))],_mm256_add_pd(Dummy_4674,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))])));
                      _mm256_storeu_pd(&_data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))],_mm256_add_pd(Dummy_4675,_mm256_loadu_pd(& _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))])));
                   }
                }
             }
             for (int64_t ctr_0 = (int64_t)((-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2) / (4)) * (4); ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
             {
                const walberla::float64 alpha_dof_0 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 alpha_dof_1 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 alpha_dof_2 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 alpha_dof_3 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 beta_dof_0 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 beta_dof_1 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 beta_dof_2 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 beta_dof_3 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 tmp_kernel_op_3 = alpha_dof_0*tmp_kernel_op_2 + alpha_dof_1*0.82157254096761978 + alpha_dof_2*0.039933048641498423 + alpha_dof_3*0.01482761006242336;
                const walberla::float64 tmp_kernel_op_9 = abs_det_jac_affine_WHITE_UP*(beta_dof_0*tmp_kernel_op_2 + beta_dof_1*0.82157254096761978 + beta_dof_2*0.039933048641498423 + beta_dof_3*0.01482761006242336);
                const walberla::float64 tmp_kernel_op_13 = alpha_dof_0*tmp_kernel_op_12 + alpha_dof_1*0.15593312049918601 + alpha_dof_2*0.3817653560693467 + alpha_dof_3*0.0048399363458717648;
                const walberla::float64 tmp_kernel_op_17 = abs_det_jac_affine_WHITE_UP*(beta_dof_0*tmp_kernel_op_12 + beta_dof_1*0.15593312049918601 + beta_dof_2*0.3817653560693467 + beta_dof_3*0.0048399363458717648);
                const walberla::float64 tmp_kernel_op_21 = alpha_dof_0*tmp_kernel_op_20 + alpha_dof_1*0.18002969351036541 + alpha_dof_2*0.0069232355736274674 + alpha_dof_3*0.44773255210137269;
                const walberla::float64 tmp_kernel_op_25 = abs_det_jac_affine_WHITE_UP*(beta_dof_0*tmp_kernel_op_20 + beta_dof_1*0.18002969351036541 + beta_dof_2*0.0069232355736274674 + beta_dof_3*0.44773255210137269);
                const walberla::float64 tmp_kernel_op_29 = alpha_dof_0*tmp_kernel_op_28 + alpha_dof_1*0.21607642918484779 + alpha_dof_2*0.43070170707783612 + alpha_dof_3*0.35284634870858678;
                const walberla::float64 tmp_kernel_op_33 = abs_det_jac_affine_WHITE_UP*(beta_dof_0*tmp_kernel_op_28 + beta_dof_1*0.21607642918484779 + beta_dof_2*0.43070170707783612 + beta_dof_3*0.35284634870858678);
                const walberla::float64 elMatDiag_0 = tmp_kernel_op_13*tmp_kernel_op_5*0.046462929447761363 + tmp_kernel_op_17*(((jac_affine_inv_2_0_WHITE_UP*0.3817653560693467 - tmp_kernel_op_14)*(jac_affine_inv_2_0_WHITE_UP*0.3817653560693467 - tmp_kernel_op_14)) + ((jac_affine_inv_2_1_WHITE_UP*0.3817653560693467 - tmp_kernel_op_15)*(jac_affine_inv_2_1_WHITE_UP*0.3817653560693467 - tmp_kernel_op_15)) + ((jac_affine_inv_2_2_WHITE_UP*0.3817653560693467 - tmp_kernel_op_16)*(jac_affine_inv_2_2_WHITE_UP*0.3817653560693467 - tmp_kernel_op_16)))*0.046462929447761363 + tmp_kernel_op_21*tmp_kernel_op_5*0.05008682322282932 + tmp_kernel_op_25*(((jac_affine_inv_2_0_WHITE_UP*0.0069232355736274674 - tmp_kernel_op_22)*(jac_affine_inv_2_0_WHITE_UP*0.0069232355736274674 - tmp_kernel_op_22)) + ((jac_affine_inv_2_1_WHITE_UP*0.0069232355736274674 - tmp_kernel_op_23)*(jac_affine_inv_2_1_WHITE_UP*0.0069232355736274674 - tmp_kernel_op_23)) + ((jac_affine_inv_2_2_WHITE_UP*0.0069232355736274674 - tmp_kernel_op_24)*(jac_affine_inv_2_2_WHITE_UP*0.0069232355736274674 - tmp_kernel_op_24)))*0.05008682322282932 + tmp_kernel_op_29*tmp_kernel_op_5*0.053182322583579168 + tmp_kernel_op_3*tmp_kernel_op_5*0.016934591412496779 + tmp_kernel_op_33*(((jac_affine_inv_2_0_WHITE_UP*0.43070170707783612 - tmp_kernel_op_30)*(jac_affine_inv_2_0_WHITE_UP*0.43070170707783612 - tmp_kernel_op_30)) + ((jac_affine_inv_2_1_WHITE_UP*0.43070170707783612 - tmp_kernel_op_31)*(jac_affine_inv_2_1_WHITE_UP*0.43070170707783612 - tmp_kernel_op_31)) + ((jac_affine_inv_2_2_WHITE_UP*0.43070170707783612 - tmp_kernel_op_32)*(jac_affine_inv_2_2_WHITE_UP*0.43070170707783612 - tmp_kernel_op_32)))*0.053182322583579168 + tmp_kernel_op_9*(((jac_affine_inv_2_0_WHITE_UP*0.039933048641498423 - tmp_kernel_op_6)*(jac_affine_inv_2_0_WHITE_UP*0.039933048641498423 - tmp_kernel_op_6)) + ((jac_affine_inv_2_1_WHITE_UP*0.039933048641498423 - tmp_kernel_op_7)*(jac_affine_inv_2_1_WHITE_UP*0.039933048641498423 - tmp_kernel_op_7)) + ((jac_affine_inv_2_2_WHITE_UP*0.039933048641498423 - tmp_kernel_op_8)*(jac_affine_inv_2_2_WHITE_UP*0.039933048641498423 - tmp_kernel_op_8)))*0.016934591412496779;
                const walberla::float64 elMatDiag_1 = tmp_kernel_op_13*tmp_kernel_op_34*0.046462929447761363 + tmp_kernel_op_17*(((jac_affine_inv_2_0_WHITE_UP*0.15593312049918601 - tmp_kernel_op_38)*(jac_affine_inv_2_0_WHITE_UP*0.15593312049918601 - tmp_kernel_op_38)) + ((jac_affine_inv_2_1_WHITE_UP*0.15593312049918601 - tmp_kernel_op_39)*(jac_affine_inv_2_1_WHITE_UP*0.15593312049918601 - tmp_kernel_op_39)) + ((jac_affine_inv_2_2_WHITE_UP*0.15593312049918601 - tmp_kernel_op_40)*(jac_affine_inv_2_2_WHITE_UP*0.15593312049918601 - tmp_kernel_op_40)))*0.046462929447761363 + tmp_kernel_op_21*tmp_kernel_op_34*0.05008682322282932 + tmp_kernel_op_25*(((jac_affine_inv_2_0_WHITE_UP*0.18002969351036541 - tmp_kernel_op_41)*(jac_affine_inv_2_0_WHITE_UP*0.18002969351036541 - tmp_kernel_op_41)) + ((jac_affine_inv_2_1_WHITE_UP*0.18002969351036541 - tmp_kernel_op_42)*(jac_affine_inv_2_1_WHITE_UP*0.18002969351036541 - tmp_kernel_op_42)) + ((jac_affine_inv_2_2_WHITE_UP*0.18002969351036541 - tmp_kernel_op_43)*(jac_affine_inv_2_2_WHITE_UP*0.18002969351036541 - tmp_kernel_op_43)))*0.05008682322282932 + tmp_kernel_op_29*tmp_kernel_op_34*0.053182322583579168 + tmp_kernel_op_3*tmp_kernel_op_34*0.016934591412496779 + tmp_kernel_op_33*(((jac_affine_inv_2_0_WHITE_UP*0.21607642918484779 - tmp_kernel_op_44)*(jac_affine_inv_2_0_WHITE_UP*0.21607642918484779 - tmp_kernel_op_44)) + ((jac_affine_inv_2_1_WHITE_UP*0.21607642918484779 - tmp_kernel_op_45)*(jac_affine_inv_2_1_WHITE_UP*0.21607642918484779 - tmp_kernel_op_45)) + ((jac_affine_inv_2_2_WHITE_UP*0.21607642918484779 - tmp_kernel_op_46)*(jac_affine_inv_2_2_WHITE_UP*0.21607642918484779 - tmp_kernel_op_46)))*0.053182322583579168 + tmp_kernel_op_9*(((jac_affine_inv_2_0_WHITE_UP*0.82157254096761978 - tmp_kernel_op_35)*(jac_affine_inv_2_0_WHITE_UP*0.82157254096761978 - tmp_kernel_op_35)) + ((jac_affine_inv_2_1_WHITE_UP*0.82157254096761978 - tmp_kernel_op_36)*(jac_affine_inv_2_1_WHITE_UP*0.82157254096761978 - tmp_kernel_op_36)) + ((jac_affine_inv_2_2_WHITE_UP*0.82157254096761978 - tmp_kernel_op_37)*(jac_affine_inv_2_2_WHITE_UP*0.82157254096761978 - tmp_kernel_op_37)))*0.016934591412496779;
                const walberla::float64 elMatDiag_2 = tmp_kernel_op_13*tmp_kernel_op_47*0.046462929447761363 + tmp_kernel_op_17*(((jac_affine_inv_1_0_WHITE_UP*0.15593312049918601 - tmp_kernel_op_51)*(jac_affine_inv_1_0_WHITE_UP*0.15593312049918601 - tmp_kernel_op_51)) + ((jac_affine_inv_1_1_WHITE_UP*0.15593312049918601 - tmp_kernel_op_52)*(jac_affine_inv_1_1_WHITE_UP*0.15593312049918601 - tmp_kernel_op_52)) + ((jac_affine_inv_1_2_WHITE_UP*0.15593312049918601 - tmp_kernel_op_53)*(jac_affine_inv_1_2_WHITE_UP*0.15593312049918601 - tmp_kernel_op_53)))*0.046462929447761363 + tmp_kernel_op_21*tmp_kernel_op_47*0.05008682322282932 + tmp_kernel_op_25*(((jac_affine_inv_1_0_WHITE_UP*0.18002969351036541 - tmp_kernel_op_54)*(jac_affine_inv_1_0_WHITE_UP*0.18002969351036541 - tmp_kernel_op_54)) + ((jac_affine_inv_1_1_WHITE_UP*0.18002969351036541 - tmp_kernel_op_55)*(jac_affine_inv_1_1_WHITE_UP*0.18002969351036541 - tmp_kernel_op_55)) + ((jac_affine_inv_1_2_WHITE_UP*0.18002969351036541 - tmp_kernel_op_56)*(jac_affine_inv_1_2_WHITE_UP*0.18002969351036541 - tmp_kernel_op_56)))*0.05008682322282932 + tmp_kernel_op_29*tmp_kernel_op_47*0.053182322583579168 + tmp_kernel_op_3*tmp_kernel_op_47*0.016934591412496779 + tmp_kernel_op_33*(((jac_affine_inv_1_0_WHITE_UP*0.21607642918484779 - tmp_kernel_op_57)*(jac_affine_inv_1_0_WHITE_UP*0.21607642918484779 - tmp_kernel_op_57)) + ((jac_affine_inv_1_1_WHITE_UP*0.21607642918484779 - tmp_kernel_op_58)*(jac_affine_inv_1_1_WHITE_UP*0.21607642918484779 - tmp_kernel_op_58)) + ((jac_affine_inv_1_2_WHITE_UP*0.21607642918484779 - tmp_kernel_op_59)*(jac_affine_inv_1_2_WHITE_UP*0.21607642918484779 - tmp_kernel_op_59)))*0.053182322583579168 + tmp_kernel_op_9*(((jac_affine_inv_1_0_WHITE_UP*0.82157254096761978 - tmp_kernel_op_48)*(jac_affine_inv_1_0_WHITE_UP*0.82157254096761978 - tmp_kernel_op_48)) + ((jac_affine_inv_1_1_WHITE_UP*0.82157254096761978 - tmp_kernel_op_49)*(jac_affine_inv_1_1_WHITE_UP*0.82157254096761978 - tmp_kernel_op_49)) + ((jac_affine_inv_1_2_WHITE_UP*0.82157254096761978 - tmp_kernel_op_50)*(jac_affine_inv_1_2_WHITE_UP*0.82157254096761978 - tmp_kernel_op_50)))*0.016934591412496779;
                const walberla::float64 elMatDiag_3 = tmp_kernel_op_13*tmp_kernel_op_66*0.046462929447761363 + tmp_kernel_op_17*(((jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_68 + tmp_kernel_op_14 + tmp_kernel_op_38)*(jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_68 + tmp_kernel_op_14 + tmp_kernel_op_38)) + ((jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_68 + tmp_kernel_op_15 + tmp_kernel_op_39)*(jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_68 + tmp_kernel_op_15 + tmp_kernel_op_39)) + ((jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_68 + tmp_kernel_op_16 + tmp_kernel_op_40)*(jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_68 + tmp_kernel_op_16 + tmp_kernel_op_40)))*0.046462929447761363 + tmp_kernel_op_21*tmp_kernel_op_66*0.05008682322282932 + tmp_kernel_op_25*(((jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_69 + tmp_kernel_op_22 + tmp_kernel_op_41)*(jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_69 + tmp_kernel_op_22 + tmp_kernel_op_41)) + ((jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_69 + tmp_kernel_op_23 + tmp_kernel_op_42)*(jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_69 + tmp_kernel_op_23 + tmp_kernel_op_42)) + ((jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_69 + tmp_kernel_op_24 + tmp_kernel_op_43)*(jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_69 + tmp_kernel_op_24 + tmp_kernel_op_43)))*0.05008682322282932 + tmp_kernel_op_29*tmp_kernel_op_66*0.053182322583579168 + tmp_kernel_op_3*tmp_kernel_op_66*0.016934591412496779 + tmp_kernel_op_33*(((jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_70 + tmp_kernel_op_30 + tmp_kernel_op_44)*(jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_70 + tmp_kernel_op_30 + tmp_kernel_op_44)) + ((jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_70 + tmp_kernel_op_31 + tmp_kernel_op_45)*(jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_70 + tmp_kernel_op_31 + tmp_kernel_op_45)) + ((jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_70 + tmp_kernel_op_32 + tmp_kernel_op_46)*(jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_70 + tmp_kernel_op_32 + tmp_kernel_op_46)))*0.053182322583579168 + tmp_kernel_op_9*(((jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_67 + tmp_kernel_op_35 + tmp_kernel_op_6)*(jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_67 + tmp_kernel_op_35 + tmp_kernel_op_6)) + ((jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_67 + tmp_kernel_op_36 + tmp_kernel_op_7)*(jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_67 + tmp_kernel_op_36 + tmp_kernel_op_7)) + ((jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_67 + tmp_kernel_op_37 + tmp_kernel_op_8)*(jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_67 + tmp_kernel_op_37 + tmp_kernel_op_8)))*0.016934591412496779;
                const walberla::float64 elMatDiag_4 = tmp_kernel_op_13*tmp_kernel_op_74*0.046462929447761363 + tmp_kernel_op_17*(((jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_76 + jac_affine_inv_2_0_WHITE_UP*0.3817653560693467 + tmp_kernel_op_51)*(jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_76 + jac_affine_inv_2_0_WHITE_UP*0.3817653560693467 + tmp_kernel_op_51)) + ((jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_76 + jac_affine_inv_2_1_WHITE_UP*0.3817653560693467 + tmp_kernel_op_52)*(jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_76 + jac_affine_inv_2_1_WHITE_UP*0.3817653560693467 + tmp_kernel_op_52)) + ((jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_76 + jac_affine_inv_2_2_WHITE_UP*0.3817653560693467 + tmp_kernel_op_53)*(jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_76 + jac_affine_inv_2_2_WHITE_UP*0.3817653560693467 + tmp_kernel_op_53)))*0.046462929447761363 + tmp_kernel_op_21*tmp_kernel_op_74*0.05008682322282932 + tmp_kernel_op_25*(((jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_77 + jac_affine_inv_2_0_WHITE_UP*0.0069232355736274674 + tmp_kernel_op_54)*(jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_77 + jac_affine_inv_2_0_WHITE_UP*0.0069232355736274674 + tmp_kernel_op_54)) + ((jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_77 + jac_affine_inv_2_1_WHITE_UP*0.0069232355736274674 + tmp_kernel_op_55)*(jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_77 + jac_affine_inv_2_1_WHITE_UP*0.0069232355736274674 + tmp_kernel_op_55)) + ((jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_77 + jac_affine_inv_2_2_WHITE_UP*0.0069232355736274674 + tmp_kernel_op_56)*(jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_77 + jac_affine_inv_2_2_WHITE_UP*0.0069232355736274674 + tmp_kernel_op_56)))*0.05008682322282932 + tmp_kernel_op_29*tmp_kernel_op_74*0.053182322583579168 + tmp_kernel_op_3*tmp_kernel_op_74*0.016934591412496779 + tmp_kernel_op_33*(((jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_78 + jac_affine_inv_2_0_WHITE_UP*0.43070170707783612 + tmp_kernel_op_57)*(jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_78 + jac_affine_inv_2_0_WHITE_UP*0.43070170707783612 + tmp_kernel_op_57)) + ((jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_78 + jac_affine_inv_2_1_WHITE_UP*0.43070170707783612 + tmp_kernel_op_58)*(jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_78 + jac_affine_inv_2_1_WHITE_UP*0.43070170707783612 + tmp_kernel_op_58)) + ((jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_78 + jac_affine_inv_2_2_WHITE_UP*0.43070170707783612 + tmp_kernel_op_59)*(jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_78 + jac_affine_inv_2_2_WHITE_UP*0.43070170707783612 + tmp_kernel_op_59)))*0.053182322583579168 + tmp_kernel_op_9*(((jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_75 + jac_affine_inv_2_0_WHITE_UP*0.039933048641498423 + tmp_kernel_op_48)*(jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_75 + jac_affine_inv_2_0_WHITE_UP*0.039933048641498423 + tmp_kernel_op_48)) + ((jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_75 + jac_affine_inv_2_1_WHITE_UP*0.039933048641498423 + tmp_kernel_op_49)*(jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_75 + jac_affine_inv_2_1_WHITE_UP*0.039933048641498423 + tmp_kernel_op_49)) + ((jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_75 + jac_affine_inv_2_2_WHITE_UP*0.039933048641498423 + tmp_kernel_op_50)*(jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_75 + jac_affine_inv_2_2_WHITE_UP*0.039933048641498423 + tmp_kernel_op_50)))*0.016934591412496779;
                const walberla::float64 elMatDiag_5 = tmp_kernel_op_13*tmp_kernel_op_79*0.046462929447761363 + tmp_kernel_op_17*(((jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_81 + jac_affine_inv_1_0_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_0_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_81 + jac_affine_inv_1_0_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_0_WHITE_UP*0.15593312049918601)) + ((jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_81 + jac_affine_inv_1_1_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_1_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_81 + jac_affine_inv_1_1_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_1_WHITE_UP*0.15593312049918601)) + ((jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_81 + jac_affine_inv_1_2_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_2_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_81 + jac_affine_inv_1_2_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_2_WHITE_UP*0.15593312049918601)))*0.046462929447761363 + tmp_kernel_op_21*tmp_kernel_op_79*0.05008682322282932 + tmp_kernel_op_25*(((jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_82 + jac_affine_inv_1_0_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_0_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_82 + jac_affine_inv_1_0_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_0_WHITE_UP*0.18002969351036541)) + ((jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_82 + jac_affine_inv_1_1_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_1_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_82 + jac_affine_inv_1_1_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_1_WHITE_UP*0.18002969351036541)) + ((jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_82 + jac_affine_inv_1_2_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_2_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_82 + jac_affine_inv_1_2_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_2_WHITE_UP*0.18002969351036541)))*0.05008682322282932 + tmp_kernel_op_29*tmp_kernel_op_79*0.053182322583579168 + tmp_kernel_op_3*tmp_kernel_op_79*0.016934591412496779 + tmp_kernel_op_33*(((jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_83 + jac_affine_inv_1_0_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_0_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_83 + jac_affine_inv_1_0_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_0_WHITE_UP*0.21607642918484779)) + ((jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_83 + jac_affine_inv_1_1_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_1_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_83 + jac_affine_inv_1_1_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_1_WHITE_UP*0.21607642918484779)) + ((jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_83 + jac_affine_inv_1_2_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_2_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_83 + jac_affine_inv_1_2_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_2_WHITE_UP*0.21607642918484779)))*0.053182322583579168 + tmp_kernel_op_9*(((jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_80 + jac_affine_inv_1_0_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_0_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_80 + jac_affine_inv_1_0_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_0_WHITE_UP*0.82157254096761978)) + ((jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_80 + jac_affine_inv_1_1_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_1_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_80 + jac_affine_inv_1_1_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_1_WHITE_UP*0.82157254096761978)) + ((jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_80 + jac_affine_inv_1_2_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_2_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_80 + jac_affine_inv_1_2_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_2_WHITE_UP*0.82157254096761978)))*0.016934591412496779;
                {
                   {
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_0 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_1 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_2 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_3 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_4 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = elMatDiag_5 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   }
                }
                const walberla::float64 Dummy_4306 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 Dummy_4307 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 Dummy_4308 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 Dummy_4309 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 Dummy_4310 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 Dummy_4311 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 Dummy_4312 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 Dummy_4313 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 Dummy_4314 = Dummy_4306*tmp_kernel_op_2 + Dummy_4307*0.82157254096761978 + Dummy_4308*0.039933048641498423 + Dummy_4309*0.01482761006242336;
                const walberla::float64 Dummy_4320 = abs_det_jac_affine_WHITE_DOWN*(Dummy_4310*tmp_kernel_op_2 + Dummy_4311*0.82157254096761978 + Dummy_4312*0.039933048641498423 + Dummy_4313*0.01482761006242336);
                const walberla::float64 Dummy_4321 = Dummy_4306*tmp_kernel_op_12 + Dummy_4307*0.15593312049918601 + Dummy_4308*0.3817653560693467 + Dummy_4309*0.0048399363458717648;
                const walberla::float64 Dummy_4325 = abs_det_jac_affine_WHITE_DOWN*(Dummy_4310*tmp_kernel_op_12 + Dummy_4311*0.15593312049918601 + Dummy_4312*0.3817653560693467 + Dummy_4313*0.0048399363458717648);
                const walberla::float64 Dummy_4326 = Dummy_4306*tmp_kernel_op_20 + Dummy_4307*0.18002969351036541 + Dummy_4308*0.0069232355736274674 + Dummy_4309*0.44773255210137269;
                const walberla::float64 Dummy_4330 = abs_det_jac_affine_WHITE_DOWN*(Dummy_4310*tmp_kernel_op_20 + Dummy_4311*0.18002969351036541 + Dummy_4312*0.0069232355736274674 + Dummy_4313*0.44773255210137269);
                const walberla::float64 Dummy_4331 = Dummy_4306*tmp_kernel_op_28 + Dummy_4307*0.21607642918484779 + Dummy_4308*0.43070170707783612 + Dummy_4309*0.35284634870858678;
                const walberla::float64 Dummy_4335 = abs_det_jac_affine_WHITE_DOWN*(Dummy_4310*tmp_kernel_op_28 + Dummy_4311*0.21607642918484779 + Dummy_4312*0.43070170707783612 + Dummy_4313*0.35284634870858678);
                const walberla::float64 Dummy_4374 = Dummy_4314*Dummy_4316*0.016934591412496779 + Dummy_4316*Dummy_4321*0.046462929447761363 + Dummy_4316*Dummy_4326*0.05008682322282932 + Dummy_4316*Dummy_4331*0.053182322583579168 + Dummy_4320*(((-Dummy_4317 + jac_affine_inv_2_0_WHITE_DOWN*0.039933048641498423)*(-Dummy_4317 + jac_affine_inv_2_0_WHITE_DOWN*0.039933048641498423)) + ((-Dummy_4318 + jac_affine_inv_2_1_WHITE_DOWN*0.039933048641498423)*(-Dummy_4318 + jac_affine_inv_2_1_WHITE_DOWN*0.039933048641498423)) + ((-Dummy_4319 + jac_affine_inv_2_2_WHITE_DOWN*0.039933048641498423)*(-Dummy_4319 + jac_affine_inv_2_2_WHITE_DOWN*0.039933048641498423)))*0.016934591412496779 + Dummy_4325*(((-Dummy_4322 + jac_affine_inv_2_0_WHITE_DOWN*0.3817653560693467)*(-Dummy_4322 + jac_affine_inv_2_0_WHITE_DOWN*0.3817653560693467)) + ((-Dummy_4323 + jac_affine_inv_2_1_WHITE_DOWN*0.3817653560693467)*(-Dummy_4323 + jac_affine_inv_2_1_WHITE_DOWN*0.3817653560693467)) + ((-Dummy_4324 + jac_affine_inv_2_2_WHITE_DOWN*0.3817653560693467)*(-Dummy_4324 + jac_affine_inv_2_2_WHITE_DOWN*0.3817653560693467)))*0.046462929447761363 + Dummy_4330*(((-Dummy_4327 + jac_affine_inv_2_0_WHITE_DOWN*0.0069232355736274674)*(-Dummy_4327 + jac_affine_inv_2_0_WHITE_DOWN*0.0069232355736274674)) + ((-Dummy_4328 + jac_affine_inv_2_1_WHITE_DOWN*0.0069232355736274674)*(-Dummy_4328 + jac_affine_inv_2_1_WHITE_DOWN*0.0069232355736274674)) + ((-Dummy_4329 + jac_affine_inv_2_2_WHITE_DOWN*0.0069232355736274674)*(-Dummy_4329 + jac_affine_inv_2_2_WHITE_DOWN*0.0069232355736274674)))*0.05008682322282932 + Dummy_4335*(((-Dummy_4332 + jac_affine_inv_2_0_WHITE_DOWN*0.43070170707783612)*(-Dummy_4332 + jac_affine_inv_2_0_WHITE_DOWN*0.43070170707783612)) + ((-Dummy_4333 + jac_affine_inv_2_1_WHITE_DOWN*0.43070170707783612)*(-Dummy_4333 + jac_affine_inv_2_1_WHITE_DOWN*0.43070170707783612)) + ((-Dummy_4334 + jac_affine_inv_2_2_WHITE_DOWN*0.43070170707783612)*(-Dummy_4334 + jac_affine_inv_2_2_WHITE_DOWN*0.43070170707783612)))*0.053182322583579168;
                const walberla::float64 Dummy_4375 = Dummy_4314*Dummy_4336*0.016934591412496779 + Dummy_4320*(((-Dummy_4337 + jac_affine_inv_2_0_WHITE_DOWN*0.82157254096761978)*(-Dummy_4337 + jac_affine_inv_2_0_WHITE_DOWN*0.82157254096761978)) + ((-Dummy_4338 + jac_affine_inv_2_1_WHITE_DOWN*0.82157254096761978)*(-Dummy_4338 + jac_affine_inv_2_1_WHITE_DOWN*0.82157254096761978)) + ((-Dummy_4339 + jac_affine_inv_2_2_WHITE_DOWN*0.82157254096761978)*(-Dummy_4339 + jac_affine_inv_2_2_WHITE_DOWN*0.82157254096761978)))*0.016934591412496779 + Dummy_4321*Dummy_4336*0.046462929447761363 + Dummy_4325*(((-Dummy_4340 + jac_affine_inv_2_0_WHITE_DOWN*0.15593312049918601)*(-Dummy_4340 + jac_affine_inv_2_0_WHITE_DOWN*0.15593312049918601)) + ((-Dummy_4341 + jac_affine_inv_2_1_WHITE_DOWN*0.15593312049918601)*(-Dummy_4341 + jac_affine_inv_2_1_WHITE_DOWN*0.15593312049918601)) + ((-Dummy_4342 + jac_affine_inv_2_2_WHITE_DOWN*0.15593312049918601)*(-Dummy_4342 + jac_affine_inv_2_2_WHITE_DOWN*0.15593312049918601)))*0.046462929447761363 + Dummy_4326*Dummy_4336*0.05008682322282932 + Dummy_4330*(((-Dummy_4343 + jac_affine_inv_2_0_WHITE_DOWN*0.18002969351036541)*(-Dummy_4343 + jac_affine_inv_2_0_WHITE_DOWN*0.18002969351036541)) + ((-Dummy_4344 + jac_affine_inv_2_1_WHITE_DOWN*0.18002969351036541)*(-Dummy_4344 + jac_affine_inv_2_1_WHITE_DOWN*0.18002969351036541)) + ((-Dummy_4345 + jac_affine_inv_2_2_WHITE_DOWN*0.18002969351036541)*(-Dummy_4345 + jac_affine_inv_2_2_WHITE_DOWN*0.18002969351036541)))*0.05008682322282932 + Dummy_4331*Dummy_4336*0.053182322583579168 + Dummy_4335*(((-Dummy_4346 + jac_affine_inv_2_0_WHITE_DOWN*0.21607642918484779)*(-Dummy_4346 + jac_affine_inv_2_0_WHITE_DOWN*0.21607642918484779)) + ((-Dummy_4347 + jac_affine_inv_2_1_WHITE_DOWN*0.21607642918484779)*(-Dummy_4347 + jac_affine_inv_2_1_WHITE_DOWN*0.21607642918484779)) + ((-Dummy_4348 + jac_affine_inv_2_2_WHITE_DOWN*0.21607642918484779)*(-Dummy_4348 + jac_affine_inv_2_2_WHITE_DOWN*0.21607642918484779)))*0.053182322583579168;
                const walberla::float64 Dummy_4376 = Dummy_4314*Dummy_4349*0.016934591412496779 + Dummy_4320*(((-Dummy_4350 + jac_affine_inv_1_0_WHITE_DOWN*0.82157254096761978)*(-Dummy_4350 + jac_affine_inv_1_0_WHITE_DOWN*0.82157254096761978)) + ((-Dummy_4351 + jac_affine_inv_1_1_WHITE_DOWN*0.82157254096761978)*(-Dummy_4351 + jac_affine_inv_1_1_WHITE_DOWN*0.82157254096761978)) + ((-Dummy_4352 + jac_affine_inv_1_2_WHITE_DOWN*0.82157254096761978)*(-Dummy_4352 + jac_affine_inv_1_2_WHITE_DOWN*0.82157254096761978)))*0.016934591412496779 + Dummy_4321*Dummy_4349*0.046462929447761363 + Dummy_4325*(((-Dummy_4353 + jac_affine_inv_1_0_WHITE_DOWN*0.15593312049918601)*(-Dummy_4353 + jac_affine_inv_1_0_WHITE_DOWN*0.15593312049918601)) + ((-Dummy_4354 + jac_affine_inv_1_1_WHITE_DOWN*0.15593312049918601)*(-Dummy_4354 + jac_affine_inv_1_1_WHITE_DOWN*0.15593312049918601)) + ((-Dummy_4355 + jac_affine_inv_1_2_WHITE_DOWN*0.15593312049918601)*(-Dummy_4355 + jac_affine_inv_1_2_WHITE_DOWN*0.15593312049918601)))*0.046462929447761363 + Dummy_4326*Dummy_4349*0.05008682322282932 + Dummy_4330*(((-Dummy_4356 + jac_affine_inv_1_0_WHITE_DOWN*0.18002969351036541)*(-Dummy_4356 + jac_affine_inv_1_0_WHITE_DOWN*0.18002969351036541)) + ((-Dummy_4357 + jac_affine_inv_1_1_WHITE_DOWN*0.18002969351036541)*(-Dummy_4357 + jac_affine_inv_1_1_WHITE_DOWN*0.18002969351036541)) + ((-Dummy_4358 + jac_affine_inv_1_2_WHITE_DOWN*0.18002969351036541)*(-Dummy_4358 + jac_affine_inv_1_2_WHITE_DOWN*0.18002969351036541)))*0.05008682322282932 + Dummy_4331*Dummy_4349*0.053182322583579168 + Dummy_4335*(((-Dummy_4359 + jac_affine_inv_1_0_WHITE_DOWN*0.21607642918484779)*(-Dummy_4359 + jac_affine_inv_1_0_WHITE_DOWN*0.21607642918484779)) + ((-Dummy_4360 + jac_affine_inv_1_1_WHITE_DOWN*0.21607642918484779)*(-Dummy_4360 + jac_affine_inv_1_1_WHITE_DOWN*0.21607642918484779)) + ((-Dummy_4361 + jac_affine_inv_1_2_WHITE_DOWN*0.21607642918484779)*(-Dummy_4361 + jac_affine_inv_1_2_WHITE_DOWN*0.21607642918484779)))*0.053182322583579168;
                const walberla::float64 Dummy_4377 = Dummy_4314*Dummy_4368*0.016934591412496779 + Dummy_4320*(((Dummy_4317 + Dummy_4337 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_67)*(Dummy_4317 + Dummy_4337 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_67)) + ((Dummy_4318 + Dummy_4338 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_67)*(Dummy_4318 + Dummy_4338 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_67)) + ((Dummy_4319 + Dummy_4339 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_67)*(Dummy_4319 + Dummy_4339 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_67)))*0.016934591412496779 + Dummy_4321*Dummy_4368*0.046462929447761363 + Dummy_4325*(((Dummy_4322 + Dummy_4340 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_68)*(Dummy_4322 + Dummy_4340 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_68)) + ((Dummy_4323 + Dummy_4341 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_68)*(Dummy_4323 + Dummy_4341 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_68)) + ((Dummy_4324 + Dummy_4342 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_68)*(Dummy_4324 + Dummy_4342 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_68)))*0.046462929447761363 + Dummy_4326*Dummy_4368*0.05008682322282932 + Dummy_4330*(((Dummy_4327 + Dummy_4343 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_69)*(Dummy_4327 + Dummy_4343 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_69)) + ((Dummy_4328 + Dummy_4344 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_69)*(Dummy_4328 + Dummy_4344 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_69)) + ((Dummy_4329 + Dummy_4345 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_69)*(Dummy_4329 + Dummy_4345 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_69)))*0.05008682322282932 + Dummy_4331*Dummy_4368*0.053182322583579168 + Dummy_4335*(((Dummy_4332 + Dummy_4346 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_70)*(Dummy_4332 + Dummy_4346 + jac_affine_inv_2_0_WHITE_DOWN*tmp_kernel_op_70)) + ((Dummy_4333 + Dummy_4347 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_70)*(Dummy_4333 + Dummy_4347 + jac_affine_inv_2_1_WHITE_DOWN*tmp_kernel_op_70)) + ((Dummy_4334 + Dummy_4348 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_70)*(Dummy_4334 + Dummy_4348 + jac_affine_inv_2_2_WHITE_DOWN*tmp_kernel_op_70)))*0.053182322583579168;
                const walberla::float64 Dummy_4378 = Dummy_4314*Dummy_4372*0.016934591412496779 + Dummy_4320*(((Dummy_4350 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_0_WHITE_DOWN*0.039933048641498423)*(Dummy_4350 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_0_WHITE_DOWN*0.039933048641498423)) + ((Dummy_4351 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_1_WHITE_DOWN*0.039933048641498423)*(Dummy_4351 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_1_WHITE_DOWN*0.039933048641498423)) + ((Dummy_4352 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_2_WHITE_DOWN*0.039933048641498423)*(Dummy_4352 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_2_WHITE_DOWN*0.039933048641498423)))*0.016934591412496779 + Dummy_4321*Dummy_4372*0.046462929447761363 + Dummy_4325*(((Dummy_4353 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_0_WHITE_DOWN*0.3817653560693467)*(Dummy_4353 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_0_WHITE_DOWN*0.3817653560693467)) + ((Dummy_4354 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_1_WHITE_DOWN*0.3817653560693467)*(Dummy_4354 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_1_WHITE_DOWN*0.3817653560693467)) + ((Dummy_4355 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_2_WHITE_DOWN*0.3817653560693467)*(Dummy_4355 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_2_WHITE_DOWN*0.3817653560693467)))*0.046462929447761363 + Dummy_4326*Dummy_4372*0.05008682322282932 + Dummy_4330*(((Dummy_4356 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_0_WHITE_DOWN*0.0069232355736274674)*(Dummy_4356 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_0_WHITE_DOWN*0.0069232355736274674)) + ((Dummy_4357 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_1_WHITE_DOWN*0.0069232355736274674)*(Dummy_4357 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_1_WHITE_DOWN*0.0069232355736274674)) + ((Dummy_4358 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_2_WHITE_DOWN*0.0069232355736274674)*(Dummy_4358 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_2_WHITE_DOWN*0.0069232355736274674)))*0.05008682322282932 + Dummy_4331*Dummy_4372*0.053182322583579168 + Dummy_4335*(((Dummy_4359 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_0_WHITE_DOWN*0.43070170707783612)*(Dummy_4359 + jac_affine_inv_1_0_WHITE_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_0_WHITE_DOWN*0.43070170707783612)) + ((Dummy_4360 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_1_WHITE_DOWN*0.43070170707783612)*(Dummy_4360 + jac_affine_inv_1_1_WHITE_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_1_WHITE_DOWN*0.43070170707783612)) + ((Dummy_4361 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_2_WHITE_DOWN*0.43070170707783612)*(Dummy_4361 + jac_affine_inv_1_2_WHITE_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_2_WHITE_DOWN*0.43070170707783612)))*0.053182322583579168;
                const walberla::float64 Dummy_4379 = Dummy_4314*Dummy_4373*0.016934591412496779 + Dummy_4320*(((jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_0_WHITE_DOWN*0.82157254096761978 + jac_affine_inv_2_0_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_0_WHITE_DOWN*0.82157254096761978 + jac_affine_inv_2_0_WHITE_DOWN*0.82157254096761978)) + ((jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_1_WHITE_DOWN*0.82157254096761978 + jac_affine_inv_2_1_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_1_WHITE_DOWN*0.82157254096761978 + jac_affine_inv_2_1_WHITE_DOWN*0.82157254096761978)) + ((jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_2_WHITE_DOWN*0.82157254096761978 + jac_affine_inv_2_2_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_2_WHITE_DOWN*0.82157254096761978 + jac_affine_inv_2_2_WHITE_DOWN*0.82157254096761978)))*0.016934591412496779 + Dummy_4321*Dummy_4373*0.046462929447761363 + Dummy_4325*(((jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_0_WHITE_DOWN*0.15593312049918601 + jac_affine_inv_2_0_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_0_WHITE_DOWN*0.15593312049918601 + jac_affine_inv_2_0_WHITE_DOWN*0.15593312049918601)) + ((jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_1_WHITE_DOWN*0.15593312049918601 + jac_affine_inv_2_1_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_1_WHITE_DOWN*0.15593312049918601 + jac_affine_inv_2_1_WHITE_DOWN*0.15593312049918601)) + ((jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_2_WHITE_DOWN*0.15593312049918601 + jac_affine_inv_2_2_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_2_WHITE_DOWN*0.15593312049918601 + jac_affine_inv_2_2_WHITE_DOWN*0.15593312049918601)))*0.046462929447761363 + Dummy_4326*Dummy_4373*0.05008682322282932 + Dummy_4330*(((jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_0_WHITE_DOWN*0.18002969351036541 + jac_affine_inv_2_0_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_0_WHITE_DOWN*0.18002969351036541 + jac_affine_inv_2_0_WHITE_DOWN*0.18002969351036541)) + ((jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_1_WHITE_DOWN*0.18002969351036541 + jac_affine_inv_2_1_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_1_WHITE_DOWN*0.18002969351036541 + jac_affine_inv_2_1_WHITE_DOWN*0.18002969351036541)) + ((jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_2_WHITE_DOWN*0.18002969351036541 + jac_affine_inv_2_2_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_2_WHITE_DOWN*0.18002969351036541 + jac_affine_inv_2_2_WHITE_DOWN*0.18002969351036541)))*0.05008682322282932 + Dummy_4331*Dummy_4373*0.053182322583579168 + Dummy_4335*(((jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_0_WHITE_DOWN*0.21607642918484779 + jac_affine_inv_2_0_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_WHITE_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_0_WHITE_DOWN*0.21607642918484779 + jac_affine_inv_2_0_WHITE_DOWN*0.21607642918484779)) + ((jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_1_WHITE_DOWN*0.21607642918484779 + jac_affine_inv_2_1_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_WHITE_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_1_WHITE_DOWN*0.21607642918484779 + jac_affine_inv_2_1_WHITE_DOWN*0.21607642918484779)) + ((jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_2_WHITE_DOWN*0.21607642918484779 + jac_affine_inv_2_2_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_WHITE_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_2_WHITE_DOWN*0.21607642918484779 + jac_affine_inv_2_2_WHITE_DOWN*0.21607642918484779)))*0.053182322583579168;
                {
                   {
                      _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = Dummy_4374 + _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1] = Dummy_4375 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = Dummy_4376 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                      _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = Dummy_4377 + _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                      _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = Dummy_4378 + _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = Dummy_4379 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                   }
                }
                const walberla::float64 Dummy_4380 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 Dummy_4381 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 Dummy_4382 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 Dummy_4383 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 Dummy_4384 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 Dummy_4385 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 Dummy_4386 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 Dummy_4387 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 Dummy_4388 = Dummy_4380*tmp_kernel_op_2 + Dummy_4381*0.82157254096761978 + Dummy_4382*0.039933048641498423 + Dummy_4383*0.01482761006242336;
                const walberla::float64 Dummy_4394 = abs_det_jac_affine_BLUE_UP*(Dummy_4384*tmp_kernel_op_2 + Dummy_4385*0.82157254096761978 + Dummy_4386*0.039933048641498423 + Dummy_4387*0.01482761006242336);
                const walberla::float64 Dummy_4395 = Dummy_4380*tmp_kernel_op_12 + Dummy_4381*0.15593312049918601 + Dummy_4382*0.3817653560693467 + Dummy_4383*0.0048399363458717648;
                const walberla::float64 Dummy_4399 = abs_det_jac_affine_BLUE_UP*(Dummy_4384*tmp_kernel_op_12 + Dummy_4385*0.15593312049918601 + Dummy_4386*0.3817653560693467 + Dummy_4387*0.0048399363458717648);
                const walberla::float64 Dummy_4400 = Dummy_4380*tmp_kernel_op_20 + Dummy_4381*0.18002969351036541 + Dummy_4382*0.0069232355736274674 + Dummy_4383*0.44773255210137269;
                const walberla::float64 Dummy_4404 = abs_det_jac_affine_BLUE_UP*(Dummy_4384*tmp_kernel_op_20 + Dummy_4385*0.18002969351036541 + Dummy_4386*0.0069232355736274674 + Dummy_4387*0.44773255210137269);
                const walberla::float64 Dummy_4405 = Dummy_4380*tmp_kernel_op_28 + Dummy_4381*0.21607642918484779 + Dummy_4382*0.43070170707783612 + Dummy_4383*0.35284634870858678;
                const walberla::float64 Dummy_4409 = abs_det_jac_affine_BLUE_UP*(Dummy_4384*tmp_kernel_op_28 + Dummy_4385*0.21607642918484779 + Dummy_4386*0.43070170707783612 + Dummy_4387*0.35284634870858678);
                const walberla::float64 Dummy_4448 = Dummy_4388*Dummy_4390*0.016934591412496779 + Dummy_4390*Dummy_4395*0.046462929447761363 + Dummy_4390*Dummy_4400*0.05008682322282932 + Dummy_4390*Dummy_4405*0.053182322583579168 + Dummy_4394*(((-Dummy_4391 + jac_affine_inv_2_0_BLUE_UP*0.039933048641498423)*(-Dummy_4391 + jac_affine_inv_2_0_BLUE_UP*0.039933048641498423)) + ((-Dummy_4392 + jac_affine_inv_2_1_BLUE_UP*0.039933048641498423)*(-Dummy_4392 + jac_affine_inv_2_1_BLUE_UP*0.039933048641498423)) + ((-Dummy_4393 + jac_affine_inv_2_2_BLUE_UP*0.039933048641498423)*(-Dummy_4393 + jac_affine_inv_2_2_BLUE_UP*0.039933048641498423)))*0.016934591412496779 + Dummy_4399*(((-Dummy_4396 + jac_affine_inv_2_0_BLUE_UP*0.3817653560693467)*(-Dummy_4396 + jac_affine_inv_2_0_BLUE_UP*0.3817653560693467)) + ((-Dummy_4397 + jac_affine_inv_2_1_BLUE_UP*0.3817653560693467)*(-Dummy_4397 + jac_affine_inv_2_1_BLUE_UP*0.3817653560693467)) + ((-Dummy_4398 + jac_affine_inv_2_2_BLUE_UP*0.3817653560693467)*(-Dummy_4398 + jac_affine_inv_2_2_BLUE_UP*0.3817653560693467)))*0.046462929447761363 + Dummy_4404*(((-Dummy_4401 + jac_affine_inv_2_0_BLUE_UP*0.0069232355736274674)*(-Dummy_4401 + jac_affine_inv_2_0_BLUE_UP*0.0069232355736274674)) + ((-Dummy_4402 + jac_affine_inv_2_1_BLUE_UP*0.0069232355736274674)*(-Dummy_4402 + jac_affine_inv_2_1_BLUE_UP*0.0069232355736274674)) + ((-Dummy_4403 + jac_affine_inv_2_2_BLUE_UP*0.0069232355736274674)*(-Dummy_4403 + jac_affine_inv_2_2_BLUE_UP*0.0069232355736274674)))*0.05008682322282932 + Dummy_4409*(((-Dummy_4406 + jac_affine_inv_2_0_BLUE_UP*0.43070170707783612)*(-Dummy_4406 + jac_affine_inv_2_0_BLUE_UP*0.43070170707783612)) + ((-Dummy_4407 + jac_affine_inv_2_1_BLUE_UP*0.43070170707783612)*(-Dummy_4407 + jac_affine_inv_2_1_BLUE_UP*0.43070170707783612)) + ((-Dummy_4408 + jac_affine_inv_2_2_BLUE_UP*0.43070170707783612)*(-Dummy_4408 + jac_affine_inv_2_2_BLUE_UP*0.43070170707783612)))*0.053182322583579168;
                const walberla::float64 Dummy_4449 = Dummy_4388*Dummy_4410*0.016934591412496779 + Dummy_4394*(((-Dummy_4411 + jac_affine_inv_2_0_BLUE_UP*0.82157254096761978)*(-Dummy_4411 + jac_affine_inv_2_0_BLUE_UP*0.82157254096761978)) + ((-Dummy_4412 + jac_affine_inv_2_1_BLUE_UP*0.82157254096761978)*(-Dummy_4412 + jac_affine_inv_2_1_BLUE_UP*0.82157254096761978)) + ((-Dummy_4413 + jac_affine_inv_2_2_BLUE_UP*0.82157254096761978)*(-Dummy_4413 + jac_affine_inv_2_2_BLUE_UP*0.82157254096761978)))*0.016934591412496779 + Dummy_4395*Dummy_4410*0.046462929447761363 + Dummy_4399*(((-Dummy_4414 + jac_affine_inv_2_0_BLUE_UP*0.15593312049918601)*(-Dummy_4414 + jac_affine_inv_2_0_BLUE_UP*0.15593312049918601)) + ((-Dummy_4415 + jac_affine_inv_2_1_BLUE_UP*0.15593312049918601)*(-Dummy_4415 + jac_affine_inv_2_1_BLUE_UP*0.15593312049918601)) + ((-Dummy_4416 + jac_affine_inv_2_2_BLUE_UP*0.15593312049918601)*(-Dummy_4416 + jac_affine_inv_2_2_BLUE_UP*0.15593312049918601)))*0.046462929447761363 + Dummy_4400*Dummy_4410*0.05008682322282932 + Dummy_4404*(((-Dummy_4417 + jac_affine_inv_2_0_BLUE_UP*0.18002969351036541)*(-Dummy_4417 + jac_affine_inv_2_0_BLUE_UP*0.18002969351036541)) + ((-Dummy_4418 + jac_affine_inv_2_1_BLUE_UP*0.18002969351036541)*(-Dummy_4418 + jac_affine_inv_2_1_BLUE_UP*0.18002969351036541)) + ((-Dummy_4419 + jac_affine_inv_2_2_BLUE_UP*0.18002969351036541)*(-Dummy_4419 + jac_affine_inv_2_2_BLUE_UP*0.18002969351036541)))*0.05008682322282932 + Dummy_4405*Dummy_4410*0.053182322583579168 + Dummy_4409*(((-Dummy_4420 + jac_affine_inv_2_0_BLUE_UP*0.21607642918484779)*(-Dummy_4420 + jac_affine_inv_2_0_BLUE_UP*0.21607642918484779)) + ((-Dummy_4421 + jac_affine_inv_2_1_BLUE_UP*0.21607642918484779)*(-Dummy_4421 + jac_affine_inv_2_1_BLUE_UP*0.21607642918484779)) + ((-Dummy_4422 + jac_affine_inv_2_2_BLUE_UP*0.21607642918484779)*(-Dummy_4422 + jac_affine_inv_2_2_BLUE_UP*0.21607642918484779)))*0.053182322583579168;
                const walberla::float64 Dummy_4450 = Dummy_4388*Dummy_4423*0.016934591412496779 + Dummy_4394*(((-Dummy_4424 + jac_affine_inv_1_0_BLUE_UP*0.82157254096761978)*(-Dummy_4424 + jac_affine_inv_1_0_BLUE_UP*0.82157254096761978)) + ((-Dummy_4425 + jac_affine_inv_1_1_BLUE_UP*0.82157254096761978)*(-Dummy_4425 + jac_affine_inv_1_1_BLUE_UP*0.82157254096761978)) + ((-Dummy_4426 + jac_affine_inv_1_2_BLUE_UP*0.82157254096761978)*(-Dummy_4426 + jac_affine_inv_1_2_BLUE_UP*0.82157254096761978)))*0.016934591412496779 + Dummy_4395*Dummy_4423*0.046462929447761363 + Dummy_4399*(((-Dummy_4427 + jac_affine_inv_1_0_BLUE_UP*0.15593312049918601)*(-Dummy_4427 + jac_affine_inv_1_0_BLUE_UP*0.15593312049918601)) + ((-Dummy_4428 + jac_affine_inv_1_1_BLUE_UP*0.15593312049918601)*(-Dummy_4428 + jac_affine_inv_1_1_BLUE_UP*0.15593312049918601)) + ((-Dummy_4429 + jac_affine_inv_1_2_BLUE_UP*0.15593312049918601)*(-Dummy_4429 + jac_affine_inv_1_2_BLUE_UP*0.15593312049918601)))*0.046462929447761363 + Dummy_4400*Dummy_4423*0.05008682322282932 + Dummy_4404*(((-Dummy_4430 + jac_affine_inv_1_0_BLUE_UP*0.18002969351036541)*(-Dummy_4430 + jac_affine_inv_1_0_BLUE_UP*0.18002969351036541)) + ((-Dummy_4431 + jac_affine_inv_1_1_BLUE_UP*0.18002969351036541)*(-Dummy_4431 + jac_affine_inv_1_1_BLUE_UP*0.18002969351036541)) + ((-Dummy_4432 + jac_affine_inv_1_2_BLUE_UP*0.18002969351036541)*(-Dummy_4432 + jac_affine_inv_1_2_BLUE_UP*0.18002969351036541)))*0.05008682322282932 + Dummy_4405*Dummy_4423*0.053182322583579168 + Dummy_4409*(((-Dummy_4433 + jac_affine_inv_1_0_BLUE_UP*0.21607642918484779)*(-Dummy_4433 + jac_affine_inv_1_0_BLUE_UP*0.21607642918484779)) + ((-Dummy_4434 + jac_affine_inv_1_1_BLUE_UP*0.21607642918484779)*(-Dummy_4434 + jac_affine_inv_1_1_BLUE_UP*0.21607642918484779)) + ((-Dummy_4435 + jac_affine_inv_1_2_BLUE_UP*0.21607642918484779)*(-Dummy_4435 + jac_affine_inv_1_2_BLUE_UP*0.21607642918484779)))*0.053182322583579168;
                const walberla::float64 Dummy_4451 = Dummy_4388*Dummy_4442*0.016934591412496779 + Dummy_4394*(((Dummy_4391 + Dummy_4411 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_67)*(Dummy_4391 + Dummy_4411 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_67)) + ((Dummy_4392 + Dummy_4412 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_67)*(Dummy_4392 + Dummy_4412 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_67)) + ((Dummy_4393 + Dummy_4413 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_67)*(Dummy_4393 + Dummy_4413 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_67)))*0.016934591412496779 + Dummy_4395*Dummy_4442*0.046462929447761363 + Dummy_4399*(((Dummy_4396 + Dummy_4414 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_68)*(Dummy_4396 + Dummy_4414 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_68)) + ((Dummy_4397 + Dummy_4415 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_68)*(Dummy_4397 + Dummy_4415 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_68)) + ((Dummy_4398 + Dummy_4416 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_68)*(Dummy_4398 + Dummy_4416 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_68)))*0.046462929447761363 + Dummy_4400*Dummy_4442*0.05008682322282932 + Dummy_4404*(((Dummy_4401 + Dummy_4417 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_69)*(Dummy_4401 + Dummy_4417 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_69)) + ((Dummy_4402 + Dummy_4418 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_69)*(Dummy_4402 + Dummy_4418 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_69)) + ((Dummy_4403 + Dummy_4419 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_69)*(Dummy_4403 + Dummy_4419 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_69)))*0.05008682322282932 + Dummy_4405*Dummy_4442*0.053182322583579168 + Dummy_4409*(((Dummy_4406 + Dummy_4420 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_70)*(Dummy_4406 + Dummy_4420 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_70)) + ((Dummy_4407 + Dummy_4421 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_70)*(Dummy_4407 + Dummy_4421 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_70)) + ((Dummy_4408 + Dummy_4422 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_70)*(Dummy_4408 + Dummy_4422 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_70)))*0.053182322583579168;
                const walberla::float64 Dummy_4452 = Dummy_4388*Dummy_4446*0.016934591412496779 + Dummy_4394*(((Dummy_4424 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_75 + jac_affine_inv_2_0_BLUE_UP*0.039933048641498423)*(Dummy_4424 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_75 + jac_affine_inv_2_0_BLUE_UP*0.039933048641498423)) + ((Dummy_4425 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_75 + jac_affine_inv_2_1_BLUE_UP*0.039933048641498423)*(Dummy_4425 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_75 + jac_affine_inv_2_1_BLUE_UP*0.039933048641498423)) + ((Dummy_4426 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_75 + jac_affine_inv_2_2_BLUE_UP*0.039933048641498423)*(Dummy_4426 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_75 + jac_affine_inv_2_2_BLUE_UP*0.039933048641498423)))*0.016934591412496779 + Dummy_4395*Dummy_4446*0.046462929447761363 + Dummy_4399*(((Dummy_4427 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_76 + jac_affine_inv_2_0_BLUE_UP*0.3817653560693467)*(Dummy_4427 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_76 + jac_affine_inv_2_0_BLUE_UP*0.3817653560693467)) + ((Dummy_4428 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_76 + jac_affine_inv_2_1_BLUE_UP*0.3817653560693467)*(Dummy_4428 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_76 + jac_affine_inv_2_1_BLUE_UP*0.3817653560693467)) + ((Dummy_4429 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_76 + jac_affine_inv_2_2_BLUE_UP*0.3817653560693467)*(Dummy_4429 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_76 + jac_affine_inv_2_2_BLUE_UP*0.3817653560693467)))*0.046462929447761363 + Dummy_4400*Dummy_4446*0.05008682322282932 + Dummy_4404*(((Dummy_4430 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_77 + jac_affine_inv_2_0_BLUE_UP*0.0069232355736274674)*(Dummy_4430 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_77 + jac_affine_inv_2_0_BLUE_UP*0.0069232355736274674)) + ((Dummy_4431 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_77 + jac_affine_inv_2_1_BLUE_UP*0.0069232355736274674)*(Dummy_4431 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_77 + jac_affine_inv_2_1_BLUE_UP*0.0069232355736274674)) + ((Dummy_4432 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_77 + jac_affine_inv_2_2_BLUE_UP*0.0069232355736274674)*(Dummy_4432 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_77 + jac_affine_inv_2_2_BLUE_UP*0.0069232355736274674)))*0.05008682322282932 + Dummy_4405*Dummy_4446*0.053182322583579168 + Dummy_4409*(((Dummy_4433 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_78 + jac_affine_inv_2_0_BLUE_UP*0.43070170707783612)*(Dummy_4433 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_78 + jac_affine_inv_2_0_BLUE_UP*0.43070170707783612)) + ((Dummy_4434 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_78 + jac_affine_inv_2_1_BLUE_UP*0.43070170707783612)*(Dummy_4434 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_78 + jac_affine_inv_2_1_BLUE_UP*0.43070170707783612)) + ((Dummy_4435 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_78 + jac_affine_inv_2_2_BLUE_UP*0.43070170707783612)*(Dummy_4435 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_78 + jac_affine_inv_2_2_BLUE_UP*0.43070170707783612)))*0.053182322583579168;
                const walberla::float64 Dummy_4453 = Dummy_4388*Dummy_4447*0.016934591412496779 + Dummy_4394*(((jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_80 + jac_affine_inv_1_0_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_0_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_80 + jac_affine_inv_1_0_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_0_BLUE_UP*0.82157254096761978)) + ((jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_80 + jac_affine_inv_1_1_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_1_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_80 + jac_affine_inv_1_1_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_1_BLUE_UP*0.82157254096761978)) + ((jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_80 + jac_affine_inv_1_2_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_2_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_80 + jac_affine_inv_1_2_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_2_BLUE_UP*0.82157254096761978)))*0.016934591412496779 + Dummy_4395*Dummy_4447*0.046462929447761363 + Dummy_4399*(((jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_81 + jac_affine_inv_1_0_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_0_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_81 + jac_affine_inv_1_0_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_0_BLUE_UP*0.15593312049918601)) + ((jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_81 + jac_affine_inv_1_1_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_1_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_81 + jac_affine_inv_1_1_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_1_BLUE_UP*0.15593312049918601)) + ((jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_81 + jac_affine_inv_1_2_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_2_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_81 + jac_affine_inv_1_2_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_2_BLUE_UP*0.15593312049918601)))*0.046462929447761363 + Dummy_4400*Dummy_4447*0.05008682322282932 + Dummy_4404*(((jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_82 + jac_affine_inv_1_0_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_0_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_82 + jac_affine_inv_1_0_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_0_BLUE_UP*0.18002969351036541)) + ((jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_82 + jac_affine_inv_1_1_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_1_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_82 + jac_affine_inv_1_1_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_1_BLUE_UP*0.18002969351036541)) + ((jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_82 + jac_affine_inv_1_2_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_2_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_82 + jac_affine_inv_1_2_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_2_BLUE_UP*0.18002969351036541)))*0.05008682322282932 + Dummy_4405*Dummy_4447*0.053182322583579168 + Dummy_4409*(((jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_83 + jac_affine_inv_1_0_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_0_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_83 + jac_affine_inv_1_0_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_0_BLUE_UP*0.21607642918484779)) + ((jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_83 + jac_affine_inv_1_1_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_1_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_83 + jac_affine_inv_1_1_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_1_BLUE_UP*0.21607642918484779)) + ((jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_83 + jac_affine_inv_1_2_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_2_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_83 + jac_affine_inv_1_2_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_2_BLUE_UP*0.21607642918484779)))*0.053182322583579168;
                {
                   {
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = Dummy_4448 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = Dummy_4449 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                      _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = Dummy_4450 + _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = Dummy_4451 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = Dummy_4452 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = Dummy_4453 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   }
                }
                const walberla::float64 Dummy_4454 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 Dummy_4455 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 Dummy_4456 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 Dummy_4457 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 Dummy_4458 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 Dummy_4459 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 Dummy_4460 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 Dummy_4461 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 Dummy_4462 = Dummy_4454*tmp_kernel_op_2 + Dummy_4455*0.82157254096761978 + Dummy_4456*0.039933048641498423 + Dummy_4457*0.01482761006242336;
                const walberla::float64 Dummy_4468 = abs_det_jac_affine_BLUE_DOWN*(Dummy_4458*tmp_kernel_op_2 + Dummy_4459*0.82157254096761978 + Dummy_4460*0.039933048641498423 + Dummy_4461*0.01482761006242336);
                const walberla::float64 Dummy_4469 = Dummy_4454*tmp_kernel_op_12 + Dummy_4455*0.15593312049918601 + Dummy_4456*0.3817653560693467 + Dummy_4457*0.0048399363458717648;
                const walberla::float64 Dummy_4473 = abs_det_jac_affine_BLUE_DOWN*(Dummy_4458*tmp_kernel_op_12 + Dummy_4459*0.15593312049918601 + Dummy_4460*0.3817653560693467 + Dummy_4461*0.0048399363458717648);
                const walberla::float64 Dummy_4474 = Dummy_4454*tmp_kernel_op_20 + Dummy_4455*0.18002969351036541 + Dummy_4456*0.0069232355736274674 + Dummy_4457*0.44773255210137269;
                const walberla::float64 Dummy_4478 = abs_det_jac_affine_BLUE_DOWN*(Dummy_4458*tmp_kernel_op_20 + Dummy_4459*0.18002969351036541 + Dummy_4460*0.0069232355736274674 + Dummy_4461*0.44773255210137269);
                const walberla::float64 Dummy_4479 = Dummy_4454*tmp_kernel_op_28 + Dummy_4455*0.21607642918484779 + Dummy_4456*0.43070170707783612 + Dummy_4457*0.35284634870858678;
                const walberla::float64 Dummy_4483 = abs_det_jac_affine_BLUE_DOWN*(Dummy_4458*tmp_kernel_op_28 + Dummy_4459*0.21607642918484779 + Dummy_4460*0.43070170707783612 + Dummy_4461*0.35284634870858678);
                const walberla::float64 Dummy_4522 = Dummy_4462*Dummy_4464*0.016934591412496779 + Dummy_4464*Dummy_4469*0.046462929447761363 + Dummy_4464*Dummy_4474*0.05008682322282932 + Dummy_4464*Dummy_4479*0.053182322583579168 + Dummy_4468*(((-Dummy_4465 + jac_affine_inv_2_0_BLUE_DOWN*0.039933048641498423)*(-Dummy_4465 + jac_affine_inv_2_0_BLUE_DOWN*0.039933048641498423)) + ((-Dummy_4466 + jac_affine_inv_2_1_BLUE_DOWN*0.039933048641498423)*(-Dummy_4466 + jac_affine_inv_2_1_BLUE_DOWN*0.039933048641498423)) + ((-Dummy_4467 + jac_affine_inv_2_2_BLUE_DOWN*0.039933048641498423)*(-Dummy_4467 + jac_affine_inv_2_2_BLUE_DOWN*0.039933048641498423)))*0.016934591412496779 + Dummy_4473*(((-Dummy_4470 + jac_affine_inv_2_0_BLUE_DOWN*0.3817653560693467)*(-Dummy_4470 + jac_affine_inv_2_0_BLUE_DOWN*0.3817653560693467)) + ((-Dummy_4471 + jac_affine_inv_2_1_BLUE_DOWN*0.3817653560693467)*(-Dummy_4471 + jac_affine_inv_2_1_BLUE_DOWN*0.3817653560693467)) + ((-Dummy_4472 + jac_affine_inv_2_2_BLUE_DOWN*0.3817653560693467)*(-Dummy_4472 + jac_affine_inv_2_2_BLUE_DOWN*0.3817653560693467)))*0.046462929447761363 + Dummy_4478*(((-Dummy_4475 + jac_affine_inv_2_0_BLUE_DOWN*0.0069232355736274674)*(-Dummy_4475 + jac_affine_inv_2_0_BLUE_DOWN*0.0069232355736274674)) + ((-Dummy_4476 + jac_affine_inv_2_1_BLUE_DOWN*0.0069232355736274674)*(-Dummy_4476 + jac_affine_inv_2_1_BLUE_DOWN*0.0069232355736274674)) + ((-Dummy_4477 + jac_affine_inv_2_2_BLUE_DOWN*0.0069232355736274674)*(-Dummy_4477 + jac_affine_inv_2_2_BLUE_DOWN*0.0069232355736274674)))*0.05008682322282932 + Dummy_4483*(((-Dummy_4480 + jac_affine_inv_2_0_BLUE_DOWN*0.43070170707783612)*(-Dummy_4480 + jac_affine_inv_2_0_BLUE_DOWN*0.43070170707783612)) + ((-Dummy_4481 + jac_affine_inv_2_1_BLUE_DOWN*0.43070170707783612)*(-Dummy_4481 + jac_affine_inv_2_1_BLUE_DOWN*0.43070170707783612)) + ((-Dummy_4482 + jac_affine_inv_2_2_BLUE_DOWN*0.43070170707783612)*(-Dummy_4482 + jac_affine_inv_2_2_BLUE_DOWN*0.43070170707783612)))*0.053182322583579168;
                const walberla::float64 Dummy_4523 = Dummy_4462*Dummy_4484*0.016934591412496779 + Dummy_4468*(((-Dummy_4485 + jac_affine_inv_2_0_BLUE_DOWN*0.82157254096761978)*(-Dummy_4485 + jac_affine_inv_2_0_BLUE_DOWN*0.82157254096761978)) + ((-Dummy_4486 + jac_affine_inv_2_1_BLUE_DOWN*0.82157254096761978)*(-Dummy_4486 + jac_affine_inv_2_1_BLUE_DOWN*0.82157254096761978)) + ((-Dummy_4487 + jac_affine_inv_2_2_BLUE_DOWN*0.82157254096761978)*(-Dummy_4487 + jac_affine_inv_2_2_BLUE_DOWN*0.82157254096761978)))*0.016934591412496779 + Dummy_4469*Dummy_4484*0.046462929447761363 + Dummy_4473*(((-Dummy_4488 + jac_affine_inv_2_0_BLUE_DOWN*0.15593312049918601)*(-Dummy_4488 + jac_affine_inv_2_0_BLUE_DOWN*0.15593312049918601)) + ((-Dummy_4489 + jac_affine_inv_2_1_BLUE_DOWN*0.15593312049918601)*(-Dummy_4489 + jac_affine_inv_2_1_BLUE_DOWN*0.15593312049918601)) + ((-Dummy_4490 + jac_affine_inv_2_2_BLUE_DOWN*0.15593312049918601)*(-Dummy_4490 + jac_affine_inv_2_2_BLUE_DOWN*0.15593312049918601)))*0.046462929447761363 + Dummy_4474*Dummy_4484*0.05008682322282932 + Dummy_4478*(((-Dummy_4491 + jac_affine_inv_2_0_BLUE_DOWN*0.18002969351036541)*(-Dummy_4491 + jac_affine_inv_2_0_BLUE_DOWN*0.18002969351036541)) + ((-Dummy_4492 + jac_affine_inv_2_1_BLUE_DOWN*0.18002969351036541)*(-Dummy_4492 + jac_affine_inv_2_1_BLUE_DOWN*0.18002969351036541)) + ((-Dummy_4493 + jac_affine_inv_2_2_BLUE_DOWN*0.18002969351036541)*(-Dummy_4493 + jac_affine_inv_2_2_BLUE_DOWN*0.18002969351036541)))*0.05008682322282932 + Dummy_4479*Dummy_4484*0.053182322583579168 + Dummy_4483*(((-Dummy_4494 + jac_affine_inv_2_0_BLUE_DOWN*0.21607642918484779)*(-Dummy_4494 + jac_affine_inv_2_0_BLUE_DOWN*0.21607642918484779)) + ((-Dummy_4495 + jac_affine_inv_2_1_BLUE_DOWN*0.21607642918484779)*(-Dummy_4495 + jac_affine_inv_2_1_BLUE_DOWN*0.21607642918484779)) + ((-Dummy_4496 + jac_affine_inv_2_2_BLUE_DOWN*0.21607642918484779)*(-Dummy_4496 + jac_affine_inv_2_2_BLUE_DOWN*0.21607642918484779)))*0.053182322583579168;
                const walberla::float64 Dummy_4524 = Dummy_4462*Dummy_4497*0.016934591412496779 + Dummy_4468*(((-Dummy_4498 + jac_affine_inv_1_0_BLUE_DOWN*0.82157254096761978)*(-Dummy_4498 + jac_affine_inv_1_0_BLUE_DOWN*0.82157254096761978)) + ((-Dummy_4499 + jac_affine_inv_1_1_BLUE_DOWN*0.82157254096761978)*(-Dummy_4499 + jac_affine_inv_1_1_BLUE_DOWN*0.82157254096761978)) + ((-Dummy_4500 + jac_affine_inv_1_2_BLUE_DOWN*0.82157254096761978)*(-Dummy_4500 + jac_affine_inv_1_2_BLUE_DOWN*0.82157254096761978)))*0.016934591412496779 + Dummy_4469*Dummy_4497*0.046462929447761363 + Dummy_4473*(((-Dummy_4501 + jac_affine_inv_1_0_BLUE_DOWN*0.15593312049918601)*(-Dummy_4501 + jac_affine_inv_1_0_BLUE_DOWN*0.15593312049918601)) + ((-Dummy_4502 + jac_affine_inv_1_1_BLUE_DOWN*0.15593312049918601)*(-Dummy_4502 + jac_affine_inv_1_1_BLUE_DOWN*0.15593312049918601)) + ((-Dummy_4503 + jac_affine_inv_1_2_BLUE_DOWN*0.15593312049918601)*(-Dummy_4503 + jac_affine_inv_1_2_BLUE_DOWN*0.15593312049918601)))*0.046462929447761363 + Dummy_4474*Dummy_4497*0.05008682322282932 + Dummy_4478*(((-Dummy_4504 + jac_affine_inv_1_0_BLUE_DOWN*0.18002969351036541)*(-Dummy_4504 + jac_affine_inv_1_0_BLUE_DOWN*0.18002969351036541)) + ((-Dummy_4505 + jac_affine_inv_1_1_BLUE_DOWN*0.18002969351036541)*(-Dummy_4505 + jac_affine_inv_1_1_BLUE_DOWN*0.18002969351036541)) + ((-Dummy_4506 + jac_affine_inv_1_2_BLUE_DOWN*0.18002969351036541)*(-Dummy_4506 + jac_affine_inv_1_2_BLUE_DOWN*0.18002969351036541)))*0.05008682322282932 + Dummy_4479*Dummy_4497*0.053182322583579168 + Dummy_4483*(((-Dummy_4507 + jac_affine_inv_1_0_BLUE_DOWN*0.21607642918484779)*(-Dummy_4507 + jac_affine_inv_1_0_BLUE_DOWN*0.21607642918484779)) + ((-Dummy_4508 + jac_affine_inv_1_1_BLUE_DOWN*0.21607642918484779)*(-Dummy_4508 + jac_affine_inv_1_1_BLUE_DOWN*0.21607642918484779)) + ((-Dummy_4509 + jac_affine_inv_1_2_BLUE_DOWN*0.21607642918484779)*(-Dummy_4509 + jac_affine_inv_1_2_BLUE_DOWN*0.21607642918484779)))*0.053182322583579168;
                const walberla::float64 Dummy_4525 = Dummy_4462*Dummy_4516*0.016934591412496779 + Dummy_4468*(((Dummy_4465 + Dummy_4485 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_67)*(Dummy_4465 + Dummy_4485 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_67)) + ((Dummy_4466 + Dummy_4486 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_67)*(Dummy_4466 + Dummy_4486 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_67)) + ((Dummy_4467 + Dummy_4487 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_67)*(Dummy_4467 + Dummy_4487 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_67)))*0.016934591412496779 + Dummy_4469*Dummy_4516*0.046462929447761363 + Dummy_4473*(((Dummy_4470 + Dummy_4488 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_68)*(Dummy_4470 + Dummy_4488 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_68)) + ((Dummy_4471 + Dummy_4489 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_68)*(Dummy_4471 + Dummy_4489 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_68)) + ((Dummy_4472 + Dummy_4490 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_68)*(Dummy_4472 + Dummy_4490 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_68)))*0.046462929447761363 + Dummy_4474*Dummy_4516*0.05008682322282932 + Dummy_4478*(((Dummy_4475 + Dummy_4491 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_69)*(Dummy_4475 + Dummy_4491 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_69)) + ((Dummy_4476 + Dummy_4492 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_69)*(Dummy_4476 + Dummy_4492 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_69)) + ((Dummy_4477 + Dummy_4493 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_69)*(Dummy_4477 + Dummy_4493 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_69)))*0.05008682322282932 + Dummy_4479*Dummy_4516*0.053182322583579168 + Dummy_4483*(((Dummy_4480 + Dummy_4494 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_70)*(Dummy_4480 + Dummy_4494 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_70)) + ((Dummy_4481 + Dummy_4495 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_70)*(Dummy_4481 + Dummy_4495 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_70)) + ((Dummy_4482 + Dummy_4496 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_70)*(Dummy_4482 + Dummy_4496 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_70)))*0.053182322583579168;
                const walberla::float64 Dummy_4526 = Dummy_4462*Dummy_4520*0.016934591412496779 + Dummy_4468*(((Dummy_4498 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_0_BLUE_DOWN*0.039933048641498423)*(Dummy_4498 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_0_BLUE_DOWN*0.039933048641498423)) + ((Dummy_4499 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_1_BLUE_DOWN*0.039933048641498423)*(Dummy_4499 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_1_BLUE_DOWN*0.039933048641498423)) + ((Dummy_4500 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_2_BLUE_DOWN*0.039933048641498423)*(Dummy_4500 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_2_BLUE_DOWN*0.039933048641498423)))*0.016934591412496779 + Dummy_4469*Dummy_4520*0.046462929447761363 + Dummy_4473*(((Dummy_4501 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_0_BLUE_DOWN*0.3817653560693467)*(Dummy_4501 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_0_BLUE_DOWN*0.3817653560693467)) + ((Dummy_4502 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_1_BLUE_DOWN*0.3817653560693467)*(Dummy_4502 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_1_BLUE_DOWN*0.3817653560693467)) + ((Dummy_4503 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_2_BLUE_DOWN*0.3817653560693467)*(Dummy_4503 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_2_BLUE_DOWN*0.3817653560693467)))*0.046462929447761363 + Dummy_4474*Dummy_4520*0.05008682322282932 + Dummy_4478*(((Dummy_4504 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_0_BLUE_DOWN*0.0069232355736274674)*(Dummy_4504 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_0_BLUE_DOWN*0.0069232355736274674)) + ((Dummy_4505 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_1_BLUE_DOWN*0.0069232355736274674)*(Dummy_4505 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_1_BLUE_DOWN*0.0069232355736274674)) + ((Dummy_4506 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_2_BLUE_DOWN*0.0069232355736274674)*(Dummy_4506 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_2_BLUE_DOWN*0.0069232355736274674)))*0.05008682322282932 + Dummy_4479*Dummy_4520*0.053182322583579168 + Dummy_4483*(((Dummy_4507 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_0_BLUE_DOWN*0.43070170707783612)*(Dummy_4507 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_0_BLUE_DOWN*0.43070170707783612)) + ((Dummy_4508 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_1_BLUE_DOWN*0.43070170707783612)*(Dummy_4508 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_1_BLUE_DOWN*0.43070170707783612)) + ((Dummy_4509 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_2_BLUE_DOWN*0.43070170707783612)*(Dummy_4509 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_2_BLUE_DOWN*0.43070170707783612)))*0.053182322583579168;
                const walberla::float64 Dummy_4527 = Dummy_4462*Dummy_4521*0.016934591412496779 + Dummy_4468*(((jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_0_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_0_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_0_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_0_BLUE_DOWN*0.82157254096761978)) + ((jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_1_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_1_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_1_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_1_BLUE_DOWN*0.82157254096761978)) + ((jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_2_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_2_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_2_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_2_BLUE_DOWN*0.82157254096761978)))*0.016934591412496779 + Dummy_4469*Dummy_4521*0.046462929447761363 + Dummy_4473*(((jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_0_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_0_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_0_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_0_BLUE_DOWN*0.15593312049918601)) + ((jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_1_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_1_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_1_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_1_BLUE_DOWN*0.15593312049918601)) + ((jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_2_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_2_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_2_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_2_BLUE_DOWN*0.15593312049918601)))*0.046462929447761363 + Dummy_4474*Dummy_4521*0.05008682322282932 + Dummy_4478*(((jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_0_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_0_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_0_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_0_BLUE_DOWN*0.18002969351036541)) + ((jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_1_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_1_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_1_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_1_BLUE_DOWN*0.18002969351036541)) + ((jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_2_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_2_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_2_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_2_BLUE_DOWN*0.18002969351036541)))*0.05008682322282932 + Dummy_4479*Dummy_4521*0.053182322583579168 + Dummy_4483*(((jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_0_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_0_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_0_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_0_BLUE_DOWN*0.21607642918484779)) + ((jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_1_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_1_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_1_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_1_BLUE_DOWN*0.21607642918484779)) + ((jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_2_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_2_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_2_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_2_BLUE_DOWN*0.21607642918484779)))*0.053182322583579168;
                {
                   {
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = Dummy_4522 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = Dummy_4523 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = Dummy_4524 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                      _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = Dummy_4525 + _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = Dummy_4526 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = Dummy_4527 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   }
                }
                const walberla::float64 Dummy_4528 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 Dummy_4529 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 Dummy_4530 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 Dummy_4531 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 Dummy_4532 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 Dummy_4533 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 Dummy_4534 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 Dummy_4535 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 Dummy_4536 = Dummy_4528*tmp_kernel_op_2 + Dummy_4529*0.82157254096761978 + Dummy_4530*0.039933048641498423 + Dummy_4531*0.01482761006242336;
                const walberla::float64 Dummy_4542 = abs_det_jac_affine_GREEN_UP*(Dummy_4532*tmp_kernel_op_2 + Dummy_4533*0.82157254096761978 + Dummy_4534*0.039933048641498423 + Dummy_4535*0.01482761006242336);
                const walberla::float64 Dummy_4543 = Dummy_4528*tmp_kernel_op_12 + Dummy_4529*0.15593312049918601 + Dummy_4530*0.3817653560693467 + Dummy_4531*0.0048399363458717648;
                const walberla::float64 Dummy_4547 = abs_det_jac_affine_GREEN_UP*(Dummy_4532*tmp_kernel_op_12 + Dummy_4533*0.15593312049918601 + Dummy_4534*0.3817653560693467 + Dummy_4535*0.0048399363458717648);
                const walberla::float64 Dummy_4548 = Dummy_4528*tmp_kernel_op_20 + Dummy_4529*0.18002969351036541 + Dummy_4530*0.0069232355736274674 + Dummy_4531*0.44773255210137269;
                const walberla::float64 Dummy_4552 = abs_det_jac_affine_GREEN_UP*(Dummy_4532*tmp_kernel_op_20 + Dummy_4533*0.18002969351036541 + Dummy_4534*0.0069232355736274674 + Dummy_4535*0.44773255210137269);
                const walberla::float64 Dummy_4553 = Dummy_4528*tmp_kernel_op_28 + Dummy_4529*0.21607642918484779 + Dummy_4530*0.43070170707783612 + Dummy_4531*0.35284634870858678;
                const walberla::float64 Dummy_4557 = abs_det_jac_affine_GREEN_UP*(Dummy_4532*tmp_kernel_op_28 + Dummy_4533*0.21607642918484779 + Dummy_4534*0.43070170707783612 + Dummy_4535*0.35284634870858678);
                const walberla::float64 Dummy_4596 = Dummy_4536*Dummy_4538*0.016934591412496779 + Dummy_4538*Dummy_4543*0.046462929447761363 + Dummy_4538*Dummy_4548*0.05008682322282932 + Dummy_4538*Dummy_4553*0.053182322583579168 + Dummy_4542*(((-Dummy_4539 + jac_affine_inv_2_0_GREEN_UP*0.039933048641498423)*(-Dummy_4539 + jac_affine_inv_2_0_GREEN_UP*0.039933048641498423)) + ((-Dummy_4540 + jac_affine_inv_2_1_GREEN_UP*0.039933048641498423)*(-Dummy_4540 + jac_affine_inv_2_1_GREEN_UP*0.039933048641498423)) + ((-Dummy_4541 + jac_affine_inv_2_2_GREEN_UP*0.039933048641498423)*(-Dummy_4541 + jac_affine_inv_2_2_GREEN_UP*0.039933048641498423)))*0.016934591412496779 + Dummy_4547*(((-Dummy_4544 + jac_affine_inv_2_0_GREEN_UP*0.3817653560693467)*(-Dummy_4544 + jac_affine_inv_2_0_GREEN_UP*0.3817653560693467)) + ((-Dummy_4545 + jac_affine_inv_2_1_GREEN_UP*0.3817653560693467)*(-Dummy_4545 + jac_affine_inv_2_1_GREEN_UP*0.3817653560693467)) + ((-Dummy_4546 + jac_affine_inv_2_2_GREEN_UP*0.3817653560693467)*(-Dummy_4546 + jac_affine_inv_2_2_GREEN_UP*0.3817653560693467)))*0.046462929447761363 + Dummy_4552*(((-Dummy_4549 + jac_affine_inv_2_0_GREEN_UP*0.0069232355736274674)*(-Dummy_4549 + jac_affine_inv_2_0_GREEN_UP*0.0069232355736274674)) + ((-Dummy_4550 + jac_affine_inv_2_1_GREEN_UP*0.0069232355736274674)*(-Dummy_4550 + jac_affine_inv_2_1_GREEN_UP*0.0069232355736274674)) + ((-Dummy_4551 + jac_affine_inv_2_2_GREEN_UP*0.0069232355736274674)*(-Dummy_4551 + jac_affine_inv_2_2_GREEN_UP*0.0069232355736274674)))*0.05008682322282932 + Dummy_4557*(((-Dummy_4554 + jac_affine_inv_2_0_GREEN_UP*0.43070170707783612)*(-Dummy_4554 + jac_affine_inv_2_0_GREEN_UP*0.43070170707783612)) + ((-Dummy_4555 + jac_affine_inv_2_1_GREEN_UP*0.43070170707783612)*(-Dummy_4555 + jac_affine_inv_2_1_GREEN_UP*0.43070170707783612)) + ((-Dummy_4556 + jac_affine_inv_2_2_GREEN_UP*0.43070170707783612)*(-Dummy_4556 + jac_affine_inv_2_2_GREEN_UP*0.43070170707783612)))*0.053182322583579168;
                const walberla::float64 Dummy_4597 = Dummy_4536*Dummy_4558*0.016934591412496779 + Dummy_4542*(((-Dummy_4559 + jac_affine_inv_2_0_GREEN_UP*0.82157254096761978)*(-Dummy_4559 + jac_affine_inv_2_0_GREEN_UP*0.82157254096761978)) + ((-Dummy_4560 + jac_affine_inv_2_1_GREEN_UP*0.82157254096761978)*(-Dummy_4560 + jac_affine_inv_2_1_GREEN_UP*0.82157254096761978)) + ((-Dummy_4561 + jac_affine_inv_2_2_GREEN_UP*0.82157254096761978)*(-Dummy_4561 + jac_affine_inv_2_2_GREEN_UP*0.82157254096761978)))*0.016934591412496779 + Dummy_4543*Dummy_4558*0.046462929447761363 + Dummy_4547*(((-Dummy_4562 + jac_affine_inv_2_0_GREEN_UP*0.15593312049918601)*(-Dummy_4562 + jac_affine_inv_2_0_GREEN_UP*0.15593312049918601)) + ((-Dummy_4563 + jac_affine_inv_2_1_GREEN_UP*0.15593312049918601)*(-Dummy_4563 + jac_affine_inv_2_1_GREEN_UP*0.15593312049918601)) + ((-Dummy_4564 + jac_affine_inv_2_2_GREEN_UP*0.15593312049918601)*(-Dummy_4564 + jac_affine_inv_2_2_GREEN_UP*0.15593312049918601)))*0.046462929447761363 + Dummy_4548*Dummy_4558*0.05008682322282932 + Dummy_4552*(((-Dummy_4565 + jac_affine_inv_2_0_GREEN_UP*0.18002969351036541)*(-Dummy_4565 + jac_affine_inv_2_0_GREEN_UP*0.18002969351036541)) + ((-Dummy_4566 + jac_affine_inv_2_1_GREEN_UP*0.18002969351036541)*(-Dummy_4566 + jac_affine_inv_2_1_GREEN_UP*0.18002969351036541)) + ((-Dummy_4567 + jac_affine_inv_2_2_GREEN_UP*0.18002969351036541)*(-Dummy_4567 + jac_affine_inv_2_2_GREEN_UP*0.18002969351036541)))*0.05008682322282932 + Dummy_4553*Dummy_4558*0.053182322583579168 + Dummy_4557*(((-Dummy_4568 + jac_affine_inv_2_0_GREEN_UP*0.21607642918484779)*(-Dummy_4568 + jac_affine_inv_2_0_GREEN_UP*0.21607642918484779)) + ((-Dummy_4569 + jac_affine_inv_2_1_GREEN_UP*0.21607642918484779)*(-Dummy_4569 + jac_affine_inv_2_1_GREEN_UP*0.21607642918484779)) + ((-Dummy_4570 + jac_affine_inv_2_2_GREEN_UP*0.21607642918484779)*(-Dummy_4570 + jac_affine_inv_2_2_GREEN_UP*0.21607642918484779)))*0.053182322583579168;
                const walberla::float64 Dummy_4598 = Dummy_4536*Dummy_4571*0.016934591412496779 + Dummy_4542*(((-Dummy_4572 + jac_affine_inv_1_0_GREEN_UP*0.82157254096761978)*(-Dummy_4572 + jac_affine_inv_1_0_GREEN_UP*0.82157254096761978)) + ((-Dummy_4573 + jac_affine_inv_1_1_GREEN_UP*0.82157254096761978)*(-Dummy_4573 + jac_affine_inv_1_1_GREEN_UP*0.82157254096761978)) + ((-Dummy_4574 + jac_affine_inv_1_2_GREEN_UP*0.82157254096761978)*(-Dummy_4574 + jac_affine_inv_1_2_GREEN_UP*0.82157254096761978)))*0.016934591412496779 + Dummy_4543*Dummy_4571*0.046462929447761363 + Dummy_4547*(((-Dummy_4575 + jac_affine_inv_1_0_GREEN_UP*0.15593312049918601)*(-Dummy_4575 + jac_affine_inv_1_0_GREEN_UP*0.15593312049918601)) + ((-Dummy_4576 + jac_affine_inv_1_1_GREEN_UP*0.15593312049918601)*(-Dummy_4576 + jac_affine_inv_1_1_GREEN_UP*0.15593312049918601)) + ((-Dummy_4577 + jac_affine_inv_1_2_GREEN_UP*0.15593312049918601)*(-Dummy_4577 + jac_affine_inv_1_2_GREEN_UP*0.15593312049918601)))*0.046462929447761363 + Dummy_4548*Dummy_4571*0.05008682322282932 + Dummy_4552*(((-Dummy_4578 + jac_affine_inv_1_0_GREEN_UP*0.18002969351036541)*(-Dummy_4578 + jac_affine_inv_1_0_GREEN_UP*0.18002969351036541)) + ((-Dummy_4579 + jac_affine_inv_1_1_GREEN_UP*0.18002969351036541)*(-Dummy_4579 + jac_affine_inv_1_1_GREEN_UP*0.18002969351036541)) + ((-Dummy_4580 + jac_affine_inv_1_2_GREEN_UP*0.18002969351036541)*(-Dummy_4580 + jac_affine_inv_1_2_GREEN_UP*0.18002969351036541)))*0.05008682322282932 + Dummy_4553*Dummy_4571*0.053182322583579168 + Dummy_4557*(((-Dummy_4581 + jac_affine_inv_1_0_GREEN_UP*0.21607642918484779)*(-Dummy_4581 + jac_affine_inv_1_0_GREEN_UP*0.21607642918484779)) + ((-Dummy_4582 + jac_affine_inv_1_1_GREEN_UP*0.21607642918484779)*(-Dummy_4582 + jac_affine_inv_1_1_GREEN_UP*0.21607642918484779)) + ((-Dummy_4583 + jac_affine_inv_1_2_GREEN_UP*0.21607642918484779)*(-Dummy_4583 + jac_affine_inv_1_2_GREEN_UP*0.21607642918484779)))*0.053182322583579168;
                const walberla::float64 Dummy_4599 = Dummy_4536*Dummy_4590*0.016934591412496779 + Dummy_4542*(((Dummy_4539 + Dummy_4559 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_67)*(Dummy_4539 + Dummy_4559 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_67)) + ((Dummy_4540 + Dummy_4560 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_67)*(Dummy_4540 + Dummy_4560 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_67)) + ((Dummy_4541 + Dummy_4561 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_67)*(Dummy_4541 + Dummy_4561 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_67)))*0.016934591412496779 + Dummy_4543*Dummy_4590*0.046462929447761363 + Dummy_4547*(((Dummy_4544 + Dummy_4562 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_68)*(Dummy_4544 + Dummy_4562 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_68)) + ((Dummy_4545 + Dummy_4563 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_68)*(Dummy_4545 + Dummy_4563 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_68)) + ((Dummy_4546 + Dummy_4564 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_68)*(Dummy_4546 + Dummy_4564 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_68)))*0.046462929447761363 + Dummy_4548*Dummy_4590*0.05008682322282932 + Dummy_4552*(((Dummy_4549 + Dummy_4565 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_69)*(Dummy_4549 + Dummy_4565 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_69)) + ((Dummy_4550 + Dummy_4566 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_69)*(Dummy_4550 + Dummy_4566 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_69)) + ((Dummy_4551 + Dummy_4567 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_69)*(Dummy_4551 + Dummy_4567 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_69)))*0.05008682322282932 + Dummy_4553*Dummy_4590*0.053182322583579168 + Dummy_4557*(((Dummy_4554 + Dummy_4568 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_70)*(Dummy_4554 + Dummy_4568 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_70)) + ((Dummy_4555 + Dummy_4569 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_70)*(Dummy_4555 + Dummy_4569 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_70)) + ((Dummy_4556 + Dummy_4570 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_70)*(Dummy_4556 + Dummy_4570 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_70)))*0.053182322583579168;
                const walberla::float64 Dummy_4600 = Dummy_4536*Dummy_4594*0.016934591412496779 + Dummy_4542*(((Dummy_4572 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_75 + jac_affine_inv_2_0_GREEN_UP*0.039933048641498423)*(Dummy_4572 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_75 + jac_affine_inv_2_0_GREEN_UP*0.039933048641498423)) + ((Dummy_4573 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_75 + jac_affine_inv_2_1_GREEN_UP*0.039933048641498423)*(Dummy_4573 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_75 + jac_affine_inv_2_1_GREEN_UP*0.039933048641498423)) + ((Dummy_4574 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_75 + jac_affine_inv_2_2_GREEN_UP*0.039933048641498423)*(Dummy_4574 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_75 + jac_affine_inv_2_2_GREEN_UP*0.039933048641498423)))*0.016934591412496779 + Dummy_4543*Dummy_4594*0.046462929447761363 + Dummy_4547*(((Dummy_4575 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_76 + jac_affine_inv_2_0_GREEN_UP*0.3817653560693467)*(Dummy_4575 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_76 + jac_affine_inv_2_0_GREEN_UP*0.3817653560693467)) + ((Dummy_4576 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_76 + jac_affine_inv_2_1_GREEN_UP*0.3817653560693467)*(Dummy_4576 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_76 + jac_affine_inv_2_1_GREEN_UP*0.3817653560693467)) + ((Dummy_4577 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_76 + jac_affine_inv_2_2_GREEN_UP*0.3817653560693467)*(Dummy_4577 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_76 + jac_affine_inv_2_2_GREEN_UP*0.3817653560693467)))*0.046462929447761363 + Dummy_4548*Dummy_4594*0.05008682322282932 + Dummy_4552*(((Dummy_4578 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_77 + jac_affine_inv_2_0_GREEN_UP*0.0069232355736274674)*(Dummy_4578 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_77 + jac_affine_inv_2_0_GREEN_UP*0.0069232355736274674)) + ((Dummy_4579 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_77 + jac_affine_inv_2_1_GREEN_UP*0.0069232355736274674)*(Dummy_4579 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_77 + jac_affine_inv_2_1_GREEN_UP*0.0069232355736274674)) + ((Dummy_4580 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_77 + jac_affine_inv_2_2_GREEN_UP*0.0069232355736274674)*(Dummy_4580 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_77 + jac_affine_inv_2_2_GREEN_UP*0.0069232355736274674)))*0.05008682322282932 + Dummy_4553*Dummy_4594*0.053182322583579168 + Dummy_4557*(((Dummy_4581 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_78 + jac_affine_inv_2_0_GREEN_UP*0.43070170707783612)*(Dummy_4581 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_78 + jac_affine_inv_2_0_GREEN_UP*0.43070170707783612)) + ((Dummy_4582 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_78 + jac_affine_inv_2_1_GREEN_UP*0.43070170707783612)*(Dummy_4582 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_78 + jac_affine_inv_2_1_GREEN_UP*0.43070170707783612)) + ((Dummy_4583 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_78 + jac_affine_inv_2_2_GREEN_UP*0.43070170707783612)*(Dummy_4583 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_78 + jac_affine_inv_2_2_GREEN_UP*0.43070170707783612)))*0.053182322583579168;
                const walberla::float64 Dummy_4601 = Dummy_4536*Dummy_4595*0.016934591412496779 + Dummy_4542*(((jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_80 + jac_affine_inv_1_0_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_0_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_80 + jac_affine_inv_1_0_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_0_GREEN_UP*0.82157254096761978)) + ((jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_80 + jac_affine_inv_1_1_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_1_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_80 + jac_affine_inv_1_1_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_1_GREEN_UP*0.82157254096761978)) + ((jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_80 + jac_affine_inv_1_2_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_2_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_80 + jac_affine_inv_1_2_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_2_GREEN_UP*0.82157254096761978)))*0.016934591412496779 + Dummy_4543*Dummy_4595*0.046462929447761363 + Dummy_4547*(((jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_81 + jac_affine_inv_1_0_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_0_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_81 + jac_affine_inv_1_0_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_0_GREEN_UP*0.15593312049918601)) + ((jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_81 + jac_affine_inv_1_1_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_1_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_81 + jac_affine_inv_1_1_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_1_GREEN_UP*0.15593312049918601)) + ((jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_81 + jac_affine_inv_1_2_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_2_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_81 + jac_affine_inv_1_2_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_2_GREEN_UP*0.15593312049918601)))*0.046462929447761363 + Dummy_4548*Dummy_4595*0.05008682322282932 + Dummy_4552*(((jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_82 + jac_affine_inv_1_0_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_0_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_82 + jac_affine_inv_1_0_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_0_GREEN_UP*0.18002969351036541)) + ((jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_82 + jac_affine_inv_1_1_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_1_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_82 + jac_affine_inv_1_1_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_1_GREEN_UP*0.18002969351036541)) + ((jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_82 + jac_affine_inv_1_2_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_2_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_82 + jac_affine_inv_1_2_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_2_GREEN_UP*0.18002969351036541)))*0.05008682322282932 + Dummy_4553*Dummy_4595*0.053182322583579168 + Dummy_4557*(((jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_83 + jac_affine_inv_1_0_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_0_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_83 + jac_affine_inv_1_0_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_0_GREEN_UP*0.21607642918484779)) + ((jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_83 + jac_affine_inv_1_1_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_1_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_83 + jac_affine_inv_1_1_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_1_GREEN_UP*0.21607642918484779)) + ((jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_83 + jac_affine_inv_1_2_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_2_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_83 + jac_affine_inv_1_2_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_2_GREEN_UP*0.21607642918484779)))*0.053182322583579168;
                {
                   {
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = Dummy_4596 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = Dummy_4597 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = Dummy_4598 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = Dummy_4599 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = Dummy_4600 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = Dummy_4601 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   }
                }
                const walberla::float64 Dummy_4602 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 Dummy_4603 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 Dummy_4604 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 Dummy_4605 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 Dummy_4606 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 Dummy_4607 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 Dummy_4608 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
                const walberla::float64 Dummy_4609 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
                const walberla::float64 Dummy_4610 = Dummy_4602*tmp_kernel_op_2 + Dummy_4603*0.82157254096761978 + Dummy_4604*0.039933048641498423 + Dummy_4605*0.01482761006242336;
                const walberla::float64 Dummy_4616 = abs_det_jac_affine_GREEN_DOWN*(Dummy_4606*tmp_kernel_op_2 + Dummy_4607*0.82157254096761978 + Dummy_4608*0.039933048641498423 + Dummy_4609*0.01482761006242336);
                const walberla::float64 Dummy_4617 = Dummy_4602*tmp_kernel_op_12 + Dummy_4603*0.15593312049918601 + Dummy_4604*0.3817653560693467 + Dummy_4605*0.0048399363458717648;
                const walberla::float64 Dummy_4621 = abs_det_jac_affine_GREEN_DOWN*(Dummy_4606*tmp_kernel_op_12 + Dummy_4607*0.15593312049918601 + Dummy_4608*0.3817653560693467 + Dummy_4609*0.0048399363458717648);
                const walberla::float64 Dummy_4622 = Dummy_4602*tmp_kernel_op_20 + Dummy_4603*0.18002969351036541 + Dummy_4604*0.0069232355736274674 + Dummy_4605*0.44773255210137269;
                const walberla::float64 Dummy_4626 = abs_det_jac_affine_GREEN_DOWN*(Dummy_4606*tmp_kernel_op_20 + Dummy_4607*0.18002969351036541 + Dummy_4608*0.0069232355736274674 + Dummy_4609*0.44773255210137269);
                const walberla::float64 Dummy_4627 = Dummy_4602*tmp_kernel_op_28 + Dummy_4603*0.21607642918484779 + Dummy_4604*0.43070170707783612 + Dummy_4605*0.35284634870858678;
                const walberla::float64 Dummy_4631 = abs_det_jac_affine_GREEN_DOWN*(Dummy_4606*tmp_kernel_op_28 + Dummy_4607*0.21607642918484779 + Dummy_4608*0.43070170707783612 + Dummy_4609*0.35284634870858678);
                const walberla::float64 Dummy_4670 = Dummy_4610*Dummy_4612*0.016934591412496779 + Dummy_4612*Dummy_4617*0.046462929447761363 + Dummy_4612*Dummy_4622*0.05008682322282932 + Dummy_4612*Dummy_4627*0.053182322583579168 + Dummy_4616*(((-Dummy_4613 + jac_affine_inv_2_0_GREEN_DOWN*0.039933048641498423)*(-Dummy_4613 + jac_affine_inv_2_0_GREEN_DOWN*0.039933048641498423)) + ((-Dummy_4614 + jac_affine_inv_2_1_GREEN_DOWN*0.039933048641498423)*(-Dummy_4614 + jac_affine_inv_2_1_GREEN_DOWN*0.039933048641498423)) + ((-Dummy_4615 + jac_affine_inv_2_2_GREEN_DOWN*0.039933048641498423)*(-Dummy_4615 + jac_affine_inv_2_2_GREEN_DOWN*0.039933048641498423)))*0.016934591412496779 + Dummy_4621*(((-Dummy_4618 + jac_affine_inv_2_0_GREEN_DOWN*0.3817653560693467)*(-Dummy_4618 + jac_affine_inv_2_0_GREEN_DOWN*0.3817653560693467)) + ((-Dummy_4619 + jac_affine_inv_2_1_GREEN_DOWN*0.3817653560693467)*(-Dummy_4619 + jac_affine_inv_2_1_GREEN_DOWN*0.3817653560693467)) + ((-Dummy_4620 + jac_affine_inv_2_2_GREEN_DOWN*0.3817653560693467)*(-Dummy_4620 + jac_affine_inv_2_2_GREEN_DOWN*0.3817653560693467)))*0.046462929447761363 + Dummy_4626*(((-Dummy_4623 + jac_affine_inv_2_0_GREEN_DOWN*0.0069232355736274674)*(-Dummy_4623 + jac_affine_inv_2_0_GREEN_DOWN*0.0069232355736274674)) + ((-Dummy_4624 + jac_affine_inv_2_1_GREEN_DOWN*0.0069232355736274674)*(-Dummy_4624 + jac_affine_inv_2_1_GREEN_DOWN*0.0069232355736274674)) + ((-Dummy_4625 + jac_affine_inv_2_2_GREEN_DOWN*0.0069232355736274674)*(-Dummy_4625 + jac_affine_inv_2_2_GREEN_DOWN*0.0069232355736274674)))*0.05008682322282932 + Dummy_4631*(((-Dummy_4628 + jac_affine_inv_2_0_GREEN_DOWN*0.43070170707783612)*(-Dummy_4628 + jac_affine_inv_2_0_GREEN_DOWN*0.43070170707783612)) + ((-Dummy_4629 + jac_affine_inv_2_1_GREEN_DOWN*0.43070170707783612)*(-Dummy_4629 + jac_affine_inv_2_1_GREEN_DOWN*0.43070170707783612)) + ((-Dummy_4630 + jac_affine_inv_2_2_GREEN_DOWN*0.43070170707783612)*(-Dummy_4630 + jac_affine_inv_2_2_GREEN_DOWN*0.43070170707783612)))*0.053182322583579168;
                const walberla::float64 Dummy_4671 = Dummy_4610*Dummy_4632*0.016934591412496779 + Dummy_4616*(((-Dummy_4633 + jac_affine_inv_2_0_GREEN_DOWN*0.82157254096761978)*(-Dummy_4633 + jac_affine_inv_2_0_GREEN_DOWN*0.82157254096761978)) + ((-Dummy_4634 + jac_affine_inv_2_1_GREEN_DOWN*0.82157254096761978)*(-Dummy_4634 + jac_affine_inv_2_1_GREEN_DOWN*0.82157254096761978)) + ((-Dummy_4635 + jac_affine_inv_2_2_GREEN_DOWN*0.82157254096761978)*(-Dummy_4635 + jac_affine_inv_2_2_GREEN_DOWN*0.82157254096761978)))*0.016934591412496779 + Dummy_4617*Dummy_4632*0.046462929447761363 + Dummy_4621*(((-Dummy_4636 + jac_affine_inv_2_0_GREEN_DOWN*0.15593312049918601)*(-Dummy_4636 + jac_affine_inv_2_0_GREEN_DOWN*0.15593312049918601)) + ((-Dummy_4637 + jac_affine_inv_2_1_GREEN_DOWN*0.15593312049918601)*(-Dummy_4637 + jac_affine_inv_2_1_GREEN_DOWN*0.15593312049918601)) + ((-Dummy_4638 + jac_affine_inv_2_2_GREEN_DOWN*0.15593312049918601)*(-Dummy_4638 + jac_affine_inv_2_2_GREEN_DOWN*0.15593312049918601)))*0.046462929447761363 + Dummy_4622*Dummy_4632*0.05008682322282932 + Dummy_4626*(((-Dummy_4639 + jac_affine_inv_2_0_GREEN_DOWN*0.18002969351036541)*(-Dummy_4639 + jac_affine_inv_2_0_GREEN_DOWN*0.18002969351036541)) + ((-Dummy_4640 + jac_affine_inv_2_1_GREEN_DOWN*0.18002969351036541)*(-Dummy_4640 + jac_affine_inv_2_1_GREEN_DOWN*0.18002969351036541)) + ((-Dummy_4641 + jac_affine_inv_2_2_GREEN_DOWN*0.18002969351036541)*(-Dummy_4641 + jac_affine_inv_2_2_GREEN_DOWN*0.18002969351036541)))*0.05008682322282932 + Dummy_4627*Dummy_4632*0.053182322583579168 + Dummy_4631*(((-Dummy_4642 + jac_affine_inv_2_0_GREEN_DOWN*0.21607642918484779)*(-Dummy_4642 + jac_affine_inv_2_0_GREEN_DOWN*0.21607642918484779)) + ((-Dummy_4643 + jac_affine_inv_2_1_GREEN_DOWN*0.21607642918484779)*(-Dummy_4643 + jac_affine_inv_2_1_GREEN_DOWN*0.21607642918484779)) + ((-Dummy_4644 + jac_affine_inv_2_2_GREEN_DOWN*0.21607642918484779)*(-Dummy_4644 + jac_affine_inv_2_2_GREEN_DOWN*0.21607642918484779)))*0.053182322583579168;
                const walberla::float64 Dummy_4672 = Dummy_4610*Dummy_4645*0.016934591412496779 + Dummy_4616*(((-Dummy_4646 + jac_affine_inv_1_0_GREEN_DOWN*0.82157254096761978)*(-Dummy_4646 + jac_affine_inv_1_0_GREEN_DOWN*0.82157254096761978)) + ((-Dummy_4647 + jac_affine_inv_1_1_GREEN_DOWN*0.82157254096761978)*(-Dummy_4647 + jac_affine_inv_1_1_GREEN_DOWN*0.82157254096761978)) + ((-Dummy_4648 + jac_affine_inv_1_2_GREEN_DOWN*0.82157254096761978)*(-Dummy_4648 + jac_affine_inv_1_2_GREEN_DOWN*0.82157254096761978)))*0.016934591412496779 + Dummy_4617*Dummy_4645*0.046462929447761363 + Dummy_4621*(((-Dummy_4649 + jac_affine_inv_1_0_GREEN_DOWN*0.15593312049918601)*(-Dummy_4649 + jac_affine_inv_1_0_GREEN_DOWN*0.15593312049918601)) + ((-Dummy_4650 + jac_affine_inv_1_1_GREEN_DOWN*0.15593312049918601)*(-Dummy_4650 + jac_affine_inv_1_1_GREEN_DOWN*0.15593312049918601)) + ((-Dummy_4651 + jac_affine_inv_1_2_GREEN_DOWN*0.15593312049918601)*(-Dummy_4651 + jac_affine_inv_1_2_GREEN_DOWN*0.15593312049918601)))*0.046462929447761363 + Dummy_4622*Dummy_4645*0.05008682322282932 + Dummy_4626*(((-Dummy_4652 + jac_affine_inv_1_0_GREEN_DOWN*0.18002969351036541)*(-Dummy_4652 + jac_affine_inv_1_0_GREEN_DOWN*0.18002969351036541)) + ((-Dummy_4653 + jac_affine_inv_1_1_GREEN_DOWN*0.18002969351036541)*(-Dummy_4653 + jac_affine_inv_1_1_GREEN_DOWN*0.18002969351036541)) + ((-Dummy_4654 + jac_affine_inv_1_2_GREEN_DOWN*0.18002969351036541)*(-Dummy_4654 + jac_affine_inv_1_2_GREEN_DOWN*0.18002969351036541)))*0.05008682322282932 + Dummy_4627*Dummy_4645*0.053182322583579168 + Dummy_4631*(((-Dummy_4655 + jac_affine_inv_1_0_GREEN_DOWN*0.21607642918484779)*(-Dummy_4655 + jac_affine_inv_1_0_GREEN_DOWN*0.21607642918484779)) + ((-Dummy_4656 + jac_affine_inv_1_1_GREEN_DOWN*0.21607642918484779)*(-Dummy_4656 + jac_affine_inv_1_1_GREEN_DOWN*0.21607642918484779)) + ((-Dummy_4657 + jac_affine_inv_1_2_GREEN_DOWN*0.21607642918484779)*(-Dummy_4657 + jac_affine_inv_1_2_GREEN_DOWN*0.21607642918484779)))*0.053182322583579168;
                const walberla::float64 Dummy_4673 = Dummy_4610*Dummy_4664*0.016934591412496779 + Dummy_4616*(((Dummy_4613 + Dummy_4633 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_67)*(Dummy_4613 + Dummy_4633 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_67)) + ((Dummy_4614 + Dummy_4634 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_67)*(Dummy_4614 + Dummy_4634 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_67)) + ((Dummy_4615 + Dummy_4635 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_67)*(Dummy_4615 + Dummy_4635 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_67)))*0.016934591412496779 + Dummy_4617*Dummy_4664*0.046462929447761363 + Dummy_4621*(((Dummy_4618 + Dummy_4636 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_68)*(Dummy_4618 + Dummy_4636 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_68)) + ((Dummy_4619 + Dummy_4637 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_68)*(Dummy_4619 + Dummy_4637 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_68)) + ((Dummy_4620 + Dummy_4638 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_68)*(Dummy_4620 + Dummy_4638 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_68)))*0.046462929447761363 + Dummy_4622*Dummy_4664*0.05008682322282932 + Dummy_4626*(((Dummy_4623 + Dummy_4639 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_69)*(Dummy_4623 + Dummy_4639 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_69)) + ((Dummy_4624 + Dummy_4640 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_69)*(Dummy_4624 + Dummy_4640 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_69)) + ((Dummy_4625 + Dummy_4641 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_69)*(Dummy_4625 + Dummy_4641 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_69)))*0.05008682322282932 + Dummy_4627*Dummy_4664*0.053182322583579168 + Dummy_4631*(((Dummy_4628 + Dummy_4642 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_70)*(Dummy_4628 + Dummy_4642 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_70)) + ((Dummy_4629 + Dummy_4643 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_70)*(Dummy_4629 + Dummy_4643 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_70)) + ((Dummy_4630 + Dummy_4644 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_70)*(Dummy_4630 + Dummy_4644 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_70)))*0.053182322583579168;
                const walberla::float64 Dummy_4674 = Dummy_4610*Dummy_4668*0.016934591412496779 + Dummy_4616*(((Dummy_4646 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_0_GREEN_DOWN*0.039933048641498423)*(Dummy_4646 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_0_GREEN_DOWN*0.039933048641498423)) + ((Dummy_4647 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_1_GREEN_DOWN*0.039933048641498423)*(Dummy_4647 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_1_GREEN_DOWN*0.039933048641498423)) + ((Dummy_4648 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_2_GREEN_DOWN*0.039933048641498423)*(Dummy_4648 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_2_GREEN_DOWN*0.039933048641498423)))*0.016934591412496779 + Dummy_4617*Dummy_4668*0.046462929447761363 + Dummy_4621*(((Dummy_4649 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_0_GREEN_DOWN*0.3817653560693467)*(Dummy_4649 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_0_GREEN_DOWN*0.3817653560693467)) + ((Dummy_4650 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_1_GREEN_DOWN*0.3817653560693467)*(Dummy_4650 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_1_GREEN_DOWN*0.3817653560693467)) + ((Dummy_4651 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_2_GREEN_DOWN*0.3817653560693467)*(Dummy_4651 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_2_GREEN_DOWN*0.3817653560693467)))*0.046462929447761363 + Dummy_4622*Dummy_4668*0.05008682322282932 + Dummy_4626*(((Dummy_4652 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_0_GREEN_DOWN*0.0069232355736274674)*(Dummy_4652 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_0_GREEN_DOWN*0.0069232355736274674)) + ((Dummy_4653 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_1_GREEN_DOWN*0.0069232355736274674)*(Dummy_4653 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_1_GREEN_DOWN*0.0069232355736274674)) + ((Dummy_4654 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_2_GREEN_DOWN*0.0069232355736274674)*(Dummy_4654 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_2_GREEN_DOWN*0.0069232355736274674)))*0.05008682322282932 + Dummy_4627*Dummy_4668*0.053182322583579168 + Dummy_4631*(((Dummy_4655 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_0_GREEN_DOWN*0.43070170707783612)*(Dummy_4655 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_0_GREEN_DOWN*0.43070170707783612)) + ((Dummy_4656 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_1_GREEN_DOWN*0.43070170707783612)*(Dummy_4656 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_1_GREEN_DOWN*0.43070170707783612)) + ((Dummy_4657 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_2_GREEN_DOWN*0.43070170707783612)*(Dummy_4657 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_2_GREEN_DOWN*0.43070170707783612)))*0.053182322583579168;
                const walberla::float64 Dummy_4675 = Dummy_4610*Dummy_4669*0.016934591412496779 + Dummy_4616*(((jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_0_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_0_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_0_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_0_GREEN_DOWN*0.82157254096761978)) + ((jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_1_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_1_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_1_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_1_GREEN_DOWN*0.82157254096761978)) + ((jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_2_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_2_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_2_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_2_GREEN_DOWN*0.82157254096761978)))*0.016934591412496779 + Dummy_4617*Dummy_4669*0.046462929447761363 + Dummy_4621*(((jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_0_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_0_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_0_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_0_GREEN_DOWN*0.15593312049918601)) + ((jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_1_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_1_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_1_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_1_GREEN_DOWN*0.15593312049918601)) + ((jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_2_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_2_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_2_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_2_GREEN_DOWN*0.15593312049918601)))*0.046462929447761363 + Dummy_4622*Dummy_4669*0.05008682322282932 + Dummy_4626*(((jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_0_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_0_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_0_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_0_GREEN_DOWN*0.18002969351036541)) + ((jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_1_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_1_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_1_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_1_GREEN_DOWN*0.18002969351036541)) + ((jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_2_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_2_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_2_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_2_GREEN_DOWN*0.18002969351036541)))*0.05008682322282932 + Dummy_4627*Dummy_4669*0.053182322583579168 + Dummy_4631*(((jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_0_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_0_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_0_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_0_GREEN_DOWN*0.21607642918484779)) + ((jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_1_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_1_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_1_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_1_GREEN_DOWN*0.21607642918484779)) + ((jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_2_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_2_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_2_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_2_GREEN_DOWN*0.21607642918484779)))*0.053182322583579168;
                {
                   {
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = Dummy_4670 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                      _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = Dummy_4671 + _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1] = Dummy_4672 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
                      _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = Dummy_4673 + _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                      _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))] = Dummy_4674 + _data_invDiag_[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
                      _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))] = Dummy_4675 + _data_invDiag_[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
                   }
                }
             }
          }
          if (-ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2 >= 0)
          {
             const walberla::float64 alpha_dof_0 = _data_alpha[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const walberla::float64 alpha_dof_1 = _data_alpha[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const walberla::float64 alpha_dof_2 = _data_alpha[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const walberla::float64 alpha_dof_3 = _data_alpha[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const walberla::float64 beta_dof_0 = _data_beta[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const walberla::float64 beta_dof_1 = _data_beta[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const walberla::float64 beta_dof_2 = _data_beta[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const walberla::float64 beta_dof_3 = _data_beta[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const walberla::float64 tmp_kernel_op_0 = -0.17842745903238022;
             const walberla::float64 tmp_kernel_op_1 = tmp_kernel_op_0 + 0.039933048641498423;
             const walberla::float64 tmp_kernel_op_2 = -tmp_kernel_op_1 - 0.01482761006242336;
             const walberla::float64 tmp_kernel_op_3 = alpha_dof_0*tmp_kernel_op_2 + alpha_dof_1*0.82157254096761978 + alpha_dof_2*0.039933048641498423 + alpha_dof_3*0.01482761006242336;
             const walberla::float64 tmp_kernel_op_4 = 1.0 / (abs_det_jac_affine_WHITE_UP);
             const walberla::float64 tmp_kernel_op_5 = tmp_kernel_op_4*((jac_affine_0_0_WHITE_UP*jac_affine_0_0_WHITE_UP)*4.0 + (jac_affine_1_0_WHITE_UP*jac_affine_1_0_WHITE_UP)*4.0 + (jac_affine_2_0_WHITE_UP*jac_affine_2_0_WHITE_UP)*4.0);
             const walberla::float64 tmp_kernel_op_6 = jac_affine_inv_1_0_WHITE_UP*0.01482761006242336;
             const walberla::float64 tmp_kernel_op_7 = jac_affine_inv_1_1_WHITE_UP*0.01482761006242336;
             const walberla::float64 tmp_kernel_op_8 = jac_affine_inv_1_2_WHITE_UP*0.01482761006242336;
             const walberla::float64 tmp_kernel_op_9 = abs_det_jac_affine_WHITE_UP*(beta_dof_0*tmp_kernel_op_2 + beta_dof_1*0.82157254096761978 + beta_dof_2*0.039933048641498423 + beta_dof_3*0.01482761006242336);
             const walberla::float64 tmp_kernel_op_10 = -0.84406687950081394;
             const walberla::float64 tmp_kernel_op_11 = tmp_kernel_op_10 + 0.3817653560693467;
             const walberla::float64 tmp_kernel_op_12 = -tmp_kernel_op_11 - 0.0048399363458717648;
             const walberla::float64 tmp_kernel_op_13 = alpha_dof_0*tmp_kernel_op_12 + alpha_dof_1*0.15593312049918601 + alpha_dof_2*0.3817653560693467 + alpha_dof_3*0.0048399363458717648;
             const walberla::float64 tmp_kernel_op_14 = jac_affine_inv_1_0_WHITE_UP*0.0048399363458717648;
             const walberla::float64 tmp_kernel_op_15 = jac_affine_inv_1_1_WHITE_UP*0.0048399363458717648;
             const walberla::float64 tmp_kernel_op_16 = jac_affine_inv_1_2_WHITE_UP*0.0048399363458717648;
             const walberla::float64 tmp_kernel_op_17 = abs_det_jac_affine_WHITE_UP*(beta_dof_0*tmp_kernel_op_12 + beta_dof_1*0.15593312049918601 + beta_dof_2*0.3817653560693467 + beta_dof_3*0.0048399363458717648);
             const walberla::float64 tmp_kernel_op_18 = -0.81997030648963465;
             const walberla::float64 tmp_kernel_op_19 = tmp_kernel_op_18 + 0.0069232355736274674;
             const walberla::float64 tmp_kernel_op_20 = -tmp_kernel_op_19 - 0.44773255210137269;
             const walberla::float64 tmp_kernel_op_21 = alpha_dof_0*tmp_kernel_op_20 + alpha_dof_1*0.18002969351036541 + alpha_dof_2*0.0069232355736274674 + alpha_dof_3*0.44773255210137269;
             const walberla::float64 tmp_kernel_op_22 = jac_affine_inv_1_0_WHITE_UP*0.44773255210137269;
             const walberla::float64 tmp_kernel_op_23 = jac_affine_inv_1_1_WHITE_UP*0.44773255210137269;
             const walberla::float64 tmp_kernel_op_24 = jac_affine_inv_1_2_WHITE_UP*0.44773255210137269;
             const walberla::float64 tmp_kernel_op_25 = abs_det_jac_affine_WHITE_UP*(beta_dof_0*tmp_kernel_op_20 + beta_dof_1*0.18002969351036541 + beta_dof_2*0.0069232355736274674 + beta_dof_3*0.44773255210137269);
             const walberla::float64 tmp_kernel_op_26 = -0.78392357081515218;
             const walberla::float64 tmp_kernel_op_27 = tmp_kernel_op_26 + 0.43070170707783612;
             const walberla::float64 tmp_kernel_op_28 = -tmp_kernel_op_27 - 0.35284634870858678;
             const walberla::float64 tmp_kernel_op_29 = alpha_dof_0*tmp_kernel_op_28 + alpha_dof_1*0.21607642918484779 + alpha_dof_2*0.43070170707783612 + alpha_dof_3*0.35284634870858678;
             const walberla::float64 tmp_kernel_op_30 = jac_affine_inv_1_0_WHITE_UP*0.35284634870858678;
             const walberla::float64 tmp_kernel_op_31 = jac_affine_inv_1_1_WHITE_UP*0.35284634870858678;
             const walberla::float64 tmp_kernel_op_32 = jac_affine_inv_1_2_WHITE_UP*0.35284634870858678;
             const walberla::float64 tmp_kernel_op_33 = abs_det_jac_affine_WHITE_UP*(beta_dof_0*tmp_kernel_op_28 + beta_dof_1*0.21607642918484779 + beta_dof_2*0.43070170707783612 + beta_dof_3*0.35284634870858678);
             const walberla::float64 tmp_kernel_op_34 = tmp_kernel_op_4*((jac_affine_0_1_WHITE_UP*jac_affine_0_1_WHITE_UP)*4.0 + (jac_affine_1_1_WHITE_UP*jac_affine_1_1_WHITE_UP)*4.0 + (jac_affine_2_1_WHITE_UP*jac_affine_2_1_WHITE_UP)*4.0);
             const walberla::float64 tmp_kernel_op_35 = jac_affine_inv_0_0_WHITE_UP*0.01482761006242336;
             const walberla::float64 tmp_kernel_op_36 = jac_affine_inv_0_1_WHITE_UP*0.01482761006242336;
             const walberla::float64 tmp_kernel_op_37 = jac_affine_inv_0_2_WHITE_UP*0.01482761006242336;
             const walberla::float64 tmp_kernel_op_38 = jac_affine_inv_0_0_WHITE_UP*0.0048399363458717648;
             const walberla::float64 tmp_kernel_op_39 = jac_affine_inv_0_1_WHITE_UP*0.0048399363458717648;
             const walberla::float64 tmp_kernel_op_40 = jac_affine_inv_0_2_WHITE_UP*0.0048399363458717648;
             const walberla::float64 tmp_kernel_op_41 = jac_affine_inv_0_0_WHITE_UP*0.44773255210137269;
             const walberla::float64 tmp_kernel_op_42 = jac_affine_inv_0_1_WHITE_UP*0.44773255210137269;
             const walberla::float64 tmp_kernel_op_43 = jac_affine_inv_0_2_WHITE_UP*0.44773255210137269;
             const walberla::float64 tmp_kernel_op_44 = jac_affine_inv_0_0_WHITE_UP*0.35284634870858678;
             const walberla::float64 tmp_kernel_op_45 = jac_affine_inv_0_1_WHITE_UP*0.35284634870858678;
             const walberla::float64 tmp_kernel_op_46 = jac_affine_inv_0_2_WHITE_UP*0.35284634870858678;
             const walberla::float64 tmp_kernel_op_47 = tmp_kernel_op_4*((jac_affine_0_2_WHITE_UP*jac_affine_0_2_WHITE_UP)*4.0 + (jac_affine_1_2_WHITE_UP*jac_affine_1_2_WHITE_UP)*4.0 + (jac_affine_2_2_WHITE_UP*jac_affine_2_2_WHITE_UP)*4.0);
             const walberla::float64 tmp_kernel_op_48 = jac_affine_inv_0_0_WHITE_UP*0.039933048641498423;
             const walberla::float64 tmp_kernel_op_49 = jac_affine_inv_0_1_WHITE_UP*0.039933048641498423;
             const walberla::float64 tmp_kernel_op_50 = jac_affine_inv_0_2_WHITE_UP*0.039933048641498423;
             const walberla::float64 tmp_kernel_op_51 = jac_affine_inv_0_0_WHITE_UP*0.3817653560693467;
             const walberla::float64 tmp_kernel_op_52 = jac_affine_inv_0_1_WHITE_UP*0.3817653560693467;
             const walberla::float64 tmp_kernel_op_53 = jac_affine_inv_0_2_WHITE_UP*0.3817653560693467;
             const walberla::float64 tmp_kernel_op_54 = jac_affine_inv_0_0_WHITE_UP*0.0069232355736274674;
             const walberla::float64 tmp_kernel_op_55 = jac_affine_inv_0_1_WHITE_UP*0.0069232355736274674;
             const walberla::float64 tmp_kernel_op_56 = jac_affine_inv_0_2_WHITE_UP*0.0069232355736274674;
             const walberla::float64 tmp_kernel_op_57 = jac_affine_inv_0_0_WHITE_UP*0.43070170707783612;
             const walberla::float64 tmp_kernel_op_58 = jac_affine_inv_0_1_WHITE_UP*0.43070170707783612;
             const walberla::float64 tmp_kernel_op_59 = jac_affine_inv_0_2_WHITE_UP*0.43070170707783612;
             const walberla::float64 tmp_kernel_op_60 = jac_affine_0_0_WHITE_UP*2.0;
             const walberla::float64 tmp_kernel_op_61 = jac_affine_0_1_WHITE_UP*2.0;
             const walberla::float64 tmp_kernel_op_62 = jac_affine_1_0_WHITE_UP*2.0;
             const walberla::float64 tmp_kernel_op_63 = jac_affine_1_1_WHITE_UP*2.0;
             const walberla::float64 tmp_kernel_op_64 = jac_affine_2_0_WHITE_UP*2.0;
             const walberla::float64 tmp_kernel_op_65 = jac_affine_2_1_WHITE_UP*2.0;
             const walberla::float64 tmp_kernel_op_66 = tmp_kernel_op_4*(((-tmp_kernel_op_60 + tmp_kernel_op_61)*(-tmp_kernel_op_60 + tmp_kernel_op_61)) + ((-tmp_kernel_op_62 + tmp_kernel_op_63)*(-tmp_kernel_op_62 + tmp_kernel_op_63)) + ((-tmp_kernel_op_64 + tmp_kernel_op_65)*(-tmp_kernel_op_64 + tmp_kernel_op_65)));
             const walberla::float64 tmp_kernel_op_67 = -tmp_kernel_op_1;
             const walberla::float64 tmp_kernel_op_68 = -tmp_kernel_op_11;
             const walberla::float64 tmp_kernel_op_69 = -tmp_kernel_op_19;
             const walberla::float64 tmp_kernel_op_70 = -tmp_kernel_op_27;
             const walberla::float64 tmp_kernel_op_71 = jac_affine_0_2_WHITE_UP*-2.0;
             const walberla::float64 tmp_kernel_op_72 = jac_affine_1_2_WHITE_UP*-2.0;
             const walberla::float64 tmp_kernel_op_73 = jac_affine_2_2_WHITE_UP*-2.0;
             const walberla::float64 tmp_kernel_op_74 = tmp_kernel_op_4*(((tmp_kernel_op_60 + tmp_kernel_op_71)*(tmp_kernel_op_60 + tmp_kernel_op_71)) + ((tmp_kernel_op_62 + tmp_kernel_op_72)*(tmp_kernel_op_62 + tmp_kernel_op_72)) + ((tmp_kernel_op_64 + tmp_kernel_op_73)*(tmp_kernel_op_64 + tmp_kernel_op_73)));
             const walberla::float64 tmp_kernel_op_75 = -tmp_kernel_op_0 - 0.01482761006242336;
             const walberla::float64 tmp_kernel_op_76 = -tmp_kernel_op_10 - 0.0048399363458717648;
             const walberla::float64 tmp_kernel_op_77 = -tmp_kernel_op_18 - 0.44773255210137269;
             const walberla::float64 tmp_kernel_op_78 = -tmp_kernel_op_26 - 0.35284634870858678;
             const walberla::float64 tmp_kernel_op_79 = tmp_kernel_op_4*(((-tmp_kernel_op_61 - tmp_kernel_op_71)*(-tmp_kernel_op_61 - tmp_kernel_op_71)) + ((-tmp_kernel_op_63 - tmp_kernel_op_72)*(-tmp_kernel_op_63 - tmp_kernel_op_72)) + ((-tmp_kernel_op_65 - tmp_kernel_op_73)*(-tmp_kernel_op_65 - tmp_kernel_op_73)));
             const walberla::float64 tmp_kernel_op_80 = 0.94523934129607823;
             const walberla::float64 tmp_kernel_op_81 = 0.61339470758478154;
             const walberla::float64 tmp_kernel_op_82 = 0.54534421232499986;
             const walberla::float64 tmp_kernel_op_83 = 0.21645194421357716;
             const walberla::float64 elMatDiag_0 = tmp_kernel_op_13*tmp_kernel_op_5*0.046462929447761363 + tmp_kernel_op_17*(((jac_affine_inv_2_0_WHITE_UP*0.3817653560693467 - tmp_kernel_op_14)*(jac_affine_inv_2_0_WHITE_UP*0.3817653560693467 - tmp_kernel_op_14)) + ((jac_affine_inv_2_1_WHITE_UP*0.3817653560693467 - tmp_kernel_op_15)*(jac_affine_inv_2_1_WHITE_UP*0.3817653560693467 - tmp_kernel_op_15)) + ((jac_affine_inv_2_2_WHITE_UP*0.3817653560693467 - tmp_kernel_op_16)*(jac_affine_inv_2_2_WHITE_UP*0.3817653560693467 - tmp_kernel_op_16)))*0.046462929447761363 + tmp_kernel_op_21*tmp_kernel_op_5*0.05008682322282932 + tmp_kernel_op_25*(((jac_affine_inv_2_0_WHITE_UP*0.0069232355736274674 - tmp_kernel_op_22)*(jac_affine_inv_2_0_WHITE_UP*0.0069232355736274674 - tmp_kernel_op_22)) + ((jac_affine_inv_2_1_WHITE_UP*0.0069232355736274674 - tmp_kernel_op_23)*(jac_affine_inv_2_1_WHITE_UP*0.0069232355736274674 - tmp_kernel_op_23)) + ((jac_affine_inv_2_2_WHITE_UP*0.0069232355736274674 - tmp_kernel_op_24)*(jac_affine_inv_2_2_WHITE_UP*0.0069232355736274674 - tmp_kernel_op_24)))*0.05008682322282932 + tmp_kernel_op_29*tmp_kernel_op_5*0.053182322583579168 + tmp_kernel_op_3*tmp_kernel_op_5*0.016934591412496779 + tmp_kernel_op_33*(((jac_affine_inv_2_0_WHITE_UP*0.43070170707783612 - tmp_kernel_op_30)*(jac_affine_inv_2_0_WHITE_UP*0.43070170707783612 - tmp_kernel_op_30)) + ((jac_affine_inv_2_1_WHITE_UP*0.43070170707783612 - tmp_kernel_op_31)*(jac_affine_inv_2_1_WHITE_UP*0.43070170707783612 - tmp_kernel_op_31)) + ((jac_affine_inv_2_2_WHITE_UP*0.43070170707783612 - tmp_kernel_op_32)*(jac_affine_inv_2_2_WHITE_UP*0.43070170707783612 - tmp_kernel_op_32)))*0.053182322583579168 + tmp_kernel_op_9*(((jac_affine_inv_2_0_WHITE_UP*0.039933048641498423 - tmp_kernel_op_6)*(jac_affine_inv_2_0_WHITE_UP*0.039933048641498423 - tmp_kernel_op_6)) + ((jac_affine_inv_2_1_WHITE_UP*0.039933048641498423 - tmp_kernel_op_7)*(jac_affine_inv_2_1_WHITE_UP*0.039933048641498423 - tmp_kernel_op_7)) + ((jac_affine_inv_2_2_WHITE_UP*0.039933048641498423 - tmp_kernel_op_8)*(jac_affine_inv_2_2_WHITE_UP*0.039933048641498423 - tmp_kernel_op_8)))*0.016934591412496779;
             const walberla::float64 elMatDiag_1 = tmp_kernel_op_13*tmp_kernel_op_34*0.046462929447761363 + tmp_kernel_op_17*(((jac_affine_inv_2_0_WHITE_UP*0.15593312049918601 - tmp_kernel_op_38)*(jac_affine_inv_2_0_WHITE_UP*0.15593312049918601 - tmp_kernel_op_38)) + ((jac_affine_inv_2_1_WHITE_UP*0.15593312049918601 - tmp_kernel_op_39)*(jac_affine_inv_2_1_WHITE_UP*0.15593312049918601 - tmp_kernel_op_39)) + ((jac_affine_inv_2_2_WHITE_UP*0.15593312049918601 - tmp_kernel_op_40)*(jac_affine_inv_2_2_WHITE_UP*0.15593312049918601 - tmp_kernel_op_40)))*0.046462929447761363 + tmp_kernel_op_21*tmp_kernel_op_34*0.05008682322282932 + tmp_kernel_op_25*(((jac_affine_inv_2_0_WHITE_UP*0.18002969351036541 - tmp_kernel_op_41)*(jac_affine_inv_2_0_WHITE_UP*0.18002969351036541 - tmp_kernel_op_41)) + ((jac_affine_inv_2_1_WHITE_UP*0.18002969351036541 - tmp_kernel_op_42)*(jac_affine_inv_2_1_WHITE_UP*0.18002969351036541 - tmp_kernel_op_42)) + ((jac_affine_inv_2_2_WHITE_UP*0.18002969351036541 - tmp_kernel_op_43)*(jac_affine_inv_2_2_WHITE_UP*0.18002969351036541 - tmp_kernel_op_43)))*0.05008682322282932 + tmp_kernel_op_29*tmp_kernel_op_34*0.053182322583579168 + tmp_kernel_op_3*tmp_kernel_op_34*0.016934591412496779 + tmp_kernel_op_33*(((jac_affine_inv_2_0_WHITE_UP*0.21607642918484779 - tmp_kernel_op_44)*(jac_affine_inv_2_0_WHITE_UP*0.21607642918484779 - tmp_kernel_op_44)) + ((jac_affine_inv_2_1_WHITE_UP*0.21607642918484779 - tmp_kernel_op_45)*(jac_affine_inv_2_1_WHITE_UP*0.21607642918484779 - tmp_kernel_op_45)) + ((jac_affine_inv_2_2_WHITE_UP*0.21607642918484779 - tmp_kernel_op_46)*(jac_affine_inv_2_2_WHITE_UP*0.21607642918484779 - tmp_kernel_op_46)))*0.053182322583579168 + tmp_kernel_op_9*(((jac_affine_inv_2_0_WHITE_UP*0.82157254096761978 - tmp_kernel_op_35)*(jac_affine_inv_2_0_WHITE_UP*0.82157254096761978 - tmp_kernel_op_35)) + ((jac_affine_inv_2_1_WHITE_UP*0.82157254096761978 - tmp_kernel_op_36)*(jac_affine_inv_2_1_WHITE_UP*0.82157254096761978 - tmp_kernel_op_36)) + ((jac_affine_inv_2_2_WHITE_UP*0.82157254096761978 - tmp_kernel_op_37)*(jac_affine_inv_2_2_WHITE_UP*0.82157254096761978 - tmp_kernel_op_37)))*0.016934591412496779;
             const walberla::float64 elMatDiag_2 = tmp_kernel_op_13*tmp_kernel_op_47*0.046462929447761363 + tmp_kernel_op_17*(((jac_affine_inv_1_0_WHITE_UP*0.15593312049918601 - tmp_kernel_op_51)*(jac_affine_inv_1_0_WHITE_UP*0.15593312049918601 - tmp_kernel_op_51)) + ((jac_affine_inv_1_1_WHITE_UP*0.15593312049918601 - tmp_kernel_op_52)*(jac_affine_inv_1_1_WHITE_UP*0.15593312049918601 - tmp_kernel_op_52)) + ((jac_affine_inv_1_2_WHITE_UP*0.15593312049918601 - tmp_kernel_op_53)*(jac_affine_inv_1_2_WHITE_UP*0.15593312049918601 - tmp_kernel_op_53)))*0.046462929447761363 + tmp_kernel_op_21*tmp_kernel_op_47*0.05008682322282932 + tmp_kernel_op_25*(((jac_affine_inv_1_0_WHITE_UP*0.18002969351036541 - tmp_kernel_op_54)*(jac_affine_inv_1_0_WHITE_UP*0.18002969351036541 - tmp_kernel_op_54)) + ((jac_affine_inv_1_1_WHITE_UP*0.18002969351036541 - tmp_kernel_op_55)*(jac_affine_inv_1_1_WHITE_UP*0.18002969351036541 - tmp_kernel_op_55)) + ((jac_affine_inv_1_2_WHITE_UP*0.18002969351036541 - tmp_kernel_op_56)*(jac_affine_inv_1_2_WHITE_UP*0.18002969351036541 - tmp_kernel_op_56)))*0.05008682322282932 + tmp_kernel_op_29*tmp_kernel_op_47*0.053182322583579168 + tmp_kernel_op_3*tmp_kernel_op_47*0.016934591412496779 + tmp_kernel_op_33*(((jac_affine_inv_1_0_WHITE_UP*0.21607642918484779 - tmp_kernel_op_57)*(jac_affine_inv_1_0_WHITE_UP*0.21607642918484779 - tmp_kernel_op_57)) + ((jac_affine_inv_1_1_WHITE_UP*0.21607642918484779 - tmp_kernel_op_58)*(jac_affine_inv_1_1_WHITE_UP*0.21607642918484779 - tmp_kernel_op_58)) + ((jac_affine_inv_1_2_WHITE_UP*0.21607642918484779 - tmp_kernel_op_59)*(jac_affine_inv_1_2_WHITE_UP*0.21607642918484779 - tmp_kernel_op_59)))*0.053182322583579168 + tmp_kernel_op_9*(((jac_affine_inv_1_0_WHITE_UP*0.82157254096761978 - tmp_kernel_op_48)*(jac_affine_inv_1_0_WHITE_UP*0.82157254096761978 - tmp_kernel_op_48)) + ((jac_affine_inv_1_1_WHITE_UP*0.82157254096761978 - tmp_kernel_op_49)*(jac_affine_inv_1_1_WHITE_UP*0.82157254096761978 - tmp_kernel_op_49)) + ((jac_affine_inv_1_2_WHITE_UP*0.82157254096761978 - tmp_kernel_op_50)*(jac_affine_inv_1_2_WHITE_UP*0.82157254096761978 - tmp_kernel_op_50)))*0.016934591412496779;
             const walberla::float64 elMatDiag_3 = tmp_kernel_op_13*tmp_kernel_op_66*0.046462929447761363 + tmp_kernel_op_17*(((jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_68 + tmp_kernel_op_14 + tmp_kernel_op_38)*(jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_68 + tmp_kernel_op_14 + tmp_kernel_op_38)) + ((jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_68 + tmp_kernel_op_15 + tmp_kernel_op_39)*(jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_68 + tmp_kernel_op_15 + tmp_kernel_op_39)) + ((jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_68 + tmp_kernel_op_16 + tmp_kernel_op_40)*(jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_68 + tmp_kernel_op_16 + tmp_kernel_op_40)))*0.046462929447761363 + tmp_kernel_op_21*tmp_kernel_op_66*0.05008682322282932 + tmp_kernel_op_25*(((jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_69 + tmp_kernel_op_22 + tmp_kernel_op_41)*(jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_69 + tmp_kernel_op_22 + tmp_kernel_op_41)) + ((jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_69 + tmp_kernel_op_23 + tmp_kernel_op_42)*(jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_69 + tmp_kernel_op_23 + tmp_kernel_op_42)) + ((jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_69 + tmp_kernel_op_24 + tmp_kernel_op_43)*(jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_69 + tmp_kernel_op_24 + tmp_kernel_op_43)))*0.05008682322282932 + tmp_kernel_op_29*tmp_kernel_op_66*0.053182322583579168 + tmp_kernel_op_3*tmp_kernel_op_66*0.016934591412496779 + tmp_kernel_op_33*(((jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_70 + tmp_kernel_op_30 + tmp_kernel_op_44)*(jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_70 + tmp_kernel_op_30 + tmp_kernel_op_44)) + ((jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_70 + tmp_kernel_op_31 + tmp_kernel_op_45)*(jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_70 + tmp_kernel_op_31 + tmp_kernel_op_45)) + ((jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_70 + tmp_kernel_op_32 + tmp_kernel_op_46)*(jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_70 + tmp_kernel_op_32 + tmp_kernel_op_46)))*0.053182322583579168 + tmp_kernel_op_9*(((jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_67 + tmp_kernel_op_35 + tmp_kernel_op_6)*(jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_67 + tmp_kernel_op_35 + tmp_kernel_op_6)) + ((jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_67 + tmp_kernel_op_36 + tmp_kernel_op_7)*(jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_67 + tmp_kernel_op_36 + tmp_kernel_op_7)) + ((jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_67 + tmp_kernel_op_37 + tmp_kernel_op_8)*(jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_67 + tmp_kernel_op_37 + tmp_kernel_op_8)))*0.016934591412496779;
             const walberla::float64 elMatDiag_4 = tmp_kernel_op_13*tmp_kernel_op_74*0.046462929447761363 + tmp_kernel_op_17*(((jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_76 + jac_affine_inv_2_0_WHITE_UP*0.3817653560693467 + tmp_kernel_op_51)*(jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_76 + jac_affine_inv_2_0_WHITE_UP*0.3817653560693467 + tmp_kernel_op_51)) + ((jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_76 + jac_affine_inv_2_1_WHITE_UP*0.3817653560693467 + tmp_kernel_op_52)*(jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_76 + jac_affine_inv_2_1_WHITE_UP*0.3817653560693467 + tmp_kernel_op_52)) + ((jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_76 + jac_affine_inv_2_2_WHITE_UP*0.3817653560693467 + tmp_kernel_op_53)*(jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_76 + jac_affine_inv_2_2_WHITE_UP*0.3817653560693467 + tmp_kernel_op_53)))*0.046462929447761363 + tmp_kernel_op_21*tmp_kernel_op_74*0.05008682322282932 + tmp_kernel_op_25*(((jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_77 + jac_affine_inv_2_0_WHITE_UP*0.0069232355736274674 + tmp_kernel_op_54)*(jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_77 + jac_affine_inv_2_0_WHITE_UP*0.0069232355736274674 + tmp_kernel_op_54)) + ((jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_77 + jac_affine_inv_2_1_WHITE_UP*0.0069232355736274674 + tmp_kernel_op_55)*(jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_77 + jac_affine_inv_2_1_WHITE_UP*0.0069232355736274674 + tmp_kernel_op_55)) + ((jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_77 + jac_affine_inv_2_2_WHITE_UP*0.0069232355736274674 + tmp_kernel_op_56)*(jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_77 + jac_affine_inv_2_2_WHITE_UP*0.0069232355736274674 + tmp_kernel_op_56)))*0.05008682322282932 + tmp_kernel_op_29*tmp_kernel_op_74*0.053182322583579168 + tmp_kernel_op_3*tmp_kernel_op_74*0.016934591412496779 + tmp_kernel_op_33*(((jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_78 + jac_affine_inv_2_0_WHITE_UP*0.43070170707783612 + tmp_kernel_op_57)*(jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_78 + jac_affine_inv_2_0_WHITE_UP*0.43070170707783612 + tmp_kernel_op_57)) + ((jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_78 + jac_affine_inv_2_1_WHITE_UP*0.43070170707783612 + tmp_kernel_op_58)*(jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_78 + jac_affine_inv_2_1_WHITE_UP*0.43070170707783612 + tmp_kernel_op_58)) + ((jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_78 + jac_affine_inv_2_2_WHITE_UP*0.43070170707783612 + tmp_kernel_op_59)*(jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_78 + jac_affine_inv_2_2_WHITE_UP*0.43070170707783612 + tmp_kernel_op_59)))*0.053182322583579168 + tmp_kernel_op_9*(((jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_75 + jac_affine_inv_2_0_WHITE_UP*0.039933048641498423 + tmp_kernel_op_48)*(jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_75 + jac_affine_inv_2_0_WHITE_UP*0.039933048641498423 + tmp_kernel_op_48)) + ((jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_75 + jac_affine_inv_2_1_WHITE_UP*0.039933048641498423 + tmp_kernel_op_49)*(jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_75 + jac_affine_inv_2_1_WHITE_UP*0.039933048641498423 + tmp_kernel_op_49)) + ((jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_75 + jac_affine_inv_2_2_WHITE_UP*0.039933048641498423 + tmp_kernel_op_50)*(jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_75 + jac_affine_inv_2_2_WHITE_UP*0.039933048641498423 + tmp_kernel_op_50)))*0.016934591412496779;
             const walberla::float64 elMatDiag_5 = tmp_kernel_op_13*tmp_kernel_op_79*0.046462929447761363 + tmp_kernel_op_17*(((jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_81 + jac_affine_inv_1_0_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_0_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_81 + jac_affine_inv_1_0_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_0_WHITE_UP*0.15593312049918601)) + ((jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_81 + jac_affine_inv_1_1_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_1_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_81 + jac_affine_inv_1_1_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_1_WHITE_UP*0.15593312049918601)) + ((jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_81 + jac_affine_inv_1_2_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_2_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_81 + jac_affine_inv_1_2_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_2_WHITE_UP*0.15593312049918601)))*0.046462929447761363 + tmp_kernel_op_21*tmp_kernel_op_79*0.05008682322282932 + tmp_kernel_op_25*(((jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_82 + jac_affine_inv_1_0_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_0_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_82 + jac_affine_inv_1_0_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_0_WHITE_UP*0.18002969351036541)) + ((jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_82 + jac_affine_inv_1_1_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_1_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_82 + jac_affine_inv_1_1_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_1_WHITE_UP*0.18002969351036541)) + ((jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_82 + jac_affine_inv_1_2_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_2_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_82 + jac_affine_inv_1_2_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_2_WHITE_UP*0.18002969351036541)))*0.05008682322282932 + tmp_kernel_op_29*tmp_kernel_op_79*0.053182322583579168 + tmp_kernel_op_3*tmp_kernel_op_79*0.016934591412496779 + tmp_kernel_op_33*(((jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_83 + jac_affine_inv_1_0_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_0_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_83 + jac_affine_inv_1_0_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_0_WHITE_UP*0.21607642918484779)) + ((jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_83 + jac_affine_inv_1_1_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_1_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_83 + jac_affine_inv_1_1_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_1_WHITE_UP*0.21607642918484779)) + ((jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_83 + jac_affine_inv_1_2_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_2_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_83 + jac_affine_inv_1_2_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_2_WHITE_UP*0.21607642918484779)))*0.053182322583579168 + tmp_kernel_op_9*(((jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_80 + jac_affine_inv_1_0_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_0_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_80 + jac_affine_inv_1_0_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_0_WHITE_UP*0.82157254096761978)) + ((jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_80 + jac_affine_inv_1_1_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_1_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_80 + jac_affine_inv_1_1_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_1_WHITE_UP*0.82157254096761978)) + ((jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_80 + jac_affine_inv_1_2_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_2_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_80 + jac_affine_inv_1_2_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_2_WHITE_UP*0.82157254096761978)))*0.016934591412496779;
             {
                {
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = elMatDiag_0 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = elMatDiag_1 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = elMatDiag_2 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = elMatDiag_3 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = elMatDiag_4 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = elMatDiag_5 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                }
             }
             const walberla::float64 Dummy_4676 = _data_alpha[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const walberla::float64 Dummy_4677 = _data_alpha[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const walberla::float64 Dummy_4678 = _data_alpha[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const walberla::float64 Dummy_4679 = _data_alpha[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const walberla::float64 Dummy_4680 = _data_beta[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const walberla::float64 Dummy_4681 = _data_beta[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const walberla::float64 Dummy_4682 = _data_beta[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const walberla::float64 Dummy_4683 = _data_beta[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const walberla::float64 Dummy_4684 = Dummy_4676*tmp_kernel_op_2 + Dummy_4677*0.82157254096761978 + Dummy_4678*0.039933048641498423 + Dummy_4679*0.01482761006242336;
             const walberla::float64 Dummy_4685 = 1.0 / (abs_det_jac_affine_BLUE_UP);
             const walberla::float64 Dummy_4686 = Dummy_4685*((jac_affine_0_0_BLUE_UP*jac_affine_0_0_BLUE_UP)*4.0 + (jac_affine_1_0_BLUE_UP*jac_affine_1_0_BLUE_UP)*4.0 + (jac_affine_2_0_BLUE_UP*jac_affine_2_0_BLUE_UP)*4.0);
             const walberla::float64 Dummy_4687 = jac_affine_inv_1_0_BLUE_UP*0.01482761006242336;
             const walberla::float64 Dummy_4688 = jac_affine_inv_1_1_BLUE_UP*0.01482761006242336;
             const walberla::float64 Dummy_4689 = jac_affine_inv_1_2_BLUE_UP*0.01482761006242336;
             const walberla::float64 Dummy_4690 = abs_det_jac_affine_BLUE_UP*(Dummy_4680*tmp_kernel_op_2 + Dummy_4681*0.82157254096761978 + Dummy_4682*0.039933048641498423 + Dummy_4683*0.01482761006242336);
             const walberla::float64 Dummy_4691 = Dummy_4676*tmp_kernel_op_12 + Dummy_4677*0.15593312049918601 + Dummy_4678*0.3817653560693467 + Dummy_4679*0.0048399363458717648;
             const walberla::float64 Dummy_4692 = jac_affine_inv_1_0_BLUE_UP*0.0048399363458717648;
             const walberla::float64 Dummy_4693 = jac_affine_inv_1_1_BLUE_UP*0.0048399363458717648;
             const walberla::float64 Dummy_4694 = jac_affine_inv_1_2_BLUE_UP*0.0048399363458717648;
             const walberla::float64 Dummy_4695 = abs_det_jac_affine_BLUE_UP*(Dummy_4680*tmp_kernel_op_12 + Dummy_4681*0.15593312049918601 + Dummy_4682*0.3817653560693467 + Dummy_4683*0.0048399363458717648);
             const walberla::float64 Dummy_4696 = Dummy_4676*tmp_kernel_op_20 + Dummy_4677*0.18002969351036541 + Dummy_4678*0.0069232355736274674 + Dummy_4679*0.44773255210137269;
             const walberla::float64 Dummy_4697 = jac_affine_inv_1_0_BLUE_UP*0.44773255210137269;
             const walberla::float64 Dummy_4698 = jac_affine_inv_1_1_BLUE_UP*0.44773255210137269;
             const walberla::float64 Dummy_4699 = jac_affine_inv_1_2_BLUE_UP*0.44773255210137269;
             const walberla::float64 Dummy_4700 = abs_det_jac_affine_BLUE_UP*(Dummy_4680*tmp_kernel_op_20 + Dummy_4681*0.18002969351036541 + Dummy_4682*0.0069232355736274674 + Dummy_4683*0.44773255210137269);
             const walberla::float64 Dummy_4701 = Dummy_4676*tmp_kernel_op_28 + Dummy_4677*0.21607642918484779 + Dummy_4678*0.43070170707783612 + Dummy_4679*0.35284634870858678;
             const walberla::float64 Dummy_4702 = jac_affine_inv_1_0_BLUE_UP*0.35284634870858678;
             const walberla::float64 Dummy_4703 = jac_affine_inv_1_1_BLUE_UP*0.35284634870858678;
             const walberla::float64 Dummy_4704 = jac_affine_inv_1_2_BLUE_UP*0.35284634870858678;
             const walberla::float64 Dummy_4705 = abs_det_jac_affine_BLUE_UP*(Dummy_4680*tmp_kernel_op_28 + Dummy_4681*0.21607642918484779 + Dummy_4682*0.43070170707783612 + Dummy_4683*0.35284634870858678);
             const walberla::float64 Dummy_4706 = Dummy_4685*((jac_affine_0_1_BLUE_UP*jac_affine_0_1_BLUE_UP)*4.0 + (jac_affine_1_1_BLUE_UP*jac_affine_1_1_BLUE_UP)*4.0 + (jac_affine_2_1_BLUE_UP*jac_affine_2_1_BLUE_UP)*4.0);
             const walberla::float64 Dummy_4707 = jac_affine_inv_0_0_BLUE_UP*0.01482761006242336;
             const walberla::float64 Dummy_4708 = jac_affine_inv_0_1_BLUE_UP*0.01482761006242336;
             const walberla::float64 Dummy_4709 = jac_affine_inv_0_2_BLUE_UP*0.01482761006242336;
             const walberla::float64 Dummy_4710 = jac_affine_inv_0_0_BLUE_UP*0.0048399363458717648;
             const walberla::float64 Dummy_4711 = jac_affine_inv_0_1_BLUE_UP*0.0048399363458717648;
             const walberla::float64 Dummy_4712 = jac_affine_inv_0_2_BLUE_UP*0.0048399363458717648;
             const walberla::float64 Dummy_4713 = jac_affine_inv_0_0_BLUE_UP*0.44773255210137269;
             const walberla::float64 Dummy_4714 = jac_affine_inv_0_1_BLUE_UP*0.44773255210137269;
             const walberla::float64 Dummy_4715 = jac_affine_inv_0_2_BLUE_UP*0.44773255210137269;
             const walberla::float64 Dummy_4716 = jac_affine_inv_0_0_BLUE_UP*0.35284634870858678;
             const walberla::float64 Dummy_4717 = jac_affine_inv_0_1_BLUE_UP*0.35284634870858678;
             const walberla::float64 Dummy_4718 = jac_affine_inv_0_2_BLUE_UP*0.35284634870858678;
             const walberla::float64 Dummy_4719 = Dummy_4685*((jac_affine_0_2_BLUE_UP*jac_affine_0_2_BLUE_UP)*4.0 + (jac_affine_1_2_BLUE_UP*jac_affine_1_2_BLUE_UP)*4.0 + (jac_affine_2_2_BLUE_UP*jac_affine_2_2_BLUE_UP)*4.0);
             const walberla::float64 Dummy_4720 = jac_affine_inv_0_0_BLUE_UP*0.039933048641498423;
             const walberla::float64 Dummy_4721 = jac_affine_inv_0_1_BLUE_UP*0.039933048641498423;
             const walberla::float64 Dummy_4722 = jac_affine_inv_0_2_BLUE_UP*0.039933048641498423;
             const walberla::float64 Dummy_4723 = jac_affine_inv_0_0_BLUE_UP*0.3817653560693467;
             const walberla::float64 Dummy_4724 = jac_affine_inv_0_1_BLUE_UP*0.3817653560693467;
             const walberla::float64 Dummy_4725 = jac_affine_inv_0_2_BLUE_UP*0.3817653560693467;
             const walberla::float64 Dummy_4726 = jac_affine_inv_0_0_BLUE_UP*0.0069232355736274674;
             const walberla::float64 Dummy_4727 = jac_affine_inv_0_1_BLUE_UP*0.0069232355736274674;
             const walberla::float64 Dummy_4728 = jac_affine_inv_0_2_BLUE_UP*0.0069232355736274674;
             const walberla::float64 Dummy_4729 = jac_affine_inv_0_0_BLUE_UP*0.43070170707783612;
             const walberla::float64 Dummy_4730 = jac_affine_inv_0_1_BLUE_UP*0.43070170707783612;
             const walberla::float64 Dummy_4731 = jac_affine_inv_0_2_BLUE_UP*0.43070170707783612;
             const walberla::float64 Dummy_4732 = jac_affine_0_0_BLUE_UP*2.0;
             const walberla::float64 Dummy_4733 = jac_affine_0_1_BLUE_UP*2.0;
             const walberla::float64 Dummy_4734 = jac_affine_1_0_BLUE_UP*2.0;
             const walberla::float64 Dummy_4735 = jac_affine_1_1_BLUE_UP*2.0;
             const walberla::float64 Dummy_4736 = jac_affine_2_0_BLUE_UP*2.0;
             const walberla::float64 Dummy_4737 = jac_affine_2_1_BLUE_UP*2.0;
             const walberla::float64 Dummy_4738 = Dummy_4685*(((-Dummy_4732 + Dummy_4733)*(-Dummy_4732 + Dummy_4733)) + ((-Dummy_4734 + Dummy_4735)*(-Dummy_4734 + Dummy_4735)) + ((-Dummy_4736 + Dummy_4737)*(-Dummy_4736 + Dummy_4737)));
             const walberla::float64 Dummy_4739 = jac_affine_0_2_BLUE_UP*-2.0;
             const walberla::float64 Dummy_4740 = jac_affine_1_2_BLUE_UP*-2.0;
             const walberla::float64 Dummy_4741 = jac_affine_2_2_BLUE_UP*-2.0;
             const walberla::float64 Dummy_4742 = Dummy_4685*(((Dummy_4732 + Dummy_4739)*(Dummy_4732 + Dummy_4739)) + ((Dummy_4734 + Dummy_4740)*(Dummy_4734 + Dummy_4740)) + ((Dummy_4736 + Dummy_4741)*(Dummy_4736 + Dummy_4741)));
             const walberla::float64 Dummy_4743 = Dummy_4685*(((-Dummy_4733 - Dummy_4739)*(-Dummy_4733 - Dummy_4739)) + ((-Dummy_4735 - Dummy_4740)*(-Dummy_4735 - Dummy_4740)) + ((-Dummy_4737 - Dummy_4741)*(-Dummy_4737 - Dummy_4741)));
             const walberla::float64 Dummy_4744 = Dummy_4684*Dummy_4686*0.016934591412496779 + Dummy_4686*Dummy_4691*0.046462929447761363 + Dummy_4686*Dummy_4696*0.05008682322282932 + Dummy_4686*Dummy_4701*0.053182322583579168 + Dummy_4690*(((-Dummy_4687 + jac_affine_inv_2_0_BLUE_UP*0.039933048641498423)*(-Dummy_4687 + jac_affine_inv_2_0_BLUE_UP*0.039933048641498423)) + ((-Dummy_4688 + jac_affine_inv_2_1_BLUE_UP*0.039933048641498423)*(-Dummy_4688 + jac_affine_inv_2_1_BLUE_UP*0.039933048641498423)) + ((-Dummy_4689 + jac_affine_inv_2_2_BLUE_UP*0.039933048641498423)*(-Dummy_4689 + jac_affine_inv_2_2_BLUE_UP*0.039933048641498423)))*0.016934591412496779 + Dummy_4695*(((-Dummy_4692 + jac_affine_inv_2_0_BLUE_UP*0.3817653560693467)*(-Dummy_4692 + jac_affine_inv_2_0_BLUE_UP*0.3817653560693467)) + ((-Dummy_4693 + jac_affine_inv_2_1_BLUE_UP*0.3817653560693467)*(-Dummy_4693 + jac_affine_inv_2_1_BLUE_UP*0.3817653560693467)) + ((-Dummy_4694 + jac_affine_inv_2_2_BLUE_UP*0.3817653560693467)*(-Dummy_4694 + jac_affine_inv_2_2_BLUE_UP*0.3817653560693467)))*0.046462929447761363 + Dummy_4700*(((-Dummy_4697 + jac_affine_inv_2_0_BLUE_UP*0.0069232355736274674)*(-Dummy_4697 + jac_affine_inv_2_0_BLUE_UP*0.0069232355736274674)) + ((-Dummy_4698 + jac_affine_inv_2_1_BLUE_UP*0.0069232355736274674)*(-Dummy_4698 + jac_affine_inv_2_1_BLUE_UP*0.0069232355736274674)) + ((-Dummy_4699 + jac_affine_inv_2_2_BLUE_UP*0.0069232355736274674)*(-Dummy_4699 + jac_affine_inv_2_2_BLUE_UP*0.0069232355736274674)))*0.05008682322282932 + Dummy_4705*(((-Dummy_4702 + jac_affine_inv_2_0_BLUE_UP*0.43070170707783612)*(-Dummy_4702 + jac_affine_inv_2_0_BLUE_UP*0.43070170707783612)) + ((-Dummy_4703 + jac_affine_inv_2_1_BLUE_UP*0.43070170707783612)*(-Dummy_4703 + jac_affine_inv_2_1_BLUE_UP*0.43070170707783612)) + ((-Dummy_4704 + jac_affine_inv_2_2_BLUE_UP*0.43070170707783612)*(-Dummy_4704 + jac_affine_inv_2_2_BLUE_UP*0.43070170707783612)))*0.053182322583579168;
             const walberla::float64 Dummy_4745 = Dummy_4684*Dummy_4706*0.016934591412496779 + Dummy_4690*(((-Dummy_4707 + jac_affine_inv_2_0_BLUE_UP*0.82157254096761978)*(-Dummy_4707 + jac_affine_inv_2_0_BLUE_UP*0.82157254096761978)) + ((-Dummy_4708 + jac_affine_inv_2_1_BLUE_UP*0.82157254096761978)*(-Dummy_4708 + jac_affine_inv_2_1_BLUE_UP*0.82157254096761978)) + ((-Dummy_4709 + jac_affine_inv_2_2_BLUE_UP*0.82157254096761978)*(-Dummy_4709 + jac_affine_inv_2_2_BLUE_UP*0.82157254096761978)))*0.016934591412496779 + Dummy_4691*Dummy_4706*0.046462929447761363 + Dummy_4695*(((-Dummy_4710 + jac_affine_inv_2_0_BLUE_UP*0.15593312049918601)*(-Dummy_4710 + jac_affine_inv_2_0_BLUE_UP*0.15593312049918601)) + ((-Dummy_4711 + jac_affine_inv_2_1_BLUE_UP*0.15593312049918601)*(-Dummy_4711 + jac_affine_inv_2_1_BLUE_UP*0.15593312049918601)) + ((-Dummy_4712 + jac_affine_inv_2_2_BLUE_UP*0.15593312049918601)*(-Dummy_4712 + jac_affine_inv_2_2_BLUE_UP*0.15593312049918601)))*0.046462929447761363 + Dummy_4696*Dummy_4706*0.05008682322282932 + Dummy_4700*(((-Dummy_4713 + jac_affine_inv_2_0_BLUE_UP*0.18002969351036541)*(-Dummy_4713 + jac_affine_inv_2_0_BLUE_UP*0.18002969351036541)) + ((-Dummy_4714 + jac_affine_inv_2_1_BLUE_UP*0.18002969351036541)*(-Dummy_4714 + jac_affine_inv_2_1_BLUE_UP*0.18002969351036541)) + ((-Dummy_4715 + jac_affine_inv_2_2_BLUE_UP*0.18002969351036541)*(-Dummy_4715 + jac_affine_inv_2_2_BLUE_UP*0.18002969351036541)))*0.05008682322282932 + Dummy_4701*Dummy_4706*0.053182322583579168 + Dummy_4705*(((-Dummy_4716 + jac_affine_inv_2_0_BLUE_UP*0.21607642918484779)*(-Dummy_4716 + jac_affine_inv_2_0_BLUE_UP*0.21607642918484779)) + ((-Dummy_4717 + jac_affine_inv_2_1_BLUE_UP*0.21607642918484779)*(-Dummy_4717 + jac_affine_inv_2_1_BLUE_UP*0.21607642918484779)) + ((-Dummy_4718 + jac_affine_inv_2_2_BLUE_UP*0.21607642918484779)*(-Dummy_4718 + jac_affine_inv_2_2_BLUE_UP*0.21607642918484779)))*0.053182322583579168;
             const walberla::float64 Dummy_4746 = Dummy_4684*Dummy_4719*0.016934591412496779 + Dummy_4690*(((-Dummy_4720 + jac_affine_inv_1_0_BLUE_UP*0.82157254096761978)*(-Dummy_4720 + jac_affine_inv_1_0_BLUE_UP*0.82157254096761978)) + ((-Dummy_4721 + jac_affine_inv_1_1_BLUE_UP*0.82157254096761978)*(-Dummy_4721 + jac_affine_inv_1_1_BLUE_UP*0.82157254096761978)) + ((-Dummy_4722 + jac_affine_inv_1_2_BLUE_UP*0.82157254096761978)*(-Dummy_4722 + jac_affine_inv_1_2_BLUE_UP*0.82157254096761978)))*0.016934591412496779 + Dummy_4691*Dummy_4719*0.046462929447761363 + Dummy_4695*(((-Dummy_4723 + jac_affine_inv_1_0_BLUE_UP*0.15593312049918601)*(-Dummy_4723 + jac_affine_inv_1_0_BLUE_UP*0.15593312049918601)) + ((-Dummy_4724 + jac_affine_inv_1_1_BLUE_UP*0.15593312049918601)*(-Dummy_4724 + jac_affine_inv_1_1_BLUE_UP*0.15593312049918601)) + ((-Dummy_4725 + jac_affine_inv_1_2_BLUE_UP*0.15593312049918601)*(-Dummy_4725 + jac_affine_inv_1_2_BLUE_UP*0.15593312049918601)))*0.046462929447761363 + Dummy_4696*Dummy_4719*0.05008682322282932 + Dummy_4700*(((-Dummy_4726 + jac_affine_inv_1_0_BLUE_UP*0.18002969351036541)*(-Dummy_4726 + jac_affine_inv_1_0_BLUE_UP*0.18002969351036541)) + ((-Dummy_4727 + jac_affine_inv_1_1_BLUE_UP*0.18002969351036541)*(-Dummy_4727 + jac_affine_inv_1_1_BLUE_UP*0.18002969351036541)) + ((-Dummy_4728 + jac_affine_inv_1_2_BLUE_UP*0.18002969351036541)*(-Dummy_4728 + jac_affine_inv_1_2_BLUE_UP*0.18002969351036541)))*0.05008682322282932 + Dummy_4701*Dummy_4719*0.053182322583579168 + Dummy_4705*(((-Dummy_4729 + jac_affine_inv_1_0_BLUE_UP*0.21607642918484779)*(-Dummy_4729 + jac_affine_inv_1_0_BLUE_UP*0.21607642918484779)) + ((-Dummy_4730 + jac_affine_inv_1_1_BLUE_UP*0.21607642918484779)*(-Dummy_4730 + jac_affine_inv_1_1_BLUE_UP*0.21607642918484779)) + ((-Dummy_4731 + jac_affine_inv_1_2_BLUE_UP*0.21607642918484779)*(-Dummy_4731 + jac_affine_inv_1_2_BLUE_UP*0.21607642918484779)))*0.053182322583579168;
             const walberla::float64 Dummy_4747 = Dummy_4684*Dummy_4738*0.016934591412496779 + Dummy_4690*(((Dummy_4687 + Dummy_4707 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_67)*(Dummy_4687 + Dummy_4707 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_67)) + ((Dummy_4688 + Dummy_4708 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_67)*(Dummy_4688 + Dummy_4708 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_67)) + ((Dummy_4689 + Dummy_4709 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_67)*(Dummy_4689 + Dummy_4709 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_67)))*0.016934591412496779 + Dummy_4691*Dummy_4738*0.046462929447761363 + Dummy_4695*(((Dummy_4692 + Dummy_4710 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_68)*(Dummy_4692 + Dummy_4710 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_68)) + ((Dummy_4693 + Dummy_4711 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_68)*(Dummy_4693 + Dummy_4711 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_68)) + ((Dummy_4694 + Dummy_4712 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_68)*(Dummy_4694 + Dummy_4712 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_68)))*0.046462929447761363 + Dummy_4696*Dummy_4738*0.05008682322282932 + Dummy_4700*(((Dummy_4697 + Dummy_4713 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_69)*(Dummy_4697 + Dummy_4713 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_69)) + ((Dummy_4698 + Dummy_4714 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_69)*(Dummy_4698 + Dummy_4714 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_69)) + ((Dummy_4699 + Dummy_4715 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_69)*(Dummy_4699 + Dummy_4715 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_69)))*0.05008682322282932 + Dummy_4701*Dummy_4738*0.053182322583579168 + Dummy_4705*(((Dummy_4702 + Dummy_4716 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_70)*(Dummy_4702 + Dummy_4716 + jac_affine_inv_2_0_BLUE_UP*tmp_kernel_op_70)) + ((Dummy_4703 + Dummy_4717 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_70)*(Dummy_4703 + Dummy_4717 + jac_affine_inv_2_1_BLUE_UP*tmp_kernel_op_70)) + ((Dummy_4704 + Dummy_4718 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_70)*(Dummy_4704 + Dummy_4718 + jac_affine_inv_2_2_BLUE_UP*tmp_kernel_op_70)))*0.053182322583579168;
             const walberla::float64 Dummy_4748 = Dummy_4684*Dummy_4742*0.016934591412496779 + Dummy_4690*(((Dummy_4720 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_75 + jac_affine_inv_2_0_BLUE_UP*0.039933048641498423)*(Dummy_4720 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_75 + jac_affine_inv_2_0_BLUE_UP*0.039933048641498423)) + ((Dummy_4721 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_75 + jac_affine_inv_2_1_BLUE_UP*0.039933048641498423)*(Dummy_4721 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_75 + jac_affine_inv_2_1_BLUE_UP*0.039933048641498423)) + ((Dummy_4722 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_75 + jac_affine_inv_2_2_BLUE_UP*0.039933048641498423)*(Dummy_4722 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_75 + jac_affine_inv_2_2_BLUE_UP*0.039933048641498423)))*0.016934591412496779 + Dummy_4691*Dummy_4742*0.046462929447761363 + Dummy_4695*(((Dummy_4723 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_76 + jac_affine_inv_2_0_BLUE_UP*0.3817653560693467)*(Dummy_4723 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_76 + jac_affine_inv_2_0_BLUE_UP*0.3817653560693467)) + ((Dummy_4724 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_76 + jac_affine_inv_2_1_BLUE_UP*0.3817653560693467)*(Dummy_4724 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_76 + jac_affine_inv_2_1_BLUE_UP*0.3817653560693467)) + ((Dummy_4725 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_76 + jac_affine_inv_2_2_BLUE_UP*0.3817653560693467)*(Dummy_4725 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_76 + jac_affine_inv_2_2_BLUE_UP*0.3817653560693467)))*0.046462929447761363 + Dummy_4696*Dummy_4742*0.05008682322282932 + Dummy_4700*(((Dummy_4726 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_77 + jac_affine_inv_2_0_BLUE_UP*0.0069232355736274674)*(Dummy_4726 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_77 + jac_affine_inv_2_0_BLUE_UP*0.0069232355736274674)) + ((Dummy_4727 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_77 + jac_affine_inv_2_1_BLUE_UP*0.0069232355736274674)*(Dummy_4727 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_77 + jac_affine_inv_2_1_BLUE_UP*0.0069232355736274674)) + ((Dummy_4728 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_77 + jac_affine_inv_2_2_BLUE_UP*0.0069232355736274674)*(Dummy_4728 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_77 + jac_affine_inv_2_2_BLUE_UP*0.0069232355736274674)))*0.05008682322282932 + Dummy_4701*Dummy_4742*0.053182322583579168 + Dummy_4705*(((Dummy_4729 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_78 + jac_affine_inv_2_0_BLUE_UP*0.43070170707783612)*(Dummy_4729 + jac_affine_inv_1_0_BLUE_UP*tmp_kernel_op_78 + jac_affine_inv_2_0_BLUE_UP*0.43070170707783612)) + ((Dummy_4730 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_78 + jac_affine_inv_2_1_BLUE_UP*0.43070170707783612)*(Dummy_4730 + jac_affine_inv_1_1_BLUE_UP*tmp_kernel_op_78 + jac_affine_inv_2_1_BLUE_UP*0.43070170707783612)) + ((Dummy_4731 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_78 + jac_affine_inv_2_2_BLUE_UP*0.43070170707783612)*(Dummy_4731 + jac_affine_inv_1_2_BLUE_UP*tmp_kernel_op_78 + jac_affine_inv_2_2_BLUE_UP*0.43070170707783612)))*0.053182322583579168;
             const walberla::float64 Dummy_4749 = Dummy_4684*Dummy_4743*0.016934591412496779 + Dummy_4690*(((jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_80 + jac_affine_inv_1_0_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_0_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_80 + jac_affine_inv_1_0_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_0_BLUE_UP*0.82157254096761978)) + ((jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_80 + jac_affine_inv_1_1_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_1_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_80 + jac_affine_inv_1_1_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_1_BLUE_UP*0.82157254096761978)) + ((jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_80 + jac_affine_inv_1_2_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_2_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_80 + jac_affine_inv_1_2_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_2_BLUE_UP*0.82157254096761978)))*0.016934591412496779 + Dummy_4691*Dummy_4743*0.046462929447761363 + Dummy_4695*(((jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_81 + jac_affine_inv_1_0_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_0_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_81 + jac_affine_inv_1_0_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_0_BLUE_UP*0.15593312049918601)) + ((jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_81 + jac_affine_inv_1_1_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_1_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_81 + jac_affine_inv_1_1_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_1_BLUE_UP*0.15593312049918601)) + ((jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_81 + jac_affine_inv_1_2_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_2_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_81 + jac_affine_inv_1_2_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_2_BLUE_UP*0.15593312049918601)))*0.046462929447761363 + Dummy_4696*Dummy_4743*0.05008682322282932 + Dummy_4700*(((jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_82 + jac_affine_inv_1_0_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_0_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_82 + jac_affine_inv_1_0_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_0_BLUE_UP*0.18002969351036541)) + ((jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_82 + jac_affine_inv_1_1_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_1_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_82 + jac_affine_inv_1_1_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_1_BLUE_UP*0.18002969351036541)) + ((jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_82 + jac_affine_inv_1_2_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_2_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_82 + jac_affine_inv_1_2_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_2_BLUE_UP*0.18002969351036541)))*0.05008682322282932 + Dummy_4701*Dummy_4743*0.053182322583579168 + Dummy_4705*(((jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_83 + jac_affine_inv_1_0_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_0_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_0_BLUE_UP*tmp_kernel_op_83 + jac_affine_inv_1_0_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_0_BLUE_UP*0.21607642918484779)) + ((jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_83 + jac_affine_inv_1_1_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_1_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_1_BLUE_UP*tmp_kernel_op_83 + jac_affine_inv_1_1_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_1_BLUE_UP*0.21607642918484779)) + ((jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_83 + jac_affine_inv_1_2_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_2_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_2_BLUE_UP*tmp_kernel_op_83 + jac_affine_inv_1_2_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_2_BLUE_UP*0.21607642918484779)))*0.053182322583579168;
             {
                {
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1] = Dummy_4744 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2] = Dummy_4745 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2];
                   _data_invDiag_[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = Dummy_4746 + _data_invDiag_[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1] = Dummy_4747 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1] = Dummy_4748 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = Dummy_4749 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                }
             }
             const walberla::float64 Dummy_4750 = _data_alpha[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const walberla::float64 Dummy_4751 = _data_alpha[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const walberla::float64 Dummy_4752 = _data_alpha[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const walberla::float64 Dummy_4753 = _data_alpha[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const walberla::float64 Dummy_4754 = _data_beta[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const walberla::float64 Dummy_4755 = _data_beta[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const walberla::float64 Dummy_4756 = _data_beta[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const walberla::float64 Dummy_4757 = _data_beta[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const walberla::float64 Dummy_4758 = Dummy_4750*tmp_kernel_op_2 + Dummy_4751*0.82157254096761978 + Dummy_4752*0.039933048641498423 + Dummy_4753*0.01482761006242336;
             const walberla::float64 Dummy_4759 = 1.0 / (abs_det_jac_affine_BLUE_DOWN);
             const walberla::float64 Dummy_4760 = Dummy_4759*((jac_affine_0_0_BLUE_DOWN*jac_affine_0_0_BLUE_DOWN)*4.0 + (jac_affine_1_0_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN)*4.0 + (jac_affine_2_0_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN)*4.0);
             const walberla::float64 Dummy_4761 = jac_affine_inv_1_0_BLUE_DOWN*0.01482761006242336;
             const walberla::float64 Dummy_4762 = jac_affine_inv_1_1_BLUE_DOWN*0.01482761006242336;
             const walberla::float64 Dummy_4763 = jac_affine_inv_1_2_BLUE_DOWN*0.01482761006242336;
             const walberla::float64 Dummy_4764 = abs_det_jac_affine_BLUE_DOWN*(Dummy_4754*tmp_kernel_op_2 + Dummy_4755*0.82157254096761978 + Dummy_4756*0.039933048641498423 + Dummy_4757*0.01482761006242336);
             const walberla::float64 Dummy_4765 = Dummy_4750*tmp_kernel_op_12 + Dummy_4751*0.15593312049918601 + Dummy_4752*0.3817653560693467 + Dummy_4753*0.0048399363458717648;
             const walberla::float64 Dummy_4766 = jac_affine_inv_1_0_BLUE_DOWN*0.0048399363458717648;
             const walberla::float64 Dummy_4767 = jac_affine_inv_1_1_BLUE_DOWN*0.0048399363458717648;
             const walberla::float64 Dummy_4768 = jac_affine_inv_1_2_BLUE_DOWN*0.0048399363458717648;
             const walberla::float64 Dummy_4769 = abs_det_jac_affine_BLUE_DOWN*(Dummy_4754*tmp_kernel_op_12 + Dummy_4755*0.15593312049918601 + Dummy_4756*0.3817653560693467 + Dummy_4757*0.0048399363458717648);
             const walberla::float64 Dummy_4770 = Dummy_4750*tmp_kernel_op_20 + Dummy_4751*0.18002969351036541 + Dummy_4752*0.0069232355736274674 + Dummy_4753*0.44773255210137269;
             const walberla::float64 Dummy_4771 = jac_affine_inv_1_0_BLUE_DOWN*0.44773255210137269;
             const walberla::float64 Dummy_4772 = jac_affine_inv_1_1_BLUE_DOWN*0.44773255210137269;
             const walberla::float64 Dummy_4773 = jac_affine_inv_1_2_BLUE_DOWN*0.44773255210137269;
             const walberla::float64 Dummy_4774 = abs_det_jac_affine_BLUE_DOWN*(Dummy_4754*tmp_kernel_op_20 + Dummy_4755*0.18002969351036541 + Dummy_4756*0.0069232355736274674 + Dummy_4757*0.44773255210137269);
             const walberla::float64 Dummy_4775 = Dummy_4750*tmp_kernel_op_28 + Dummy_4751*0.21607642918484779 + Dummy_4752*0.43070170707783612 + Dummy_4753*0.35284634870858678;
             const walberla::float64 Dummy_4776 = jac_affine_inv_1_0_BLUE_DOWN*0.35284634870858678;
             const walberla::float64 Dummy_4777 = jac_affine_inv_1_1_BLUE_DOWN*0.35284634870858678;
             const walberla::float64 Dummy_4778 = jac_affine_inv_1_2_BLUE_DOWN*0.35284634870858678;
             const walberla::float64 Dummy_4779 = abs_det_jac_affine_BLUE_DOWN*(Dummy_4754*tmp_kernel_op_28 + Dummy_4755*0.21607642918484779 + Dummy_4756*0.43070170707783612 + Dummy_4757*0.35284634870858678);
             const walberla::float64 Dummy_4780 = Dummy_4759*((jac_affine_0_1_BLUE_DOWN*jac_affine_0_1_BLUE_DOWN)*4.0 + (jac_affine_1_1_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN)*4.0 + (jac_affine_2_1_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN)*4.0);
             const walberla::float64 Dummy_4781 = jac_affine_inv_0_0_BLUE_DOWN*0.01482761006242336;
             const walberla::float64 Dummy_4782 = jac_affine_inv_0_1_BLUE_DOWN*0.01482761006242336;
             const walberla::float64 Dummy_4783 = jac_affine_inv_0_2_BLUE_DOWN*0.01482761006242336;
             const walberla::float64 Dummy_4784 = jac_affine_inv_0_0_BLUE_DOWN*0.0048399363458717648;
             const walberla::float64 Dummy_4785 = jac_affine_inv_0_1_BLUE_DOWN*0.0048399363458717648;
             const walberla::float64 Dummy_4786 = jac_affine_inv_0_2_BLUE_DOWN*0.0048399363458717648;
             const walberla::float64 Dummy_4787 = jac_affine_inv_0_0_BLUE_DOWN*0.44773255210137269;
             const walberla::float64 Dummy_4788 = jac_affine_inv_0_1_BLUE_DOWN*0.44773255210137269;
             const walberla::float64 Dummy_4789 = jac_affine_inv_0_2_BLUE_DOWN*0.44773255210137269;
             const walberla::float64 Dummy_4790 = jac_affine_inv_0_0_BLUE_DOWN*0.35284634870858678;
             const walberla::float64 Dummy_4791 = jac_affine_inv_0_1_BLUE_DOWN*0.35284634870858678;
             const walberla::float64 Dummy_4792 = jac_affine_inv_0_2_BLUE_DOWN*0.35284634870858678;
             const walberla::float64 Dummy_4793 = Dummy_4759*((jac_affine_0_2_BLUE_DOWN*jac_affine_0_2_BLUE_DOWN)*4.0 + (jac_affine_1_2_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN)*4.0 + (jac_affine_2_2_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN)*4.0);
             const walberla::float64 Dummy_4794 = jac_affine_inv_0_0_BLUE_DOWN*0.039933048641498423;
             const walberla::float64 Dummy_4795 = jac_affine_inv_0_1_BLUE_DOWN*0.039933048641498423;
             const walberla::float64 Dummy_4796 = jac_affine_inv_0_2_BLUE_DOWN*0.039933048641498423;
             const walberla::float64 Dummy_4797 = jac_affine_inv_0_0_BLUE_DOWN*0.3817653560693467;
             const walberla::float64 Dummy_4798 = jac_affine_inv_0_1_BLUE_DOWN*0.3817653560693467;
             const walberla::float64 Dummy_4799 = jac_affine_inv_0_2_BLUE_DOWN*0.3817653560693467;
             const walberla::float64 Dummy_4800 = jac_affine_inv_0_0_BLUE_DOWN*0.0069232355736274674;
             const walberla::float64 Dummy_4801 = jac_affine_inv_0_1_BLUE_DOWN*0.0069232355736274674;
             const walberla::float64 Dummy_4802 = jac_affine_inv_0_2_BLUE_DOWN*0.0069232355736274674;
             const walberla::float64 Dummy_4803 = jac_affine_inv_0_0_BLUE_DOWN*0.43070170707783612;
             const walberla::float64 Dummy_4804 = jac_affine_inv_0_1_BLUE_DOWN*0.43070170707783612;
             const walberla::float64 Dummy_4805 = jac_affine_inv_0_2_BLUE_DOWN*0.43070170707783612;
             const walberla::float64 Dummy_4806 = jac_affine_0_0_BLUE_DOWN*2.0;
             const walberla::float64 Dummy_4807 = jac_affine_0_1_BLUE_DOWN*2.0;
             const walberla::float64 Dummy_4808 = jac_affine_1_0_BLUE_DOWN*2.0;
             const walberla::float64 Dummy_4809 = jac_affine_1_1_BLUE_DOWN*2.0;
             const walberla::float64 Dummy_4810 = jac_affine_2_0_BLUE_DOWN*2.0;
             const walberla::float64 Dummy_4811 = jac_affine_2_1_BLUE_DOWN*2.0;
             const walberla::float64 Dummy_4812 = Dummy_4759*(((-Dummy_4806 + Dummy_4807)*(-Dummy_4806 + Dummy_4807)) + ((-Dummy_4808 + Dummy_4809)*(-Dummy_4808 + Dummy_4809)) + ((-Dummy_4810 + Dummy_4811)*(-Dummy_4810 + Dummy_4811)));
             const walberla::float64 Dummy_4813 = jac_affine_0_2_BLUE_DOWN*-2.0;
             const walberla::float64 Dummy_4814 = jac_affine_1_2_BLUE_DOWN*-2.0;
             const walberla::float64 Dummy_4815 = jac_affine_2_2_BLUE_DOWN*-2.0;
             const walberla::float64 Dummy_4816 = Dummy_4759*(((Dummy_4806 + Dummy_4813)*(Dummy_4806 + Dummy_4813)) + ((Dummy_4808 + Dummy_4814)*(Dummy_4808 + Dummy_4814)) + ((Dummy_4810 + Dummy_4815)*(Dummy_4810 + Dummy_4815)));
             const walberla::float64 Dummy_4817 = Dummy_4759*(((-Dummy_4807 - Dummy_4813)*(-Dummy_4807 - Dummy_4813)) + ((-Dummy_4809 - Dummy_4814)*(-Dummy_4809 - Dummy_4814)) + ((-Dummy_4811 - Dummy_4815)*(-Dummy_4811 - Dummy_4815)));
             const walberla::float64 Dummy_4818 = Dummy_4758*Dummy_4760*0.016934591412496779 + Dummy_4760*Dummy_4765*0.046462929447761363 + Dummy_4760*Dummy_4770*0.05008682322282932 + Dummy_4760*Dummy_4775*0.053182322583579168 + Dummy_4764*(((-Dummy_4761 + jac_affine_inv_2_0_BLUE_DOWN*0.039933048641498423)*(-Dummy_4761 + jac_affine_inv_2_0_BLUE_DOWN*0.039933048641498423)) + ((-Dummy_4762 + jac_affine_inv_2_1_BLUE_DOWN*0.039933048641498423)*(-Dummy_4762 + jac_affine_inv_2_1_BLUE_DOWN*0.039933048641498423)) + ((-Dummy_4763 + jac_affine_inv_2_2_BLUE_DOWN*0.039933048641498423)*(-Dummy_4763 + jac_affine_inv_2_2_BLUE_DOWN*0.039933048641498423)))*0.016934591412496779 + Dummy_4769*(((-Dummy_4766 + jac_affine_inv_2_0_BLUE_DOWN*0.3817653560693467)*(-Dummy_4766 + jac_affine_inv_2_0_BLUE_DOWN*0.3817653560693467)) + ((-Dummy_4767 + jac_affine_inv_2_1_BLUE_DOWN*0.3817653560693467)*(-Dummy_4767 + jac_affine_inv_2_1_BLUE_DOWN*0.3817653560693467)) + ((-Dummy_4768 + jac_affine_inv_2_2_BLUE_DOWN*0.3817653560693467)*(-Dummy_4768 + jac_affine_inv_2_2_BLUE_DOWN*0.3817653560693467)))*0.046462929447761363 + Dummy_4774*(((-Dummy_4771 + jac_affine_inv_2_0_BLUE_DOWN*0.0069232355736274674)*(-Dummy_4771 + jac_affine_inv_2_0_BLUE_DOWN*0.0069232355736274674)) + ((-Dummy_4772 + jac_affine_inv_2_1_BLUE_DOWN*0.0069232355736274674)*(-Dummy_4772 + jac_affine_inv_2_1_BLUE_DOWN*0.0069232355736274674)) + ((-Dummy_4773 + jac_affine_inv_2_2_BLUE_DOWN*0.0069232355736274674)*(-Dummy_4773 + jac_affine_inv_2_2_BLUE_DOWN*0.0069232355736274674)))*0.05008682322282932 + Dummy_4779*(((-Dummy_4776 + jac_affine_inv_2_0_BLUE_DOWN*0.43070170707783612)*(-Dummy_4776 + jac_affine_inv_2_0_BLUE_DOWN*0.43070170707783612)) + ((-Dummy_4777 + jac_affine_inv_2_1_BLUE_DOWN*0.43070170707783612)*(-Dummy_4777 + jac_affine_inv_2_1_BLUE_DOWN*0.43070170707783612)) + ((-Dummy_4778 + jac_affine_inv_2_2_BLUE_DOWN*0.43070170707783612)*(-Dummy_4778 + jac_affine_inv_2_2_BLUE_DOWN*0.43070170707783612)))*0.053182322583579168;
             const walberla::float64 Dummy_4819 = Dummy_4758*Dummy_4780*0.016934591412496779 + Dummy_4764*(((-Dummy_4781 + jac_affine_inv_2_0_BLUE_DOWN*0.82157254096761978)*(-Dummy_4781 + jac_affine_inv_2_0_BLUE_DOWN*0.82157254096761978)) + ((-Dummy_4782 + jac_affine_inv_2_1_BLUE_DOWN*0.82157254096761978)*(-Dummy_4782 + jac_affine_inv_2_1_BLUE_DOWN*0.82157254096761978)) + ((-Dummy_4783 + jac_affine_inv_2_2_BLUE_DOWN*0.82157254096761978)*(-Dummy_4783 + jac_affine_inv_2_2_BLUE_DOWN*0.82157254096761978)))*0.016934591412496779 + Dummy_4765*Dummy_4780*0.046462929447761363 + Dummy_4769*(((-Dummy_4784 + jac_affine_inv_2_0_BLUE_DOWN*0.15593312049918601)*(-Dummy_4784 + jac_affine_inv_2_0_BLUE_DOWN*0.15593312049918601)) + ((-Dummy_4785 + jac_affine_inv_2_1_BLUE_DOWN*0.15593312049918601)*(-Dummy_4785 + jac_affine_inv_2_1_BLUE_DOWN*0.15593312049918601)) + ((-Dummy_4786 + jac_affine_inv_2_2_BLUE_DOWN*0.15593312049918601)*(-Dummy_4786 + jac_affine_inv_2_2_BLUE_DOWN*0.15593312049918601)))*0.046462929447761363 + Dummy_4770*Dummy_4780*0.05008682322282932 + Dummy_4774*(((-Dummy_4787 + jac_affine_inv_2_0_BLUE_DOWN*0.18002969351036541)*(-Dummy_4787 + jac_affine_inv_2_0_BLUE_DOWN*0.18002969351036541)) + ((-Dummy_4788 + jac_affine_inv_2_1_BLUE_DOWN*0.18002969351036541)*(-Dummy_4788 + jac_affine_inv_2_1_BLUE_DOWN*0.18002969351036541)) + ((-Dummy_4789 + jac_affine_inv_2_2_BLUE_DOWN*0.18002969351036541)*(-Dummy_4789 + jac_affine_inv_2_2_BLUE_DOWN*0.18002969351036541)))*0.05008682322282932 + Dummy_4775*Dummy_4780*0.053182322583579168 + Dummy_4779*(((-Dummy_4790 + jac_affine_inv_2_0_BLUE_DOWN*0.21607642918484779)*(-Dummy_4790 + jac_affine_inv_2_0_BLUE_DOWN*0.21607642918484779)) + ((-Dummy_4791 + jac_affine_inv_2_1_BLUE_DOWN*0.21607642918484779)*(-Dummy_4791 + jac_affine_inv_2_1_BLUE_DOWN*0.21607642918484779)) + ((-Dummy_4792 + jac_affine_inv_2_2_BLUE_DOWN*0.21607642918484779)*(-Dummy_4792 + jac_affine_inv_2_2_BLUE_DOWN*0.21607642918484779)))*0.053182322583579168;
             const walberla::float64 Dummy_4820 = Dummy_4758*Dummy_4793*0.016934591412496779 + Dummy_4764*(((-Dummy_4794 + jac_affine_inv_1_0_BLUE_DOWN*0.82157254096761978)*(-Dummy_4794 + jac_affine_inv_1_0_BLUE_DOWN*0.82157254096761978)) + ((-Dummy_4795 + jac_affine_inv_1_1_BLUE_DOWN*0.82157254096761978)*(-Dummy_4795 + jac_affine_inv_1_1_BLUE_DOWN*0.82157254096761978)) + ((-Dummy_4796 + jac_affine_inv_1_2_BLUE_DOWN*0.82157254096761978)*(-Dummy_4796 + jac_affine_inv_1_2_BLUE_DOWN*0.82157254096761978)))*0.016934591412496779 + Dummy_4765*Dummy_4793*0.046462929447761363 + Dummy_4769*(((-Dummy_4797 + jac_affine_inv_1_0_BLUE_DOWN*0.15593312049918601)*(-Dummy_4797 + jac_affine_inv_1_0_BLUE_DOWN*0.15593312049918601)) + ((-Dummy_4798 + jac_affine_inv_1_1_BLUE_DOWN*0.15593312049918601)*(-Dummy_4798 + jac_affine_inv_1_1_BLUE_DOWN*0.15593312049918601)) + ((-Dummy_4799 + jac_affine_inv_1_2_BLUE_DOWN*0.15593312049918601)*(-Dummy_4799 + jac_affine_inv_1_2_BLUE_DOWN*0.15593312049918601)))*0.046462929447761363 + Dummy_4770*Dummy_4793*0.05008682322282932 + Dummy_4774*(((-Dummy_4800 + jac_affine_inv_1_0_BLUE_DOWN*0.18002969351036541)*(-Dummy_4800 + jac_affine_inv_1_0_BLUE_DOWN*0.18002969351036541)) + ((-Dummy_4801 + jac_affine_inv_1_1_BLUE_DOWN*0.18002969351036541)*(-Dummy_4801 + jac_affine_inv_1_1_BLUE_DOWN*0.18002969351036541)) + ((-Dummy_4802 + jac_affine_inv_1_2_BLUE_DOWN*0.18002969351036541)*(-Dummy_4802 + jac_affine_inv_1_2_BLUE_DOWN*0.18002969351036541)))*0.05008682322282932 + Dummy_4775*Dummy_4793*0.053182322583579168 + Dummy_4779*(((-Dummy_4803 + jac_affine_inv_1_0_BLUE_DOWN*0.21607642918484779)*(-Dummy_4803 + jac_affine_inv_1_0_BLUE_DOWN*0.21607642918484779)) + ((-Dummy_4804 + jac_affine_inv_1_1_BLUE_DOWN*0.21607642918484779)*(-Dummy_4804 + jac_affine_inv_1_1_BLUE_DOWN*0.21607642918484779)) + ((-Dummy_4805 + jac_affine_inv_1_2_BLUE_DOWN*0.21607642918484779)*(-Dummy_4805 + jac_affine_inv_1_2_BLUE_DOWN*0.21607642918484779)))*0.053182322583579168;
             const walberla::float64 Dummy_4821 = Dummy_4758*Dummy_4812*0.016934591412496779 + Dummy_4764*(((Dummy_4761 + Dummy_4781 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_67)*(Dummy_4761 + Dummy_4781 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_67)) + ((Dummy_4762 + Dummy_4782 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_67)*(Dummy_4762 + Dummy_4782 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_67)) + ((Dummy_4763 + Dummy_4783 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_67)*(Dummy_4763 + Dummy_4783 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_67)))*0.016934591412496779 + Dummy_4765*Dummy_4812*0.046462929447761363 + Dummy_4769*(((Dummy_4766 + Dummy_4784 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_68)*(Dummy_4766 + Dummy_4784 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_68)) + ((Dummy_4767 + Dummy_4785 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_68)*(Dummy_4767 + Dummy_4785 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_68)) + ((Dummy_4768 + Dummy_4786 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_68)*(Dummy_4768 + Dummy_4786 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_68)))*0.046462929447761363 + Dummy_4770*Dummy_4812*0.05008682322282932 + Dummy_4774*(((Dummy_4771 + Dummy_4787 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_69)*(Dummy_4771 + Dummy_4787 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_69)) + ((Dummy_4772 + Dummy_4788 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_69)*(Dummy_4772 + Dummy_4788 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_69)) + ((Dummy_4773 + Dummy_4789 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_69)*(Dummy_4773 + Dummy_4789 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_69)))*0.05008682322282932 + Dummy_4775*Dummy_4812*0.053182322583579168 + Dummy_4779*(((Dummy_4776 + Dummy_4790 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_70)*(Dummy_4776 + Dummy_4790 + jac_affine_inv_2_0_BLUE_DOWN*tmp_kernel_op_70)) + ((Dummy_4777 + Dummy_4791 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_70)*(Dummy_4777 + Dummy_4791 + jac_affine_inv_2_1_BLUE_DOWN*tmp_kernel_op_70)) + ((Dummy_4778 + Dummy_4792 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_70)*(Dummy_4778 + Dummy_4792 + jac_affine_inv_2_2_BLUE_DOWN*tmp_kernel_op_70)))*0.053182322583579168;
             const walberla::float64 Dummy_4822 = Dummy_4758*Dummy_4816*0.016934591412496779 + Dummy_4764*(((Dummy_4794 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_0_BLUE_DOWN*0.039933048641498423)*(Dummy_4794 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_0_BLUE_DOWN*0.039933048641498423)) + ((Dummy_4795 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_1_BLUE_DOWN*0.039933048641498423)*(Dummy_4795 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_1_BLUE_DOWN*0.039933048641498423)) + ((Dummy_4796 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_2_BLUE_DOWN*0.039933048641498423)*(Dummy_4796 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_2_BLUE_DOWN*0.039933048641498423)))*0.016934591412496779 + Dummy_4765*Dummy_4816*0.046462929447761363 + Dummy_4769*(((Dummy_4797 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_0_BLUE_DOWN*0.3817653560693467)*(Dummy_4797 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_0_BLUE_DOWN*0.3817653560693467)) + ((Dummy_4798 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_1_BLUE_DOWN*0.3817653560693467)*(Dummy_4798 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_1_BLUE_DOWN*0.3817653560693467)) + ((Dummy_4799 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_2_BLUE_DOWN*0.3817653560693467)*(Dummy_4799 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_2_BLUE_DOWN*0.3817653560693467)))*0.046462929447761363 + Dummy_4770*Dummy_4816*0.05008682322282932 + Dummy_4774*(((Dummy_4800 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_0_BLUE_DOWN*0.0069232355736274674)*(Dummy_4800 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_0_BLUE_DOWN*0.0069232355736274674)) + ((Dummy_4801 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_1_BLUE_DOWN*0.0069232355736274674)*(Dummy_4801 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_1_BLUE_DOWN*0.0069232355736274674)) + ((Dummy_4802 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_2_BLUE_DOWN*0.0069232355736274674)*(Dummy_4802 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_2_BLUE_DOWN*0.0069232355736274674)))*0.05008682322282932 + Dummy_4775*Dummy_4816*0.053182322583579168 + Dummy_4779*(((Dummy_4803 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_0_BLUE_DOWN*0.43070170707783612)*(Dummy_4803 + jac_affine_inv_1_0_BLUE_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_0_BLUE_DOWN*0.43070170707783612)) + ((Dummy_4804 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_1_BLUE_DOWN*0.43070170707783612)*(Dummy_4804 + jac_affine_inv_1_1_BLUE_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_1_BLUE_DOWN*0.43070170707783612)) + ((Dummy_4805 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_2_BLUE_DOWN*0.43070170707783612)*(Dummy_4805 + jac_affine_inv_1_2_BLUE_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_2_BLUE_DOWN*0.43070170707783612)))*0.053182322583579168;
             const walberla::float64 Dummy_4823 = Dummy_4758*Dummy_4817*0.016934591412496779 + Dummy_4764*(((jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_0_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_0_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_0_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_0_BLUE_DOWN*0.82157254096761978)) + ((jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_1_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_1_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_1_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_1_BLUE_DOWN*0.82157254096761978)) + ((jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_2_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_2_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_2_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_2_BLUE_DOWN*0.82157254096761978)))*0.016934591412496779 + Dummy_4765*Dummy_4817*0.046462929447761363 + Dummy_4769*(((jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_0_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_0_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_0_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_0_BLUE_DOWN*0.15593312049918601)) + ((jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_1_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_1_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_1_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_1_BLUE_DOWN*0.15593312049918601)) + ((jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_2_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_2_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_2_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_2_BLUE_DOWN*0.15593312049918601)))*0.046462929447761363 + Dummy_4770*Dummy_4817*0.05008682322282932 + Dummy_4774*(((jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_0_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_0_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_0_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_0_BLUE_DOWN*0.18002969351036541)) + ((jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_1_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_1_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_1_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_1_BLUE_DOWN*0.18002969351036541)) + ((jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_2_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_2_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_2_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_2_BLUE_DOWN*0.18002969351036541)))*0.05008682322282932 + Dummy_4775*Dummy_4817*0.053182322583579168 + Dummy_4779*(((jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_0_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_0_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_BLUE_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_0_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_0_BLUE_DOWN*0.21607642918484779)) + ((jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_1_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_1_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_BLUE_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_1_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_1_BLUE_DOWN*0.21607642918484779)) + ((jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_2_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_2_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_BLUE_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_2_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_2_BLUE_DOWN*0.21607642918484779)))*0.053182322583579168;
             {
                {
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2] = Dummy_4818 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2] = Dummy_4819 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2] = Dummy_4820 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2];
                   _data_invDiag_[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = Dummy_4821 + _data_invDiag_[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2] = Dummy_4822 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = Dummy_4823 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                }
             }
             const walberla::float64 Dummy_4824 = _data_alpha[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const walberla::float64 Dummy_4825 = _data_alpha[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const walberla::float64 Dummy_4826 = _data_alpha[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const walberla::float64 Dummy_4827 = _data_alpha[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const walberla::float64 Dummy_4828 = _data_beta[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const walberla::float64 Dummy_4829 = _data_beta[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const walberla::float64 Dummy_4830 = _data_beta[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const walberla::float64 Dummy_4831 = _data_beta[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const walberla::float64 Dummy_4832 = Dummy_4824*tmp_kernel_op_2 + Dummy_4825*0.82157254096761978 + Dummy_4826*0.039933048641498423 + Dummy_4827*0.01482761006242336;
             const walberla::float64 Dummy_4833 = 1.0 / (abs_det_jac_affine_GREEN_UP);
             const walberla::float64 Dummy_4834 = Dummy_4833*((jac_affine_0_0_GREEN_UP*jac_affine_0_0_GREEN_UP)*4.0 + (jac_affine_1_0_GREEN_UP*jac_affine_1_0_GREEN_UP)*4.0 + (jac_affine_2_0_GREEN_UP*jac_affine_2_0_GREEN_UP)*4.0);
             const walberla::float64 Dummy_4835 = jac_affine_inv_1_0_GREEN_UP*0.01482761006242336;
             const walberla::float64 Dummy_4836 = jac_affine_inv_1_1_GREEN_UP*0.01482761006242336;
             const walberla::float64 Dummy_4837 = jac_affine_inv_1_2_GREEN_UP*0.01482761006242336;
             const walberla::float64 Dummy_4838 = abs_det_jac_affine_GREEN_UP*(Dummy_4828*tmp_kernel_op_2 + Dummy_4829*0.82157254096761978 + Dummy_4830*0.039933048641498423 + Dummy_4831*0.01482761006242336);
             const walberla::float64 Dummy_4839 = Dummy_4824*tmp_kernel_op_12 + Dummy_4825*0.15593312049918601 + Dummy_4826*0.3817653560693467 + Dummy_4827*0.0048399363458717648;
             const walberla::float64 Dummy_4840 = jac_affine_inv_1_0_GREEN_UP*0.0048399363458717648;
             const walberla::float64 Dummy_4841 = jac_affine_inv_1_1_GREEN_UP*0.0048399363458717648;
             const walberla::float64 Dummy_4842 = jac_affine_inv_1_2_GREEN_UP*0.0048399363458717648;
             const walberla::float64 Dummy_4843 = abs_det_jac_affine_GREEN_UP*(Dummy_4828*tmp_kernel_op_12 + Dummy_4829*0.15593312049918601 + Dummy_4830*0.3817653560693467 + Dummy_4831*0.0048399363458717648);
             const walberla::float64 Dummy_4844 = Dummy_4824*tmp_kernel_op_20 + Dummy_4825*0.18002969351036541 + Dummy_4826*0.0069232355736274674 + Dummy_4827*0.44773255210137269;
             const walberla::float64 Dummy_4845 = jac_affine_inv_1_0_GREEN_UP*0.44773255210137269;
             const walberla::float64 Dummy_4846 = jac_affine_inv_1_1_GREEN_UP*0.44773255210137269;
             const walberla::float64 Dummy_4847 = jac_affine_inv_1_2_GREEN_UP*0.44773255210137269;
             const walberla::float64 Dummy_4848 = abs_det_jac_affine_GREEN_UP*(Dummy_4828*tmp_kernel_op_20 + Dummy_4829*0.18002969351036541 + Dummy_4830*0.0069232355736274674 + Dummy_4831*0.44773255210137269);
             const walberla::float64 Dummy_4849 = Dummy_4824*tmp_kernel_op_28 + Dummy_4825*0.21607642918484779 + Dummy_4826*0.43070170707783612 + Dummy_4827*0.35284634870858678;
             const walberla::float64 Dummy_4850 = jac_affine_inv_1_0_GREEN_UP*0.35284634870858678;
             const walberla::float64 Dummy_4851 = jac_affine_inv_1_1_GREEN_UP*0.35284634870858678;
             const walberla::float64 Dummy_4852 = jac_affine_inv_1_2_GREEN_UP*0.35284634870858678;
             const walberla::float64 Dummy_4853 = abs_det_jac_affine_GREEN_UP*(Dummy_4828*tmp_kernel_op_28 + Dummy_4829*0.21607642918484779 + Dummy_4830*0.43070170707783612 + Dummy_4831*0.35284634870858678);
             const walberla::float64 Dummy_4854 = Dummy_4833*((jac_affine_0_1_GREEN_UP*jac_affine_0_1_GREEN_UP)*4.0 + (jac_affine_1_1_GREEN_UP*jac_affine_1_1_GREEN_UP)*4.0 + (jac_affine_2_1_GREEN_UP*jac_affine_2_1_GREEN_UP)*4.0);
             const walberla::float64 Dummy_4855 = jac_affine_inv_0_0_GREEN_UP*0.01482761006242336;
             const walberla::float64 Dummy_4856 = jac_affine_inv_0_1_GREEN_UP*0.01482761006242336;
             const walberla::float64 Dummy_4857 = jac_affine_inv_0_2_GREEN_UP*0.01482761006242336;
             const walberla::float64 Dummy_4858 = jac_affine_inv_0_0_GREEN_UP*0.0048399363458717648;
             const walberla::float64 Dummy_4859 = jac_affine_inv_0_1_GREEN_UP*0.0048399363458717648;
             const walberla::float64 Dummy_4860 = jac_affine_inv_0_2_GREEN_UP*0.0048399363458717648;
             const walberla::float64 Dummy_4861 = jac_affine_inv_0_0_GREEN_UP*0.44773255210137269;
             const walberla::float64 Dummy_4862 = jac_affine_inv_0_1_GREEN_UP*0.44773255210137269;
             const walberla::float64 Dummy_4863 = jac_affine_inv_0_2_GREEN_UP*0.44773255210137269;
             const walberla::float64 Dummy_4864 = jac_affine_inv_0_0_GREEN_UP*0.35284634870858678;
             const walberla::float64 Dummy_4865 = jac_affine_inv_0_1_GREEN_UP*0.35284634870858678;
             const walberla::float64 Dummy_4866 = jac_affine_inv_0_2_GREEN_UP*0.35284634870858678;
             const walberla::float64 Dummy_4867 = Dummy_4833*((jac_affine_0_2_GREEN_UP*jac_affine_0_2_GREEN_UP)*4.0 + (jac_affine_1_2_GREEN_UP*jac_affine_1_2_GREEN_UP)*4.0 + (jac_affine_2_2_GREEN_UP*jac_affine_2_2_GREEN_UP)*4.0);
             const walberla::float64 Dummy_4868 = jac_affine_inv_0_0_GREEN_UP*0.039933048641498423;
             const walberla::float64 Dummy_4869 = jac_affine_inv_0_1_GREEN_UP*0.039933048641498423;
             const walberla::float64 Dummy_4870 = jac_affine_inv_0_2_GREEN_UP*0.039933048641498423;
             const walberla::float64 Dummy_4871 = jac_affine_inv_0_0_GREEN_UP*0.3817653560693467;
             const walberla::float64 Dummy_4872 = jac_affine_inv_0_1_GREEN_UP*0.3817653560693467;
             const walberla::float64 Dummy_4873 = jac_affine_inv_0_2_GREEN_UP*0.3817653560693467;
             const walberla::float64 Dummy_4874 = jac_affine_inv_0_0_GREEN_UP*0.0069232355736274674;
             const walberla::float64 Dummy_4875 = jac_affine_inv_0_1_GREEN_UP*0.0069232355736274674;
             const walberla::float64 Dummy_4876 = jac_affine_inv_0_2_GREEN_UP*0.0069232355736274674;
             const walberla::float64 Dummy_4877 = jac_affine_inv_0_0_GREEN_UP*0.43070170707783612;
             const walberla::float64 Dummy_4878 = jac_affine_inv_0_1_GREEN_UP*0.43070170707783612;
             const walberla::float64 Dummy_4879 = jac_affine_inv_0_2_GREEN_UP*0.43070170707783612;
             const walberla::float64 Dummy_4880 = jac_affine_0_0_GREEN_UP*2.0;
             const walberla::float64 Dummy_4881 = jac_affine_0_1_GREEN_UP*2.0;
             const walberla::float64 Dummy_4882 = jac_affine_1_0_GREEN_UP*2.0;
             const walberla::float64 Dummy_4883 = jac_affine_1_1_GREEN_UP*2.0;
             const walberla::float64 Dummy_4884 = jac_affine_2_0_GREEN_UP*2.0;
             const walberla::float64 Dummy_4885 = jac_affine_2_1_GREEN_UP*2.0;
             const walberla::float64 Dummy_4886 = Dummy_4833*(((-Dummy_4880 + Dummy_4881)*(-Dummy_4880 + Dummy_4881)) + ((-Dummy_4882 + Dummy_4883)*(-Dummy_4882 + Dummy_4883)) + ((-Dummy_4884 + Dummy_4885)*(-Dummy_4884 + Dummy_4885)));
             const walberla::float64 Dummy_4887 = jac_affine_0_2_GREEN_UP*-2.0;
             const walberla::float64 Dummy_4888 = jac_affine_1_2_GREEN_UP*-2.0;
             const walberla::float64 Dummy_4889 = jac_affine_2_2_GREEN_UP*-2.0;
             const walberla::float64 Dummy_4890 = Dummy_4833*(((Dummy_4880 + Dummy_4887)*(Dummy_4880 + Dummy_4887)) + ((Dummy_4882 + Dummy_4888)*(Dummy_4882 + Dummy_4888)) + ((Dummy_4884 + Dummy_4889)*(Dummy_4884 + Dummy_4889)));
             const walberla::float64 Dummy_4891 = Dummy_4833*(((-Dummy_4881 - Dummy_4887)*(-Dummy_4881 - Dummy_4887)) + ((-Dummy_4883 - Dummy_4888)*(-Dummy_4883 - Dummy_4888)) + ((-Dummy_4885 - Dummy_4889)*(-Dummy_4885 - Dummy_4889)));
             const walberla::float64 Dummy_4892 = Dummy_4832*Dummy_4834*0.016934591412496779 + Dummy_4834*Dummy_4839*0.046462929447761363 + Dummy_4834*Dummy_4844*0.05008682322282932 + Dummy_4834*Dummy_4849*0.053182322583579168 + Dummy_4838*(((-Dummy_4835 + jac_affine_inv_2_0_GREEN_UP*0.039933048641498423)*(-Dummy_4835 + jac_affine_inv_2_0_GREEN_UP*0.039933048641498423)) + ((-Dummy_4836 + jac_affine_inv_2_1_GREEN_UP*0.039933048641498423)*(-Dummy_4836 + jac_affine_inv_2_1_GREEN_UP*0.039933048641498423)) + ((-Dummy_4837 + jac_affine_inv_2_2_GREEN_UP*0.039933048641498423)*(-Dummy_4837 + jac_affine_inv_2_2_GREEN_UP*0.039933048641498423)))*0.016934591412496779 + Dummy_4843*(((-Dummy_4840 + jac_affine_inv_2_0_GREEN_UP*0.3817653560693467)*(-Dummy_4840 + jac_affine_inv_2_0_GREEN_UP*0.3817653560693467)) + ((-Dummy_4841 + jac_affine_inv_2_1_GREEN_UP*0.3817653560693467)*(-Dummy_4841 + jac_affine_inv_2_1_GREEN_UP*0.3817653560693467)) + ((-Dummy_4842 + jac_affine_inv_2_2_GREEN_UP*0.3817653560693467)*(-Dummy_4842 + jac_affine_inv_2_2_GREEN_UP*0.3817653560693467)))*0.046462929447761363 + Dummy_4848*(((-Dummy_4845 + jac_affine_inv_2_0_GREEN_UP*0.0069232355736274674)*(-Dummy_4845 + jac_affine_inv_2_0_GREEN_UP*0.0069232355736274674)) + ((-Dummy_4846 + jac_affine_inv_2_1_GREEN_UP*0.0069232355736274674)*(-Dummy_4846 + jac_affine_inv_2_1_GREEN_UP*0.0069232355736274674)) + ((-Dummy_4847 + jac_affine_inv_2_2_GREEN_UP*0.0069232355736274674)*(-Dummy_4847 + jac_affine_inv_2_2_GREEN_UP*0.0069232355736274674)))*0.05008682322282932 + Dummy_4853*(((-Dummy_4850 + jac_affine_inv_2_0_GREEN_UP*0.43070170707783612)*(-Dummy_4850 + jac_affine_inv_2_0_GREEN_UP*0.43070170707783612)) + ((-Dummy_4851 + jac_affine_inv_2_1_GREEN_UP*0.43070170707783612)*(-Dummy_4851 + jac_affine_inv_2_1_GREEN_UP*0.43070170707783612)) + ((-Dummy_4852 + jac_affine_inv_2_2_GREEN_UP*0.43070170707783612)*(-Dummy_4852 + jac_affine_inv_2_2_GREEN_UP*0.43070170707783612)))*0.053182322583579168;
             const walberla::float64 Dummy_4893 = Dummy_4832*Dummy_4854*0.016934591412496779 + Dummy_4838*(((-Dummy_4855 + jac_affine_inv_2_0_GREEN_UP*0.82157254096761978)*(-Dummy_4855 + jac_affine_inv_2_0_GREEN_UP*0.82157254096761978)) + ((-Dummy_4856 + jac_affine_inv_2_1_GREEN_UP*0.82157254096761978)*(-Dummy_4856 + jac_affine_inv_2_1_GREEN_UP*0.82157254096761978)) + ((-Dummy_4857 + jac_affine_inv_2_2_GREEN_UP*0.82157254096761978)*(-Dummy_4857 + jac_affine_inv_2_2_GREEN_UP*0.82157254096761978)))*0.016934591412496779 + Dummy_4839*Dummy_4854*0.046462929447761363 + Dummy_4843*(((-Dummy_4858 + jac_affine_inv_2_0_GREEN_UP*0.15593312049918601)*(-Dummy_4858 + jac_affine_inv_2_0_GREEN_UP*0.15593312049918601)) + ((-Dummy_4859 + jac_affine_inv_2_1_GREEN_UP*0.15593312049918601)*(-Dummy_4859 + jac_affine_inv_2_1_GREEN_UP*0.15593312049918601)) + ((-Dummy_4860 + jac_affine_inv_2_2_GREEN_UP*0.15593312049918601)*(-Dummy_4860 + jac_affine_inv_2_2_GREEN_UP*0.15593312049918601)))*0.046462929447761363 + Dummy_4844*Dummy_4854*0.05008682322282932 + Dummy_4848*(((-Dummy_4861 + jac_affine_inv_2_0_GREEN_UP*0.18002969351036541)*(-Dummy_4861 + jac_affine_inv_2_0_GREEN_UP*0.18002969351036541)) + ((-Dummy_4862 + jac_affine_inv_2_1_GREEN_UP*0.18002969351036541)*(-Dummy_4862 + jac_affine_inv_2_1_GREEN_UP*0.18002969351036541)) + ((-Dummy_4863 + jac_affine_inv_2_2_GREEN_UP*0.18002969351036541)*(-Dummy_4863 + jac_affine_inv_2_2_GREEN_UP*0.18002969351036541)))*0.05008682322282932 + Dummy_4849*Dummy_4854*0.053182322583579168 + Dummy_4853*(((-Dummy_4864 + jac_affine_inv_2_0_GREEN_UP*0.21607642918484779)*(-Dummy_4864 + jac_affine_inv_2_0_GREEN_UP*0.21607642918484779)) + ((-Dummy_4865 + jac_affine_inv_2_1_GREEN_UP*0.21607642918484779)*(-Dummy_4865 + jac_affine_inv_2_1_GREEN_UP*0.21607642918484779)) + ((-Dummy_4866 + jac_affine_inv_2_2_GREEN_UP*0.21607642918484779)*(-Dummy_4866 + jac_affine_inv_2_2_GREEN_UP*0.21607642918484779)))*0.053182322583579168;
             const walberla::float64 Dummy_4894 = Dummy_4832*Dummy_4867*0.016934591412496779 + Dummy_4838*(((-Dummy_4868 + jac_affine_inv_1_0_GREEN_UP*0.82157254096761978)*(-Dummy_4868 + jac_affine_inv_1_0_GREEN_UP*0.82157254096761978)) + ((-Dummy_4869 + jac_affine_inv_1_1_GREEN_UP*0.82157254096761978)*(-Dummy_4869 + jac_affine_inv_1_1_GREEN_UP*0.82157254096761978)) + ((-Dummy_4870 + jac_affine_inv_1_2_GREEN_UP*0.82157254096761978)*(-Dummy_4870 + jac_affine_inv_1_2_GREEN_UP*0.82157254096761978)))*0.016934591412496779 + Dummy_4839*Dummy_4867*0.046462929447761363 + Dummy_4843*(((-Dummy_4871 + jac_affine_inv_1_0_GREEN_UP*0.15593312049918601)*(-Dummy_4871 + jac_affine_inv_1_0_GREEN_UP*0.15593312049918601)) + ((-Dummy_4872 + jac_affine_inv_1_1_GREEN_UP*0.15593312049918601)*(-Dummy_4872 + jac_affine_inv_1_1_GREEN_UP*0.15593312049918601)) + ((-Dummy_4873 + jac_affine_inv_1_2_GREEN_UP*0.15593312049918601)*(-Dummy_4873 + jac_affine_inv_1_2_GREEN_UP*0.15593312049918601)))*0.046462929447761363 + Dummy_4844*Dummy_4867*0.05008682322282932 + Dummy_4848*(((-Dummy_4874 + jac_affine_inv_1_0_GREEN_UP*0.18002969351036541)*(-Dummy_4874 + jac_affine_inv_1_0_GREEN_UP*0.18002969351036541)) + ((-Dummy_4875 + jac_affine_inv_1_1_GREEN_UP*0.18002969351036541)*(-Dummy_4875 + jac_affine_inv_1_1_GREEN_UP*0.18002969351036541)) + ((-Dummy_4876 + jac_affine_inv_1_2_GREEN_UP*0.18002969351036541)*(-Dummy_4876 + jac_affine_inv_1_2_GREEN_UP*0.18002969351036541)))*0.05008682322282932 + Dummy_4849*Dummy_4867*0.053182322583579168 + Dummy_4853*(((-Dummy_4877 + jac_affine_inv_1_0_GREEN_UP*0.21607642918484779)*(-Dummy_4877 + jac_affine_inv_1_0_GREEN_UP*0.21607642918484779)) + ((-Dummy_4878 + jac_affine_inv_1_1_GREEN_UP*0.21607642918484779)*(-Dummy_4878 + jac_affine_inv_1_1_GREEN_UP*0.21607642918484779)) + ((-Dummy_4879 + jac_affine_inv_1_2_GREEN_UP*0.21607642918484779)*(-Dummy_4879 + jac_affine_inv_1_2_GREEN_UP*0.21607642918484779)))*0.053182322583579168;
             const walberla::float64 Dummy_4895 = Dummy_4832*Dummy_4886*0.016934591412496779 + Dummy_4838*(((Dummy_4835 + Dummy_4855 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_67)*(Dummy_4835 + Dummy_4855 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_67)) + ((Dummy_4836 + Dummy_4856 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_67)*(Dummy_4836 + Dummy_4856 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_67)) + ((Dummy_4837 + Dummy_4857 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_67)*(Dummy_4837 + Dummy_4857 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_67)))*0.016934591412496779 + Dummy_4839*Dummy_4886*0.046462929447761363 + Dummy_4843*(((Dummy_4840 + Dummy_4858 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_68)*(Dummy_4840 + Dummy_4858 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_68)) + ((Dummy_4841 + Dummy_4859 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_68)*(Dummy_4841 + Dummy_4859 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_68)) + ((Dummy_4842 + Dummy_4860 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_68)*(Dummy_4842 + Dummy_4860 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_68)))*0.046462929447761363 + Dummy_4844*Dummy_4886*0.05008682322282932 + Dummy_4848*(((Dummy_4845 + Dummy_4861 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_69)*(Dummy_4845 + Dummy_4861 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_69)) + ((Dummy_4846 + Dummy_4862 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_69)*(Dummy_4846 + Dummy_4862 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_69)) + ((Dummy_4847 + Dummy_4863 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_69)*(Dummy_4847 + Dummy_4863 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_69)))*0.05008682322282932 + Dummy_4849*Dummy_4886*0.053182322583579168 + Dummy_4853*(((Dummy_4850 + Dummy_4864 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_70)*(Dummy_4850 + Dummy_4864 + jac_affine_inv_2_0_GREEN_UP*tmp_kernel_op_70)) + ((Dummy_4851 + Dummy_4865 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_70)*(Dummy_4851 + Dummy_4865 + jac_affine_inv_2_1_GREEN_UP*tmp_kernel_op_70)) + ((Dummy_4852 + Dummy_4866 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_70)*(Dummy_4852 + Dummy_4866 + jac_affine_inv_2_2_GREEN_UP*tmp_kernel_op_70)))*0.053182322583579168;
             const walberla::float64 Dummy_4896 = Dummy_4832*Dummy_4890*0.016934591412496779 + Dummy_4838*(((Dummy_4868 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_75 + jac_affine_inv_2_0_GREEN_UP*0.039933048641498423)*(Dummy_4868 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_75 + jac_affine_inv_2_0_GREEN_UP*0.039933048641498423)) + ((Dummy_4869 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_75 + jac_affine_inv_2_1_GREEN_UP*0.039933048641498423)*(Dummy_4869 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_75 + jac_affine_inv_2_1_GREEN_UP*0.039933048641498423)) + ((Dummy_4870 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_75 + jac_affine_inv_2_2_GREEN_UP*0.039933048641498423)*(Dummy_4870 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_75 + jac_affine_inv_2_2_GREEN_UP*0.039933048641498423)))*0.016934591412496779 + Dummy_4839*Dummy_4890*0.046462929447761363 + Dummy_4843*(((Dummy_4871 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_76 + jac_affine_inv_2_0_GREEN_UP*0.3817653560693467)*(Dummy_4871 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_76 + jac_affine_inv_2_0_GREEN_UP*0.3817653560693467)) + ((Dummy_4872 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_76 + jac_affine_inv_2_1_GREEN_UP*0.3817653560693467)*(Dummy_4872 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_76 + jac_affine_inv_2_1_GREEN_UP*0.3817653560693467)) + ((Dummy_4873 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_76 + jac_affine_inv_2_2_GREEN_UP*0.3817653560693467)*(Dummy_4873 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_76 + jac_affine_inv_2_2_GREEN_UP*0.3817653560693467)))*0.046462929447761363 + Dummy_4844*Dummy_4890*0.05008682322282932 + Dummy_4848*(((Dummy_4874 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_77 + jac_affine_inv_2_0_GREEN_UP*0.0069232355736274674)*(Dummy_4874 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_77 + jac_affine_inv_2_0_GREEN_UP*0.0069232355736274674)) + ((Dummy_4875 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_77 + jac_affine_inv_2_1_GREEN_UP*0.0069232355736274674)*(Dummy_4875 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_77 + jac_affine_inv_2_1_GREEN_UP*0.0069232355736274674)) + ((Dummy_4876 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_77 + jac_affine_inv_2_2_GREEN_UP*0.0069232355736274674)*(Dummy_4876 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_77 + jac_affine_inv_2_2_GREEN_UP*0.0069232355736274674)))*0.05008682322282932 + Dummy_4849*Dummy_4890*0.053182322583579168 + Dummy_4853*(((Dummy_4877 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_78 + jac_affine_inv_2_0_GREEN_UP*0.43070170707783612)*(Dummy_4877 + jac_affine_inv_1_0_GREEN_UP*tmp_kernel_op_78 + jac_affine_inv_2_0_GREEN_UP*0.43070170707783612)) + ((Dummy_4878 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_78 + jac_affine_inv_2_1_GREEN_UP*0.43070170707783612)*(Dummy_4878 + jac_affine_inv_1_1_GREEN_UP*tmp_kernel_op_78 + jac_affine_inv_2_1_GREEN_UP*0.43070170707783612)) + ((Dummy_4879 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_78 + jac_affine_inv_2_2_GREEN_UP*0.43070170707783612)*(Dummy_4879 + jac_affine_inv_1_2_GREEN_UP*tmp_kernel_op_78 + jac_affine_inv_2_2_GREEN_UP*0.43070170707783612)))*0.053182322583579168;
             const walberla::float64 Dummy_4897 = Dummy_4832*Dummy_4891*0.016934591412496779 + Dummy_4838*(((jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_80 + jac_affine_inv_1_0_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_0_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_80 + jac_affine_inv_1_0_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_0_GREEN_UP*0.82157254096761978)) + ((jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_80 + jac_affine_inv_1_1_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_1_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_80 + jac_affine_inv_1_1_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_1_GREEN_UP*0.82157254096761978)) + ((jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_80 + jac_affine_inv_1_2_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_2_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_80 + jac_affine_inv_1_2_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_2_GREEN_UP*0.82157254096761978)))*0.016934591412496779 + Dummy_4839*Dummy_4891*0.046462929447761363 + Dummy_4843*(((jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_81 + jac_affine_inv_1_0_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_0_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_81 + jac_affine_inv_1_0_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_0_GREEN_UP*0.15593312049918601)) + ((jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_81 + jac_affine_inv_1_1_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_1_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_81 + jac_affine_inv_1_1_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_1_GREEN_UP*0.15593312049918601)) + ((jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_81 + jac_affine_inv_1_2_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_2_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_81 + jac_affine_inv_1_2_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_2_GREEN_UP*0.15593312049918601)))*0.046462929447761363 + Dummy_4844*Dummy_4891*0.05008682322282932 + Dummy_4848*(((jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_82 + jac_affine_inv_1_0_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_0_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_82 + jac_affine_inv_1_0_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_0_GREEN_UP*0.18002969351036541)) + ((jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_82 + jac_affine_inv_1_1_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_1_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_82 + jac_affine_inv_1_1_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_1_GREEN_UP*0.18002969351036541)) + ((jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_82 + jac_affine_inv_1_2_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_2_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_82 + jac_affine_inv_1_2_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_2_GREEN_UP*0.18002969351036541)))*0.05008682322282932 + Dummy_4849*Dummy_4891*0.053182322583579168 + Dummy_4853*(((jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_83 + jac_affine_inv_1_0_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_0_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_0_GREEN_UP*tmp_kernel_op_83 + jac_affine_inv_1_0_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_0_GREEN_UP*0.21607642918484779)) + ((jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_83 + jac_affine_inv_1_1_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_1_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_1_GREEN_UP*tmp_kernel_op_83 + jac_affine_inv_1_1_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_1_GREEN_UP*0.21607642918484779)) + ((jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_83 + jac_affine_inv_1_2_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_2_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_2_GREEN_UP*tmp_kernel_op_83 + jac_affine_inv_1_2_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_2_GREEN_UP*0.21607642918484779)))*0.053182322583579168;
             {
                {
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2] = Dummy_4892 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2] = Dummy_4893 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = Dummy_4894 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1] = Dummy_4895 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = Dummy_4896 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = Dummy_4897 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                }
             }
             const walberla::float64 Dummy_4898 = _data_alpha[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const walberla::float64 Dummy_4899 = _data_alpha[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const walberla::float64 Dummy_4900 = _data_alpha[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const walberla::float64 Dummy_4901 = _data_alpha[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const walberla::float64 Dummy_4902 = _data_beta[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const walberla::float64 Dummy_4903 = _data_beta[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const walberla::float64 Dummy_4904 = _data_beta[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1];
             const walberla::float64 Dummy_4905 = _data_beta[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 2];
             const walberla::float64 Dummy_4906 = Dummy_4898*tmp_kernel_op_2 + Dummy_4899*0.82157254096761978 + Dummy_4900*0.039933048641498423 + Dummy_4901*0.01482761006242336;
             const walberla::float64 Dummy_4907 = 1.0 / (abs_det_jac_affine_GREEN_DOWN);
             const walberla::float64 Dummy_4908 = Dummy_4907*((jac_affine_0_0_GREEN_DOWN*jac_affine_0_0_GREEN_DOWN)*4.0 + (jac_affine_1_0_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN)*4.0 + (jac_affine_2_0_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN)*4.0);
             const walberla::float64 Dummy_4909 = jac_affine_inv_1_0_GREEN_DOWN*0.01482761006242336;
             const walberla::float64 Dummy_4910 = jac_affine_inv_1_1_GREEN_DOWN*0.01482761006242336;
             const walberla::float64 Dummy_4911 = jac_affine_inv_1_2_GREEN_DOWN*0.01482761006242336;
             const walberla::float64 Dummy_4912 = abs_det_jac_affine_GREEN_DOWN*(Dummy_4902*tmp_kernel_op_2 + Dummy_4903*0.82157254096761978 + Dummy_4904*0.039933048641498423 + Dummy_4905*0.01482761006242336);
             const walberla::float64 Dummy_4913 = Dummy_4898*tmp_kernel_op_12 + Dummy_4899*0.15593312049918601 + Dummy_4900*0.3817653560693467 + Dummy_4901*0.0048399363458717648;
             const walberla::float64 Dummy_4914 = jac_affine_inv_1_0_GREEN_DOWN*0.0048399363458717648;
             const walberla::float64 Dummy_4915 = jac_affine_inv_1_1_GREEN_DOWN*0.0048399363458717648;
             const walberla::float64 Dummy_4916 = jac_affine_inv_1_2_GREEN_DOWN*0.0048399363458717648;
             const walberla::float64 Dummy_4917 = abs_det_jac_affine_GREEN_DOWN*(Dummy_4902*tmp_kernel_op_12 + Dummy_4903*0.15593312049918601 + Dummy_4904*0.3817653560693467 + Dummy_4905*0.0048399363458717648);
             const walberla::float64 Dummy_4918 = Dummy_4898*tmp_kernel_op_20 + Dummy_4899*0.18002969351036541 + Dummy_4900*0.0069232355736274674 + Dummy_4901*0.44773255210137269;
             const walberla::float64 Dummy_4919 = jac_affine_inv_1_0_GREEN_DOWN*0.44773255210137269;
             const walberla::float64 Dummy_4920 = jac_affine_inv_1_1_GREEN_DOWN*0.44773255210137269;
             const walberla::float64 Dummy_4921 = jac_affine_inv_1_2_GREEN_DOWN*0.44773255210137269;
             const walberla::float64 Dummy_4922 = abs_det_jac_affine_GREEN_DOWN*(Dummy_4902*tmp_kernel_op_20 + Dummy_4903*0.18002969351036541 + Dummy_4904*0.0069232355736274674 + Dummy_4905*0.44773255210137269);
             const walberla::float64 Dummy_4923 = Dummy_4898*tmp_kernel_op_28 + Dummy_4899*0.21607642918484779 + Dummy_4900*0.43070170707783612 + Dummy_4901*0.35284634870858678;
             const walberla::float64 Dummy_4924 = jac_affine_inv_1_0_GREEN_DOWN*0.35284634870858678;
             const walberla::float64 Dummy_4925 = jac_affine_inv_1_1_GREEN_DOWN*0.35284634870858678;
             const walberla::float64 Dummy_4926 = jac_affine_inv_1_2_GREEN_DOWN*0.35284634870858678;
             const walberla::float64 Dummy_4927 = abs_det_jac_affine_GREEN_DOWN*(Dummy_4902*tmp_kernel_op_28 + Dummy_4903*0.21607642918484779 + Dummy_4904*0.43070170707783612 + Dummy_4905*0.35284634870858678);
             const walberla::float64 Dummy_4928 = Dummy_4907*((jac_affine_0_1_GREEN_DOWN*jac_affine_0_1_GREEN_DOWN)*4.0 + (jac_affine_1_1_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN)*4.0 + (jac_affine_2_1_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN)*4.0);
             const walberla::float64 Dummy_4929 = jac_affine_inv_0_0_GREEN_DOWN*0.01482761006242336;
             const walberla::float64 Dummy_4930 = jac_affine_inv_0_1_GREEN_DOWN*0.01482761006242336;
             const walberla::float64 Dummy_4931 = jac_affine_inv_0_2_GREEN_DOWN*0.01482761006242336;
             const walberla::float64 Dummy_4932 = jac_affine_inv_0_0_GREEN_DOWN*0.0048399363458717648;
             const walberla::float64 Dummy_4933 = jac_affine_inv_0_1_GREEN_DOWN*0.0048399363458717648;
             const walberla::float64 Dummy_4934 = jac_affine_inv_0_2_GREEN_DOWN*0.0048399363458717648;
             const walberla::float64 Dummy_4935 = jac_affine_inv_0_0_GREEN_DOWN*0.44773255210137269;
             const walberla::float64 Dummy_4936 = jac_affine_inv_0_1_GREEN_DOWN*0.44773255210137269;
             const walberla::float64 Dummy_4937 = jac_affine_inv_0_2_GREEN_DOWN*0.44773255210137269;
             const walberla::float64 Dummy_4938 = jac_affine_inv_0_0_GREEN_DOWN*0.35284634870858678;
             const walberla::float64 Dummy_4939 = jac_affine_inv_0_1_GREEN_DOWN*0.35284634870858678;
             const walberla::float64 Dummy_4940 = jac_affine_inv_0_2_GREEN_DOWN*0.35284634870858678;
             const walberla::float64 Dummy_4941 = Dummy_4907*((jac_affine_0_2_GREEN_DOWN*jac_affine_0_2_GREEN_DOWN)*4.0 + (jac_affine_1_2_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN)*4.0 + (jac_affine_2_2_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN)*4.0);
             const walberla::float64 Dummy_4942 = jac_affine_inv_0_0_GREEN_DOWN*0.039933048641498423;
             const walberla::float64 Dummy_4943 = jac_affine_inv_0_1_GREEN_DOWN*0.039933048641498423;
             const walberla::float64 Dummy_4944 = jac_affine_inv_0_2_GREEN_DOWN*0.039933048641498423;
             const walberla::float64 Dummy_4945 = jac_affine_inv_0_0_GREEN_DOWN*0.3817653560693467;
             const walberla::float64 Dummy_4946 = jac_affine_inv_0_1_GREEN_DOWN*0.3817653560693467;
             const walberla::float64 Dummy_4947 = jac_affine_inv_0_2_GREEN_DOWN*0.3817653560693467;
             const walberla::float64 Dummy_4948 = jac_affine_inv_0_0_GREEN_DOWN*0.0069232355736274674;
             const walberla::float64 Dummy_4949 = jac_affine_inv_0_1_GREEN_DOWN*0.0069232355736274674;
             const walberla::float64 Dummy_4950 = jac_affine_inv_0_2_GREEN_DOWN*0.0069232355736274674;
             const walberla::float64 Dummy_4951 = jac_affine_inv_0_0_GREEN_DOWN*0.43070170707783612;
             const walberla::float64 Dummy_4952 = jac_affine_inv_0_1_GREEN_DOWN*0.43070170707783612;
             const walberla::float64 Dummy_4953 = jac_affine_inv_0_2_GREEN_DOWN*0.43070170707783612;
             const walberla::float64 Dummy_4954 = jac_affine_0_0_GREEN_DOWN*2.0;
             const walberla::float64 Dummy_4955 = jac_affine_0_1_GREEN_DOWN*2.0;
             const walberla::float64 Dummy_4956 = jac_affine_1_0_GREEN_DOWN*2.0;
             const walberla::float64 Dummy_4957 = jac_affine_1_1_GREEN_DOWN*2.0;
             const walberla::float64 Dummy_4958 = jac_affine_2_0_GREEN_DOWN*2.0;
             const walberla::float64 Dummy_4959 = jac_affine_2_1_GREEN_DOWN*2.0;
             const walberla::float64 Dummy_4960 = Dummy_4907*(((-Dummy_4954 + Dummy_4955)*(-Dummy_4954 + Dummy_4955)) + ((-Dummy_4956 + Dummy_4957)*(-Dummy_4956 + Dummy_4957)) + ((-Dummy_4958 + Dummy_4959)*(-Dummy_4958 + Dummy_4959)));
             const walberla::float64 Dummy_4961 = jac_affine_0_2_GREEN_DOWN*-2.0;
             const walberla::float64 Dummy_4962 = jac_affine_1_2_GREEN_DOWN*-2.0;
             const walberla::float64 Dummy_4963 = jac_affine_2_2_GREEN_DOWN*-2.0;
             const walberla::float64 Dummy_4964 = Dummy_4907*(((Dummy_4954 + Dummy_4961)*(Dummy_4954 + Dummy_4961)) + ((Dummy_4956 + Dummy_4962)*(Dummy_4956 + Dummy_4962)) + ((Dummy_4958 + Dummy_4963)*(Dummy_4958 + Dummy_4963)));
             const walberla::float64 Dummy_4965 = Dummy_4907*(((-Dummy_4955 - Dummy_4961)*(-Dummy_4955 - Dummy_4961)) + ((-Dummy_4957 - Dummy_4962)*(-Dummy_4957 - Dummy_4962)) + ((-Dummy_4959 - Dummy_4963)*(-Dummy_4959 - Dummy_4963)));
             const walberla::float64 Dummy_4966 = Dummy_4906*Dummy_4908*0.016934591412496779 + Dummy_4908*Dummy_4913*0.046462929447761363 + Dummy_4908*Dummy_4918*0.05008682322282932 + Dummy_4908*Dummy_4923*0.053182322583579168 + Dummy_4912*(((-Dummy_4909 + jac_affine_inv_2_0_GREEN_DOWN*0.039933048641498423)*(-Dummy_4909 + jac_affine_inv_2_0_GREEN_DOWN*0.039933048641498423)) + ((-Dummy_4910 + jac_affine_inv_2_1_GREEN_DOWN*0.039933048641498423)*(-Dummy_4910 + jac_affine_inv_2_1_GREEN_DOWN*0.039933048641498423)) + ((-Dummy_4911 + jac_affine_inv_2_2_GREEN_DOWN*0.039933048641498423)*(-Dummy_4911 + jac_affine_inv_2_2_GREEN_DOWN*0.039933048641498423)))*0.016934591412496779 + Dummy_4917*(((-Dummy_4914 + jac_affine_inv_2_0_GREEN_DOWN*0.3817653560693467)*(-Dummy_4914 + jac_affine_inv_2_0_GREEN_DOWN*0.3817653560693467)) + ((-Dummy_4915 + jac_affine_inv_2_1_GREEN_DOWN*0.3817653560693467)*(-Dummy_4915 + jac_affine_inv_2_1_GREEN_DOWN*0.3817653560693467)) + ((-Dummy_4916 + jac_affine_inv_2_2_GREEN_DOWN*0.3817653560693467)*(-Dummy_4916 + jac_affine_inv_2_2_GREEN_DOWN*0.3817653560693467)))*0.046462929447761363 + Dummy_4922*(((-Dummy_4919 + jac_affine_inv_2_0_GREEN_DOWN*0.0069232355736274674)*(-Dummy_4919 + jac_affine_inv_2_0_GREEN_DOWN*0.0069232355736274674)) + ((-Dummy_4920 + jac_affine_inv_2_1_GREEN_DOWN*0.0069232355736274674)*(-Dummy_4920 + jac_affine_inv_2_1_GREEN_DOWN*0.0069232355736274674)) + ((-Dummy_4921 + jac_affine_inv_2_2_GREEN_DOWN*0.0069232355736274674)*(-Dummy_4921 + jac_affine_inv_2_2_GREEN_DOWN*0.0069232355736274674)))*0.05008682322282932 + Dummy_4927*(((-Dummy_4924 + jac_affine_inv_2_0_GREEN_DOWN*0.43070170707783612)*(-Dummy_4924 + jac_affine_inv_2_0_GREEN_DOWN*0.43070170707783612)) + ((-Dummy_4925 + jac_affine_inv_2_1_GREEN_DOWN*0.43070170707783612)*(-Dummy_4925 + jac_affine_inv_2_1_GREEN_DOWN*0.43070170707783612)) + ((-Dummy_4926 + jac_affine_inv_2_2_GREEN_DOWN*0.43070170707783612)*(-Dummy_4926 + jac_affine_inv_2_2_GREEN_DOWN*0.43070170707783612)))*0.053182322583579168;
             const walberla::float64 Dummy_4967 = Dummy_4906*Dummy_4928*0.016934591412496779 + Dummy_4912*(((-Dummy_4929 + jac_affine_inv_2_0_GREEN_DOWN*0.82157254096761978)*(-Dummy_4929 + jac_affine_inv_2_0_GREEN_DOWN*0.82157254096761978)) + ((-Dummy_4930 + jac_affine_inv_2_1_GREEN_DOWN*0.82157254096761978)*(-Dummy_4930 + jac_affine_inv_2_1_GREEN_DOWN*0.82157254096761978)) + ((-Dummy_4931 + jac_affine_inv_2_2_GREEN_DOWN*0.82157254096761978)*(-Dummy_4931 + jac_affine_inv_2_2_GREEN_DOWN*0.82157254096761978)))*0.016934591412496779 + Dummy_4913*Dummy_4928*0.046462929447761363 + Dummy_4917*(((-Dummy_4932 + jac_affine_inv_2_0_GREEN_DOWN*0.15593312049918601)*(-Dummy_4932 + jac_affine_inv_2_0_GREEN_DOWN*0.15593312049918601)) + ((-Dummy_4933 + jac_affine_inv_2_1_GREEN_DOWN*0.15593312049918601)*(-Dummy_4933 + jac_affine_inv_2_1_GREEN_DOWN*0.15593312049918601)) + ((-Dummy_4934 + jac_affine_inv_2_2_GREEN_DOWN*0.15593312049918601)*(-Dummy_4934 + jac_affine_inv_2_2_GREEN_DOWN*0.15593312049918601)))*0.046462929447761363 + Dummy_4918*Dummy_4928*0.05008682322282932 + Dummy_4922*(((-Dummy_4935 + jac_affine_inv_2_0_GREEN_DOWN*0.18002969351036541)*(-Dummy_4935 + jac_affine_inv_2_0_GREEN_DOWN*0.18002969351036541)) + ((-Dummy_4936 + jac_affine_inv_2_1_GREEN_DOWN*0.18002969351036541)*(-Dummy_4936 + jac_affine_inv_2_1_GREEN_DOWN*0.18002969351036541)) + ((-Dummy_4937 + jac_affine_inv_2_2_GREEN_DOWN*0.18002969351036541)*(-Dummy_4937 + jac_affine_inv_2_2_GREEN_DOWN*0.18002969351036541)))*0.05008682322282932 + Dummy_4923*Dummy_4928*0.053182322583579168 + Dummy_4927*(((-Dummy_4938 + jac_affine_inv_2_0_GREEN_DOWN*0.21607642918484779)*(-Dummy_4938 + jac_affine_inv_2_0_GREEN_DOWN*0.21607642918484779)) + ((-Dummy_4939 + jac_affine_inv_2_1_GREEN_DOWN*0.21607642918484779)*(-Dummy_4939 + jac_affine_inv_2_1_GREEN_DOWN*0.21607642918484779)) + ((-Dummy_4940 + jac_affine_inv_2_2_GREEN_DOWN*0.21607642918484779)*(-Dummy_4940 + jac_affine_inv_2_2_GREEN_DOWN*0.21607642918484779)))*0.053182322583579168;
             const walberla::float64 Dummy_4968 = Dummy_4906*Dummy_4941*0.016934591412496779 + Dummy_4912*(((-Dummy_4942 + jac_affine_inv_1_0_GREEN_DOWN*0.82157254096761978)*(-Dummy_4942 + jac_affine_inv_1_0_GREEN_DOWN*0.82157254096761978)) + ((-Dummy_4943 + jac_affine_inv_1_1_GREEN_DOWN*0.82157254096761978)*(-Dummy_4943 + jac_affine_inv_1_1_GREEN_DOWN*0.82157254096761978)) + ((-Dummy_4944 + jac_affine_inv_1_2_GREEN_DOWN*0.82157254096761978)*(-Dummy_4944 + jac_affine_inv_1_2_GREEN_DOWN*0.82157254096761978)))*0.016934591412496779 + Dummy_4913*Dummy_4941*0.046462929447761363 + Dummy_4917*(((-Dummy_4945 + jac_affine_inv_1_0_GREEN_DOWN*0.15593312049918601)*(-Dummy_4945 + jac_affine_inv_1_0_GREEN_DOWN*0.15593312049918601)) + ((-Dummy_4946 + jac_affine_inv_1_1_GREEN_DOWN*0.15593312049918601)*(-Dummy_4946 + jac_affine_inv_1_1_GREEN_DOWN*0.15593312049918601)) + ((-Dummy_4947 + jac_affine_inv_1_2_GREEN_DOWN*0.15593312049918601)*(-Dummy_4947 + jac_affine_inv_1_2_GREEN_DOWN*0.15593312049918601)))*0.046462929447761363 + Dummy_4918*Dummy_4941*0.05008682322282932 + Dummy_4922*(((-Dummy_4948 + jac_affine_inv_1_0_GREEN_DOWN*0.18002969351036541)*(-Dummy_4948 + jac_affine_inv_1_0_GREEN_DOWN*0.18002969351036541)) + ((-Dummy_4949 + jac_affine_inv_1_1_GREEN_DOWN*0.18002969351036541)*(-Dummy_4949 + jac_affine_inv_1_1_GREEN_DOWN*0.18002969351036541)) + ((-Dummy_4950 + jac_affine_inv_1_2_GREEN_DOWN*0.18002969351036541)*(-Dummy_4950 + jac_affine_inv_1_2_GREEN_DOWN*0.18002969351036541)))*0.05008682322282932 + Dummy_4923*Dummy_4941*0.053182322583579168 + Dummy_4927*(((-Dummy_4951 + jac_affine_inv_1_0_GREEN_DOWN*0.21607642918484779)*(-Dummy_4951 + jac_affine_inv_1_0_GREEN_DOWN*0.21607642918484779)) + ((-Dummy_4952 + jac_affine_inv_1_1_GREEN_DOWN*0.21607642918484779)*(-Dummy_4952 + jac_affine_inv_1_1_GREEN_DOWN*0.21607642918484779)) + ((-Dummy_4953 + jac_affine_inv_1_2_GREEN_DOWN*0.21607642918484779)*(-Dummy_4953 + jac_affine_inv_1_2_GREEN_DOWN*0.21607642918484779)))*0.053182322583579168;
             const walberla::float64 Dummy_4969 = Dummy_4906*Dummy_4960*0.016934591412496779 + Dummy_4912*(((Dummy_4909 + Dummy_4929 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_67)*(Dummy_4909 + Dummy_4929 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_67)) + ((Dummy_4910 + Dummy_4930 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_67)*(Dummy_4910 + Dummy_4930 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_67)) + ((Dummy_4911 + Dummy_4931 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_67)*(Dummy_4911 + Dummy_4931 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_67)))*0.016934591412496779 + Dummy_4913*Dummy_4960*0.046462929447761363 + Dummy_4917*(((Dummy_4914 + Dummy_4932 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_68)*(Dummy_4914 + Dummy_4932 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_68)) + ((Dummy_4915 + Dummy_4933 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_68)*(Dummy_4915 + Dummy_4933 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_68)) + ((Dummy_4916 + Dummy_4934 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_68)*(Dummy_4916 + Dummy_4934 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_68)))*0.046462929447761363 + Dummy_4918*Dummy_4960*0.05008682322282932 + Dummy_4922*(((Dummy_4919 + Dummy_4935 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_69)*(Dummy_4919 + Dummy_4935 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_69)) + ((Dummy_4920 + Dummy_4936 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_69)*(Dummy_4920 + Dummy_4936 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_69)) + ((Dummy_4921 + Dummy_4937 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_69)*(Dummy_4921 + Dummy_4937 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_69)))*0.05008682322282932 + Dummy_4923*Dummy_4960*0.053182322583579168 + Dummy_4927*(((Dummy_4924 + Dummy_4938 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_70)*(Dummy_4924 + Dummy_4938 + jac_affine_inv_2_0_GREEN_DOWN*tmp_kernel_op_70)) + ((Dummy_4925 + Dummy_4939 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_70)*(Dummy_4925 + Dummy_4939 + jac_affine_inv_2_1_GREEN_DOWN*tmp_kernel_op_70)) + ((Dummy_4926 + Dummy_4940 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_70)*(Dummy_4926 + Dummy_4940 + jac_affine_inv_2_2_GREEN_DOWN*tmp_kernel_op_70)))*0.053182322583579168;
             const walberla::float64 Dummy_4970 = Dummy_4906*Dummy_4964*0.016934591412496779 + Dummy_4912*(((Dummy_4942 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_0_GREEN_DOWN*0.039933048641498423)*(Dummy_4942 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_0_GREEN_DOWN*0.039933048641498423)) + ((Dummy_4943 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_1_GREEN_DOWN*0.039933048641498423)*(Dummy_4943 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_1_GREEN_DOWN*0.039933048641498423)) + ((Dummy_4944 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_2_GREEN_DOWN*0.039933048641498423)*(Dummy_4944 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_75 + jac_affine_inv_2_2_GREEN_DOWN*0.039933048641498423)))*0.016934591412496779 + Dummy_4913*Dummy_4964*0.046462929447761363 + Dummy_4917*(((Dummy_4945 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_0_GREEN_DOWN*0.3817653560693467)*(Dummy_4945 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_0_GREEN_DOWN*0.3817653560693467)) + ((Dummy_4946 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_1_GREEN_DOWN*0.3817653560693467)*(Dummy_4946 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_1_GREEN_DOWN*0.3817653560693467)) + ((Dummy_4947 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_2_GREEN_DOWN*0.3817653560693467)*(Dummy_4947 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_76 + jac_affine_inv_2_2_GREEN_DOWN*0.3817653560693467)))*0.046462929447761363 + Dummy_4918*Dummy_4964*0.05008682322282932 + Dummy_4922*(((Dummy_4948 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_0_GREEN_DOWN*0.0069232355736274674)*(Dummy_4948 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_0_GREEN_DOWN*0.0069232355736274674)) + ((Dummy_4949 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_1_GREEN_DOWN*0.0069232355736274674)*(Dummy_4949 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_1_GREEN_DOWN*0.0069232355736274674)) + ((Dummy_4950 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_2_GREEN_DOWN*0.0069232355736274674)*(Dummy_4950 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_77 + jac_affine_inv_2_2_GREEN_DOWN*0.0069232355736274674)))*0.05008682322282932 + Dummy_4923*Dummy_4964*0.053182322583579168 + Dummy_4927*(((Dummy_4951 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_0_GREEN_DOWN*0.43070170707783612)*(Dummy_4951 + jac_affine_inv_1_0_GREEN_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_0_GREEN_DOWN*0.43070170707783612)) + ((Dummy_4952 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_1_GREEN_DOWN*0.43070170707783612)*(Dummy_4952 + jac_affine_inv_1_1_GREEN_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_1_GREEN_DOWN*0.43070170707783612)) + ((Dummy_4953 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_2_GREEN_DOWN*0.43070170707783612)*(Dummy_4953 + jac_affine_inv_1_2_GREEN_DOWN*tmp_kernel_op_78 + jac_affine_inv_2_2_GREEN_DOWN*0.43070170707783612)))*0.053182322583579168;
             const walberla::float64 Dummy_4971 = Dummy_4906*Dummy_4965*0.016934591412496779 + Dummy_4912*(((jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_0_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_0_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_0_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_0_GREEN_DOWN*0.82157254096761978)) + ((jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_1_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_1_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_1_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_1_GREEN_DOWN*0.82157254096761978)) + ((jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_2_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_2_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_80 + jac_affine_inv_1_2_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_2_GREEN_DOWN*0.82157254096761978)))*0.016934591412496779 + Dummy_4913*Dummy_4965*0.046462929447761363 + Dummy_4917*(((jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_0_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_0_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_0_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_0_GREEN_DOWN*0.15593312049918601)) + ((jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_1_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_1_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_1_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_1_GREEN_DOWN*0.15593312049918601)) + ((jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_2_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_2_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_81 + jac_affine_inv_1_2_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_2_GREEN_DOWN*0.15593312049918601)))*0.046462929447761363 + Dummy_4918*Dummy_4965*0.05008682322282932 + Dummy_4922*(((jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_0_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_0_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_0_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_0_GREEN_DOWN*0.18002969351036541)) + ((jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_1_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_1_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_1_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_1_GREEN_DOWN*0.18002969351036541)) + ((jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_2_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_2_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_82 + jac_affine_inv_1_2_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_2_GREEN_DOWN*0.18002969351036541)))*0.05008682322282932 + Dummy_4923*Dummy_4965*0.053182322583579168 + Dummy_4927*(((jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_0_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_0_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_GREEN_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_0_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_0_GREEN_DOWN*0.21607642918484779)) + ((jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_1_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_1_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_GREEN_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_1_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_1_GREEN_DOWN*0.21607642918484779)) + ((jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_2_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_2_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_GREEN_DOWN*tmp_kernel_op_83 + jac_affine_inv_1_2_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_2_GREEN_DOWN*0.21607642918484779)))*0.053182322583579168;
             {
                {
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2] = Dummy_4966 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2];
                   _data_invDiag_[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = Dummy_4967 + _data_invDiag_[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1] = Dummy_4968 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1];
                   _data_invDiag_[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = Dummy_4969 + _data_invDiag_[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2] = Dummy_4970 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) - 2];
                   _data_invDiag_[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2] = Dummy_4971 + _data_invDiag_[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 2];
                }
             }
          } 
          const walberla::float64 alpha_dof_0 = _data_alpha[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
          const walberla::float64 alpha_dof_1 = _data_alpha[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
          const walberla::float64 alpha_dof_2 = _data_alpha[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
          const walberla::float64 alpha_dof_3 = _data_alpha[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1];
          const walberla::float64 beta_dof_0 = _data_beta[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
          const walberla::float64 beta_dof_1 = _data_beta[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
          const walberla::float64 beta_dof_2 = _data_beta[-ctr_1 - ctr_2 + micro_edges_per_macro_edge + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) - 1];
          const walberla::float64 beta_dof_3 = _data_beta[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - 1];
          const walberla::float64 tmp_kernel_op_3 = alpha_dof_0*tmp_kernel_op_2 + alpha_dof_1*0.82157254096761978 + alpha_dof_2*0.039933048641498423 + alpha_dof_3*0.01482761006242336;
          const walberla::float64 tmp_kernel_op_9 = abs_det_jac_affine_WHITE_UP*(beta_dof_0*tmp_kernel_op_2 + beta_dof_1*0.82157254096761978 + beta_dof_2*0.039933048641498423 + beta_dof_3*0.01482761006242336);
          const walberla::float64 tmp_kernel_op_13 = alpha_dof_0*tmp_kernel_op_12 + alpha_dof_1*0.15593312049918601 + alpha_dof_2*0.3817653560693467 + alpha_dof_3*0.0048399363458717648;
          const walberla::float64 tmp_kernel_op_17 = abs_det_jac_affine_WHITE_UP*(beta_dof_0*tmp_kernel_op_12 + beta_dof_1*0.15593312049918601 + beta_dof_2*0.3817653560693467 + beta_dof_3*0.0048399363458717648);
          const walberla::float64 tmp_kernel_op_21 = alpha_dof_0*tmp_kernel_op_20 + alpha_dof_1*0.18002969351036541 + alpha_dof_2*0.0069232355736274674 + alpha_dof_3*0.44773255210137269;
          const walberla::float64 tmp_kernel_op_25 = abs_det_jac_affine_WHITE_UP*(beta_dof_0*tmp_kernel_op_20 + beta_dof_1*0.18002969351036541 + beta_dof_2*0.0069232355736274674 + beta_dof_3*0.44773255210137269);
          const walberla::float64 tmp_kernel_op_29 = alpha_dof_0*tmp_kernel_op_28 + alpha_dof_1*0.21607642918484779 + alpha_dof_2*0.43070170707783612 + alpha_dof_3*0.35284634870858678;
          const walberla::float64 tmp_kernel_op_33 = abs_det_jac_affine_WHITE_UP*(beta_dof_0*tmp_kernel_op_28 + beta_dof_1*0.21607642918484779 + beta_dof_2*0.43070170707783612 + beta_dof_3*0.35284634870858678);
          const walberla::float64 elMatDiag_0 = tmp_kernel_op_13*tmp_kernel_op_5*0.046462929447761363 + tmp_kernel_op_17*(((jac_affine_inv_2_0_WHITE_UP*0.3817653560693467 - tmp_kernel_op_14)*(jac_affine_inv_2_0_WHITE_UP*0.3817653560693467 - tmp_kernel_op_14)) + ((jac_affine_inv_2_1_WHITE_UP*0.3817653560693467 - tmp_kernel_op_15)*(jac_affine_inv_2_1_WHITE_UP*0.3817653560693467 - tmp_kernel_op_15)) + ((jac_affine_inv_2_2_WHITE_UP*0.3817653560693467 - tmp_kernel_op_16)*(jac_affine_inv_2_2_WHITE_UP*0.3817653560693467 - tmp_kernel_op_16)))*0.046462929447761363 + tmp_kernel_op_21*tmp_kernel_op_5*0.05008682322282932 + tmp_kernel_op_25*(((jac_affine_inv_2_0_WHITE_UP*0.0069232355736274674 - tmp_kernel_op_22)*(jac_affine_inv_2_0_WHITE_UP*0.0069232355736274674 - tmp_kernel_op_22)) + ((jac_affine_inv_2_1_WHITE_UP*0.0069232355736274674 - tmp_kernel_op_23)*(jac_affine_inv_2_1_WHITE_UP*0.0069232355736274674 - tmp_kernel_op_23)) + ((jac_affine_inv_2_2_WHITE_UP*0.0069232355736274674 - tmp_kernel_op_24)*(jac_affine_inv_2_2_WHITE_UP*0.0069232355736274674 - tmp_kernel_op_24)))*0.05008682322282932 + tmp_kernel_op_29*tmp_kernel_op_5*0.053182322583579168 + tmp_kernel_op_3*tmp_kernel_op_5*0.016934591412496779 + tmp_kernel_op_33*(((jac_affine_inv_2_0_WHITE_UP*0.43070170707783612 - tmp_kernel_op_30)*(jac_affine_inv_2_0_WHITE_UP*0.43070170707783612 - tmp_kernel_op_30)) + ((jac_affine_inv_2_1_WHITE_UP*0.43070170707783612 - tmp_kernel_op_31)*(jac_affine_inv_2_1_WHITE_UP*0.43070170707783612 - tmp_kernel_op_31)) + ((jac_affine_inv_2_2_WHITE_UP*0.43070170707783612 - tmp_kernel_op_32)*(jac_affine_inv_2_2_WHITE_UP*0.43070170707783612 - tmp_kernel_op_32)))*0.053182322583579168 + tmp_kernel_op_9*(((jac_affine_inv_2_0_WHITE_UP*0.039933048641498423 - tmp_kernel_op_6)*(jac_affine_inv_2_0_WHITE_UP*0.039933048641498423 - tmp_kernel_op_6)) + ((jac_affine_inv_2_1_WHITE_UP*0.039933048641498423 - tmp_kernel_op_7)*(jac_affine_inv_2_1_WHITE_UP*0.039933048641498423 - tmp_kernel_op_7)) + ((jac_affine_inv_2_2_WHITE_UP*0.039933048641498423 - tmp_kernel_op_8)*(jac_affine_inv_2_2_WHITE_UP*0.039933048641498423 - tmp_kernel_op_8)))*0.016934591412496779;
          const walberla::float64 elMatDiag_1 = tmp_kernel_op_13*tmp_kernel_op_34*0.046462929447761363 + tmp_kernel_op_17*(((jac_affine_inv_2_0_WHITE_UP*0.15593312049918601 - tmp_kernel_op_38)*(jac_affine_inv_2_0_WHITE_UP*0.15593312049918601 - tmp_kernel_op_38)) + ((jac_affine_inv_2_1_WHITE_UP*0.15593312049918601 - tmp_kernel_op_39)*(jac_affine_inv_2_1_WHITE_UP*0.15593312049918601 - tmp_kernel_op_39)) + ((jac_affine_inv_2_2_WHITE_UP*0.15593312049918601 - tmp_kernel_op_40)*(jac_affine_inv_2_2_WHITE_UP*0.15593312049918601 - tmp_kernel_op_40)))*0.046462929447761363 + tmp_kernel_op_21*tmp_kernel_op_34*0.05008682322282932 + tmp_kernel_op_25*(((jac_affine_inv_2_0_WHITE_UP*0.18002969351036541 - tmp_kernel_op_41)*(jac_affine_inv_2_0_WHITE_UP*0.18002969351036541 - tmp_kernel_op_41)) + ((jac_affine_inv_2_1_WHITE_UP*0.18002969351036541 - tmp_kernel_op_42)*(jac_affine_inv_2_1_WHITE_UP*0.18002969351036541 - tmp_kernel_op_42)) + ((jac_affine_inv_2_2_WHITE_UP*0.18002969351036541 - tmp_kernel_op_43)*(jac_affine_inv_2_2_WHITE_UP*0.18002969351036541 - tmp_kernel_op_43)))*0.05008682322282932 + tmp_kernel_op_29*tmp_kernel_op_34*0.053182322583579168 + tmp_kernel_op_3*tmp_kernel_op_34*0.016934591412496779 + tmp_kernel_op_33*(((jac_affine_inv_2_0_WHITE_UP*0.21607642918484779 - tmp_kernel_op_44)*(jac_affine_inv_2_0_WHITE_UP*0.21607642918484779 - tmp_kernel_op_44)) + ((jac_affine_inv_2_1_WHITE_UP*0.21607642918484779 - tmp_kernel_op_45)*(jac_affine_inv_2_1_WHITE_UP*0.21607642918484779 - tmp_kernel_op_45)) + ((jac_affine_inv_2_2_WHITE_UP*0.21607642918484779 - tmp_kernel_op_46)*(jac_affine_inv_2_2_WHITE_UP*0.21607642918484779 - tmp_kernel_op_46)))*0.053182322583579168 + tmp_kernel_op_9*(((jac_affine_inv_2_0_WHITE_UP*0.82157254096761978 - tmp_kernel_op_35)*(jac_affine_inv_2_0_WHITE_UP*0.82157254096761978 - tmp_kernel_op_35)) + ((jac_affine_inv_2_1_WHITE_UP*0.82157254096761978 - tmp_kernel_op_36)*(jac_affine_inv_2_1_WHITE_UP*0.82157254096761978 - tmp_kernel_op_36)) + ((jac_affine_inv_2_2_WHITE_UP*0.82157254096761978 - tmp_kernel_op_37)*(jac_affine_inv_2_2_WHITE_UP*0.82157254096761978 - tmp_kernel_op_37)))*0.016934591412496779;
          const walberla::float64 elMatDiag_2 = tmp_kernel_op_13*tmp_kernel_op_47*0.046462929447761363 + tmp_kernel_op_17*(((jac_affine_inv_1_0_WHITE_UP*0.15593312049918601 - tmp_kernel_op_51)*(jac_affine_inv_1_0_WHITE_UP*0.15593312049918601 - tmp_kernel_op_51)) + ((jac_affine_inv_1_1_WHITE_UP*0.15593312049918601 - tmp_kernel_op_52)*(jac_affine_inv_1_1_WHITE_UP*0.15593312049918601 - tmp_kernel_op_52)) + ((jac_affine_inv_1_2_WHITE_UP*0.15593312049918601 - tmp_kernel_op_53)*(jac_affine_inv_1_2_WHITE_UP*0.15593312049918601 - tmp_kernel_op_53)))*0.046462929447761363 + tmp_kernel_op_21*tmp_kernel_op_47*0.05008682322282932 + tmp_kernel_op_25*(((jac_affine_inv_1_0_WHITE_UP*0.18002969351036541 - tmp_kernel_op_54)*(jac_affine_inv_1_0_WHITE_UP*0.18002969351036541 - tmp_kernel_op_54)) + ((jac_affine_inv_1_1_WHITE_UP*0.18002969351036541 - tmp_kernel_op_55)*(jac_affine_inv_1_1_WHITE_UP*0.18002969351036541 - tmp_kernel_op_55)) + ((jac_affine_inv_1_2_WHITE_UP*0.18002969351036541 - tmp_kernel_op_56)*(jac_affine_inv_1_2_WHITE_UP*0.18002969351036541 - tmp_kernel_op_56)))*0.05008682322282932 + tmp_kernel_op_29*tmp_kernel_op_47*0.053182322583579168 + tmp_kernel_op_3*tmp_kernel_op_47*0.016934591412496779 + tmp_kernel_op_33*(((jac_affine_inv_1_0_WHITE_UP*0.21607642918484779 - tmp_kernel_op_57)*(jac_affine_inv_1_0_WHITE_UP*0.21607642918484779 - tmp_kernel_op_57)) + ((jac_affine_inv_1_1_WHITE_UP*0.21607642918484779 - tmp_kernel_op_58)*(jac_affine_inv_1_1_WHITE_UP*0.21607642918484779 - tmp_kernel_op_58)) + ((jac_affine_inv_1_2_WHITE_UP*0.21607642918484779 - tmp_kernel_op_59)*(jac_affine_inv_1_2_WHITE_UP*0.21607642918484779 - tmp_kernel_op_59)))*0.053182322583579168 + tmp_kernel_op_9*(((jac_affine_inv_1_0_WHITE_UP*0.82157254096761978 - tmp_kernel_op_48)*(jac_affine_inv_1_0_WHITE_UP*0.82157254096761978 - tmp_kernel_op_48)) + ((jac_affine_inv_1_1_WHITE_UP*0.82157254096761978 - tmp_kernel_op_49)*(jac_affine_inv_1_1_WHITE_UP*0.82157254096761978 - tmp_kernel_op_49)) + ((jac_affine_inv_1_2_WHITE_UP*0.82157254096761978 - tmp_kernel_op_50)*(jac_affine_inv_1_2_WHITE_UP*0.82157254096761978 - tmp_kernel_op_50)))*0.016934591412496779;
          const walberla::float64 elMatDiag_3 = tmp_kernel_op_13*tmp_kernel_op_66*0.046462929447761363 + tmp_kernel_op_17*(((jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_68 + tmp_kernel_op_14 + tmp_kernel_op_38)*(jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_68 + tmp_kernel_op_14 + tmp_kernel_op_38)) + ((jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_68 + tmp_kernel_op_15 + tmp_kernel_op_39)*(jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_68 + tmp_kernel_op_15 + tmp_kernel_op_39)) + ((jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_68 + tmp_kernel_op_16 + tmp_kernel_op_40)*(jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_68 + tmp_kernel_op_16 + tmp_kernel_op_40)))*0.046462929447761363 + tmp_kernel_op_21*tmp_kernel_op_66*0.05008682322282932 + tmp_kernel_op_25*(((jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_69 + tmp_kernel_op_22 + tmp_kernel_op_41)*(jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_69 + tmp_kernel_op_22 + tmp_kernel_op_41)) + ((jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_69 + tmp_kernel_op_23 + tmp_kernel_op_42)*(jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_69 + tmp_kernel_op_23 + tmp_kernel_op_42)) + ((jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_69 + tmp_kernel_op_24 + tmp_kernel_op_43)*(jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_69 + tmp_kernel_op_24 + tmp_kernel_op_43)))*0.05008682322282932 + tmp_kernel_op_29*tmp_kernel_op_66*0.053182322583579168 + tmp_kernel_op_3*tmp_kernel_op_66*0.016934591412496779 + tmp_kernel_op_33*(((jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_70 + tmp_kernel_op_30 + tmp_kernel_op_44)*(jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_70 + tmp_kernel_op_30 + tmp_kernel_op_44)) + ((jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_70 + tmp_kernel_op_31 + tmp_kernel_op_45)*(jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_70 + tmp_kernel_op_31 + tmp_kernel_op_45)) + ((jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_70 + tmp_kernel_op_32 + tmp_kernel_op_46)*(jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_70 + tmp_kernel_op_32 + tmp_kernel_op_46)))*0.053182322583579168 + tmp_kernel_op_9*(((jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_67 + tmp_kernel_op_35 + tmp_kernel_op_6)*(jac_affine_inv_2_0_WHITE_UP*tmp_kernel_op_67 + tmp_kernel_op_35 + tmp_kernel_op_6)) + ((jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_67 + tmp_kernel_op_36 + tmp_kernel_op_7)*(jac_affine_inv_2_1_WHITE_UP*tmp_kernel_op_67 + tmp_kernel_op_36 + tmp_kernel_op_7)) + ((jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_67 + tmp_kernel_op_37 + tmp_kernel_op_8)*(jac_affine_inv_2_2_WHITE_UP*tmp_kernel_op_67 + tmp_kernel_op_37 + tmp_kernel_op_8)))*0.016934591412496779;
          const walberla::float64 elMatDiag_4 = tmp_kernel_op_13*tmp_kernel_op_74*0.046462929447761363 + tmp_kernel_op_17*(((jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_76 + jac_affine_inv_2_0_WHITE_UP*0.3817653560693467 + tmp_kernel_op_51)*(jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_76 + jac_affine_inv_2_0_WHITE_UP*0.3817653560693467 + tmp_kernel_op_51)) + ((jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_76 + jac_affine_inv_2_1_WHITE_UP*0.3817653560693467 + tmp_kernel_op_52)*(jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_76 + jac_affine_inv_2_1_WHITE_UP*0.3817653560693467 + tmp_kernel_op_52)) + ((jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_76 + jac_affine_inv_2_2_WHITE_UP*0.3817653560693467 + tmp_kernel_op_53)*(jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_76 + jac_affine_inv_2_2_WHITE_UP*0.3817653560693467 + tmp_kernel_op_53)))*0.046462929447761363 + tmp_kernel_op_21*tmp_kernel_op_74*0.05008682322282932 + tmp_kernel_op_25*(((jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_77 + jac_affine_inv_2_0_WHITE_UP*0.0069232355736274674 + tmp_kernel_op_54)*(jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_77 + jac_affine_inv_2_0_WHITE_UP*0.0069232355736274674 + tmp_kernel_op_54)) + ((jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_77 + jac_affine_inv_2_1_WHITE_UP*0.0069232355736274674 + tmp_kernel_op_55)*(jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_77 + jac_affine_inv_2_1_WHITE_UP*0.0069232355736274674 + tmp_kernel_op_55)) + ((jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_77 + jac_affine_inv_2_2_WHITE_UP*0.0069232355736274674 + tmp_kernel_op_56)*(jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_77 + jac_affine_inv_2_2_WHITE_UP*0.0069232355736274674 + tmp_kernel_op_56)))*0.05008682322282932 + tmp_kernel_op_29*tmp_kernel_op_74*0.053182322583579168 + tmp_kernel_op_3*tmp_kernel_op_74*0.016934591412496779 + tmp_kernel_op_33*(((jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_78 + jac_affine_inv_2_0_WHITE_UP*0.43070170707783612 + tmp_kernel_op_57)*(jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_78 + jac_affine_inv_2_0_WHITE_UP*0.43070170707783612 + tmp_kernel_op_57)) + ((jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_78 + jac_affine_inv_2_1_WHITE_UP*0.43070170707783612 + tmp_kernel_op_58)*(jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_78 + jac_affine_inv_2_1_WHITE_UP*0.43070170707783612 + tmp_kernel_op_58)) + ((jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_78 + jac_affine_inv_2_2_WHITE_UP*0.43070170707783612 + tmp_kernel_op_59)*(jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_78 + jac_affine_inv_2_2_WHITE_UP*0.43070170707783612 + tmp_kernel_op_59)))*0.053182322583579168 + tmp_kernel_op_9*(((jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_75 + jac_affine_inv_2_0_WHITE_UP*0.039933048641498423 + tmp_kernel_op_48)*(jac_affine_inv_1_0_WHITE_UP*tmp_kernel_op_75 + jac_affine_inv_2_0_WHITE_UP*0.039933048641498423 + tmp_kernel_op_48)) + ((jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_75 + jac_affine_inv_2_1_WHITE_UP*0.039933048641498423 + tmp_kernel_op_49)*(jac_affine_inv_1_1_WHITE_UP*tmp_kernel_op_75 + jac_affine_inv_2_1_WHITE_UP*0.039933048641498423 + tmp_kernel_op_49)) + ((jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_75 + jac_affine_inv_2_2_WHITE_UP*0.039933048641498423 + tmp_kernel_op_50)*(jac_affine_inv_1_2_WHITE_UP*tmp_kernel_op_75 + jac_affine_inv_2_2_WHITE_UP*0.039933048641498423 + tmp_kernel_op_50)))*0.016934591412496779;
          const walberla::float64 elMatDiag_5 = tmp_kernel_op_13*tmp_kernel_op_79*0.046462929447761363 + tmp_kernel_op_17*(((jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_81 + jac_affine_inv_1_0_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_0_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_81 + jac_affine_inv_1_0_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_0_WHITE_UP*0.15593312049918601)) + ((jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_81 + jac_affine_inv_1_1_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_1_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_81 + jac_affine_inv_1_1_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_1_WHITE_UP*0.15593312049918601)) + ((jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_81 + jac_affine_inv_1_2_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_2_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_81 + jac_affine_inv_1_2_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_2_WHITE_UP*0.15593312049918601)))*0.046462929447761363 + tmp_kernel_op_21*tmp_kernel_op_79*0.05008682322282932 + tmp_kernel_op_25*(((jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_82 + jac_affine_inv_1_0_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_0_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_82 + jac_affine_inv_1_0_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_0_WHITE_UP*0.18002969351036541)) + ((jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_82 + jac_affine_inv_1_1_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_1_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_82 + jac_affine_inv_1_1_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_1_WHITE_UP*0.18002969351036541)) + ((jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_82 + jac_affine_inv_1_2_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_2_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_82 + jac_affine_inv_1_2_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_2_WHITE_UP*0.18002969351036541)))*0.05008682322282932 + tmp_kernel_op_29*tmp_kernel_op_79*0.053182322583579168 + tmp_kernel_op_3*tmp_kernel_op_79*0.016934591412496779 + tmp_kernel_op_33*(((jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_83 + jac_affine_inv_1_0_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_0_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_83 + jac_affine_inv_1_0_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_0_WHITE_UP*0.21607642918484779)) + ((jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_83 + jac_affine_inv_1_1_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_1_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_83 + jac_affine_inv_1_1_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_1_WHITE_UP*0.21607642918484779)) + ((jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_83 + jac_affine_inv_1_2_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_2_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_83 + jac_affine_inv_1_2_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_2_WHITE_UP*0.21607642918484779)))*0.053182322583579168 + tmp_kernel_op_9*(((jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_80 + jac_affine_inv_1_0_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_0_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_0_WHITE_UP*tmp_kernel_op_80 + jac_affine_inv_1_0_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_0_WHITE_UP*0.82157254096761978)) + ((jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_80 + jac_affine_inv_1_1_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_1_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_1_WHITE_UP*tmp_kernel_op_80 + jac_affine_inv_1_1_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_1_WHITE_UP*0.82157254096761978)) + ((jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_80 + jac_affine_inv_1_2_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_2_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_2_WHITE_UP*tmp_kernel_op_80 + jac_affine_inv_1_2_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_2_WHITE_UP*0.82157254096761978)))*0.016934591412496779;
          {
             {
                {
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1] = elMatDiag_0 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1] = elMatDiag_1 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1] = elMatDiag_2 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1] = elMatDiag_3 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1] = elMatDiag_4 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1];
                   _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1] = elMatDiag_5 + _data_invDiag_[ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ctr_1 - ctr_2 + micro_edges_per_macro_edge - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) - 1];
                }
             }
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
