/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG form generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/





























#include "../N1E1ElementwiseCurlCurlPlusMass.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void N1E1ElementwiseCurlCurlPlusMass::toMatrix_macro_3D( walberla::float64 * RESTRICT  _data_alpha, walberla::float64 * RESTRICT  _data_beta, idx_t * RESTRICT  _data_dst, idx_t * RESTRICT  _data_src, const Cell& cell, const uint_t level, walberla::float64 macro_vertex_coord_id_0comp0, walberla::float64 macro_vertex_coord_id_0comp1, walberla::float64 macro_vertex_coord_id_0comp2, walberla::float64 macro_vertex_coord_id_1comp0, walberla::float64 macro_vertex_coord_id_1comp1, walberla::float64 macro_vertex_coord_id_1comp2, walberla::float64 macro_vertex_coord_id_2comp0, walberla::float64 macro_vertex_coord_id_2comp1, walberla::float64 macro_vertex_coord_id_2comp2, walberla::float64 macro_vertex_coord_id_3comp0, walberla::float64 macro_vertex_coord_id_3comp1, walberla::float64 macro_vertex_coord_id_3comp2, std::shared_ptr< SparseMatrixProxy > mat, int64_t micro_edges_per_macro_edge, walberla::float64 micro_edges_per_macro_edge_float ) const
{
    {
       const walberla::float64 _data_q_w [] = {0.016934591412496779, 0.046462929447761363, 0.05008682322282932, 0.053182322583579168};
   
       const walberla::float64 tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const walberla::float64 p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const walberla::float64 p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const walberla::float64 p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const walberla::float64 p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const walberla::float64 p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const walberla::float64 p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const walberla::float64 p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const walberla::float64 p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const walberla::float64 p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const walberla::float64 p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const walberla::float64 p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const walberla::float64 p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const walberla::float64 jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const walberla::float64 jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const walberla::float64 jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const walberla::float64 jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const walberla::float64 jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const walberla::float64 tmp_coords_jac_5_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const walberla::float64 jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const walberla::float64 tmp_coords_jac_3_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const walberla::float64 jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const walberla::float64 jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const walberla::float64 tmp_coords_jac_2_WHITE_UP = jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP;
       const walberla::float64 jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const walberla::float64 tmp_coords_jac_1_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const walberla::float64 tmp_coords_jac_4_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const walberla::float64 tmp_coords_jac_6_WHITE_UP = jac_affine_0_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_0_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_0_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
       const walberla::float64 tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const walberla::float64 jac_affine_inv_0_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
       const walberla::float64 jac_affine_inv_0_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_2_1_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const walberla::float64 jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const walberla::float64 jac_affine_inv_1_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const walberla::float64 jac_affine_inv_1_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const walberla::float64 jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const walberla::float64 jac_affine_inv_2_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const walberla::float64 jac_affine_inv_2_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const walberla::float64 jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const walberla::float64 abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       {
          /* CellType.WHITE_UP */
          const walberla::float64 _data_phi_0_0_WHITE_UP [] = {0.12366680032845842, 0.82157254096761978, 0.039933048641498423, 0.01482761006242336, 0.45746158708559548, 0.15593312049918601, 0.3817653560693467, 0.0048399363458717648, 0.36531451881463445, 0.18002969351036541, 0.0069232355736274674, 0.44773255210137269, 0.00037551502872928966, 0.21607642918484779, 0.43070170707783612, 0.35284634870858678};
      
          const walberla::float64 _data_curl_curl_det_0_0_WHITE_UP [] = {1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_0_WHITE_UP*jac_affine_0_0_WHITE_UP)*4.0 + (jac_affine_1_0_WHITE_UP*jac_affine_1_0_WHITE_UP)*4.0 + (jac_affine_2_0_WHITE_UP*jac_affine_2_0_WHITE_UP)*4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_0_WHITE_UP*jac_affine_0_1_WHITE_UP*-4.0 + jac_affine_1_0_WHITE_UP*jac_affine_1_1_WHITE_UP*-4.0 + jac_affine_2_0_WHITE_UP*jac_affine_2_1_WHITE_UP*-4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_0_WHITE_UP*jac_affine_0_2_WHITE_UP*4.0 + jac_affine_1_0_WHITE_UP*jac_affine_1_2_WHITE_UP*4.0 + jac_affine_2_0_WHITE_UP*jac_affine_2_2_WHITE_UP*4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_0_WHITE_UP*(jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*2.0 + jac_affine_1_0_WHITE_UP*(jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*2.0 + jac_affine_2_0_WHITE_UP*(jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_0_WHITE_UP*(jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)*2.0 + jac_affine_1_0_WHITE_UP*(jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)*2.0 + jac_affine_2_0_WHITE_UP*(jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_0_WHITE_UP*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0)*2.0 + jac_affine_1_0_WHITE_UP*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0)*2.0 + jac_affine_2_0_WHITE_UP*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_1_WHITE_UP*jac_affine_0_1_WHITE_UP)*4.0 + (jac_affine_1_1_WHITE_UP*jac_affine_1_1_WHITE_UP)*4.0 + (jac_affine_2_1_WHITE_UP*jac_affine_2_1_WHITE_UP)*4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_1_WHITE_UP*jac_affine_0_2_WHITE_UP*-4.0 + jac_affine_1_1_WHITE_UP*jac_affine_1_2_WHITE_UP*-4.0 + jac_affine_2_1_WHITE_UP*jac_affine_2_2_WHITE_UP*-4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_1_WHITE_UP*(jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*-2.0 + jac_affine_1_1_WHITE_UP*(jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*-2.0 + jac_affine_2_1_WHITE_UP*(jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_1_WHITE_UP*(jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)*-2.0 + jac_affine_1_1_WHITE_UP*(jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)*-2.0 + jac_affine_2_1_WHITE_UP*(jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_1_WHITE_UP*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0)*-2.0 + jac_affine_1_1_WHITE_UP*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0)*-2.0 + jac_affine_2_1_WHITE_UP*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_2_WHITE_UP*jac_affine_0_2_WHITE_UP)*4.0 + (jac_affine_1_2_WHITE_UP*jac_affine_1_2_WHITE_UP)*4.0 + (jac_affine_2_2_WHITE_UP*jac_affine_2_2_WHITE_UP)*4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_2_WHITE_UP*(jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*2.0 + jac_affine_1_2_WHITE_UP*(jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*2.0 + jac_affine_2_2_WHITE_UP*(jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_2_WHITE_UP*(jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)*2.0 + jac_affine_1_2_WHITE_UP*(jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)*2.0 + jac_affine_2_2_WHITE_UP*(jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_2_WHITE_UP*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0)*2.0 + jac_affine_1_2_WHITE_UP*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0)*2.0 + jac_affine_2_2_WHITE_UP*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(((jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*(jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)) + ((jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*(jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)) + ((jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*(jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0))), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*(jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0) + (jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*(jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0) + (jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*(jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0) + (jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0) + (jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)), 1.0 / (abs_det_jac_affine_WHITE_UP)*(((jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)*(jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)) + ((jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)*(jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)) + ((jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)*(jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0))), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0) + (jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0) + (jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)), 1.0 / (abs_det_jac_affine_WHITE_UP)*(((jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0)*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0)) + ((jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0)*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0)) + ((jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0))), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_0_WHITE_UP*jac_affine_0_0_WHITE_UP)*4.0 + (jac_affine_1_0_WHITE_UP*jac_affine_1_0_WHITE_UP)*4.0 + (jac_affine_2_0_WHITE_UP*jac_affine_2_0_WHITE_UP)*4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_0_WHITE_UP*jac_affine_0_1_WHITE_UP*-4.0 + jac_affine_1_0_WHITE_UP*jac_affine_1_1_WHITE_UP*-4.0 + jac_affine_2_0_WHITE_UP*jac_affine_2_1_WHITE_UP*-4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_0_WHITE_UP*jac_affine_0_2_WHITE_UP*4.0 + jac_affine_1_0_WHITE_UP*jac_affine_1_2_WHITE_UP*4.0 + jac_affine_2_0_WHITE_UP*jac_affine_2_2_WHITE_UP*4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_0_WHITE_UP*(jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*2.0 + jac_affine_1_0_WHITE_UP*(jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*2.0 + jac_affine_2_0_WHITE_UP*(jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_0_WHITE_UP*(jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)*2.0 + jac_affine_1_0_WHITE_UP*(jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)*2.0 + jac_affine_2_0_WHITE_UP*(jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_0_WHITE_UP*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0)*2.0 + jac_affine_1_0_WHITE_UP*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0)*2.0 + jac_affine_2_0_WHITE_UP*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_1_WHITE_UP*jac_affine_0_1_WHITE_UP)*4.0 + (jac_affine_1_1_WHITE_UP*jac_affine_1_1_WHITE_UP)*4.0 + (jac_affine_2_1_WHITE_UP*jac_affine_2_1_WHITE_UP)*4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_1_WHITE_UP*jac_affine_0_2_WHITE_UP*-4.0 + jac_affine_1_1_WHITE_UP*jac_affine_1_2_WHITE_UP*-4.0 + jac_affine_2_1_WHITE_UP*jac_affine_2_2_WHITE_UP*-4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_1_WHITE_UP*(jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*-2.0 + jac_affine_1_1_WHITE_UP*(jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*-2.0 + jac_affine_2_1_WHITE_UP*(jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_1_WHITE_UP*(jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)*-2.0 + jac_affine_1_1_WHITE_UP*(jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)*-2.0 + jac_affine_2_1_WHITE_UP*(jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_1_WHITE_UP*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0)*-2.0 + jac_affine_1_1_WHITE_UP*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0)*-2.0 + jac_affine_2_1_WHITE_UP*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_2_WHITE_UP*jac_affine_0_2_WHITE_UP)*4.0 + (jac_affine_1_2_WHITE_UP*jac_affine_1_2_WHITE_UP)*4.0 + (jac_affine_2_2_WHITE_UP*jac_affine_2_2_WHITE_UP)*4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_2_WHITE_UP*(jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*2.0 + jac_affine_1_2_WHITE_UP*(jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*2.0 + jac_affine_2_2_WHITE_UP*(jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_2_WHITE_UP*(jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)*2.0 + jac_affine_1_2_WHITE_UP*(jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)*2.0 + jac_affine_2_2_WHITE_UP*(jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_2_WHITE_UP*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0)*2.0 + jac_affine_1_2_WHITE_UP*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0)*2.0 + jac_affine_2_2_WHITE_UP*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(((jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*(jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)) + ((jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*(jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)) + ((jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*(jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0))), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*(jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0) + (jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*(jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0) + (jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*(jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0) + (jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0) + (jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)), 1.0 / (abs_det_jac_affine_WHITE_UP)*(((jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)*(jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)) + ((jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)*(jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)) + ((jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)*(jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0))), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0) + (jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0) + (jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)), 1.0 / (abs_det_jac_affine_WHITE_UP)*(((jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0)*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0)) + ((jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0)*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0)) + ((jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0))), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_0_WHITE_UP*jac_affine_0_0_WHITE_UP)*4.0 + (jac_affine_1_0_WHITE_UP*jac_affine_1_0_WHITE_UP)*4.0 + (jac_affine_2_0_WHITE_UP*jac_affine_2_0_WHITE_UP)*4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_0_WHITE_UP*jac_affine_0_1_WHITE_UP*-4.0 + jac_affine_1_0_WHITE_UP*jac_affine_1_1_WHITE_UP*-4.0 + jac_affine_2_0_WHITE_UP*jac_affine_2_1_WHITE_UP*-4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_0_WHITE_UP*jac_affine_0_2_WHITE_UP*4.0 + jac_affine_1_0_WHITE_UP*jac_affine_1_2_WHITE_UP*4.0 + jac_affine_2_0_WHITE_UP*jac_affine_2_2_WHITE_UP*4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_0_WHITE_UP*(jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*2.0 + jac_affine_1_0_WHITE_UP*(jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*2.0 + jac_affine_2_0_WHITE_UP*(jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_0_WHITE_UP*(jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)*2.0 + jac_affine_1_0_WHITE_UP*(jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)*2.0 + jac_affine_2_0_WHITE_UP*(jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_0_WHITE_UP*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0)*2.0 + jac_affine_1_0_WHITE_UP*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0)*2.0 + jac_affine_2_0_WHITE_UP*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_1_WHITE_UP*jac_affine_0_1_WHITE_UP)*4.0 + (jac_affine_1_1_WHITE_UP*jac_affine_1_1_WHITE_UP)*4.0 + (jac_affine_2_1_WHITE_UP*jac_affine_2_1_WHITE_UP)*4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_1_WHITE_UP*jac_affine_0_2_WHITE_UP*-4.0 + jac_affine_1_1_WHITE_UP*jac_affine_1_2_WHITE_UP*-4.0 + jac_affine_2_1_WHITE_UP*jac_affine_2_2_WHITE_UP*-4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_1_WHITE_UP*(jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*-2.0 + jac_affine_1_1_WHITE_UP*(jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*-2.0 + jac_affine_2_1_WHITE_UP*(jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_1_WHITE_UP*(jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)*-2.0 + jac_affine_1_1_WHITE_UP*(jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)*-2.0 + jac_affine_2_1_WHITE_UP*(jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_1_WHITE_UP*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0)*-2.0 + jac_affine_1_1_WHITE_UP*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0)*-2.0 + jac_affine_2_1_WHITE_UP*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_2_WHITE_UP*jac_affine_0_2_WHITE_UP)*4.0 + (jac_affine_1_2_WHITE_UP*jac_affine_1_2_WHITE_UP)*4.0 + (jac_affine_2_2_WHITE_UP*jac_affine_2_2_WHITE_UP)*4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_2_WHITE_UP*(jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*2.0 + jac_affine_1_2_WHITE_UP*(jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*2.0 + jac_affine_2_2_WHITE_UP*(jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_2_WHITE_UP*(jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)*2.0 + jac_affine_1_2_WHITE_UP*(jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)*2.0 + jac_affine_2_2_WHITE_UP*(jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_2_WHITE_UP*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0)*2.0 + jac_affine_1_2_WHITE_UP*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0)*2.0 + jac_affine_2_2_WHITE_UP*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(((jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*(jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)) + ((jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*(jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)) + ((jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*(jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0))), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*(jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0) + (jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*(jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0) + (jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*(jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0) + (jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0) + (jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)), 1.0 / (abs_det_jac_affine_WHITE_UP)*(((jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)*(jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)) + ((jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)*(jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)) + ((jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)*(jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0))), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0) + (jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0) + (jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)), 1.0 / (abs_det_jac_affine_WHITE_UP)*(((jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0)*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0)) + ((jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0)*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0)) + ((jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0))), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_0_WHITE_UP*jac_affine_0_0_WHITE_UP)*4.0 + (jac_affine_1_0_WHITE_UP*jac_affine_1_0_WHITE_UP)*4.0 + (jac_affine_2_0_WHITE_UP*jac_affine_2_0_WHITE_UP)*4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_0_WHITE_UP*jac_affine_0_1_WHITE_UP*-4.0 + jac_affine_1_0_WHITE_UP*jac_affine_1_1_WHITE_UP*-4.0 + jac_affine_2_0_WHITE_UP*jac_affine_2_1_WHITE_UP*-4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_0_WHITE_UP*jac_affine_0_2_WHITE_UP*4.0 + jac_affine_1_0_WHITE_UP*jac_affine_1_2_WHITE_UP*4.0 + jac_affine_2_0_WHITE_UP*jac_affine_2_2_WHITE_UP*4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_0_WHITE_UP*(jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*2.0 + jac_affine_1_0_WHITE_UP*(jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*2.0 + jac_affine_2_0_WHITE_UP*(jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_0_WHITE_UP*(jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)*2.0 + jac_affine_1_0_WHITE_UP*(jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)*2.0 + jac_affine_2_0_WHITE_UP*(jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_0_WHITE_UP*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0)*2.0 + jac_affine_1_0_WHITE_UP*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0)*2.0 + jac_affine_2_0_WHITE_UP*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_1_WHITE_UP*jac_affine_0_1_WHITE_UP)*4.0 + (jac_affine_1_1_WHITE_UP*jac_affine_1_1_WHITE_UP)*4.0 + (jac_affine_2_1_WHITE_UP*jac_affine_2_1_WHITE_UP)*4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_1_WHITE_UP*jac_affine_0_2_WHITE_UP*-4.0 + jac_affine_1_1_WHITE_UP*jac_affine_1_2_WHITE_UP*-4.0 + jac_affine_2_1_WHITE_UP*jac_affine_2_2_WHITE_UP*-4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_1_WHITE_UP*(jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*-2.0 + jac_affine_1_1_WHITE_UP*(jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*-2.0 + jac_affine_2_1_WHITE_UP*(jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_1_WHITE_UP*(jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)*-2.0 + jac_affine_1_1_WHITE_UP*(jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)*-2.0 + jac_affine_2_1_WHITE_UP*(jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_1_WHITE_UP*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0)*-2.0 + jac_affine_1_1_WHITE_UP*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0)*-2.0 + jac_affine_2_1_WHITE_UP*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_2_WHITE_UP*jac_affine_0_2_WHITE_UP)*4.0 + (jac_affine_1_2_WHITE_UP*jac_affine_1_2_WHITE_UP)*4.0 + (jac_affine_2_2_WHITE_UP*jac_affine_2_2_WHITE_UP)*4.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_2_WHITE_UP*(jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*2.0 + jac_affine_1_2_WHITE_UP*(jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*2.0 + jac_affine_2_2_WHITE_UP*(jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_2_WHITE_UP*(jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)*2.0 + jac_affine_1_2_WHITE_UP*(jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)*2.0 + jac_affine_2_2_WHITE_UP*(jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(jac_affine_0_2_WHITE_UP*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0)*2.0 + jac_affine_1_2_WHITE_UP*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0)*2.0 + jac_affine_2_2_WHITE_UP*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_UP)*(((jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*(jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)) + ((jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*(jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)) + ((jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*(jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0))), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*(jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0) + (jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*(jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0) + (jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*(jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_0_WHITE_UP*-2.0 + jac_affine_0_1_WHITE_UP*2.0)*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0) + (jac_affine_1_0_WHITE_UP*-2.0 + jac_affine_1_1_WHITE_UP*2.0)*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0) + (jac_affine_2_0_WHITE_UP*-2.0 + jac_affine_2_1_WHITE_UP*2.0)*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)), 1.0 / (abs_det_jac_affine_WHITE_UP)*(((jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)*(jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)) + ((jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)*(jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)) + ((jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)*(jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0))), 1.0 / (abs_det_jac_affine_WHITE_UP)*((jac_affine_0_0_WHITE_UP*2.0 + jac_affine_0_2_WHITE_UP*-2.0)*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0) + (jac_affine_1_0_WHITE_UP*2.0 + jac_affine_1_2_WHITE_UP*-2.0)*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0) + (jac_affine_2_0_WHITE_UP*2.0 + jac_affine_2_2_WHITE_UP*-2.0)*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)), 1.0 / (abs_det_jac_affine_WHITE_UP)*(((jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0)*(jac_affine_0_1_WHITE_UP*-2.0 + jac_affine_0_2_WHITE_UP*2.0)) + ((jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0)*(jac_affine_1_1_WHITE_UP*-2.0 + jac_affine_1_2_WHITE_UP*2.0)) + ((jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)*(jac_affine_2_1_WHITE_UP*-2.0 + jac_affine_2_2_WHITE_UP*2.0)))};
      
          const walberla::float64 _data_mass_det_0_0_WHITE_UP [] = {abs_det_jac_affine_WHITE_UP*(((jac_affine_inv_1_0_WHITE_UP*-0.37131174720816351 + jac_affine_inv_2_0_WHITE_UP)*(jac_affine_inv_1_0_WHITE_UP*-0.37131174720816351 + jac_affine_inv_2_0_WHITE_UP))*0.0015946483738042789 + ((jac_affine_inv_1_1_WHITE_UP*-0.37131174720816351 + jac_affine_inv_2_1_WHITE_UP)*(jac_affine_inv_1_1_WHITE_UP*-0.37131174720816351 + jac_affine_inv_2_1_WHITE_UP))*0.0015946483738042789 + ((jac_affine_inv_1_2_WHITE_UP*-0.37131174720816351 + jac_affine_inv_2_2_WHITE_UP)*(jac_affine_inv_1_2_WHITE_UP*-0.37131174720816351 + jac_affine_inv_2_2_WHITE_UP))*0.0015946483738042789), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_0_WHITE_UP*0.82157254096761978)*(jac_affine_inv_1_0_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_0_WHITE_UP*0.039933048641498423) + (jac_affine_inv_0_1_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_1_WHITE_UP*0.82157254096761978)*(jac_affine_inv_1_1_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_1_WHITE_UP*0.039933048641498423) + (jac_affine_inv_0_2_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_2_WHITE_UP*0.82157254096761978)*(jac_affine_inv_1_2_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_2_WHITE_UP*0.039933048641498423)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.039933048641498423 + jac_affine_inv_1_0_WHITE_UP*0.82157254096761978)*(jac_affine_inv_1_0_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_0_WHITE_UP*0.039933048641498423) + (jac_affine_inv_0_1_WHITE_UP*-0.039933048641498423 + jac_affine_inv_1_1_WHITE_UP*0.82157254096761978)*(jac_affine_inv_1_1_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_1_WHITE_UP*0.039933048641498423) + (jac_affine_inv_0_2_WHITE_UP*-0.039933048641498423 + jac_affine_inv_1_2_WHITE_UP*0.82157254096761978)*(jac_affine_inv_1_2_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_2_WHITE_UP*0.039933048641498423)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_0_WHITE_UP*0.039933048641498423)*(jac_affine_inv_0_0_WHITE_UP*0.01482761006242336 + jac_affine_inv_1_0_WHITE_UP*0.01482761006242336 + jac_affine_inv_2_0_WHITE_UP*0.13849441039088178) + (jac_affine_inv_1_1_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_1_WHITE_UP*0.039933048641498423)*(jac_affine_inv_0_1_WHITE_UP*0.01482761006242336 + jac_affine_inv_1_1_WHITE_UP*0.01482761006242336 + jac_affine_inv_2_1_WHITE_UP*0.13849441039088178) + (jac_affine_inv_1_2_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_2_WHITE_UP*0.039933048641498423)*(jac_affine_inv_0_2_WHITE_UP*0.01482761006242336 + jac_affine_inv_1_2_WHITE_UP*0.01482761006242336 + jac_affine_inv_2_2_WHITE_UP*0.13849441039088178)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_0_WHITE_UP*0.039933048641498423)*(jac_affine_inv_0_0_WHITE_UP*0.039933048641498423 + jac_affine_inv_1_0_WHITE_UP*0.16359984896995686 + jac_affine_inv_2_0_WHITE_UP*0.039933048641498423) + (jac_affine_inv_1_1_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_1_WHITE_UP*0.039933048641498423)*(jac_affine_inv_0_1_WHITE_UP*0.039933048641498423 + jac_affine_inv_1_1_WHITE_UP*0.16359984896995686 + jac_affine_inv_2_1_WHITE_UP*0.039933048641498423) + (jac_affine_inv_1_2_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_2_WHITE_UP*0.039933048641498423)*(jac_affine_inv_0_2_WHITE_UP*0.039933048641498423 + jac_affine_inv_1_2_WHITE_UP*0.16359984896995686 + jac_affine_inv_2_2_WHITE_UP*0.039933048641498423)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_0_WHITE_UP*0.039933048641498423)*(jac_affine_inv_0_0_WHITE_UP*0.94523934129607823 + jac_affine_inv_1_0_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_0_WHITE_UP*0.82157254096761978) + (jac_affine_inv_1_1_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_1_WHITE_UP*0.039933048641498423)*(jac_affine_inv_0_1_WHITE_UP*0.94523934129607823 + jac_affine_inv_1_1_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_1_WHITE_UP*0.82157254096761978) + (jac_affine_inv_1_2_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_2_WHITE_UP*0.039933048641498423)*(jac_affine_inv_0_2_WHITE_UP*0.94523934129607823 + jac_affine_inv_1_2_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_2_WHITE_UP*0.82157254096761978)), abs_det_jac_affine_WHITE_UP*(((jac_affine_inv_0_0_WHITE_UP*-0.018047840358637001 + jac_affine_inv_2_0_WHITE_UP)*(jac_affine_inv_0_0_WHITE_UP*-0.018047840358637001 + jac_affine_inv_2_0_WHITE_UP))*0.67498144007199123 + ((jac_affine_inv_0_1_WHITE_UP*-0.018047840358637001 + jac_affine_inv_2_1_WHITE_UP)*(jac_affine_inv_0_1_WHITE_UP*-0.018047840358637001 + jac_affine_inv_2_1_WHITE_UP))*0.67498144007199123 + ((jac_affine_inv_0_2_WHITE_UP*-0.018047840358637001 + jac_affine_inv_2_2_WHITE_UP)*(jac_affine_inv_0_2_WHITE_UP*-0.018047840358637001 + jac_affine_inv_2_2_WHITE_UP))*0.67498144007199123), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_0_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_0_WHITE_UP*-0.039933048641498423 + jac_affine_inv_1_0_WHITE_UP*0.82157254096761978) + (jac_affine_inv_0_1_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_1_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_1_WHITE_UP*-0.039933048641498423 + jac_affine_inv_1_1_WHITE_UP*0.82157254096761978) + (jac_affine_inv_0_2_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_2_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_2_WHITE_UP*-0.039933048641498423 + jac_affine_inv_1_2_WHITE_UP*0.82157254096761978)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_0_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_0_WHITE_UP*0.01482761006242336 + jac_affine_inv_1_0_WHITE_UP*0.01482761006242336 + jac_affine_inv_2_0_WHITE_UP*0.13849441039088178) + (jac_affine_inv_0_1_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_1_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_1_WHITE_UP*0.01482761006242336 + jac_affine_inv_1_1_WHITE_UP*0.01482761006242336 + jac_affine_inv_2_1_WHITE_UP*0.13849441039088178) + (jac_affine_inv_0_2_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_2_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_2_WHITE_UP*0.01482761006242336 + jac_affine_inv_1_2_WHITE_UP*0.01482761006242336 + jac_affine_inv_2_2_WHITE_UP*0.13849441039088178)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_0_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_0_WHITE_UP*0.039933048641498423 + jac_affine_inv_1_0_WHITE_UP*0.16359984896995686 + jac_affine_inv_2_0_WHITE_UP*0.039933048641498423) + (jac_affine_inv_0_1_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_1_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_1_WHITE_UP*0.039933048641498423 + jac_affine_inv_1_1_WHITE_UP*0.16359984896995686 + jac_affine_inv_2_1_WHITE_UP*0.039933048641498423) + (jac_affine_inv_0_2_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_2_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_2_WHITE_UP*0.039933048641498423 + jac_affine_inv_1_2_WHITE_UP*0.16359984896995686 + jac_affine_inv_2_2_WHITE_UP*0.039933048641498423)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_0_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_0_WHITE_UP*0.94523934129607823 + jac_affine_inv_1_0_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_0_WHITE_UP*0.82157254096761978) + (jac_affine_inv_0_1_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_1_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_1_WHITE_UP*0.94523934129607823 + jac_affine_inv_1_1_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_1_WHITE_UP*0.82157254096761978) + (jac_affine_inv_0_2_WHITE_UP*-0.01482761006242336 + jac_affine_inv_2_2_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_2_WHITE_UP*0.94523934129607823 + jac_affine_inv_1_2_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_2_WHITE_UP*0.82157254096761978)), abs_det_jac_affine_WHITE_UP*(((jac_affine_inv_0_0_WHITE_UP*-0.048605627196920013 + jac_affine_inv_1_0_WHITE_UP)*(jac_affine_inv_0_0_WHITE_UP*-0.048605627196920013 + jac_affine_inv_1_0_WHITE_UP))*0.67498144007199123 + ((jac_affine_inv_0_1_WHITE_UP*-0.048605627196920013 + jac_affine_inv_1_1_WHITE_UP)*(jac_affine_inv_0_1_WHITE_UP*-0.048605627196920013 + jac_affine_inv_1_1_WHITE_UP))*0.67498144007199123 + ((jac_affine_inv_0_2_WHITE_UP*-0.048605627196920013 + jac_affine_inv_1_2_WHITE_UP)*(jac_affine_inv_0_2_WHITE_UP*-0.048605627196920013 + jac_affine_inv_1_2_WHITE_UP))*0.67498144007199123), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.039933048641498423 + jac_affine_inv_1_0_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_0_WHITE_UP*0.01482761006242336 + jac_affine_inv_1_0_WHITE_UP*0.01482761006242336 + jac_affine_inv_2_0_WHITE_UP*0.13849441039088178) + (jac_affine_inv_0_1_WHITE_UP*-0.039933048641498423 + jac_affine_inv_1_1_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_1_WHITE_UP*0.01482761006242336 + jac_affine_inv_1_1_WHITE_UP*0.01482761006242336 + jac_affine_inv_2_1_WHITE_UP*0.13849441039088178) + (jac_affine_inv_0_2_WHITE_UP*-0.039933048641498423 + jac_affine_inv_1_2_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_2_WHITE_UP*0.01482761006242336 + jac_affine_inv_1_2_WHITE_UP*0.01482761006242336 + jac_affine_inv_2_2_WHITE_UP*0.13849441039088178)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.039933048641498423 + jac_affine_inv_1_0_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_0_WHITE_UP*0.039933048641498423 + jac_affine_inv_1_0_WHITE_UP*0.16359984896995686 + jac_affine_inv_2_0_WHITE_UP*0.039933048641498423) + (jac_affine_inv_0_1_WHITE_UP*-0.039933048641498423 + jac_affine_inv_1_1_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_1_WHITE_UP*0.039933048641498423 + jac_affine_inv_1_1_WHITE_UP*0.16359984896995686 + jac_affine_inv_2_1_WHITE_UP*0.039933048641498423) + (jac_affine_inv_0_2_WHITE_UP*-0.039933048641498423 + jac_affine_inv_1_2_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_2_WHITE_UP*0.039933048641498423 + jac_affine_inv_1_2_WHITE_UP*0.16359984896995686 + jac_affine_inv_2_2_WHITE_UP*0.039933048641498423)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.039933048641498423 + jac_affine_inv_1_0_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_0_WHITE_UP*0.94523934129607823 + jac_affine_inv_1_0_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_0_WHITE_UP*0.82157254096761978) + (jac_affine_inv_0_1_WHITE_UP*-0.039933048641498423 + jac_affine_inv_1_1_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_1_WHITE_UP*0.94523934129607823 + jac_affine_inv_1_1_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_1_WHITE_UP*0.82157254096761978) + (jac_affine_inv_0_2_WHITE_UP*-0.039933048641498423 + jac_affine_inv_1_2_WHITE_UP*0.82157254096761978)*(jac_affine_inv_0_2_WHITE_UP*0.94523934129607823 + jac_affine_inv_1_2_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_2_WHITE_UP*0.82157254096761978)), abs_det_jac_affine_WHITE_UP*(((jac_affine_inv_0_0_WHITE_UP*0.10706287727117962 + jac_affine_inv_1_0_WHITE_UP*0.10706287727117962 + jac_affine_inv_2_0_WHITE_UP)*(jac_affine_inv_0_0_WHITE_UP*0.10706287727117962 + jac_affine_inv_1_0_WHITE_UP*0.10706287727117962 + jac_affine_inv_2_0_WHITE_UP))*0.019180701709517984 + ((jac_affine_inv_0_1_WHITE_UP*0.10706287727117962 + jac_affine_inv_1_1_WHITE_UP*0.10706287727117962 + jac_affine_inv_2_1_WHITE_UP)*(jac_affine_inv_0_1_WHITE_UP*0.10706287727117962 + jac_affine_inv_1_1_WHITE_UP*0.10706287727117962 + jac_affine_inv_2_1_WHITE_UP))*0.019180701709517984 + ((jac_affine_inv_0_2_WHITE_UP*0.10706287727117962 + jac_affine_inv_1_2_WHITE_UP*0.10706287727117962 + jac_affine_inv_2_2_WHITE_UP)*(jac_affine_inv_0_2_WHITE_UP*0.10706287727117962 + jac_affine_inv_1_2_WHITE_UP*0.10706287727117962 + jac_affine_inv_2_2_WHITE_UP))*0.019180701709517984), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.01482761006242336 + jac_affine_inv_1_0_WHITE_UP*0.01482761006242336 + jac_affine_inv_2_0_WHITE_UP*0.13849441039088178)*(jac_affine_inv_0_0_WHITE_UP*0.039933048641498423 + jac_affine_inv_1_0_WHITE_UP*0.16359984896995686 + jac_affine_inv_2_0_WHITE_UP*0.039933048641498423) + (jac_affine_inv_0_1_WHITE_UP*0.01482761006242336 + jac_affine_inv_1_1_WHITE_UP*0.01482761006242336 + jac_affine_inv_2_1_WHITE_UP*0.13849441039088178)*(jac_affine_inv_0_1_WHITE_UP*0.039933048641498423 + jac_affine_inv_1_1_WHITE_UP*0.16359984896995686 + jac_affine_inv_2_1_WHITE_UP*0.039933048641498423) + (jac_affine_inv_0_2_WHITE_UP*0.01482761006242336 + jac_affine_inv_1_2_WHITE_UP*0.01482761006242336 + jac_affine_inv_2_2_WHITE_UP*0.13849441039088178)*(jac_affine_inv_0_2_WHITE_UP*0.039933048641498423 + jac_affine_inv_1_2_WHITE_UP*0.16359984896995686 + jac_affine_inv_2_2_WHITE_UP*0.039933048641498423)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.01482761006242336 + jac_affine_inv_1_0_WHITE_UP*0.01482761006242336 + jac_affine_inv_2_0_WHITE_UP*0.13849441039088178)*(jac_affine_inv_0_0_WHITE_UP*0.94523934129607823 + jac_affine_inv_1_0_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_0_WHITE_UP*0.82157254096761978) + (jac_affine_inv_0_1_WHITE_UP*0.01482761006242336 + jac_affine_inv_1_1_WHITE_UP*0.01482761006242336 + jac_affine_inv_2_1_WHITE_UP*0.13849441039088178)*(jac_affine_inv_0_1_WHITE_UP*0.94523934129607823 + jac_affine_inv_1_1_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_1_WHITE_UP*0.82157254096761978) + (jac_affine_inv_0_2_WHITE_UP*0.01482761006242336 + jac_affine_inv_1_2_WHITE_UP*0.01482761006242336 + jac_affine_inv_2_2_WHITE_UP*0.13849441039088178)*(jac_affine_inv_0_2_WHITE_UP*0.94523934129607823 + jac_affine_inv_1_2_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_2_WHITE_UP*0.82157254096761978)), abs_det_jac_affine_WHITE_UP*(((jac_affine_inv_0_0_WHITE_UP*0.2440897647089616 + jac_affine_inv_1_0_WHITE_UP + jac_affine_inv_2_0_WHITE_UP*0.2440897647089616)*(jac_affine_inv_0_0_WHITE_UP*0.2440897647089616 + jac_affine_inv_1_0_WHITE_UP + jac_affine_inv_2_0_WHITE_UP*0.2440897647089616))*0.026764910582992695 + ((jac_affine_inv_0_1_WHITE_UP*0.2440897647089616 + jac_affine_inv_1_1_WHITE_UP + jac_affine_inv_2_1_WHITE_UP*0.2440897647089616)*(jac_affine_inv_0_1_WHITE_UP*0.2440897647089616 + jac_affine_inv_1_1_WHITE_UP + jac_affine_inv_2_1_WHITE_UP*0.2440897647089616))*0.026764910582992695 + ((jac_affine_inv_0_2_WHITE_UP*0.2440897647089616 + jac_affine_inv_1_2_WHITE_UP + jac_affine_inv_2_2_WHITE_UP*0.2440897647089616)*(jac_affine_inv_0_2_WHITE_UP*0.2440897647089616 + jac_affine_inv_1_2_WHITE_UP + jac_affine_inv_2_2_WHITE_UP*0.2440897647089616))*0.026764910582992695), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.039933048641498423 + jac_affine_inv_1_0_WHITE_UP*0.16359984896995686 + jac_affine_inv_2_0_WHITE_UP*0.039933048641498423)*(jac_affine_inv_0_0_WHITE_UP*0.94523934129607823 + jac_affine_inv_1_0_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_0_WHITE_UP*0.82157254096761978) + (jac_affine_inv_0_1_WHITE_UP*0.039933048641498423 + jac_affine_inv_1_1_WHITE_UP*0.16359984896995686 + jac_affine_inv_2_1_WHITE_UP*0.039933048641498423)*(jac_affine_inv_0_1_WHITE_UP*0.94523934129607823 + jac_affine_inv_1_1_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_1_WHITE_UP*0.82157254096761978) + (jac_affine_inv_0_2_WHITE_UP*0.039933048641498423 + jac_affine_inv_1_2_WHITE_UP*0.16359984896995686 + jac_affine_inv_2_2_WHITE_UP*0.039933048641498423)*(jac_affine_inv_0_2_WHITE_UP*0.94523934129607823 + jac_affine_inv_1_2_WHITE_UP*0.82157254096761978 + jac_affine_inv_2_2_WHITE_UP*0.82157254096761978)), abs_det_jac_affine_WHITE_UP*(((jac_affine_inv_0_0_WHITE_UP + jac_affine_inv_1_0_WHITE_UP*0.86916879680558901 + jac_affine_inv_2_0_WHITE_UP*0.86916879680558901)*(jac_affine_inv_0_0_WHITE_UP + jac_affine_inv_1_0_WHITE_UP*0.86916879680558901 + jac_affine_inv_2_0_WHITE_UP*0.86916879680558901))*0.89347741233384381 + ((jac_affine_inv_0_1_WHITE_UP + jac_affine_inv_1_1_WHITE_UP*0.86916879680558901 + jac_affine_inv_2_1_WHITE_UP*0.86916879680558901)*(jac_affine_inv_0_1_WHITE_UP + jac_affine_inv_1_1_WHITE_UP*0.86916879680558901 + jac_affine_inv_2_1_WHITE_UP*0.86916879680558901))*0.89347741233384381 + ((jac_affine_inv_0_2_WHITE_UP + jac_affine_inv_1_2_WHITE_UP*0.86916879680558901 + jac_affine_inv_2_2_WHITE_UP*0.86916879680558901)*(jac_affine_inv_0_2_WHITE_UP + jac_affine_inv_1_2_WHITE_UP*0.86916879680558901 + jac_affine_inv_2_2_WHITE_UP*0.86916879680558901))*0.89347741233384381), abs_det_jac_affine_WHITE_UP*(((jac_affine_inv_1_0_WHITE_UP*-0.012677777773509136 + jac_affine_inv_2_0_WHITE_UP)*(jac_affine_inv_1_0_WHITE_UP*-0.012677777773509136 + jac_affine_inv_2_0_WHITE_UP))*0.14574478709475508 + ((jac_affine_inv_1_1_WHITE_UP*-0.012677777773509136 + jac_affine_inv_2_1_WHITE_UP)*(jac_affine_inv_1_1_WHITE_UP*-0.012677777773509136 + jac_affine_inv_2_1_WHITE_UP))*0.14574478709475508 + ((jac_affine_inv_1_2_WHITE_UP*-0.012677777773509136 + jac_affine_inv_2_2_WHITE_UP)*(jac_affine_inv_1_2_WHITE_UP*-0.012677777773509136 + jac_affine_inv_2_2_WHITE_UP))*0.14574478709475508), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_0_WHITE_UP*0.15593312049918601)*(jac_affine_inv_1_0_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_0_WHITE_UP*0.3817653560693467) + (jac_affine_inv_0_1_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_1_WHITE_UP*0.15593312049918601)*(jac_affine_inv_1_1_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_1_WHITE_UP*0.3817653560693467) + (jac_affine_inv_0_2_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_2_WHITE_UP*0.15593312049918601)*(jac_affine_inv_1_2_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_2_WHITE_UP*0.3817653560693467)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.3817653560693467 + jac_affine_inv_1_0_WHITE_UP*0.15593312049918601)*(jac_affine_inv_1_0_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_0_WHITE_UP*0.3817653560693467) + (jac_affine_inv_0_1_WHITE_UP*-0.3817653560693467 + jac_affine_inv_1_1_WHITE_UP*0.15593312049918601)*(jac_affine_inv_1_1_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_1_WHITE_UP*0.3817653560693467) + (jac_affine_inv_0_2_WHITE_UP*-0.3817653560693467 + jac_affine_inv_1_2_WHITE_UP*0.15593312049918601)*(jac_affine_inv_1_2_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_2_WHITE_UP*0.3817653560693467)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_0_WHITE_UP*0.3817653560693467)*(jac_affine_inv_0_0_WHITE_UP*0.0048399363458717648 + jac_affine_inv_1_0_WHITE_UP*0.0048399363458717648 + jac_affine_inv_2_0_WHITE_UP*0.46230152343146724) + (jac_affine_inv_1_1_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_1_WHITE_UP*0.3817653560693467)*(jac_affine_inv_0_1_WHITE_UP*0.0048399363458717648 + jac_affine_inv_1_1_WHITE_UP*0.0048399363458717648 + jac_affine_inv_2_1_WHITE_UP*0.46230152343146724) + (jac_affine_inv_1_2_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_2_WHITE_UP*0.3817653560693467)*(jac_affine_inv_0_2_WHITE_UP*0.0048399363458717648 + jac_affine_inv_1_2_WHITE_UP*0.0048399363458717648 + jac_affine_inv_2_2_WHITE_UP*0.46230152343146724)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_0_WHITE_UP*0.3817653560693467)*(jac_affine_inv_0_0_WHITE_UP*0.3817653560693467 + jac_affine_inv_1_0_WHITE_UP*0.83922694315494217 + jac_affine_inv_2_0_WHITE_UP*0.3817653560693467) + (jac_affine_inv_1_1_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_1_WHITE_UP*0.3817653560693467)*(jac_affine_inv_0_1_WHITE_UP*0.3817653560693467 + jac_affine_inv_1_1_WHITE_UP*0.83922694315494217 + jac_affine_inv_2_1_WHITE_UP*0.3817653560693467) + (jac_affine_inv_1_2_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_2_WHITE_UP*0.3817653560693467)*(jac_affine_inv_0_2_WHITE_UP*0.3817653560693467 + jac_affine_inv_1_2_WHITE_UP*0.83922694315494217 + jac_affine_inv_2_2_WHITE_UP*0.3817653560693467)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_0_WHITE_UP*0.3817653560693467)*(jac_affine_inv_0_0_WHITE_UP*0.61339470758478154 + jac_affine_inv_1_0_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_0_WHITE_UP*0.15593312049918601) + (jac_affine_inv_1_1_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_1_WHITE_UP*0.3817653560693467)*(jac_affine_inv_0_1_WHITE_UP*0.61339470758478154 + jac_affine_inv_1_1_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_1_WHITE_UP*0.15593312049918601) + (jac_affine_inv_1_2_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_2_WHITE_UP*0.3817653560693467)*(jac_affine_inv_0_2_WHITE_UP*0.61339470758478154 + jac_affine_inv_1_2_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_2_WHITE_UP*0.15593312049918601)), abs_det_jac_affine_WHITE_UP*(((jac_affine_inv_0_0_WHITE_UP*-0.031038539666093771 + jac_affine_inv_2_0_WHITE_UP)*(jac_affine_inv_0_0_WHITE_UP*-0.031038539666093771 + jac_affine_inv_2_0_WHITE_UP))*0.024315138068613663 + ((jac_affine_inv_0_1_WHITE_UP*-0.031038539666093771 + jac_affine_inv_2_1_WHITE_UP)*(jac_affine_inv_0_1_WHITE_UP*-0.031038539666093771 + jac_affine_inv_2_1_WHITE_UP))*0.024315138068613663 + ((jac_affine_inv_0_2_WHITE_UP*-0.031038539666093771 + jac_affine_inv_2_2_WHITE_UP)*(jac_affine_inv_0_2_WHITE_UP*-0.031038539666093771 + jac_affine_inv_2_2_WHITE_UP))*0.024315138068613663), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_0_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_0_WHITE_UP*-0.3817653560693467 + jac_affine_inv_1_0_WHITE_UP*0.15593312049918601) + (jac_affine_inv_0_1_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_1_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_1_WHITE_UP*-0.3817653560693467 + jac_affine_inv_1_1_WHITE_UP*0.15593312049918601) + (jac_affine_inv_0_2_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_2_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_2_WHITE_UP*-0.3817653560693467 + jac_affine_inv_1_2_WHITE_UP*0.15593312049918601)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_0_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_0_WHITE_UP*0.0048399363458717648 + jac_affine_inv_1_0_WHITE_UP*0.0048399363458717648 + jac_affine_inv_2_0_WHITE_UP*0.46230152343146724) + (jac_affine_inv_0_1_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_1_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_1_WHITE_UP*0.0048399363458717648 + jac_affine_inv_1_1_WHITE_UP*0.0048399363458717648 + jac_affine_inv_2_1_WHITE_UP*0.46230152343146724) + (jac_affine_inv_0_2_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_2_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_2_WHITE_UP*0.0048399363458717648 + jac_affine_inv_1_2_WHITE_UP*0.0048399363458717648 + jac_affine_inv_2_2_WHITE_UP*0.46230152343146724)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_0_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_0_WHITE_UP*0.3817653560693467 + jac_affine_inv_1_0_WHITE_UP*0.83922694315494217 + jac_affine_inv_2_0_WHITE_UP*0.3817653560693467) + (jac_affine_inv_0_1_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_1_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_1_WHITE_UP*0.3817653560693467 + jac_affine_inv_1_1_WHITE_UP*0.83922694315494217 + jac_affine_inv_2_1_WHITE_UP*0.3817653560693467) + (jac_affine_inv_0_2_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_2_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_2_WHITE_UP*0.3817653560693467 + jac_affine_inv_1_2_WHITE_UP*0.83922694315494217 + jac_affine_inv_2_2_WHITE_UP*0.3817653560693467)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_0_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_0_WHITE_UP*0.61339470758478154 + jac_affine_inv_1_0_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_0_WHITE_UP*0.15593312049918601) + (jac_affine_inv_0_1_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_1_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_1_WHITE_UP*0.61339470758478154 + jac_affine_inv_1_1_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_1_WHITE_UP*0.15593312049918601) + (jac_affine_inv_0_2_WHITE_UP*-0.0048399363458717648 + jac_affine_inv_2_2_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_2_WHITE_UP*0.61339470758478154 + jac_affine_inv_1_2_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_2_WHITE_UP*0.15593312049918601)), abs_det_jac_affine_WHITE_UP*(((-jac_affine_inv_0_0_WHITE_UP + jac_affine_inv_1_0_WHITE_UP*0.40845277870331731)*(-jac_affine_inv_0_0_WHITE_UP + jac_affine_inv_1_0_WHITE_UP*0.40845277870331731))*0.14574478709475508 + ((-jac_affine_inv_0_1_WHITE_UP + jac_affine_inv_1_1_WHITE_UP*0.40845277870331731)*(-jac_affine_inv_0_1_WHITE_UP + jac_affine_inv_1_1_WHITE_UP*0.40845277870331731))*0.14574478709475508 + ((-jac_affine_inv_0_2_WHITE_UP + jac_affine_inv_1_2_WHITE_UP*0.40845277870331731)*(-jac_affine_inv_0_2_WHITE_UP + jac_affine_inv_1_2_WHITE_UP*0.40845277870331731))*0.14574478709475508), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.3817653560693467 + jac_affine_inv_1_0_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_0_WHITE_UP*0.0048399363458717648 + jac_affine_inv_1_0_WHITE_UP*0.0048399363458717648 + jac_affine_inv_2_0_WHITE_UP*0.46230152343146724) + (jac_affine_inv_0_1_WHITE_UP*-0.3817653560693467 + jac_affine_inv_1_1_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_1_WHITE_UP*0.0048399363458717648 + jac_affine_inv_1_1_WHITE_UP*0.0048399363458717648 + jac_affine_inv_2_1_WHITE_UP*0.46230152343146724) + (jac_affine_inv_0_2_WHITE_UP*-0.3817653560693467 + jac_affine_inv_1_2_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_2_WHITE_UP*0.0048399363458717648 + jac_affine_inv_1_2_WHITE_UP*0.0048399363458717648 + jac_affine_inv_2_2_WHITE_UP*0.46230152343146724)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.3817653560693467 + jac_affine_inv_1_0_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_0_WHITE_UP*0.3817653560693467 + jac_affine_inv_1_0_WHITE_UP*0.83922694315494217 + jac_affine_inv_2_0_WHITE_UP*0.3817653560693467) + (jac_affine_inv_0_1_WHITE_UP*-0.3817653560693467 + jac_affine_inv_1_1_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_1_WHITE_UP*0.3817653560693467 + jac_affine_inv_1_1_WHITE_UP*0.83922694315494217 + jac_affine_inv_2_1_WHITE_UP*0.3817653560693467) + (jac_affine_inv_0_2_WHITE_UP*-0.3817653560693467 + jac_affine_inv_1_2_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_2_WHITE_UP*0.3817653560693467 + jac_affine_inv_1_2_WHITE_UP*0.83922694315494217 + jac_affine_inv_2_2_WHITE_UP*0.3817653560693467)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.3817653560693467 + jac_affine_inv_1_0_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_0_WHITE_UP*0.61339470758478154 + jac_affine_inv_1_0_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_0_WHITE_UP*0.15593312049918601) + (jac_affine_inv_0_1_WHITE_UP*-0.3817653560693467 + jac_affine_inv_1_1_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_1_WHITE_UP*0.61339470758478154 + jac_affine_inv_1_1_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_1_WHITE_UP*0.15593312049918601) + (jac_affine_inv_0_2_WHITE_UP*-0.3817653560693467 + jac_affine_inv_1_2_WHITE_UP*0.15593312049918601)*(jac_affine_inv_0_2_WHITE_UP*0.61339470758478154 + jac_affine_inv_1_2_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_2_WHITE_UP*0.15593312049918601)), abs_det_jac_affine_WHITE_UP*(((jac_affine_inv_0_0_WHITE_UP*0.010469219979953731 + jac_affine_inv_1_0_WHITE_UP*0.010469219979953731 + jac_affine_inv_2_0_WHITE_UP)*(jac_affine_inv_0_0_WHITE_UP*0.010469219979953731 + jac_affine_inv_1_0_WHITE_UP*0.010469219979953731 + jac_affine_inv_2_0_WHITE_UP))*0.21372269856705545 + ((jac_affine_inv_0_1_WHITE_UP*0.010469219979953731 + jac_affine_inv_1_1_WHITE_UP*0.010469219979953731 + jac_affine_inv_2_1_WHITE_UP)*(jac_affine_inv_0_1_WHITE_UP*0.010469219979953731 + jac_affine_inv_1_1_WHITE_UP*0.010469219979953731 + jac_affine_inv_2_1_WHITE_UP))*0.21372269856705545 + ((jac_affine_inv_0_2_WHITE_UP*0.010469219979953731 + jac_affine_inv_1_2_WHITE_UP*0.010469219979953731 + jac_affine_inv_2_2_WHITE_UP)*(jac_affine_inv_0_2_WHITE_UP*0.010469219979953731 + jac_affine_inv_1_2_WHITE_UP*0.010469219979953731 + jac_affine_inv_2_2_WHITE_UP))*0.21372269856705545), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.0048399363458717648 + jac_affine_inv_1_0_WHITE_UP*0.0048399363458717648 + jac_affine_inv_2_0_WHITE_UP*0.46230152343146724)*(jac_affine_inv_0_0_WHITE_UP*0.3817653560693467 + jac_affine_inv_1_0_WHITE_UP*0.83922694315494217 + jac_affine_inv_2_0_WHITE_UP*0.3817653560693467) + (jac_affine_inv_0_1_WHITE_UP*0.0048399363458717648 + jac_affine_inv_1_1_WHITE_UP*0.0048399363458717648 + jac_affine_inv_2_1_WHITE_UP*0.46230152343146724)*(jac_affine_inv_0_1_WHITE_UP*0.3817653560693467 + jac_affine_inv_1_1_WHITE_UP*0.83922694315494217 + jac_affine_inv_2_1_WHITE_UP*0.3817653560693467) + (jac_affine_inv_0_2_WHITE_UP*0.0048399363458717648 + jac_affine_inv_1_2_WHITE_UP*0.0048399363458717648 + jac_affine_inv_2_2_WHITE_UP*0.46230152343146724)*(jac_affine_inv_0_2_WHITE_UP*0.3817653560693467 + jac_affine_inv_1_2_WHITE_UP*0.83922694315494217 + jac_affine_inv_2_2_WHITE_UP*0.3817653560693467)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.0048399363458717648 + jac_affine_inv_1_0_WHITE_UP*0.0048399363458717648 + jac_affine_inv_2_0_WHITE_UP*0.46230152343146724)*(jac_affine_inv_0_0_WHITE_UP*0.61339470758478154 + jac_affine_inv_1_0_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_0_WHITE_UP*0.15593312049918601) + (jac_affine_inv_0_1_WHITE_UP*0.0048399363458717648 + jac_affine_inv_1_1_WHITE_UP*0.0048399363458717648 + jac_affine_inv_2_1_WHITE_UP*0.46230152343146724)*(jac_affine_inv_0_1_WHITE_UP*0.61339470758478154 + jac_affine_inv_1_1_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_1_WHITE_UP*0.15593312049918601) + (jac_affine_inv_0_2_WHITE_UP*0.0048399363458717648 + jac_affine_inv_1_2_WHITE_UP*0.0048399363458717648 + jac_affine_inv_2_2_WHITE_UP*0.46230152343146724)*(jac_affine_inv_0_2_WHITE_UP*0.61339470758478154 + jac_affine_inv_1_2_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_2_WHITE_UP*0.15593312049918601)), abs_det_jac_affine_WHITE_UP*(((jac_affine_inv_0_0_WHITE_UP*0.45490121496118757 + jac_affine_inv_1_0_WHITE_UP + jac_affine_inv_2_0_WHITE_UP*0.45490121496118757)*(jac_affine_inv_0_0_WHITE_UP*0.45490121496118757 + jac_affine_inv_1_0_WHITE_UP + jac_affine_inv_2_0_WHITE_UP*0.45490121496118757))*0.70430186211718859 + ((jac_affine_inv_0_1_WHITE_UP*0.45490121496118757 + jac_affine_inv_1_1_WHITE_UP + jac_affine_inv_2_1_WHITE_UP*0.45490121496118757)*(jac_affine_inv_0_1_WHITE_UP*0.45490121496118757 + jac_affine_inv_1_1_WHITE_UP + jac_affine_inv_2_1_WHITE_UP*0.45490121496118757))*0.70430186211718859 + ((jac_affine_inv_0_2_WHITE_UP*0.45490121496118757 + jac_affine_inv_1_2_WHITE_UP + jac_affine_inv_2_2_WHITE_UP*0.45490121496118757)*(jac_affine_inv_0_2_WHITE_UP*0.45490121496118757 + jac_affine_inv_1_2_WHITE_UP + jac_affine_inv_2_2_WHITE_UP*0.45490121496118757))*0.70430186211718859), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.3817653560693467 + jac_affine_inv_1_0_WHITE_UP*0.83922694315494217 + jac_affine_inv_2_0_WHITE_UP*0.3817653560693467)*(jac_affine_inv_0_0_WHITE_UP*0.61339470758478154 + jac_affine_inv_1_0_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_0_WHITE_UP*0.15593312049918601) + (jac_affine_inv_0_1_WHITE_UP*0.3817653560693467 + jac_affine_inv_1_1_WHITE_UP*0.83922694315494217 + jac_affine_inv_2_1_WHITE_UP*0.3817653560693467)*(jac_affine_inv_0_1_WHITE_UP*0.61339470758478154 + jac_affine_inv_1_1_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_1_WHITE_UP*0.15593312049918601) + (jac_affine_inv_0_2_WHITE_UP*0.3817653560693467 + jac_affine_inv_1_2_WHITE_UP*0.83922694315494217 + jac_affine_inv_2_2_WHITE_UP*0.3817653560693467)*(jac_affine_inv_0_2_WHITE_UP*0.61339470758478154 + jac_affine_inv_1_2_WHITE_UP*0.15593312049918601 + jac_affine_inv_2_2_WHITE_UP*0.15593312049918601)), abs_det_jac_affine_WHITE_UP*(((jac_affine_inv_0_0_WHITE_UP + jac_affine_inv_1_0_WHITE_UP*0.25421334512840316 + jac_affine_inv_2_0_WHITE_UP*0.25421334512840316)*(jac_affine_inv_0_0_WHITE_UP + jac_affine_inv_1_0_WHITE_UP*0.25421334512840316 + jac_affine_inv_2_0_WHITE_UP*0.25421334512840316))*0.37625306729301966 + ((jac_affine_inv_0_1_WHITE_UP + jac_affine_inv_1_1_WHITE_UP*0.25421334512840316 + jac_affine_inv_2_1_WHITE_UP*0.25421334512840316)*(jac_affine_inv_0_1_WHITE_UP + jac_affine_inv_1_1_WHITE_UP*0.25421334512840316 + jac_affine_inv_2_1_WHITE_UP*0.25421334512840316))*0.37625306729301966 + ((jac_affine_inv_0_2_WHITE_UP + jac_affine_inv_1_2_WHITE_UP*0.25421334512840316 + jac_affine_inv_2_2_WHITE_UP*0.25421334512840316)*(jac_affine_inv_0_2_WHITE_UP + jac_affine_inv_1_2_WHITE_UP*0.25421334512840316 + jac_affine_inv_2_2_WHITE_UP*0.25421334512840316))*0.37625306729301966), abs_det_jac_affine_WHITE_UP*(((-jac_affine_inv_1_0_WHITE_UP + jac_affine_inv_2_0_WHITE_UP*0.015462881894859308)*(-jac_affine_inv_1_0_WHITE_UP + jac_affine_inv_2_0_WHITE_UP*0.015462881894859308))*0.20046443821120841 + ((-jac_affine_inv_1_1_WHITE_UP + jac_affine_inv_2_1_WHITE_UP*0.015462881894859308)*(-jac_affine_inv_1_1_WHITE_UP + jac_affine_inv_2_1_WHITE_UP*0.015462881894859308))*0.20046443821120841 + ((-jac_affine_inv_1_2_WHITE_UP + jac_affine_inv_2_2_WHITE_UP*0.015462881894859308)*(-jac_affine_inv_1_2_WHITE_UP + jac_affine_inv_2_2_WHITE_UP*0.015462881894859308))*0.20046443821120841), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_0_WHITE_UP*0.18002969351036541)*(jac_affine_inv_1_0_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_0_WHITE_UP*0.0069232355736274674) + (jac_affine_inv_0_1_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_1_WHITE_UP*0.18002969351036541)*(jac_affine_inv_1_1_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_1_WHITE_UP*0.0069232355736274674) + (jac_affine_inv_0_2_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_2_WHITE_UP*0.18002969351036541)*(jac_affine_inv_1_2_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_2_WHITE_UP*0.0069232355736274674)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.0069232355736274674 + jac_affine_inv_1_0_WHITE_UP*0.18002969351036541)*(jac_affine_inv_1_0_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_0_WHITE_UP*0.0069232355736274674) + (jac_affine_inv_0_1_WHITE_UP*-0.0069232355736274674 + jac_affine_inv_1_1_WHITE_UP*0.18002969351036541)*(jac_affine_inv_1_1_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_1_WHITE_UP*0.0069232355736274674) + (jac_affine_inv_0_2_WHITE_UP*-0.0069232355736274674 + jac_affine_inv_1_2_WHITE_UP*0.18002969351036541)*(jac_affine_inv_1_2_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_2_WHITE_UP*0.0069232355736274674)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_0_WHITE_UP*0.0069232355736274674)*(jac_affine_inv_0_0_WHITE_UP*0.44773255210137269 + jac_affine_inv_1_0_WHITE_UP*0.44773255210137269 + jac_affine_inv_2_0_WHITE_UP*0.81304707091600714) + (jac_affine_inv_1_1_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_1_WHITE_UP*0.0069232355736274674)*(jac_affine_inv_0_1_WHITE_UP*0.44773255210137269 + jac_affine_inv_1_1_WHITE_UP*0.44773255210137269 + jac_affine_inv_2_1_WHITE_UP*0.81304707091600714) + (jac_affine_inv_1_2_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_2_WHITE_UP*0.0069232355736274674)*(jac_affine_inv_0_2_WHITE_UP*0.44773255210137269 + jac_affine_inv_1_2_WHITE_UP*0.44773255210137269 + jac_affine_inv_2_2_WHITE_UP*0.81304707091600714)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_0_WHITE_UP*0.0069232355736274674)*(jac_affine_inv_0_0_WHITE_UP*0.0069232355736274674 + jac_affine_inv_1_0_WHITE_UP*0.37223775438826195 + jac_affine_inv_2_0_WHITE_UP*0.0069232355736274674) + (jac_affine_inv_1_1_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_1_WHITE_UP*0.0069232355736274674)*(jac_affine_inv_0_1_WHITE_UP*0.0069232355736274674 + jac_affine_inv_1_1_WHITE_UP*0.37223775438826195 + jac_affine_inv_2_1_WHITE_UP*0.0069232355736274674) + (jac_affine_inv_1_2_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_2_WHITE_UP*0.0069232355736274674)*(jac_affine_inv_0_2_WHITE_UP*0.0069232355736274674 + jac_affine_inv_1_2_WHITE_UP*0.37223775438826195 + jac_affine_inv_2_2_WHITE_UP*0.0069232355736274674)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_0_WHITE_UP*0.0069232355736274674)*(jac_affine_inv_0_0_WHITE_UP*0.54534421232499986 + jac_affine_inv_1_0_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_0_WHITE_UP*0.18002969351036541) + (jac_affine_inv_1_1_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_1_WHITE_UP*0.0069232355736274674)*(jac_affine_inv_0_1_WHITE_UP*0.54534421232499986 + jac_affine_inv_1_1_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_1_WHITE_UP*0.18002969351036541) + (jac_affine_inv_1_2_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_2_WHITE_UP*0.0069232355736274674)*(jac_affine_inv_0_2_WHITE_UP*0.54534421232499986 + jac_affine_inv_1_2_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_2_WHITE_UP*0.18002969351036541)), abs_det_jac_affine_WHITE_UP*(((-jac_affine_inv_0_0_WHITE_UP + jac_affine_inv_2_0_WHITE_UP*0.40209203611714223)*(-jac_affine_inv_0_0_WHITE_UP + jac_affine_inv_2_0_WHITE_UP*0.40209203611714223))*0.20046443821120841 + ((-jac_affine_inv_0_1_WHITE_UP + jac_affine_inv_2_1_WHITE_UP*0.40209203611714223)*(-jac_affine_inv_0_1_WHITE_UP + jac_affine_inv_2_1_WHITE_UP*0.40209203611714223))*0.20046443821120841 + ((-jac_affine_inv_0_2_WHITE_UP + jac_affine_inv_2_2_WHITE_UP*0.40209203611714223)*(-jac_affine_inv_0_2_WHITE_UP + jac_affine_inv_2_2_WHITE_UP*0.40209203611714223))*0.20046443821120841), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.0069232355736274674 + jac_affine_inv_1_0_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_0_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_0_WHITE_UP*0.18002969351036541) + (jac_affine_inv_0_1_WHITE_UP*-0.0069232355736274674 + jac_affine_inv_1_1_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_1_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_1_WHITE_UP*0.18002969351036541) + (jac_affine_inv_0_2_WHITE_UP*-0.0069232355736274674 + jac_affine_inv_1_2_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_2_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_2_WHITE_UP*0.18002969351036541)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_0_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_0_WHITE_UP*0.44773255210137269 + jac_affine_inv_1_0_WHITE_UP*0.44773255210137269 + jac_affine_inv_2_0_WHITE_UP*0.81304707091600714) + (jac_affine_inv_0_1_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_1_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_1_WHITE_UP*0.44773255210137269 + jac_affine_inv_1_1_WHITE_UP*0.44773255210137269 + jac_affine_inv_2_1_WHITE_UP*0.81304707091600714) + (jac_affine_inv_0_2_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_2_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_2_WHITE_UP*0.44773255210137269 + jac_affine_inv_1_2_WHITE_UP*0.44773255210137269 + jac_affine_inv_2_2_WHITE_UP*0.81304707091600714)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_0_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_0_WHITE_UP*0.0069232355736274674 + jac_affine_inv_1_0_WHITE_UP*0.37223775438826195 + jac_affine_inv_2_0_WHITE_UP*0.0069232355736274674) + (jac_affine_inv_0_1_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_1_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_1_WHITE_UP*0.0069232355736274674 + jac_affine_inv_1_1_WHITE_UP*0.37223775438826195 + jac_affine_inv_2_1_WHITE_UP*0.0069232355736274674) + (jac_affine_inv_0_2_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_2_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_2_WHITE_UP*0.0069232355736274674 + jac_affine_inv_1_2_WHITE_UP*0.37223775438826195 + jac_affine_inv_2_2_WHITE_UP*0.0069232355736274674)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_0_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_0_WHITE_UP*0.54534421232499986 + jac_affine_inv_1_0_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_0_WHITE_UP*0.18002969351036541) + (jac_affine_inv_0_1_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_1_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_1_WHITE_UP*0.54534421232499986 + jac_affine_inv_1_1_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_1_WHITE_UP*0.18002969351036541) + (jac_affine_inv_0_2_WHITE_UP*-0.44773255210137269 + jac_affine_inv_2_2_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_2_WHITE_UP*0.54534421232499986 + jac_affine_inv_1_2_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_2_WHITE_UP*0.18002969351036541)), abs_det_jac_affine_WHITE_UP*(((jac_affine_inv_0_0_WHITE_UP*-0.03845607598742512 + jac_affine_inv_1_0_WHITE_UP)*(jac_affine_inv_0_0_WHITE_UP*-0.03845607598742512 + jac_affine_inv_1_0_WHITE_UP))*0.032410690545436105 + ((jac_affine_inv_0_1_WHITE_UP*-0.03845607598742512 + jac_affine_inv_1_1_WHITE_UP)*(jac_affine_inv_0_1_WHITE_UP*-0.03845607598742512 + jac_affine_inv_1_1_WHITE_UP))*0.032410690545436105 + ((jac_affine_inv_0_2_WHITE_UP*-0.03845607598742512 + jac_affine_inv_1_2_WHITE_UP)*(jac_affine_inv_0_2_WHITE_UP*-0.03845607598742512 + jac_affine_inv_1_2_WHITE_UP))*0.032410690545436105), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.0069232355736274674 + jac_affine_inv_1_0_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_0_WHITE_UP*0.44773255210137269 + jac_affine_inv_1_0_WHITE_UP*0.44773255210137269 + jac_affine_inv_2_0_WHITE_UP*0.81304707091600714) + (jac_affine_inv_0_1_WHITE_UP*-0.0069232355736274674 + jac_affine_inv_1_1_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_1_WHITE_UP*0.44773255210137269 + jac_affine_inv_1_1_WHITE_UP*0.44773255210137269 + jac_affine_inv_2_1_WHITE_UP*0.81304707091600714) + (jac_affine_inv_0_2_WHITE_UP*-0.0069232355736274674 + jac_affine_inv_1_2_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_2_WHITE_UP*0.44773255210137269 + jac_affine_inv_1_2_WHITE_UP*0.44773255210137269 + jac_affine_inv_2_2_WHITE_UP*0.81304707091600714)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.0069232355736274674 + jac_affine_inv_1_0_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_0_WHITE_UP*0.0069232355736274674 + jac_affine_inv_1_0_WHITE_UP*0.37223775438826195 + jac_affine_inv_2_0_WHITE_UP*0.0069232355736274674) + (jac_affine_inv_0_1_WHITE_UP*-0.0069232355736274674 + jac_affine_inv_1_1_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_1_WHITE_UP*0.0069232355736274674 + jac_affine_inv_1_1_WHITE_UP*0.37223775438826195 + jac_affine_inv_2_1_WHITE_UP*0.0069232355736274674) + (jac_affine_inv_0_2_WHITE_UP*-0.0069232355736274674 + jac_affine_inv_1_2_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_2_WHITE_UP*0.0069232355736274674 + jac_affine_inv_1_2_WHITE_UP*0.37223775438826195 + jac_affine_inv_2_2_WHITE_UP*0.0069232355736274674)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.0069232355736274674 + jac_affine_inv_1_0_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_0_WHITE_UP*0.54534421232499986 + jac_affine_inv_1_0_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_0_WHITE_UP*0.18002969351036541) + (jac_affine_inv_0_1_WHITE_UP*-0.0069232355736274674 + jac_affine_inv_1_1_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_1_WHITE_UP*0.54534421232499986 + jac_affine_inv_1_1_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_1_WHITE_UP*0.18002969351036541) + (jac_affine_inv_0_2_WHITE_UP*-0.0069232355736274674 + jac_affine_inv_1_2_WHITE_UP*0.18002969351036541)*(jac_affine_inv_0_2_WHITE_UP*0.54534421232499986 + jac_affine_inv_1_2_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_2_WHITE_UP*0.18002969351036541)), abs_det_jac_affine_WHITE_UP*(((jac_affine_inv_0_0_WHITE_UP*0.55068466281655948 + jac_affine_inv_1_0_WHITE_UP*0.55068466281655948 + jac_affine_inv_2_0_WHITE_UP)*(jac_affine_inv_0_0_WHITE_UP*0.55068466281655948 + jac_affine_inv_1_0_WHITE_UP*0.55068466281655948 + jac_affine_inv_2_0_WHITE_UP))*0.6610455395250987 + ((jac_affine_inv_0_1_WHITE_UP*0.55068466281655948 + jac_affine_inv_1_1_WHITE_UP*0.55068466281655948 + jac_affine_inv_2_1_WHITE_UP)*(jac_affine_inv_0_1_WHITE_UP*0.55068466281655948 + jac_affine_inv_1_1_WHITE_UP*0.55068466281655948 + jac_affine_inv_2_1_WHITE_UP))*0.6610455395250987 + ((jac_affine_inv_0_2_WHITE_UP*0.55068466281655948 + jac_affine_inv_1_2_WHITE_UP*0.55068466281655948 + jac_affine_inv_2_2_WHITE_UP)*(jac_affine_inv_0_2_WHITE_UP*0.55068466281655948 + jac_affine_inv_1_2_WHITE_UP*0.55068466281655948 + jac_affine_inv_2_2_WHITE_UP))*0.6610455395250987), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.0069232355736274674 + jac_affine_inv_1_0_WHITE_UP*0.37223775438826195 + jac_affine_inv_2_0_WHITE_UP*0.0069232355736274674)*(jac_affine_inv_0_0_WHITE_UP*0.44773255210137269 + jac_affine_inv_1_0_WHITE_UP*0.44773255210137269 + jac_affine_inv_2_0_WHITE_UP*0.81304707091600714) + (jac_affine_inv_0_1_WHITE_UP*0.0069232355736274674 + jac_affine_inv_1_1_WHITE_UP*0.37223775438826195 + jac_affine_inv_2_1_WHITE_UP*0.0069232355736274674)*(jac_affine_inv_0_1_WHITE_UP*0.44773255210137269 + jac_affine_inv_1_1_WHITE_UP*0.44773255210137269 + jac_affine_inv_2_1_WHITE_UP*0.81304707091600714) + (jac_affine_inv_0_2_WHITE_UP*0.0069232355736274674 + jac_affine_inv_1_2_WHITE_UP*0.37223775438826195 + jac_affine_inv_2_2_WHITE_UP*0.0069232355736274674)*(jac_affine_inv_0_2_WHITE_UP*0.44773255210137269 + jac_affine_inv_1_2_WHITE_UP*0.44773255210137269 + jac_affine_inv_2_2_WHITE_UP*0.81304707091600714)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.44773255210137269 + jac_affine_inv_1_0_WHITE_UP*0.44773255210137269 + jac_affine_inv_2_0_WHITE_UP*0.81304707091600714)*(jac_affine_inv_0_0_WHITE_UP*0.54534421232499986 + jac_affine_inv_1_0_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_0_WHITE_UP*0.18002969351036541) + (jac_affine_inv_0_1_WHITE_UP*0.44773255210137269 + jac_affine_inv_1_1_WHITE_UP*0.44773255210137269 + jac_affine_inv_2_1_WHITE_UP*0.81304707091600714)*(jac_affine_inv_0_1_WHITE_UP*0.54534421232499986 + jac_affine_inv_1_1_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_1_WHITE_UP*0.18002969351036541) + (jac_affine_inv_0_2_WHITE_UP*0.44773255210137269 + jac_affine_inv_1_2_WHITE_UP*0.44773255210137269 + jac_affine_inv_2_2_WHITE_UP*0.81304707091600714)*(jac_affine_inv_0_2_WHITE_UP*0.54534421232499986 + jac_affine_inv_1_2_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_2_WHITE_UP*0.18002969351036541)), abs_det_jac_affine_WHITE_UP*(((jac_affine_inv_0_0_WHITE_UP*0.01859896126067373 + jac_affine_inv_1_0_WHITE_UP + jac_affine_inv_2_0_WHITE_UP*0.01859896126067373)*(jac_affine_inv_0_0_WHITE_UP*0.01859896126067373 + jac_affine_inv_1_0_WHITE_UP + jac_affine_inv_2_0_WHITE_UP*0.01859896126067373))*0.13856094579201603 + ((jac_affine_inv_0_1_WHITE_UP*0.01859896126067373 + jac_affine_inv_1_1_WHITE_UP + jac_affine_inv_2_1_WHITE_UP*0.01859896126067373)*(jac_affine_inv_0_1_WHITE_UP*0.01859896126067373 + jac_affine_inv_1_1_WHITE_UP + jac_affine_inv_2_1_WHITE_UP*0.01859896126067373))*0.13856094579201603 + ((jac_affine_inv_0_2_WHITE_UP*0.01859896126067373 + jac_affine_inv_1_2_WHITE_UP + jac_affine_inv_2_2_WHITE_UP*0.01859896126067373)*(jac_affine_inv_0_2_WHITE_UP*0.01859896126067373 + jac_affine_inv_1_2_WHITE_UP + jac_affine_inv_2_2_WHITE_UP*0.01859896126067373))*0.13856094579201603), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.0069232355736274674 + jac_affine_inv_1_0_WHITE_UP*0.37223775438826195 + jac_affine_inv_2_0_WHITE_UP*0.0069232355736274674)*(jac_affine_inv_0_0_WHITE_UP*0.54534421232499986 + jac_affine_inv_1_0_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_0_WHITE_UP*0.18002969351036541) + (jac_affine_inv_0_1_WHITE_UP*0.0069232355736274674 + jac_affine_inv_1_1_WHITE_UP*0.37223775438826195 + jac_affine_inv_2_1_WHITE_UP*0.0069232355736274674)*(jac_affine_inv_0_1_WHITE_UP*0.54534421232499986 + jac_affine_inv_1_1_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_1_WHITE_UP*0.18002969351036541) + (jac_affine_inv_0_2_WHITE_UP*0.0069232355736274674 + jac_affine_inv_1_2_WHITE_UP*0.37223775438826195 + jac_affine_inv_2_2_WHITE_UP*0.0069232355736274674)*(jac_affine_inv_0_2_WHITE_UP*0.54534421232499986 + jac_affine_inv_1_2_WHITE_UP*0.18002969351036541 + jac_affine_inv_2_2_WHITE_UP*0.18002969351036541)), abs_det_jac_affine_WHITE_UP*(((jac_affine_inv_0_0_WHITE_UP + jac_affine_inv_1_0_WHITE_UP*0.33012121416459822 + jac_affine_inv_2_0_WHITE_UP*0.33012121416459822)*(jac_affine_inv_0_0_WHITE_UP + jac_affine_inv_1_0_WHITE_UP*0.33012121416459822 + jac_affine_inv_2_0_WHITE_UP*0.33012121416459822))*0.29740030991637451 + ((jac_affine_inv_0_1_WHITE_UP + jac_affine_inv_1_1_WHITE_UP*0.33012121416459822 + jac_affine_inv_2_1_WHITE_UP*0.33012121416459822)*(jac_affine_inv_0_1_WHITE_UP + jac_affine_inv_1_1_WHITE_UP*0.33012121416459822 + jac_affine_inv_2_1_WHITE_UP*0.33012121416459822))*0.29740030991637451 + ((jac_affine_inv_0_2_WHITE_UP + jac_affine_inv_1_2_WHITE_UP*0.33012121416459822 + jac_affine_inv_2_2_WHITE_UP*0.33012121416459822)*(jac_affine_inv_0_2_WHITE_UP + jac_affine_inv_1_2_WHITE_UP*0.33012121416459822 + jac_affine_inv_2_2_WHITE_UP*0.33012121416459822))*0.29740030991637451), abs_det_jac_affine_WHITE_UP*(((jac_affine_inv_1_0_WHITE_UP*-0.81923601162978588 + jac_affine_inv_2_0_WHITE_UP)*(jac_affine_inv_1_0_WHITE_UP*-0.81923601162978588 + jac_affine_inv_2_0_WHITE_UP))*0.18550396047976214 + ((jac_affine_inv_1_1_WHITE_UP*-0.81923601162978588 + jac_affine_inv_2_1_WHITE_UP)*(jac_affine_inv_1_1_WHITE_UP*-0.81923601162978588 + jac_affine_inv_2_1_WHITE_UP))*0.18550396047976214 + ((jac_affine_inv_1_2_WHITE_UP*-0.81923601162978588 + jac_affine_inv_2_2_WHITE_UP)*(jac_affine_inv_1_2_WHITE_UP*-0.81923601162978588 + jac_affine_inv_2_2_WHITE_UP))*0.18550396047976214), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_0_WHITE_UP*0.21607642918484779)*(jac_affine_inv_1_0_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_0_WHITE_UP*0.43070170707783612) + (jac_affine_inv_0_1_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_1_WHITE_UP*0.21607642918484779)*(jac_affine_inv_1_1_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_1_WHITE_UP*0.43070170707783612) + (jac_affine_inv_0_2_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_2_WHITE_UP*0.21607642918484779)*(jac_affine_inv_1_2_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_2_WHITE_UP*0.43070170707783612)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.43070170707783612 + jac_affine_inv_1_0_WHITE_UP*0.21607642918484779)*(jac_affine_inv_1_0_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_0_WHITE_UP*0.43070170707783612) + (jac_affine_inv_0_1_WHITE_UP*-0.43070170707783612 + jac_affine_inv_1_1_WHITE_UP*0.21607642918484779)*(jac_affine_inv_1_1_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_1_WHITE_UP*0.43070170707783612) + (jac_affine_inv_0_2_WHITE_UP*-0.43070170707783612 + jac_affine_inv_1_2_WHITE_UP*0.21607642918484779)*(jac_affine_inv_1_2_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_2_WHITE_UP*0.43070170707783612)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_0_WHITE_UP*0.43070170707783612)*(jac_affine_inv_0_0_WHITE_UP*0.35284634870858678 + jac_affine_inv_1_0_WHITE_UP*0.35284634870858678 + jac_affine_inv_2_0_WHITE_UP*0.35322186373731607) + (jac_affine_inv_1_1_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_1_WHITE_UP*0.43070170707783612)*(jac_affine_inv_0_1_WHITE_UP*0.35284634870858678 + jac_affine_inv_1_1_WHITE_UP*0.35284634870858678 + jac_affine_inv_2_1_WHITE_UP*0.35322186373731607) + (jac_affine_inv_1_2_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_2_WHITE_UP*0.43070170707783612)*(jac_affine_inv_0_2_WHITE_UP*0.35284634870858678 + jac_affine_inv_1_2_WHITE_UP*0.35284634870858678 + jac_affine_inv_2_2_WHITE_UP*0.35322186373731607)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_0_WHITE_UP*0.43070170707783612)*(jac_affine_inv_0_0_WHITE_UP*0.43070170707783612 + jac_affine_inv_1_0_WHITE_UP*0.43107722210656541 + jac_affine_inv_2_0_WHITE_UP*0.43070170707783612) + (jac_affine_inv_1_1_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_1_WHITE_UP*0.43070170707783612)*(jac_affine_inv_0_1_WHITE_UP*0.43070170707783612 + jac_affine_inv_1_1_WHITE_UP*0.43107722210656541 + jac_affine_inv_2_1_WHITE_UP*0.43070170707783612) + (jac_affine_inv_1_2_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_2_WHITE_UP*0.43070170707783612)*(jac_affine_inv_0_2_WHITE_UP*0.43070170707783612 + jac_affine_inv_1_2_WHITE_UP*0.43107722210656541 + jac_affine_inv_2_2_WHITE_UP*0.43070170707783612)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_1_0_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_0_WHITE_UP*0.43070170707783612)*(jac_affine_inv_0_0_WHITE_UP*0.21645194421357716 + jac_affine_inv_1_0_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_0_WHITE_UP*0.21607642918484779) + (jac_affine_inv_1_1_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_1_WHITE_UP*0.43070170707783612)*(jac_affine_inv_0_1_WHITE_UP*0.21645194421357716 + jac_affine_inv_1_1_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_1_WHITE_UP*0.21607642918484779) + (jac_affine_inv_1_2_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_2_WHITE_UP*0.43070170707783612)*(jac_affine_inv_0_2_WHITE_UP*0.21645194421357716 + jac_affine_inv_1_2_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_2_WHITE_UP*0.21607642918484779)), abs_det_jac_affine_WHITE_UP*(((-jac_affine_inv_0_0_WHITE_UP + jac_affine_inv_2_0_WHITE_UP*0.61238108308527162)*(-jac_affine_inv_0_0_WHITE_UP + jac_affine_inv_2_0_WHITE_UP*0.61238108308527162))*0.12450054579698162 + ((-jac_affine_inv_0_1_WHITE_UP + jac_affine_inv_2_1_WHITE_UP*0.61238108308527162)*(-jac_affine_inv_0_1_WHITE_UP + jac_affine_inv_2_1_WHITE_UP*0.61238108308527162))*0.12450054579698162 + ((-jac_affine_inv_0_2_WHITE_UP + jac_affine_inv_2_2_WHITE_UP*0.61238108308527162)*(-jac_affine_inv_0_2_WHITE_UP + jac_affine_inv_2_2_WHITE_UP*0.61238108308527162))*0.12450054579698162), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_0_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_0_WHITE_UP*-0.43070170707783612 + jac_affine_inv_1_0_WHITE_UP*0.21607642918484779) + (jac_affine_inv_0_1_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_1_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_1_WHITE_UP*-0.43070170707783612 + jac_affine_inv_1_1_WHITE_UP*0.21607642918484779) + (jac_affine_inv_0_2_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_2_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_2_WHITE_UP*-0.43070170707783612 + jac_affine_inv_1_2_WHITE_UP*0.21607642918484779)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_0_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_0_WHITE_UP*0.35284634870858678 + jac_affine_inv_1_0_WHITE_UP*0.35284634870858678 + jac_affine_inv_2_0_WHITE_UP*0.35322186373731607) + (jac_affine_inv_0_1_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_1_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_1_WHITE_UP*0.35284634870858678 + jac_affine_inv_1_1_WHITE_UP*0.35284634870858678 + jac_affine_inv_2_1_WHITE_UP*0.35322186373731607) + (jac_affine_inv_0_2_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_2_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_2_WHITE_UP*0.35284634870858678 + jac_affine_inv_1_2_WHITE_UP*0.35284634870858678 + jac_affine_inv_2_2_WHITE_UP*0.35322186373731607)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_0_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_0_WHITE_UP*0.43070170707783612 + jac_affine_inv_1_0_WHITE_UP*0.43107722210656541 + jac_affine_inv_2_0_WHITE_UP*0.43070170707783612) + (jac_affine_inv_0_1_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_1_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_1_WHITE_UP*0.43070170707783612 + jac_affine_inv_1_1_WHITE_UP*0.43107722210656541 + jac_affine_inv_2_1_WHITE_UP*0.43070170707783612) + (jac_affine_inv_0_2_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_2_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_2_WHITE_UP*0.43070170707783612 + jac_affine_inv_1_2_WHITE_UP*0.43107722210656541 + jac_affine_inv_2_2_WHITE_UP*0.43070170707783612)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_0_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_0_WHITE_UP*0.21645194421357716 + jac_affine_inv_1_0_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_0_WHITE_UP*0.21607642918484779) + (jac_affine_inv_0_1_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_1_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_1_WHITE_UP*0.21645194421357716 + jac_affine_inv_1_1_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_1_WHITE_UP*0.21607642918484779) + (jac_affine_inv_0_2_WHITE_UP*-0.35284634870858678 + jac_affine_inv_2_2_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_2_WHITE_UP*0.21645194421357716 + jac_affine_inv_1_2_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_2_WHITE_UP*0.21607642918484779)), abs_det_jac_affine_WHITE_UP*(((-jac_affine_inv_0_0_WHITE_UP + jac_affine_inv_1_0_WHITE_UP*0.50168463610430647)*(-jac_affine_inv_0_0_WHITE_UP + jac_affine_inv_1_0_WHITE_UP*0.50168463610430647))*0.18550396047976214 + ((-jac_affine_inv_0_1_WHITE_UP + jac_affine_inv_1_1_WHITE_UP*0.50168463610430647)*(-jac_affine_inv_0_1_WHITE_UP + jac_affine_inv_1_1_WHITE_UP*0.50168463610430647))*0.18550396047976214 + ((-jac_affine_inv_0_2_WHITE_UP + jac_affine_inv_1_2_WHITE_UP*0.50168463610430647)*(-jac_affine_inv_0_2_WHITE_UP + jac_affine_inv_1_2_WHITE_UP*0.50168463610430647))*0.18550396047976214), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.43070170707783612 + jac_affine_inv_1_0_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_0_WHITE_UP*0.35284634870858678 + jac_affine_inv_1_0_WHITE_UP*0.35284634870858678 + jac_affine_inv_2_0_WHITE_UP*0.35322186373731607) + (jac_affine_inv_0_1_WHITE_UP*-0.43070170707783612 + jac_affine_inv_1_1_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_1_WHITE_UP*0.35284634870858678 + jac_affine_inv_1_1_WHITE_UP*0.35284634870858678 + jac_affine_inv_2_1_WHITE_UP*0.35322186373731607) + (jac_affine_inv_0_2_WHITE_UP*-0.43070170707783612 + jac_affine_inv_1_2_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_2_WHITE_UP*0.35284634870858678 + jac_affine_inv_1_2_WHITE_UP*0.35284634870858678 + jac_affine_inv_2_2_WHITE_UP*0.35322186373731607)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.43070170707783612 + jac_affine_inv_1_0_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_0_WHITE_UP*0.43070170707783612 + jac_affine_inv_1_0_WHITE_UP*0.43107722210656541 + jac_affine_inv_2_0_WHITE_UP*0.43070170707783612) + (jac_affine_inv_0_1_WHITE_UP*-0.43070170707783612 + jac_affine_inv_1_1_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_1_WHITE_UP*0.43070170707783612 + jac_affine_inv_1_1_WHITE_UP*0.43107722210656541 + jac_affine_inv_2_1_WHITE_UP*0.43070170707783612) + (jac_affine_inv_0_2_WHITE_UP*-0.43070170707783612 + jac_affine_inv_1_2_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_2_WHITE_UP*0.43070170707783612 + jac_affine_inv_1_2_WHITE_UP*0.43107722210656541 + jac_affine_inv_2_2_WHITE_UP*0.43070170707783612)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*-0.43070170707783612 + jac_affine_inv_1_0_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_0_WHITE_UP*0.21645194421357716 + jac_affine_inv_1_0_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_0_WHITE_UP*0.21607642918484779) + (jac_affine_inv_0_1_WHITE_UP*-0.43070170707783612 + jac_affine_inv_1_1_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_1_WHITE_UP*0.21645194421357716 + jac_affine_inv_1_1_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_1_WHITE_UP*0.21607642918484779) + (jac_affine_inv_0_2_WHITE_UP*-0.43070170707783612 + jac_affine_inv_1_2_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_2_WHITE_UP*0.21645194421357716 + jac_affine_inv_1_2_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_2_WHITE_UP*0.21607642918484779)), abs_det_jac_affine_WHITE_UP*(((jac_affine_inv_0_0_WHITE_UP*0.99893688622568233 + jac_affine_inv_1_0_WHITE_UP*0.99893688622568233 + jac_affine_inv_2_0_WHITE_UP)*(jac_affine_inv_0_0_WHITE_UP*0.99893688622568233 + jac_affine_inv_1_0_WHITE_UP*0.99893688622568233 + jac_affine_inv_2_0_WHITE_UP))*0.12476568502206307 + ((jac_affine_inv_0_1_WHITE_UP*0.99893688622568233 + jac_affine_inv_1_1_WHITE_UP*0.99893688622568233 + jac_affine_inv_2_1_WHITE_UP)*(jac_affine_inv_0_1_WHITE_UP*0.99893688622568233 + jac_affine_inv_1_1_WHITE_UP*0.99893688622568233 + jac_affine_inv_2_1_WHITE_UP))*0.12476568502206307 + ((jac_affine_inv_0_2_WHITE_UP*0.99893688622568233 + jac_affine_inv_1_2_WHITE_UP*0.99893688622568233 + jac_affine_inv_2_2_WHITE_UP)*(jac_affine_inv_0_2_WHITE_UP*0.99893688622568233 + jac_affine_inv_1_2_WHITE_UP*0.99893688622568233 + jac_affine_inv_2_2_WHITE_UP))*0.12476568502206307), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.35284634870858678 + jac_affine_inv_1_0_WHITE_UP*0.35284634870858678 + jac_affine_inv_2_0_WHITE_UP*0.35322186373731607)*(jac_affine_inv_0_0_WHITE_UP*0.43070170707783612 + jac_affine_inv_1_0_WHITE_UP*0.43107722210656541 + jac_affine_inv_2_0_WHITE_UP*0.43070170707783612) + (jac_affine_inv_0_1_WHITE_UP*0.35284634870858678 + jac_affine_inv_1_1_WHITE_UP*0.35284634870858678 + jac_affine_inv_2_1_WHITE_UP*0.35322186373731607)*(jac_affine_inv_0_1_WHITE_UP*0.43070170707783612 + jac_affine_inv_1_1_WHITE_UP*0.43107722210656541 + jac_affine_inv_2_1_WHITE_UP*0.43070170707783612) + (jac_affine_inv_0_2_WHITE_UP*0.35284634870858678 + jac_affine_inv_1_2_WHITE_UP*0.35284634870858678 + jac_affine_inv_2_2_WHITE_UP*0.35322186373731607)*(jac_affine_inv_0_2_WHITE_UP*0.43070170707783612 + jac_affine_inv_1_2_WHITE_UP*0.43107722210656541 + jac_affine_inv_2_2_WHITE_UP*0.43070170707783612)), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.21645194421357716 + jac_affine_inv_1_0_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_0_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_0_WHITE_UP*0.35284634870858678 + jac_affine_inv_1_0_WHITE_UP*0.35284634870858678 + jac_affine_inv_2_0_WHITE_UP*0.35322186373731607) + (jac_affine_inv_0_1_WHITE_UP*0.21645194421357716 + jac_affine_inv_1_1_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_1_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_1_WHITE_UP*0.35284634870858678 + jac_affine_inv_1_1_WHITE_UP*0.35284634870858678 + jac_affine_inv_2_1_WHITE_UP*0.35322186373731607) + (jac_affine_inv_0_2_WHITE_UP*0.21645194421357716 + jac_affine_inv_1_2_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_2_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_2_WHITE_UP*0.35284634870858678 + jac_affine_inv_1_2_WHITE_UP*0.35284634870858678 + jac_affine_inv_2_2_WHITE_UP*0.35322186373731607)), abs_det_jac_affine_WHITE_UP*(((jac_affine_inv_0_0_WHITE_UP*0.99912889150836071 + jac_affine_inv_1_0_WHITE_UP + jac_affine_inv_2_0_WHITE_UP*0.99912889150836071)*(jac_affine_inv_0_0_WHITE_UP*0.99912889150836071 + jac_affine_inv_1_0_WHITE_UP + jac_affine_inv_2_0_WHITE_UP*0.99912889150836071))*0.18582757141911313 + ((jac_affine_inv_0_1_WHITE_UP*0.99912889150836071 + jac_affine_inv_1_1_WHITE_UP + jac_affine_inv_2_1_WHITE_UP*0.99912889150836071)*(jac_affine_inv_0_1_WHITE_UP*0.99912889150836071 + jac_affine_inv_1_1_WHITE_UP + jac_affine_inv_2_1_WHITE_UP*0.99912889150836071))*0.18582757141911313 + ((jac_affine_inv_0_2_WHITE_UP*0.99912889150836071 + jac_affine_inv_1_2_WHITE_UP + jac_affine_inv_2_2_WHITE_UP*0.99912889150836071)*(jac_affine_inv_0_2_WHITE_UP*0.99912889150836071 + jac_affine_inv_1_2_WHITE_UP + jac_affine_inv_2_2_WHITE_UP*0.99912889150836071))*0.18582757141911313), abs_det_jac_affine_WHITE_UP*((jac_affine_inv_0_0_WHITE_UP*0.21645194421357716 + jac_affine_inv_1_0_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_0_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_0_WHITE_UP*0.43070170707783612 + jac_affine_inv_1_0_WHITE_UP*0.43107722210656541 + jac_affine_inv_2_0_WHITE_UP*0.43070170707783612) + (jac_affine_inv_0_1_WHITE_UP*0.21645194421357716 + jac_affine_inv_1_1_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_1_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_1_WHITE_UP*0.43070170707783612 + jac_affine_inv_1_1_WHITE_UP*0.43107722210656541 + jac_affine_inv_2_1_WHITE_UP*0.43070170707783612) + (jac_affine_inv_0_2_WHITE_UP*0.21645194421357716 + jac_affine_inv_1_2_WHITE_UP*0.21607642918484779 + jac_affine_inv_2_2_WHITE_UP*0.21607642918484779)*(jac_affine_inv_0_2_WHITE_UP*0.43070170707783612 + jac_affine_inv_1_2_WHITE_UP*0.43107722210656541 + jac_affine_inv_2_2_WHITE_UP*0.43070170707783612)), abs_det_jac_affine_WHITE_UP*(((jac_affine_inv_0_0_WHITE_UP + jac_affine_inv_1_0_WHITE_UP*0.99826513441543008 + jac_affine_inv_2_0_WHITE_UP*0.99826513441543008)*(jac_affine_inv_0_0_WHITE_UP + jac_affine_inv_1_0_WHITE_UP*0.99826513441543008 + jac_affine_inv_2_0_WHITE_UP*0.99826513441543008))*0.046851444153837518 + ((jac_affine_inv_0_1_WHITE_UP + jac_affine_inv_1_1_WHITE_UP*0.99826513441543008 + jac_affine_inv_2_1_WHITE_UP*0.99826513441543008)*(jac_affine_inv_0_1_WHITE_UP + jac_affine_inv_1_1_WHITE_UP*0.99826513441543008 + jac_affine_inv_2_1_WHITE_UP*0.99826513441543008))*0.046851444153837518 + ((jac_affine_inv_0_2_WHITE_UP + jac_affine_inv_1_2_WHITE_UP*0.99826513441543008 + jac_affine_inv_2_2_WHITE_UP*0.99826513441543008)*(jac_affine_inv_0_2_WHITE_UP + jac_affine_inv_1_2_WHITE_UP*0.99826513441543008 + jac_affine_inv_2_2_WHITE_UP*0.99826513441543008))*0.046851444153837518)};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
             const walberla::float64 alpha_dof_0 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 alpha_dof_1 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 alpha_dof_2 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 alpha_dof_3 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 beta_dof_0 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 beta_dof_1 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 beta_dof_2 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 beta_dof_3 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             walberla::float64 q_acc_0_0 = 0.0;
             walberla::float64 q_acc_0_1 = 0.0;
             walberla::float64 q_acc_0_2 = 0.0;
             walberla::float64 q_acc_0_3 = 0.0;
             walberla::float64 q_acc_0_4 = 0.0;
             walberla::float64 q_acc_0_5 = 0.0;
             walberla::float64 q_acc_1_1 = 0.0;
             walberla::float64 q_acc_1_2 = 0.0;
             walberla::float64 q_acc_1_3 = 0.0;
             walberla::float64 q_acc_1_4 = 0.0;
             walberla::float64 q_acc_1_5 = 0.0;
             walberla::float64 q_acc_2_2 = 0.0;
             walberla::float64 q_acc_2_3 = 0.0;
             walberla::float64 q_acc_2_4 = 0.0;
             walberla::float64 q_acc_2_5 = 0.0;
             walberla::float64 q_acc_3_3 = 0.0;
             walberla::float64 q_acc_3_4 = 0.0;
             walberla::float64 q_acc_3_5 = 0.0;
             walberla::float64 q_acc_4_4 = 0.0;
             walberla::float64 q_acc_4_5 = 0.0;
             walberla::float64 q_acc_5_5 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const walberla::float64 tmp_qloop_0 = alpha_dof_0*_data_phi_0_0_WHITE_UP[4*q] + alpha_dof_1*_data_phi_0_0_WHITE_UP[4*q + 1] + alpha_dof_2*_data_phi_0_0_WHITE_UP[4*q + 2] + alpha_dof_3*_data_phi_0_0_WHITE_UP[4*q + 3];
                const walberla::float64 tmp_qloop_1 = beta_dof_0*_data_phi_0_0_WHITE_UP[4*q] + beta_dof_1*_data_phi_0_0_WHITE_UP[4*q + 1] + beta_dof_2*_data_phi_0_0_WHITE_UP[4*q + 2] + beta_dof_3*_data_phi_0_0_WHITE_UP[4*q + 3];
                const walberla::float64 q_tmp_0_0 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_UP[21*q] + tmp_qloop_1*_data_mass_det_0_0_WHITE_UP[21*q])*_data_q_w[q];
                const walberla::float64 q_tmp_0_1 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_UP[21*q + 1] + tmp_qloop_1*_data_mass_det_0_0_WHITE_UP[21*q + 1])*_data_q_w[q];
                const walberla::float64 q_tmp_0_2 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_UP[21*q + 2] + tmp_qloop_1*_data_mass_det_0_0_WHITE_UP[21*q + 2])*_data_q_w[q];
                const walberla::float64 q_tmp_0_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_UP[21*q + 3] + tmp_qloop_1*_data_mass_det_0_0_WHITE_UP[21*q + 3])*_data_q_w[q];
                const walberla::float64 q_tmp_0_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_UP[21*q + 4] + tmp_qloop_1*_data_mass_det_0_0_WHITE_UP[21*q + 4])*_data_q_w[q];
                const walberla::float64 q_tmp_0_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_UP[21*q + 5] + tmp_qloop_1*_data_mass_det_0_0_WHITE_UP[21*q + 5])*_data_q_w[q];
                const walberla::float64 q_tmp_1_1 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_UP[21*q + 6] + tmp_qloop_1*_data_mass_det_0_0_WHITE_UP[21*q + 6])*_data_q_w[q];
                const walberla::float64 q_tmp_1_2 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_UP[21*q + 7] + tmp_qloop_1*_data_mass_det_0_0_WHITE_UP[21*q + 7])*_data_q_w[q];
                const walberla::float64 q_tmp_1_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_UP[21*q + 8] + tmp_qloop_1*_data_mass_det_0_0_WHITE_UP[21*q + 8])*_data_q_w[q];
                const walberla::float64 q_tmp_1_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_UP[21*q + 9] + tmp_qloop_1*_data_mass_det_0_0_WHITE_UP[21*q + 9])*_data_q_w[q];
                const walberla::float64 q_tmp_1_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_UP[21*q + 10] + tmp_qloop_1*_data_mass_det_0_0_WHITE_UP[21*q + 10])*_data_q_w[q];
                const walberla::float64 q_tmp_2_2 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_UP[21*q + 11] + tmp_qloop_1*_data_mass_det_0_0_WHITE_UP[21*q + 11])*_data_q_w[q];
                const walberla::float64 q_tmp_2_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_UP[21*q + 12] + tmp_qloop_1*_data_mass_det_0_0_WHITE_UP[21*q + 12])*_data_q_w[q];
                const walberla::float64 q_tmp_2_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_UP[21*q + 13] + tmp_qloop_1*_data_mass_det_0_0_WHITE_UP[21*q + 13])*_data_q_w[q];
                const walberla::float64 q_tmp_2_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_UP[21*q + 14] + tmp_qloop_1*_data_mass_det_0_0_WHITE_UP[21*q + 14])*_data_q_w[q];
                const walberla::float64 q_tmp_3_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_UP[21*q + 15] + tmp_qloop_1*_data_mass_det_0_0_WHITE_UP[21*q + 15])*_data_q_w[q];
                const walberla::float64 q_tmp_3_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_UP[21*q + 16] + tmp_qloop_1*_data_mass_det_0_0_WHITE_UP[21*q + 16])*_data_q_w[q];
                const walberla::float64 q_tmp_3_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_UP[21*q + 17] + tmp_qloop_1*_data_mass_det_0_0_WHITE_UP[21*q + 17])*_data_q_w[q];
                const walberla::float64 q_tmp_4_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_UP[21*q + 18] + tmp_qloop_1*_data_mass_det_0_0_WHITE_UP[21*q + 18])*_data_q_w[q];
                const walberla::float64 q_tmp_4_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_UP[21*q + 19] + tmp_qloop_1*_data_mass_det_0_0_WHITE_UP[21*q + 19])*_data_q_w[q];
                const walberla::float64 q_tmp_5_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_UP[21*q + 20] + tmp_qloop_1*_data_mass_det_0_0_WHITE_UP[21*q + 20])*_data_q_w[q];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
             }
             const walberla::float64 elMat_0_0 = q_acc_0_0;
             const walberla::float64 elMat_0_1 = q_acc_0_1;
             const walberla::float64 elMat_0_2 = q_acc_0_2;
             const walberla::float64 elMat_0_3 = q_acc_0_3;
             const walberla::float64 elMat_0_4 = q_acc_0_4;
             const walberla::float64 elMat_0_5 = q_acc_0_5;
             const walberla::float64 elMat_1_0 = q_acc_0_1;
             const walberla::float64 elMat_1_1 = q_acc_1_1;
             const walberla::float64 elMat_1_2 = q_acc_1_2;
             const walberla::float64 elMat_1_3 = q_acc_1_3;
             const walberla::float64 elMat_1_4 = q_acc_1_4;
             const walberla::float64 elMat_1_5 = q_acc_1_5;
             const walberla::float64 elMat_2_0 = q_acc_0_2;
             const walberla::float64 elMat_2_1 = q_acc_1_2;
             const walberla::float64 elMat_2_2 = q_acc_2_2;
             const walberla::float64 elMat_2_3 = q_acc_2_3;
             const walberla::float64 elMat_2_4 = q_acc_2_4;
             const walberla::float64 elMat_2_5 = q_acc_2_5;
             const walberla::float64 elMat_3_0 = q_acc_0_3;
             const walberla::float64 elMat_3_1 = q_acc_1_3;
             const walberla::float64 elMat_3_2 = q_acc_2_3;
             const walberla::float64 elMat_3_3 = q_acc_3_3;
             const walberla::float64 elMat_3_4 = q_acc_3_4;
             const walberla::float64 elMat_3_5 = q_acc_3_5;
             const walberla::float64 elMat_4_0 = q_acc_0_4;
             const walberla::float64 elMat_4_1 = q_acc_1_4;
             const walberla::float64 elMat_4_2 = q_acc_2_4;
             const walberla::float64 elMat_4_3 = q_acc_3_4;
             const walberla::float64 elMat_4_4 = q_acc_4_4;
             const walberla::float64 elMat_4_5 = q_acc_4_5;
             const walberla::float64 elMat_5_0 = q_acc_0_5;
             const walberla::float64 elMat_5_1 = q_acc_1_5;
             const walberla::float64 elMat_5_2 = q_acc_2_5;
             const walberla::float64 elMat_5_3 = q_acc_3_5;
             const walberla::float64 elMat_5_4 = q_acc_4_5;
             const walberla::float64 elMat_5_5 = q_acc_5_5;
         
             std::vector< uint_t > _data_rowIdx( 6 );
             std::vector< uint_t > _data_colIdx( 6 );
             std::vector< walberla::float64 > _data_mat( 36 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[1] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[2] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[3] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[1] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[2] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[3] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[4] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[5] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
         
             /* Apply basis transformation */
         
             const Eigen::DiagonalMatrix< real_t, 6 > basisTransformation = n1e1::macrocell::basisTransformation( level, cell, {ctr_0, ctr_1, ctr_2}, celldof::CellType::WHITE_UP );
         
             _data_mat[0] = ((walberla::float64)((basisTransformation.diagonal()(0)*basisTransformation.diagonal()(0))*elMat_0_0));
             _data_mat[1] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(1)*elMat_0_1));
             _data_mat[2] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(2)*elMat_0_2));
             _data_mat[3] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(3)*elMat_0_3));
             _data_mat[4] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(4)*elMat_0_4));
             _data_mat[5] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(5)*elMat_0_5));
             _data_mat[6] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(1)*elMat_1_0));
             _data_mat[7] = ((walberla::float64)((basisTransformation.diagonal()(1)*basisTransformation.diagonal()(1))*elMat_1_1));
             _data_mat[8] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(2)*elMat_1_2));
             _data_mat[9] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(3)*elMat_1_3));
             _data_mat[10] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(4)*elMat_1_4));
             _data_mat[11] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(5)*elMat_1_5));
             _data_mat[12] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(2)*elMat_2_0));
             _data_mat[13] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(2)*elMat_2_1));
             _data_mat[14] = ((walberla::float64)((basisTransformation.diagonal()(2)*basisTransformation.diagonal()(2))*elMat_2_2));
             _data_mat[15] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(3)*elMat_2_3));
             _data_mat[16] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(4)*elMat_2_4));
             _data_mat[17] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(5)*elMat_2_5));
             _data_mat[18] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(3)*elMat_3_0));
             _data_mat[19] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(3)*elMat_3_1));
             _data_mat[20] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(3)*elMat_3_2));
             _data_mat[21] = ((walberla::float64)((basisTransformation.diagonal()(3)*basisTransformation.diagonal()(3))*elMat_3_3));
             _data_mat[22] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(4)*elMat_3_4));
             _data_mat[23] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(5)*elMat_3_5));
             _data_mat[24] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(4)*elMat_4_0));
             _data_mat[25] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(4)*elMat_4_1));
             _data_mat[26] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(4)*elMat_4_2));
             _data_mat[27] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(4)*elMat_4_3));
             _data_mat[28] = ((walberla::float64)((basisTransformation.diagonal()(4)*basisTransformation.diagonal()(4))*elMat_4_4));
             _data_mat[29] = ((walberla::float64)(basisTransformation.diagonal()(4)*basisTransformation.diagonal()(5)*elMat_4_5));
             _data_mat[30] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(5)*elMat_5_0));
             _data_mat[31] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(5)*elMat_5_1));
             _data_mat[32] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(5)*elMat_5_2));
             _data_mat[33] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(5)*elMat_5_3));
             _data_mat[34] = ((walberla::float64)(basisTransformation.diagonal()(4)*basisTransformation.diagonal()(5)*elMat_5_4));
             _data_mat[35] = ((walberla::float64)((basisTransformation.diagonal()(5)*basisTransformation.diagonal()(5))*elMat_5_5));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const walberla::float64 tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const walberla::float64 tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const walberla::float64 tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const walberla::float64 tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const walberla::float64 tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const walberla::float64 tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const walberla::float64 tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const walberla::float64 tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const walberla::float64 tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const walberla::float64 tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const walberla::float64 p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const walberla::float64 p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const walberla::float64 p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const walberla::float64 p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const walberla::float64 p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const walberla::float64 p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const walberla::float64 p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const walberla::float64 p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const walberla::float64 p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const walberla::float64 p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const walberla::float64 p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const walberla::float64 p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const walberla::float64 jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const walberla::float64 jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const walberla::float64 jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const walberla::float64 jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const walberla::float64 jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const walberla::float64 jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const walberla::float64 jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const walberla::float64 jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_14_WHITE_DOWN = jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
       const walberla::float64 jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_13_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_0_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_0_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_0_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_1_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_1_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_2_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_2_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const walberla::float64 abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       {
          /* CellType.WHITE_DOWN */
          const walberla::float64 _data_phi_0_0_WHITE_DOWN [] = {0.12366680032845842, 0.82157254096761978, 0.039933048641498423, 0.01482761006242336, 0.45746158708559548, 0.15593312049918601, 0.3817653560693467, 0.0048399363458717648, 0.36531451881463445, 0.18002969351036541, 0.0069232355736274674, 0.44773255210137269, 0.00037551502872928966, 0.21607642918484779, 0.43070170707783612, 0.35284634870858678};
      
          const walberla::float64 _data_curl_curl_det_0_0_WHITE_DOWN [] = {1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_0_WHITE_DOWN*jac_affine_0_0_WHITE_DOWN)*4.0 + (jac_affine_1_0_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN)*4.0 + (jac_affine_2_0_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_0_WHITE_DOWN*jac_affine_0_1_WHITE_DOWN*-4.0 + jac_affine_1_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN*-4.0 + jac_affine_2_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN*-4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_0_WHITE_DOWN*jac_affine_0_2_WHITE_DOWN*4.0 + jac_affine_1_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN*4.0 + jac_affine_2_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN*4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_0_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*2.0 + jac_affine_1_0_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*2.0 + jac_affine_2_0_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_0_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)*2.0 + jac_affine_1_0_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)*2.0 + jac_affine_2_0_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_0_WHITE_DOWN*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0)*2.0 + jac_affine_1_0_WHITE_DOWN*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0)*2.0 + jac_affine_2_0_WHITE_DOWN*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_1_WHITE_DOWN*jac_affine_0_1_WHITE_DOWN)*4.0 + (jac_affine_1_1_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN)*4.0 + (jac_affine_2_1_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_1_WHITE_DOWN*jac_affine_0_2_WHITE_DOWN*-4.0 + jac_affine_1_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN*-4.0 + jac_affine_2_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN*-4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_1_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*-2.0 + jac_affine_1_1_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*-2.0 + jac_affine_2_1_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_1_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)*-2.0 + jac_affine_1_1_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)*-2.0 + jac_affine_2_1_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_1_WHITE_DOWN*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0)*-2.0 + jac_affine_1_1_WHITE_DOWN*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0)*-2.0 + jac_affine_2_1_WHITE_DOWN*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_2_WHITE_DOWN*jac_affine_0_2_WHITE_DOWN)*4.0 + (jac_affine_1_2_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN)*4.0 + (jac_affine_2_2_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_2_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*2.0 + jac_affine_1_2_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*2.0 + jac_affine_2_2_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_2_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)*2.0 + jac_affine_1_2_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)*2.0 + jac_affine_2_2_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_2_WHITE_DOWN*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0)*2.0 + jac_affine_1_2_WHITE_DOWN*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0)*2.0 + jac_affine_2_2_WHITE_DOWN*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(((jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*(jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)) + ((jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*(jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)) + ((jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*(jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0))), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*(jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0) + (jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*(jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0) + (jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*(jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0) + (jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0) + (jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(((jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)*(jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)) + ((jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)*(jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)) + ((jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)*(jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0))), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0) + (jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0) + (jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(((jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0)*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0)) + ((jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0)*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0)) + ((jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0))), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_0_WHITE_DOWN*jac_affine_0_0_WHITE_DOWN)*4.0 + (jac_affine_1_0_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN)*4.0 + (jac_affine_2_0_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_0_WHITE_DOWN*jac_affine_0_1_WHITE_DOWN*-4.0 + jac_affine_1_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN*-4.0 + jac_affine_2_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN*-4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_0_WHITE_DOWN*jac_affine_0_2_WHITE_DOWN*4.0 + jac_affine_1_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN*4.0 + jac_affine_2_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN*4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_0_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*2.0 + jac_affine_1_0_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*2.0 + jac_affine_2_0_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_0_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)*2.0 + jac_affine_1_0_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)*2.0 + jac_affine_2_0_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_0_WHITE_DOWN*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0)*2.0 + jac_affine_1_0_WHITE_DOWN*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0)*2.0 + jac_affine_2_0_WHITE_DOWN*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_1_WHITE_DOWN*jac_affine_0_1_WHITE_DOWN)*4.0 + (jac_affine_1_1_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN)*4.0 + (jac_affine_2_1_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_1_WHITE_DOWN*jac_affine_0_2_WHITE_DOWN*-4.0 + jac_affine_1_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN*-4.0 + jac_affine_2_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN*-4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_1_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*-2.0 + jac_affine_1_1_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*-2.0 + jac_affine_2_1_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_1_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)*-2.0 + jac_affine_1_1_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)*-2.0 + jac_affine_2_1_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_1_WHITE_DOWN*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0)*-2.0 + jac_affine_1_1_WHITE_DOWN*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0)*-2.0 + jac_affine_2_1_WHITE_DOWN*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_2_WHITE_DOWN*jac_affine_0_2_WHITE_DOWN)*4.0 + (jac_affine_1_2_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN)*4.0 + (jac_affine_2_2_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_2_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*2.0 + jac_affine_1_2_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*2.0 + jac_affine_2_2_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_2_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)*2.0 + jac_affine_1_2_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)*2.0 + jac_affine_2_2_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_2_WHITE_DOWN*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0)*2.0 + jac_affine_1_2_WHITE_DOWN*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0)*2.0 + jac_affine_2_2_WHITE_DOWN*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(((jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*(jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)) + ((jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*(jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)) + ((jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*(jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0))), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*(jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0) + (jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*(jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0) + (jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*(jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0) + (jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0) + (jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(((jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)*(jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)) + ((jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)*(jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)) + ((jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)*(jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0))), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0) + (jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0) + (jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(((jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0)*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0)) + ((jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0)*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0)) + ((jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0))), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_0_WHITE_DOWN*jac_affine_0_0_WHITE_DOWN)*4.0 + (jac_affine_1_0_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN)*4.0 + (jac_affine_2_0_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_0_WHITE_DOWN*jac_affine_0_1_WHITE_DOWN*-4.0 + jac_affine_1_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN*-4.0 + jac_affine_2_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN*-4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_0_WHITE_DOWN*jac_affine_0_2_WHITE_DOWN*4.0 + jac_affine_1_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN*4.0 + jac_affine_2_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN*4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_0_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*2.0 + jac_affine_1_0_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*2.0 + jac_affine_2_0_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_0_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)*2.0 + jac_affine_1_0_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)*2.0 + jac_affine_2_0_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_0_WHITE_DOWN*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0)*2.0 + jac_affine_1_0_WHITE_DOWN*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0)*2.0 + jac_affine_2_0_WHITE_DOWN*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_1_WHITE_DOWN*jac_affine_0_1_WHITE_DOWN)*4.0 + (jac_affine_1_1_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN)*4.0 + (jac_affine_2_1_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_1_WHITE_DOWN*jac_affine_0_2_WHITE_DOWN*-4.0 + jac_affine_1_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN*-4.0 + jac_affine_2_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN*-4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_1_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*-2.0 + jac_affine_1_1_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*-2.0 + jac_affine_2_1_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_1_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)*-2.0 + jac_affine_1_1_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)*-2.0 + jac_affine_2_1_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_1_WHITE_DOWN*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0)*-2.0 + jac_affine_1_1_WHITE_DOWN*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0)*-2.0 + jac_affine_2_1_WHITE_DOWN*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_2_WHITE_DOWN*jac_affine_0_2_WHITE_DOWN)*4.0 + (jac_affine_1_2_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN)*4.0 + (jac_affine_2_2_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_2_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*2.0 + jac_affine_1_2_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*2.0 + jac_affine_2_2_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_2_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)*2.0 + jac_affine_1_2_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)*2.0 + jac_affine_2_2_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_2_WHITE_DOWN*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0)*2.0 + jac_affine_1_2_WHITE_DOWN*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0)*2.0 + jac_affine_2_2_WHITE_DOWN*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(((jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*(jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)) + ((jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*(jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)) + ((jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*(jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0))), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*(jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0) + (jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*(jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0) + (jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*(jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0) + (jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0) + (jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(((jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)*(jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)) + ((jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)*(jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)) + ((jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)*(jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0))), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0) + (jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0) + (jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(((jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0)*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0)) + ((jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0)*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0)) + ((jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0))), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_0_WHITE_DOWN*jac_affine_0_0_WHITE_DOWN)*4.0 + (jac_affine_1_0_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN)*4.0 + (jac_affine_2_0_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_0_WHITE_DOWN*jac_affine_0_1_WHITE_DOWN*-4.0 + jac_affine_1_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN*-4.0 + jac_affine_2_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN*-4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_0_WHITE_DOWN*jac_affine_0_2_WHITE_DOWN*4.0 + jac_affine_1_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN*4.0 + jac_affine_2_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN*4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_0_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*2.0 + jac_affine_1_0_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*2.0 + jac_affine_2_0_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_0_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)*2.0 + jac_affine_1_0_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)*2.0 + jac_affine_2_0_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_0_WHITE_DOWN*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0)*2.0 + jac_affine_1_0_WHITE_DOWN*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0)*2.0 + jac_affine_2_0_WHITE_DOWN*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_1_WHITE_DOWN*jac_affine_0_1_WHITE_DOWN)*4.0 + (jac_affine_1_1_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN)*4.0 + (jac_affine_2_1_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_1_WHITE_DOWN*jac_affine_0_2_WHITE_DOWN*-4.0 + jac_affine_1_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN*-4.0 + jac_affine_2_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN*-4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_1_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*-2.0 + jac_affine_1_1_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*-2.0 + jac_affine_2_1_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_1_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)*-2.0 + jac_affine_1_1_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)*-2.0 + jac_affine_2_1_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_1_WHITE_DOWN*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0)*-2.0 + jac_affine_1_1_WHITE_DOWN*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0)*-2.0 + jac_affine_2_1_WHITE_DOWN*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_2_WHITE_DOWN*jac_affine_0_2_WHITE_DOWN)*4.0 + (jac_affine_1_2_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN)*4.0 + (jac_affine_2_2_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_2_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*2.0 + jac_affine_1_2_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*2.0 + jac_affine_2_2_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_2_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)*2.0 + jac_affine_1_2_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)*2.0 + jac_affine_2_2_WHITE_DOWN*(jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(jac_affine_0_2_WHITE_DOWN*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0)*2.0 + jac_affine_1_2_WHITE_DOWN*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0)*2.0 + jac_affine_2_2_WHITE_DOWN*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(((jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*(jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)) + ((jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*(jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)) + ((jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*(jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0))), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*(jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0) + (jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*(jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0) + (jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*(jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_0_WHITE_DOWN*-2.0 + jac_affine_0_1_WHITE_DOWN*2.0)*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0) + (jac_affine_1_0_WHITE_DOWN*-2.0 + jac_affine_1_1_WHITE_DOWN*2.0)*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0) + (jac_affine_2_0_WHITE_DOWN*-2.0 + jac_affine_2_1_WHITE_DOWN*2.0)*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(((jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)*(jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)) + ((jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)*(jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)) + ((jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)*(jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0))), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*((jac_affine_0_0_WHITE_DOWN*2.0 + jac_affine_0_2_WHITE_DOWN*-2.0)*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0) + (jac_affine_1_0_WHITE_DOWN*2.0 + jac_affine_1_2_WHITE_DOWN*-2.0)*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0) + (jac_affine_2_0_WHITE_DOWN*2.0 + jac_affine_2_2_WHITE_DOWN*-2.0)*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)), 1.0 / (abs_det_jac_affine_WHITE_DOWN)*(((jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0)*(jac_affine_0_1_WHITE_DOWN*-2.0 + jac_affine_0_2_WHITE_DOWN*2.0)) + ((jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0)*(jac_affine_1_1_WHITE_DOWN*-2.0 + jac_affine_1_2_WHITE_DOWN*2.0)) + ((jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)*(jac_affine_2_1_WHITE_DOWN*-2.0 + jac_affine_2_2_WHITE_DOWN*2.0)))};
      
          const walberla::float64 _data_mass_det_0_0_WHITE_DOWN [] = {abs_det_jac_affine_WHITE_DOWN*(((jac_affine_inv_1_0_WHITE_DOWN*-0.37131174720816351 + jac_affine_inv_2_0_WHITE_DOWN)*(jac_affine_inv_1_0_WHITE_DOWN*-0.37131174720816351 + jac_affine_inv_2_0_WHITE_DOWN))*0.0015946483738042789 + ((jac_affine_inv_1_1_WHITE_DOWN*-0.37131174720816351 + jac_affine_inv_2_1_WHITE_DOWN)*(jac_affine_inv_1_1_WHITE_DOWN*-0.37131174720816351 + jac_affine_inv_2_1_WHITE_DOWN))*0.0015946483738042789 + ((jac_affine_inv_1_2_WHITE_DOWN*-0.37131174720816351 + jac_affine_inv_2_2_WHITE_DOWN)*(jac_affine_inv_1_2_WHITE_DOWN*-0.37131174720816351 + jac_affine_inv_2_2_WHITE_DOWN))*0.0015946483738042789), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_1_0_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_WHITE_DOWN*0.039933048641498423) + (jac_affine_inv_0_1_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_1_1_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_WHITE_DOWN*0.039933048641498423) + (jac_affine_inv_0_2_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_1_2_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_WHITE_DOWN*0.039933048641498423)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.039933048641498423 + jac_affine_inv_1_0_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_1_0_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_WHITE_DOWN*0.039933048641498423) + (jac_affine_inv_0_1_WHITE_DOWN*-0.039933048641498423 + jac_affine_inv_1_1_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_1_1_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_WHITE_DOWN*0.039933048641498423) + (jac_affine_inv_0_2_WHITE_DOWN*-0.039933048641498423 + jac_affine_inv_1_2_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_1_2_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_WHITE_DOWN*0.039933048641498423)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_WHITE_DOWN*0.039933048641498423)*(jac_affine_inv_0_0_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_1_0_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_2_0_WHITE_DOWN*0.13849441039088178) + (jac_affine_inv_1_1_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_WHITE_DOWN*0.039933048641498423)*(jac_affine_inv_0_1_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_1_1_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_2_1_WHITE_DOWN*0.13849441039088178) + (jac_affine_inv_1_2_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_WHITE_DOWN*0.039933048641498423)*(jac_affine_inv_0_2_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_1_2_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_2_2_WHITE_DOWN*0.13849441039088178)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_WHITE_DOWN*0.039933048641498423)*(jac_affine_inv_0_0_WHITE_DOWN*0.039933048641498423 + jac_affine_inv_1_0_WHITE_DOWN*0.16359984896995686 + jac_affine_inv_2_0_WHITE_DOWN*0.039933048641498423) + (jac_affine_inv_1_1_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_WHITE_DOWN*0.039933048641498423)*(jac_affine_inv_0_1_WHITE_DOWN*0.039933048641498423 + jac_affine_inv_1_1_WHITE_DOWN*0.16359984896995686 + jac_affine_inv_2_1_WHITE_DOWN*0.039933048641498423) + (jac_affine_inv_1_2_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_WHITE_DOWN*0.039933048641498423)*(jac_affine_inv_0_2_WHITE_DOWN*0.039933048641498423 + jac_affine_inv_1_2_WHITE_DOWN*0.16359984896995686 + jac_affine_inv_2_2_WHITE_DOWN*0.039933048641498423)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_WHITE_DOWN*0.039933048641498423)*(jac_affine_inv_0_0_WHITE_DOWN*0.94523934129607823 + jac_affine_inv_1_0_WHITE_DOWN*0.82157254096761978 + jac_affine_inv_2_0_WHITE_DOWN*0.82157254096761978) + (jac_affine_inv_1_1_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_WHITE_DOWN*0.039933048641498423)*(jac_affine_inv_0_1_WHITE_DOWN*0.94523934129607823 + jac_affine_inv_1_1_WHITE_DOWN*0.82157254096761978 + jac_affine_inv_2_1_WHITE_DOWN*0.82157254096761978) + (jac_affine_inv_1_2_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_WHITE_DOWN*0.039933048641498423)*(jac_affine_inv_0_2_WHITE_DOWN*0.94523934129607823 + jac_affine_inv_1_2_WHITE_DOWN*0.82157254096761978 + jac_affine_inv_2_2_WHITE_DOWN*0.82157254096761978)), abs_det_jac_affine_WHITE_DOWN*(((jac_affine_inv_0_0_WHITE_DOWN*-0.018047840358637001 + jac_affine_inv_2_0_WHITE_DOWN)*(jac_affine_inv_0_0_WHITE_DOWN*-0.018047840358637001 + jac_affine_inv_2_0_WHITE_DOWN))*0.67498144007199123 + ((jac_affine_inv_0_1_WHITE_DOWN*-0.018047840358637001 + jac_affine_inv_2_1_WHITE_DOWN)*(jac_affine_inv_0_1_WHITE_DOWN*-0.018047840358637001 + jac_affine_inv_2_1_WHITE_DOWN))*0.67498144007199123 + ((jac_affine_inv_0_2_WHITE_DOWN*-0.018047840358637001 + jac_affine_inv_2_2_WHITE_DOWN)*(jac_affine_inv_0_2_WHITE_DOWN*-0.018047840358637001 + jac_affine_inv_2_2_WHITE_DOWN))*0.67498144007199123), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_WHITE_DOWN*-0.039933048641498423 + jac_affine_inv_1_0_WHITE_DOWN*0.82157254096761978) + (jac_affine_inv_0_1_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_WHITE_DOWN*-0.039933048641498423 + jac_affine_inv_1_1_WHITE_DOWN*0.82157254096761978) + (jac_affine_inv_0_2_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_WHITE_DOWN*-0.039933048641498423 + jac_affine_inv_1_2_WHITE_DOWN*0.82157254096761978)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_1_0_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_2_0_WHITE_DOWN*0.13849441039088178) + (jac_affine_inv_0_1_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_1_1_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_2_1_WHITE_DOWN*0.13849441039088178) + (jac_affine_inv_0_2_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_1_2_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_2_2_WHITE_DOWN*0.13849441039088178)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_WHITE_DOWN*0.039933048641498423 + jac_affine_inv_1_0_WHITE_DOWN*0.16359984896995686 + jac_affine_inv_2_0_WHITE_DOWN*0.039933048641498423) + (jac_affine_inv_0_1_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_WHITE_DOWN*0.039933048641498423 + jac_affine_inv_1_1_WHITE_DOWN*0.16359984896995686 + jac_affine_inv_2_1_WHITE_DOWN*0.039933048641498423) + (jac_affine_inv_0_2_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_WHITE_DOWN*0.039933048641498423 + jac_affine_inv_1_2_WHITE_DOWN*0.16359984896995686 + jac_affine_inv_2_2_WHITE_DOWN*0.039933048641498423)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_WHITE_DOWN*0.94523934129607823 + jac_affine_inv_1_0_WHITE_DOWN*0.82157254096761978 + jac_affine_inv_2_0_WHITE_DOWN*0.82157254096761978) + (jac_affine_inv_0_1_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_WHITE_DOWN*0.94523934129607823 + jac_affine_inv_1_1_WHITE_DOWN*0.82157254096761978 + jac_affine_inv_2_1_WHITE_DOWN*0.82157254096761978) + (jac_affine_inv_0_2_WHITE_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_WHITE_DOWN*0.94523934129607823 + jac_affine_inv_1_2_WHITE_DOWN*0.82157254096761978 + jac_affine_inv_2_2_WHITE_DOWN*0.82157254096761978)), abs_det_jac_affine_WHITE_DOWN*(((jac_affine_inv_0_0_WHITE_DOWN*-0.048605627196920013 + jac_affine_inv_1_0_WHITE_DOWN)*(jac_affine_inv_0_0_WHITE_DOWN*-0.048605627196920013 + jac_affine_inv_1_0_WHITE_DOWN))*0.67498144007199123 + ((jac_affine_inv_0_1_WHITE_DOWN*-0.048605627196920013 + jac_affine_inv_1_1_WHITE_DOWN)*(jac_affine_inv_0_1_WHITE_DOWN*-0.048605627196920013 + jac_affine_inv_1_1_WHITE_DOWN))*0.67498144007199123 + ((jac_affine_inv_0_2_WHITE_DOWN*-0.048605627196920013 + jac_affine_inv_1_2_WHITE_DOWN)*(jac_affine_inv_0_2_WHITE_DOWN*-0.048605627196920013 + jac_affine_inv_1_2_WHITE_DOWN))*0.67498144007199123), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.039933048641498423 + jac_affine_inv_1_0_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_1_0_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_2_0_WHITE_DOWN*0.13849441039088178) + (jac_affine_inv_0_1_WHITE_DOWN*-0.039933048641498423 + jac_affine_inv_1_1_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_1_1_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_2_1_WHITE_DOWN*0.13849441039088178) + (jac_affine_inv_0_2_WHITE_DOWN*-0.039933048641498423 + jac_affine_inv_1_2_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_1_2_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_2_2_WHITE_DOWN*0.13849441039088178)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.039933048641498423 + jac_affine_inv_1_0_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_WHITE_DOWN*0.039933048641498423 + jac_affine_inv_1_0_WHITE_DOWN*0.16359984896995686 + jac_affine_inv_2_0_WHITE_DOWN*0.039933048641498423) + (jac_affine_inv_0_1_WHITE_DOWN*-0.039933048641498423 + jac_affine_inv_1_1_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_WHITE_DOWN*0.039933048641498423 + jac_affine_inv_1_1_WHITE_DOWN*0.16359984896995686 + jac_affine_inv_2_1_WHITE_DOWN*0.039933048641498423) + (jac_affine_inv_0_2_WHITE_DOWN*-0.039933048641498423 + jac_affine_inv_1_2_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_WHITE_DOWN*0.039933048641498423 + jac_affine_inv_1_2_WHITE_DOWN*0.16359984896995686 + jac_affine_inv_2_2_WHITE_DOWN*0.039933048641498423)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.039933048641498423 + jac_affine_inv_1_0_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_WHITE_DOWN*0.94523934129607823 + jac_affine_inv_1_0_WHITE_DOWN*0.82157254096761978 + jac_affine_inv_2_0_WHITE_DOWN*0.82157254096761978) + (jac_affine_inv_0_1_WHITE_DOWN*-0.039933048641498423 + jac_affine_inv_1_1_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_WHITE_DOWN*0.94523934129607823 + jac_affine_inv_1_1_WHITE_DOWN*0.82157254096761978 + jac_affine_inv_2_1_WHITE_DOWN*0.82157254096761978) + (jac_affine_inv_0_2_WHITE_DOWN*-0.039933048641498423 + jac_affine_inv_1_2_WHITE_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_WHITE_DOWN*0.94523934129607823 + jac_affine_inv_1_2_WHITE_DOWN*0.82157254096761978 + jac_affine_inv_2_2_WHITE_DOWN*0.82157254096761978)), abs_det_jac_affine_WHITE_DOWN*(((jac_affine_inv_0_0_WHITE_DOWN*0.10706287727117962 + jac_affine_inv_1_0_WHITE_DOWN*0.10706287727117962 + jac_affine_inv_2_0_WHITE_DOWN)*(jac_affine_inv_0_0_WHITE_DOWN*0.10706287727117962 + jac_affine_inv_1_0_WHITE_DOWN*0.10706287727117962 + jac_affine_inv_2_0_WHITE_DOWN))*0.019180701709517984 + ((jac_affine_inv_0_1_WHITE_DOWN*0.10706287727117962 + jac_affine_inv_1_1_WHITE_DOWN*0.10706287727117962 + jac_affine_inv_2_1_WHITE_DOWN)*(jac_affine_inv_0_1_WHITE_DOWN*0.10706287727117962 + jac_affine_inv_1_1_WHITE_DOWN*0.10706287727117962 + jac_affine_inv_2_1_WHITE_DOWN))*0.019180701709517984 + ((jac_affine_inv_0_2_WHITE_DOWN*0.10706287727117962 + jac_affine_inv_1_2_WHITE_DOWN*0.10706287727117962 + jac_affine_inv_2_2_WHITE_DOWN)*(jac_affine_inv_0_2_WHITE_DOWN*0.10706287727117962 + jac_affine_inv_1_2_WHITE_DOWN*0.10706287727117962 + jac_affine_inv_2_2_WHITE_DOWN))*0.019180701709517984), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_1_0_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_2_0_WHITE_DOWN*0.13849441039088178)*(jac_affine_inv_0_0_WHITE_DOWN*0.039933048641498423 + jac_affine_inv_1_0_WHITE_DOWN*0.16359984896995686 + jac_affine_inv_2_0_WHITE_DOWN*0.039933048641498423) + (jac_affine_inv_0_1_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_1_1_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_2_1_WHITE_DOWN*0.13849441039088178)*(jac_affine_inv_0_1_WHITE_DOWN*0.039933048641498423 + jac_affine_inv_1_1_WHITE_DOWN*0.16359984896995686 + jac_affine_inv_2_1_WHITE_DOWN*0.039933048641498423) + (jac_affine_inv_0_2_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_1_2_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_2_2_WHITE_DOWN*0.13849441039088178)*(jac_affine_inv_0_2_WHITE_DOWN*0.039933048641498423 + jac_affine_inv_1_2_WHITE_DOWN*0.16359984896995686 + jac_affine_inv_2_2_WHITE_DOWN*0.039933048641498423)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_1_0_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_2_0_WHITE_DOWN*0.13849441039088178)*(jac_affine_inv_0_0_WHITE_DOWN*0.94523934129607823 + jac_affine_inv_1_0_WHITE_DOWN*0.82157254096761978 + jac_affine_inv_2_0_WHITE_DOWN*0.82157254096761978) + (jac_affine_inv_0_1_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_1_1_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_2_1_WHITE_DOWN*0.13849441039088178)*(jac_affine_inv_0_1_WHITE_DOWN*0.94523934129607823 + jac_affine_inv_1_1_WHITE_DOWN*0.82157254096761978 + jac_affine_inv_2_1_WHITE_DOWN*0.82157254096761978) + (jac_affine_inv_0_2_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_1_2_WHITE_DOWN*0.01482761006242336 + jac_affine_inv_2_2_WHITE_DOWN*0.13849441039088178)*(jac_affine_inv_0_2_WHITE_DOWN*0.94523934129607823 + jac_affine_inv_1_2_WHITE_DOWN*0.82157254096761978 + jac_affine_inv_2_2_WHITE_DOWN*0.82157254096761978)), abs_det_jac_affine_WHITE_DOWN*(((jac_affine_inv_0_0_WHITE_DOWN*0.2440897647089616 + jac_affine_inv_1_0_WHITE_DOWN + jac_affine_inv_2_0_WHITE_DOWN*0.2440897647089616)*(jac_affine_inv_0_0_WHITE_DOWN*0.2440897647089616 + jac_affine_inv_1_0_WHITE_DOWN + jac_affine_inv_2_0_WHITE_DOWN*0.2440897647089616))*0.026764910582992695 + ((jac_affine_inv_0_1_WHITE_DOWN*0.2440897647089616 + jac_affine_inv_1_1_WHITE_DOWN + jac_affine_inv_2_1_WHITE_DOWN*0.2440897647089616)*(jac_affine_inv_0_1_WHITE_DOWN*0.2440897647089616 + jac_affine_inv_1_1_WHITE_DOWN + jac_affine_inv_2_1_WHITE_DOWN*0.2440897647089616))*0.026764910582992695 + ((jac_affine_inv_0_2_WHITE_DOWN*0.2440897647089616 + jac_affine_inv_1_2_WHITE_DOWN + jac_affine_inv_2_2_WHITE_DOWN*0.2440897647089616)*(jac_affine_inv_0_2_WHITE_DOWN*0.2440897647089616 + jac_affine_inv_1_2_WHITE_DOWN + jac_affine_inv_2_2_WHITE_DOWN*0.2440897647089616))*0.026764910582992695), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.039933048641498423 + jac_affine_inv_1_0_WHITE_DOWN*0.16359984896995686 + jac_affine_inv_2_0_WHITE_DOWN*0.039933048641498423)*(jac_affine_inv_0_0_WHITE_DOWN*0.94523934129607823 + jac_affine_inv_1_0_WHITE_DOWN*0.82157254096761978 + jac_affine_inv_2_0_WHITE_DOWN*0.82157254096761978) + (jac_affine_inv_0_1_WHITE_DOWN*0.039933048641498423 + jac_affine_inv_1_1_WHITE_DOWN*0.16359984896995686 + jac_affine_inv_2_1_WHITE_DOWN*0.039933048641498423)*(jac_affine_inv_0_1_WHITE_DOWN*0.94523934129607823 + jac_affine_inv_1_1_WHITE_DOWN*0.82157254096761978 + jac_affine_inv_2_1_WHITE_DOWN*0.82157254096761978) + (jac_affine_inv_0_2_WHITE_DOWN*0.039933048641498423 + jac_affine_inv_1_2_WHITE_DOWN*0.16359984896995686 + jac_affine_inv_2_2_WHITE_DOWN*0.039933048641498423)*(jac_affine_inv_0_2_WHITE_DOWN*0.94523934129607823 + jac_affine_inv_1_2_WHITE_DOWN*0.82157254096761978 + jac_affine_inv_2_2_WHITE_DOWN*0.82157254096761978)), abs_det_jac_affine_WHITE_DOWN*(((jac_affine_inv_0_0_WHITE_DOWN + jac_affine_inv_1_0_WHITE_DOWN*0.86916879680558901 + jac_affine_inv_2_0_WHITE_DOWN*0.86916879680558901)*(jac_affine_inv_0_0_WHITE_DOWN + jac_affine_inv_1_0_WHITE_DOWN*0.86916879680558901 + jac_affine_inv_2_0_WHITE_DOWN*0.86916879680558901))*0.89347741233384381 + ((jac_affine_inv_0_1_WHITE_DOWN + jac_affine_inv_1_1_WHITE_DOWN*0.86916879680558901 + jac_affine_inv_2_1_WHITE_DOWN*0.86916879680558901)*(jac_affine_inv_0_1_WHITE_DOWN + jac_affine_inv_1_1_WHITE_DOWN*0.86916879680558901 + jac_affine_inv_2_1_WHITE_DOWN*0.86916879680558901))*0.89347741233384381 + ((jac_affine_inv_0_2_WHITE_DOWN + jac_affine_inv_1_2_WHITE_DOWN*0.86916879680558901 + jac_affine_inv_2_2_WHITE_DOWN*0.86916879680558901)*(jac_affine_inv_0_2_WHITE_DOWN + jac_affine_inv_1_2_WHITE_DOWN*0.86916879680558901 + jac_affine_inv_2_2_WHITE_DOWN*0.86916879680558901))*0.89347741233384381), abs_det_jac_affine_WHITE_DOWN*(((jac_affine_inv_1_0_WHITE_DOWN*-0.012677777773509136 + jac_affine_inv_2_0_WHITE_DOWN)*(jac_affine_inv_1_0_WHITE_DOWN*-0.012677777773509136 + jac_affine_inv_2_0_WHITE_DOWN))*0.14574478709475508 + ((jac_affine_inv_1_1_WHITE_DOWN*-0.012677777773509136 + jac_affine_inv_2_1_WHITE_DOWN)*(jac_affine_inv_1_1_WHITE_DOWN*-0.012677777773509136 + jac_affine_inv_2_1_WHITE_DOWN))*0.14574478709475508 + ((jac_affine_inv_1_2_WHITE_DOWN*-0.012677777773509136 + jac_affine_inv_2_2_WHITE_DOWN)*(jac_affine_inv_1_2_WHITE_DOWN*-0.012677777773509136 + jac_affine_inv_2_2_WHITE_DOWN))*0.14574478709475508), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_1_0_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_WHITE_DOWN*0.3817653560693467) + (jac_affine_inv_0_1_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_1_1_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_WHITE_DOWN*0.3817653560693467) + (jac_affine_inv_0_2_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_1_2_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_WHITE_DOWN*0.3817653560693467)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.3817653560693467 + jac_affine_inv_1_0_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_1_0_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_WHITE_DOWN*0.3817653560693467) + (jac_affine_inv_0_1_WHITE_DOWN*-0.3817653560693467 + jac_affine_inv_1_1_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_1_1_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_WHITE_DOWN*0.3817653560693467) + (jac_affine_inv_0_2_WHITE_DOWN*-0.3817653560693467 + jac_affine_inv_1_2_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_1_2_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_WHITE_DOWN*0.3817653560693467)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_WHITE_DOWN*0.3817653560693467)*(jac_affine_inv_0_0_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_1_0_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_2_0_WHITE_DOWN*0.46230152343146724) + (jac_affine_inv_1_1_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_WHITE_DOWN*0.3817653560693467)*(jac_affine_inv_0_1_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_1_1_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_2_1_WHITE_DOWN*0.46230152343146724) + (jac_affine_inv_1_2_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_WHITE_DOWN*0.3817653560693467)*(jac_affine_inv_0_2_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_1_2_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_2_2_WHITE_DOWN*0.46230152343146724)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_WHITE_DOWN*0.3817653560693467)*(jac_affine_inv_0_0_WHITE_DOWN*0.3817653560693467 + jac_affine_inv_1_0_WHITE_DOWN*0.83922694315494217 + jac_affine_inv_2_0_WHITE_DOWN*0.3817653560693467) + (jac_affine_inv_1_1_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_WHITE_DOWN*0.3817653560693467)*(jac_affine_inv_0_1_WHITE_DOWN*0.3817653560693467 + jac_affine_inv_1_1_WHITE_DOWN*0.83922694315494217 + jac_affine_inv_2_1_WHITE_DOWN*0.3817653560693467) + (jac_affine_inv_1_2_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_WHITE_DOWN*0.3817653560693467)*(jac_affine_inv_0_2_WHITE_DOWN*0.3817653560693467 + jac_affine_inv_1_2_WHITE_DOWN*0.83922694315494217 + jac_affine_inv_2_2_WHITE_DOWN*0.3817653560693467)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_WHITE_DOWN*0.3817653560693467)*(jac_affine_inv_0_0_WHITE_DOWN*0.61339470758478154 + jac_affine_inv_1_0_WHITE_DOWN*0.15593312049918601 + jac_affine_inv_2_0_WHITE_DOWN*0.15593312049918601) + (jac_affine_inv_1_1_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_WHITE_DOWN*0.3817653560693467)*(jac_affine_inv_0_1_WHITE_DOWN*0.61339470758478154 + jac_affine_inv_1_1_WHITE_DOWN*0.15593312049918601 + jac_affine_inv_2_1_WHITE_DOWN*0.15593312049918601) + (jac_affine_inv_1_2_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_WHITE_DOWN*0.3817653560693467)*(jac_affine_inv_0_2_WHITE_DOWN*0.61339470758478154 + jac_affine_inv_1_2_WHITE_DOWN*0.15593312049918601 + jac_affine_inv_2_2_WHITE_DOWN*0.15593312049918601)), abs_det_jac_affine_WHITE_DOWN*(((jac_affine_inv_0_0_WHITE_DOWN*-0.031038539666093771 + jac_affine_inv_2_0_WHITE_DOWN)*(jac_affine_inv_0_0_WHITE_DOWN*-0.031038539666093771 + jac_affine_inv_2_0_WHITE_DOWN))*0.024315138068613663 + ((jac_affine_inv_0_1_WHITE_DOWN*-0.031038539666093771 + jac_affine_inv_2_1_WHITE_DOWN)*(jac_affine_inv_0_1_WHITE_DOWN*-0.031038539666093771 + jac_affine_inv_2_1_WHITE_DOWN))*0.024315138068613663 + ((jac_affine_inv_0_2_WHITE_DOWN*-0.031038539666093771 + jac_affine_inv_2_2_WHITE_DOWN)*(jac_affine_inv_0_2_WHITE_DOWN*-0.031038539666093771 + jac_affine_inv_2_2_WHITE_DOWN))*0.024315138068613663), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_WHITE_DOWN*-0.3817653560693467 + jac_affine_inv_1_0_WHITE_DOWN*0.15593312049918601) + (jac_affine_inv_0_1_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_WHITE_DOWN*-0.3817653560693467 + jac_affine_inv_1_1_WHITE_DOWN*0.15593312049918601) + (jac_affine_inv_0_2_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_WHITE_DOWN*-0.3817653560693467 + jac_affine_inv_1_2_WHITE_DOWN*0.15593312049918601)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_1_0_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_2_0_WHITE_DOWN*0.46230152343146724) + (jac_affine_inv_0_1_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_1_1_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_2_1_WHITE_DOWN*0.46230152343146724) + (jac_affine_inv_0_2_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_1_2_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_2_2_WHITE_DOWN*0.46230152343146724)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_WHITE_DOWN*0.3817653560693467 + jac_affine_inv_1_0_WHITE_DOWN*0.83922694315494217 + jac_affine_inv_2_0_WHITE_DOWN*0.3817653560693467) + (jac_affine_inv_0_1_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_WHITE_DOWN*0.3817653560693467 + jac_affine_inv_1_1_WHITE_DOWN*0.83922694315494217 + jac_affine_inv_2_1_WHITE_DOWN*0.3817653560693467) + (jac_affine_inv_0_2_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_WHITE_DOWN*0.3817653560693467 + jac_affine_inv_1_2_WHITE_DOWN*0.83922694315494217 + jac_affine_inv_2_2_WHITE_DOWN*0.3817653560693467)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_WHITE_DOWN*0.61339470758478154 + jac_affine_inv_1_0_WHITE_DOWN*0.15593312049918601 + jac_affine_inv_2_0_WHITE_DOWN*0.15593312049918601) + (jac_affine_inv_0_1_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_WHITE_DOWN*0.61339470758478154 + jac_affine_inv_1_1_WHITE_DOWN*0.15593312049918601 + jac_affine_inv_2_1_WHITE_DOWN*0.15593312049918601) + (jac_affine_inv_0_2_WHITE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_WHITE_DOWN*0.61339470758478154 + jac_affine_inv_1_2_WHITE_DOWN*0.15593312049918601 + jac_affine_inv_2_2_WHITE_DOWN*0.15593312049918601)), abs_det_jac_affine_WHITE_DOWN*(((-jac_affine_inv_0_0_WHITE_DOWN + jac_affine_inv_1_0_WHITE_DOWN*0.40845277870331731)*(-jac_affine_inv_0_0_WHITE_DOWN + jac_affine_inv_1_0_WHITE_DOWN*0.40845277870331731))*0.14574478709475508 + ((-jac_affine_inv_0_1_WHITE_DOWN + jac_affine_inv_1_1_WHITE_DOWN*0.40845277870331731)*(-jac_affine_inv_0_1_WHITE_DOWN + jac_affine_inv_1_1_WHITE_DOWN*0.40845277870331731))*0.14574478709475508 + ((-jac_affine_inv_0_2_WHITE_DOWN + jac_affine_inv_1_2_WHITE_DOWN*0.40845277870331731)*(-jac_affine_inv_0_2_WHITE_DOWN + jac_affine_inv_1_2_WHITE_DOWN*0.40845277870331731))*0.14574478709475508), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.3817653560693467 + jac_affine_inv_1_0_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_1_0_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_2_0_WHITE_DOWN*0.46230152343146724) + (jac_affine_inv_0_1_WHITE_DOWN*-0.3817653560693467 + jac_affine_inv_1_1_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_1_1_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_2_1_WHITE_DOWN*0.46230152343146724) + (jac_affine_inv_0_2_WHITE_DOWN*-0.3817653560693467 + jac_affine_inv_1_2_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_1_2_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_2_2_WHITE_DOWN*0.46230152343146724)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.3817653560693467 + jac_affine_inv_1_0_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_WHITE_DOWN*0.3817653560693467 + jac_affine_inv_1_0_WHITE_DOWN*0.83922694315494217 + jac_affine_inv_2_0_WHITE_DOWN*0.3817653560693467) + (jac_affine_inv_0_1_WHITE_DOWN*-0.3817653560693467 + jac_affine_inv_1_1_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_WHITE_DOWN*0.3817653560693467 + jac_affine_inv_1_1_WHITE_DOWN*0.83922694315494217 + jac_affine_inv_2_1_WHITE_DOWN*0.3817653560693467) + (jac_affine_inv_0_2_WHITE_DOWN*-0.3817653560693467 + jac_affine_inv_1_2_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_WHITE_DOWN*0.3817653560693467 + jac_affine_inv_1_2_WHITE_DOWN*0.83922694315494217 + jac_affine_inv_2_2_WHITE_DOWN*0.3817653560693467)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.3817653560693467 + jac_affine_inv_1_0_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_WHITE_DOWN*0.61339470758478154 + jac_affine_inv_1_0_WHITE_DOWN*0.15593312049918601 + jac_affine_inv_2_0_WHITE_DOWN*0.15593312049918601) + (jac_affine_inv_0_1_WHITE_DOWN*-0.3817653560693467 + jac_affine_inv_1_1_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_WHITE_DOWN*0.61339470758478154 + jac_affine_inv_1_1_WHITE_DOWN*0.15593312049918601 + jac_affine_inv_2_1_WHITE_DOWN*0.15593312049918601) + (jac_affine_inv_0_2_WHITE_DOWN*-0.3817653560693467 + jac_affine_inv_1_2_WHITE_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_WHITE_DOWN*0.61339470758478154 + jac_affine_inv_1_2_WHITE_DOWN*0.15593312049918601 + jac_affine_inv_2_2_WHITE_DOWN*0.15593312049918601)), abs_det_jac_affine_WHITE_DOWN*(((jac_affine_inv_0_0_WHITE_DOWN*0.010469219979953731 + jac_affine_inv_1_0_WHITE_DOWN*0.010469219979953731 + jac_affine_inv_2_0_WHITE_DOWN)*(jac_affine_inv_0_0_WHITE_DOWN*0.010469219979953731 + jac_affine_inv_1_0_WHITE_DOWN*0.010469219979953731 + jac_affine_inv_2_0_WHITE_DOWN))*0.21372269856705545 + ((jac_affine_inv_0_1_WHITE_DOWN*0.010469219979953731 + jac_affine_inv_1_1_WHITE_DOWN*0.010469219979953731 + jac_affine_inv_2_1_WHITE_DOWN)*(jac_affine_inv_0_1_WHITE_DOWN*0.010469219979953731 + jac_affine_inv_1_1_WHITE_DOWN*0.010469219979953731 + jac_affine_inv_2_1_WHITE_DOWN))*0.21372269856705545 + ((jac_affine_inv_0_2_WHITE_DOWN*0.010469219979953731 + jac_affine_inv_1_2_WHITE_DOWN*0.010469219979953731 + jac_affine_inv_2_2_WHITE_DOWN)*(jac_affine_inv_0_2_WHITE_DOWN*0.010469219979953731 + jac_affine_inv_1_2_WHITE_DOWN*0.010469219979953731 + jac_affine_inv_2_2_WHITE_DOWN))*0.21372269856705545), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_1_0_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_2_0_WHITE_DOWN*0.46230152343146724)*(jac_affine_inv_0_0_WHITE_DOWN*0.3817653560693467 + jac_affine_inv_1_0_WHITE_DOWN*0.83922694315494217 + jac_affine_inv_2_0_WHITE_DOWN*0.3817653560693467) + (jac_affine_inv_0_1_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_1_1_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_2_1_WHITE_DOWN*0.46230152343146724)*(jac_affine_inv_0_1_WHITE_DOWN*0.3817653560693467 + jac_affine_inv_1_1_WHITE_DOWN*0.83922694315494217 + jac_affine_inv_2_1_WHITE_DOWN*0.3817653560693467) + (jac_affine_inv_0_2_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_1_2_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_2_2_WHITE_DOWN*0.46230152343146724)*(jac_affine_inv_0_2_WHITE_DOWN*0.3817653560693467 + jac_affine_inv_1_2_WHITE_DOWN*0.83922694315494217 + jac_affine_inv_2_2_WHITE_DOWN*0.3817653560693467)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_1_0_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_2_0_WHITE_DOWN*0.46230152343146724)*(jac_affine_inv_0_0_WHITE_DOWN*0.61339470758478154 + jac_affine_inv_1_0_WHITE_DOWN*0.15593312049918601 + jac_affine_inv_2_0_WHITE_DOWN*0.15593312049918601) + (jac_affine_inv_0_1_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_1_1_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_2_1_WHITE_DOWN*0.46230152343146724)*(jac_affine_inv_0_1_WHITE_DOWN*0.61339470758478154 + jac_affine_inv_1_1_WHITE_DOWN*0.15593312049918601 + jac_affine_inv_2_1_WHITE_DOWN*0.15593312049918601) + (jac_affine_inv_0_2_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_1_2_WHITE_DOWN*0.0048399363458717648 + jac_affine_inv_2_2_WHITE_DOWN*0.46230152343146724)*(jac_affine_inv_0_2_WHITE_DOWN*0.61339470758478154 + jac_affine_inv_1_2_WHITE_DOWN*0.15593312049918601 + jac_affine_inv_2_2_WHITE_DOWN*0.15593312049918601)), abs_det_jac_affine_WHITE_DOWN*(((jac_affine_inv_0_0_WHITE_DOWN*0.45490121496118757 + jac_affine_inv_1_0_WHITE_DOWN + jac_affine_inv_2_0_WHITE_DOWN*0.45490121496118757)*(jac_affine_inv_0_0_WHITE_DOWN*0.45490121496118757 + jac_affine_inv_1_0_WHITE_DOWN + jac_affine_inv_2_0_WHITE_DOWN*0.45490121496118757))*0.70430186211718859 + ((jac_affine_inv_0_1_WHITE_DOWN*0.45490121496118757 + jac_affine_inv_1_1_WHITE_DOWN + jac_affine_inv_2_1_WHITE_DOWN*0.45490121496118757)*(jac_affine_inv_0_1_WHITE_DOWN*0.45490121496118757 + jac_affine_inv_1_1_WHITE_DOWN + jac_affine_inv_2_1_WHITE_DOWN*0.45490121496118757))*0.70430186211718859 + ((jac_affine_inv_0_2_WHITE_DOWN*0.45490121496118757 + jac_affine_inv_1_2_WHITE_DOWN + jac_affine_inv_2_2_WHITE_DOWN*0.45490121496118757)*(jac_affine_inv_0_2_WHITE_DOWN*0.45490121496118757 + jac_affine_inv_1_2_WHITE_DOWN + jac_affine_inv_2_2_WHITE_DOWN*0.45490121496118757))*0.70430186211718859), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.3817653560693467 + jac_affine_inv_1_0_WHITE_DOWN*0.83922694315494217 + jac_affine_inv_2_0_WHITE_DOWN*0.3817653560693467)*(jac_affine_inv_0_0_WHITE_DOWN*0.61339470758478154 + jac_affine_inv_1_0_WHITE_DOWN*0.15593312049918601 + jac_affine_inv_2_0_WHITE_DOWN*0.15593312049918601) + (jac_affine_inv_0_1_WHITE_DOWN*0.3817653560693467 + jac_affine_inv_1_1_WHITE_DOWN*0.83922694315494217 + jac_affine_inv_2_1_WHITE_DOWN*0.3817653560693467)*(jac_affine_inv_0_1_WHITE_DOWN*0.61339470758478154 + jac_affine_inv_1_1_WHITE_DOWN*0.15593312049918601 + jac_affine_inv_2_1_WHITE_DOWN*0.15593312049918601) + (jac_affine_inv_0_2_WHITE_DOWN*0.3817653560693467 + jac_affine_inv_1_2_WHITE_DOWN*0.83922694315494217 + jac_affine_inv_2_2_WHITE_DOWN*0.3817653560693467)*(jac_affine_inv_0_2_WHITE_DOWN*0.61339470758478154 + jac_affine_inv_1_2_WHITE_DOWN*0.15593312049918601 + jac_affine_inv_2_2_WHITE_DOWN*0.15593312049918601)), abs_det_jac_affine_WHITE_DOWN*(((jac_affine_inv_0_0_WHITE_DOWN + jac_affine_inv_1_0_WHITE_DOWN*0.25421334512840316 + jac_affine_inv_2_0_WHITE_DOWN*0.25421334512840316)*(jac_affine_inv_0_0_WHITE_DOWN + jac_affine_inv_1_0_WHITE_DOWN*0.25421334512840316 + jac_affine_inv_2_0_WHITE_DOWN*0.25421334512840316))*0.37625306729301966 + ((jac_affine_inv_0_1_WHITE_DOWN + jac_affine_inv_1_1_WHITE_DOWN*0.25421334512840316 + jac_affine_inv_2_1_WHITE_DOWN*0.25421334512840316)*(jac_affine_inv_0_1_WHITE_DOWN + jac_affine_inv_1_1_WHITE_DOWN*0.25421334512840316 + jac_affine_inv_2_1_WHITE_DOWN*0.25421334512840316))*0.37625306729301966 + ((jac_affine_inv_0_2_WHITE_DOWN + jac_affine_inv_1_2_WHITE_DOWN*0.25421334512840316 + jac_affine_inv_2_2_WHITE_DOWN*0.25421334512840316)*(jac_affine_inv_0_2_WHITE_DOWN + jac_affine_inv_1_2_WHITE_DOWN*0.25421334512840316 + jac_affine_inv_2_2_WHITE_DOWN*0.25421334512840316))*0.37625306729301966), abs_det_jac_affine_WHITE_DOWN*(((-jac_affine_inv_1_0_WHITE_DOWN + jac_affine_inv_2_0_WHITE_DOWN*0.015462881894859308)*(-jac_affine_inv_1_0_WHITE_DOWN + jac_affine_inv_2_0_WHITE_DOWN*0.015462881894859308))*0.20046443821120841 + ((-jac_affine_inv_1_1_WHITE_DOWN + jac_affine_inv_2_1_WHITE_DOWN*0.015462881894859308)*(-jac_affine_inv_1_1_WHITE_DOWN + jac_affine_inv_2_1_WHITE_DOWN*0.015462881894859308))*0.20046443821120841 + ((-jac_affine_inv_1_2_WHITE_DOWN + jac_affine_inv_2_2_WHITE_DOWN*0.015462881894859308)*(-jac_affine_inv_1_2_WHITE_DOWN + jac_affine_inv_2_2_WHITE_DOWN*0.015462881894859308))*0.20046443821120841), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_1_0_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_WHITE_DOWN*0.0069232355736274674) + (jac_affine_inv_0_1_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_1_1_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_WHITE_DOWN*0.0069232355736274674) + (jac_affine_inv_0_2_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_1_2_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_WHITE_DOWN*0.0069232355736274674)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_0_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_1_0_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_WHITE_DOWN*0.0069232355736274674) + (jac_affine_inv_0_1_WHITE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_1_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_1_1_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_WHITE_DOWN*0.0069232355736274674) + (jac_affine_inv_0_2_WHITE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_2_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_1_2_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_WHITE_DOWN*0.0069232355736274674)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_WHITE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_0_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_1_0_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_2_0_WHITE_DOWN*0.81304707091600714) + (jac_affine_inv_1_1_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_WHITE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_1_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_1_1_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_2_1_WHITE_DOWN*0.81304707091600714) + (jac_affine_inv_1_2_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_WHITE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_2_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_1_2_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_2_2_WHITE_DOWN*0.81304707091600714)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_WHITE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_0_WHITE_DOWN*0.0069232355736274674 + jac_affine_inv_1_0_WHITE_DOWN*0.37223775438826195 + jac_affine_inv_2_0_WHITE_DOWN*0.0069232355736274674) + (jac_affine_inv_1_1_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_WHITE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_1_WHITE_DOWN*0.0069232355736274674 + jac_affine_inv_1_1_WHITE_DOWN*0.37223775438826195 + jac_affine_inv_2_1_WHITE_DOWN*0.0069232355736274674) + (jac_affine_inv_1_2_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_WHITE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_2_WHITE_DOWN*0.0069232355736274674 + jac_affine_inv_1_2_WHITE_DOWN*0.37223775438826195 + jac_affine_inv_2_2_WHITE_DOWN*0.0069232355736274674)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_WHITE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_0_WHITE_DOWN*0.54534421232499986 + jac_affine_inv_1_0_WHITE_DOWN*0.18002969351036541 + jac_affine_inv_2_0_WHITE_DOWN*0.18002969351036541) + (jac_affine_inv_1_1_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_WHITE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_1_WHITE_DOWN*0.54534421232499986 + jac_affine_inv_1_1_WHITE_DOWN*0.18002969351036541 + jac_affine_inv_2_1_WHITE_DOWN*0.18002969351036541) + (jac_affine_inv_1_2_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_WHITE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_2_WHITE_DOWN*0.54534421232499986 + jac_affine_inv_1_2_WHITE_DOWN*0.18002969351036541 + jac_affine_inv_2_2_WHITE_DOWN*0.18002969351036541)), abs_det_jac_affine_WHITE_DOWN*(((-jac_affine_inv_0_0_WHITE_DOWN + jac_affine_inv_2_0_WHITE_DOWN*0.40209203611714223)*(-jac_affine_inv_0_0_WHITE_DOWN + jac_affine_inv_2_0_WHITE_DOWN*0.40209203611714223))*0.20046443821120841 + ((-jac_affine_inv_0_1_WHITE_DOWN + jac_affine_inv_2_1_WHITE_DOWN*0.40209203611714223)*(-jac_affine_inv_0_1_WHITE_DOWN + jac_affine_inv_2_1_WHITE_DOWN*0.40209203611714223))*0.20046443821120841 + ((-jac_affine_inv_0_2_WHITE_DOWN + jac_affine_inv_2_2_WHITE_DOWN*0.40209203611714223)*(-jac_affine_inv_0_2_WHITE_DOWN + jac_affine_inv_2_2_WHITE_DOWN*0.40209203611714223))*0.20046443821120841), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_0_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_WHITE_DOWN*0.18002969351036541) + (jac_affine_inv_0_1_WHITE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_1_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_WHITE_DOWN*0.18002969351036541) + (jac_affine_inv_0_2_WHITE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_2_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_WHITE_DOWN*0.18002969351036541)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_1_0_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_2_0_WHITE_DOWN*0.81304707091600714) + (jac_affine_inv_0_1_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_1_1_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_2_1_WHITE_DOWN*0.81304707091600714) + (jac_affine_inv_0_2_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_1_2_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_2_2_WHITE_DOWN*0.81304707091600714)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_WHITE_DOWN*0.0069232355736274674 + jac_affine_inv_1_0_WHITE_DOWN*0.37223775438826195 + jac_affine_inv_2_0_WHITE_DOWN*0.0069232355736274674) + (jac_affine_inv_0_1_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_WHITE_DOWN*0.0069232355736274674 + jac_affine_inv_1_1_WHITE_DOWN*0.37223775438826195 + jac_affine_inv_2_1_WHITE_DOWN*0.0069232355736274674) + (jac_affine_inv_0_2_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_WHITE_DOWN*0.0069232355736274674 + jac_affine_inv_1_2_WHITE_DOWN*0.37223775438826195 + jac_affine_inv_2_2_WHITE_DOWN*0.0069232355736274674)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_WHITE_DOWN*0.54534421232499986 + jac_affine_inv_1_0_WHITE_DOWN*0.18002969351036541 + jac_affine_inv_2_0_WHITE_DOWN*0.18002969351036541) + (jac_affine_inv_0_1_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_WHITE_DOWN*0.54534421232499986 + jac_affine_inv_1_1_WHITE_DOWN*0.18002969351036541 + jac_affine_inv_2_1_WHITE_DOWN*0.18002969351036541) + (jac_affine_inv_0_2_WHITE_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_WHITE_DOWN*0.54534421232499986 + jac_affine_inv_1_2_WHITE_DOWN*0.18002969351036541 + jac_affine_inv_2_2_WHITE_DOWN*0.18002969351036541)), abs_det_jac_affine_WHITE_DOWN*(((jac_affine_inv_0_0_WHITE_DOWN*-0.03845607598742512 + jac_affine_inv_1_0_WHITE_DOWN)*(jac_affine_inv_0_0_WHITE_DOWN*-0.03845607598742512 + jac_affine_inv_1_0_WHITE_DOWN))*0.032410690545436105 + ((jac_affine_inv_0_1_WHITE_DOWN*-0.03845607598742512 + jac_affine_inv_1_1_WHITE_DOWN)*(jac_affine_inv_0_1_WHITE_DOWN*-0.03845607598742512 + jac_affine_inv_1_1_WHITE_DOWN))*0.032410690545436105 + ((jac_affine_inv_0_2_WHITE_DOWN*-0.03845607598742512 + jac_affine_inv_1_2_WHITE_DOWN)*(jac_affine_inv_0_2_WHITE_DOWN*-0.03845607598742512 + jac_affine_inv_1_2_WHITE_DOWN))*0.032410690545436105), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_0_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_1_0_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_2_0_WHITE_DOWN*0.81304707091600714) + (jac_affine_inv_0_1_WHITE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_1_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_1_1_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_2_1_WHITE_DOWN*0.81304707091600714) + (jac_affine_inv_0_2_WHITE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_2_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_1_2_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_2_2_WHITE_DOWN*0.81304707091600714)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_0_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_WHITE_DOWN*0.0069232355736274674 + jac_affine_inv_1_0_WHITE_DOWN*0.37223775438826195 + jac_affine_inv_2_0_WHITE_DOWN*0.0069232355736274674) + (jac_affine_inv_0_1_WHITE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_1_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_WHITE_DOWN*0.0069232355736274674 + jac_affine_inv_1_1_WHITE_DOWN*0.37223775438826195 + jac_affine_inv_2_1_WHITE_DOWN*0.0069232355736274674) + (jac_affine_inv_0_2_WHITE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_2_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_WHITE_DOWN*0.0069232355736274674 + jac_affine_inv_1_2_WHITE_DOWN*0.37223775438826195 + jac_affine_inv_2_2_WHITE_DOWN*0.0069232355736274674)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_0_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_WHITE_DOWN*0.54534421232499986 + jac_affine_inv_1_0_WHITE_DOWN*0.18002969351036541 + jac_affine_inv_2_0_WHITE_DOWN*0.18002969351036541) + (jac_affine_inv_0_1_WHITE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_1_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_WHITE_DOWN*0.54534421232499986 + jac_affine_inv_1_1_WHITE_DOWN*0.18002969351036541 + jac_affine_inv_2_1_WHITE_DOWN*0.18002969351036541) + (jac_affine_inv_0_2_WHITE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_2_WHITE_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_WHITE_DOWN*0.54534421232499986 + jac_affine_inv_1_2_WHITE_DOWN*0.18002969351036541 + jac_affine_inv_2_2_WHITE_DOWN*0.18002969351036541)), abs_det_jac_affine_WHITE_DOWN*(((jac_affine_inv_0_0_WHITE_DOWN*0.55068466281655948 + jac_affine_inv_1_0_WHITE_DOWN*0.55068466281655948 + jac_affine_inv_2_0_WHITE_DOWN)*(jac_affine_inv_0_0_WHITE_DOWN*0.55068466281655948 + jac_affine_inv_1_0_WHITE_DOWN*0.55068466281655948 + jac_affine_inv_2_0_WHITE_DOWN))*0.6610455395250987 + ((jac_affine_inv_0_1_WHITE_DOWN*0.55068466281655948 + jac_affine_inv_1_1_WHITE_DOWN*0.55068466281655948 + jac_affine_inv_2_1_WHITE_DOWN)*(jac_affine_inv_0_1_WHITE_DOWN*0.55068466281655948 + jac_affine_inv_1_1_WHITE_DOWN*0.55068466281655948 + jac_affine_inv_2_1_WHITE_DOWN))*0.6610455395250987 + ((jac_affine_inv_0_2_WHITE_DOWN*0.55068466281655948 + jac_affine_inv_1_2_WHITE_DOWN*0.55068466281655948 + jac_affine_inv_2_2_WHITE_DOWN)*(jac_affine_inv_0_2_WHITE_DOWN*0.55068466281655948 + jac_affine_inv_1_2_WHITE_DOWN*0.55068466281655948 + jac_affine_inv_2_2_WHITE_DOWN))*0.6610455395250987), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.0069232355736274674 + jac_affine_inv_1_0_WHITE_DOWN*0.37223775438826195 + jac_affine_inv_2_0_WHITE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_0_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_1_0_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_2_0_WHITE_DOWN*0.81304707091600714) + (jac_affine_inv_0_1_WHITE_DOWN*0.0069232355736274674 + jac_affine_inv_1_1_WHITE_DOWN*0.37223775438826195 + jac_affine_inv_2_1_WHITE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_1_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_1_1_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_2_1_WHITE_DOWN*0.81304707091600714) + (jac_affine_inv_0_2_WHITE_DOWN*0.0069232355736274674 + jac_affine_inv_1_2_WHITE_DOWN*0.37223775438826195 + jac_affine_inv_2_2_WHITE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_2_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_1_2_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_2_2_WHITE_DOWN*0.81304707091600714)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_1_0_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_2_0_WHITE_DOWN*0.81304707091600714)*(jac_affine_inv_0_0_WHITE_DOWN*0.54534421232499986 + jac_affine_inv_1_0_WHITE_DOWN*0.18002969351036541 + jac_affine_inv_2_0_WHITE_DOWN*0.18002969351036541) + (jac_affine_inv_0_1_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_1_1_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_2_1_WHITE_DOWN*0.81304707091600714)*(jac_affine_inv_0_1_WHITE_DOWN*0.54534421232499986 + jac_affine_inv_1_1_WHITE_DOWN*0.18002969351036541 + jac_affine_inv_2_1_WHITE_DOWN*0.18002969351036541) + (jac_affine_inv_0_2_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_1_2_WHITE_DOWN*0.44773255210137269 + jac_affine_inv_2_2_WHITE_DOWN*0.81304707091600714)*(jac_affine_inv_0_2_WHITE_DOWN*0.54534421232499986 + jac_affine_inv_1_2_WHITE_DOWN*0.18002969351036541 + jac_affine_inv_2_2_WHITE_DOWN*0.18002969351036541)), abs_det_jac_affine_WHITE_DOWN*(((jac_affine_inv_0_0_WHITE_DOWN*0.01859896126067373 + jac_affine_inv_1_0_WHITE_DOWN + jac_affine_inv_2_0_WHITE_DOWN*0.01859896126067373)*(jac_affine_inv_0_0_WHITE_DOWN*0.01859896126067373 + jac_affine_inv_1_0_WHITE_DOWN + jac_affine_inv_2_0_WHITE_DOWN*0.01859896126067373))*0.13856094579201603 + ((jac_affine_inv_0_1_WHITE_DOWN*0.01859896126067373 + jac_affine_inv_1_1_WHITE_DOWN + jac_affine_inv_2_1_WHITE_DOWN*0.01859896126067373)*(jac_affine_inv_0_1_WHITE_DOWN*0.01859896126067373 + jac_affine_inv_1_1_WHITE_DOWN + jac_affine_inv_2_1_WHITE_DOWN*0.01859896126067373))*0.13856094579201603 + ((jac_affine_inv_0_2_WHITE_DOWN*0.01859896126067373 + jac_affine_inv_1_2_WHITE_DOWN + jac_affine_inv_2_2_WHITE_DOWN*0.01859896126067373)*(jac_affine_inv_0_2_WHITE_DOWN*0.01859896126067373 + jac_affine_inv_1_2_WHITE_DOWN + jac_affine_inv_2_2_WHITE_DOWN*0.01859896126067373))*0.13856094579201603), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.0069232355736274674 + jac_affine_inv_1_0_WHITE_DOWN*0.37223775438826195 + jac_affine_inv_2_0_WHITE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_0_WHITE_DOWN*0.54534421232499986 + jac_affine_inv_1_0_WHITE_DOWN*0.18002969351036541 + jac_affine_inv_2_0_WHITE_DOWN*0.18002969351036541) + (jac_affine_inv_0_1_WHITE_DOWN*0.0069232355736274674 + jac_affine_inv_1_1_WHITE_DOWN*0.37223775438826195 + jac_affine_inv_2_1_WHITE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_1_WHITE_DOWN*0.54534421232499986 + jac_affine_inv_1_1_WHITE_DOWN*0.18002969351036541 + jac_affine_inv_2_1_WHITE_DOWN*0.18002969351036541) + (jac_affine_inv_0_2_WHITE_DOWN*0.0069232355736274674 + jac_affine_inv_1_2_WHITE_DOWN*0.37223775438826195 + jac_affine_inv_2_2_WHITE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_2_WHITE_DOWN*0.54534421232499986 + jac_affine_inv_1_2_WHITE_DOWN*0.18002969351036541 + jac_affine_inv_2_2_WHITE_DOWN*0.18002969351036541)), abs_det_jac_affine_WHITE_DOWN*(((jac_affine_inv_0_0_WHITE_DOWN + jac_affine_inv_1_0_WHITE_DOWN*0.33012121416459822 + jac_affine_inv_2_0_WHITE_DOWN*0.33012121416459822)*(jac_affine_inv_0_0_WHITE_DOWN + jac_affine_inv_1_0_WHITE_DOWN*0.33012121416459822 + jac_affine_inv_2_0_WHITE_DOWN*0.33012121416459822))*0.29740030991637451 + ((jac_affine_inv_0_1_WHITE_DOWN + jac_affine_inv_1_1_WHITE_DOWN*0.33012121416459822 + jac_affine_inv_2_1_WHITE_DOWN*0.33012121416459822)*(jac_affine_inv_0_1_WHITE_DOWN + jac_affine_inv_1_1_WHITE_DOWN*0.33012121416459822 + jac_affine_inv_2_1_WHITE_DOWN*0.33012121416459822))*0.29740030991637451 + ((jac_affine_inv_0_2_WHITE_DOWN + jac_affine_inv_1_2_WHITE_DOWN*0.33012121416459822 + jac_affine_inv_2_2_WHITE_DOWN*0.33012121416459822)*(jac_affine_inv_0_2_WHITE_DOWN + jac_affine_inv_1_2_WHITE_DOWN*0.33012121416459822 + jac_affine_inv_2_2_WHITE_DOWN*0.33012121416459822))*0.29740030991637451), abs_det_jac_affine_WHITE_DOWN*(((jac_affine_inv_1_0_WHITE_DOWN*-0.81923601162978588 + jac_affine_inv_2_0_WHITE_DOWN)*(jac_affine_inv_1_0_WHITE_DOWN*-0.81923601162978588 + jac_affine_inv_2_0_WHITE_DOWN))*0.18550396047976214 + ((jac_affine_inv_1_1_WHITE_DOWN*-0.81923601162978588 + jac_affine_inv_2_1_WHITE_DOWN)*(jac_affine_inv_1_1_WHITE_DOWN*-0.81923601162978588 + jac_affine_inv_2_1_WHITE_DOWN))*0.18550396047976214 + ((jac_affine_inv_1_2_WHITE_DOWN*-0.81923601162978588 + jac_affine_inv_2_2_WHITE_DOWN)*(jac_affine_inv_1_2_WHITE_DOWN*-0.81923601162978588 + jac_affine_inv_2_2_WHITE_DOWN))*0.18550396047976214), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_1_0_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_WHITE_DOWN*0.43070170707783612) + (jac_affine_inv_0_1_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_1_1_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_WHITE_DOWN*0.43070170707783612) + (jac_affine_inv_0_2_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_1_2_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_WHITE_DOWN*0.43070170707783612)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.43070170707783612 + jac_affine_inv_1_0_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_1_0_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_WHITE_DOWN*0.43070170707783612) + (jac_affine_inv_0_1_WHITE_DOWN*-0.43070170707783612 + jac_affine_inv_1_1_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_1_1_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_WHITE_DOWN*0.43070170707783612) + (jac_affine_inv_0_2_WHITE_DOWN*-0.43070170707783612 + jac_affine_inv_1_2_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_1_2_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_WHITE_DOWN*0.43070170707783612)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_WHITE_DOWN*0.43070170707783612)*(jac_affine_inv_0_0_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_1_0_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_2_0_WHITE_DOWN*0.35322186373731607) + (jac_affine_inv_1_1_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_WHITE_DOWN*0.43070170707783612)*(jac_affine_inv_0_1_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_1_1_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_2_1_WHITE_DOWN*0.35322186373731607) + (jac_affine_inv_1_2_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_WHITE_DOWN*0.43070170707783612)*(jac_affine_inv_0_2_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_1_2_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_2_2_WHITE_DOWN*0.35322186373731607)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_WHITE_DOWN*0.43070170707783612)*(jac_affine_inv_0_0_WHITE_DOWN*0.43070170707783612 + jac_affine_inv_1_0_WHITE_DOWN*0.43107722210656541 + jac_affine_inv_2_0_WHITE_DOWN*0.43070170707783612) + (jac_affine_inv_1_1_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_WHITE_DOWN*0.43070170707783612)*(jac_affine_inv_0_1_WHITE_DOWN*0.43070170707783612 + jac_affine_inv_1_1_WHITE_DOWN*0.43107722210656541 + jac_affine_inv_2_1_WHITE_DOWN*0.43070170707783612) + (jac_affine_inv_1_2_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_WHITE_DOWN*0.43070170707783612)*(jac_affine_inv_0_2_WHITE_DOWN*0.43070170707783612 + jac_affine_inv_1_2_WHITE_DOWN*0.43107722210656541 + jac_affine_inv_2_2_WHITE_DOWN*0.43070170707783612)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_1_0_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_WHITE_DOWN*0.43070170707783612)*(jac_affine_inv_0_0_WHITE_DOWN*0.21645194421357716 + jac_affine_inv_1_0_WHITE_DOWN*0.21607642918484779 + jac_affine_inv_2_0_WHITE_DOWN*0.21607642918484779) + (jac_affine_inv_1_1_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_WHITE_DOWN*0.43070170707783612)*(jac_affine_inv_0_1_WHITE_DOWN*0.21645194421357716 + jac_affine_inv_1_1_WHITE_DOWN*0.21607642918484779 + jac_affine_inv_2_1_WHITE_DOWN*0.21607642918484779) + (jac_affine_inv_1_2_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_WHITE_DOWN*0.43070170707783612)*(jac_affine_inv_0_2_WHITE_DOWN*0.21645194421357716 + jac_affine_inv_1_2_WHITE_DOWN*0.21607642918484779 + jac_affine_inv_2_2_WHITE_DOWN*0.21607642918484779)), abs_det_jac_affine_WHITE_DOWN*(((-jac_affine_inv_0_0_WHITE_DOWN + jac_affine_inv_2_0_WHITE_DOWN*0.61238108308527162)*(-jac_affine_inv_0_0_WHITE_DOWN + jac_affine_inv_2_0_WHITE_DOWN*0.61238108308527162))*0.12450054579698162 + ((-jac_affine_inv_0_1_WHITE_DOWN + jac_affine_inv_2_1_WHITE_DOWN*0.61238108308527162)*(-jac_affine_inv_0_1_WHITE_DOWN + jac_affine_inv_2_1_WHITE_DOWN*0.61238108308527162))*0.12450054579698162 + ((-jac_affine_inv_0_2_WHITE_DOWN + jac_affine_inv_2_2_WHITE_DOWN*0.61238108308527162)*(-jac_affine_inv_0_2_WHITE_DOWN + jac_affine_inv_2_2_WHITE_DOWN*0.61238108308527162))*0.12450054579698162), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_WHITE_DOWN*-0.43070170707783612 + jac_affine_inv_1_0_WHITE_DOWN*0.21607642918484779) + (jac_affine_inv_0_1_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_WHITE_DOWN*-0.43070170707783612 + jac_affine_inv_1_1_WHITE_DOWN*0.21607642918484779) + (jac_affine_inv_0_2_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_WHITE_DOWN*-0.43070170707783612 + jac_affine_inv_1_2_WHITE_DOWN*0.21607642918484779)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_1_0_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_2_0_WHITE_DOWN*0.35322186373731607) + (jac_affine_inv_0_1_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_1_1_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_2_1_WHITE_DOWN*0.35322186373731607) + (jac_affine_inv_0_2_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_1_2_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_2_2_WHITE_DOWN*0.35322186373731607)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_WHITE_DOWN*0.43070170707783612 + jac_affine_inv_1_0_WHITE_DOWN*0.43107722210656541 + jac_affine_inv_2_0_WHITE_DOWN*0.43070170707783612) + (jac_affine_inv_0_1_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_WHITE_DOWN*0.43070170707783612 + jac_affine_inv_1_1_WHITE_DOWN*0.43107722210656541 + jac_affine_inv_2_1_WHITE_DOWN*0.43070170707783612) + (jac_affine_inv_0_2_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_WHITE_DOWN*0.43070170707783612 + jac_affine_inv_1_2_WHITE_DOWN*0.43107722210656541 + jac_affine_inv_2_2_WHITE_DOWN*0.43070170707783612)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_WHITE_DOWN*0.21645194421357716 + jac_affine_inv_1_0_WHITE_DOWN*0.21607642918484779 + jac_affine_inv_2_0_WHITE_DOWN*0.21607642918484779) + (jac_affine_inv_0_1_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_WHITE_DOWN*0.21645194421357716 + jac_affine_inv_1_1_WHITE_DOWN*0.21607642918484779 + jac_affine_inv_2_1_WHITE_DOWN*0.21607642918484779) + (jac_affine_inv_0_2_WHITE_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_WHITE_DOWN*0.21645194421357716 + jac_affine_inv_1_2_WHITE_DOWN*0.21607642918484779 + jac_affine_inv_2_2_WHITE_DOWN*0.21607642918484779)), abs_det_jac_affine_WHITE_DOWN*(((-jac_affine_inv_0_0_WHITE_DOWN + jac_affine_inv_1_0_WHITE_DOWN*0.50168463610430647)*(-jac_affine_inv_0_0_WHITE_DOWN + jac_affine_inv_1_0_WHITE_DOWN*0.50168463610430647))*0.18550396047976214 + ((-jac_affine_inv_0_1_WHITE_DOWN + jac_affine_inv_1_1_WHITE_DOWN*0.50168463610430647)*(-jac_affine_inv_0_1_WHITE_DOWN + jac_affine_inv_1_1_WHITE_DOWN*0.50168463610430647))*0.18550396047976214 + ((-jac_affine_inv_0_2_WHITE_DOWN + jac_affine_inv_1_2_WHITE_DOWN*0.50168463610430647)*(-jac_affine_inv_0_2_WHITE_DOWN + jac_affine_inv_1_2_WHITE_DOWN*0.50168463610430647))*0.18550396047976214), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.43070170707783612 + jac_affine_inv_1_0_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_1_0_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_2_0_WHITE_DOWN*0.35322186373731607) + (jac_affine_inv_0_1_WHITE_DOWN*-0.43070170707783612 + jac_affine_inv_1_1_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_1_1_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_2_1_WHITE_DOWN*0.35322186373731607) + (jac_affine_inv_0_2_WHITE_DOWN*-0.43070170707783612 + jac_affine_inv_1_2_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_1_2_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_2_2_WHITE_DOWN*0.35322186373731607)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.43070170707783612 + jac_affine_inv_1_0_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_WHITE_DOWN*0.43070170707783612 + jac_affine_inv_1_0_WHITE_DOWN*0.43107722210656541 + jac_affine_inv_2_0_WHITE_DOWN*0.43070170707783612) + (jac_affine_inv_0_1_WHITE_DOWN*-0.43070170707783612 + jac_affine_inv_1_1_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_WHITE_DOWN*0.43070170707783612 + jac_affine_inv_1_1_WHITE_DOWN*0.43107722210656541 + jac_affine_inv_2_1_WHITE_DOWN*0.43070170707783612) + (jac_affine_inv_0_2_WHITE_DOWN*-0.43070170707783612 + jac_affine_inv_1_2_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_WHITE_DOWN*0.43070170707783612 + jac_affine_inv_1_2_WHITE_DOWN*0.43107722210656541 + jac_affine_inv_2_2_WHITE_DOWN*0.43070170707783612)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*-0.43070170707783612 + jac_affine_inv_1_0_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_WHITE_DOWN*0.21645194421357716 + jac_affine_inv_1_0_WHITE_DOWN*0.21607642918484779 + jac_affine_inv_2_0_WHITE_DOWN*0.21607642918484779) + (jac_affine_inv_0_1_WHITE_DOWN*-0.43070170707783612 + jac_affine_inv_1_1_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_WHITE_DOWN*0.21645194421357716 + jac_affine_inv_1_1_WHITE_DOWN*0.21607642918484779 + jac_affine_inv_2_1_WHITE_DOWN*0.21607642918484779) + (jac_affine_inv_0_2_WHITE_DOWN*-0.43070170707783612 + jac_affine_inv_1_2_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_WHITE_DOWN*0.21645194421357716 + jac_affine_inv_1_2_WHITE_DOWN*0.21607642918484779 + jac_affine_inv_2_2_WHITE_DOWN*0.21607642918484779)), abs_det_jac_affine_WHITE_DOWN*(((jac_affine_inv_0_0_WHITE_DOWN*0.99893688622568233 + jac_affine_inv_1_0_WHITE_DOWN*0.99893688622568233 + jac_affine_inv_2_0_WHITE_DOWN)*(jac_affine_inv_0_0_WHITE_DOWN*0.99893688622568233 + jac_affine_inv_1_0_WHITE_DOWN*0.99893688622568233 + jac_affine_inv_2_0_WHITE_DOWN))*0.12476568502206307 + ((jac_affine_inv_0_1_WHITE_DOWN*0.99893688622568233 + jac_affine_inv_1_1_WHITE_DOWN*0.99893688622568233 + jac_affine_inv_2_1_WHITE_DOWN)*(jac_affine_inv_0_1_WHITE_DOWN*0.99893688622568233 + jac_affine_inv_1_1_WHITE_DOWN*0.99893688622568233 + jac_affine_inv_2_1_WHITE_DOWN))*0.12476568502206307 + ((jac_affine_inv_0_2_WHITE_DOWN*0.99893688622568233 + jac_affine_inv_1_2_WHITE_DOWN*0.99893688622568233 + jac_affine_inv_2_2_WHITE_DOWN)*(jac_affine_inv_0_2_WHITE_DOWN*0.99893688622568233 + jac_affine_inv_1_2_WHITE_DOWN*0.99893688622568233 + jac_affine_inv_2_2_WHITE_DOWN))*0.12476568502206307), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_1_0_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_2_0_WHITE_DOWN*0.35322186373731607)*(jac_affine_inv_0_0_WHITE_DOWN*0.43070170707783612 + jac_affine_inv_1_0_WHITE_DOWN*0.43107722210656541 + jac_affine_inv_2_0_WHITE_DOWN*0.43070170707783612) + (jac_affine_inv_0_1_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_1_1_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_2_1_WHITE_DOWN*0.35322186373731607)*(jac_affine_inv_0_1_WHITE_DOWN*0.43070170707783612 + jac_affine_inv_1_1_WHITE_DOWN*0.43107722210656541 + jac_affine_inv_2_1_WHITE_DOWN*0.43070170707783612) + (jac_affine_inv_0_2_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_1_2_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_2_2_WHITE_DOWN*0.35322186373731607)*(jac_affine_inv_0_2_WHITE_DOWN*0.43070170707783612 + jac_affine_inv_1_2_WHITE_DOWN*0.43107722210656541 + jac_affine_inv_2_2_WHITE_DOWN*0.43070170707783612)), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.21645194421357716 + jac_affine_inv_1_0_WHITE_DOWN*0.21607642918484779 + jac_affine_inv_2_0_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_1_0_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_2_0_WHITE_DOWN*0.35322186373731607) + (jac_affine_inv_0_1_WHITE_DOWN*0.21645194421357716 + jac_affine_inv_1_1_WHITE_DOWN*0.21607642918484779 + jac_affine_inv_2_1_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_1_1_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_2_1_WHITE_DOWN*0.35322186373731607) + (jac_affine_inv_0_2_WHITE_DOWN*0.21645194421357716 + jac_affine_inv_1_2_WHITE_DOWN*0.21607642918484779 + jac_affine_inv_2_2_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_1_2_WHITE_DOWN*0.35284634870858678 + jac_affine_inv_2_2_WHITE_DOWN*0.35322186373731607)), abs_det_jac_affine_WHITE_DOWN*(((jac_affine_inv_0_0_WHITE_DOWN*0.99912889150836071 + jac_affine_inv_1_0_WHITE_DOWN + jac_affine_inv_2_0_WHITE_DOWN*0.99912889150836071)*(jac_affine_inv_0_0_WHITE_DOWN*0.99912889150836071 + jac_affine_inv_1_0_WHITE_DOWN + jac_affine_inv_2_0_WHITE_DOWN*0.99912889150836071))*0.18582757141911313 + ((jac_affine_inv_0_1_WHITE_DOWN*0.99912889150836071 + jac_affine_inv_1_1_WHITE_DOWN + jac_affine_inv_2_1_WHITE_DOWN*0.99912889150836071)*(jac_affine_inv_0_1_WHITE_DOWN*0.99912889150836071 + jac_affine_inv_1_1_WHITE_DOWN + jac_affine_inv_2_1_WHITE_DOWN*0.99912889150836071))*0.18582757141911313 + ((jac_affine_inv_0_2_WHITE_DOWN*0.99912889150836071 + jac_affine_inv_1_2_WHITE_DOWN + jac_affine_inv_2_2_WHITE_DOWN*0.99912889150836071)*(jac_affine_inv_0_2_WHITE_DOWN*0.99912889150836071 + jac_affine_inv_1_2_WHITE_DOWN + jac_affine_inv_2_2_WHITE_DOWN*0.99912889150836071))*0.18582757141911313), abs_det_jac_affine_WHITE_DOWN*((jac_affine_inv_0_0_WHITE_DOWN*0.21645194421357716 + jac_affine_inv_1_0_WHITE_DOWN*0.21607642918484779 + jac_affine_inv_2_0_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_WHITE_DOWN*0.43070170707783612 + jac_affine_inv_1_0_WHITE_DOWN*0.43107722210656541 + jac_affine_inv_2_0_WHITE_DOWN*0.43070170707783612) + (jac_affine_inv_0_1_WHITE_DOWN*0.21645194421357716 + jac_affine_inv_1_1_WHITE_DOWN*0.21607642918484779 + jac_affine_inv_2_1_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_WHITE_DOWN*0.43070170707783612 + jac_affine_inv_1_1_WHITE_DOWN*0.43107722210656541 + jac_affine_inv_2_1_WHITE_DOWN*0.43070170707783612) + (jac_affine_inv_0_2_WHITE_DOWN*0.21645194421357716 + jac_affine_inv_1_2_WHITE_DOWN*0.21607642918484779 + jac_affine_inv_2_2_WHITE_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_WHITE_DOWN*0.43070170707783612 + jac_affine_inv_1_2_WHITE_DOWN*0.43107722210656541 + jac_affine_inv_2_2_WHITE_DOWN*0.43070170707783612)), abs_det_jac_affine_WHITE_DOWN*(((jac_affine_inv_0_0_WHITE_DOWN + jac_affine_inv_1_0_WHITE_DOWN*0.99826513441543008 + jac_affine_inv_2_0_WHITE_DOWN*0.99826513441543008)*(jac_affine_inv_0_0_WHITE_DOWN + jac_affine_inv_1_0_WHITE_DOWN*0.99826513441543008 + jac_affine_inv_2_0_WHITE_DOWN*0.99826513441543008))*0.046851444153837518 + ((jac_affine_inv_0_1_WHITE_DOWN + jac_affine_inv_1_1_WHITE_DOWN*0.99826513441543008 + jac_affine_inv_2_1_WHITE_DOWN*0.99826513441543008)*(jac_affine_inv_0_1_WHITE_DOWN + jac_affine_inv_1_1_WHITE_DOWN*0.99826513441543008 + jac_affine_inv_2_1_WHITE_DOWN*0.99826513441543008))*0.046851444153837518 + ((jac_affine_inv_0_2_WHITE_DOWN + jac_affine_inv_1_2_WHITE_DOWN*0.99826513441543008 + jac_affine_inv_2_2_WHITE_DOWN*0.99826513441543008)*(jac_affine_inv_0_2_WHITE_DOWN + jac_affine_inv_1_2_WHITE_DOWN*0.99826513441543008 + jac_affine_inv_2_2_WHITE_DOWN*0.99826513441543008))*0.046851444153837518)};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
          {
             const walberla::float64 alpha_dof_0 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 alpha_dof_1 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 alpha_dof_2 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 alpha_dof_3 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 beta_dof_0 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 beta_dof_1 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 beta_dof_2 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 beta_dof_3 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             walberla::float64 q_acc_0_0 = 0.0;
             walberla::float64 q_acc_0_1 = 0.0;
             walberla::float64 q_acc_0_2 = 0.0;
             walberla::float64 q_acc_0_3 = 0.0;
             walberla::float64 q_acc_0_4 = 0.0;
             walberla::float64 q_acc_0_5 = 0.0;
             walberla::float64 q_acc_1_1 = 0.0;
             walberla::float64 q_acc_1_2 = 0.0;
             walberla::float64 q_acc_1_3 = 0.0;
             walberla::float64 q_acc_1_4 = 0.0;
             walberla::float64 q_acc_1_5 = 0.0;
             walberla::float64 q_acc_2_2 = 0.0;
             walberla::float64 q_acc_2_3 = 0.0;
             walberla::float64 q_acc_2_4 = 0.0;
             walberla::float64 q_acc_2_5 = 0.0;
             walberla::float64 q_acc_3_3 = 0.0;
             walberla::float64 q_acc_3_4 = 0.0;
             walberla::float64 q_acc_3_5 = 0.0;
             walberla::float64 q_acc_4_4 = 0.0;
             walberla::float64 q_acc_4_5 = 0.0;
             walberla::float64 q_acc_5_5 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const walberla::float64 tmp_qloop_0 = alpha_dof_0*_data_phi_0_0_WHITE_DOWN[4*q] + alpha_dof_1*_data_phi_0_0_WHITE_DOWN[4*q + 1] + alpha_dof_2*_data_phi_0_0_WHITE_DOWN[4*q + 2] + alpha_dof_3*_data_phi_0_0_WHITE_DOWN[4*q + 3];
                const walberla::float64 tmp_qloop_1 = beta_dof_0*_data_phi_0_0_WHITE_DOWN[4*q] + beta_dof_1*_data_phi_0_0_WHITE_DOWN[4*q + 1] + beta_dof_2*_data_phi_0_0_WHITE_DOWN[4*q + 2] + beta_dof_3*_data_phi_0_0_WHITE_DOWN[4*q + 3];
                const walberla::float64 q_tmp_0_0 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_DOWN[21*q] + tmp_qloop_1*_data_mass_det_0_0_WHITE_DOWN[21*q])*_data_q_w[q];
                const walberla::float64 q_tmp_0_1 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_DOWN[21*q + 1] + tmp_qloop_1*_data_mass_det_0_0_WHITE_DOWN[21*q + 1])*_data_q_w[q];
                const walberla::float64 q_tmp_0_2 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_DOWN[21*q + 2] + tmp_qloop_1*_data_mass_det_0_0_WHITE_DOWN[21*q + 2])*_data_q_w[q];
                const walberla::float64 q_tmp_0_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_DOWN[21*q + 3] + tmp_qloop_1*_data_mass_det_0_0_WHITE_DOWN[21*q + 3])*_data_q_w[q];
                const walberla::float64 q_tmp_0_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_DOWN[21*q + 4] + tmp_qloop_1*_data_mass_det_0_0_WHITE_DOWN[21*q + 4])*_data_q_w[q];
                const walberla::float64 q_tmp_0_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_DOWN[21*q + 5] + tmp_qloop_1*_data_mass_det_0_0_WHITE_DOWN[21*q + 5])*_data_q_w[q];
                const walberla::float64 q_tmp_1_1 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_DOWN[21*q + 6] + tmp_qloop_1*_data_mass_det_0_0_WHITE_DOWN[21*q + 6])*_data_q_w[q];
                const walberla::float64 q_tmp_1_2 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_DOWN[21*q + 7] + tmp_qloop_1*_data_mass_det_0_0_WHITE_DOWN[21*q + 7])*_data_q_w[q];
                const walberla::float64 q_tmp_1_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_DOWN[21*q + 8] + tmp_qloop_1*_data_mass_det_0_0_WHITE_DOWN[21*q + 8])*_data_q_w[q];
                const walberla::float64 q_tmp_1_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_DOWN[21*q + 9] + tmp_qloop_1*_data_mass_det_0_0_WHITE_DOWN[21*q + 9])*_data_q_w[q];
                const walberla::float64 q_tmp_1_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_DOWN[21*q + 10] + tmp_qloop_1*_data_mass_det_0_0_WHITE_DOWN[21*q + 10])*_data_q_w[q];
                const walberla::float64 q_tmp_2_2 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_DOWN[21*q + 11] + tmp_qloop_1*_data_mass_det_0_0_WHITE_DOWN[21*q + 11])*_data_q_w[q];
                const walberla::float64 q_tmp_2_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_DOWN[21*q + 12] + tmp_qloop_1*_data_mass_det_0_0_WHITE_DOWN[21*q + 12])*_data_q_w[q];
                const walberla::float64 q_tmp_2_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_DOWN[21*q + 13] + tmp_qloop_1*_data_mass_det_0_0_WHITE_DOWN[21*q + 13])*_data_q_w[q];
                const walberla::float64 q_tmp_2_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_DOWN[21*q + 14] + tmp_qloop_1*_data_mass_det_0_0_WHITE_DOWN[21*q + 14])*_data_q_w[q];
                const walberla::float64 q_tmp_3_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_DOWN[21*q + 15] + tmp_qloop_1*_data_mass_det_0_0_WHITE_DOWN[21*q + 15])*_data_q_w[q];
                const walberla::float64 q_tmp_3_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_DOWN[21*q + 16] + tmp_qloop_1*_data_mass_det_0_0_WHITE_DOWN[21*q + 16])*_data_q_w[q];
                const walberla::float64 q_tmp_3_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_DOWN[21*q + 17] + tmp_qloop_1*_data_mass_det_0_0_WHITE_DOWN[21*q + 17])*_data_q_w[q];
                const walberla::float64 q_tmp_4_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_DOWN[21*q + 18] + tmp_qloop_1*_data_mass_det_0_0_WHITE_DOWN[21*q + 18])*_data_q_w[q];
                const walberla::float64 q_tmp_4_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_DOWN[21*q + 19] + tmp_qloop_1*_data_mass_det_0_0_WHITE_DOWN[21*q + 19])*_data_q_w[q];
                const walberla::float64 q_tmp_5_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_WHITE_DOWN[21*q + 20] + tmp_qloop_1*_data_mass_det_0_0_WHITE_DOWN[21*q + 20])*_data_q_w[q];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
             }
             const walberla::float64 elMat_0_0 = q_acc_0_0;
             const walberla::float64 elMat_0_1 = q_acc_0_1;
             const walberla::float64 elMat_0_2 = q_acc_0_2;
             const walberla::float64 elMat_0_3 = q_acc_0_3;
             const walberla::float64 elMat_0_4 = q_acc_0_4;
             const walberla::float64 elMat_0_5 = q_acc_0_5;
             const walberla::float64 elMat_1_0 = q_acc_0_1;
             const walberla::float64 elMat_1_1 = q_acc_1_1;
             const walberla::float64 elMat_1_2 = q_acc_1_2;
             const walberla::float64 elMat_1_3 = q_acc_1_3;
             const walberla::float64 elMat_1_4 = q_acc_1_4;
             const walberla::float64 elMat_1_5 = q_acc_1_5;
             const walberla::float64 elMat_2_0 = q_acc_0_2;
             const walberla::float64 elMat_2_1 = q_acc_1_2;
             const walberla::float64 elMat_2_2 = q_acc_2_2;
             const walberla::float64 elMat_2_3 = q_acc_2_3;
             const walberla::float64 elMat_2_4 = q_acc_2_4;
             const walberla::float64 elMat_2_5 = q_acc_2_5;
             const walberla::float64 elMat_3_0 = q_acc_0_3;
             const walberla::float64 elMat_3_1 = q_acc_1_3;
             const walberla::float64 elMat_3_2 = q_acc_2_3;
             const walberla::float64 elMat_3_3 = q_acc_3_3;
             const walberla::float64 elMat_3_4 = q_acc_3_4;
             const walberla::float64 elMat_3_5 = q_acc_3_5;
             const walberla::float64 elMat_4_0 = q_acc_0_4;
             const walberla::float64 elMat_4_1 = q_acc_1_4;
             const walberla::float64 elMat_4_2 = q_acc_2_4;
             const walberla::float64 elMat_4_3 = q_acc_3_4;
             const walberla::float64 elMat_4_4 = q_acc_4_4;
             const walberla::float64 elMat_4_5 = q_acc_4_5;
             const walberla::float64 elMat_5_0 = q_acc_0_5;
             const walberla::float64 elMat_5_1 = q_acc_1_5;
             const walberla::float64 elMat_5_2 = q_acc_2_5;
             const walberla::float64 elMat_5_3 = q_acc_3_5;
             const walberla::float64 elMat_5_4 = q_acc_4_5;
             const walberla::float64 elMat_5_5 = q_acc_5_5;
         
             std::vector< uint_t > _data_rowIdx( 6 );
             std::vector< uint_t > _data_colIdx( 6 );
             std::vector< walberla::float64 > _data_mat( 36 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[1] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]));
             _data_rowIdx[2] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[3] = ((uint64_t)(_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[4] = ((uint64_t)(_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[0] = ((uint64_t)(_data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[1] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]));
             _data_colIdx[2] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[3] = ((uint64_t)(_data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[4] = ((uint64_t)(_data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[5] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
         
             /* Apply basis transformation */
         
             const Eigen::DiagonalMatrix< real_t, 6 > basisTransformation = n1e1::macrocell::basisTransformation( level, cell, {ctr_0, ctr_1, ctr_2}, celldof::CellType::WHITE_DOWN );
         
             _data_mat[0] = ((walberla::float64)((basisTransformation.diagonal()(0)*basisTransformation.diagonal()(0))*elMat_0_0));
             _data_mat[1] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(1)*elMat_0_1));
             _data_mat[2] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(2)*elMat_0_2));
             _data_mat[3] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(3)*elMat_0_3));
             _data_mat[4] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(4)*elMat_0_4));
             _data_mat[5] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(5)*elMat_0_5));
             _data_mat[6] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(1)*elMat_1_0));
             _data_mat[7] = ((walberla::float64)((basisTransformation.diagonal()(1)*basisTransformation.diagonal()(1))*elMat_1_1));
             _data_mat[8] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(2)*elMat_1_2));
             _data_mat[9] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(3)*elMat_1_3));
             _data_mat[10] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(4)*elMat_1_4));
             _data_mat[11] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(5)*elMat_1_5));
             _data_mat[12] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(2)*elMat_2_0));
             _data_mat[13] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(2)*elMat_2_1));
             _data_mat[14] = ((walberla::float64)((basisTransformation.diagonal()(2)*basisTransformation.diagonal()(2))*elMat_2_2));
             _data_mat[15] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(3)*elMat_2_3));
             _data_mat[16] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(4)*elMat_2_4));
             _data_mat[17] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(5)*elMat_2_5));
             _data_mat[18] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(3)*elMat_3_0));
             _data_mat[19] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(3)*elMat_3_1));
             _data_mat[20] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(3)*elMat_3_2));
             _data_mat[21] = ((walberla::float64)((basisTransformation.diagonal()(3)*basisTransformation.diagonal()(3))*elMat_3_3));
             _data_mat[22] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(4)*elMat_3_4));
             _data_mat[23] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(5)*elMat_3_5));
             _data_mat[24] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(4)*elMat_4_0));
             _data_mat[25] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(4)*elMat_4_1));
             _data_mat[26] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(4)*elMat_4_2));
             _data_mat[27] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(4)*elMat_4_3));
             _data_mat[28] = ((walberla::float64)((basisTransformation.diagonal()(4)*basisTransformation.diagonal()(4))*elMat_4_4));
             _data_mat[29] = ((walberla::float64)(basisTransformation.diagonal()(4)*basisTransformation.diagonal()(5)*elMat_4_5));
             _data_mat[30] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(5)*elMat_5_0));
             _data_mat[31] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(5)*elMat_5_1));
             _data_mat[32] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(5)*elMat_5_2));
             _data_mat[33] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(5)*elMat_5_3));
             _data_mat[34] = ((walberla::float64)(basisTransformation.diagonal()(4)*basisTransformation.diagonal()(5)*elMat_5_4));
             _data_mat[35] = ((walberla::float64)((basisTransformation.diagonal()(5)*basisTransformation.diagonal()(5))*elMat_5_5));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const walberla::float64 tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const walberla::float64 tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const walberla::float64 tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const walberla::float64 tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const walberla::float64 tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const walberla::float64 tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const walberla::float64 tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const walberla::float64 p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const walberla::float64 p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const walberla::float64 p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const walberla::float64 p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const walberla::float64 p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const walberla::float64 p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const walberla::float64 p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const walberla::float64 p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const walberla::float64 p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const walberla::float64 p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const walberla::float64 p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const walberla::float64 p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const walberla::float64 jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const walberla::float64 jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const walberla::float64 jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const walberla::float64 jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const walberla::float64 jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const walberla::float64 tmp_coords_jac_11_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const walberla::float64 jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const walberla::float64 tmp_coords_jac_9_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const walberla::float64 jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const walberla::float64 jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const walberla::float64 tmp_coords_jac_8_BLUE_UP = jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP;
       const walberla::float64 jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const walberla::float64 tmp_coords_jac_7_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const walberla::float64 tmp_coords_jac_10_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const walberla::float64 tmp_coords_jac_12_BLUE_UP = jac_affine_0_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_0_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_0_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
       const walberla::float64 tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const walberla::float64 jac_affine_inv_0_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
       const walberla::float64 jac_affine_inv_0_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_2_1_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const walberla::float64 jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const walberla::float64 jac_affine_inv_1_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const walberla::float64 jac_affine_inv_1_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const walberla::float64 jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const walberla::float64 jac_affine_inv_2_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const walberla::float64 jac_affine_inv_2_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const walberla::float64 jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const walberla::float64 abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       {
          /* CellType.BLUE_UP */
          const walberla::float64 _data_phi_0_0_BLUE_UP [] = {0.12366680032845842, 0.82157254096761978, 0.039933048641498423, 0.01482761006242336, 0.45746158708559548, 0.15593312049918601, 0.3817653560693467, 0.0048399363458717648, 0.36531451881463445, 0.18002969351036541, 0.0069232355736274674, 0.44773255210137269, 0.00037551502872928966, 0.21607642918484779, 0.43070170707783612, 0.35284634870858678};
      
          const walberla::float64 _data_curl_curl_det_0_0_BLUE_UP [] = {1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_0_BLUE_UP*jac_affine_0_0_BLUE_UP)*4.0 + (jac_affine_1_0_BLUE_UP*jac_affine_1_0_BLUE_UP)*4.0 + (jac_affine_2_0_BLUE_UP*jac_affine_2_0_BLUE_UP)*4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_0_BLUE_UP*jac_affine_0_1_BLUE_UP*-4.0 + jac_affine_1_0_BLUE_UP*jac_affine_1_1_BLUE_UP*-4.0 + jac_affine_2_0_BLUE_UP*jac_affine_2_1_BLUE_UP*-4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_0_BLUE_UP*jac_affine_0_2_BLUE_UP*4.0 + jac_affine_1_0_BLUE_UP*jac_affine_1_2_BLUE_UP*4.0 + jac_affine_2_0_BLUE_UP*jac_affine_2_2_BLUE_UP*4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_0_BLUE_UP*(jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*2.0 + jac_affine_1_0_BLUE_UP*(jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*2.0 + jac_affine_2_0_BLUE_UP*(jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_0_BLUE_UP*(jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)*2.0 + jac_affine_1_0_BLUE_UP*(jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)*2.0 + jac_affine_2_0_BLUE_UP*(jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_0_BLUE_UP*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0)*2.0 + jac_affine_1_0_BLUE_UP*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0)*2.0 + jac_affine_2_0_BLUE_UP*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_1_BLUE_UP*jac_affine_0_1_BLUE_UP)*4.0 + (jac_affine_1_1_BLUE_UP*jac_affine_1_1_BLUE_UP)*4.0 + (jac_affine_2_1_BLUE_UP*jac_affine_2_1_BLUE_UP)*4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_1_BLUE_UP*jac_affine_0_2_BLUE_UP*-4.0 + jac_affine_1_1_BLUE_UP*jac_affine_1_2_BLUE_UP*-4.0 + jac_affine_2_1_BLUE_UP*jac_affine_2_2_BLUE_UP*-4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_1_BLUE_UP*(jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*-2.0 + jac_affine_1_1_BLUE_UP*(jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*-2.0 + jac_affine_2_1_BLUE_UP*(jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_1_BLUE_UP*(jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)*-2.0 + jac_affine_1_1_BLUE_UP*(jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)*-2.0 + jac_affine_2_1_BLUE_UP*(jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_1_BLUE_UP*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0)*-2.0 + jac_affine_1_1_BLUE_UP*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0)*-2.0 + jac_affine_2_1_BLUE_UP*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_2_BLUE_UP*jac_affine_0_2_BLUE_UP)*4.0 + (jac_affine_1_2_BLUE_UP*jac_affine_1_2_BLUE_UP)*4.0 + (jac_affine_2_2_BLUE_UP*jac_affine_2_2_BLUE_UP)*4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_2_BLUE_UP*(jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*2.0 + jac_affine_1_2_BLUE_UP*(jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*2.0 + jac_affine_2_2_BLUE_UP*(jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_2_BLUE_UP*(jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)*2.0 + jac_affine_1_2_BLUE_UP*(jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)*2.0 + jac_affine_2_2_BLUE_UP*(jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_2_BLUE_UP*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0)*2.0 + jac_affine_1_2_BLUE_UP*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0)*2.0 + jac_affine_2_2_BLUE_UP*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(((jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*(jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)) + ((jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*(jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)) + ((jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*(jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0))), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*(jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0) + (jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*(jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0) + (jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*(jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0) + (jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0) + (jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)), 1.0 / (abs_det_jac_affine_BLUE_UP)*(((jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)*(jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)) + ((jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)*(jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)) + ((jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)*(jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0))), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0) + (jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0) + (jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)), 1.0 / (abs_det_jac_affine_BLUE_UP)*(((jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0)*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0)) + ((jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0)*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0)) + ((jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0))), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_0_BLUE_UP*jac_affine_0_0_BLUE_UP)*4.0 + (jac_affine_1_0_BLUE_UP*jac_affine_1_0_BLUE_UP)*4.0 + (jac_affine_2_0_BLUE_UP*jac_affine_2_0_BLUE_UP)*4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_0_BLUE_UP*jac_affine_0_1_BLUE_UP*-4.0 + jac_affine_1_0_BLUE_UP*jac_affine_1_1_BLUE_UP*-4.0 + jac_affine_2_0_BLUE_UP*jac_affine_2_1_BLUE_UP*-4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_0_BLUE_UP*jac_affine_0_2_BLUE_UP*4.0 + jac_affine_1_0_BLUE_UP*jac_affine_1_2_BLUE_UP*4.0 + jac_affine_2_0_BLUE_UP*jac_affine_2_2_BLUE_UP*4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_0_BLUE_UP*(jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*2.0 + jac_affine_1_0_BLUE_UP*(jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*2.0 + jac_affine_2_0_BLUE_UP*(jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_0_BLUE_UP*(jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)*2.0 + jac_affine_1_0_BLUE_UP*(jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)*2.0 + jac_affine_2_0_BLUE_UP*(jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_0_BLUE_UP*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0)*2.0 + jac_affine_1_0_BLUE_UP*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0)*2.0 + jac_affine_2_0_BLUE_UP*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_1_BLUE_UP*jac_affine_0_1_BLUE_UP)*4.0 + (jac_affine_1_1_BLUE_UP*jac_affine_1_1_BLUE_UP)*4.0 + (jac_affine_2_1_BLUE_UP*jac_affine_2_1_BLUE_UP)*4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_1_BLUE_UP*jac_affine_0_2_BLUE_UP*-4.0 + jac_affine_1_1_BLUE_UP*jac_affine_1_2_BLUE_UP*-4.0 + jac_affine_2_1_BLUE_UP*jac_affine_2_2_BLUE_UP*-4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_1_BLUE_UP*(jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*-2.0 + jac_affine_1_1_BLUE_UP*(jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*-2.0 + jac_affine_2_1_BLUE_UP*(jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_1_BLUE_UP*(jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)*-2.0 + jac_affine_1_1_BLUE_UP*(jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)*-2.0 + jac_affine_2_1_BLUE_UP*(jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_1_BLUE_UP*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0)*-2.0 + jac_affine_1_1_BLUE_UP*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0)*-2.0 + jac_affine_2_1_BLUE_UP*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_2_BLUE_UP*jac_affine_0_2_BLUE_UP)*4.0 + (jac_affine_1_2_BLUE_UP*jac_affine_1_2_BLUE_UP)*4.0 + (jac_affine_2_2_BLUE_UP*jac_affine_2_2_BLUE_UP)*4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_2_BLUE_UP*(jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*2.0 + jac_affine_1_2_BLUE_UP*(jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*2.0 + jac_affine_2_2_BLUE_UP*(jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_2_BLUE_UP*(jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)*2.0 + jac_affine_1_2_BLUE_UP*(jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)*2.0 + jac_affine_2_2_BLUE_UP*(jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_2_BLUE_UP*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0)*2.0 + jac_affine_1_2_BLUE_UP*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0)*2.0 + jac_affine_2_2_BLUE_UP*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(((jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*(jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)) + ((jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*(jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)) + ((jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*(jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0))), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*(jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0) + (jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*(jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0) + (jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*(jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0) + (jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0) + (jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)), 1.0 / (abs_det_jac_affine_BLUE_UP)*(((jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)*(jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)) + ((jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)*(jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)) + ((jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)*(jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0))), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0) + (jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0) + (jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)), 1.0 / (abs_det_jac_affine_BLUE_UP)*(((jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0)*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0)) + ((jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0)*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0)) + ((jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0))), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_0_BLUE_UP*jac_affine_0_0_BLUE_UP)*4.0 + (jac_affine_1_0_BLUE_UP*jac_affine_1_0_BLUE_UP)*4.0 + (jac_affine_2_0_BLUE_UP*jac_affine_2_0_BLUE_UP)*4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_0_BLUE_UP*jac_affine_0_1_BLUE_UP*-4.0 + jac_affine_1_0_BLUE_UP*jac_affine_1_1_BLUE_UP*-4.0 + jac_affine_2_0_BLUE_UP*jac_affine_2_1_BLUE_UP*-4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_0_BLUE_UP*jac_affine_0_2_BLUE_UP*4.0 + jac_affine_1_0_BLUE_UP*jac_affine_1_2_BLUE_UP*4.0 + jac_affine_2_0_BLUE_UP*jac_affine_2_2_BLUE_UP*4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_0_BLUE_UP*(jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*2.0 + jac_affine_1_0_BLUE_UP*(jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*2.0 + jac_affine_2_0_BLUE_UP*(jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_0_BLUE_UP*(jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)*2.0 + jac_affine_1_0_BLUE_UP*(jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)*2.0 + jac_affine_2_0_BLUE_UP*(jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_0_BLUE_UP*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0)*2.0 + jac_affine_1_0_BLUE_UP*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0)*2.0 + jac_affine_2_0_BLUE_UP*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_1_BLUE_UP*jac_affine_0_1_BLUE_UP)*4.0 + (jac_affine_1_1_BLUE_UP*jac_affine_1_1_BLUE_UP)*4.0 + (jac_affine_2_1_BLUE_UP*jac_affine_2_1_BLUE_UP)*4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_1_BLUE_UP*jac_affine_0_2_BLUE_UP*-4.0 + jac_affine_1_1_BLUE_UP*jac_affine_1_2_BLUE_UP*-4.0 + jac_affine_2_1_BLUE_UP*jac_affine_2_2_BLUE_UP*-4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_1_BLUE_UP*(jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*-2.0 + jac_affine_1_1_BLUE_UP*(jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*-2.0 + jac_affine_2_1_BLUE_UP*(jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_1_BLUE_UP*(jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)*-2.0 + jac_affine_1_1_BLUE_UP*(jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)*-2.0 + jac_affine_2_1_BLUE_UP*(jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_1_BLUE_UP*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0)*-2.0 + jac_affine_1_1_BLUE_UP*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0)*-2.0 + jac_affine_2_1_BLUE_UP*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_2_BLUE_UP*jac_affine_0_2_BLUE_UP)*4.0 + (jac_affine_1_2_BLUE_UP*jac_affine_1_2_BLUE_UP)*4.0 + (jac_affine_2_2_BLUE_UP*jac_affine_2_2_BLUE_UP)*4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_2_BLUE_UP*(jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*2.0 + jac_affine_1_2_BLUE_UP*(jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*2.0 + jac_affine_2_2_BLUE_UP*(jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_2_BLUE_UP*(jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)*2.0 + jac_affine_1_2_BLUE_UP*(jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)*2.0 + jac_affine_2_2_BLUE_UP*(jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_2_BLUE_UP*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0)*2.0 + jac_affine_1_2_BLUE_UP*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0)*2.0 + jac_affine_2_2_BLUE_UP*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(((jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*(jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)) + ((jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*(jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)) + ((jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*(jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0))), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*(jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0) + (jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*(jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0) + (jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*(jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0) + (jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0) + (jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)), 1.0 / (abs_det_jac_affine_BLUE_UP)*(((jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)*(jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)) + ((jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)*(jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)) + ((jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)*(jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0))), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0) + (jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0) + (jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)), 1.0 / (abs_det_jac_affine_BLUE_UP)*(((jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0)*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0)) + ((jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0)*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0)) + ((jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0))), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_0_BLUE_UP*jac_affine_0_0_BLUE_UP)*4.0 + (jac_affine_1_0_BLUE_UP*jac_affine_1_0_BLUE_UP)*4.0 + (jac_affine_2_0_BLUE_UP*jac_affine_2_0_BLUE_UP)*4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_0_BLUE_UP*jac_affine_0_1_BLUE_UP*-4.0 + jac_affine_1_0_BLUE_UP*jac_affine_1_1_BLUE_UP*-4.0 + jac_affine_2_0_BLUE_UP*jac_affine_2_1_BLUE_UP*-4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_0_BLUE_UP*jac_affine_0_2_BLUE_UP*4.0 + jac_affine_1_0_BLUE_UP*jac_affine_1_2_BLUE_UP*4.0 + jac_affine_2_0_BLUE_UP*jac_affine_2_2_BLUE_UP*4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_0_BLUE_UP*(jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*2.0 + jac_affine_1_0_BLUE_UP*(jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*2.0 + jac_affine_2_0_BLUE_UP*(jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_0_BLUE_UP*(jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)*2.0 + jac_affine_1_0_BLUE_UP*(jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)*2.0 + jac_affine_2_0_BLUE_UP*(jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_0_BLUE_UP*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0)*2.0 + jac_affine_1_0_BLUE_UP*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0)*2.0 + jac_affine_2_0_BLUE_UP*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_1_BLUE_UP*jac_affine_0_1_BLUE_UP)*4.0 + (jac_affine_1_1_BLUE_UP*jac_affine_1_1_BLUE_UP)*4.0 + (jac_affine_2_1_BLUE_UP*jac_affine_2_1_BLUE_UP)*4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_1_BLUE_UP*jac_affine_0_2_BLUE_UP*-4.0 + jac_affine_1_1_BLUE_UP*jac_affine_1_2_BLUE_UP*-4.0 + jac_affine_2_1_BLUE_UP*jac_affine_2_2_BLUE_UP*-4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_1_BLUE_UP*(jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*-2.0 + jac_affine_1_1_BLUE_UP*(jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*-2.0 + jac_affine_2_1_BLUE_UP*(jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_1_BLUE_UP*(jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)*-2.0 + jac_affine_1_1_BLUE_UP*(jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)*-2.0 + jac_affine_2_1_BLUE_UP*(jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_1_BLUE_UP*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0)*-2.0 + jac_affine_1_1_BLUE_UP*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0)*-2.0 + jac_affine_2_1_BLUE_UP*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_2_BLUE_UP*jac_affine_0_2_BLUE_UP)*4.0 + (jac_affine_1_2_BLUE_UP*jac_affine_1_2_BLUE_UP)*4.0 + (jac_affine_2_2_BLUE_UP*jac_affine_2_2_BLUE_UP)*4.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_2_BLUE_UP*(jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*2.0 + jac_affine_1_2_BLUE_UP*(jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*2.0 + jac_affine_2_2_BLUE_UP*(jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_2_BLUE_UP*(jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)*2.0 + jac_affine_1_2_BLUE_UP*(jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)*2.0 + jac_affine_2_2_BLUE_UP*(jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(jac_affine_0_2_BLUE_UP*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0)*2.0 + jac_affine_1_2_BLUE_UP*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0)*2.0 + jac_affine_2_2_BLUE_UP*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_UP)*(((jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*(jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)) + ((jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*(jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)) + ((jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*(jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0))), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*(jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0) + (jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*(jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0) + (jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*(jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_0_BLUE_UP*-2.0 + jac_affine_0_1_BLUE_UP*2.0)*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0) + (jac_affine_1_0_BLUE_UP*-2.0 + jac_affine_1_1_BLUE_UP*2.0)*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0) + (jac_affine_2_0_BLUE_UP*-2.0 + jac_affine_2_1_BLUE_UP*2.0)*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)), 1.0 / (abs_det_jac_affine_BLUE_UP)*(((jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)*(jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)) + ((jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)*(jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)) + ((jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)*(jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0))), 1.0 / (abs_det_jac_affine_BLUE_UP)*((jac_affine_0_0_BLUE_UP*2.0 + jac_affine_0_2_BLUE_UP*-2.0)*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0) + (jac_affine_1_0_BLUE_UP*2.0 + jac_affine_1_2_BLUE_UP*-2.0)*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0) + (jac_affine_2_0_BLUE_UP*2.0 + jac_affine_2_2_BLUE_UP*-2.0)*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)), 1.0 / (abs_det_jac_affine_BLUE_UP)*(((jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0)*(jac_affine_0_1_BLUE_UP*-2.0 + jac_affine_0_2_BLUE_UP*2.0)) + ((jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0)*(jac_affine_1_1_BLUE_UP*-2.0 + jac_affine_1_2_BLUE_UP*2.0)) + ((jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)*(jac_affine_2_1_BLUE_UP*-2.0 + jac_affine_2_2_BLUE_UP*2.0)))};
      
          const walberla::float64 _data_mass_det_0_0_BLUE_UP [] = {abs_det_jac_affine_BLUE_UP*(((jac_affine_inv_1_0_BLUE_UP*-0.37131174720816351 + jac_affine_inv_2_0_BLUE_UP)*(jac_affine_inv_1_0_BLUE_UP*-0.37131174720816351 + jac_affine_inv_2_0_BLUE_UP))*0.0015946483738042789 + ((jac_affine_inv_1_1_BLUE_UP*-0.37131174720816351 + jac_affine_inv_2_1_BLUE_UP)*(jac_affine_inv_1_1_BLUE_UP*-0.37131174720816351 + jac_affine_inv_2_1_BLUE_UP))*0.0015946483738042789 + ((jac_affine_inv_1_2_BLUE_UP*-0.37131174720816351 + jac_affine_inv_2_2_BLUE_UP)*(jac_affine_inv_1_2_BLUE_UP*-0.37131174720816351 + jac_affine_inv_2_2_BLUE_UP))*0.0015946483738042789), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_0_BLUE_UP*0.82157254096761978)*(jac_affine_inv_1_0_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_0_BLUE_UP*0.039933048641498423) + (jac_affine_inv_0_1_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_1_BLUE_UP*0.82157254096761978)*(jac_affine_inv_1_1_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_1_BLUE_UP*0.039933048641498423) + (jac_affine_inv_0_2_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_2_BLUE_UP*0.82157254096761978)*(jac_affine_inv_1_2_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_2_BLUE_UP*0.039933048641498423)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.039933048641498423 + jac_affine_inv_1_0_BLUE_UP*0.82157254096761978)*(jac_affine_inv_1_0_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_0_BLUE_UP*0.039933048641498423) + (jac_affine_inv_0_1_BLUE_UP*-0.039933048641498423 + jac_affine_inv_1_1_BLUE_UP*0.82157254096761978)*(jac_affine_inv_1_1_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_1_BLUE_UP*0.039933048641498423) + (jac_affine_inv_0_2_BLUE_UP*-0.039933048641498423 + jac_affine_inv_1_2_BLUE_UP*0.82157254096761978)*(jac_affine_inv_1_2_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_2_BLUE_UP*0.039933048641498423)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_0_BLUE_UP*0.039933048641498423)*(jac_affine_inv_0_0_BLUE_UP*0.01482761006242336 + jac_affine_inv_1_0_BLUE_UP*0.01482761006242336 + jac_affine_inv_2_0_BLUE_UP*0.13849441039088178) + (jac_affine_inv_1_1_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_1_BLUE_UP*0.039933048641498423)*(jac_affine_inv_0_1_BLUE_UP*0.01482761006242336 + jac_affine_inv_1_1_BLUE_UP*0.01482761006242336 + jac_affine_inv_2_1_BLUE_UP*0.13849441039088178) + (jac_affine_inv_1_2_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_2_BLUE_UP*0.039933048641498423)*(jac_affine_inv_0_2_BLUE_UP*0.01482761006242336 + jac_affine_inv_1_2_BLUE_UP*0.01482761006242336 + jac_affine_inv_2_2_BLUE_UP*0.13849441039088178)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_0_BLUE_UP*0.039933048641498423)*(jac_affine_inv_0_0_BLUE_UP*0.039933048641498423 + jac_affine_inv_1_0_BLUE_UP*0.16359984896995686 + jac_affine_inv_2_0_BLUE_UP*0.039933048641498423) + (jac_affine_inv_1_1_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_1_BLUE_UP*0.039933048641498423)*(jac_affine_inv_0_1_BLUE_UP*0.039933048641498423 + jac_affine_inv_1_1_BLUE_UP*0.16359984896995686 + jac_affine_inv_2_1_BLUE_UP*0.039933048641498423) + (jac_affine_inv_1_2_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_2_BLUE_UP*0.039933048641498423)*(jac_affine_inv_0_2_BLUE_UP*0.039933048641498423 + jac_affine_inv_1_2_BLUE_UP*0.16359984896995686 + jac_affine_inv_2_2_BLUE_UP*0.039933048641498423)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_0_BLUE_UP*0.039933048641498423)*(jac_affine_inv_0_0_BLUE_UP*0.94523934129607823 + jac_affine_inv_1_0_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_0_BLUE_UP*0.82157254096761978) + (jac_affine_inv_1_1_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_1_BLUE_UP*0.039933048641498423)*(jac_affine_inv_0_1_BLUE_UP*0.94523934129607823 + jac_affine_inv_1_1_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_1_BLUE_UP*0.82157254096761978) + (jac_affine_inv_1_2_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_2_BLUE_UP*0.039933048641498423)*(jac_affine_inv_0_2_BLUE_UP*0.94523934129607823 + jac_affine_inv_1_2_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_2_BLUE_UP*0.82157254096761978)), abs_det_jac_affine_BLUE_UP*(((jac_affine_inv_0_0_BLUE_UP*-0.018047840358637001 + jac_affine_inv_2_0_BLUE_UP)*(jac_affine_inv_0_0_BLUE_UP*-0.018047840358637001 + jac_affine_inv_2_0_BLUE_UP))*0.67498144007199123 + ((jac_affine_inv_0_1_BLUE_UP*-0.018047840358637001 + jac_affine_inv_2_1_BLUE_UP)*(jac_affine_inv_0_1_BLUE_UP*-0.018047840358637001 + jac_affine_inv_2_1_BLUE_UP))*0.67498144007199123 + ((jac_affine_inv_0_2_BLUE_UP*-0.018047840358637001 + jac_affine_inv_2_2_BLUE_UP)*(jac_affine_inv_0_2_BLUE_UP*-0.018047840358637001 + jac_affine_inv_2_2_BLUE_UP))*0.67498144007199123), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_0_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_0_BLUE_UP*-0.039933048641498423 + jac_affine_inv_1_0_BLUE_UP*0.82157254096761978) + (jac_affine_inv_0_1_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_1_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_1_BLUE_UP*-0.039933048641498423 + jac_affine_inv_1_1_BLUE_UP*0.82157254096761978) + (jac_affine_inv_0_2_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_2_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_2_BLUE_UP*-0.039933048641498423 + jac_affine_inv_1_2_BLUE_UP*0.82157254096761978)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_0_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_0_BLUE_UP*0.01482761006242336 + jac_affine_inv_1_0_BLUE_UP*0.01482761006242336 + jac_affine_inv_2_0_BLUE_UP*0.13849441039088178) + (jac_affine_inv_0_1_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_1_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_1_BLUE_UP*0.01482761006242336 + jac_affine_inv_1_1_BLUE_UP*0.01482761006242336 + jac_affine_inv_2_1_BLUE_UP*0.13849441039088178) + (jac_affine_inv_0_2_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_2_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_2_BLUE_UP*0.01482761006242336 + jac_affine_inv_1_2_BLUE_UP*0.01482761006242336 + jac_affine_inv_2_2_BLUE_UP*0.13849441039088178)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_0_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_0_BLUE_UP*0.039933048641498423 + jac_affine_inv_1_0_BLUE_UP*0.16359984896995686 + jac_affine_inv_2_0_BLUE_UP*0.039933048641498423) + (jac_affine_inv_0_1_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_1_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_1_BLUE_UP*0.039933048641498423 + jac_affine_inv_1_1_BLUE_UP*0.16359984896995686 + jac_affine_inv_2_1_BLUE_UP*0.039933048641498423) + (jac_affine_inv_0_2_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_2_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_2_BLUE_UP*0.039933048641498423 + jac_affine_inv_1_2_BLUE_UP*0.16359984896995686 + jac_affine_inv_2_2_BLUE_UP*0.039933048641498423)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_0_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_0_BLUE_UP*0.94523934129607823 + jac_affine_inv_1_0_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_0_BLUE_UP*0.82157254096761978) + (jac_affine_inv_0_1_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_1_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_1_BLUE_UP*0.94523934129607823 + jac_affine_inv_1_1_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_1_BLUE_UP*0.82157254096761978) + (jac_affine_inv_0_2_BLUE_UP*-0.01482761006242336 + jac_affine_inv_2_2_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_2_BLUE_UP*0.94523934129607823 + jac_affine_inv_1_2_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_2_BLUE_UP*0.82157254096761978)), abs_det_jac_affine_BLUE_UP*(((jac_affine_inv_0_0_BLUE_UP*-0.048605627196920013 + jac_affine_inv_1_0_BLUE_UP)*(jac_affine_inv_0_0_BLUE_UP*-0.048605627196920013 + jac_affine_inv_1_0_BLUE_UP))*0.67498144007199123 + ((jac_affine_inv_0_1_BLUE_UP*-0.048605627196920013 + jac_affine_inv_1_1_BLUE_UP)*(jac_affine_inv_0_1_BLUE_UP*-0.048605627196920013 + jac_affine_inv_1_1_BLUE_UP))*0.67498144007199123 + ((jac_affine_inv_0_2_BLUE_UP*-0.048605627196920013 + jac_affine_inv_1_2_BLUE_UP)*(jac_affine_inv_0_2_BLUE_UP*-0.048605627196920013 + jac_affine_inv_1_2_BLUE_UP))*0.67498144007199123), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.039933048641498423 + jac_affine_inv_1_0_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_0_BLUE_UP*0.01482761006242336 + jac_affine_inv_1_0_BLUE_UP*0.01482761006242336 + jac_affine_inv_2_0_BLUE_UP*0.13849441039088178) + (jac_affine_inv_0_1_BLUE_UP*-0.039933048641498423 + jac_affine_inv_1_1_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_1_BLUE_UP*0.01482761006242336 + jac_affine_inv_1_1_BLUE_UP*0.01482761006242336 + jac_affine_inv_2_1_BLUE_UP*0.13849441039088178) + (jac_affine_inv_0_2_BLUE_UP*-0.039933048641498423 + jac_affine_inv_1_2_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_2_BLUE_UP*0.01482761006242336 + jac_affine_inv_1_2_BLUE_UP*0.01482761006242336 + jac_affine_inv_2_2_BLUE_UP*0.13849441039088178)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.039933048641498423 + jac_affine_inv_1_0_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_0_BLUE_UP*0.039933048641498423 + jac_affine_inv_1_0_BLUE_UP*0.16359984896995686 + jac_affine_inv_2_0_BLUE_UP*0.039933048641498423) + (jac_affine_inv_0_1_BLUE_UP*-0.039933048641498423 + jac_affine_inv_1_1_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_1_BLUE_UP*0.039933048641498423 + jac_affine_inv_1_1_BLUE_UP*0.16359984896995686 + jac_affine_inv_2_1_BLUE_UP*0.039933048641498423) + (jac_affine_inv_0_2_BLUE_UP*-0.039933048641498423 + jac_affine_inv_1_2_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_2_BLUE_UP*0.039933048641498423 + jac_affine_inv_1_2_BLUE_UP*0.16359984896995686 + jac_affine_inv_2_2_BLUE_UP*0.039933048641498423)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.039933048641498423 + jac_affine_inv_1_0_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_0_BLUE_UP*0.94523934129607823 + jac_affine_inv_1_0_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_0_BLUE_UP*0.82157254096761978) + (jac_affine_inv_0_1_BLUE_UP*-0.039933048641498423 + jac_affine_inv_1_1_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_1_BLUE_UP*0.94523934129607823 + jac_affine_inv_1_1_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_1_BLUE_UP*0.82157254096761978) + (jac_affine_inv_0_2_BLUE_UP*-0.039933048641498423 + jac_affine_inv_1_2_BLUE_UP*0.82157254096761978)*(jac_affine_inv_0_2_BLUE_UP*0.94523934129607823 + jac_affine_inv_1_2_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_2_BLUE_UP*0.82157254096761978)), abs_det_jac_affine_BLUE_UP*(((jac_affine_inv_0_0_BLUE_UP*0.10706287727117962 + jac_affine_inv_1_0_BLUE_UP*0.10706287727117962 + jac_affine_inv_2_0_BLUE_UP)*(jac_affine_inv_0_0_BLUE_UP*0.10706287727117962 + jac_affine_inv_1_0_BLUE_UP*0.10706287727117962 + jac_affine_inv_2_0_BLUE_UP))*0.019180701709517984 + ((jac_affine_inv_0_1_BLUE_UP*0.10706287727117962 + jac_affine_inv_1_1_BLUE_UP*0.10706287727117962 + jac_affine_inv_2_1_BLUE_UP)*(jac_affine_inv_0_1_BLUE_UP*0.10706287727117962 + jac_affine_inv_1_1_BLUE_UP*0.10706287727117962 + jac_affine_inv_2_1_BLUE_UP))*0.019180701709517984 + ((jac_affine_inv_0_2_BLUE_UP*0.10706287727117962 + jac_affine_inv_1_2_BLUE_UP*0.10706287727117962 + jac_affine_inv_2_2_BLUE_UP)*(jac_affine_inv_0_2_BLUE_UP*0.10706287727117962 + jac_affine_inv_1_2_BLUE_UP*0.10706287727117962 + jac_affine_inv_2_2_BLUE_UP))*0.019180701709517984), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.01482761006242336 + jac_affine_inv_1_0_BLUE_UP*0.01482761006242336 + jac_affine_inv_2_0_BLUE_UP*0.13849441039088178)*(jac_affine_inv_0_0_BLUE_UP*0.039933048641498423 + jac_affine_inv_1_0_BLUE_UP*0.16359984896995686 + jac_affine_inv_2_0_BLUE_UP*0.039933048641498423) + (jac_affine_inv_0_1_BLUE_UP*0.01482761006242336 + jac_affine_inv_1_1_BLUE_UP*0.01482761006242336 + jac_affine_inv_2_1_BLUE_UP*0.13849441039088178)*(jac_affine_inv_0_1_BLUE_UP*0.039933048641498423 + jac_affine_inv_1_1_BLUE_UP*0.16359984896995686 + jac_affine_inv_2_1_BLUE_UP*0.039933048641498423) + (jac_affine_inv_0_2_BLUE_UP*0.01482761006242336 + jac_affine_inv_1_2_BLUE_UP*0.01482761006242336 + jac_affine_inv_2_2_BLUE_UP*0.13849441039088178)*(jac_affine_inv_0_2_BLUE_UP*0.039933048641498423 + jac_affine_inv_1_2_BLUE_UP*0.16359984896995686 + jac_affine_inv_2_2_BLUE_UP*0.039933048641498423)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.01482761006242336 + jac_affine_inv_1_0_BLUE_UP*0.01482761006242336 + jac_affine_inv_2_0_BLUE_UP*0.13849441039088178)*(jac_affine_inv_0_0_BLUE_UP*0.94523934129607823 + jac_affine_inv_1_0_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_0_BLUE_UP*0.82157254096761978) + (jac_affine_inv_0_1_BLUE_UP*0.01482761006242336 + jac_affine_inv_1_1_BLUE_UP*0.01482761006242336 + jac_affine_inv_2_1_BLUE_UP*0.13849441039088178)*(jac_affine_inv_0_1_BLUE_UP*0.94523934129607823 + jac_affine_inv_1_1_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_1_BLUE_UP*0.82157254096761978) + (jac_affine_inv_0_2_BLUE_UP*0.01482761006242336 + jac_affine_inv_1_2_BLUE_UP*0.01482761006242336 + jac_affine_inv_2_2_BLUE_UP*0.13849441039088178)*(jac_affine_inv_0_2_BLUE_UP*0.94523934129607823 + jac_affine_inv_1_2_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_2_BLUE_UP*0.82157254096761978)), abs_det_jac_affine_BLUE_UP*(((jac_affine_inv_0_0_BLUE_UP*0.2440897647089616 + jac_affine_inv_1_0_BLUE_UP + jac_affine_inv_2_0_BLUE_UP*0.2440897647089616)*(jac_affine_inv_0_0_BLUE_UP*0.2440897647089616 + jac_affine_inv_1_0_BLUE_UP + jac_affine_inv_2_0_BLUE_UP*0.2440897647089616))*0.026764910582992695 + ((jac_affine_inv_0_1_BLUE_UP*0.2440897647089616 + jac_affine_inv_1_1_BLUE_UP + jac_affine_inv_2_1_BLUE_UP*0.2440897647089616)*(jac_affine_inv_0_1_BLUE_UP*0.2440897647089616 + jac_affine_inv_1_1_BLUE_UP + jac_affine_inv_2_1_BLUE_UP*0.2440897647089616))*0.026764910582992695 + ((jac_affine_inv_0_2_BLUE_UP*0.2440897647089616 + jac_affine_inv_1_2_BLUE_UP + jac_affine_inv_2_2_BLUE_UP*0.2440897647089616)*(jac_affine_inv_0_2_BLUE_UP*0.2440897647089616 + jac_affine_inv_1_2_BLUE_UP + jac_affine_inv_2_2_BLUE_UP*0.2440897647089616))*0.026764910582992695), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.039933048641498423 + jac_affine_inv_1_0_BLUE_UP*0.16359984896995686 + jac_affine_inv_2_0_BLUE_UP*0.039933048641498423)*(jac_affine_inv_0_0_BLUE_UP*0.94523934129607823 + jac_affine_inv_1_0_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_0_BLUE_UP*0.82157254096761978) + (jac_affine_inv_0_1_BLUE_UP*0.039933048641498423 + jac_affine_inv_1_1_BLUE_UP*0.16359984896995686 + jac_affine_inv_2_1_BLUE_UP*0.039933048641498423)*(jac_affine_inv_0_1_BLUE_UP*0.94523934129607823 + jac_affine_inv_1_1_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_1_BLUE_UP*0.82157254096761978) + (jac_affine_inv_0_2_BLUE_UP*0.039933048641498423 + jac_affine_inv_1_2_BLUE_UP*0.16359984896995686 + jac_affine_inv_2_2_BLUE_UP*0.039933048641498423)*(jac_affine_inv_0_2_BLUE_UP*0.94523934129607823 + jac_affine_inv_1_2_BLUE_UP*0.82157254096761978 + jac_affine_inv_2_2_BLUE_UP*0.82157254096761978)), abs_det_jac_affine_BLUE_UP*(((jac_affine_inv_0_0_BLUE_UP + jac_affine_inv_1_0_BLUE_UP*0.86916879680558901 + jac_affine_inv_2_0_BLUE_UP*0.86916879680558901)*(jac_affine_inv_0_0_BLUE_UP + jac_affine_inv_1_0_BLUE_UP*0.86916879680558901 + jac_affine_inv_2_0_BLUE_UP*0.86916879680558901))*0.89347741233384381 + ((jac_affine_inv_0_1_BLUE_UP + jac_affine_inv_1_1_BLUE_UP*0.86916879680558901 + jac_affine_inv_2_1_BLUE_UP*0.86916879680558901)*(jac_affine_inv_0_1_BLUE_UP + jac_affine_inv_1_1_BLUE_UP*0.86916879680558901 + jac_affine_inv_2_1_BLUE_UP*0.86916879680558901))*0.89347741233384381 + ((jac_affine_inv_0_2_BLUE_UP + jac_affine_inv_1_2_BLUE_UP*0.86916879680558901 + jac_affine_inv_2_2_BLUE_UP*0.86916879680558901)*(jac_affine_inv_0_2_BLUE_UP + jac_affine_inv_1_2_BLUE_UP*0.86916879680558901 + jac_affine_inv_2_2_BLUE_UP*0.86916879680558901))*0.89347741233384381), abs_det_jac_affine_BLUE_UP*(((jac_affine_inv_1_0_BLUE_UP*-0.012677777773509136 + jac_affine_inv_2_0_BLUE_UP)*(jac_affine_inv_1_0_BLUE_UP*-0.012677777773509136 + jac_affine_inv_2_0_BLUE_UP))*0.14574478709475508 + ((jac_affine_inv_1_1_BLUE_UP*-0.012677777773509136 + jac_affine_inv_2_1_BLUE_UP)*(jac_affine_inv_1_1_BLUE_UP*-0.012677777773509136 + jac_affine_inv_2_1_BLUE_UP))*0.14574478709475508 + ((jac_affine_inv_1_2_BLUE_UP*-0.012677777773509136 + jac_affine_inv_2_2_BLUE_UP)*(jac_affine_inv_1_2_BLUE_UP*-0.012677777773509136 + jac_affine_inv_2_2_BLUE_UP))*0.14574478709475508), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_0_BLUE_UP*0.15593312049918601)*(jac_affine_inv_1_0_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_0_BLUE_UP*0.3817653560693467) + (jac_affine_inv_0_1_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_1_BLUE_UP*0.15593312049918601)*(jac_affine_inv_1_1_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_1_BLUE_UP*0.3817653560693467) + (jac_affine_inv_0_2_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_2_BLUE_UP*0.15593312049918601)*(jac_affine_inv_1_2_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_2_BLUE_UP*0.3817653560693467)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.3817653560693467 + jac_affine_inv_1_0_BLUE_UP*0.15593312049918601)*(jac_affine_inv_1_0_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_0_BLUE_UP*0.3817653560693467) + (jac_affine_inv_0_1_BLUE_UP*-0.3817653560693467 + jac_affine_inv_1_1_BLUE_UP*0.15593312049918601)*(jac_affine_inv_1_1_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_1_BLUE_UP*0.3817653560693467) + (jac_affine_inv_0_2_BLUE_UP*-0.3817653560693467 + jac_affine_inv_1_2_BLUE_UP*0.15593312049918601)*(jac_affine_inv_1_2_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_2_BLUE_UP*0.3817653560693467)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_0_BLUE_UP*0.3817653560693467)*(jac_affine_inv_0_0_BLUE_UP*0.0048399363458717648 + jac_affine_inv_1_0_BLUE_UP*0.0048399363458717648 + jac_affine_inv_2_0_BLUE_UP*0.46230152343146724) + (jac_affine_inv_1_1_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_1_BLUE_UP*0.3817653560693467)*(jac_affine_inv_0_1_BLUE_UP*0.0048399363458717648 + jac_affine_inv_1_1_BLUE_UP*0.0048399363458717648 + jac_affine_inv_2_1_BLUE_UP*0.46230152343146724) + (jac_affine_inv_1_2_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_2_BLUE_UP*0.3817653560693467)*(jac_affine_inv_0_2_BLUE_UP*0.0048399363458717648 + jac_affine_inv_1_2_BLUE_UP*0.0048399363458717648 + jac_affine_inv_2_2_BLUE_UP*0.46230152343146724)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_0_BLUE_UP*0.3817653560693467)*(jac_affine_inv_0_0_BLUE_UP*0.3817653560693467 + jac_affine_inv_1_0_BLUE_UP*0.83922694315494217 + jac_affine_inv_2_0_BLUE_UP*0.3817653560693467) + (jac_affine_inv_1_1_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_1_BLUE_UP*0.3817653560693467)*(jac_affine_inv_0_1_BLUE_UP*0.3817653560693467 + jac_affine_inv_1_1_BLUE_UP*0.83922694315494217 + jac_affine_inv_2_1_BLUE_UP*0.3817653560693467) + (jac_affine_inv_1_2_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_2_BLUE_UP*0.3817653560693467)*(jac_affine_inv_0_2_BLUE_UP*0.3817653560693467 + jac_affine_inv_1_2_BLUE_UP*0.83922694315494217 + jac_affine_inv_2_2_BLUE_UP*0.3817653560693467)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_0_BLUE_UP*0.3817653560693467)*(jac_affine_inv_0_0_BLUE_UP*0.61339470758478154 + jac_affine_inv_1_0_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_0_BLUE_UP*0.15593312049918601) + (jac_affine_inv_1_1_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_1_BLUE_UP*0.3817653560693467)*(jac_affine_inv_0_1_BLUE_UP*0.61339470758478154 + jac_affine_inv_1_1_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_1_BLUE_UP*0.15593312049918601) + (jac_affine_inv_1_2_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_2_BLUE_UP*0.3817653560693467)*(jac_affine_inv_0_2_BLUE_UP*0.61339470758478154 + jac_affine_inv_1_2_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_2_BLUE_UP*0.15593312049918601)), abs_det_jac_affine_BLUE_UP*(((jac_affine_inv_0_0_BLUE_UP*-0.031038539666093771 + jac_affine_inv_2_0_BLUE_UP)*(jac_affine_inv_0_0_BLUE_UP*-0.031038539666093771 + jac_affine_inv_2_0_BLUE_UP))*0.024315138068613663 + ((jac_affine_inv_0_1_BLUE_UP*-0.031038539666093771 + jac_affine_inv_2_1_BLUE_UP)*(jac_affine_inv_0_1_BLUE_UP*-0.031038539666093771 + jac_affine_inv_2_1_BLUE_UP))*0.024315138068613663 + ((jac_affine_inv_0_2_BLUE_UP*-0.031038539666093771 + jac_affine_inv_2_2_BLUE_UP)*(jac_affine_inv_0_2_BLUE_UP*-0.031038539666093771 + jac_affine_inv_2_2_BLUE_UP))*0.024315138068613663), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_0_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_0_BLUE_UP*-0.3817653560693467 + jac_affine_inv_1_0_BLUE_UP*0.15593312049918601) + (jac_affine_inv_0_1_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_1_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_1_BLUE_UP*-0.3817653560693467 + jac_affine_inv_1_1_BLUE_UP*0.15593312049918601) + (jac_affine_inv_0_2_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_2_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_2_BLUE_UP*-0.3817653560693467 + jac_affine_inv_1_2_BLUE_UP*0.15593312049918601)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_0_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_0_BLUE_UP*0.0048399363458717648 + jac_affine_inv_1_0_BLUE_UP*0.0048399363458717648 + jac_affine_inv_2_0_BLUE_UP*0.46230152343146724) + (jac_affine_inv_0_1_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_1_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_1_BLUE_UP*0.0048399363458717648 + jac_affine_inv_1_1_BLUE_UP*0.0048399363458717648 + jac_affine_inv_2_1_BLUE_UP*0.46230152343146724) + (jac_affine_inv_0_2_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_2_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_2_BLUE_UP*0.0048399363458717648 + jac_affine_inv_1_2_BLUE_UP*0.0048399363458717648 + jac_affine_inv_2_2_BLUE_UP*0.46230152343146724)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_0_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_0_BLUE_UP*0.3817653560693467 + jac_affine_inv_1_0_BLUE_UP*0.83922694315494217 + jac_affine_inv_2_0_BLUE_UP*0.3817653560693467) + (jac_affine_inv_0_1_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_1_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_1_BLUE_UP*0.3817653560693467 + jac_affine_inv_1_1_BLUE_UP*0.83922694315494217 + jac_affine_inv_2_1_BLUE_UP*0.3817653560693467) + (jac_affine_inv_0_2_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_2_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_2_BLUE_UP*0.3817653560693467 + jac_affine_inv_1_2_BLUE_UP*0.83922694315494217 + jac_affine_inv_2_2_BLUE_UP*0.3817653560693467)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_0_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_0_BLUE_UP*0.61339470758478154 + jac_affine_inv_1_0_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_0_BLUE_UP*0.15593312049918601) + (jac_affine_inv_0_1_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_1_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_1_BLUE_UP*0.61339470758478154 + jac_affine_inv_1_1_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_1_BLUE_UP*0.15593312049918601) + (jac_affine_inv_0_2_BLUE_UP*-0.0048399363458717648 + jac_affine_inv_2_2_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_2_BLUE_UP*0.61339470758478154 + jac_affine_inv_1_2_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_2_BLUE_UP*0.15593312049918601)), abs_det_jac_affine_BLUE_UP*(((-jac_affine_inv_0_0_BLUE_UP + jac_affine_inv_1_0_BLUE_UP*0.40845277870331731)*(-jac_affine_inv_0_0_BLUE_UP + jac_affine_inv_1_0_BLUE_UP*0.40845277870331731))*0.14574478709475508 + ((-jac_affine_inv_0_1_BLUE_UP + jac_affine_inv_1_1_BLUE_UP*0.40845277870331731)*(-jac_affine_inv_0_1_BLUE_UP + jac_affine_inv_1_1_BLUE_UP*0.40845277870331731))*0.14574478709475508 + ((-jac_affine_inv_0_2_BLUE_UP + jac_affine_inv_1_2_BLUE_UP*0.40845277870331731)*(-jac_affine_inv_0_2_BLUE_UP + jac_affine_inv_1_2_BLUE_UP*0.40845277870331731))*0.14574478709475508), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.3817653560693467 + jac_affine_inv_1_0_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_0_BLUE_UP*0.0048399363458717648 + jac_affine_inv_1_0_BLUE_UP*0.0048399363458717648 + jac_affine_inv_2_0_BLUE_UP*0.46230152343146724) + (jac_affine_inv_0_1_BLUE_UP*-0.3817653560693467 + jac_affine_inv_1_1_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_1_BLUE_UP*0.0048399363458717648 + jac_affine_inv_1_1_BLUE_UP*0.0048399363458717648 + jac_affine_inv_2_1_BLUE_UP*0.46230152343146724) + (jac_affine_inv_0_2_BLUE_UP*-0.3817653560693467 + jac_affine_inv_1_2_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_2_BLUE_UP*0.0048399363458717648 + jac_affine_inv_1_2_BLUE_UP*0.0048399363458717648 + jac_affine_inv_2_2_BLUE_UP*0.46230152343146724)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.3817653560693467 + jac_affine_inv_1_0_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_0_BLUE_UP*0.3817653560693467 + jac_affine_inv_1_0_BLUE_UP*0.83922694315494217 + jac_affine_inv_2_0_BLUE_UP*0.3817653560693467) + (jac_affine_inv_0_1_BLUE_UP*-0.3817653560693467 + jac_affine_inv_1_1_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_1_BLUE_UP*0.3817653560693467 + jac_affine_inv_1_1_BLUE_UP*0.83922694315494217 + jac_affine_inv_2_1_BLUE_UP*0.3817653560693467) + (jac_affine_inv_0_2_BLUE_UP*-0.3817653560693467 + jac_affine_inv_1_2_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_2_BLUE_UP*0.3817653560693467 + jac_affine_inv_1_2_BLUE_UP*0.83922694315494217 + jac_affine_inv_2_2_BLUE_UP*0.3817653560693467)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.3817653560693467 + jac_affine_inv_1_0_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_0_BLUE_UP*0.61339470758478154 + jac_affine_inv_1_0_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_0_BLUE_UP*0.15593312049918601) + (jac_affine_inv_0_1_BLUE_UP*-0.3817653560693467 + jac_affine_inv_1_1_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_1_BLUE_UP*0.61339470758478154 + jac_affine_inv_1_1_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_1_BLUE_UP*0.15593312049918601) + (jac_affine_inv_0_2_BLUE_UP*-0.3817653560693467 + jac_affine_inv_1_2_BLUE_UP*0.15593312049918601)*(jac_affine_inv_0_2_BLUE_UP*0.61339470758478154 + jac_affine_inv_1_2_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_2_BLUE_UP*0.15593312049918601)), abs_det_jac_affine_BLUE_UP*(((jac_affine_inv_0_0_BLUE_UP*0.010469219979953731 + jac_affine_inv_1_0_BLUE_UP*0.010469219979953731 + jac_affine_inv_2_0_BLUE_UP)*(jac_affine_inv_0_0_BLUE_UP*0.010469219979953731 + jac_affine_inv_1_0_BLUE_UP*0.010469219979953731 + jac_affine_inv_2_0_BLUE_UP))*0.21372269856705545 + ((jac_affine_inv_0_1_BLUE_UP*0.010469219979953731 + jac_affine_inv_1_1_BLUE_UP*0.010469219979953731 + jac_affine_inv_2_1_BLUE_UP)*(jac_affine_inv_0_1_BLUE_UP*0.010469219979953731 + jac_affine_inv_1_1_BLUE_UP*0.010469219979953731 + jac_affine_inv_2_1_BLUE_UP))*0.21372269856705545 + ((jac_affine_inv_0_2_BLUE_UP*0.010469219979953731 + jac_affine_inv_1_2_BLUE_UP*0.010469219979953731 + jac_affine_inv_2_2_BLUE_UP)*(jac_affine_inv_0_2_BLUE_UP*0.010469219979953731 + jac_affine_inv_1_2_BLUE_UP*0.010469219979953731 + jac_affine_inv_2_2_BLUE_UP))*0.21372269856705545), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.0048399363458717648 + jac_affine_inv_1_0_BLUE_UP*0.0048399363458717648 + jac_affine_inv_2_0_BLUE_UP*0.46230152343146724)*(jac_affine_inv_0_0_BLUE_UP*0.3817653560693467 + jac_affine_inv_1_0_BLUE_UP*0.83922694315494217 + jac_affine_inv_2_0_BLUE_UP*0.3817653560693467) + (jac_affine_inv_0_1_BLUE_UP*0.0048399363458717648 + jac_affine_inv_1_1_BLUE_UP*0.0048399363458717648 + jac_affine_inv_2_1_BLUE_UP*0.46230152343146724)*(jac_affine_inv_0_1_BLUE_UP*0.3817653560693467 + jac_affine_inv_1_1_BLUE_UP*0.83922694315494217 + jac_affine_inv_2_1_BLUE_UP*0.3817653560693467) + (jac_affine_inv_0_2_BLUE_UP*0.0048399363458717648 + jac_affine_inv_1_2_BLUE_UP*0.0048399363458717648 + jac_affine_inv_2_2_BLUE_UP*0.46230152343146724)*(jac_affine_inv_0_2_BLUE_UP*0.3817653560693467 + jac_affine_inv_1_2_BLUE_UP*0.83922694315494217 + jac_affine_inv_2_2_BLUE_UP*0.3817653560693467)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.0048399363458717648 + jac_affine_inv_1_0_BLUE_UP*0.0048399363458717648 + jac_affine_inv_2_0_BLUE_UP*0.46230152343146724)*(jac_affine_inv_0_0_BLUE_UP*0.61339470758478154 + jac_affine_inv_1_0_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_0_BLUE_UP*0.15593312049918601) + (jac_affine_inv_0_1_BLUE_UP*0.0048399363458717648 + jac_affine_inv_1_1_BLUE_UP*0.0048399363458717648 + jac_affine_inv_2_1_BLUE_UP*0.46230152343146724)*(jac_affine_inv_0_1_BLUE_UP*0.61339470758478154 + jac_affine_inv_1_1_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_1_BLUE_UP*0.15593312049918601) + (jac_affine_inv_0_2_BLUE_UP*0.0048399363458717648 + jac_affine_inv_1_2_BLUE_UP*0.0048399363458717648 + jac_affine_inv_2_2_BLUE_UP*0.46230152343146724)*(jac_affine_inv_0_2_BLUE_UP*0.61339470758478154 + jac_affine_inv_1_2_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_2_BLUE_UP*0.15593312049918601)), abs_det_jac_affine_BLUE_UP*(((jac_affine_inv_0_0_BLUE_UP*0.45490121496118757 + jac_affine_inv_1_0_BLUE_UP + jac_affine_inv_2_0_BLUE_UP*0.45490121496118757)*(jac_affine_inv_0_0_BLUE_UP*0.45490121496118757 + jac_affine_inv_1_0_BLUE_UP + jac_affine_inv_2_0_BLUE_UP*0.45490121496118757))*0.70430186211718859 + ((jac_affine_inv_0_1_BLUE_UP*0.45490121496118757 + jac_affine_inv_1_1_BLUE_UP + jac_affine_inv_2_1_BLUE_UP*0.45490121496118757)*(jac_affine_inv_0_1_BLUE_UP*0.45490121496118757 + jac_affine_inv_1_1_BLUE_UP + jac_affine_inv_2_1_BLUE_UP*0.45490121496118757))*0.70430186211718859 + ((jac_affine_inv_0_2_BLUE_UP*0.45490121496118757 + jac_affine_inv_1_2_BLUE_UP + jac_affine_inv_2_2_BLUE_UP*0.45490121496118757)*(jac_affine_inv_0_2_BLUE_UP*0.45490121496118757 + jac_affine_inv_1_2_BLUE_UP + jac_affine_inv_2_2_BLUE_UP*0.45490121496118757))*0.70430186211718859), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.3817653560693467 + jac_affine_inv_1_0_BLUE_UP*0.83922694315494217 + jac_affine_inv_2_0_BLUE_UP*0.3817653560693467)*(jac_affine_inv_0_0_BLUE_UP*0.61339470758478154 + jac_affine_inv_1_0_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_0_BLUE_UP*0.15593312049918601) + (jac_affine_inv_0_1_BLUE_UP*0.3817653560693467 + jac_affine_inv_1_1_BLUE_UP*0.83922694315494217 + jac_affine_inv_2_1_BLUE_UP*0.3817653560693467)*(jac_affine_inv_0_1_BLUE_UP*0.61339470758478154 + jac_affine_inv_1_1_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_1_BLUE_UP*0.15593312049918601) + (jac_affine_inv_0_2_BLUE_UP*0.3817653560693467 + jac_affine_inv_1_2_BLUE_UP*0.83922694315494217 + jac_affine_inv_2_2_BLUE_UP*0.3817653560693467)*(jac_affine_inv_0_2_BLUE_UP*0.61339470758478154 + jac_affine_inv_1_2_BLUE_UP*0.15593312049918601 + jac_affine_inv_2_2_BLUE_UP*0.15593312049918601)), abs_det_jac_affine_BLUE_UP*(((jac_affine_inv_0_0_BLUE_UP + jac_affine_inv_1_0_BLUE_UP*0.25421334512840316 + jac_affine_inv_2_0_BLUE_UP*0.25421334512840316)*(jac_affine_inv_0_0_BLUE_UP + jac_affine_inv_1_0_BLUE_UP*0.25421334512840316 + jac_affine_inv_2_0_BLUE_UP*0.25421334512840316))*0.37625306729301966 + ((jac_affine_inv_0_1_BLUE_UP + jac_affine_inv_1_1_BLUE_UP*0.25421334512840316 + jac_affine_inv_2_1_BLUE_UP*0.25421334512840316)*(jac_affine_inv_0_1_BLUE_UP + jac_affine_inv_1_1_BLUE_UP*0.25421334512840316 + jac_affine_inv_2_1_BLUE_UP*0.25421334512840316))*0.37625306729301966 + ((jac_affine_inv_0_2_BLUE_UP + jac_affine_inv_1_2_BLUE_UP*0.25421334512840316 + jac_affine_inv_2_2_BLUE_UP*0.25421334512840316)*(jac_affine_inv_0_2_BLUE_UP + jac_affine_inv_1_2_BLUE_UP*0.25421334512840316 + jac_affine_inv_2_2_BLUE_UP*0.25421334512840316))*0.37625306729301966), abs_det_jac_affine_BLUE_UP*(((-jac_affine_inv_1_0_BLUE_UP + jac_affine_inv_2_0_BLUE_UP*0.015462881894859308)*(-jac_affine_inv_1_0_BLUE_UP + jac_affine_inv_2_0_BLUE_UP*0.015462881894859308))*0.20046443821120841 + ((-jac_affine_inv_1_1_BLUE_UP + jac_affine_inv_2_1_BLUE_UP*0.015462881894859308)*(-jac_affine_inv_1_1_BLUE_UP + jac_affine_inv_2_1_BLUE_UP*0.015462881894859308))*0.20046443821120841 + ((-jac_affine_inv_1_2_BLUE_UP + jac_affine_inv_2_2_BLUE_UP*0.015462881894859308)*(-jac_affine_inv_1_2_BLUE_UP + jac_affine_inv_2_2_BLUE_UP*0.015462881894859308))*0.20046443821120841), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_0_BLUE_UP*0.18002969351036541)*(jac_affine_inv_1_0_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_0_BLUE_UP*0.0069232355736274674) + (jac_affine_inv_0_1_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_1_BLUE_UP*0.18002969351036541)*(jac_affine_inv_1_1_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_1_BLUE_UP*0.0069232355736274674) + (jac_affine_inv_0_2_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_2_BLUE_UP*0.18002969351036541)*(jac_affine_inv_1_2_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_2_BLUE_UP*0.0069232355736274674)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.0069232355736274674 + jac_affine_inv_1_0_BLUE_UP*0.18002969351036541)*(jac_affine_inv_1_0_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_0_BLUE_UP*0.0069232355736274674) + (jac_affine_inv_0_1_BLUE_UP*-0.0069232355736274674 + jac_affine_inv_1_1_BLUE_UP*0.18002969351036541)*(jac_affine_inv_1_1_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_1_BLUE_UP*0.0069232355736274674) + (jac_affine_inv_0_2_BLUE_UP*-0.0069232355736274674 + jac_affine_inv_1_2_BLUE_UP*0.18002969351036541)*(jac_affine_inv_1_2_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_2_BLUE_UP*0.0069232355736274674)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_0_BLUE_UP*0.0069232355736274674)*(jac_affine_inv_0_0_BLUE_UP*0.44773255210137269 + jac_affine_inv_1_0_BLUE_UP*0.44773255210137269 + jac_affine_inv_2_0_BLUE_UP*0.81304707091600714) + (jac_affine_inv_1_1_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_1_BLUE_UP*0.0069232355736274674)*(jac_affine_inv_0_1_BLUE_UP*0.44773255210137269 + jac_affine_inv_1_1_BLUE_UP*0.44773255210137269 + jac_affine_inv_2_1_BLUE_UP*0.81304707091600714) + (jac_affine_inv_1_2_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_2_BLUE_UP*0.0069232355736274674)*(jac_affine_inv_0_2_BLUE_UP*0.44773255210137269 + jac_affine_inv_1_2_BLUE_UP*0.44773255210137269 + jac_affine_inv_2_2_BLUE_UP*0.81304707091600714)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_0_BLUE_UP*0.0069232355736274674)*(jac_affine_inv_0_0_BLUE_UP*0.0069232355736274674 + jac_affine_inv_1_0_BLUE_UP*0.37223775438826195 + jac_affine_inv_2_0_BLUE_UP*0.0069232355736274674) + (jac_affine_inv_1_1_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_1_BLUE_UP*0.0069232355736274674)*(jac_affine_inv_0_1_BLUE_UP*0.0069232355736274674 + jac_affine_inv_1_1_BLUE_UP*0.37223775438826195 + jac_affine_inv_2_1_BLUE_UP*0.0069232355736274674) + (jac_affine_inv_1_2_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_2_BLUE_UP*0.0069232355736274674)*(jac_affine_inv_0_2_BLUE_UP*0.0069232355736274674 + jac_affine_inv_1_2_BLUE_UP*0.37223775438826195 + jac_affine_inv_2_2_BLUE_UP*0.0069232355736274674)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_0_BLUE_UP*0.0069232355736274674)*(jac_affine_inv_0_0_BLUE_UP*0.54534421232499986 + jac_affine_inv_1_0_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_0_BLUE_UP*0.18002969351036541) + (jac_affine_inv_1_1_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_1_BLUE_UP*0.0069232355736274674)*(jac_affine_inv_0_1_BLUE_UP*0.54534421232499986 + jac_affine_inv_1_1_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_1_BLUE_UP*0.18002969351036541) + (jac_affine_inv_1_2_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_2_BLUE_UP*0.0069232355736274674)*(jac_affine_inv_0_2_BLUE_UP*0.54534421232499986 + jac_affine_inv_1_2_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_2_BLUE_UP*0.18002969351036541)), abs_det_jac_affine_BLUE_UP*(((-jac_affine_inv_0_0_BLUE_UP + jac_affine_inv_2_0_BLUE_UP*0.40209203611714223)*(-jac_affine_inv_0_0_BLUE_UP + jac_affine_inv_2_0_BLUE_UP*0.40209203611714223))*0.20046443821120841 + ((-jac_affine_inv_0_1_BLUE_UP + jac_affine_inv_2_1_BLUE_UP*0.40209203611714223)*(-jac_affine_inv_0_1_BLUE_UP + jac_affine_inv_2_1_BLUE_UP*0.40209203611714223))*0.20046443821120841 + ((-jac_affine_inv_0_2_BLUE_UP + jac_affine_inv_2_2_BLUE_UP*0.40209203611714223)*(-jac_affine_inv_0_2_BLUE_UP + jac_affine_inv_2_2_BLUE_UP*0.40209203611714223))*0.20046443821120841), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.0069232355736274674 + jac_affine_inv_1_0_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_0_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_0_BLUE_UP*0.18002969351036541) + (jac_affine_inv_0_1_BLUE_UP*-0.0069232355736274674 + jac_affine_inv_1_1_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_1_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_1_BLUE_UP*0.18002969351036541) + (jac_affine_inv_0_2_BLUE_UP*-0.0069232355736274674 + jac_affine_inv_1_2_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_2_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_2_BLUE_UP*0.18002969351036541)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_0_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_0_BLUE_UP*0.44773255210137269 + jac_affine_inv_1_0_BLUE_UP*0.44773255210137269 + jac_affine_inv_2_0_BLUE_UP*0.81304707091600714) + (jac_affine_inv_0_1_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_1_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_1_BLUE_UP*0.44773255210137269 + jac_affine_inv_1_1_BLUE_UP*0.44773255210137269 + jac_affine_inv_2_1_BLUE_UP*0.81304707091600714) + (jac_affine_inv_0_2_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_2_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_2_BLUE_UP*0.44773255210137269 + jac_affine_inv_1_2_BLUE_UP*0.44773255210137269 + jac_affine_inv_2_2_BLUE_UP*0.81304707091600714)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_0_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_0_BLUE_UP*0.0069232355736274674 + jac_affine_inv_1_0_BLUE_UP*0.37223775438826195 + jac_affine_inv_2_0_BLUE_UP*0.0069232355736274674) + (jac_affine_inv_0_1_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_1_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_1_BLUE_UP*0.0069232355736274674 + jac_affine_inv_1_1_BLUE_UP*0.37223775438826195 + jac_affine_inv_2_1_BLUE_UP*0.0069232355736274674) + (jac_affine_inv_0_2_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_2_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_2_BLUE_UP*0.0069232355736274674 + jac_affine_inv_1_2_BLUE_UP*0.37223775438826195 + jac_affine_inv_2_2_BLUE_UP*0.0069232355736274674)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_0_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_0_BLUE_UP*0.54534421232499986 + jac_affine_inv_1_0_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_0_BLUE_UP*0.18002969351036541) + (jac_affine_inv_0_1_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_1_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_1_BLUE_UP*0.54534421232499986 + jac_affine_inv_1_1_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_1_BLUE_UP*0.18002969351036541) + (jac_affine_inv_0_2_BLUE_UP*-0.44773255210137269 + jac_affine_inv_2_2_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_2_BLUE_UP*0.54534421232499986 + jac_affine_inv_1_2_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_2_BLUE_UP*0.18002969351036541)), abs_det_jac_affine_BLUE_UP*(((jac_affine_inv_0_0_BLUE_UP*-0.03845607598742512 + jac_affine_inv_1_0_BLUE_UP)*(jac_affine_inv_0_0_BLUE_UP*-0.03845607598742512 + jac_affine_inv_1_0_BLUE_UP))*0.032410690545436105 + ((jac_affine_inv_0_1_BLUE_UP*-0.03845607598742512 + jac_affine_inv_1_1_BLUE_UP)*(jac_affine_inv_0_1_BLUE_UP*-0.03845607598742512 + jac_affine_inv_1_1_BLUE_UP))*0.032410690545436105 + ((jac_affine_inv_0_2_BLUE_UP*-0.03845607598742512 + jac_affine_inv_1_2_BLUE_UP)*(jac_affine_inv_0_2_BLUE_UP*-0.03845607598742512 + jac_affine_inv_1_2_BLUE_UP))*0.032410690545436105), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.0069232355736274674 + jac_affine_inv_1_0_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_0_BLUE_UP*0.44773255210137269 + jac_affine_inv_1_0_BLUE_UP*0.44773255210137269 + jac_affine_inv_2_0_BLUE_UP*0.81304707091600714) + (jac_affine_inv_0_1_BLUE_UP*-0.0069232355736274674 + jac_affine_inv_1_1_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_1_BLUE_UP*0.44773255210137269 + jac_affine_inv_1_1_BLUE_UP*0.44773255210137269 + jac_affine_inv_2_1_BLUE_UP*0.81304707091600714) + (jac_affine_inv_0_2_BLUE_UP*-0.0069232355736274674 + jac_affine_inv_1_2_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_2_BLUE_UP*0.44773255210137269 + jac_affine_inv_1_2_BLUE_UP*0.44773255210137269 + jac_affine_inv_2_2_BLUE_UP*0.81304707091600714)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.0069232355736274674 + jac_affine_inv_1_0_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_0_BLUE_UP*0.0069232355736274674 + jac_affine_inv_1_0_BLUE_UP*0.37223775438826195 + jac_affine_inv_2_0_BLUE_UP*0.0069232355736274674) + (jac_affine_inv_0_1_BLUE_UP*-0.0069232355736274674 + jac_affine_inv_1_1_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_1_BLUE_UP*0.0069232355736274674 + jac_affine_inv_1_1_BLUE_UP*0.37223775438826195 + jac_affine_inv_2_1_BLUE_UP*0.0069232355736274674) + (jac_affine_inv_0_2_BLUE_UP*-0.0069232355736274674 + jac_affine_inv_1_2_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_2_BLUE_UP*0.0069232355736274674 + jac_affine_inv_1_2_BLUE_UP*0.37223775438826195 + jac_affine_inv_2_2_BLUE_UP*0.0069232355736274674)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.0069232355736274674 + jac_affine_inv_1_0_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_0_BLUE_UP*0.54534421232499986 + jac_affine_inv_1_0_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_0_BLUE_UP*0.18002969351036541) + (jac_affine_inv_0_1_BLUE_UP*-0.0069232355736274674 + jac_affine_inv_1_1_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_1_BLUE_UP*0.54534421232499986 + jac_affine_inv_1_1_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_1_BLUE_UP*0.18002969351036541) + (jac_affine_inv_0_2_BLUE_UP*-0.0069232355736274674 + jac_affine_inv_1_2_BLUE_UP*0.18002969351036541)*(jac_affine_inv_0_2_BLUE_UP*0.54534421232499986 + jac_affine_inv_1_2_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_2_BLUE_UP*0.18002969351036541)), abs_det_jac_affine_BLUE_UP*(((jac_affine_inv_0_0_BLUE_UP*0.55068466281655948 + jac_affine_inv_1_0_BLUE_UP*0.55068466281655948 + jac_affine_inv_2_0_BLUE_UP)*(jac_affine_inv_0_0_BLUE_UP*0.55068466281655948 + jac_affine_inv_1_0_BLUE_UP*0.55068466281655948 + jac_affine_inv_2_0_BLUE_UP))*0.6610455395250987 + ((jac_affine_inv_0_1_BLUE_UP*0.55068466281655948 + jac_affine_inv_1_1_BLUE_UP*0.55068466281655948 + jac_affine_inv_2_1_BLUE_UP)*(jac_affine_inv_0_1_BLUE_UP*0.55068466281655948 + jac_affine_inv_1_1_BLUE_UP*0.55068466281655948 + jac_affine_inv_2_1_BLUE_UP))*0.6610455395250987 + ((jac_affine_inv_0_2_BLUE_UP*0.55068466281655948 + jac_affine_inv_1_2_BLUE_UP*0.55068466281655948 + jac_affine_inv_2_2_BLUE_UP)*(jac_affine_inv_0_2_BLUE_UP*0.55068466281655948 + jac_affine_inv_1_2_BLUE_UP*0.55068466281655948 + jac_affine_inv_2_2_BLUE_UP))*0.6610455395250987), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.0069232355736274674 + jac_affine_inv_1_0_BLUE_UP*0.37223775438826195 + jac_affine_inv_2_0_BLUE_UP*0.0069232355736274674)*(jac_affine_inv_0_0_BLUE_UP*0.44773255210137269 + jac_affine_inv_1_0_BLUE_UP*0.44773255210137269 + jac_affine_inv_2_0_BLUE_UP*0.81304707091600714) + (jac_affine_inv_0_1_BLUE_UP*0.0069232355736274674 + jac_affine_inv_1_1_BLUE_UP*0.37223775438826195 + jac_affine_inv_2_1_BLUE_UP*0.0069232355736274674)*(jac_affine_inv_0_1_BLUE_UP*0.44773255210137269 + jac_affine_inv_1_1_BLUE_UP*0.44773255210137269 + jac_affine_inv_2_1_BLUE_UP*0.81304707091600714) + (jac_affine_inv_0_2_BLUE_UP*0.0069232355736274674 + jac_affine_inv_1_2_BLUE_UP*0.37223775438826195 + jac_affine_inv_2_2_BLUE_UP*0.0069232355736274674)*(jac_affine_inv_0_2_BLUE_UP*0.44773255210137269 + jac_affine_inv_1_2_BLUE_UP*0.44773255210137269 + jac_affine_inv_2_2_BLUE_UP*0.81304707091600714)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.44773255210137269 + jac_affine_inv_1_0_BLUE_UP*0.44773255210137269 + jac_affine_inv_2_0_BLUE_UP*0.81304707091600714)*(jac_affine_inv_0_0_BLUE_UP*0.54534421232499986 + jac_affine_inv_1_0_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_0_BLUE_UP*0.18002969351036541) + (jac_affine_inv_0_1_BLUE_UP*0.44773255210137269 + jac_affine_inv_1_1_BLUE_UP*0.44773255210137269 + jac_affine_inv_2_1_BLUE_UP*0.81304707091600714)*(jac_affine_inv_0_1_BLUE_UP*0.54534421232499986 + jac_affine_inv_1_1_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_1_BLUE_UP*0.18002969351036541) + (jac_affine_inv_0_2_BLUE_UP*0.44773255210137269 + jac_affine_inv_1_2_BLUE_UP*0.44773255210137269 + jac_affine_inv_2_2_BLUE_UP*0.81304707091600714)*(jac_affine_inv_0_2_BLUE_UP*0.54534421232499986 + jac_affine_inv_1_2_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_2_BLUE_UP*0.18002969351036541)), abs_det_jac_affine_BLUE_UP*(((jac_affine_inv_0_0_BLUE_UP*0.01859896126067373 + jac_affine_inv_1_0_BLUE_UP + jac_affine_inv_2_0_BLUE_UP*0.01859896126067373)*(jac_affine_inv_0_0_BLUE_UP*0.01859896126067373 + jac_affine_inv_1_0_BLUE_UP + jac_affine_inv_2_0_BLUE_UP*0.01859896126067373))*0.13856094579201603 + ((jac_affine_inv_0_1_BLUE_UP*0.01859896126067373 + jac_affine_inv_1_1_BLUE_UP + jac_affine_inv_2_1_BLUE_UP*0.01859896126067373)*(jac_affine_inv_0_1_BLUE_UP*0.01859896126067373 + jac_affine_inv_1_1_BLUE_UP + jac_affine_inv_2_1_BLUE_UP*0.01859896126067373))*0.13856094579201603 + ((jac_affine_inv_0_2_BLUE_UP*0.01859896126067373 + jac_affine_inv_1_2_BLUE_UP + jac_affine_inv_2_2_BLUE_UP*0.01859896126067373)*(jac_affine_inv_0_2_BLUE_UP*0.01859896126067373 + jac_affine_inv_1_2_BLUE_UP + jac_affine_inv_2_2_BLUE_UP*0.01859896126067373))*0.13856094579201603), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.0069232355736274674 + jac_affine_inv_1_0_BLUE_UP*0.37223775438826195 + jac_affine_inv_2_0_BLUE_UP*0.0069232355736274674)*(jac_affine_inv_0_0_BLUE_UP*0.54534421232499986 + jac_affine_inv_1_0_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_0_BLUE_UP*0.18002969351036541) + (jac_affine_inv_0_1_BLUE_UP*0.0069232355736274674 + jac_affine_inv_1_1_BLUE_UP*0.37223775438826195 + jac_affine_inv_2_1_BLUE_UP*0.0069232355736274674)*(jac_affine_inv_0_1_BLUE_UP*0.54534421232499986 + jac_affine_inv_1_1_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_1_BLUE_UP*0.18002969351036541) + (jac_affine_inv_0_2_BLUE_UP*0.0069232355736274674 + jac_affine_inv_1_2_BLUE_UP*0.37223775438826195 + jac_affine_inv_2_2_BLUE_UP*0.0069232355736274674)*(jac_affine_inv_0_2_BLUE_UP*0.54534421232499986 + jac_affine_inv_1_2_BLUE_UP*0.18002969351036541 + jac_affine_inv_2_2_BLUE_UP*0.18002969351036541)), abs_det_jac_affine_BLUE_UP*(((jac_affine_inv_0_0_BLUE_UP + jac_affine_inv_1_0_BLUE_UP*0.33012121416459822 + jac_affine_inv_2_0_BLUE_UP*0.33012121416459822)*(jac_affine_inv_0_0_BLUE_UP + jac_affine_inv_1_0_BLUE_UP*0.33012121416459822 + jac_affine_inv_2_0_BLUE_UP*0.33012121416459822))*0.29740030991637451 + ((jac_affine_inv_0_1_BLUE_UP + jac_affine_inv_1_1_BLUE_UP*0.33012121416459822 + jac_affine_inv_2_1_BLUE_UP*0.33012121416459822)*(jac_affine_inv_0_1_BLUE_UP + jac_affine_inv_1_1_BLUE_UP*0.33012121416459822 + jac_affine_inv_2_1_BLUE_UP*0.33012121416459822))*0.29740030991637451 + ((jac_affine_inv_0_2_BLUE_UP + jac_affine_inv_1_2_BLUE_UP*0.33012121416459822 + jac_affine_inv_2_2_BLUE_UP*0.33012121416459822)*(jac_affine_inv_0_2_BLUE_UP + jac_affine_inv_1_2_BLUE_UP*0.33012121416459822 + jac_affine_inv_2_2_BLUE_UP*0.33012121416459822))*0.29740030991637451), abs_det_jac_affine_BLUE_UP*(((jac_affine_inv_1_0_BLUE_UP*-0.81923601162978588 + jac_affine_inv_2_0_BLUE_UP)*(jac_affine_inv_1_0_BLUE_UP*-0.81923601162978588 + jac_affine_inv_2_0_BLUE_UP))*0.18550396047976214 + ((jac_affine_inv_1_1_BLUE_UP*-0.81923601162978588 + jac_affine_inv_2_1_BLUE_UP)*(jac_affine_inv_1_1_BLUE_UP*-0.81923601162978588 + jac_affine_inv_2_1_BLUE_UP))*0.18550396047976214 + ((jac_affine_inv_1_2_BLUE_UP*-0.81923601162978588 + jac_affine_inv_2_2_BLUE_UP)*(jac_affine_inv_1_2_BLUE_UP*-0.81923601162978588 + jac_affine_inv_2_2_BLUE_UP))*0.18550396047976214), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_0_BLUE_UP*0.21607642918484779)*(jac_affine_inv_1_0_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_0_BLUE_UP*0.43070170707783612) + (jac_affine_inv_0_1_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_1_BLUE_UP*0.21607642918484779)*(jac_affine_inv_1_1_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_1_BLUE_UP*0.43070170707783612) + (jac_affine_inv_0_2_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_2_BLUE_UP*0.21607642918484779)*(jac_affine_inv_1_2_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_2_BLUE_UP*0.43070170707783612)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.43070170707783612 + jac_affine_inv_1_0_BLUE_UP*0.21607642918484779)*(jac_affine_inv_1_0_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_0_BLUE_UP*0.43070170707783612) + (jac_affine_inv_0_1_BLUE_UP*-0.43070170707783612 + jac_affine_inv_1_1_BLUE_UP*0.21607642918484779)*(jac_affine_inv_1_1_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_1_BLUE_UP*0.43070170707783612) + (jac_affine_inv_0_2_BLUE_UP*-0.43070170707783612 + jac_affine_inv_1_2_BLUE_UP*0.21607642918484779)*(jac_affine_inv_1_2_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_2_BLUE_UP*0.43070170707783612)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_0_BLUE_UP*0.43070170707783612)*(jac_affine_inv_0_0_BLUE_UP*0.35284634870858678 + jac_affine_inv_1_0_BLUE_UP*0.35284634870858678 + jac_affine_inv_2_0_BLUE_UP*0.35322186373731607) + (jac_affine_inv_1_1_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_1_BLUE_UP*0.43070170707783612)*(jac_affine_inv_0_1_BLUE_UP*0.35284634870858678 + jac_affine_inv_1_1_BLUE_UP*0.35284634870858678 + jac_affine_inv_2_1_BLUE_UP*0.35322186373731607) + (jac_affine_inv_1_2_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_2_BLUE_UP*0.43070170707783612)*(jac_affine_inv_0_2_BLUE_UP*0.35284634870858678 + jac_affine_inv_1_2_BLUE_UP*0.35284634870858678 + jac_affine_inv_2_2_BLUE_UP*0.35322186373731607)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_0_BLUE_UP*0.43070170707783612)*(jac_affine_inv_0_0_BLUE_UP*0.43070170707783612 + jac_affine_inv_1_0_BLUE_UP*0.43107722210656541 + jac_affine_inv_2_0_BLUE_UP*0.43070170707783612) + (jac_affine_inv_1_1_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_1_BLUE_UP*0.43070170707783612)*(jac_affine_inv_0_1_BLUE_UP*0.43070170707783612 + jac_affine_inv_1_1_BLUE_UP*0.43107722210656541 + jac_affine_inv_2_1_BLUE_UP*0.43070170707783612) + (jac_affine_inv_1_2_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_2_BLUE_UP*0.43070170707783612)*(jac_affine_inv_0_2_BLUE_UP*0.43070170707783612 + jac_affine_inv_1_2_BLUE_UP*0.43107722210656541 + jac_affine_inv_2_2_BLUE_UP*0.43070170707783612)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_1_0_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_0_BLUE_UP*0.43070170707783612)*(jac_affine_inv_0_0_BLUE_UP*0.21645194421357716 + jac_affine_inv_1_0_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_0_BLUE_UP*0.21607642918484779) + (jac_affine_inv_1_1_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_1_BLUE_UP*0.43070170707783612)*(jac_affine_inv_0_1_BLUE_UP*0.21645194421357716 + jac_affine_inv_1_1_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_1_BLUE_UP*0.21607642918484779) + (jac_affine_inv_1_2_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_2_BLUE_UP*0.43070170707783612)*(jac_affine_inv_0_2_BLUE_UP*0.21645194421357716 + jac_affine_inv_1_2_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_2_BLUE_UP*0.21607642918484779)), abs_det_jac_affine_BLUE_UP*(((-jac_affine_inv_0_0_BLUE_UP + jac_affine_inv_2_0_BLUE_UP*0.61238108308527162)*(-jac_affine_inv_0_0_BLUE_UP + jac_affine_inv_2_0_BLUE_UP*0.61238108308527162))*0.12450054579698162 + ((-jac_affine_inv_0_1_BLUE_UP + jac_affine_inv_2_1_BLUE_UP*0.61238108308527162)*(-jac_affine_inv_0_1_BLUE_UP + jac_affine_inv_2_1_BLUE_UP*0.61238108308527162))*0.12450054579698162 + ((-jac_affine_inv_0_2_BLUE_UP + jac_affine_inv_2_2_BLUE_UP*0.61238108308527162)*(-jac_affine_inv_0_2_BLUE_UP + jac_affine_inv_2_2_BLUE_UP*0.61238108308527162))*0.12450054579698162), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_0_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_0_BLUE_UP*-0.43070170707783612 + jac_affine_inv_1_0_BLUE_UP*0.21607642918484779) + (jac_affine_inv_0_1_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_1_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_1_BLUE_UP*-0.43070170707783612 + jac_affine_inv_1_1_BLUE_UP*0.21607642918484779) + (jac_affine_inv_0_2_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_2_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_2_BLUE_UP*-0.43070170707783612 + jac_affine_inv_1_2_BLUE_UP*0.21607642918484779)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_0_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_0_BLUE_UP*0.35284634870858678 + jac_affine_inv_1_0_BLUE_UP*0.35284634870858678 + jac_affine_inv_2_0_BLUE_UP*0.35322186373731607) + (jac_affine_inv_0_1_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_1_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_1_BLUE_UP*0.35284634870858678 + jac_affine_inv_1_1_BLUE_UP*0.35284634870858678 + jac_affine_inv_2_1_BLUE_UP*0.35322186373731607) + (jac_affine_inv_0_2_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_2_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_2_BLUE_UP*0.35284634870858678 + jac_affine_inv_1_2_BLUE_UP*0.35284634870858678 + jac_affine_inv_2_2_BLUE_UP*0.35322186373731607)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_0_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_0_BLUE_UP*0.43070170707783612 + jac_affine_inv_1_0_BLUE_UP*0.43107722210656541 + jac_affine_inv_2_0_BLUE_UP*0.43070170707783612) + (jac_affine_inv_0_1_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_1_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_1_BLUE_UP*0.43070170707783612 + jac_affine_inv_1_1_BLUE_UP*0.43107722210656541 + jac_affine_inv_2_1_BLUE_UP*0.43070170707783612) + (jac_affine_inv_0_2_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_2_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_2_BLUE_UP*0.43070170707783612 + jac_affine_inv_1_2_BLUE_UP*0.43107722210656541 + jac_affine_inv_2_2_BLUE_UP*0.43070170707783612)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_0_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_0_BLUE_UP*0.21645194421357716 + jac_affine_inv_1_0_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_0_BLUE_UP*0.21607642918484779) + (jac_affine_inv_0_1_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_1_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_1_BLUE_UP*0.21645194421357716 + jac_affine_inv_1_1_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_1_BLUE_UP*0.21607642918484779) + (jac_affine_inv_0_2_BLUE_UP*-0.35284634870858678 + jac_affine_inv_2_2_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_2_BLUE_UP*0.21645194421357716 + jac_affine_inv_1_2_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_2_BLUE_UP*0.21607642918484779)), abs_det_jac_affine_BLUE_UP*(((-jac_affine_inv_0_0_BLUE_UP + jac_affine_inv_1_0_BLUE_UP*0.50168463610430647)*(-jac_affine_inv_0_0_BLUE_UP + jac_affine_inv_1_0_BLUE_UP*0.50168463610430647))*0.18550396047976214 + ((-jac_affine_inv_0_1_BLUE_UP + jac_affine_inv_1_1_BLUE_UP*0.50168463610430647)*(-jac_affine_inv_0_1_BLUE_UP + jac_affine_inv_1_1_BLUE_UP*0.50168463610430647))*0.18550396047976214 + ((-jac_affine_inv_0_2_BLUE_UP + jac_affine_inv_1_2_BLUE_UP*0.50168463610430647)*(-jac_affine_inv_0_2_BLUE_UP + jac_affine_inv_1_2_BLUE_UP*0.50168463610430647))*0.18550396047976214), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.43070170707783612 + jac_affine_inv_1_0_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_0_BLUE_UP*0.35284634870858678 + jac_affine_inv_1_0_BLUE_UP*0.35284634870858678 + jac_affine_inv_2_0_BLUE_UP*0.35322186373731607) + (jac_affine_inv_0_1_BLUE_UP*-0.43070170707783612 + jac_affine_inv_1_1_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_1_BLUE_UP*0.35284634870858678 + jac_affine_inv_1_1_BLUE_UP*0.35284634870858678 + jac_affine_inv_2_1_BLUE_UP*0.35322186373731607) + (jac_affine_inv_0_2_BLUE_UP*-0.43070170707783612 + jac_affine_inv_1_2_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_2_BLUE_UP*0.35284634870858678 + jac_affine_inv_1_2_BLUE_UP*0.35284634870858678 + jac_affine_inv_2_2_BLUE_UP*0.35322186373731607)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.43070170707783612 + jac_affine_inv_1_0_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_0_BLUE_UP*0.43070170707783612 + jac_affine_inv_1_0_BLUE_UP*0.43107722210656541 + jac_affine_inv_2_0_BLUE_UP*0.43070170707783612) + (jac_affine_inv_0_1_BLUE_UP*-0.43070170707783612 + jac_affine_inv_1_1_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_1_BLUE_UP*0.43070170707783612 + jac_affine_inv_1_1_BLUE_UP*0.43107722210656541 + jac_affine_inv_2_1_BLUE_UP*0.43070170707783612) + (jac_affine_inv_0_2_BLUE_UP*-0.43070170707783612 + jac_affine_inv_1_2_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_2_BLUE_UP*0.43070170707783612 + jac_affine_inv_1_2_BLUE_UP*0.43107722210656541 + jac_affine_inv_2_2_BLUE_UP*0.43070170707783612)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*-0.43070170707783612 + jac_affine_inv_1_0_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_0_BLUE_UP*0.21645194421357716 + jac_affine_inv_1_0_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_0_BLUE_UP*0.21607642918484779) + (jac_affine_inv_0_1_BLUE_UP*-0.43070170707783612 + jac_affine_inv_1_1_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_1_BLUE_UP*0.21645194421357716 + jac_affine_inv_1_1_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_1_BLUE_UP*0.21607642918484779) + (jac_affine_inv_0_2_BLUE_UP*-0.43070170707783612 + jac_affine_inv_1_2_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_2_BLUE_UP*0.21645194421357716 + jac_affine_inv_1_2_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_2_BLUE_UP*0.21607642918484779)), abs_det_jac_affine_BLUE_UP*(((jac_affine_inv_0_0_BLUE_UP*0.99893688622568233 + jac_affine_inv_1_0_BLUE_UP*0.99893688622568233 + jac_affine_inv_2_0_BLUE_UP)*(jac_affine_inv_0_0_BLUE_UP*0.99893688622568233 + jac_affine_inv_1_0_BLUE_UP*0.99893688622568233 + jac_affine_inv_2_0_BLUE_UP))*0.12476568502206307 + ((jac_affine_inv_0_1_BLUE_UP*0.99893688622568233 + jac_affine_inv_1_1_BLUE_UP*0.99893688622568233 + jac_affine_inv_2_1_BLUE_UP)*(jac_affine_inv_0_1_BLUE_UP*0.99893688622568233 + jac_affine_inv_1_1_BLUE_UP*0.99893688622568233 + jac_affine_inv_2_1_BLUE_UP))*0.12476568502206307 + ((jac_affine_inv_0_2_BLUE_UP*0.99893688622568233 + jac_affine_inv_1_2_BLUE_UP*0.99893688622568233 + jac_affine_inv_2_2_BLUE_UP)*(jac_affine_inv_0_2_BLUE_UP*0.99893688622568233 + jac_affine_inv_1_2_BLUE_UP*0.99893688622568233 + jac_affine_inv_2_2_BLUE_UP))*0.12476568502206307), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.35284634870858678 + jac_affine_inv_1_0_BLUE_UP*0.35284634870858678 + jac_affine_inv_2_0_BLUE_UP*0.35322186373731607)*(jac_affine_inv_0_0_BLUE_UP*0.43070170707783612 + jac_affine_inv_1_0_BLUE_UP*0.43107722210656541 + jac_affine_inv_2_0_BLUE_UP*0.43070170707783612) + (jac_affine_inv_0_1_BLUE_UP*0.35284634870858678 + jac_affine_inv_1_1_BLUE_UP*0.35284634870858678 + jac_affine_inv_2_1_BLUE_UP*0.35322186373731607)*(jac_affine_inv_0_1_BLUE_UP*0.43070170707783612 + jac_affine_inv_1_1_BLUE_UP*0.43107722210656541 + jac_affine_inv_2_1_BLUE_UP*0.43070170707783612) + (jac_affine_inv_0_2_BLUE_UP*0.35284634870858678 + jac_affine_inv_1_2_BLUE_UP*0.35284634870858678 + jac_affine_inv_2_2_BLUE_UP*0.35322186373731607)*(jac_affine_inv_0_2_BLUE_UP*0.43070170707783612 + jac_affine_inv_1_2_BLUE_UP*0.43107722210656541 + jac_affine_inv_2_2_BLUE_UP*0.43070170707783612)), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.21645194421357716 + jac_affine_inv_1_0_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_0_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_0_BLUE_UP*0.35284634870858678 + jac_affine_inv_1_0_BLUE_UP*0.35284634870858678 + jac_affine_inv_2_0_BLUE_UP*0.35322186373731607) + (jac_affine_inv_0_1_BLUE_UP*0.21645194421357716 + jac_affine_inv_1_1_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_1_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_1_BLUE_UP*0.35284634870858678 + jac_affine_inv_1_1_BLUE_UP*0.35284634870858678 + jac_affine_inv_2_1_BLUE_UP*0.35322186373731607) + (jac_affine_inv_0_2_BLUE_UP*0.21645194421357716 + jac_affine_inv_1_2_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_2_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_2_BLUE_UP*0.35284634870858678 + jac_affine_inv_1_2_BLUE_UP*0.35284634870858678 + jac_affine_inv_2_2_BLUE_UP*0.35322186373731607)), abs_det_jac_affine_BLUE_UP*(((jac_affine_inv_0_0_BLUE_UP*0.99912889150836071 + jac_affine_inv_1_0_BLUE_UP + jac_affine_inv_2_0_BLUE_UP*0.99912889150836071)*(jac_affine_inv_0_0_BLUE_UP*0.99912889150836071 + jac_affine_inv_1_0_BLUE_UP + jac_affine_inv_2_0_BLUE_UP*0.99912889150836071))*0.18582757141911313 + ((jac_affine_inv_0_1_BLUE_UP*0.99912889150836071 + jac_affine_inv_1_1_BLUE_UP + jac_affine_inv_2_1_BLUE_UP*0.99912889150836071)*(jac_affine_inv_0_1_BLUE_UP*0.99912889150836071 + jac_affine_inv_1_1_BLUE_UP + jac_affine_inv_2_1_BLUE_UP*0.99912889150836071))*0.18582757141911313 + ((jac_affine_inv_0_2_BLUE_UP*0.99912889150836071 + jac_affine_inv_1_2_BLUE_UP + jac_affine_inv_2_2_BLUE_UP*0.99912889150836071)*(jac_affine_inv_0_2_BLUE_UP*0.99912889150836071 + jac_affine_inv_1_2_BLUE_UP + jac_affine_inv_2_2_BLUE_UP*0.99912889150836071))*0.18582757141911313), abs_det_jac_affine_BLUE_UP*((jac_affine_inv_0_0_BLUE_UP*0.21645194421357716 + jac_affine_inv_1_0_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_0_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_0_BLUE_UP*0.43070170707783612 + jac_affine_inv_1_0_BLUE_UP*0.43107722210656541 + jac_affine_inv_2_0_BLUE_UP*0.43070170707783612) + (jac_affine_inv_0_1_BLUE_UP*0.21645194421357716 + jac_affine_inv_1_1_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_1_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_1_BLUE_UP*0.43070170707783612 + jac_affine_inv_1_1_BLUE_UP*0.43107722210656541 + jac_affine_inv_2_1_BLUE_UP*0.43070170707783612) + (jac_affine_inv_0_2_BLUE_UP*0.21645194421357716 + jac_affine_inv_1_2_BLUE_UP*0.21607642918484779 + jac_affine_inv_2_2_BLUE_UP*0.21607642918484779)*(jac_affine_inv_0_2_BLUE_UP*0.43070170707783612 + jac_affine_inv_1_2_BLUE_UP*0.43107722210656541 + jac_affine_inv_2_2_BLUE_UP*0.43070170707783612)), abs_det_jac_affine_BLUE_UP*(((jac_affine_inv_0_0_BLUE_UP + jac_affine_inv_1_0_BLUE_UP*0.99826513441543008 + jac_affine_inv_2_0_BLUE_UP*0.99826513441543008)*(jac_affine_inv_0_0_BLUE_UP + jac_affine_inv_1_0_BLUE_UP*0.99826513441543008 + jac_affine_inv_2_0_BLUE_UP*0.99826513441543008))*0.046851444153837518 + ((jac_affine_inv_0_1_BLUE_UP + jac_affine_inv_1_1_BLUE_UP*0.99826513441543008 + jac_affine_inv_2_1_BLUE_UP*0.99826513441543008)*(jac_affine_inv_0_1_BLUE_UP + jac_affine_inv_1_1_BLUE_UP*0.99826513441543008 + jac_affine_inv_2_1_BLUE_UP*0.99826513441543008))*0.046851444153837518 + ((jac_affine_inv_0_2_BLUE_UP + jac_affine_inv_1_2_BLUE_UP*0.99826513441543008 + jac_affine_inv_2_2_BLUE_UP*0.99826513441543008)*(jac_affine_inv_0_2_BLUE_UP + jac_affine_inv_1_2_BLUE_UP*0.99826513441543008 + jac_affine_inv_2_2_BLUE_UP*0.99826513441543008))*0.046851444153837518)};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
             const walberla::float64 alpha_dof_0 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 alpha_dof_1 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 alpha_dof_2 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 alpha_dof_3 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 beta_dof_0 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 beta_dof_1 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 beta_dof_2 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 beta_dof_3 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             walberla::float64 q_acc_0_0 = 0.0;
             walberla::float64 q_acc_0_1 = 0.0;
             walberla::float64 q_acc_0_2 = 0.0;
             walberla::float64 q_acc_0_3 = 0.0;
             walberla::float64 q_acc_0_4 = 0.0;
             walberla::float64 q_acc_0_5 = 0.0;
             walberla::float64 q_acc_1_1 = 0.0;
             walberla::float64 q_acc_1_2 = 0.0;
             walberla::float64 q_acc_1_3 = 0.0;
             walberla::float64 q_acc_1_4 = 0.0;
             walberla::float64 q_acc_1_5 = 0.0;
             walberla::float64 q_acc_2_2 = 0.0;
             walberla::float64 q_acc_2_3 = 0.0;
             walberla::float64 q_acc_2_4 = 0.0;
             walberla::float64 q_acc_2_5 = 0.0;
             walberla::float64 q_acc_3_3 = 0.0;
             walberla::float64 q_acc_3_4 = 0.0;
             walberla::float64 q_acc_3_5 = 0.0;
             walberla::float64 q_acc_4_4 = 0.0;
             walberla::float64 q_acc_4_5 = 0.0;
             walberla::float64 q_acc_5_5 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const walberla::float64 tmp_qloop_0 = alpha_dof_0*_data_phi_0_0_BLUE_UP[4*q] + alpha_dof_1*_data_phi_0_0_BLUE_UP[4*q + 1] + alpha_dof_2*_data_phi_0_0_BLUE_UP[4*q + 2] + alpha_dof_3*_data_phi_0_0_BLUE_UP[4*q + 3];
                const walberla::float64 tmp_qloop_1 = beta_dof_0*_data_phi_0_0_BLUE_UP[4*q] + beta_dof_1*_data_phi_0_0_BLUE_UP[4*q + 1] + beta_dof_2*_data_phi_0_0_BLUE_UP[4*q + 2] + beta_dof_3*_data_phi_0_0_BLUE_UP[4*q + 3];
                const walberla::float64 q_tmp_0_0 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_UP[21*q] + tmp_qloop_1*_data_mass_det_0_0_BLUE_UP[21*q])*_data_q_w[q];
                const walberla::float64 q_tmp_0_1 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_UP[21*q + 1] + tmp_qloop_1*_data_mass_det_0_0_BLUE_UP[21*q + 1])*_data_q_w[q];
                const walberla::float64 q_tmp_0_2 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_UP[21*q + 2] + tmp_qloop_1*_data_mass_det_0_0_BLUE_UP[21*q + 2])*_data_q_w[q];
                const walberla::float64 q_tmp_0_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_UP[21*q + 3] + tmp_qloop_1*_data_mass_det_0_0_BLUE_UP[21*q + 3])*_data_q_w[q];
                const walberla::float64 q_tmp_0_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_UP[21*q + 4] + tmp_qloop_1*_data_mass_det_0_0_BLUE_UP[21*q + 4])*_data_q_w[q];
                const walberla::float64 q_tmp_0_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_UP[21*q + 5] + tmp_qloop_1*_data_mass_det_0_0_BLUE_UP[21*q + 5])*_data_q_w[q];
                const walberla::float64 q_tmp_1_1 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_UP[21*q + 6] + tmp_qloop_1*_data_mass_det_0_0_BLUE_UP[21*q + 6])*_data_q_w[q];
                const walberla::float64 q_tmp_1_2 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_UP[21*q + 7] + tmp_qloop_1*_data_mass_det_0_0_BLUE_UP[21*q + 7])*_data_q_w[q];
                const walberla::float64 q_tmp_1_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_UP[21*q + 8] + tmp_qloop_1*_data_mass_det_0_0_BLUE_UP[21*q + 8])*_data_q_w[q];
                const walberla::float64 q_tmp_1_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_UP[21*q + 9] + tmp_qloop_1*_data_mass_det_0_0_BLUE_UP[21*q + 9])*_data_q_w[q];
                const walberla::float64 q_tmp_1_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_UP[21*q + 10] + tmp_qloop_1*_data_mass_det_0_0_BLUE_UP[21*q + 10])*_data_q_w[q];
                const walberla::float64 q_tmp_2_2 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_UP[21*q + 11] + tmp_qloop_1*_data_mass_det_0_0_BLUE_UP[21*q + 11])*_data_q_w[q];
                const walberla::float64 q_tmp_2_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_UP[21*q + 12] + tmp_qloop_1*_data_mass_det_0_0_BLUE_UP[21*q + 12])*_data_q_w[q];
                const walberla::float64 q_tmp_2_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_UP[21*q + 13] + tmp_qloop_1*_data_mass_det_0_0_BLUE_UP[21*q + 13])*_data_q_w[q];
                const walberla::float64 q_tmp_2_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_UP[21*q + 14] + tmp_qloop_1*_data_mass_det_0_0_BLUE_UP[21*q + 14])*_data_q_w[q];
                const walberla::float64 q_tmp_3_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_UP[21*q + 15] + tmp_qloop_1*_data_mass_det_0_0_BLUE_UP[21*q + 15])*_data_q_w[q];
                const walberla::float64 q_tmp_3_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_UP[21*q + 16] + tmp_qloop_1*_data_mass_det_0_0_BLUE_UP[21*q + 16])*_data_q_w[q];
                const walberla::float64 q_tmp_3_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_UP[21*q + 17] + tmp_qloop_1*_data_mass_det_0_0_BLUE_UP[21*q + 17])*_data_q_w[q];
                const walberla::float64 q_tmp_4_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_UP[21*q + 18] + tmp_qloop_1*_data_mass_det_0_0_BLUE_UP[21*q + 18])*_data_q_w[q];
                const walberla::float64 q_tmp_4_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_UP[21*q + 19] + tmp_qloop_1*_data_mass_det_0_0_BLUE_UP[21*q + 19])*_data_q_w[q];
                const walberla::float64 q_tmp_5_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_UP[21*q + 20] + tmp_qloop_1*_data_mass_det_0_0_BLUE_UP[21*q + 20])*_data_q_w[q];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
             }
             const walberla::float64 elMat_0_0 = q_acc_0_0;
             const walberla::float64 elMat_0_1 = q_acc_0_1;
             const walberla::float64 elMat_0_2 = q_acc_0_2;
             const walberla::float64 elMat_0_3 = q_acc_0_3;
             const walberla::float64 elMat_0_4 = q_acc_0_4;
             const walberla::float64 elMat_0_5 = q_acc_0_5;
             const walberla::float64 elMat_1_0 = q_acc_0_1;
             const walberla::float64 elMat_1_1 = q_acc_1_1;
             const walberla::float64 elMat_1_2 = q_acc_1_2;
             const walberla::float64 elMat_1_3 = q_acc_1_3;
             const walberla::float64 elMat_1_4 = q_acc_1_4;
             const walberla::float64 elMat_1_5 = q_acc_1_5;
             const walberla::float64 elMat_2_0 = q_acc_0_2;
             const walberla::float64 elMat_2_1 = q_acc_1_2;
             const walberla::float64 elMat_2_2 = q_acc_2_2;
             const walberla::float64 elMat_2_3 = q_acc_2_3;
             const walberla::float64 elMat_2_4 = q_acc_2_4;
             const walberla::float64 elMat_2_5 = q_acc_2_5;
             const walberla::float64 elMat_3_0 = q_acc_0_3;
             const walberla::float64 elMat_3_1 = q_acc_1_3;
             const walberla::float64 elMat_3_2 = q_acc_2_3;
             const walberla::float64 elMat_3_3 = q_acc_3_3;
             const walberla::float64 elMat_3_4 = q_acc_3_4;
             const walberla::float64 elMat_3_5 = q_acc_3_5;
             const walberla::float64 elMat_4_0 = q_acc_0_4;
             const walberla::float64 elMat_4_1 = q_acc_1_4;
             const walberla::float64 elMat_4_2 = q_acc_2_4;
             const walberla::float64 elMat_4_3 = q_acc_3_4;
             const walberla::float64 elMat_4_4 = q_acc_4_4;
             const walberla::float64 elMat_4_5 = q_acc_4_5;
             const walberla::float64 elMat_5_0 = q_acc_0_5;
             const walberla::float64 elMat_5_1 = q_acc_1_5;
             const walberla::float64 elMat_5_2 = q_acc_2_5;
             const walberla::float64 elMat_5_3 = q_acc_3_5;
             const walberla::float64 elMat_5_4 = q_acc_4_5;
             const walberla::float64 elMat_5_5 = q_acc_5_5;
         
             std::vector< uint_t > _data_rowIdx( 6 );
             std::vector< uint_t > _data_colIdx( 6 );
             std::vector< walberla::float64 > _data_mat( 36 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[1] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[2] = ((uint64_t)(_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[3] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[4] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[5] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[1] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[2] = ((uint64_t)(_data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[3] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[4] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[5] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
         
             /* Apply basis transformation */
         
             const Eigen::DiagonalMatrix< real_t, 6 > basisTransformation = n1e1::macrocell::basisTransformation( level, cell, {ctr_0, ctr_1, ctr_2}, celldof::CellType::BLUE_UP );
         
             _data_mat[0] = ((walberla::float64)((basisTransformation.diagonal()(0)*basisTransformation.diagonal()(0))*elMat_0_0));
             _data_mat[1] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(1)*elMat_0_1));
             _data_mat[2] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(2)*elMat_0_2));
             _data_mat[3] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(3)*elMat_0_3));
             _data_mat[4] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(4)*elMat_0_4));
             _data_mat[5] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(5)*elMat_0_5));
             _data_mat[6] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(1)*elMat_1_0));
             _data_mat[7] = ((walberla::float64)((basisTransformation.diagonal()(1)*basisTransformation.diagonal()(1))*elMat_1_1));
             _data_mat[8] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(2)*elMat_1_2));
             _data_mat[9] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(3)*elMat_1_3));
             _data_mat[10] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(4)*elMat_1_4));
             _data_mat[11] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(5)*elMat_1_5));
             _data_mat[12] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(2)*elMat_2_0));
             _data_mat[13] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(2)*elMat_2_1));
             _data_mat[14] = ((walberla::float64)((basisTransformation.diagonal()(2)*basisTransformation.diagonal()(2))*elMat_2_2));
             _data_mat[15] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(3)*elMat_2_3));
             _data_mat[16] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(4)*elMat_2_4));
             _data_mat[17] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(5)*elMat_2_5));
             _data_mat[18] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(3)*elMat_3_0));
             _data_mat[19] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(3)*elMat_3_1));
             _data_mat[20] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(3)*elMat_3_2));
             _data_mat[21] = ((walberla::float64)((basisTransformation.diagonal()(3)*basisTransformation.diagonal()(3))*elMat_3_3));
             _data_mat[22] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(4)*elMat_3_4));
             _data_mat[23] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(5)*elMat_3_5));
             _data_mat[24] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(4)*elMat_4_0));
             _data_mat[25] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(4)*elMat_4_1));
             _data_mat[26] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(4)*elMat_4_2));
             _data_mat[27] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(4)*elMat_4_3));
             _data_mat[28] = ((walberla::float64)((basisTransformation.diagonal()(4)*basisTransformation.diagonal()(4))*elMat_4_4));
             _data_mat[29] = ((walberla::float64)(basisTransformation.diagonal()(4)*basisTransformation.diagonal()(5)*elMat_4_5));
             _data_mat[30] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(5)*elMat_5_0));
             _data_mat[31] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(5)*elMat_5_1));
             _data_mat[32] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(5)*elMat_5_2));
             _data_mat[33] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(5)*elMat_5_3));
             _data_mat[34] = ((walberla::float64)(basisTransformation.diagonal()(4)*basisTransformation.diagonal()(5)*elMat_5_4));
             _data_mat[35] = ((walberla::float64)((basisTransformation.diagonal()(5)*basisTransformation.diagonal()(5))*elMat_5_5));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const walberla::float64 tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const walberla::float64 tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const walberla::float64 tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const walberla::float64 tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const walberla::float64 tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const walberla::float64 tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const walberla::float64 tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const walberla::float64 tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const walberla::float64 p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const walberla::float64 p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const walberla::float64 p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const walberla::float64 p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const walberla::float64 p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const walberla::float64 p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const walberla::float64 p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const walberla::float64 p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const walberla::float64 p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const walberla::float64 p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const walberla::float64 p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const walberla::float64 p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const walberla::float64 jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const walberla::float64 jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const walberla::float64 jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const walberla::float64 jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const walberla::float64 jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const walberla::float64 jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const walberla::float64 jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const walberla::float64 jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_11_BLUE_DOWN = jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
       const walberla::float64 jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_10_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_0_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_0_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_0_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_1_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_1_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_2_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_2_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const walberla::float64 abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       {
          /* CellType.BLUE_DOWN */
          const walberla::float64 _data_phi_0_0_BLUE_DOWN [] = {0.12366680032845842, 0.82157254096761978, 0.039933048641498423, 0.01482761006242336, 0.45746158708559548, 0.15593312049918601, 0.3817653560693467, 0.0048399363458717648, 0.36531451881463445, 0.18002969351036541, 0.0069232355736274674, 0.44773255210137269, 0.00037551502872928966, 0.21607642918484779, 0.43070170707783612, 0.35284634870858678};
      
          const walberla::float64 _data_curl_curl_det_0_0_BLUE_DOWN [] = {1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_0_BLUE_DOWN*jac_affine_0_0_BLUE_DOWN)*4.0 + (jac_affine_1_0_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN)*4.0 + (jac_affine_2_0_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_0_BLUE_DOWN*jac_affine_0_1_BLUE_DOWN*-4.0 + jac_affine_1_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN*-4.0 + jac_affine_2_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN*-4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_0_BLUE_DOWN*jac_affine_0_2_BLUE_DOWN*4.0 + jac_affine_1_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN*4.0 + jac_affine_2_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN*4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_0_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*2.0 + jac_affine_1_0_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*2.0 + jac_affine_2_0_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_0_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)*2.0 + jac_affine_1_0_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)*2.0 + jac_affine_2_0_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_0_BLUE_DOWN*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0)*2.0 + jac_affine_1_0_BLUE_DOWN*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0)*2.0 + jac_affine_2_0_BLUE_DOWN*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_1_BLUE_DOWN*jac_affine_0_1_BLUE_DOWN)*4.0 + (jac_affine_1_1_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN)*4.0 + (jac_affine_2_1_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_1_BLUE_DOWN*jac_affine_0_2_BLUE_DOWN*-4.0 + jac_affine_1_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN*-4.0 + jac_affine_2_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN*-4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_1_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*-2.0 + jac_affine_1_1_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*-2.0 + jac_affine_2_1_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_1_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)*-2.0 + jac_affine_1_1_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)*-2.0 + jac_affine_2_1_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_1_BLUE_DOWN*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0)*-2.0 + jac_affine_1_1_BLUE_DOWN*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0)*-2.0 + jac_affine_2_1_BLUE_DOWN*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_2_BLUE_DOWN*jac_affine_0_2_BLUE_DOWN)*4.0 + (jac_affine_1_2_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN)*4.0 + (jac_affine_2_2_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_2_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*2.0 + jac_affine_1_2_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*2.0 + jac_affine_2_2_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_2_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)*2.0 + jac_affine_1_2_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)*2.0 + jac_affine_2_2_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_2_BLUE_DOWN*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0)*2.0 + jac_affine_1_2_BLUE_DOWN*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0)*2.0 + jac_affine_2_2_BLUE_DOWN*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(((jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*(jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)) + ((jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*(jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)) + ((jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*(jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0))), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*(jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0) + (jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*(jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0) + (jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*(jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0) + (jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0) + (jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(((jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)*(jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)) + ((jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)*(jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)) + ((jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)*(jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0))), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0) + (jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0) + (jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(((jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0)*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0)) + ((jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0)*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0)) + ((jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0))), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_0_BLUE_DOWN*jac_affine_0_0_BLUE_DOWN)*4.0 + (jac_affine_1_0_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN)*4.0 + (jac_affine_2_0_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_0_BLUE_DOWN*jac_affine_0_1_BLUE_DOWN*-4.0 + jac_affine_1_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN*-4.0 + jac_affine_2_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN*-4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_0_BLUE_DOWN*jac_affine_0_2_BLUE_DOWN*4.0 + jac_affine_1_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN*4.0 + jac_affine_2_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN*4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_0_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*2.0 + jac_affine_1_0_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*2.0 + jac_affine_2_0_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_0_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)*2.0 + jac_affine_1_0_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)*2.0 + jac_affine_2_0_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_0_BLUE_DOWN*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0)*2.0 + jac_affine_1_0_BLUE_DOWN*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0)*2.0 + jac_affine_2_0_BLUE_DOWN*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_1_BLUE_DOWN*jac_affine_0_1_BLUE_DOWN)*4.0 + (jac_affine_1_1_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN)*4.0 + (jac_affine_2_1_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_1_BLUE_DOWN*jac_affine_0_2_BLUE_DOWN*-4.0 + jac_affine_1_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN*-4.0 + jac_affine_2_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN*-4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_1_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*-2.0 + jac_affine_1_1_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*-2.0 + jac_affine_2_1_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_1_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)*-2.0 + jac_affine_1_1_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)*-2.0 + jac_affine_2_1_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_1_BLUE_DOWN*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0)*-2.0 + jac_affine_1_1_BLUE_DOWN*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0)*-2.0 + jac_affine_2_1_BLUE_DOWN*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_2_BLUE_DOWN*jac_affine_0_2_BLUE_DOWN)*4.0 + (jac_affine_1_2_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN)*4.0 + (jac_affine_2_2_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_2_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*2.0 + jac_affine_1_2_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*2.0 + jac_affine_2_2_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_2_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)*2.0 + jac_affine_1_2_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)*2.0 + jac_affine_2_2_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_2_BLUE_DOWN*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0)*2.0 + jac_affine_1_2_BLUE_DOWN*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0)*2.0 + jac_affine_2_2_BLUE_DOWN*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(((jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*(jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)) + ((jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*(jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)) + ((jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*(jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0))), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*(jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0) + (jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*(jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0) + (jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*(jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0) + (jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0) + (jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(((jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)*(jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)) + ((jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)*(jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)) + ((jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)*(jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0))), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0) + (jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0) + (jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(((jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0)*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0)) + ((jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0)*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0)) + ((jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0))), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_0_BLUE_DOWN*jac_affine_0_0_BLUE_DOWN)*4.0 + (jac_affine_1_0_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN)*4.0 + (jac_affine_2_0_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_0_BLUE_DOWN*jac_affine_0_1_BLUE_DOWN*-4.0 + jac_affine_1_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN*-4.0 + jac_affine_2_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN*-4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_0_BLUE_DOWN*jac_affine_0_2_BLUE_DOWN*4.0 + jac_affine_1_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN*4.0 + jac_affine_2_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN*4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_0_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*2.0 + jac_affine_1_0_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*2.0 + jac_affine_2_0_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_0_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)*2.0 + jac_affine_1_0_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)*2.0 + jac_affine_2_0_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_0_BLUE_DOWN*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0)*2.0 + jac_affine_1_0_BLUE_DOWN*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0)*2.0 + jac_affine_2_0_BLUE_DOWN*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_1_BLUE_DOWN*jac_affine_0_1_BLUE_DOWN)*4.0 + (jac_affine_1_1_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN)*4.0 + (jac_affine_2_1_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_1_BLUE_DOWN*jac_affine_0_2_BLUE_DOWN*-4.0 + jac_affine_1_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN*-4.0 + jac_affine_2_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN*-4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_1_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*-2.0 + jac_affine_1_1_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*-2.0 + jac_affine_2_1_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_1_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)*-2.0 + jac_affine_1_1_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)*-2.0 + jac_affine_2_1_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_1_BLUE_DOWN*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0)*-2.0 + jac_affine_1_1_BLUE_DOWN*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0)*-2.0 + jac_affine_2_1_BLUE_DOWN*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_2_BLUE_DOWN*jac_affine_0_2_BLUE_DOWN)*4.0 + (jac_affine_1_2_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN)*4.0 + (jac_affine_2_2_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_2_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*2.0 + jac_affine_1_2_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*2.0 + jac_affine_2_2_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_2_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)*2.0 + jac_affine_1_2_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)*2.0 + jac_affine_2_2_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_2_BLUE_DOWN*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0)*2.0 + jac_affine_1_2_BLUE_DOWN*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0)*2.0 + jac_affine_2_2_BLUE_DOWN*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(((jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*(jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)) + ((jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*(jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)) + ((jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*(jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0))), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*(jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0) + (jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*(jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0) + (jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*(jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0) + (jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0) + (jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(((jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)*(jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)) + ((jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)*(jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)) + ((jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)*(jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0))), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0) + (jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0) + (jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(((jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0)*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0)) + ((jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0)*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0)) + ((jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0))), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_0_BLUE_DOWN*jac_affine_0_0_BLUE_DOWN)*4.0 + (jac_affine_1_0_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN)*4.0 + (jac_affine_2_0_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_0_BLUE_DOWN*jac_affine_0_1_BLUE_DOWN*-4.0 + jac_affine_1_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN*-4.0 + jac_affine_2_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN*-4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_0_BLUE_DOWN*jac_affine_0_2_BLUE_DOWN*4.0 + jac_affine_1_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN*4.0 + jac_affine_2_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN*4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_0_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*2.0 + jac_affine_1_0_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*2.0 + jac_affine_2_0_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_0_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)*2.0 + jac_affine_1_0_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)*2.0 + jac_affine_2_0_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_0_BLUE_DOWN*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0)*2.0 + jac_affine_1_0_BLUE_DOWN*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0)*2.0 + jac_affine_2_0_BLUE_DOWN*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_1_BLUE_DOWN*jac_affine_0_1_BLUE_DOWN)*4.0 + (jac_affine_1_1_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN)*4.0 + (jac_affine_2_1_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_1_BLUE_DOWN*jac_affine_0_2_BLUE_DOWN*-4.0 + jac_affine_1_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN*-4.0 + jac_affine_2_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN*-4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_1_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*-2.0 + jac_affine_1_1_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*-2.0 + jac_affine_2_1_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_1_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)*-2.0 + jac_affine_1_1_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)*-2.0 + jac_affine_2_1_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_1_BLUE_DOWN*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0)*-2.0 + jac_affine_1_1_BLUE_DOWN*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0)*-2.0 + jac_affine_2_1_BLUE_DOWN*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_2_BLUE_DOWN*jac_affine_0_2_BLUE_DOWN)*4.0 + (jac_affine_1_2_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN)*4.0 + (jac_affine_2_2_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN)*4.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_2_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*2.0 + jac_affine_1_2_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*2.0 + jac_affine_2_2_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_2_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)*2.0 + jac_affine_1_2_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)*2.0 + jac_affine_2_2_BLUE_DOWN*(jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(jac_affine_0_2_BLUE_DOWN*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0)*2.0 + jac_affine_1_2_BLUE_DOWN*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0)*2.0 + jac_affine_2_2_BLUE_DOWN*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(((jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*(jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)) + ((jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*(jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)) + ((jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*(jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0))), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*(jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0) + (jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*(jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0) + (jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*(jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_0_BLUE_DOWN*-2.0 + jac_affine_0_1_BLUE_DOWN*2.0)*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0) + (jac_affine_1_0_BLUE_DOWN*-2.0 + jac_affine_1_1_BLUE_DOWN*2.0)*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0) + (jac_affine_2_0_BLUE_DOWN*-2.0 + jac_affine_2_1_BLUE_DOWN*2.0)*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(((jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)*(jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)) + ((jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)*(jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)) + ((jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)*(jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0))), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*((jac_affine_0_0_BLUE_DOWN*2.0 + jac_affine_0_2_BLUE_DOWN*-2.0)*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0) + (jac_affine_1_0_BLUE_DOWN*2.0 + jac_affine_1_2_BLUE_DOWN*-2.0)*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0) + (jac_affine_2_0_BLUE_DOWN*2.0 + jac_affine_2_2_BLUE_DOWN*-2.0)*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)), 1.0 / (abs_det_jac_affine_BLUE_DOWN)*(((jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0)*(jac_affine_0_1_BLUE_DOWN*-2.0 + jac_affine_0_2_BLUE_DOWN*2.0)) + ((jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0)*(jac_affine_1_1_BLUE_DOWN*-2.0 + jac_affine_1_2_BLUE_DOWN*2.0)) + ((jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)*(jac_affine_2_1_BLUE_DOWN*-2.0 + jac_affine_2_2_BLUE_DOWN*2.0)))};
      
          const walberla::float64 _data_mass_det_0_0_BLUE_DOWN [] = {abs_det_jac_affine_BLUE_DOWN*(((jac_affine_inv_1_0_BLUE_DOWN*-0.37131174720816351 + jac_affine_inv_2_0_BLUE_DOWN)*(jac_affine_inv_1_0_BLUE_DOWN*-0.37131174720816351 + jac_affine_inv_2_0_BLUE_DOWN))*0.0015946483738042789 + ((jac_affine_inv_1_1_BLUE_DOWN*-0.37131174720816351 + jac_affine_inv_2_1_BLUE_DOWN)*(jac_affine_inv_1_1_BLUE_DOWN*-0.37131174720816351 + jac_affine_inv_2_1_BLUE_DOWN))*0.0015946483738042789 + ((jac_affine_inv_1_2_BLUE_DOWN*-0.37131174720816351 + jac_affine_inv_2_2_BLUE_DOWN)*(jac_affine_inv_1_2_BLUE_DOWN*-0.37131174720816351 + jac_affine_inv_2_2_BLUE_DOWN))*0.0015946483738042789), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_1_0_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_BLUE_DOWN*0.039933048641498423) + (jac_affine_inv_0_1_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_1_1_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_BLUE_DOWN*0.039933048641498423) + (jac_affine_inv_0_2_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_1_2_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_BLUE_DOWN*0.039933048641498423)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.039933048641498423 + jac_affine_inv_1_0_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_1_0_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_BLUE_DOWN*0.039933048641498423) + (jac_affine_inv_0_1_BLUE_DOWN*-0.039933048641498423 + jac_affine_inv_1_1_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_1_1_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_BLUE_DOWN*0.039933048641498423) + (jac_affine_inv_0_2_BLUE_DOWN*-0.039933048641498423 + jac_affine_inv_1_2_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_1_2_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_BLUE_DOWN*0.039933048641498423)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_BLUE_DOWN*0.039933048641498423)*(jac_affine_inv_0_0_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_1_0_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_2_0_BLUE_DOWN*0.13849441039088178) + (jac_affine_inv_1_1_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_BLUE_DOWN*0.039933048641498423)*(jac_affine_inv_0_1_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_1_1_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_2_1_BLUE_DOWN*0.13849441039088178) + (jac_affine_inv_1_2_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_BLUE_DOWN*0.039933048641498423)*(jac_affine_inv_0_2_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_1_2_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_2_2_BLUE_DOWN*0.13849441039088178)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_BLUE_DOWN*0.039933048641498423)*(jac_affine_inv_0_0_BLUE_DOWN*0.039933048641498423 + jac_affine_inv_1_0_BLUE_DOWN*0.16359984896995686 + jac_affine_inv_2_0_BLUE_DOWN*0.039933048641498423) + (jac_affine_inv_1_1_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_BLUE_DOWN*0.039933048641498423)*(jac_affine_inv_0_1_BLUE_DOWN*0.039933048641498423 + jac_affine_inv_1_1_BLUE_DOWN*0.16359984896995686 + jac_affine_inv_2_1_BLUE_DOWN*0.039933048641498423) + (jac_affine_inv_1_2_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_BLUE_DOWN*0.039933048641498423)*(jac_affine_inv_0_2_BLUE_DOWN*0.039933048641498423 + jac_affine_inv_1_2_BLUE_DOWN*0.16359984896995686 + jac_affine_inv_2_2_BLUE_DOWN*0.039933048641498423)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_BLUE_DOWN*0.039933048641498423)*(jac_affine_inv_0_0_BLUE_DOWN*0.94523934129607823 + jac_affine_inv_1_0_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_0_BLUE_DOWN*0.82157254096761978) + (jac_affine_inv_1_1_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_BLUE_DOWN*0.039933048641498423)*(jac_affine_inv_0_1_BLUE_DOWN*0.94523934129607823 + jac_affine_inv_1_1_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_1_BLUE_DOWN*0.82157254096761978) + (jac_affine_inv_1_2_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_BLUE_DOWN*0.039933048641498423)*(jac_affine_inv_0_2_BLUE_DOWN*0.94523934129607823 + jac_affine_inv_1_2_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_2_BLUE_DOWN*0.82157254096761978)), abs_det_jac_affine_BLUE_DOWN*(((jac_affine_inv_0_0_BLUE_DOWN*-0.018047840358637001 + jac_affine_inv_2_0_BLUE_DOWN)*(jac_affine_inv_0_0_BLUE_DOWN*-0.018047840358637001 + jac_affine_inv_2_0_BLUE_DOWN))*0.67498144007199123 + ((jac_affine_inv_0_1_BLUE_DOWN*-0.018047840358637001 + jac_affine_inv_2_1_BLUE_DOWN)*(jac_affine_inv_0_1_BLUE_DOWN*-0.018047840358637001 + jac_affine_inv_2_1_BLUE_DOWN))*0.67498144007199123 + ((jac_affine_inv_0_2_BLUE_DOWN*-0.018047840358637001 + jac_affine_inv_2_2_BLUE_DOWN)*(jac_affine_inv_0_2_BLUE_DOWN*-0.018047840358637001 + jac_affine_inv_2_2_BLUE_DOWN))*0.67498144007199123), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_BLUE_DOWN*-0.039933048641498423 + jac_affine_inv_1_0_BLUE_DOWN*0.82157254096761978) + (jac_affine_inv_0_1_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_BLUE_DOWN*-0.039933048641498423 + jac_affine_inv_1_1_BLUE_DOWN*0.82157254096761978) + (jac_affine_inv_0_2_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_BLUE_DOWN*-0.039933048641498423 + jac_affine_inv_1_2_BLUE_DOWN*0.82157254096761978)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_1_0_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_2_0_BLUE_DOWN*0.13849441039088178) + (jac_affine_inv_0_1_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_1_1_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_2_1_BLUE_DOWN*0.13849441039088178) + (jac_affine_inv_0_2_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_1_2_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_2_2_BLUE_DOWN*0.13849441039088178)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_BLUE_DOWN*0.039933048641498423 + jac_affine_inv_1_0_BLUE_DOWN*0.16359984896995686 + jac_affine_inv_2_0_BLUE_DOWN*0.039933048641498423) + (jac_affine_inv_0_1_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_BLUE_DOWN*0.039933048641498423 + jac_affine_inv_1_1_BLUE_DOWN*0.16359984896995686 + jac_affine_inv_2_1_BLUE_DOWN*0.039933048641498423) + (jac_affine_inv_0_2_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_BLUE_DOWN*0.039933048641498423 + jac_affine_inv_1_2_BLUE_DOWN*0.16359984896995686 + jac_affine_inv_2_2_BLUE_DOWN*0.039933048641498423)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_BLUE_DOWN*0.94523934129607823 + jac_affine_inv_1_0_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_0_BLUE_DOWN*0.82157254096761978) + (jac_affine_inv_0_1_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_BLUE_DOWN*0.94523934129607823 + jac_affine_inv_1_1_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_1_BLUE_DOWN*0.82157254096761978) + (jac_affine_inv_0_2_BLUE_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_BLUE_DOWN*0.94523934129607823 + jac_affine_inv_1_2_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_2_BLUE_DOWN*0.82157254096761978)), abs_det_jac_affine_BLUE_DOWN*(((jac_affine_inv_0_0_BLUE_DOWN*-0.048605627196920013 + jac_affine_inv_1_0_BLUE_DOWN)*(jac_affine_inv_0_0_BLUE_DOWN*-0.048605627196920013 + jac_affine_inv_1_0_BLUE_DOWN))*0.67498144007199123 + ((jac_affine_inv_0_1_BLUE_DOWN*-0.048605627196920013 + jac_affine_inv_1_1_BLUE_DOWN)*(jac_affine_inv_0_1_BLUE_DOWN*-0.048605627196920013 + jac_affine_inv_1_1_BLUE_DOWN))*0.67498144007199123 + ((jac_affine_inv_0_2_BLUE_DOWN*-0.048605627196920013 + jac_affine_inv_1_2_BLUE_DOWN)*(jac_affine_inv_0_2_BLUE_DOWN*-0.048605627196920013 + jac_affine_inv_1_2_BLUE_DOWN))*0.67498144007199123), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.039933048641498423 + jac_affine_inv_1_0_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_1_0_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_2_0_BLUE_DOWN*0.13849441039088178) + (jac_affine_inv_0_1_BLUE_DOWN*-0.039933048641498423 + jac_affine_inv_1_1_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_1_1_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_2_1_BLUE_DOWN*0.13849441039088178) + (jac_affine_inv_0_2_BLUE_DOWN*-0.039933048641498423 + jac_affine_inv_1_2_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_1_2_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_2_2_BLUE_DOWN*0.13849441039088178)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.039933048641498423 + jac_affine_inv_1_0_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_BLUE_DOWN*0.039933048641498423 + jac_affine_inv_1_0_BLUE_DOWN*0.16359984896995686 + jac_affine_inv_2_0_BLUE_DOWN*0.039933048641498423) + (jac_affine_inv_0_1_BLUE_DOWN*-0.039933048641498423 + jac_affine_inv_1_1_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_BLUE_DOWN*0.039933048641498423 + jac_affine_inv_1_1_BLUE_DOWN*0.16359984896995686 + jac_affine_inv_2_1_BLUE_DOWN*0.039933048641498423) + (jac_affine_inv_0_2_BLUE_DOWN*-0.039933048641498423 + jac_affine_inv_1_2_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_BLUE_DOWN*0.039933048641498423 + jac_affine_inv_1_2_BLUE_DOWN*0.16359984896995686 + jac_affine_inv_2_2_BLUE_DOWN*0.039933048641498423)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.039933048641498423 + jac_affine_inv_1_0_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_BLUE_DOWN*0.94523934129607823 + jac_affine_inv_1_0_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_0_BLUE_DOWN*0.82157254096761978) + (jac_affine_inv_0_1_BLUE_DOWN*-0.039933048641498423 + jac_affine_inv_1_1_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_BLUE_DOWN*0.94523934129607823 + jac_affine_inv_1_1_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_1_BLUE_DOWN*0.82157254096761978) + (jac_affine_inv_0_2_BLUE_DOWN*-0.039933048641498423 + jac_affine_inv_1_2_BLUE_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_BLUE_DOWN*0.94523934129607823 + jac_affine_inv_1_2_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_2_BLUE_DOWN*0.82157254096761978)), abs_det_jac_affine_BLUE_DOWN*(((jac_affine_inv_0_0_BLUE_DOWN*0.10706287727117962 + jac_affine_inv_1_0_BLUE_DOWN*0.10706287727117962 + jac_affine_inv_2_0_BLUE_DOWN)*(jac_affine_inv_0_0_BLUE_DOWN*0.10706287727117962 + jac_affine_inv_1_0_BLUE_DOWN*0.10706287727117962 + jac_affine_inv_2_0_BLUE_DOWN))*0.019180701709517984 + ((jac_affine_inv_0_1_BLUE_DOWN*0.10706287727117962 + jac_affine_inv_1_1_BLUE_DOWN*0.10706287727117962 + jac_affine_inv_2_1_BLUE_DOWN)*(jac_affine_inv_0_1_BLUE_DOWN*0.10706287727117962 + jac_affine_inv_1_1_BLUE_DOWN*0.10706287727117962 + jac_affine_inv_2_1_BLUE_DOWN))*0.019180701709517984 + ((jac_affine_inv_0_2_BLUE_DOWN*0.10706287727117962 + jac_affine_inv_1_2_BLUE_DOWN*0.10706287727117962 + jac_affine_inv_2_2_BLUE_DOWN)*(jac_affine_inv_0_2_BLUE_DOWN*0.10706287727117962 + jac_affine_inv_1_2_BLUE_DOWN*0.10706287727117962 + jac_affine_inv_2_2_BLUE_DOWN))*0.019180701709517984), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_1_0_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_2_0_BLUE_DOWN*0.13849441039088178)*(jac_affine_inv_0_0_BLUE_DOWN*0.039933048641498423 + jac_affine_inv_1_0_BLUE_DOWN*0.16359984896995686 + jac_affine_inv_2_0_BLUE_DOWN*0.039933048641498423) + (jac_affine_inv_0_1_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_1_1_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_2_1_BLUE_DOWN*0.13849441039088178)*(jac_affine_inv_0_1_BLUE_DOWN*0.039933048641498423 + jac_affine_inv_1_1_BLUE_DOWN*0.16359984896995686 + jac_affine_inv_2_1_BLUE_DOWN*0.039933048641498423) + (jac_affine_inv_0_2_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_1_2_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_2_2_BLUE_DOWN*0.13849441039088178)*(jac_affine_inv_0_2_BLUE_DOWN*0.039933048641498423 + jac_affine_inv_1_2_BLUE_DOWN*0.16359984896995686 + jac_affine_inv_2_2_BLUE_DOWN*0.039933048641498423)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_1_0_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_2_0_BLUE_DOWN*0.13849441039088178)*(jac_affine_inv_0_0_BLUE_DOWN*0.94523934129607823 + jac_affine_inv_1_0_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_0_BLUE_DOWN*0.82157254096761978) + (jac_affine_inv_0_1_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_1_1_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_2_1_BLUE_DOWN*0.13849441039088178)*(jac_affine_inv_0_1_BLUE_DOWN*0.94523934129607823 + jac_affine_inv_1_1_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_1_BLUE_DOWN*0.82157254096761978) + (jac_affine_inv_0_2_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_1_2_BLUE_DOWN*0.01482761006242336 + jac_affine_inv_2_2_BLUE_DOWN*0.13849441039088178)*(jac_affine_inv_0_2_BLUE_DOWN*0.94523934129607823 + jac_affine_inv_1_2_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_2_BLUE_DOWN*0.82157254096761978)), abs_det_jac_affine_BLUE_DOWN*(((jac_affine_inv_0_0_BLUE_DOWN*0.2440897647089616 + jac_affine_inv_1_0_BLUE_DOWN + jac_affine_inv_2_0_BLUE_DOWN*0.2440897647089616)*(jac_affine_inv_0_0_BLUE_DOWN*0.2440897647089616 + jac_affine_inv_1_0_BLUE_DOWN + jac_affine_inv_2_0_BLUE_DOWN*0.2440897647089616))*0.026764910582992695 + ((jac_affine_inv_0_1_BLUE_DOWN*0.2440897647089616 + jac_affine_inv_1_1_BLUE_DOWN + jac_affine_inv_2_1_BLUE_DOWN*0.2440897647089616)*(jac_affine_inv_0_1_BLUE_DOWN*0.2440897647089616 + jac_affine_inv_1_1_BLUE_DOWN + jac_affine_inv_2_1_BLUE_DOWN*0.2440897647089616))*0.026764910582992695 + ((jac_affine_inv_0_2_BLUE_DOWN*0.2440897647089616 + jac_affine_inv_1_2_BLUE_DOWN + jac_affine_inv_2_2_BLUE_DOWN*0.2440897647089616)*(jac_affine_inv_0_2_BLUE_DOWN*0.2440897647089616 + jac_affine_inv_1_2_BLUE_DOWN + jac_affine_inv_2_2_BLUE_DOWN*0.2440897647089616))*0.026764910582992695), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.039933048641498423 + jac_affine_inv_1_0_BLUE_DOWN*0.16359984896995686 + jac_affine_inv_2_0_BLUE_DOWN*0.039933048641498423)*(jac_affine_inv_0_0_BLUE_DOWN*0.94523934129607823 + jac_affine_inv_1_0_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_0_BLUE_DOWN*0.82157254096761978) + (jac_affine_inv_0_1_BLUE_DOWN*0.039933048641498423 + jac_affine_inv_1_1_BLUE_DOWN*0.16359984896995686 + jac_affine_inv_2_1_BLUE_DOWN*0.039933048641498423)*(jac_affine_inv_0_1_BLUE_DOWN*0.94523934129607823 + jac_affine_inv_1_1_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_1_BLUE_DOWN*0.82157254096761978) + (jac_affine_inv_0_2_BLUE_DOWN*0.039933048641498423 + jac_affine_inv_1_2_BLUE_DOWN*0.16359984896995686 + jac_affine_inv_2_2_BLUE_DOWN*0.039933048641498423)*(jac_affine_inv_0_2_BLUE_DOWN*0.94523934129607823 + jac_affine_inv_1_2_BLUE_DOWN*0.82157254096761978 + jac_affine_inv_2_2_BLUE_DOWN*0.82157254096761978)), abs_det_jac_affine_BLUE_DOWN*(((jac_affine_inv_0_0_BLUE_DOWN + jac_affine_inv_1_0_BLUE_DOWN*0.86916879680558901 + jac_affine_inv_2_0_BLUE_DOWN*0.86916879680558901)*(jac_affine_inv_0_0_BLUE_DOWN + jac_affine_inv_1_0_BLUE_DOWN*0.86916879680558901 + jac_affine_inv_2_0_BLUE_DOWN*0.86916879680558901))*0.89347741233384381 + ((jac_affine_inv_0_1_BLUE_DOWN + jac_affine_inv_1_1_BLUE_DOWN*0.86916879680558901 + jac_affine_inv_2_1_BLUE_DOWN*0.86916879680558901)*(jac_affine_inv_0_1_BLUE_DOWN + jac_affine_inv_1_1_BLUE_DOWN*0.86916879680558901 + jac_affine_inv_2_1_BLUE_DOWN*0.86916879680558901))*0.89347741233384381 + ((jac_affine_inv_0_2_BLUE_DOWN + jac_affine_inv_1_2_BLUE_DOWN*0.86916879680558901 + jac_affine_inv_2_2_BLUE_DOWN*0.86916879680558901)*(jac_affine_inv_0_2_BLUE_DOWN + jac_affine_inv_1_2_BLUE_DOWN*0.86916879680558901 + jac_affine_inv_2_2_BLUE_DOWN*0.86916879680558901))*0.89347741233384381), abs_det_jac_affine_BLUE_DOWN*(((jac_affine_inv_1_0_BLUE_DOWN*-0.012677777773509136 + jac_affine_inv_2_0_BLUE_DOWN)*(jac_affine_inv_1_0_BLUE_DOWN*-0.012677777773509136 + jac_affine_inv_2_0_BLUE_DOWN))*0.14574478709475508 + ((jac_affine_inv_1_1_BLUE_DOWN*-0.012677777773509136 + jac_affine_inv_2_1_BLUE_DOWN)*(jac_affine_inv_1_1_BLUE_DOWN*-0.012677777773509136 + jac_affine_inv_2_1_BLUE_DOWN))*0.14574478709475508 + ((jac_affine_inv_1_2_BLUE_DOWN*-0.012677777773509136 + jac_affine_inv_2_2_BLUE_DOWN)*(jac_affine_inv_1_2_BLUE_DOWN*-0.012677777773509136 + jac_affine_inv_2_2_BLUE_DOWN))*0.14574478709475508), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_1_0_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_BLUE_DOWN*0.3817653560693467) + (jac_affine_inv_0_1_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_1_1_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_BLUE_DOWN*0.3817653560693467) + (jac_affine_inv_0_2_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_1_2_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_BLUE_DOWN*0.3817653560693467)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.3817653560693467 + jac_affine_inv_1_0_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_1_0_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_BLUE_DOWN*0.3817653560693467) + (jac_affine_inv_0_1_BLUE_DOWN*-0.3817653560693467 + jac_affine_inv_1_1_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_1_1_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_BLUE_DOWN*0.3817653560693467) + (jac_affine_inv_0_2_BLUE_DOWN*-0.3817653560693467 + jac_affine_inv_1_2_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_1_2_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_BLUE_DOWN*0.3817653560693467)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_BLUE_DOWN*0.3817653560693467)*(jac_affine_inv_0_0_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_1_0_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_2_0_BLUE_DOWN*0.46230152343146724) + (jac_affine_inv_1_1_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_BLUE_DOWN*0.3817653560693467)*(jac_affine_inv_0_1_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_1_1_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_2_1_BLUE_DOWN*0.46230152343146724) + (jac_affine_inv_1_2_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_BLUE_DOWN*0.3817653560693467)*(jac_affine_inv_0_2_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_1_2_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_2_2_BLUE_DOWN*0.46230152343146724)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_BLUE_DOWN*0.3817653560693467)*(jac_affine_inv_0_0_BLUE_DOWN*0.3817653560693467 + jac_affine_inv_1_0_BLUE_DOWN*0.83922694315494217 + jac_affine_inv_2_0_BLUE_DOWN*0.3817653560693467) + (jac_affine_inv_1_1_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_BLUE_DOWN*0.3817653560693467)*(jac_affine_inv_0_1_BLUE_DOWN*0.3817653560693467 + jac_affine_inv_1_1_BLUE_DOWN*0.83922694315494217 + jac_affine_inv_2_1_BLUE_DOWN*0.3817653560693467) + (jac_affine_inv_1_2_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_BLUE_DOWN*0.3817653560693467)*(jac_affine_inv_0_2_BLUE_DOWN*0.3817653560693467 + jac_affine_inv_1_2_BLUE_DOWN*0.83922694315494217 + jac_affine_inv_2_2_BLUE_DOWN*0.3817653560693467)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_BLUE_DOWN*0.3817653560693467)*(jac_affine_inv_0_0_BLUE_DOWN*0.61339470758478154 + jac_affine_inv_1_0_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_0_BLUE_DOWN*0.15593312049918601) + (jac_affine_inv_1_1_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_BLUE_DOWN*0.3817653560693467)*(jac_affine_inv_0_1_BLUE_DOWN*0.61339470758478154 + jac_affine_inv_1_1_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_1_BLUE_DOWN*0.15593312049918601) + (jac_affine_inv_1_2_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_BLUE_DOWN*0.3817653560693467)*(jac_affine_inv_0_2_BLUE_DOWN*0.61339470758478154 + jac_affine_inv_1_2_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_2_BLUE_DOWN*0.15593312049918601)), abs_det_jac_affine_BLUE_DOWN*(((jac_affine_inv_0_0_BLUE_DOWN*-0.031038539666093771 + jac_affine_inv_2_0_BLUE_DOWN)*(jac_affine_inv_0_0_BLUE_DOWN*-0.031038539666093771 + jac_affine_inv_2_0_BLUE_DOWN))*0.024315138068613663 + ((jac_affine_inv_0_1_BLUE_DOWN*-0.031038539666093771 + jac_affine_inv_2_1_BLUE_DOWN)*(jac_affine_inv_0_1_BLUE_DOWN*-0.031038539666093771 + jac_affine_inv_2_1_BLUE_DOWN))*0.024315138068613663 + ((jac_affine_inv_0_2_BLUE_DOWN*-0.031038539666093771 + jac_affine_inv_2_2_BLUE_DOWN)*(jac_affine_inv_0_2_BLUE_DOWN*-0.031038539666093771 + jac_affine_inv_2_2_BLUE_DOWN))*0.024315138068613663), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_BLUE_DOWN*-0.3817653560693467 + jac_affine_inv_1_0_BLUE_DOWN*0.15593312049918601) + (jac_affine_inv_0_1_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_BLUE_DOWN*-0.3817653560693467 + jac_affine_inv_1_1_BLUE_DOWN*0.15593312049918601) + (jac_affine_inv_0_2_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_BLUE_DOWN*-0.3817653560693467 + jac_affine_inv_1_2_BLUE_DOWN*0.15593312049918601)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_1_0_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_2_0_BLUE_DOWN*0.46230152343146724) + (jac_affine_inv_0_1_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_1_1_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_2_1_BLUE_DOWN*0.46230152343146724) + (jac_affine_inv_0_2_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_1_2_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_2_2_BLUE_DOWN*0.46230152343146724)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_BLUE_DOWN*0.3817653560693467 + jac_affine_inv_1_0_BLUE_DOWN*0.83922694315494217 + jac_affine_inv_2_0_BLUE_DOWN*0.3817653560693467) + (jac_affine_inv_0_1_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_BLUE_DOWN*0.3817653560693467 + jac_affine_inv_1_1_BLUE_DOWN*0.83922694315494217 + jac_affine_inv_2_1_BLUE_DOWN*0.3817653560693467) + (jac_affine_inv_0_2_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_BLUE_DOWN*0.3817653560693467 + jac_affine_inv_1_2_BLUE_DOWN*0.83922694315494217 + jac_affine_inv_2_2_BLUE_DOWN*0.3817653560693467)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_BLUE_DOWN*0.61339470758478154 + jac_affine_inv_1_0_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_0_BLUE_DOWN*0.15593312049918601) + (jac_affine_inv_0_1_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_BLUE_DOWN*0.61339470758478154 + jac_affine_inv_1_1_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_1_BLUE_DOWN*0.15593312049918601) + (jac_affine_inv_0_2_BLUE_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_BLUE_DOWN*0.61339470758478154 + jac_affine_inv_1_2_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_2_BLUE_DOWN*0.15593312049918601)), abs_det_jac_affine_BLUE_DOWN*(((-jac_affine_inv_0_0_BLUE_DOWN + jac_affine_inv_1_0_BLUE_DOWN*0.40845277870331731)*(-jac_affine_inv_0_0_BLUE_DOWN + jac_affine_inv_1_0_BLUE_DOWN*0.40845277870331731))*0.14574478709475508 + ((-jac_affine_inv_0_1_BLUE_DOWN + jac_affine_inv_1_1_BLUE_DOWN*0.40845277870331731)*(-jac_affine_inv_0_1_BLUE_DOWN + jac_affine_inv_1_1_BLUE_DOWN*0.40845277870331731))*0.14574478709475508 + ((-jac_affine_inv_0_2_BLUE_DOWN + jac_affine_inv_1_2_BLUE_DOWN*0.40845277870331731)*(-jac_affine_inv_0_2_BLUE_DOWN + jac_affine_inv_1_2_BLUE_DOWN*0.40845277870331731))*0.14574478709475508), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.3817653560693467 + jac_affine_inv_1_0_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_1_0_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_2_0_BLUE_DOWN*0.46230152343146724) + (jac_affine_inv_0_1_BLUE_DOWN*-0.3817653560693467 + jac_affine_inv_1_1_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_1_1_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_2_1_BLUE_DOWN*0.46230152343146724) + (jac_affine_inv_0_2_BLUE_DOWN*-0.3817653560693467 + jac_affine_inv_1_2_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_1_2_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_2_2_BLUE_DOWN*0.46230152343146724)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.3817653560693467 + jac_affine_inv_1_0_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_BLUE_DOWN*0.3817653560693467 + jac_affine_inv_1_0_BLUE_DOWN*0.83922694315494217 + jac_affine_inv_2_0_BLUE_DOWN*0.3817653560693467) + (jac_affine_inv_0_1_BLUE_DOWN*-0.3817653560693467 + jac_affine_inv_1_1_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_BLUE_DOWN*0.3817653560693467 + jac_affine_inv_1_1_BLUE_DOWN*0.83922694315494217 + jac_affine_inv_2_1_BLUE_DOWN*0.3817653560693467) + (jac_affine_inv_0_2_BLUE_DOWN*-0.3817653560693467 + jac_affine_inv_1_2_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_BLUE_DOWN*0.3817653560693467 + jac_affine_inv_1_2_BLUE_DOWN*0.83922694315494217 + jac_affine_inv_2_2_BLUE_DOWN*0.3817653560693467)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.3817653560693467 + jac_affine_inv_1_0_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_BLUE_DOWN*0.61339470758478154 + jac_affine_inv_1_0_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_0_BLUE_DOWN*0.15593312049918601) + (jac_affine_inv_0_1_BLUE_DOWN*-0.3817653560693467 + jac_affine_inv_1_1_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_BLUE_DOWN*0.61339470758478154 + jac_affine_inv_1_1_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_1_BLUE_DOWN*0.15593312049918601) + (jac_affine_inv_0_2_BLUE_DOWN*-0.3817653560693467 + jac_affine_inv_1_2_BLUE_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_BLUE_DOWN*0.61339470758478154 + jac_affine_inv_1_2_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_2_BLUE_DOWN*0.15593312049918601)), abs_det_jac_affine_BLUE_DOWN*(((jac_affine_inv_0_0_BLUE_DOWN*0.010469219979953731 + jac_affine_inv_1_0_BLUE_DOWN*0.010469219979953731 + jac_affine_inv_2_0_BLUE_DOWN)*(jac_affine_inv_0_0_BLUE_DOWN*0.010469219979953731 + jac_affine_inv_1_0_BLUE_DOWN*0.010469219979953731 + jac_affine_inv_2_0_BLUE_DOWN))*0.21372269856705545 + ((jac_affine_inv_0_1_BLUE_DOWN*0.010469219979953731 + jac_affine_inv_1_1_BLUE_DOWN*0.010469219979953731 + jac_affine_inv_2_1_BLUE_DOWN)*(jac_affine_inv_0_1_BLUE_DOWN*0.010469219979953731 + jac_affine_inv_1_1_BLUE_DOWN*0.010469219979953731 + jac_affine_inv_2_1_BLUE_DOWN))*0.21372269856705545 + ((jac_affine_inv_0_2_BLUE_DOWN*0.010469219979953731 + jac_affine_inv_1_2_BLUE_DOWN*0.010469219979953731 + jac_affine_inv_2_2_BLUE_DOWN)*(jac_affine_inv_0_2_BLUE_DOWN*0.010469219979953731 + jac_affine_inv_1_2_BLUE_DOWN*0.010469219979953731 + jac_affine_inv_2_2_BLUE_DOWN))*0.21372269856705545), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_1_0_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_2_0_BLUE_DOWN*0.46230152343146724)*(jac_affine_inv_0_0_BLUE_DOWN*0.3817653560693467 + jac_affine_inv_1_0_BLUE_DOWN*0.83922694315494217 + jac_affine_inv_2_0_BLUE_DOWN*0.3817653560693467) + (jac_affine_inv_0_1_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_1_1_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_2_1_BLUE_DOWN*0.46230152343146724)*(jac_affine_inv_0_1_BLUE_DOWN*0.3817653560693467 + jac_affine_inv_1_1_BLUE_DOWN*0.83922694315494217 + jac_affine_inv_2_1_BLUE_DOWN*0.3817653560693467) + (jac_affine_inv_0_2_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_1_2_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_2_2_BLUE_DOWN*0.46230152343146724)*(jac_affine_inv_0_2_BLUE_DOWN*0.3817653560693467 + jac_affine_inv_1_2_BLUE_DOWN*0.83922694315494217 + jac_affine_inv_2_2_BLUE_DOWN*0.3817653560693467)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_1_0_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_2_0_BLUE_DOWN*0.46230152343146724)*(jac_affine_inv_0_0_BLUE_DOWN*0.61339470758478154 + jac_affine_inv_1_0_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_0_BLUE_DOWN*0.15593312049918601) + (jac_affine_inv_0_1_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_1_1_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_2_1_BLUE_DOWN*0.46230152343146724)*(jac_affine_inv_0_1_BLUE_DOWN*0.61339470758478154 + jac_affine_inv_1_1_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_1_BLUE_DOWN*0.15593312049918601) + (jac_affine_inv_0_2_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_1_2_BLUE_DOWN*0.0048399363458717648 + jac_affine_inv_2_2_BLUE_DOWN*0.46230152343146724)*(jac_affine_inv_0_2_BLUE_DOWN*0.61339470758478154 + jac_affine_inv_1_2_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_2_BLUE_DOWN*0.15593312049918601)), abs_det_jac_affine_BLUE_DOWN*(((jac_affine_inv_0_0_BLUE_DOWN*0.45490121496118757 + jac_affine_inv_1_0_BLUE_DOWN + jac_affine_inv_2_0_BLUE_DOWN*0.45490121496118757)*(jac_affine_inv_0_0_BLUE_DOWN*0.45490121496118757 + jac_affine_inv_1_0_BLUE_DOWN + jac_affine_inv_2_0_BLUE_DOWN*0.45490121496118757))*0.70430186211718859 + ((jac_affine_inv_0_1_BLUE_DOWN*0.45490121496118757 + jac_affine_inv_1_1_BLUE_DOWN + jac_affine_inv_2_1_BLUE_DOWN*0.45490121496118757)*(jac_affine_inv_0_1_BLUE_DOWN*0.45490121496118757 + jac_affine_inv_1_1_BLUE_DOWN + jac_affine_inv_2_1_BLUE_DOWN*0.45490121496118757))*0.70430186211718859 + ((jac_affine_inv_0_2_BLUE_DOWN*0.45490121496118757 + jac_affine_inv_1_2_BLUE_DOWN + jac_affine_inv_2_2_BLUE_DOWN*0.45490121496118757)*(jac_affine_inv_0_2_BLUE_DOWN*0.45490121496118757 + jac_affine_inv_1_2_BLUE_DOWN + jac_affine_inv_2_2_BLUE_DOWN*0.45490121496118757))*0.70430186211718859), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.3817653560693467 + jac_affine_inv_1_0_BLUE_DOWN*0.83922694315494217 + jac_affine_inv_2_0_BLUE_DOWN*0.3817653560693467)*(jac_affine_inv_0_0_BLUE_DOWN*0.61339470758478154 + jac_affine_inv_1_0_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_0_BLUE_DOWN*0.15593312049918601) + (jac_affine_inv_0_1_BLUE_DOWN*0.3817653560693467 + jac_affine_inv_1_1_BLUE_DOWN*0.83922694315494217 + jac_affine_inv_2_1_BLUE_DOWN*0.3817653560693467)*(jac_affine_inv_0_1_BLUE_DOWN*0.61339470758478154 + jac_affine_inv_1_1_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_1_BLUE_DOWN*0.15593312049918601) + (jac_affine_inv_0_2_BLUE_DOWN*0.3817653560693467 + jac_affine_inv_1_2_BLUE_DOWN*0.83922694315494217 + jac_affine_inv_2_2_BLUE_DOWN*0.3817653560693467)*(jac_affine_inv_0_2_BLUE_DOWN*0.61339470758478154 + jac_affine_inv_1_2_BLUE_DOWN*0.15593312049918601 + jac_affine_inv_2_2_BLUE_DOWN*0.15593312049918601)), abs_det_jac_affine_BLUE_DOWN*(((jac_affine_inv_0_0_BLUE_DOWN + jac_affine_inv_1_0_BLUE_DOWN*0.25421334512840316 + jac_affine_inv_2_0_BLUE_DOWN*0.25421334512840316)*(jac_affine_inv_0_0_BLUE_DOWN + jac_affine_inv_1_0_BLUE_DOWN*0.25421334512840316 + jac_affine_inv_2_0_BLUE_DOWN*0.25421334512840316))*0.37625306729301966 + ((jac_affine_inv_0_1_BLUE_DOWN + jac_affine_inv_1_1_BLUE_DOWN*0.25421334512840316 + jac_affine_inv_2_1_BLUE_DOWN*0.25421334512840316)*(jac_affine_inv_0_1_BLUE_DOWN + jac_affine_inv_1_1_BLUE_DOWN*0.25421334512840316 + jac_affine_inv_2_1_BLUE_DOWN*0.25421334512840316))*0.37625306729301966 + ((jac_affine_inv_0_2_BLUE_DOWN + jac_affine_inv_1_2_BLUE_DOWN*0.25421334512840316 + jac_affine_inv_2_2_BLUE_DOWN*0.25421334512840316)*(jac_affine_inv_0_2_BLUE_DOWN + jac_affine_inv_1_2_BLUE_DOWN*0.25421334512840316 + jac_affine_inv_2_2_BLUE_DOWN*0.25421334512840316))*0.37625306729301966), abs_det_jac_affine_BLUE_DOWN*(((-jac_affine_inv_1_0_BLUE_DOWN + jac_affine_inv_2_0_BLUE_DOWN*0.015462881894859308)*(-jac_affine_inv_1_0_BLUE_DOWN + jac_affine_inv_2_0_BLUE_DOWN*0.015462881894859308))*0.20046443821120841 + ((-jac_affine_inv_1_1_BLUE_DOWN + jac_affine_inv_2_1_BLUE_DOWN*0.015462881894859308)*(-jac_affine_inv_1_1_BLUE_DOWN + jac_affine_inv_2_1_BLUE_DOWN*0.015462881894859308))*0.20046443821120841 + ((-jac_affine_inv_1_2_BLUE_DOWN + jac_affine_inv_2_2_BLUE_DOWN*0.015462881894859308)*(-jac_affine_inv_1_2_BLUE_DOWN + jac_affine_inv_2_2_BLUE_DOWN*0.015462881894859308))*0.20046443821120841), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_1_0_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_BLUE_DOWN*0.0069232355736274674) + (jac_affine_inv_0_1_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_1_1_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_BLUE_DOWN*0.0069232355736274674) + (jac_affine_inv_0_2_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_1_2_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_BLUE_DOWN*0.0069232355736274674)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_0_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_1_0_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_BLUE_DOWN*0.0069232355736274674) + (jac_affine_inv_0_1_BLUE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_1_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_1_1_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_BLUE_DOWN*0.0069232355736274674) + (jac_affine_inv_0_2_BLUE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_2_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_1_2_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_BLUE_DOWN*0.0069232355736274674)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_BLUE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_0_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_1_0_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_2_0_BLUE_DOWN*0.81304707091600714) + (jac_affine_inv_1_1_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_BLUE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_1_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_1_1_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_2_1_BLUE_DOWN*0.81304707091600714) + (jac_affine_inv_1_2_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_BLUE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_2_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_1_2_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_2_2_BLUE_DOWN*0.81304707091600714)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_BLUE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_0_BLUE_DOWN*0.0069232355736274674 + jac_affine_inv_1_0_BLUE_DOWN*0.37223775438826195 + jac_affine_inv_2_0_BLUE_DOWN*0.0069232355736274674) + (jac_affine_inv_1_1_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_BLUE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_1_BLUE_DOWN*0.0069232355736274674 + jac_affine_inv_1_1_BLUE_DOWN*0.37223775438826195 + jac_affine_inv_2_1_BLUE_DOWN*0.0069232355736274674) + (jac_affine_inv_1_2_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_BLUE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_2_BLUE_DOWN*0.0069232355736274674 + jac_affine_inv_1_2_BLUE_DOWN*0.37223775438826195 + jac_affine_inv_2_2_BLUE_DOWN*0.0069232355736274674)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_BLUE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_0_BLUE_DOWN*0.54534421232499986 + jac_affine_inv_1_0_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_0_BLUE_DOWN*0.18002969351036541) + (jac_affine_inv_1_1_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_BLUE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_1_BLUE_DOWN*0.54534421232499986 + jac_affine_inv_1_1_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_1_BLUE_DOWN*0.18002969351036541) + (jac_affine_inv_1_2_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_BLUE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_2_BLUE_DOWN*0.54534421232499986 + jac_affine_inv_1_2_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_2_BLUE_DOWN*0.18002969351036541)), abs_det_jac_affine_BLUE_DOWN*(((-jac_affine_inv_0_0_BLUE_DOWN + jac_affine_inv_2_0_BLUE_DOWN*0.40209203611714223)*(-jac_affine_inv_0_0_BLUE_DOWN + jac_affine_inv_2_0_BLUE_DOWN*0.40209203611714223))*0.20046443821120841 + ((-jac_affine_inv_0_1_BLUE_DOWN + jac_affine_inv_2_1_BLUE_DOWN*0.40209203611714223)*(-jac_affine_inv_0_1_BLUE_DOWN + jac_affine_inv_2_1_BLUE_DOWN*0.40209203611714223))*0.20046443821120841 + ((-jac_affine_inv_0_2_BLUE_DOWN + jac_affine_inv_2_2_BLUE_DOWN*0.40209203611714223)*(-jac_affine_inv_0_2_BLUE_DOWN + jac_affine_inv_2_2_BLUE_DOWN*0.40209203611714223))*0.20046443821120841), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_0_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_BLUE_DOWN*0.18002969351036541) + (jac_affine_inv_0_1_BLUE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_1_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_BLUE_DOWN*0.18002969351036541) + (jac_affine_inv_0_2_BLUE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_2_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_BLUE_DOWN*0.18002969351036541)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_1_0_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_2_0_BLUE_DOWN*0.81304707091600714) + (jac_affine_inv_0_1_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_1_1_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_2_1_BLUE_DOWN*0.81304707091600714) + (jac_affine_inv_0_2_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_1_2_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_2_2_BLUE_DOWN*0.81304707091600714)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_BLUE_DOWN*0.0069232355736274674 + jac_affine_inv_1_0_BLUE_DOWN*0.37223775438826195 + jac_affine_inv_2_0_BLUE_DOWN*0.0069232355736274674) + (jac_affine_inv_0_1_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_BLUE_DOWN*0.0069232355736274674 + jac_affine_inv_1_1_BLUE_DOWN*0.37223775438826195 + jac_affine_inv_2_1_BLUE_DOWN*0.0069232355736274674) + (jac_affine_inv_0_2_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_BLUE_DOWN*0.0069232355736274674 + jac_affine_inv_1_2_BLUE_DOWN*0.37223775438826195 + jac_affine_inv_2_2_BLUE_DOWN*0.0069232355736274674)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_BLUE_DOWN*0.54534421232499986 + jac_affine_inv_1_0_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_0_BLUE_DOWN*0.18002969351036541) + (jac_affine_inv_0_1_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_BLUE_DOWN*0.54534421232499986 + jac_affine_inv_1_1_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_1_BLUE_DOWN*0.18002969351036541) + (jac_affine_inv_0_2_BLUE_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_BLUE_DOWN*0.54534421232499986 + jac_affine_inv_1_2_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_2_BLUE_DOWN*0.18002969351036541)), abs_det_jac_affine_BLUE_DOWN*(((jac_affine_inv_0_0_BLUE_DOWN*-0.03845607598742512 + jac_affine_inv_1_0_BLUE_DOWN)*(jac_affine_inv_0_0_BLUE_DOWN*-0.03845607598742512 + jac_affine_inv_1_0_BLUE_DOWN))*0.032410690545436105 + ((jac_affine_inv_0_1_BLUE_DOWN*-0.03845607598742512 + jac_affine_inv_1_1_BLUE_DOWN)*(jac_affine_inv_0_1_BLUE_DOWN*-0.03845607598742512 + jac_affine_inv_1_1_BLUE_DOWN))*0.032410690545436105 + ((jac_affine_inv_0_2_BLUE_DOWN*-0.03845607598742512 + jac_affine_inv_1_2_BLUE_DOWN)*(jac_affine_inv_0_2_BLUE_DOWN*-0.03845607598742512 + jac_affine_inv_1_2_BLUE_DOWN))*0.032410690545436105), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_0_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_1_0_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_2_0_BLUE_DOWN*0.81304707091600714) + (jac_affine_inv_0_1_BLUE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_1_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_1_1_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_2_1_BLUE_DOWN*0.81304707091600714) + (jac_affine_inv_0_2_BLUE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_2_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_1_2_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_2_2_BLUE_DOWN*0.81304707091600714)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_0_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_BLUE_DOWN*0.0069232355736274674 + jac_affine_inv_1_0_BLUE_DOWN*0.37223775438826195 + jac_affine_inv_2_0_BLUE_DOWN*0.0069232355736274674) + (jac_affine_inv_0_1_BLUE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_1_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_BLUE_DOWN*0.0069232355736274674 + jac_affine_inv_1_1_BLUE_DOWN*0.37223775438826195 + jac_affine_inv_2_1_BLUE_DOWN*0.0069232355736274674) + (jac_affine_inv_0_2_BLUE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_2_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_BLUE_DOWN*0.0069232355736274674 + jac_affine_inv_1_2_BLUE_DOWN*0.37223775438826195 + jac_affine_inv_2_2_BLUE_DOWN*0.0069232355736274674)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_0_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_BLUE_DOWN*0.54534421232499986 + jac_affine_inv_1_0_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_0_BLUE_DOWN*0.18002969351036541) + (jac_affine_inv_0_1_BLUE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_1_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_BLUE_DOWN*0.54534421232499986 + jac_affine_inv_1_1_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_1_BLUE_DOWN*0.18002969351036541) + (jac_affine_inv_0_2_BLUE_DOWN*-0.0069232355736274674 + jac_affine_inv_1_2_BLUE_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_BLUE_DOWN*0.54534421232499986 + jac_affine_inv_1_2_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_2_BLUE_DOWN*0.18002969351036541)), abs_det_jac_affine_BLUE_DOWN*(((jac_affine_inv_0_0_BLUE_DOWN*0.55068466281655948 + jac_affine_inv_1_0_BLUE_DOWN*0.55068466281655948 + jac_affine_inv_2_0_BLUE_DOWN)*(jac_affine_inv_0_0_BLUE_DOWN*0.55068466281655948 + jac_affine_inv_1_0_BLUE_DOWN*0.55068466281655948 + jac_affine_inv_2_0_BLUE_DOWN))*0.6610455395250987 + ((jac_affine_inv_0_1_BLUE_DOWN*0.55068466281655948 + jac_affine_inv_1_1_BLUE_DOWN*0.55068466281655948 + jac_affine_inv_2_1_BLUE_DOWN)*(jac_affine_inv_0_1_BLUE_DOWN*0.55068466281655948 + jac_affine_inv_1_1_BLUE_DOWN*0.55068466281655948 + jac_affine_inv_2_1_BLUE_DOWN))*0.6610455395250987 + ((jac_affine_inv_0_2_BLUE_DOWN*0.55068466281655948 + jac_affine_inv_1_2_BLUE_DOWN*0.55068466281655948 + jac_affine_inv_2_2_BLUE_DOWN)*(jac_affine_inv_0_2_BLUE_DOWN*0.55068466281655948 + jac_affine_inv_1_2_BLUE_DOWN*0.55068466281655948 + jac_affine_inv_2_2_BLUE_DOWN))*0.6610455395250987), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.0069232355736274674 + jac_affine_inv_1_0_BLUE_DOWN*0.37223775438826195 + jac_affine_inv_2_0_BLUE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_0_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_1_0_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_2_0_BLUE_DOWN*0.81304707091600714) + (jac_affine_inv_0_1_BLUE_DOWN*0.0069232355736274674 + jac_affine_inv_1_1_BLUE_DOWN*0.37223775438826195 + jac_affine_inv_2_1_BLUE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_1_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_1_1_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_2_1_BLUE_DOWN*0.81304707091600714) + (jac_affine_inv_0_2_BLUE_DOWN*0.0069232355736274674 + jac_affine_inv_1_2_BLUE_DOWN*0.37223775438826195 + jac_affine_inv_2_2_BLUE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_2_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_1_2_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_2_2_BLUE_DOWN*0.81304707091600714)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_1_0_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_2_0_BLUE_DOWN*0.81304707091600714)*(jac_affine_inv_0_0_BLUE_DOWN*0.54534421232499986 + jac_affine_inv_1_0_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_0_BLUE_DOWN*0.18002969351036541) + (jac_affine_inv_0_1_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_1_1_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_2_1_BLUE_DOWN*0.81304707091600714)*(jac_affine_inv_0_1_BLUE_DOWN*0.54534421232499986 + jac_affine_inv_1_1_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_1_BLUE_DOWN*0.18002969351036541) + (jac_affine_inv_0_2_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_1_2_BLUE_DOWN*0.44773255210137269 + jac_affine_inv_2_2_BLUE_DOWN*0.81304707091600714)*(jac_affine_inv_0_2_BLUE_DOWN*0.54534421232499986 + jac_affine_inv_1_2_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_2_BLUE_DOWN*0.18002969351036541)), abs_det_jac_affine_BLUE_DOWN*(((jac_affine_inv_0_0_BLUE_DOWN*0.01859896126067373 + jac_affine_inv_1_0_BLUE_DOWN + jac_affine_inv_2_0_BLUE_DOWN*0.01859896126067373)*(jac_affine_inv_0_0_BLUE_DOWN*0.01859896126067373 + jac_affine_inv_1_0_BLUE_DOWN + jac_affine_inv_2_0_BLUE_DOWN*0.01859896126067373))*0.13856094579201603 + ((jac_affine_inv_0_1_BLUE_DOWN*0.01859896126067373 + jac_affine_inv_1_1_BLUE_DOWN + jac_affine_inv_2_1_BLUE_DOWN*0.01859896126067373)*(jac_affine_inv_0_1_BLUE_DOWN*0.01859896126067373 + jac_affine_inv_1_1_BLUE_DOWN + jac_affine_inv_2_1_BLUE_DOWN*0.01859896126067373))*0.13856094579201603 + ((jac_affine_inv_0_2_BLUE_DOWN*0.01859896126067373 + jac_affine_inv_1_2_BLUE_DOWN + jac_affine_inv_2_2_BLUE_DOWN*0.01859896126067373)*(jac_affine_inv_0_2_BLUE_DOWN*0.01859896126067373 + jac_affine_inv_1_2_BLUE_DOWN + jac_affine_inv_2_2_BLUE_DOWN*0.01859896126067373))*0.13856094579201603), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.0069232355736274674 + jac_affine_inv_1_0_BLUE_DOWN*0.37223775438826195 + jac_affine_inv_2_0_BLUE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_0_BLUE_DOWN*0.54534421232499986 + jac_affine_inv_1_0_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_0_BLUE_DOWN*0.18002969351036541) + (jac_affine_inv_0_1_BLUE_DOWN*0.0069232355736274674 + jac_affine_inv_1_1_BLUE_DOWN*0.37223775438826195 + jac_affine_inv_2_1_BLUE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_1_BLUE_DOWN*0.54534421232499986 + jac_affine_inv_1_1_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_1_BLUE_DOWN*0.18002969351036541) + (jac_affine_inv_0_2_BLUE_DOWN*0.0069232355736274674 + jac_affine_inv_1_2_BLUE_DOWN*0.37223775438826195 + jac_affine_inv_2_2_BLUE_DOWN*0.0069232355736274674)*(jac_affine_inv_0_2_BLUE_DOWN*0.54534421232499986 + jac_affine_inv_1_2_BLUE_DOWN*0.18002969351036541 + jac_affine_inv_2_2_BLUE_DOWN*0.18002969351036541)), abs_det_jac_affine_BLUE_DOWN*(((jac_affine_inv_0_0_BLUE_DOWN + jac_affine_inv_1_0_BLUE_DOWN*0.33012121416459822 + jac_affine_inv_2_0_BLUE_DOWN*0.33012121416459822)*(jac_affine_inv_0_0_BLUE_DOWN + jac_affine_inv_1_0_BLUE_DOWN*0.33012121416459822 + jac_affine_inv_2_0_BLUE_DOWN*0.33012121416459822))*0.29740030991637451 + ((jac_affine_inv_0_1_BLUE_DOWN + jac_affine_inv_1_1_BLUE_DOWN*0.33012121416459822 + jac_affine_inv_2_1_BLUE_DOWN*0.33012121416459822)*(jac_affine_inv_0_1_BLUE_DOWN + jac_affine_inv_1_1_BLUE_DOWN*0.33012121416459822 + jac_affine_inv_2_1_BLUE_DOWN*0.33012121416459822))*0.29740030991637451 + ((jac_affine_inv_0_2_BLUE_DOWN + jac_affine_inv_1_2_BLUE_DOWN*0.33012121416459822 + jac_affine_inv_2_2_BLUE_DOWN*0.33012121416459822)*(jac_affine_inv_0_2_BLUE_DOWN + jac_affine_inv_1_2_BLUE_DOWN*0.33012121416459822 + jac_affine_inv_2_2_BLUE_DOWN*0.33012121416459822))*0.29740030991637451), abs_det_jac_affine_BLUE_DOWN*(((jac_affine_inv_1_0_BLUE_DOWN*-0.81923601162978588 + jac_affine_inv_2_0_BLUE_DOWN)*(jac_affine_inv_1_0_BLUE_DOWN*-0.81923601162978588 + jac_affine_inv_2_0_BLUE_DOWN))*0.18550396047976214 + ((jac_affine_inv_1_1_BLUE_DOWN*-0.81923601162978588 + jac_affine_inv_2_1_BLUE_DOWN)*(jac_affine_inv_1_1_BLUE_DOWN*-0.81923601162978588 + jac_affine_inv_2_1_BLUE_DOWN))*0.18550396047976214 + ((jac_affine_inv_1_2_BLUE_DOWN*-0.81923601162978588 + jac_affine_inv_2_2_BLUE_DOWN)*(jac_affine_inv_1_2_BLUE_DOWN*-0.81923601162978588 + jac_affine_inv_2_2_BLUE_DOWN))*0.18550396047976214), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_1_0_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_BLUE_DOWN*0.43070170707783612) + (jac_affine_inv_0_1_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_1_1_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_BLUE_DOWN*0.43070170707783612) + (jac_affine_inv_0_2_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_1_2_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_BLUE_DOWN*0.43070170707783612)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.43070170707783612 + jac_affine_inv_1_0_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_1_0_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_BLUE_DOWN*0.43070170707783612) + (jac_affine_inv_0_1_BLUE_DOWN*-0.43070170707783612 + jac_affine_inv_1_1_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_1_1_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_BLUE_DOWN*0.43070170707783612) + (jac_affine_inv_0_2_BLUE_DOWN*-0.43070170707783612 + jac_affine_inv_1_2_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_1_2_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_BLUE_DOWN*0.43070170707783612)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_BLUE_DOWN*0.43070170707783612)*(jac_affine_inv_0_0_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_1_0_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_2_0_BLUE_DOWN*0.35322186373731607) + (jac_affine_inv_1_1_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_BLUE_DOWN*0.43070170707783612)*(jac_affine_inv_0_1_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_1_1_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_2_1_BLUE_DOWN*0.35322186373731607) + (jac_affine_inv_1_2_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_BLUE_DOWN*0.43070170707783612)*(jac_affine_inv_0_2_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_1_2_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_2_2_BLUE_DOWN*0.35322186373731607)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_BLUE_DOWN*0.43070170707783612)*(jac_affine_inv_0_0_BLUE_DOWN*0.43070170707783612 + jac_affine_inv_1_0_BLUE_DOWN*0.43107722210656541 + jac_affine_inv_2_0_BLUE_DOWN*0.43070170707783612) + (jac_affine_inv_1_1_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_BLUE_DOWN*0.43070170707783612)*(jac_affine_inv_0_1_BLUE_DOWN*0.43070170707783612 + jac_affine_inv_1_1_BLUE_DOWN*0.43107722210656541 + jac_affine_inv_2_1_BLUE_DOWN*0.43070170707783612) + (jac_affine_inv_1_2_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_BLUE_DOWN*0.43070170707783612)*(jac_affine_inv_0_2_BLUE_DOWN*0.43070170707783612 + jac_affine_inv_1_2_BLUE_DOWN*0.43107722210656541 + jac_affine_inv_2_2_BLUE_DOWN*0.43070170707783612)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_1_0_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_BLUE_DOWN*0.43070170707783612)*(jac_affine_inv_0_0_BLUE_DOWN*0.21645194421357716 + jac_affine_inv_1_0_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_0_BLUE_DOWN*0.21607642918484779) + (jac_affine_inv_1_1_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_BLUE_DOWN*0.43070170707783612)*(jac_affine_inv_0_1_BLUE_DOWN*0.21645194421357716 + jac_affine_inv_1_1_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_1_BLUE_DOWN*0.21607642918484779) + (jac_affine_inv_1_2_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_BLUE_DOWN*0.43070170707783612)*(jac_affine_inv_0_2_BLUE_DOWN*0.21645194421357716 + jac_affine_inv_1_2_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_2_BLUE_DOWN*0.21607642918484779)), abs_det_jac_affine_BLUE_DOWN*(((-jac_affine_inv_0_0_BLUE_DOWN + jac_affine_inv_2_0_BLUE_DOWN*0.61238108308527162)*(-jac_affine_inv_0_0_BLUE_DOWN + jac_affine_inv_2_0_BLUE_DOWN*0.61238108308527162))*0.12450054579698162 + ((-jac_affine_inv_0_1_BLUE_DOWN + jac_affine_inv_2_1_BLUE_DOWN*0.61238108308527162)*(-jac_affine_inv_0_1_BLUE_DOWN + jac_affine_inv_2_1_BLUE_DOWN*0.61238108308527162))*0.12450054579698162 + ((-jac_affine_inv_0_2_BLUE_DOWN + jac_affine_inv_2_2_BLUE_DOWN*0.61238108308527162)*(-jac_affine_inv_0_2_BLUE_DOWN + jac_affine_inv_2_2_BLUE_DOWN*0.61238108308527162))*0.12450054579698162), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_BLUE_DOWN*-0.43070170707783612 + jac_affine_inv_1_0_BLUE_DOWN*0.21607642918484779) + (jac_affine_inv_0_1_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_BLUE_DOWN*-0.43070170707783612 + jac_affine_inv_1_1_BLUE_DOWN*0.21607642918484779) + (jac_affine_inv_0_2_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_BLUE_DOWN*-0.43070170707783612 + jac_affine_inv_1_2_BLUE_DOWN*0.21607642918484779)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_1_0_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_2_0_BLUE_DOWN*0.35322186373731607) + (jac_affine_inv_0_1_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_1_1_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_2_1_BLUE_DOWN*0.35322186373731607) + (jac_affine_inv_0_2_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_1_2_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_2_2_BLUE_DOWN*0.35322186373731607)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_BLUE_DOWN*0.43070170707783612 + jac_affine_inv_1_0_BLUE_DOWN*0.43107722210656541 + jac_affine_inv_2_0_BLUE_DOWN*0.43070170707783612) + (jac_affine_inv_0_1_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_BLUE_DOWN*0.43070170707783612 + jac_affine_inv_1_1_BLUE_DOWN*0.43107722210656541 + jac_affine_inv_2_1_BLUE_DOWN*0.43070170707783612) + (jac_affine_inv_0_2_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_BLUE_DOWN*0.43070170707783612 + jac_affine_inv_1_2_BLUE_DOWN*0.43107722210656541 + jac_affine_inv_2_2_BLUE_DOWN*0.43070170707783612)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_BLUE_DOWN*0.21645194421357716 + jac_affine_inv_1_0_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_0_BLUE_DOWN*0.21607642918484779) + (jac_affine_inv_0_1_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_BLUE_DOWN*0.21645194421357716 + jac_affine_inv_1_1_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_1_BLUE_DOWN*0.21607642918484779) + (jac_affine_inv_0_2_BLUE_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_BLUE_DOWN*0.21645194421357716 + jac_affine_inv_1_2_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_2_BLUE_DOWN*0.21607642918484779)), abs_det_jac_affine_BLUE_DOWN*(((-jac_affine_inv_0_0_BLUE_DOWN + jac_affine_inv_1_0_BLUE_DOWN*0.50168463610430647)*(-jac_affine_inv_0_0_BLUE_DOWN + jac_affine_inv_1_0_BLUE_DOWN*0.50168463610430647))*0.18550396047976214 + ((-jac_affine_inv_0_1_BLUE_DOWN + jac_affine_inv_1_1_BLUE_DOWN*0.50168463610430647)*(-jac_affine_inv_0_1_BLUE_DOWN + jac_affine_inv_1_1_BLUE_DOWN*0.50168463610430647))*0.18550396047976214 + ((-jac_affine_inv_0_2_BLUE_DOWN + jac_affine_inv_1_2_BLUE_DOWN*0.50168463610430647)*(-jac_affine_inv_0_2_BLUE_DOWN + jac_affine_inv_1_2_BLUE_DOWN*0.50168463610430647))*0.18550396047976214), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.43070170707783612 + jac_affine_inv_1_0_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_1_0_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_2_0_BLUE_DOWN*0.35322186373731607) + (jac_affine_inv_0_1_BLUE_DOWN*-0.43070170707783612 + jac_affine_inv_1_1_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_1_1_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_2_1_BLUE_DOWN*0.35322186373731607) + (jac_affine_inv_0_2_BLUE_DOWN*-0.43070170707783612 + jac_affine_inv_1_2_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_1_2_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_2_2_BLUE_DOWN*0.35322186373731607)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.43070170707783612 + jac_affine_inv_1_0_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_BLUE_DOWN*0.43070170707783612 + jac_affine_inv_1_0_BLUE_DOWN*0.43107722210656541 + jac_affine_inv_2_0_BLUE_DOWN*0.43070170707783612) + (jac_affine_inv_0_1_BLUE_DOWN*-0.43070170707783612 + jac_affine_inv_1_1_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_BLUE_DOWN*0.43070170707783612 + jac_affine_inv_1_1_BLUE_DOWN*0.43107722210656541 + jac_affine_inv_2_1_BLUE_DOWN*0.43070170707783612) + (jac_affine_inv_0_2_BLUE_DOWN*-0.43070170707783612 + jac_affine_inv_1_2_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_BLUE_DOWN*0.43070170707783612 + jac_affine_inv_1_2_BLUE_DOWN*0.43107722210656541 + jac_affine_inv_2_2_BLUE_DOWN*0.43070170707783612)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*-0.43070170707783612 + jac_affine_inv_1_0_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_BLUE_DOWN*0.21645194421357716 + jac_affine_inv_1_0_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_0_BLUE_DOWN*0.21607642918484779) + (jac_affine_inv_0_1_BLUE_DOWN*-0.43070170707783612 + jac_affine_inv_1_1_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_BLUE_DOWN*0.21645194421357716 + jac_affine_inv_1_1_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_1_BLUE_DOWN*0.21607642918484779) + (jac_affine_inv_0_2_BLUE_DOWN*-0.43070170707783612 + jac_affine_inv_1_2_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_BLUE_DOWN*0.21645194421357716 + jac_affine_inv_1_2_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_2_BLUE_DOWN*0.21607642918484779)), abs_det_jac_affine_BLUE_DOWN*(((jac_affine_inv_0_0_BLUE_DOWN*0.99893688622568233 + jac_affine_inv_1_0_BLUE_DOWN*0.99893688622568233 + jac_affine_inv_2_0_BLUE_DOWN)*(jac_affine_inv_0_0_BLUE_DOWN*0.99893688622568233 + jac_affine_inv_1_0_BLUE_DOWN*0.99893688622568233 + jac_affine_inv_2_0_BLUE_DOWN))*0.12476568502206307 + ((jac_affine_inv_0_1_BLUE_DOWN*0.99893688622568233 + jac_affine_inv_1_1_BLUE_DOWN*0.99893688622568233 + jac_affine_inv_2_1_BLUE_DOWN)*(jac_affine_inv_0_1_BLUE_DOWN*0.99893688622568233 + jac_affine_inv_1_1_BLUE_DOWN*0.99893688622568233 + jac_affine_inv_2_1_BLUE_DOWN))*0.12476568502206307 + ((jac_affine_inv_0_2_BLUE_DOWN*0.99893688622568233 + jac_affine_inv_1_2_BLUE_DOWN*0.99893688622568233 + jac_affine_inv_2_2_BLUE_DOWN)*(jac_affine_inv_0_2_BLUE_DOWN*0.99893688622568233 + jac_affine_inv_1_2_BLUE_DOWN*0.99893688622568233 + jac_affine_inv_2_2_BLUE_DOWN))*0.12476568502206307), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_1_0_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_2_0_BLUE_DOWN*0.35322186373731607)*(jac_affine_inv_0_0_BLUE_DOWN*0.43070170707783612 + jac_affine_inv_1_0_BLUE_DOWN*0.43107722210656541 + jac_affine_inv_2_0_BLUE_DOWN*0.43070170707783612) + (jac_affine_inv_0_1_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_1_1_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_2_1_BLUE_DOWN*0.35322186373731607)*(jac_affine_inv_0_1_BLUE_DOWN*0.43070170707783612 + jac_affine_inv_1_1_BLUE_DOWN*0.43107722210656541 + jac_affine_inv_2_1_BLUE_DOWN*0.43070170707783612) + (jac_affine_inv_0_2_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_1_2_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_2_2_BLUE_DOWN*0.35322186373731607)*(jac_affine_inv_0_2_BLUE_DOWN*0.43070170707783612 + jac_affine_inv_1_2_BLUE_DOWN*0.43107722210656541 + jac_affine_inv_2_2_BLUE_DOWN*0.43070170707783612)), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.21645194421357716 + jac_affine_inv_1_0_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_0_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_1_0_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_2_0_BLUE_DOWN*0.35322186373731607) + (jac_affine_inv_0_1_BLUE_DOWN*0.21645194421357716 + jac_affine_inv_1_1_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_1_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_1_1_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_2_1_BLUE_DOWN*0.35322186373731607) + (jac_affine_inv_0_2_BLUE_DOWN*0.21645194421357716 + jac_affine_inv_1_2_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_2_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_1_2_BLUE_DOWN*0.35284634870858678 + jac_affine_inv_2_2_BLUE_DOWN*0.35322186373731607)), abs_det_jac_affine_BLUE_DOWN*(((jac_affine_inv_0_0_BLUE_DOWN*0.99912889150836071 + jac_affine_inv_1_0_BLUE_DOWN + jac_affine_inv_2_0_BLUE_DOWN*0.99912889150836071)*(jac_affine_inv_0_0_BLUE_DOWN*0.99912889150836071 + jac_affine_inv_1_0_BLUE_DOWN + jac_affine_inv_2_0_BLUE_DOWN*0.99912889150836071))*0.18582757141911313 + ((jac_affine_inv_0_1_BLUE_DOWN*0.99912889150836071 + jac_affine_inv_1_1_BLUE_DOWN + jac_affine_inv_2_1_BLUE_DOWN*0.99912889150836071)*(jac_affine_inv_0_1_BLUE_DOWN*0.99912889150836071 + jac_affine_inv_1_1_BLUE_DOWN + jac_affine_inv_2_1_BLUE_DOWN*0.99912889150836071))*0.18582757141911313 + ((jac_affine_inv_0_2_BLUE_DOWN*0.99912889150836071 + jac_affine_inv_1_2_BLUE_DOWN + jac_affine_inv_2_2_BLUE_DOWN*0.99912889150836071)*(jac_affine_inv_0_2_BLUE_DOWN*0.99912889150836071 + jac_affine_inv_1_2_BLUE_DOWN + jac_affine_inv_2_2_BLUE_DOWN*0.99912889150836071))*0.18582757141911313), abs_det_jac_affine_BLUE_DOWN*((jac_affine_inv_0_0_BLUE_DOWN*0.21645194421357716 + jac_affine_inv_1_0_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_0_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_BLUE_DOWN*0.43070170707783612 + jac_affine_inv_1_0_BLUE_DOWN*0.43107722210656541 + jac_affine_inv_2_0_BLUE_DOWN*0.43070170707783612) + (jac_affine_inv_0_1_BLUE_DOWN*0.21645194421357716 + jac_affine_inv_1_1_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_1_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_BLUE_DOWN*0.43070170707783612 + jac_affine_inv_1_1_BLUE_DOWN*0.43107722210656541 + jac_affine_inv_2_1_BLUE_DOWN*0.43070170707783612) + (jac_affine_inv_0_2_BLUE_DOWN*0.21645194421357716 + jac_affine_inv_1_2_BLUE_DOWN*0.21607642918484779 + jac_affine_inv_2_2_BLUE_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_BLUE_DOWN*0.43070170707783612 + jac_affine_inv_1_2_BLUE_DOWN*0.43107722210656541 + jac_affine_inv_2_2_BLUE_DOWN*0.43070170707783612)), abs_det_jac_affine_BLUE_DOWN*(((jac_affine_inv_0_0_BLUE_DOWN + jac_affine_inv_1_0_BLUE_DOWN*0.99826513441543008 + jac_affine_inv_2_0_BLUE_DOWN*0.99826513441543008)*(jac_affine_inv_0_0_BLUE_DOWN + jac_affine_inv_1_0_BLUE_DOWN*0.99826513441543008 + jac_affine_inv_2_0_BLUE_DOWN*0.99826513441543008))*0.046851444153837518 + ((jac_affine_inv_0_1_BLUE_DOWN + jac_affine_inv_1_1_BLUE_DOWN*0.99826513441543008 + jac_affine_inv_2_1_BLUE_DOWN*0.99826513441543008)*(jac_affine_inv_0_1_BLUE_DOWN + jac_affine_inv_1_1_BLUE_DOWN*0.99826513441543008 + jac_affine_inv_2_1_BLUE_DOWN*0.99826513441543008))*0.046851444153837518 + ((jac_affine_inv_0_2_BLUE_DOWN + jac_affine_inv_1_2_BLUE_DOWN*0.99826513441543008 + jac_affine_inv_2_2_BLUE_DOWN*0.99826513441543008)*(jac_affine_inv_0_2_BLUE_DOWN + jac_affine_inv_1_2_BLUE_DOWN*0.99826513441543008 + jac_affine_inv_2_2_BLUE_DOWN*0.99826513441543008))*0.046851444153837518)};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
             const walberla::float64 alpha_dof_0 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 alpha_dof_1 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 alpha_dof_2 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 alpha_dof_3 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 beta_dof_0 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 beta_dof_1 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 beta_dof_2 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 beta_dof_3 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             walberla::float64 q_acc_0_0 = 0.0;
             walberla::float64 q_acc_0_1 = 0.0;
             walberla::float64 q_acc_0_2 = 0.0;
             walberla::float64 q_acc_0_3 = 0.0;
             walberla::float64 q_acc_0_4 = 0.0;
             walberla::float64 q_acc_0_5 = 0.0;
             walberla::float64 q_acc_1_1 = 0.0;
             walberla::float64 q_acc_1_2 = 0.0;
             walberla::float64 q_acc_1_3 = 0.0;
             walberla::float64 q_acc_1_4 = 0.0;
             walberla::float64 q_acc_1_5 = 0.0;
             walberla::float64 q_acc_2_2 = 0.0;
             walberla::float64 q_acc_2_3 = 0.0;
             walberla::float64 q_acc_2_4 = 0.0;
             walberla::float64 q_acc_2_5 = 0.0;
             walberla::float64 q_acc_3_3 = 0.0;
             walberla::float64 q_acc_3_4 = 0.0;
             walberla::float64 q_acc_3_5 = 0.0;
             walberla::float64 q_acc_4_4 = 0.0;
             walberla::float64 q_acc_4_5 = 0.0;
             walberla::float64 q_acc_5_5 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const walberla::float64 tmp_qloop_0 = alpha_dof_0*_data_phi_0_0_BLUE_DOWN[4*q] + alpha_dof_1*_data_phi_0_0_BLUE_DOWN[4*q + 1] + alpha_dof_2*_data_phi_0_0_BLUE_DOWN[4*q + 2] + alpha_dof_3*_data_phi_0_0_BLUE_DOWN[4*q + 3];
                const walberla::float64 tmp_qloop_1 = beta_dof_0*_data_phi_0_0_BLUE_DOWN[4*q] + beta_dof_1*_data_phi_0_0_BLUE_DOWN[4*q + 1] + beta_dof_2*_data_phi_0_0_BLUE_DOWN[4*q + 2] + beta_dof_3*_data_phi_0_0_BLUE_DOWN[4*q + 3];
                const walberla::float64 q_tmp_0_0 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_DOWN[21*q] + tmp_qloop_1*_data_mass_det_0_0_BLUE_DOWN[21*q])*_data_q_w[q];
                const walberla::float64 q_tmp_0_1 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_DOWN[21*q + 1] + tmp_qloop_1*_data_mass_det_0_0_BLUE_DOWN[21*q + 1])*_data_q_w[q];
                const walberla::float64 q_tmp_0_2 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_DOWN[21*q + 2] + tmp_qloop_1*_data_mass_det_0_0_BLUE_DOWN[21*q + 2])*_data_q_w[q];
                const walberla::float64 q_tmp_0_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_DOWN[21*q + 3] + tmp_qloop_1*_data_mass_det_0_0_BLUE_DOWN[21*q + 3])*_data_q_w[q];
                const walberla::float64 q_tmp_0_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_DOWN[21*q + 4] + tmp_qloop_1*_data_mass_det_0_0_BLUE_DOWN[21*q + 4])*_data_q_w[q];
                const walberla::float64 q_tmp_0_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_DOWN[21*q + 5] + tmp_qloop_1*_data_mass_det_0_0_BLUE_DOWN[21*q + 5])*_data_q_w[q];
                const walberla::float64 q_tmp_1_1 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_DOWN[21*q + 6] + tmp_qloop_1*_data_mass_det_0_0_BLUE_DOWN[21*q + 6])*_data_q_w[q];
                const walberla::float64 q_tmp_1_2 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_DOWN[21*q + 7] + tmp_qloop_1*_data_mass_det_0_0_BLUE_DOWN[21*q + 7])*_data_q_w[q];
                const walberla::float64 q_tmp_1_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_DOWN[21*q + 8] + tmp_qloop_1*_data_mass_det_0_0_BLUE_DOWN[21*q + 8])*_data_q_w[q];
                const walberla::float64 q_tmp_1_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_DOWN[21*q + 9] + tmp_qloop_1*_data_mass_det_0_0_BLUE_DOWN[21*q + 9])*_data_q_w[q];
                const walberla::float64 q_tmp_1_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_DOWN[21*q + 10] + tmp_qloop_1*_data_mass_det_0_0_BLUE_DOWN[21*q + 10])*_data_q_w[q];
                const walberla::float64 q_tmp_2_2 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_DOWN[21*q + 11] + tmp_qloop_1*_data_mass_det_0_0_BLUE_DOWN[21*q + 11])*_data_q_w[q];
                const walberla::float64 q_tmp_2_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_DOWN[21*q + 12] + tmp_qloop_1*_data_mass_det_0_0_BLUE_DOWN[21*q + 12])*_data_q_w[q];
                const walberla::float64 q_tmp_2_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_DOWN[21*q + 13] + tmp_qloop_1*_data_mass_det_0_0_BLUE_DOWN[21*q + 13])*_data_q_w[q];
                const walberla::float64 q_tmp_2_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_DOWN[21*q + 14] + tmp_qloop_1*_data_mass_det_0_0_BLUE_DOWN[21*q + 14])*_data_q_w[q];
                const walberla::float64 q_tmp_3_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_DOWN[21*q + 15] + tmp_qloop_1*_data_mass_det_0_0_BLUE_DOWN[21*q + 15])*_data_q_w[q];
                const walberla::float64 q_tmp_3_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_DOWN[21*q + 16] + tmp_qloop_1*_data_mass_det_0_0_BLUE_DOWN[21*q + 16])*_data_q_w[q];
                const walberla::float64 q_tmp_3_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_DOWN[21*q + 17] + tmp_qloop_1*_data_mass_det_0_0_BLUE_DOWN[21*q + 17])*_data_q_w[q];
                const walberla::float64 q_tmp_4_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_DOWN[21*q + 18] + tmp_qloop_1*_data_mass_det_0_0_BLUE_DOWN[21*q + 18])*_data_q_w[q];
                const walberla::float64 q_tmp_4_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_DOWN[21*q + 19] + tmp_qloop_1*_data_mass_det_0_0_BLUE_DOWN[21*q + 19])*_data_q_w[q];
                const walberla::float64 q_tmp_5_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_BLUE_DOWN[21*q + 20] + tmp_qloop_1*_data_mass_det_0_0_BLUE_DOWN[21*q + 20])*_data_q_w[q];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
             }
             const walberla::float64 elMat_0_0 = q_acc_0_0;
             const walberla::float64 elMat_0_1 = q_acc_0_1;
             const walberla::float64 elMat_0_2 = q_acc_0_2;
             const walberla::float64 elMat_0_3 = q_acc_0_3;
             const walberla::float64 elMat_0_4 = q_acc_0_4;
             const walberla::float64 elMat_0_5 = q_acc_0_5;
             const walberla::float64 elMat_1_0 = q_acc_0_1;
             const walberla::float64 elMat_1_1 = q_acc_1_1;
             const walberla::float64 elMat_1_2 = q_acc_1_2;
             const walberla::float64 elMat_1_3 = q_acc_1_3;
             const walberla::float64 elMat_1_4 = q_acc_1_4;
             const walberla::float64 elMat_1_5 = q_acc_1_5;
             const walberla::float64 elMat_2_0 = q_acc_0_2;
             const walberla::float64 elMat_2_1 = q_acc_1_2;
             const walberla::float64 elMat_2_2 = q_acc_2_2;
             const walberla::float64 elMat_2_3 = q_acc_2_3;
             const walberla::float64 elMat_2_4 = q_acc_2_4;
             const walberla::float64 elMat_2_5 = q_acc_2_5;
             const walberla::float64 elMat_3_0 = q_acc_0_3;
             const walberla::float64 elMat_3_1 = q_acc_1_3;
             const walberla::float64 elMat_3_2 = q_acc_2_3;
             const walberla::float64 elMat_3_3 = q_acc_3_3;
             const walberla::float64 elMat_3_4 = q_acc_3_4;
             const walberla::float64 elMat_3_5 = q_acc_3_5;
             const walberla::float64 elMat_4_0 = q_acc_0_4;
             const walberla::float64 elMat_4_1 = q_acc_1_4;
             const walberla::float64 elMat_4_2 = q_acc_2_4;
             const walberla::float64 elMat_4_3 = q_acc_3_4;
             const walberla::float64 elMat_4_4 = q_acc_4_4;
             const walberla::float64 elMat_4_5 = q_acc_4_5;
             const walberla::float64 elMat_5_0 = q_acc_0_5;
             const walberla::float64 elMat_5_1 = q_acc_1_5;
             const walberla::float64 elMat_5_2 = q_acc_2_5;
             const walberla::float64 elMat_5_3 = q_acc_3_5;
             const walberla::float64 elMat_5_4 = q_acc_4_5;
             const walberla::float64 elMat_5_5 = q_acc_5_5;
         
             std::vector< uint_t > _data_rowIdx( 6 );
             std::vector< uint_t > _data_colIdx( 6 );
             std::vector< walberla::float64 > _data_mat( 36 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[1] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[2] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[3] = ((uint64_t)(_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[1] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[2] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[3] = ((uint64_t)(_data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[4] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[5] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
         
             /* Apply basis transformation */
         
             const Eigen::DiagonalMatrix< real_t, 6 > basisTransformation = n1e1::macrocell::basisTransformation( level, cell, {ctr_0, ctr_1, ctr_2}, celldof::CellType::BLUE_DOWN );
         
             _data_mat[0] = ((walberla::float64)((basisTransformation.diagonal()(0)*basisTransformation.diagonal()(0))*elMat_0_0));
             _data_mat[1] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(1)*elMat_0_1));
             _data_mat[2] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(2)*elMat_0_2));
             _data_mat[3] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(3)*elMat_0_3));
             _data_mat[4] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(4)*elMat_0_4));
             _data_mat[5] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(5)*elMat_0_5));
             _data_mat[6] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(1)*elMat_1_0));
             _data_mat[7] = ((walberla::float64)((basisTransformation.diagonal()(1)*basisTransformation.diagonal()(1))*elMat_1_1));
             _data_mat[8] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(2)*elMat_1_2));
             _data_mat[9] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(3)*elMat_1_3));
             _data_mat[10] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(4)*elMat_1_4));
             _data_mat[11] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(5)*elMat_1_5));
             _data_mat[12] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(2)*elMat_2_0));
             _data_mat[13] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(2)*elMat_2_1));
             _data_mat[14] = ((walberla::float64)((basisTransformation.diagonal()(2)*basisTransformation.diagonal()(2))*elMat_2_2));
             _data_mat[15] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(3)*elMat_2_3));
             _data_mat[16] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(4)*elMat_2_4));
             _data_mat[17] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(5)*elMat_2_5));
             _data_mat[18] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(3)*elMat_3_0));
             _data_mat[19] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(3)*elMat_3_1));
             _data_mat[20] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(3)*elMat_3_2));
             _data_mat[21] = ((walberla::float64)((basisTransformation.diagonal()(3)*basisTransformation.diagonal()(3))*elMat_3_3));
             _data_mat[22] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(4)*elMat_3_4));
             _data_mat[23] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(5)*elMat_3_5));
             _data_mat[24] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(4)*elMat_4_0));
             _data_mat[25] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(4)*elMat_4_1));
             _data_mat[26] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(4)*elMat_4_2));
             _data_mat[27] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(4)*elMat_4_3));
             _data_mat[28] = ((walberla::float64)((basisTransformation.diagonal()(4)*basisTransformation.diagonal()(4))*elMat_4_4));
             _data_mat[29] = ((walberla::float64)(basisTransformation.diagonal()(4)*basisTransformation.diagonal()(5)*elMat_4_5));
             _data_mat[30] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(5)*elMat_5_0));
             _data_mat[31] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(5)*elMat_5_1));
             _data_mat[32] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(5)*elMat_5_2));
             _data_mat[33] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(5)*elMat_5_3));
             _data_mat[34] = ((walberla::float64)(basisTransformation.diagonal()(4)*basisTransformation.diagonal()(5)*elMat_5_4));
             _data_mat[35] = ((walberla::float64)((basisTransformation.diagonal()(5)*basisTransformation.diagonal()(5))*elMat_5_5));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const walberla::float64 tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const walberla::float64 tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const walberla::float64 tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const walberla::float64 tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const walberla::float64 tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const walberla::float64 tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const walberla::float64 tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const walberla::float64 p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const walberla::float64 p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const walberla::float64 p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const walberla::float64 p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const walberla::float64 p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const walberla::float64 p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const walberla::float64 p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const walberla::float64 p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const walberla::float64 p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const walberla::float64 p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const walberla::float64 p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const walberla::float64 p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const walberla::float64 jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const walberla::float64 jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const walberla::float64 jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const walberla::float64 jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const walberla::float64 jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const walberla::float64 tmp_coords_jac_11_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const walberla::float64 jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const walberla::float64 tmp_coords_jac_9_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const walberla::float64 jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const walberla::float64 jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const walberla::float64 tmp_coords_jac_8_GREEN_UP = jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP;
       const walberla::float64 jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const walberla::float64 tmp_coords_jac_7_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const walberla::float64 tmp_coords_jac_10_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const walberla::float64 tmp_coords_jac_12_GREEN_UP = jac_affine_0_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_0_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_0_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
       const walberla::float64 tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const walberla::float64 jac_affine_inv_0_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
       const walberla::float64 jac_affine_inv_0_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_2_1_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const walberla::float64 jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const walberla::float64 jac_affine_inv_1_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const walberla::float64 jac_affine_inv_1_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const walberla::float64 jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const walberla::float64 jac_affine_inv_2_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const walberla::float64 jac_affine_inv_2_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const walberla::float64 jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const walberla::float64 abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       {
          /* CellType.GREEN_UP */
          const walberla::float64 _data_phi_0_0_GREEN_UP [] = {0.12366680032845842, 0.82157254096761978, 0.039933048641498423, 0.01482761006242336, 0.45746158708559548, 0.15593312049918601, 0.3817653560693467, 0.0048399363458717648, 0.36531451881463445, 0.18002969351036541, 0.0069232355736274674, 0.44773255210137269, 0.00037551502872928966, 0.21607642918484779, 0.43070170707783612, 0.35284634870858678};
      
          const walberla::float64 _data_curl_curl_det_0_0_GREEN_UP [] = {1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_0_GREEN_UP*jac_affine_0_0_GREEN_UP)*4.0 + (jac_affine_1_0_GREEN_UP*jac_affine_1_0_GREEN_UP)*4.0 + (jac_affine_2_0_GREEN_UP*jac_affine_2_0_GREEN_UP)*4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_0_GREEN_UP*jac_affine_0_1_GREEN_UP*-4.0 + jac_affine_1_0_GREEN_UP*jac_affine_1_1_GREEN_UP*-4.0 + jac_affine_2_0_GREEN_UP*jac_affine_2_1_GREEN_UP*-4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_0_GREEN_UP*jac_affine_0_2_GREEN_UP*4.0 + jac_affine_1_0_GREEN_UP*jac_affine_1_2_GREEN_UP*4.0 + jac_affine_2_0_GREEN_UP*jac_affine_2_2_GREEN_UP*4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_0_GREEN_UP*(jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*2.0 + jac_affine_1_0_GREEN_UP*(jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*2.0 + jac_affine_2_0_GREEN_UP*(jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_0_GREEN_UP*(jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)*2.0 + jac_affine_1_0_GREEN_UP*(jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)*2.0 + jac_affine_2_0_GREEN_UP*(jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_0_GREEN_UP*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0)*2.0 + jac_affine_1_0_GREEN_UP*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0)*2.0 + jac_affine_2_0_GREEN_UP*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_1_GREEN_UP*jac_affine_0_1_GREEN_UP)*4.0 + (jac_affine_1_1_GREEN_UP*jac_affine_1_1_GREEN_UP)*4.0 + (jac_affine_2_1_GREEN_UP*jac_affine_2_1_GREEN_UP)*4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_1_GREEN_UP*jac_affine_0_2_GREEN_UP*-4.0 + jac_affine_1_1_GREEN_UP*jac_affine_1_2_GREEN_UP*-4.0 + jac_affine_2_1_GREEN_UP*jac_affine_2_2_GREEN_UP*-4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_1_GREEN_UP*(jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*-2.0 + jac_affine_1_1_GREEN_UP*(jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*-2.0 + jac_affine_2_1_GREEN_UP*(jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_1_GREEN_UP*(jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)*-2.0 + jac_affine_1_1_GREEN_UP*(jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)*-2.0 + jac_affine_2_1_GREEN_UP*(jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_1_GREEN_UP*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0)*-2.0 + jac_affine_1_1_GREEN_UP*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0)*-2.0 + jac_affine_2_1_GREEN_UP*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_2_GREEN_UP*jac_affine_0_2_GREEN_UP)*4.0 + (jac_affine_1_2_GREEN_UP*jac_affine_1_2_GREEN_UP)*4.0 + (jac_affine_2_2_GREEN_UP*jac_affine_2_2_GREEN_UP)*4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_2_GREEN_UP*(jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*2.0 + jac_affine_1_2_GREEN_UP*(jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*2.0 + jac_affine_2_2_GREEN_UP*(jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_2_GREEN_UP*(jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)*2.0 + jac_affine_1_2_GREEN_UP*(jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)*2.0 + jac_affine_2_2_GREEN_UP*(jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_2_GREEN_UP*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0)*2.0 + jac_affine_1_2_GREEN_UP*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0)*2.0 + jac_affine_2_2_GREEN_UP*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(((jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*(jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)) + ((jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*(jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)) + ((jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*(jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0))), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*(jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0) + (jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*(jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0) + (jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*(jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0) + (jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0) + (jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)), 1.0 / (abs_det_jac_affine_GREEN_UP)*(((jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)*(jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)) + ((jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)*(jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)) + ((jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)*(jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0))), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0) + (jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0) + (jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)), 1.0 / (abs_det_jac_affine_GREEN_UP)*(((jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0)*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0)) + ((jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0)*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0)) + ((jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0))), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_0_GREEN_UP*jac_affine_0_0_GREEN_UP)*4.0 + (jac_affine_1_0_GREEN_UP*jac_affine_1_0_GREEN_UP)*4.0 + (jac_affine_2_0_GREEN_UP*jac_affine_2_0_GREEN_UP)*4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_0_GREEN_UP*jac_affine_0_1_GREEN_UP*-4.0 + jac_affine_1_0_GREEN_UP*jac_affine_1_1_GREEN_UP*-4.0 + jac_affine_2_0_GREEN_UP*jac_affine_2_1_GREEN_UP*-4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_0_GREEN_UP*jac_affine_0_2_GREEN_UP*4.0 + jac_affine_1_0_GREEN_UP*jac_affine_1_2_GREEN_UP*4.0 + jac_affine_2_0_GREEN_UP*jac_affine_2_2_GREEN_UP*4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_0_GREEN_UP*(jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*2.0 + jac_affine_1_0_GREEN_UP*(jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*2.0 + jac_affine_2_0_GREEN_UP*(jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_0_GREEN_UP*(jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)*2.0 + jac_affine_1_0_GREEN_UP*(jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)*2.0 + jac_affine_2_0_GREEN_UP*(jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_0_GREEN_UP*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0)*2.0 + jac_affine_1_0_GREEN_UP*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0)*2.0 + jac_affine_2_0_GREEN_UP*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_1_GREEN_UP*jac_affine_0_1_GREEN_UP)*4.0 + (jac_affine_1_1_GREEN_UP*jac_affine_1_1_GREEN_UP)*4.0 + (jac_affine_2_1_GREEN_UP*jac_affine_2_1_GREEN_UP)*4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_1_GREEN_UP*jac_affine_0_2_GREEN_UP*-4.0 + jac_affine_1_1_GREEN_UP*jac_affine_1_2_GREEN_UP*-4.0 + jac_affine_2_1_GREEN_UP*jac_affine_2_2_GREEN_UP*-4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_1_GREEN_UP*(jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*-2.0 + jac_affine_1_1_GREEN_UP*(jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*-2.0 + jac_affine_2_1_GREEN_UP*(jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_1_GREEN_UP*(jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)*-2.0 + jac_affine_1_1_GREEN_UP*(jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)*-2.0 + jac_affine_2_1_GREEN_UP*(jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_1_GREEN_UP*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0)*-2.0 + jac_affine_1_1_GREEN_UP*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0)*-2.0 + jac_affine_2_1_GREEN_UP*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_2_GREEN_UP*jac_affine_0_2_GREEN_UP)*4.0 + (jac_affine_1_2_GREEN_UP*jac_affine_1_2_GREEN_UP)*4.0 + (jac_affine_2_2_GREEN_UP*jac_affine_2_2_GREEN_UP)*4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_2_GREEN_UP*(jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*2.0 + jac_affine_1_2_GREEN_UP*(jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*2.0 + jac_affine_2_2_GREEN_UP*(jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_2_GREEN_UP*(jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)*2.0 + jac_affine_1_2_GREEN_UP*(jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)*2.0 + jac_affine_2_2_GREEN_UP*(jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_2_GREEN_UP*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0)*2.0 + jac_affine_1_2_GREEN_UP*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0)*2.0 + jac_affine_2_2_GREEN_UP*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(((jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*(jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)) + ((jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*(jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)) + ((jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*(jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0))), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*(jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0) + (jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*(jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0) + (jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*(jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0) + (jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0) + (jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)), 1.0 / (abs_det_jac_affine_GREEN_UP)*(((jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)*(jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)) + ((jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)*(jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)) + ((jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)*(jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0))), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0) + (jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0) + (jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)), 1.0 / (abs_det_jac_affine_GREEN_UP)*(((jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0)*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0)) + ((jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0)*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0)) + ((jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0))), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_0_GREEN_UP*jac_affine_0_0_GREEN_UP)*4.0 + (jac_affine_1_0_GREEN_UP*jac_affine_1_0_GREEN_UP)*4.0 + (jac_affine_2_0_GREEN_UP*jac_affine_2_0_GREEN_UP)*4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_0_GREEN_UP*jac_affine_0_1_GREEN_UP*-4.0 + jac_affine_1_0_GREEN_UP*jac_affine_1_1_GREEN_UP*-4.0 + jac_affine_2_0_GREEN_UP*jac_affine_2_1_GREEN_UP*-4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_0_GREEN_UP*jac_affine_0_2_GREEN_UP*4.0 + jac_affine_1_0_GREEN_UP*jac_affine_1_2_GREEN_UP*4.0 + jac_affine_2_0_GREEN_UP*jac_affine_2_2_GREEN_UP*4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_0_GREEN_UP*(jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*2.0 + jac_affine_1_0_GREEN_UP*(jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*2.0 + jac_affine_2_0_GREEN_UP*(jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_0_GREEN_UP*(jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)*2.0 + jac_affine_1_0_GREEN_UP*(jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)*2.0 + jac_affine_2_0_GREEN_UP*(jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_0_GREEN_UP*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0)*2.0 + jac_affine_1_0_GREEN_UP*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0)*2.0 + jac_affine_2_0_GREEN_UP*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_1_GREEN_UP*jac_affine_0_1_GREEN_UP)*4.0 + (jac_affine_1_1_GREEN_UP*jac_affine_1_1_GREEN_UP)*4.0 + (jac_affine_2_1_GREEN_UP*jac_affine_2_1_GREEN_UP)*4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_1_GREEN_UP*jac_affine_0_2_GREEN_UP*-4.0 + jac_affine_1_1_GREEN_UP*jac_affine_1_2_GREEN_UP*-4.0 + jac_affine_2_1_GREEN_UP*jac_affine_2_2_GREEN_UP*-4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_1_GREEN_UP*(jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*-2.0 + jac_affine_1_1_GREEN_UP*(jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*-2.0 + jac_affine_2_1_GREEN_UP*(jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_1_GREEN_UP*(jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)*-2.0 + jac_affine_1_1_GREEN_UP*(jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)*-2.0 + jac_affine_2_1_GREEN_UP*(jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_1_GREEN_UP*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0)*-2.0 + jac_affine_1_1_GREEN_UP*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0)*-2.0 + jac_affine_2_1_GREEN_UP*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_2_GREEN_UP*jac_affine_0_2_GREEN_UP)*4.0 + (jac_affine_1_2_GREEN_UP*jac_affine_1_2_GREEN_UP)*4.0 + (jac_affine_2_2_GREEN_UP*jac_affine_2_2_GREEN_UP)*4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_2_GREEN_UP*(jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*2.0 + jac_affine_1_2_GREEN_UP*(jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*2.0 + jac_affine_2_2_GREEN_UP*(jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_2_GREEN_UP*(jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)*2.0 + jac_affine_1_2_GREEN_UP*(jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)*2.0 + jac_affine_2_2_GREEN_UP*(jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_2_GREEN_UP*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0)*2.0 + jac_affine_1_2_GREEN_UP*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0)*2.0 + jac_affine_2_2_GREEN_UP*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(((jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*(jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)) + ((jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*(jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)) + ((jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*(jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0))), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*(jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0) + (jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*(jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0) + (jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*(jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0) + (jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0) + (jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)), 1.0 / (abs_det_jac_affine_GREEN_UP)*(((jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)*(jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)) + ((jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)*(jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)) + ((jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)*(jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0))), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0) + (jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0) + (jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)), 1.0 / (abs_det_jac_affine_GREEN_UP)*(((jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0)*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0)) + ((jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0)*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0)) + ((jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0))), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_0_GREEN_UP*jac_affine_0_0_GREEN_UP)*4.0 + (jac_affine_1_0_GREEN_UP*jac_affine_1_0_GREEN_UP)*4.0 + (jac_affine_2_0_GREEN_UP*jac_affine_2_0_GREEN_UP)*4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_0_GREEN_UP*jac_affine_0_1_GREEN_UP*-4.0 + jac_affine_1_0_GREEN_UP*jac_affine_1_1_GREEN_UP*-4.0 + jac_affine_2_0_GREEN_UP*jac_affine_2_1_GREEN_UP*-4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_0_GREEN_UP*jac_affine_0_2_GREEN_UP*4.0 + jac_affine_1_0_GREEN_UP*jac_affine_1_2_GREEN_UP*4.0 + jac_affine_2_0_GREEN_UP*jac_affine_2_2_GREEN_UP*4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_0_GREEN_UP*(jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*2.0 + jac_affine_1_0_GREEN_UP*(jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*2.0 + jac_affine_2_0_GREEN_UP*(jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_0_GREEN_UP*(jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)*2.0 + jac_affine_1_0_GREEN_UP*(jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)*2.0 + jac_affine_2_0_GREEN_UP*(jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_0_GREEN_UP*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0)*2.0 + jac_affine_1_0_GREEN_UP*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0)*2.0 + jac_affine_2_0_GREEN_UP*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_1_GREEN_UP*jac_affine_0_1_GREEN_UP)*4.0 + (jac_affine_1_1_GREEN_UP*jac_affine_1_1_GREEN_UP)*4.0 + (jac_affine_2_1_GREEN_UP*jac_affine_2_1_GREEN_UP)*4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_1_GREEN_UP*jac_affine_0_2_GREEN_UP*-4.0 + jac_affine_1_1_GREEN_UP*jac_affine_1_2_GREEN_UP*-4.0 + jac_affine_2_1_GREEN_UP*jac_affine_2_2_GREEN_UP*-4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_1_GREEN_UP*(jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*-2.0 + jac_affine_1_1_GREEN_UP*(jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*-2.0 + jac_affine_2_1_GREEN_UP*(jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_1_GREEN_UP*(jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)*-2.0 + jac_affine_1_1_GREEN_UP*(jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)*-2.0 + jac_affine_2_1_GREEN_UP*(jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_1_GREEN_UP*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0)*-2.0 + jac_affine_1_1_GREEN_UP*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0)*-2.0 + jac_affine_2_1_GREEN_UP*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_2_GREEN_UP*jac_affine_0_2_GREEN_UP)*4.0 + (jac_affine_1_2_GREEN_UP*jac_affine_1_2_GREEN_UP)*4.0 + (jac_affine_2_2_GREEN_UP*jac_affine_2_2_GREEN_UP)*4.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_2_GREEN_UP*(jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*2.0 + jac_affine_1_2_GREEN_UP*(jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*2.0 + jac_affine_2_2_GREEN_UP*(jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_2_GREEN_UP*(jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)*2.0 + jac_affine_1_2_GREEN_UP*(jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)*2.0 + jac_affine_2_2_GREEN_UP*(jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(jac_affine_0_2_GREEN_UP*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0)*2.0 + jac_affine_1_2_GREEN_UP*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0)*2.0 + jac_affine_2_2_GREEN_UP*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_UP)*(((jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*(jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)) + ((jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*(jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)) + ((jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*(jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0))), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*(jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0) + (jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*(jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0) + (jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*(jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_0_GREEN_UP*-2.0 + jac_affine_0_1_GREEN_UP*2.0)*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0) + (jac_affine_1_0_GREEN_UP*-2.0 + jac_affine_1_1_GREEN_UP*2.0)*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0) + (jac_affine_2_0_GREEN_UP*-2.0 + jac_affine_2_1_GREEN_UP*2.0)*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)), 1.0 / (abs_det_jac_affine_GREEN_UP)*(((jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)*(jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)) + ((jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)*(jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)) + ((jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)*(jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0))), 1.0 / (abs_det_jac_affine_GREEN_UP)*((jac_affine_0_0_GREEN_UP*2.0 + jac_affine_0_2_GREEN_UP*-2.0)*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0) + (jac_affine_1_0_GREEN_UP*2.0 + jac_affine_1_2_GREEN_UP*-2.0)*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0) + (jac_affine_2_0_GREEN_UP*2.0 + jac_affine_2_2_GREEN_UP*-2.0)*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)), 1.0 / (abs_det_jac_affine_GREEN_UP)*(((jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0)*(jac_affine_0_1_GREEN_UP*-2.0 + jac_affine_0_2_GREEN_UP*2.0)) + ((jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0)*(jac_affine_1_1_GREEN_UP*-2.0 + jac_affine_1_2_GREEN_UP*2.0)) + ((jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)*(jac_affine_2_1_GREEN_UP*-2.0 + jac_affine_2_2_GREEN_UP*2.0)))};
      
          const walberla::float64 _data_mass_det_0_0_GREEN_UP [] = {abs_det_jac_affine_GREEN_UP*(((jac_affine_inv_1_0_GREEN_UP*-0.37131174720816351 + jac_affine_inv_2_0_GREEN_UP)*(jac_affine_inv_1_0_GREEN_UP*-0.37131174720816351 + jac_affine_inv_2_0_GREEN_UP))*0.0015946483738042789 + ((jac_affine_inv_1_1_GREEN_UP*-0.37131174720816351 + jac_affine_inv_2_1_GREEN_UP)*(jac_affine_inv_1_1_GREEN_UP*-0.37131174720816351 + jac_affine_inv_2_1_GREEN_UP))*0.0015946483738042789 + ((jac_affine_inv_1_2_GREEN_UP*-0.37131174720816351 + jac_affine_inv_2_2_GREEN_UP)*(jac_affine_inv_1_2_GREEN_UP*-0.37131174720816351 + jac_affine_inv_2_2_GREEN_UP))*0.0015946483738042789), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_0_GREEN_UP*0.82157254096761978)*(jac_affine_inv_1_0_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_0_GREEN_UP*0.039933048641498423) + (jac_affine_inv_0_1_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_1_GREEN_UP*0.82157254096761978)*(jac_affine_inv_1_1_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_1_GREEN_UP*0.039933048641498423) + (jac_affine_inv_0_2_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_2_GREEN_UP*0.82157254096761978)*(jac_affine_inv_1_2_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_2_GREEN_UP*0.039933048641498423)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.039933048641498423 + jac_affine_inv_1_0_GREEN_UP*0.82157254096761978)*(jac_affine_inv_1_0_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_0_GREEN_UP*0.039933048641498423) + (jac_affine_inv_0_1_GREEN_UP*-0.039933048641498423 + jac_affine_inv_1_1_GREEN_UP*0.82157254096761978)*(jac_affine_inv_1_1_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_1_GREEN_UP*0.039933048641498423) + (jac_affine_inv_0_2_GREEN_UP*-0.039933048641498423 + jac_affine_inv_1_2_GREEN_UP*0.82157254096761978)*(jac_affine_inv_1_2_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_2_GREEN_UP*0.039933048641498423)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_0_GREEN_UP*0.039933048641498423)*(jac_affine_inv_0_0_GREEN_UP*0.01482761006242336 + jac_affine_inv_1_0_GREEN_UP*0.01482761006242336 + jac_affine_inv_2_0_GREEN_UP*0.13849441039088178) + (jac_affine_inv_1_1_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_1_GREEN_UP*0.039933048641498423)*(jac_affine_inv_0_1_GREEN_UP*0.01482761006242336 + jac_affine_inv_1_1_GREEN_UP*0.01482761006242336 + jac_affine_inv_2_1_GREEN_UP*0.13849441039088178) + (jac_affine_inv_1_2_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_2_GREEN_UP*0.039933048641498423)*(jac_affine_inv_0_2_GREEN_UP*0.01482761006242336 + jac_affine_inv_1_2_GREEN_UP*0.01482761006242336 + jac_affine_inv_2_2_GREEN_UP*0.13849441039088178)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_0_GREEN_UP*0.039933048641498423)*(jac_affine_inv_0_0_GREEN_UP*0.039933048641498423 + jac_affine_inv_1_0_GREEN_UP*0.16359984896995686 + jac_affine_inv_2_0_GREEN_UP*0.039933048641498423) + (jac_affine_inv_1_1_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_1_GREEN_UP*0.039933048641498423)*(jac_affine_inv_0_1_GREEN_UP*0.039933048641498423 + jac_affine_inv_1_1_GREEN_UP*0.16359984896995686 + jac_affine_inv_2_1_GREEN_UP*0.039933048641498423) + (jac_affine_inv_1_2_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_2_GREEN_UP*0.039933048641498423)*(jac_affine_inv_0_2_GREEN_UP*0.039933048641498423 + jac_affine_inv_1_2_GREEN_UP*0.16359984896995686 + jac_affine_inv_2_2_GREEN_UP*0.039933048641498423)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_0_GREEN_UP*0.039933048641498423)*(jac_affine_inv_0_0_GREEN_UP*0.94523934129607823 + jac_affine_inv_1_0_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_0_GREEN_UP*0.82157254096761978) + (jac_affine_inv_1_1_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_1_GREEN_UP*0.039933048641498423)*(jac_affine_inv_0_1_GREEN_UP*0.94523934129607823 + jac_affine_inv_1_1_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_1_GREEN_UP*0.82157254096761978) + (jac_affine_inv_1_2_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_2_GREEN_UP*0.039933048641498423)*(jac_affine_inv_0_2_GREEN_UP*0.94523934129607823 + jac_affine_inv_1_2_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_2_GREEN_UP*0.82157254096761978)), abs_det_jac_affine_GREEN_UP*(((jac_affine_inv_0_0_GREEN_UP*-0.018047840358637001 + jac_affine_inv_2_0_GREEN_UP)*(jac_affine_inv_0_0_GREEN_UP*-0.018047840358637001 + jac_affine_inv_2_0_GREEN_UP))*0.67498144007199123 + ((jac_affine_inv_0_1_GREEN_UP*-0.018047840358637001 + jac_affine_inv_2_1_GREEN_UP)*(jac_affine_inv_0_1_GREEN_UP*-0.018047840358637001 + jac_affine_inv_2_1_GREEN_UP))*0.67498144007199123 + ((jac_affine_inv_0_2_GREEN_UP*-0.018047840358637001 + jac_affine_inv_2_2_GREEN_UP)*(jac_affine_inv_0_2_GREEN_UP*-0.018047840358637001 + jac_affine_inv_2_2_GREEN_UP))*0.67498144007199123), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_0_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_0_GREEN_UP*-0.039933048641498423 + jac_affine_inv_1_0_GREEN_UP*0.82157254096761978) + (jac_affine_inv_0_1_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_1_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_1_GREEN_UP*-0.039933048641498423 + jac_affine_inv_1_1_GREEN_UP*0.82157254096761978) + (jac_affine_inv_0_2_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_2_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_2_GREEN_UP*-0.039933048641498423 + jac_affine_inv_1_2_GREEN_UP*0.82157254096761978)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_0_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_0_GREEN_UP*0.01482761006242336 + jac_affine_inv_1_0_GREEN_UP*0.01482761006242336 + jac_affine_inv_2_0_GREEN_UP*0.13849441039088178) + (jac_affine_inv_0_1_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_1_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_1_GREEN_UP*0.01482761006242336 + jac_affine_inv_1_1_GREEN_UP*0.01482761006242336 + jac_affine_inv_2_1_GREEN_UP*0.13849441039088178) + (jac_affine_inv_0_2_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_2_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_2_GREEN_UP*0.01482761006242336 + jac_affine_inv_1_2_GREEN_UP*0.01482761006242336 + jac_affine_inv_2_2_GREEN_UP*0.13849441039088178)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_0_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_0_GREEN_UP*0.039933048641498423 + jac_affine_inv_1_0_GREEN_UP*0.16359984896995686 + jac_affine_inv_2_0_GREEN_UP*0.039933048641498423) + (jac_affine_inv_0_1_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_1_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_1_GREEN_UP*0.039933048641498423 + jac_affine_inv_1_1_GREEN_UP*0.16359984896995686 + jac_affine_inv_2_1_GREEN_UP*0.039933048641498423) + (jac_affine_inv_0_2_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_2_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_2_GREEN_UP*0.039933048641498423 + jac_affine_inv_1_2_GREEN_UP*0.16359984896995686 + jac_affine_inv_2_2_GREEN_UP*0.039933048641498423)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_0_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_0_GREEN_UP*0.94523934129607823 + jac_affine_inv_1_0_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_0_GREEN_UP*0.82157254096761978) + (jac_affine_inv_0_1_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_1_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_1_GREEN_UP*0.94523934129607823 + jac_affine_inv_1_1_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_1_GREEN_UP*0.82157254096761978) + (jac_affine_inv_0_2_GREEN_UP*-0.01482761006242336 + jac_affine_inv_2_2_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_2_GREEN_UP*0.94523934129607823 + jac_affine_inv_1_2_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_2_GREEN_UP*0.82157254096761978)), abs_det_jac_affine_GREEN_UP*(((jac_affine_inv_0_0_GREEN_UP*-0.048605627196920013 + jac_affine_inv_1_0_GREEN_UP)*(jac_affine_inv_0_0_GREEN_UP*-0.048605627196920013 + jac_affine_inv_1_0_GREEN_UP))*0.67498144007199123 + ((jac_affine_inv_0_1_GREEN_UP*-0.048605627196920013 + jac_affine_inv_1_1_GREEN_UP)*(jac_affine_inv_0_1_GREEN_UP*-0.048605627196920013 + jac_affine_inv_1_1_GREEN_UP))*0.67498144007199123 + ((jac_affine_inv_0_2_GREEN_UP*-0.048605627196920013 + jac_affine_inv_1_2_GREEN_UP)*(jac_affine_inv_0_2_GREEN_UP*-0.048605627196920013 + jac_affine_inv_1_2_GREEN_UP))*0.67498144007199123), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.039933048641498423 + jac_affine_inv_1_0_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_0_GREEN_UP*0.01482761006242336 + jac_affine_inv_1_0_GREEN_UP*0.01482761006242336 + jac_affine_inv_2_0_GREEN_UP*0.13849441039088178) + (jac_affine_inv_0_1_GREEN_UP*-0.039933048641498423 + jac_affine_inv_1_1_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_1_GREEN_UP*0.01482761006242336 + jac_affine_inv_1_1_GREEN_UP*0.01482761006242336 + jac_affine_inv_2_1_GREEN_UP*0.13849441039088178) + (jac_affine_inv_0_2_GREEN_UP*-0.039933048641498423 + jac_affine_inv_1_2_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_2_GREEN_UP*0.01482761006242336 + jac_affine_inv_1_2_GREEN_UP*0.01482761006242336 + jac_affine_inv_2_2_GREEN_UP*0.13849441039088178)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.039933048641498423 + jac_affine_inv_1_0_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_0_GREEN_UP*0.039933048641498423 + jac_affine_inv_1_0_GREEN_UP*0.16359984896995686 + jac_affine_inv_2_0_GREEN_UP*0.039933048641498423) + (jac_affine_inv_0_1_GREEN_UP*-0.039933048641498423 + jac_affine_inv_1_1_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_1_GREEN_UP*0.039933048641498423 + jac_affine_inv_1_1_GREEN_UP*0.16359984896995686 + jac_affine_inv_2_1_GREEN_UP*0.039933048641498423) + (jac_affine_inv_0_2_GREEN_UP*-0.039933048641498423 + jac_affine_inv_1_2_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_2_GREEN_UP*0.039933048641498423 + jac_affine_inv_1_2_GREEN_UP*0.16359984896995686 + jac_affine_inv_2_2_GREEN_UP*0.039933048641498423)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.039933048641498423 + jac_affine_inv_1_0_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_0_GREEN_UP*0.94523934129607823 + jac_affine_inv_1_0_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_0_GREEN_UP*0.82157254096761978) + (jac_affine_inv_0_1_GREEN_UP*-0.039933048641498423 + jac_affine_inv_1_1_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_1_GREEN_UP*0.94523934129607823 + jac_affine_inv_1_1_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_1_GREEN_UP*0.82157254096761978) + (jac_affine_inv_0_2_GREEN_UP*-0.039933048641498423 + jac_affine_inv_1_2_GREEN_UP*0.82157254096761978)*(jac_affine_inv_0_2_GREEN_UP*0.94523934129607823 + jac_affine_inv_1_2_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_2_GREEN_UP*0.82157254096761978)), abs_det_jac_affine_GREEN_UP*(((jac_affine_inv_0_0_GREEN_UP*0.10706287727117962 + jac_affine_inv_1_0_GREEN_UP*0.10706287727117962 + jac_affine_inv_2_0_GREEN_UP)*(jac_affine_inv_0_0_GREEN_UP*0.10706287727117962 + jac_affine_inv_1_0_GREEN_UP*0.10706287727117962 + jac_affine_inv_2_0_GREEN_UP))*0.019180701709517984 + ((jac_affine_inv_0_1_GREEN_UP*0.10706287727117962 + jac_affine_inv_1_1_GREEN_UP*0.10706287727117962 + jac_affine_inv_2_1_GREEN_UP)*(jac_affine_inv_0_1_GREEN_UP*0.10706287727117962 + jac_affine_inv_1_1_GREEN_UP*0.10706287727117962 + jac_affine_inv_2_1_GREEN_UP))*0.019180701709517984 + ((jac_affine_inv_0_2_GREEN_UP*0.10706287727117962 + jac_affine_inv_1_2_GREEN_UP*0.10706287727117962 + jac_affine_inv_2_2_GREEN_UP)*(jac_affine_inv_0_2_GREEN_UP*0.10706287727117962 + jac_affine_inv_1_2_GREEN_UP*0.10706287727117962 + jac_affine_inv_2_2_GREEN_UP))*0.019180701709517984), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.01482761006242336 + jac_affine_inv_1_0_GREEN_UP*0.01482761006242336 + jac_affine_inv_2_0_GREEN_UP*0.13849441039088178)*(jac_affine_inv_0_0_GREEN_UP*0.039933048641498423 + jac_affine_inv_1_0_GREEN_UP*0.16359984896995686 + jac_affine_inv_2_0_GREEN_UP*0.039933048641498423) + (jac_affine_inv_0_1_GREEN_UP*0.01482761006242336 + jac_affine_inv_1_1_GREEN_UP*0.01482761006242336 + jac_affine_inv_2_1_GREEN_UP*0.13849441039088178)*(jac_affine_inv_0_1_GREEN_UP*0.039933048641498423 + jac_affine_inv_1_1_GREEN_UP*0.16359984896995686 + jac_affine_inv_2_1_GREEN_UP*0.039933048641498423) + (jac_affine_inv_0_2_GREEN_UP*0.01482761006242336 + jac_affine_inv_1_2_GREEN_UP*0.01482761006242336 + jac_affine_inv_2_2_GREEN_UP*0.13849441039088178)*(jac_affine_inv_0_2_GREEN_UP*0.039933048641498423 + jac_affine_inv_1_2_GREEN_UP*0.16359984896995686 + jac_affine_inv_2_2_GREEN_UP*0.039933048641498423)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.01482761006242336 + jac_affine_inv_1_0_GREEN_UP*0.01482761006242336 + jac_affine_inv_2_0_GREEN_UP*0.13849441039088178)*(jac_affine_inv_0_0_GREEN_UP*0.94523934129607823 + jac_affine_inv_1_0_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_0_GREEN_UP*0.82157254096761978) + (jac_affine_inv_0_1_GREEN_UP*0.01482761006242336 + jac_affine_inv_1_1_GREEN_UP*0.01482761006242336 + jac_affine_inv_2_1_GREEN_UP*0.13849441039088178)*(jac_affine_inv_0_1_GREEN_UP*0.94523934129607823 + jac_affine_inv_1_1_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_1_GREEN_UP*0.82157254096761978) + (jac_affine_inv_0_2_GREEN_UP*0.01482761006242336 + jac_affine_inv_1_2_GREEN_UP*0.01482761006242336 + jac_affine_inv_2_2_GREEN_UP*0.13849441039088178)*(jac_affine_inv_0_2_GREEN_UP*0.94523934129607823 + jac_affine_inv_1_2_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_2_GREEN_UP*0.82157254096761978)), abs_det_jac_affine_GREEN_UP*(((jac_affine_inv_0_0_GREEN_UP*0.2440897647089616 + jac_affine_inv_1_0_GREEN_UP + jac_affine_inv_2_0_GREEN_UP*0.2440897647089616)*(jac_affine_inv_0_0_GREEN_UP*0.2440897647089616 + jac_affine_inv_1_0_GREEN_UP + jac_affine_inv_2_0_GREEN_UP*0.2440897647089616))*0.026764910582992695 + ((jac_affine_inv_0_1_GREEN_UP*0.2440897647089616 + jac_affine_inv_1_1_GREEN_UP + jac_affine_inv_2_1_GREEN_UP*0.2440897647089616)*(jac_affine_inv_0_1_GREEN_UP*0.2440897647089616 + jac_affine_inv_1_1_GREEN_UP + jac_affine_inv_2_1_GREEN_UP*0.2440897647089616))*0.026764910582992695 + ((jac_affine_inv_0_2_GREEN_UP*0.2440897647089616 + jac_affine_inv_1_2_GREEN_UP + jac_affine_inv_2_2_GREEN_UP*0.2440897647089616)*(jac_affine_inv_0_2_GREEN_UP*0.2440897647089616 + jac_affine_inv_1_2_GREEN_UP + jac_affine_inv_2_2_GREEN_UP*0.2440897647089616))*0.026764910582992695), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.039933048641498423 + jac_affine_inv_1_0_GREEN_UP*0.16359984896995686 + jac_affine_inv_2_0_GREEN_UP*0.039933048641498423)*(jac_affine_inv_0_0_GREEN_UP*0.94523934129607823 + jac_affine_inv_1_0_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_0_GREEN_UP*0.82157254096761978) + (jac_affine_inv_0_1_GREEN_UP*0.039933048641498423 + jac_affine_inv_1_1_GREEN_UP*0.16359984896995686 + jac_affine_inv_2_1_GREEN_UP*0.039933048641498423)*(jac_affine_inv_0_1_GREEN_UP*0.94523934129607823 + jac_affine_inv_1_1_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_1_GREEN_UP*0.82157254096761978) + (jac_affine_inv_0_2_GREEN_UP*0.039933048641498423 + jac_affine_inv_1_2_GREEN_UP*0.16359984896995686 + jac_affine_inv_2_2_GREEN_UP*0.039933048641498423)*(jac_affine_inv_0_2_GREEN_UP*0.94523934129607823 + jac_affine_inv_1_2_GREEN_UP*0.82157254096761978 + jac_affine_inv_2_2_GREEN_UP*0.82157254096761978)), abs_det_jac_affine_GREEN_UP*(((jac_affine_inv_0_0_GREEN_UP + jac_affine_inv_1_0_GREEN_UP*0.86916879680558901 + jac_affine_inv_2_0_GREEN_UP*0.86916879680558901)*(jac_affine_inv_0_0_GREEN_UP + jac_affine_inv_1_0_GREEN_UP*0.86916879680558901 + jac_affine_inv_2_0_GREEN_UP*0.86916879680558901))*0.89347741233384381 + ((jac_affine_inv_0_1_GREEN_UP + jac_affine_inv_1_1_GREEN_UP*0.86916879680558901 + jac_affine_inv_2_1_GREEN_UP*0.86916879680558901)*(jac_affine_inv_0_1_GREEN_UP + jac_affine_inv_1_1_GREEN_UP*0.86916879680558901 + jac_affine_inv_2_1_GREEN_UP*0.86916879680558901))*0.89347741233384381 + ((jac_affine_inv_0_2_GREEN_UP + jac_affine_inv_1_2_GREEN_UP*0.86916879680558901 + jac_affine_inv_2_2_GREEN_UP*0.86916879680558901)*(jac_affine_inv_0_2_GREEN_UP + jac_affine_inv_1_2_GREEN_UP*0.86916879680558901 + jac_affine_inv_2_2_GREEN_UP*0.86916879680558901))*0.89347741233384381), abs_det_jac_affine_GREEN_UP*(((jac_affine_inv_1_0_GREEN_UP*-0.012677777773509136 + jac_affine_inv_2_0_GREEN_UP)*(jac_affine_inv_1_0_GREEN_UP*-0.012677777773509136 + jac_affine_inv_2_0_GREEN_UP))*0.14574478709475508 + ((jac_affine_inv_1_1_GREEN_UP*-0.012677777773509136 + jac_affine_inv_2_1_GREEN_UP)*(jac_affine_inv_1_1_GREEN_UP*-0.012677777773509136 + jac_affine_inv_2_1_GREEN_UP))*0.14574478709475508 + ((jac_affine_inv_1_2_GREEN_UP*-0.012677777773509136 + jac_affine_inv_2_2_GREEN_UP)*(jac_affine_inv_1_2_GREEN_UP*-0.012677777773509136 + jac_affine_inv_2_2_GREEN_UP))*0.14574478709475508), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_0_GREEN_UP*0.15593312049918601)*(jac_affine_inv_1_0_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_0_GREEN_UP*0.3817653560693467) + (jac_affine_inv_0_1_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_1_GREEN_UP*0.15593312049918601)*(jac_affine_inv_1_1_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_1_GREEN_UP*0.3817653560693467) + (jac_affine_inv_0_2_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_2_GREEN_UP*0.15593312049918601)*(jac_affine_inv_1_2_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_2_GREEN_UP*0.3817653560693467)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.3817653560693467 + jac_affine_inv_1_0_GREEN_UP*0.15593312049918601)*(jac_affine_inv_1_0_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_0_GREEN_UP*0.3817653560693467) + (jac_affine_inv_0_1_GREEN_UP*-0.3817653560693467 + jac_affine_inv_1_1_GREEN_UP*0.15593312049918601)*(jac_affine_inv_1_1_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_1_GREEN_UP*0.3817653560693467) + (jac_affine_inv_0_2_GREEN_UP*-0.3817653560693467 + jac_affine_inv_1_2_GREEN_UP*0.15593312049918601)*(jac_affine_inv_1_2_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_2_GREEN_UP*0.3817653560693467)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_0_GREEN_UP*0.3817653560693467)*(jac_affine_inv_0_0_GREEN_UP*0.0048399363458717648 + jac_affine_inv_1_0_GREEN_UP*0.0048399363458717648 + jac_affine_inv_2_0_GREEN_UP*0.46230152343146724) + (jac_affine_inv_1_1_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_1_GREEN_UP*0.3817653560693467)*(jac_affine_inv_0_1_GREEN_UP*0.0048399363458717648 + jac_affine_inv_1_1_GREEN_UP*0.0048399363458717648 + jac_affine_inv_2_1_GREEN_UP*0.46230152343146724) + (jac_affine_inv_1_2_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_2_GREEN_UP*0.3817653560693467)*(jac_affine_inv_0_2_GREEN_UP*0.0048399363458717648 + jac_affine_inv_1_2_GREEN_UP*0.0048399363458717648 + jac_affine_inv_2_2_GREEN_UP*0.46230152343146724)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_0_GREEN_UP*0.3817653560693467)*(jac_affine_inv_0_0_GREEN_UP*0.3817653560693467 + jac_affine_inv_1_0_GREEN_UP*0.83922694315494217 + jac_affine_inv_2_0_GREEN_UP*0.3817653560693467) + (jac_affine_inv_1_1_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_1_GREEN_UP*0.3817653560693467)*(jac_affine_inv_0_1_GREEN_UP*0.3817653560693467 + jac_affine_inv_1_1_GREEN_UP*0.83922694315494217 + jac_affine_inv_2_1_GREEN_UP*0.3817653560693467) + (jac_affine_inv_1_2_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_2_GREEN_UP*0.3817653560693467)*(jac_affine_inv_0_2_GREEN_UP*0.3817653560693467 + jac_affine_inv_1_2_GREEN_UP*0.83922694315494217 + jac_affine_inv_2_2_GREEN_UP*0.3817653560693467)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_0_GREEN_UP*0.3817653560693467)*(jac_affine_inv_0_0_GREEN_UP*0.61339470758478154 + jac_affine_inv_1_0_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_0_GREEN_UP*0.15593312049918601) + (jac_affine_inv_1_1_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_1_GREEN_UP*0.3817653560693467)*(jac_affine_inv_0_1_GREEN_UP*0.61339470758478154 + jac_affine_inv_1_1_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_1_GREEN_UP*0.15593312049918601) + (jac_affine_inv_1_2_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_2_GREEN_UP*0.3817653560693467)*(jac_affine_inv_0_2_GREEN_UP*0.61339470758478154 + jac_affine_inv_1_2_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_2_GREEN_UP*0.15593312049918601)), abs_det_jac_affine_GREEN_UP*(((jac_affine_inv_0_0_GREEN_UP*-0.031038539666093771 + jac_affine_inv_2_0_GREEN_UP)*(jac_affine_inv_0_0_GREEN_UP*-0.031038539666093771 + jac_affine_inv_2_0_GREEN_UP))*0.024315138068613663 + ((jac_affine_inv_0_1_GREEN_UP*-0.031038539666093771 + jac_affine_inv_2_1_GREEN_UP)*(jac_affine_inv_0_1_GREEN_UP*-0.031038539666093771 + jac_affine_inv_2_1_GREEN_UP))*0.024315138068613663 + ((jac_affine_inv_0_2_GREEN_UP*-0.031038539666093771 + jac_affine_inv_2_2_GREEN_UP)*(jac_affine_inv_0_2_GREEN_UP*-0.031038539666093771 + jac_affine_inv_2_2_GREEN_UP))*0.024315138068613663), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_0_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_0_GREEN_UP*-0.3817653560693467 + jac_affine_inv_1_0_GREEN_UP*0.15593312049918601) + (jac_affine_inv_0_1_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_1_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_1_GREEN_UP*-0.3817653560693467 + jac_affine_inv_1_1_GREEN_UP*0.15593312049918601) + (jac_affine_inv_0_2_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_2_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_2_GREEN_UP*-0.3817653560693467 + jac_affine_inv_1_2_GREEN_UP*0.15593312049918601)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_0_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_0_GREEN_UP*0.0048399363458717648 + jac_affine_inv_1_0_GREEN_UP*0.0048399363458717648 + jac_affine_inv_2_0_GREEN_UP*0.46230152343146724) + (jac_affine_inv_0_1_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_1_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_1_GREEN_UP*0.0048399363458717648 + jac_affine_inv_1_1_GREEN_UP*0.0048399363458717648 + jac_affine_inv_2_1_GREEN_UP*0.46230152343146724) + (jac_affine_inv_0_2_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_2_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_2_GREEN_UP*0.0048399363458717648 + jac_affine_inv_1_2_GREEN_UP*0.0048399363458717648 + jac_affine_inv_2_2_GREEN_UP*0.46230152343146724)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_0_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_0_GREEN_UP*0.3817653560693467 + jac_affine_inv_1_0_GREEN_UP*0.83922694315494217 + jac_affine_inv_2_0_GREEN_UP*0.3817653560693467) + (jac_affine_inv_0_1_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_1_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_1_GREEN_UP*0.3817653560693467 + jac_affine_inv_1_1_GREEN_UP*0.83922694315494217 + jac_affine_inv_2_1_GREEN_UP*0.3817653560693467) + (jac_affine_inv_0_2_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_2_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_2_GREEN_UP*0.3817653560693467 + jac_affine_inv_1_2_GREEN_UP*0.83922694315494217 + jac_affine_inv_2_2_GREEN_UP*0.3817653560693467)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_0_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_0_GREEN_UP*0.61339470758478154 + jac_affine_inv_1_0_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_0_GREEN_UP*0.15593312049918601) + (jac_affine_inv_0_1_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_1_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_1_GREEN_UP*0.61339470758478154 + jac_affine_inv_1_1_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_1_GREEN_UP*0.15593312049918601) + (jac_affine_inv_0_2_GREEN_UP*-0.0048399363458717648 + jac_affine_inv_2_2_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_2_GREEN_UP*0.61339470758478154 + jac_affine_inv_1_2_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_2_GREEN_UP*0.15593312049918601)), abs_det_jac_affine_GREEN_UP*(((-jac_affine_inv_0_0_GREEN_UP + jac_affine_inv_1_0_GREEN_UP*0.40845277870331731)*(-jac_affine_inv_0_0_GREEN_UP + jac_affine_inv_1_0_GREEN_UP*0.40845277870331731))*0.14574478709475508 + ((-jac_affine_inv_0_1_GREEN_UP + jac_affine_inv_1_1_GREEN_UP*0.40845277870331731)*(-jac_affine_inv_0_1_GREEN_UP + jac_affine_inv_1_1_GREEN_UP*0.40845277870331731))*0.14574478709475508 + ((-jac_affine_inv_0_2_GREEN_UP + jac_affine_inv_1_2_GREEN_UP*0.40845277870331731)*(-jac_affine_inv_0_2_GREEN_UP + jac_affine_inv_1_2_GREEN_UP*0.40845277870331731))*0.14574478709475508), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.3817653560693467 + jac_affine_inv_1_0_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_0_GREEN_UP*0.0048399363458717648 + jac_affine_inv_1_0_GREEN_UP*0.0048399363458717648 + jac_affine_inv_2_0_GREEN_UP*0.46230152343146724) + (jac_affine_inv_0_1_GREEN_UP*-0.3817653560693467 + jac_affine_inv_1_1_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_1_GREEN_UP*0.0048399363458717648 + jac_affine_inv_1_1_GREEN_UP*0.0048399363458717648 + jac_affine_inv_2_1_GREEN_UP*0.46230152343146724) + (jac_affine_inv_0_2_GREEN_UP*-0.3817653560693467 + jac_affine_inv_1_2_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_2_GREEN_UP*0.0048399363458717648 + jac_affine_inv_1_2_GREEN_UP*0.0048399363458717648 + jac_affine_inv_2_2_GREEN_UP*0.46230152343146724)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.3817653560693467 + jac_affine_inv_1_0_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_0_GREEN_UP*0.3817653560693467 + jac_affine_inv_1_0_GREEN_UP*0.83922694315494217 + jac_affine_inv_2_0_GREEN_UP*0.3817653560693467) + (jac_affine_inv_0_1_GREEN_UP*-0.3817653560693467 + jac_affine_inv_1_1_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_1_GREEN_UP*0.3817653560693467 + jac_affine_inv_1_1_GREEN_UP*0.83922694315494217 + jac_affine_inv_2_1_GREEN_UP*0.3817653560693467) + (jac_affine_inv_0_2_GREEN_UP*-0.3817653560693467 + jac_affine_inv_1_2_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_2_GREEN_UP*0.3817653560693467 + jac_affine_inv_1_2_GREEN_UP*0.83922694315494217 + jac_affine_inv_2_2_GREEN_UP*0.3817653560693467)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.3817653560693467 + jac_affine_inv_1_0_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_0_GREEN_UP*0.61339470758478154 + jac_affine_inv_1_0_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_0_GREEN_UP*0.15593312049918601) + (jac_affine_inv_0_1_GREEN_UP*-0.3817653560693467 + jac_affine_inv_1_1_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_1_GREEN_UP*0.61339470758478154 + jac_affine_inv_1_1_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_1_GREEN_UP*0.15593312049918601) + (jac_affine_inv_0_2_GREEN_UP*-0.3817653560693467 + jac_affine_inv_1_2_GREEN_UP*0.15593312049918601)*(jac_affine_inv_0_2_GREEN_UP*0.61339470758478154 + jac_affine_inv_1_2_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_2_GREEN_UP*0.15593312049918601)), abs_det_jac_affine_GREEN_UP*(((jac_affine_inv_0_0_GREEN_UP*0.010469219979953731 + jac_affine_inv_1_0_GREEN_UP*0.010469219979953731 + jac_affine_inv_2_0_GREEN_UP)*(jac_affine_inv_0_0_GREEN_UP*0.010469219979953731 + jac_affine_inv_1_0_GREEN_UP*0.010469219979953731 + jac_affine_inv_2_0_GREEN_UP))*0.21372269856705545 + ((jac_affine_inv_0_1_GREEN_UP*0.010469219979953731 + jac_affine_inv_1_1_GREEN_UP*0.010469219979953731 + jac_affine_inv_2_1_GREEN_UP)*(jac_affine_inv_0_1_GREEN_UP*0.010469219979953731 + jac_affine_inv_1_1_GREEN_UP*0.010469219979953731 + jac_affine_inv_2_1_GREEN_UP))*0.21372269856705545 + ((jac_affine_inv_0_2_GREEN_UP*0.010469219979953731 + jac_affine_inv_1_2_GREEN_UP*0.010469219979953731 + jac_affine_inv_2_2_GREEN_UP)*(jac_affine_inv_0_2_GREEN_UP*0.010469219979953731 + jac_affine_inv_1_2_GREEN_UP*0.010469219979953731 + jac_affine_inv_2_2_GREEN_UP))*0.21372269856705545), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.0048399363458717648 + jac_affine_inv_1_0_GREEN_UP*0.0048399363458717648 + jac_affine_inv_2_0_GREEN_UP*0.46230152343146724)*(jac_affine_inv_0_0_GREEN_UP*0.3817653560693467 + jac_affine_inv_1_0_GREEN_UP*0.83922694315494217 + jac_affine_inv_2_0_GREEN_UP*0.3817653560693467) + (jac_affine_inv_0_1_GREEN_UP*0.0048399363458717648 + jac_affine_inv_1_1_GREEN_UP*0.0048399363458717648 + jac_affine_inv_2_1_GREEN_UP*0.46230152343146724)*(jac_affine_inv_0_1_GREEN_UP*0.3817653560693467 + jac_affine_inv_1_1_GREEN_UP*0.83922694315494217 + jac_affine_inv_2_1_GREEN_UP*0.3817653560693467) + (jac_affine_inv_0_2_GREEN_UP*0.0048399363458717648 + jac_affine_inv_1_2_GREEN_UP*0.0048399363458717648 + jac_affine_inv_2_2_GREEN_UP*0.46230152343146724)*(jac_affine_inv_0_2_GREEN_UP*0.3817653560693467 + jac_affine_inv_1_2_GREEN_UP*0.83922694315494217 + jac_affine_inv_2_2_GREEN_UP*0.3817653560693467)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.0048399363458717648 + jac_affine_inv_1_0_GREEN_UP*0.0048399363458717648 + jac_affine_inv_2_0_GREEN_UP*0.46230152343146724)*(jac_affine_inv_0_0_GREEN_UP*0.61339470758478154 + jac_affine_inv_1_0_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_0_GREEN_UP*0.15593312049918601) + (jac_affine_inv_0_1_GREEN_UP*0.0048399363458717648 + jac_affine_inv_1_1_GREEN_UP*0.0048399363458717648 + jac_affine_inv_2_1_GREEN_UP*0.46230152343146724)*(jac_affine_inv_0_1_GREEN_UP*0.61339470758478154 + jac_affine_inv_1_1_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_1_GREEN_UP*0.15593312049918601) + (jac_affine_inv_0_2_GREEN_UP*0.0048399363458717648 + jac_affine_inv_1_2_GREEN_UP*0.0048399363458717648 + jac_affine_inv_2_2_GREEN_UP*0.46230152343146724)*(jac_affine_inv_0_2_GREEN_UP*0.61339470758478154 + jac_affine_inv_1_2_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_2_GREEN_UP*0.15593312049918601)), abs_det_jac_affine_GREEN_UP*(((jac_affine_inv_0_0_GREEN_UP*0.45490121496118757 + jac_affine_inv_1_0_GREEN_UP + jac_affine_inv_2_0_GREEN_UP*0.45490121496118757)*(jac_affine_inv_0_0_GREEN_UP*0.45490121496118757 + jac_affine_inv_1_0_GREEN_UP + jac_affine_inv_2_0_GREEN_UP*0.45490121496118757))*0.70430186211718859 + ((jac_affine_inv_0_1_GREEN_UP*0.45490121496118757 + jac_affine_inv_1_1_GREEN_UP + jac_affine_inv_2_1_GREEN_UP*0.45490121496118757)*(jac_affine_inv_0_1_GREEN_UP*0.45490121496118757 + jac_affine_inv_1_1_GREEN_UP + jac_affine_inv_2_1_GREEN_UP*0.45490121496118757))*0.70430186211718859 + ((jac_affine_inv_0_2_GREEN_UP*0.45490121496118757 + jac_affine_inv_1_2_GREEN_UP + jac_affine_inv_2_2_GREEN_UP*0.45490121496118757)*(jac_affine_inv_0_2_GREEN_UP*0.45490121496118757 + jac_affine_inv_1_2_GREEN_UP + jac_affine_inv_2_2_GREEN_UP*0.45490121496118757))*0.70430186211718859), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.3817653560693467 + jac_affine_inv_1_0_GREEN_UP*0.83922694315494217 + jac_affine_inv_2_0_GREEN_UP*0.3817653560693467)*(jac_affine_inv_0_0_GREEN_UP*0.61339470758478154 + jac_affine_inv_1_0_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_0_GREEN_UP*0.15593312049918601) + (jac_affine_inv_0_1_GREEN_UP*0.3817653560693467 + jac_affine_inv_1_1_GREEN_UP*0.83922694315494217 + jac_affine_inv_2_1_GREEN_UP*0.3817653560693467)*(jac_affine_inv_0_1_GREEN_UP*0.61339470758478154 + jac_affine_inv_1_1_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_1_GREEN_UP*0.15593312049918601) + (jac_affine_inv_0_2_GREEN_UP*0.3817653560693467 + jac_affine_inv_1_2_GREEN_UP*0.83922694315494217 + jac_affine_inv_2_2_GREEN_UP*0.3817653560693467)*(jac_affine_inv_0_2_GREEN_UP*0.61339470758478154 + jac_affine_inv_1_2_GREEN_UP*0.15593312049918601 + jac_affine_inv_2_2_GREEN_UP*0.15593312049918601)), abs_det_jac_affine_GREEN_UP*(((jac_affine_inv_0_0_GREEN_UP + jac_affine_inv_1_0_GREEN_UP*0.25421334512840316 + jac_affine_inv_2_0_GREEN_UP*0.25421334512840316)*(jac_affine_inv_0_0_GREEN_UP + jac_affine_inv_1_0_GREEN_UP*0.25421334512840316 + jac_affine_inv_2_0_GREEN_UP*0.25421334512840316))*0.37625306729301966 + ((jac_affine_inv_0_1_GREEN_UP + jac_affine_inv_1_1_GREEN_UP*0.25421334512840316 + jac_affine_inv_2_1_GREEN_UP*0.25421334512840316)*(jac_affine_inv_0_1_GREEN_UP + jac_affine_inv_1_1_GREEN_UP*0.25421334512840316 + jac_affine_inv_2_1_GREEN_UP*0.25421334512840316))*0.37625306729301966 + ((jac_affine_inv_0_2_GREEN_UP + jac_affine_inv_1_2_GREEN_UP*0.25421334512840316 + jac_affine_inv_2_2_GREEN_UP*0.25421334512840316)*(jac_affine_inv_0_2_GREEN_UP + jac_affine_inv_1_2_GREEN_UP*0.25421334512840316 + jac_affine_inv_2_2_GREEN_UP*0.25421334512840316))*0.37625306729301966), abs_det_jac_affine_GREEN_UP*(((-jac_affine_inv_1_0_GREEN_UP + jac_affine_inv_2_0_GREEN_UP*0.015462881894859308)*(-jac_affine_inv_1_0_GREEN_UP + jac_affine_inv_2_0_GREEN_UP*0.015462881894859308))*0.20046443821120841 + ((-jac_affine_inv_1_1_GREEN_UP + jac_affine_inv_2_1_GREEN_UP*0.015462881894859308)*(-jac_affine_inv_1_1_GREEN_UP + jac_affine_inv_2_1_GREEN_UP*0.015462881894859308))*0.20046443821120841 + ((-jac_affine_inv_1_2_GREEN_UP + jac_affine_inv_2_2_GREEN_UP*0.015462881894859308)*(-jac_affine_inv_1_2_GREEN_UP + jac_affine_inv_2_2_GREEN_UP*0.015462881894859308))*0.20046443821120841), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_0_GREEN_UP*0.18002969351036541)*(jac_affine_inv_1_0_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_0_GREEN_UP*0.0069232355736274674) + (jac_affine_inv_0_1_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_1_GREEN_UP*0.18002969351036541)*(jac_affine_inv_1_1_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_1_GREEN_UP*0.0069232355736274674) + (jac_affine_inv_0_2_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_2_GREEN_UP*0.18002969351036541)*(jac_affine_inv_1_2_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_2_GREEN_UP*0.0069232355736274674)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.0069232355736274674 + jac_affine_inv_1_0_GREEN_UP*0.18002969351036541)*(jac_affine_inv_1_0_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_0_GREEN_UP*0.0069232355736274674) + (jac_affine_inv_0_1_GREEN_UP*-0.0069232355736274674 + jac_affine_inv_1_1_GREEN_UP*0.18002969351036541)*(jac_affine_inv_1_1_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_1_GREEN_UP*0.0069232355736274674) + (jac_affine_inv_0_2_GREEN_UP*-0.0069232355736274674 + jac_affine_inv_1_2_GREEN_UP*0.18002969351036541)*(jac_affine_inv_1_2_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_2_GREEN_UP*0.0069232355736274674)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_0_GREEN_UP*0.0069232355736274674)*(jac_affine_inv_0_0_GREEN_UP*0.44773255210137269 + jac_affine_inv_1_0_GREEN_UP*0.44773255210137269 + jac_affine_inv_2_0_GREEN_UP*0.81304707091600714) + (jac_affine_inv_1_1_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_1_GREEN_UP*0.0069232355736274674)*(jac_affine_inv_0_1_GREEN_UP*0.44773255210137269 + jac_affine_inv_1_1_GREEN_UP*0.44773255210137269 + jac_affine_inv_2_1_GREEN_UP*0.81304707091600714) + (jac_affine_inv_1_2_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_2_GREEN_UP*0.0069232355736274674)*(jac_affine_inv_0_2_GREEN_UP*0.44773255210137269 + jac_affine_inv_1_2_GREEN_UP*0.44773255210137269 + jac_affine_inv_2_2_GREEN_UP*0.81304707091600714)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_0_GREEN_UP*0.0069232355736274674)*(jac_affine_inv_0_0_GREEN_UP*0.0069232355736274674 + jac_affine_inv_1_0_GREEN_UP*0.37223775438826195 + jac_affine_inv_2_0_GREEN_UP*0.0069232355736274674) + (jac_affine_inv_1_1_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_1_GREEN_UP*0.0069232355736274674)*(jac_affine_inv_0_1_GREEN_UP*0.0069232355736274674 + jac_affine_inv_1_1_GREEN_UP*0.37223775438826195 + jac_affine_inv_2_1_GREEN_UP*0.0069232355736274674) + (jac_affine_inv_1_2_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_2_GREEN_UP*0.0069232355736274674)*(jac_affine_inv_0_2_GREEN_UP*0.0069232355736274674 + jac_affine_inv_1_2_GREEN_UP*0.37223775438826195 + jac_affine_inv_2_2_GREEN_UP*0.0069232355736274674)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_0_GREEN_UP*0.0069232355736274674)*(jac_affine_inv_0_0_GREEN_UP*0.54534421232499986 + jac_affine_inv_1_0_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_0_GREEN_UP*0.18002969351036541) + (jac_affine_inv_1_1_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_1_GREEN_UP*0.0069232355736274674)*(jac_affine_inv_0_1_GREEN_UP*0.54534421232499986 + jac_affine_inv_1_1_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_1_GREEN_UP*0.18002969351036541) + (jac_affine_inv_1_2_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_2_GREEN_UP*0.0069232355736274674)*(jac_affine_inv_0_2_GREEN_UP*0.54534421232499986 + jac_affine_inv_1_2_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_2_GREEN_UP*0.18002969351036541)), abs_det_jac_affine_GREEN_UP*(((-jac_affine_inv_0_0_GREEN_UP + jac_affine_inv_2_0_GREEN_UP*0.40209203611714223)*(-jac_affine_inv_0_0_GREEN_UP + jac_affine_inv_2_0_GREEN_UP*0.40209203611714223))*0.20046443821120841 + ((-jac_affine_inv_0_1_GREEN_UP + jac_affine_inv_2_1_GREEN_UP*0.40209203611714223)*(-jac_affine_inv_0_1_GREEN_UP + jac_affine_inv_2_1_GREEN_UP*0.40209203611714223))*0.20046443821120841 + ((-jac_affine_inv_0_2_GREEN_UP + jac_affine_inv_2_2_GREEN_UP*0.40209203611714223)*(-jac_affine_inv_0_2_GREEN_UP + jac_affine_inv_2_2_GREEN_UP*0.40209203611714223))*0.20046443821120841), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.0069232355736274674 + jac_affine_inv_1_0_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_0_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_0_GREEN_UP*0.18002969351036541) + (jac_affine_inv_0_1_GREEN_UP*-0.0069232355736274674 + jac_affine_inv_1_1_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_1_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_1_GREEN_UP*0.18002969351036541) + (jac_affine_inv_0_2_GREEN_UP*-0.0069232355736274674 + jac_affine_inv_1_2_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_2_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_2_GREEN_UP*0.18002969351036541)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_0_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_0_GREEN_UP*0.44773255210137269 + jac_affine_inv_1_0_GREEN_UP*0.44773255210137269 + jac_affine_inv_2_0_GREEN_UP*0.81304707091600714) + (jac_affine_inv_0_1_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_1_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_1_GREEN_UP*0.44773255210137269 + jac_affine_inv_1_1_GREEN_UP*0.44773255210137269 + jac_affine_inv_2_1_GREEN_UP*0.81304707091600714) + (jac_affine_inv_0_2_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_2_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_2_GREEN_UP*0.44773255210137269 + jac_affine_inv_1_2_GREEN_UP*0.44773255210137269 + jac_affine_inv_2_2_GREEN_UP*0.81304707091600714)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_0_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_0_GREEN_UP*0.0069232355736274674 + jac_affine_inv_1_0_GREEN_UP*0.37223775438826195 + jac_affine_inv_2_0_GREEN_UP*0.0069232355736274674) + (jac_affine_inv_0_1_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_1_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_1_GREEN_UP*0.0069232355736274674 + jac_affine_inv_1_1_GREEN_UP*0.37223775438826195 + jac_affine_inv_2_1_GREEN_UP*0.0069232355736274674) + (jac_affine_inv_0_2_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_2_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_2_GREEN_UP*0.0069232355736274674 + jac_affine_inv_1_2_GREEN_UP*0.37223775438826195 + jac_affine_inv_2_2_GREEN_UP*0.0069232355736274674)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_0_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_0_GREEN_UP*0.54534421232499986 + jac_affine_inv_1_0_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_0_GREEN_UP*0.18002969351036541) + (jac_affine_inv_0_1_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_1_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_1_GREEN_UP*0.54534421232499986 + jac_affine_inv_1_1_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_1_GREEN_UP*0.18002969351036541) + (jac_affine_inv_0_2_GREEN_UP*-0.44773255210137269 + jac_affine_inv_2_2_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_2_GREEN_UP*0.54534421232499986 + jac_affine_inv_1_2_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_2_GREEN_UP*0.18002969351036541)), abs_det_jac_affine_GREEN_UP*(((jac_affine_inv_0_0_GREEN_UP*-0.03845607598742512 + jac_affine_inv_1_0_GREEN_UP)*(jac_affine_inv_0_0_GREEN_UP*-0.03845607598742512 + jac_affine_inv_1_0_GREEN_UP))*0.032410690545436105 + ((jac_affine_inv_0_1_GREEN_UP*-0.03845607598742512 + jac_affine_inv_1_1_GREEN_UP)*(jac_affine_inv_0_1_GREEN_UP*-0.03845607598742512 + jac_affine_inv_1_1_GREEN_UP))*0.032410690545436105 + ((jac_affine_inv_0_2_GREEN_UP*-0.03845607598742512 + jac_affine_inv_1_2_GREEN_UP)*(jac_affine_inv_0_2_GREEN_UP*-0.03845607598742512 + jac_affine_inv_1_2_GREEN_UP))*0.032410690545436105), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.0069232355736274674 + jac_affine_inv_1_0_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_0_GREEN_UP*0.44773255210137269 + jac_affine_inv_1_0_GREEN_UP*0.44773255210137269 + jac_affine_inv_2_0_GREEN_UP*0.81304707091600714) + (jac_affine_inv_0_1_GREEN_UP*-0.0069232355736274674 + jac_affine_inv_1_1_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_1_GREEN_UP*0.44773255210137269 + jac_affine_inv_1_1_GREEN_UP*0.44773255210137269 + jac_affine_inv_2_1_GREEN_UP*0.81304707091600714) + (jac_affine_inv_0_2_GREEN_UP*-0.0069232355736274674 + jac_affine_inv_1_2_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_2_GREEN_UP*0.44773255210137269 + jac_affine_inv_1_2_GREEN_UP*0.44773255210137269 + jac_affine_inv_2_2_GREEN_UP*0.81304707091600714)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.0069232355736274674 + jac_affine_inv_1_0_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_0_GREEN_UP*0.0069232355736274674 + jac_affine_inv_1_0_GREEN_UP*0.37223775438826195 + jac_affine_inv_2_0_GREEN_UP*0.0069232355736274674) + (jac_affine_inv_0_1_GREEN_UP*-0.0069232355736274674 + jac_affine_inv_1_1_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_1_GREEN_UP*0.0069232355736274674 + jac_affine_inv_1_1_GREEN_UP*0.37223775438826195 + jac_affine_inv_2_1_GREEN_UP*0.0069232355736274674) + (jac_affine_inv_0_2_GREEN_UP*-0.0069232355736274674 + jac_affine_inv_1_2_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_2_GREEN_UP*0.0069232355736274674 + jac_affine_inv_1_2_GREEN_UP*0.37223775438826195 + jac_affine_inv_2_2_GREEN_UP*0.0069232355736274674)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.0069232355736274674 + jac_affine_inv_1_0_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_0_GREEN_UP*0.54534421232499986 + jac_affine_inv_1_0_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_0_GREEN_UP*0.18002969351036541) + (jac_affine_inv_0_1_GREEN_UP*-0.0069232355736274674 + jac_affine_inv_1_1_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_1_GREEN_UP*0.54534421232499986 + jac_affine_inv_1_1_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_1_GREEN_UP*0.18002969351036541) + (jac_affine_inv_0_2_GREEN_UP*-0.0069232355736274674 + jac_affine_inv_1_2_GREEN_UP*0.18002969351036541)*(jac_affine_inv_0_2_GREEN_UP*0.54534421232499986 + jac_affine_inv_1_2_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_2_GREEN_UP*0.18002969351036541)), abs_det_jac_affine_GREEN_UP*(((jac_affine_inv_0_0_GREEN_UP*0.55068466281655948 + jac_affine_inv_1_0_GREEN_UP*0.55068466281655948 + jac_affine_inv_2_0_GREEN_UP)*(jac_affine_inv_0_0_GREEN_UP*0.55068466281655948 + jac_affine_inv_1_0_GREEN_UP*0.55068466281655948 + jac_affine_inv_2_0_GREEN_UP))*0.6610455395250987 + ((jac_affine_inv_0_1_GREEN_UP*0.55068466281655948 + jac_affine_inv_1_1_GREEN_UP*0.55068466281655948 + jac_affine_inv_2_1_GREEN_UP)*(jac_affine_inv_0_1_GREEN_UP*0.55068466281655948 + jac_affine_inv_1_1_GREEN_UP*0.55068466281655948 + jac_affine_inv_2_1_GREEN_UP))*0.6610455395250987 + ((jac_affine_inv_0_2_GREEN_UP*0.55068466281655948 + jac_affine_inv_1_2_GREEN_UP*0.55068466281655948 + jac_affine_inv_2_2_GREEN_UP)*(jac_affine_inv_0_2_GREEN_UP*0.55068466281655948 + jac_affine_inv_1_2_GREEN_UP*0.55068466281655948 + jac_affine_inv_2_2_GREEN_UP))*0.6610455395250987), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.0069232355736274674 + jac_affine_inv_1_0_GREEN_UP*0.37223775438826195 + jac_affine_inv_2_0_GREEN_UP*0.0069232355736274674)*(jac_affine_inv_0_0_GREEN_UP*0.44773255210137269 + jac_affine_inv_1_0_GREEN_UP*0.44773255210137269 + jac_affine_inv_2_0_GREEN_UP*0.81304707091600714) + (jac_affine_inv_0_1_GREEN_UP*0.0069232355736274674 + jac_affine_inv_1_1_GREEN_UP*0.37223775438826195 + jac_affine_inv_2_1_GREEN_UP*0.0069232355736274674)*(jac_affine_inv_0_1_GREEN_UP*0.44773255210137269 + jac_affine_inv_1_1_GREEN_UP*0.44773255210137269 + jac_affine_inv_2_1_GREEN_UP*0.81304707091600714) + (jac_affine_inv_0_2_GREEN_UP*0.0069232355736274674 + jac_affine_inv_1_2_GREEN_UP*0.37223775438826195 + jac_affine_inv_2_2_GREEN_UP*0.0069232355736274674)*(jac_affine_inv_0_2_GREEN_UP*0.44773255210137269 + jac_affine_inv_1_2_GREEN_UP*0.44773255210137269 + jac_affine_inv_2_2_GREEN_UP*0.81304707091600714)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.44773255210137269 + jac_affine_inv_1_0_GREEN_UP*0.44773255210137269 + jac_affine_inv_2_0_GREEN_UP*0.81304707091600714)*(jac_affine_inv_0_0_GREEN_UP*0.54534421232499986 + jac_affine_inv_1_0_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_0_GREEN_UP*0.18002969351036541) + (jac_affine_inv_0_1_GREEN_UP*0.44773255210137269 + jac_affine_inv_1_1_GREEN_UP*0.44773255210137269 + jac_affine_inv_2_1_GREEN_UP*0.81304707091600714)*(jac_affine_inv_0_1_GREEN_UP*0.54534421232499986 + jac_affine_inv_1_1_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_1_GREEN_UP*0.18002969351036541) + (jac_affine_inv_0_2_GREEN_UP*0.44773255210137269 + jac_affine_inv_1_2_GREEN_UP*0.44773255210137269 + jac_affine_inv_2_2_GREEN_UP*0.81304707091600714)*(jac_affine_inv_0_2_GREEN_UP*0.54534421232499986 + jac_affine_inv_1_2_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_2_GREEN_UP*0.18002969351036541)), abs_det_jac_affine_GREEN_UP*(((jac_affine_inv_0_0_GREEN_UP*0.01859896126067373 + jac_affine_inv_1_0_GREEN_UP + jac_affine_inv_2_0_GREEN_UP*0.01859896126067373)*(jac_affine_inv_0_0_GREEN_UP*0.01859896126067373 + jac_affine_inv_1_0_GREEN_UP + jac_affine_inv_2_0_GREEN_UP*0.01859896126067373))*0.13856094579201603 + ((jac_affine_inv_0_1_GREEN_UP*0.01859896126067373 + jac_affine_inv_1_1_GREEN_UP + jac_affine_inv_2_1_GREEN_UP*0.01859896126067373)*(jac_affine_inv_0_1_GREEN_UP*0.01859896126067373 + jac_affine_inv_1_1_GREEN_UP + jac_affine_inv_2_1_GREEN_UP*0.01859896126067373))*0.13856094579201603 + ((jac_affine_inv_0_2_GREEN_UP*0.01859896126067373 + jac_affine_inv_1_2_GREEN_UP + jac_affine_inv_2_2_GREEN_UP*0.01859896126067373)*(jac_affine_inv_0_2_GREEN_UP*0.01859896126067373 + jac_affine_inv_1_2_GREEN_UP + jac_affine_inv_2_2_GREEN_UP*0.01859896126067373))*0.13856094579201603), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.0069232355736274674 + jac_affine_inv_1_0_GREEN_UP*0.37223775438826195 + jac_affine_inv_2_0_GREEN_UP*0.0069232355736274674)*(jac_affine_inv_0_0_GREEN_UP*0.54534421232499986 + jac_affine_inv_1_0_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_0_GREEN_UP*0.18002969351036541) + (jac_affine_inv_0_1_GREEN_UP*0.0069232355736274674 + jac_affine_inv_1_1_GREEN_UP*0.37223775438826195 + jac_affine_inv_2_1_GREEN_UP*0.0069232355736274674)*(jac_affine_inv_0_1_GREEN_UP*0.54534421232499986 + jac_affine_inv_1_1_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_1_GREEN_UP*0.18002969351036541) + (jac_affine_inv_0_2_GREEN_UP*0.0069232355736274674 + jac_affine_inv_1_2_GREEN_UP*0.37223775438826195 + jac_affine_inv_2_2_GREEN_UP*0.0069232355736274674)*(jac_affine_inv_0_2_GREEN_UP*0.54534421232499986 + jac_affine_inv_1_2_GREEN_UP*0.18002969351036541 + jac_affine_inv_2_2_GREEN_UP*0.18002969351036541)), abs_det_jac_affine_GREEN_UP*(((jac_affine_inv_0_0_GREEN_UP + jac_affine_inv_1_0_GREEN_UP*0.33012121416459822 + jac_affine_inv_2_0_GREEN_UP*0.33012121416459822)*(jac_affine_inv_0_0_GREEN_UP + jac_affine_inv_1_0_GREEN_UP*0.33012121416459822 + jac_affine_inv_2_0_GREEN_UP*0.33012121416459822))*0.29740030991637451 + ((jac_affine_inv_0_1_GREEN_UP + jac_affine_inv_1_1_GREEN_UP*0.33012121416459822 + jac_affine_inv_2_1_GREEN_UP*0.33012121416459822)*(jac_affine_inv_0_1_GREEN_UP + jac_affine_inv_1_1_GREEN_UP*0.33012121416459822 + jac_affine_inv_2_1_GREEN_UP*0.33012121416459822))*0.29740030991637451 + ((jac_affine_inv_0_2_GREEN_UP + jac_affine_inv_1_2_GREEN_UP*0.33012121416459822 + jac_affine_inv_2_2_GREEN_UP*0.33012121416459822)*(jac_affine_inv_0_2_GREEN_UP + jac_affine_inv_1_2_GREEN_UP*0.33012121416459822 + jac_affine_inv_2_2_GREEN_UP*0.33012121416459822))*0.29740030991637451), abs_det_jac_affine_GREEN_UP*(((jac_affine_inv_1_0_GREEN_UP*-0.81923601162978588 + jac_affine_inv_2_0_GREEN_UP)*(jac_affine_inv_1_0_GREEN_UP*-0.81923601162978588 + jac_affine_inv_2_0_GREEN_UP))*0.18550396047976214 + ((jac_affine_inv_1_1_GREEN_UP*-0.81923601162978588 + jac_affine_inv_2_1_GREEN_UP)*(jac_affine_inv_1_1_GREEN_UP*-0.81923601162978588 + jac_affine_inv_2_1_GREEN_UP))*0.18550396047976214 + ((jac_affine_inv_1_2_GREEN_UP*-0.81923601162978588 + jac_affine_inv_2_2_GREEN_UP)*(jac_affine_inv_1_2_GREEN_UP*-0.81923601162978588 + jac_affine_inv_2_2_GREEN_UP))*0.18550396047976214), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_0_GREEN_UP*0.21607642918484779)*(jac_affine_inv_1_0_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_0_GREEN_UP*0.43070170707783612) + (jac_affine_inv_0_1_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_1_GREEN_UP*0.21607642918484779)*(jac_affine_inv_1_1_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_1_GREEN_UP*0.43070170707783612) + (jac_affine_inv_0_2_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_2_GREEN_UP*0.21607642918484779)*(jac_affine_inv_1_2_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_2_GREEN_UP*0.43070170707783612)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.43070170707783612 + jac_affine_inv_1_0_GREEN_UP*0.21607642918484779)*(jac_affine_inv_1_0_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_0_GREEN_UP*0.43070170707783612) + (jac_affine_inv_0_1_GREEN_UP*-0.43070170707783612 + jac_affine_inv_1_1_GREEN_UP*0.21607642918484779)*(jac_affine_inv_1_1_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_1_GREEN_UP*0.43070170707783612) + (jac_affine_inv_0_2_GREEN_UP*-0.43070170707783612 + jac_affine_inv_1_2_GREEN_UP*0.21607642918484779)*(jac_affine_inv_1_2_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_2_GREEN_UP*0.43070170707783612)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_0_GREEN_UP*0.43070170707783612)*(jac_affine_inv_0_0_GREEN_UP*0.35284634870858678 + jac_affine_inv_1_0_GREEN_UP*0.35284634870858678 + jac_affine_inv_2_0_GREEN_UP*0.35322186373731607) + (jac_affine_inv_1_1_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_1_GREEN_UP*0.43070170707783612)*(jac_affine_inv_0_1_GREEN_UP*0.35284634870858678 + jac_affine_inv_1_1_GREEN_UP*0.35284634870858678 + jac_affine_inv_2_1_GREEN_UP*0.35322186373731607) + (jac_affine_inv_1_2_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_2_GREEN_UP*0.43070170707783612)*(jac_affine_inv_0_2_GREEN_UP*0.35284634870858678 + jac_affine_inv_1_2_GREEN_UP*0.35284634870858678 + jac_affine_inv_2_2_GREEN_UP*0.35322186373731607)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_0_GREEN_UP*0.43070170707783612)*(jac_affine_inv_0_0_GREEN_UP*0.43070170707783612 + jac_affine_inv_1_0_GREEN_UP*0.43107722210656541 + jac_affine_inv_2_0_GREEN_UP*0.43070170707783612) + (jac_affine_inv_1_1_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_1_GREEN_UP*0.43070170707783612)*(jac_affine_inv_0_1_GREEN_UP*0.43070170707783612 + jac_affine_inv_1_1_GREEN_UP*0.43107722210656541 + jac_affine_inv_2_1_GREEN_UP*0.43070170707783612) + (jac_affine_inv_1_2_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_2_GREEN_UP*0.43070170707783612)*(jac_affine_inv_0_2_GREEN_UP*0.43070170707783612 + jac_affine_inv_1_2_GREEN_UP*0.43107722210656541 + jac_affine_inv_2_2_GREEN_UP*0.43070170707783612)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_1_0_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_0_GREEN_UP*0.43070170707783612)*(jac_affine_inv_0_0_GREEN_UP*0.21645194421357716 + jac_affine_inv_1_0_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_0_GREEN_UP*0.21607642918484779) + (jac_affine_inv_1_1_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_1_GREEN_UP*0.43070170707783612)*(jac_affine_inv_0_1_GREEN_UP*0.21645194421357716 + jac_affine_inv_1_1_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_1_GREEN_UP*0.21607642918484779) + (jac_affine_inv_1_2_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_2_GREEN_UP*0.43070170707783612)*(jac_affine_inv_0_2_GREEN_UP*0.21645194421357716 + jac_affine_inv_1_2_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_2_GREEN_UP*0.21607642918484779)), abs_det_jac_affine_GREEN_UP*(((-jac_affine_inv_0_0_GREEN_UP + jac_affine_inv_2_0_GREEN_UP*0.61238108308527162)*(-jac_affine_inv_0_0_GREEN_UP + jac_affine_inv_2_0_GREEN_UP*0.61238108308527162))*0.12450054579698162 + ((-jac_affine_inv_0_1_GREEN_UP + jac_affine_inv_2_1_GREEN_UP*0.61238108308527162)*(-jac_affine_inv_0_1_GREEN_UP + jac_affine_inv_2_1_GREEN_UP*0.61238108308527162))*0.12450054579698162 + ((-jac_affine_inv_0_2_GREEN_UP + jac_affine_inv_2_2_GREEN_UP*0.61238108308527162)*(-jac_affine_inv_0_2_GREEN_UP + jac_affine_inv_2_2_GREEN_UP*0.61238108308527162))*0.12450054579698162), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_0_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_0_GREEN_UP*-0.43070170707783612 + jac_affine_inv_1_0_GREEN_UP*0.21607642918484779) + (jac_affine_inv_0_1_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_1_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_1_GREEN_UP*-0.43070170707783612 + jac_affine_inv_1_1_GREEN_UP*0.21607642918484779) + (jac_affine_inv_0_2_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_2_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_2_GREEN_UP*-0.43070170707783612 + jac_affine_inv_1_2_GREEN_UP*0.21607642918484779)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_0_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_0_GREEN_UP*0.35284634870858678 + jac_affine_inv_1_0_GREEN_UP*0.35284634870858678 + jac_affine_inv_2_0_GREEN_UP*0.35322186373731607) + (jac_affine_inv_0_1_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_1_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_1_GREEN_UP*0.35284634870858678 + jac_affine_inv_1_1_GREEN_UP*0.35284634870858678 + jac_affine_inv_2_1_GREEN_UP*0.35322186373731607) + (jac_affine_inv_0_2_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_2_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_2_GREEN_UP*0.35284634870858678 + jac_affine_inv_1_2_GREEN_UP*0.35284634870858678 + jac_affine_inv_2_2_GREEN_UP*0.35322186373731607)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_0_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_0_GREEN_UP*0.43070170707783612 + jac_affine_inv_1_0_GREEN_UP*0.43107722210656541 + jac_affine_inv_2_0_GREEN_UP*0.43070170707783612) + (jac_affine_inv_0_1_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_1_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_1_GREEN_UP*0.43070170707783612 + jac_affine_inv_1_1_GREEN_UP*0.43107722210656541 + jac_affine_inv_2_1_GREEN_UP*0.43070170707783612) + (jac_affine_inv_0_2_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_2_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_2_GREEN_UP*0.43070170707783612 + jac_affine_inv_1_2_GREEN_UP*0.43107722210656541 + jac_affine_inv_2_2_GREEN_UP*0.43070170707783612)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_0_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_0_GREEN_UP*0.21645194421357716 + jac_affine_inv_1_0_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_0_GREEN_UP*0.21607642918484779) + (jac_affine_inv_0_1_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_1_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_1_GREEN_UP*0.21645194421357716 + jac_affine_inv_1_1_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_1_GREEN_UP*0.21607642918484779) + (jac_affine_inv_0_2_GREEN_UP*-0.35284634870858678 + jac_affine_inv_2_2_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_2_GREEN_UP*0.21645194421357716 + jac_affine_inv_1_2_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_2_GREEN_UP*0.21607642918484779)), abs_det_jac_affine_GREEN_UP*(((-jac_affine_inv_0_0_GREEN_UP + jac_affine_inv_1_0_GREEN_UP*0.50168463610430647)*(-jac_affine_inv_0_0_GREEN_UP + jac_affine_inv_1_0_GREEN_UP*0.50168463610430647))*0.18550396047976214 + ((-jac_affine_inv_0_1_GREEN_UP + jac_affine_inv_1_1_GREEN_UP*0.50168463610430647)*(-jac_affine_inv_0_1_GREEN_UP + jac_affine_inv_1_1_GREEN_UP*0.50168463610430647))*0.18550396047976214 + ((-jac_affine_inv_0_2_GREEN_UP + jac_affine_inv_1_2_GREEN_UP*0.50168463610430647)*(-jac_affine_inv_0_2_GREEN_UP + jac_affine_inv_1_2_GREEN_UP*0.50168463610430647))*0.18550396047976214), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.43070170707783612 + jac_affine_inv_1_0_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_0_GREEN_UP*0.35284634870858678 + jac_affine_inv_1_0_GREEN_UP*0.35284634870858678 + jac_affine_inv_2_0_GREEN_UP*0.35322186373731607) + (jac_affine_inv_0_1_GREEN_UP*-0.43070170707783612 + jac_affine_inv_1_1_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_1_GREEN_UP*0.35284634870858678 + jac_affine_inv_1_1_GREEN_UP*0.35284634870858678 + jac_affine_inv_2_1_GREEN_UP*0.35322186373731607) + (jac_affine_inv_0_2_GREEN_UP*-0.43070170707783612 + jac_affine_inv_1_2_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_2_GREEN_UP*0.35284634870858678 + jac_affine_inv_1_2_GREEN_UP*0.35284634870858678 + jac_affine_inv_2_2_GREEN_UP*0.35322186373731607)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.43070170707783612 + jac_affine_inv_1_0_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_0_GREEN_UP*0.43070170707783612 + jac_affine_inv_1_0_GREEN_UP*0.43107722210656541 + jac_affine_inv_2_0_GREEN_UP*0.43070170707783612) + (jac_affine_inv_0_1_GREEN_UP*-0.43070170707783612 + jac_affine_inv_1_1_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_1_GREEN_UP*0.43070170707783612 + jac_affine_inv_1_1_GREEN_UP*0.43107722210656541 + jac_affine_inv_2_1_GREEN_UP*0.43070170707783612) + (jac_affine_inv_0_2_GREEN_UP*-0.43070170707783612 + jac_affine_inv_1_2_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_2_GREEN_UP*0.43070170707783612 + jac_affine_inv_1_2_GREEN_UP*0.43107722210656541 + jac_affine_inv_2_2_GREEN_UP*0.43070170707783612)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*-0.43070170707783612 + jac_affine_inv_1_0_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_0_GREEN_UP*0.21645194421357716 + jac_affine_inv_1_0_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_0_GREEN_UP*0.21607642918484779) + (jac_affine_inv_0_1_GREEN_UP*-0.43070170707783612 + jac_affine_inv_1_1_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_1_GREEN_UP*0.21645194421357716 + jac_affine_inv_1_1_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_1_GREEN_UP*0.21607642918484779) + (jac_affine_inv_0_2_GREEN_UP*-0.43070170707783612 + jac_affine_inv_1_2_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_2_GREEN_UP*0.21645194421357716 + jac_affine_inv_1_2_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_2_GREEN_UP*0.21607642918484779)), abs_det_jac_affine_GREEN_UP*(((jac_affine_inv_0_0_GREEN_UP*0.99893688622568233 + jac_affine_inv_1_0_GREEN_UP*0.99893688622568233 + jac_affine_inv_2_0_GREEN_UP)*(jac_affine_inv_0_0_GREEN_UP*0.99893688622568233 + jac_affine_inv_1_0_GREEN_UP*0.99893688622568233 + jac_affine_inv_2_0_GREEN_UP))*0.12476568502206307 + ((jac_affine_inv_0_1_GREEN_UP*0.99893688622568233 + jac_affine_inv_1_1_GREEN_UP*0.99893688622568233 + jac_affine_inv_2_1_GREEN_UP)*(jac_affine_inv_0_1_GREEN_UP*0.99893688622568233 + jac_affine_inv_1_1_GREEN_UP*0.99893688622568233 + jac_affine_inv_2_1_GREEN_UP))*0.12476568502206307 + ((jac_affine_inv_0_2_GREEN_UP*0.99893688622568233 + jac_affine_inv_1_2_GREEN_UP*0.99893688622568233 + jac_affine_inv_2_2_GREEN_UP)*(jac_affine_inv_0_2_GREEN_UP*0.99893688622568233 + jac_affine_inv_1_2_GREEN_UP*0.99893688622568233 + jac_affine_inv_2_2_GREEN_UP))*0.12476568502206307), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.35284634870858678 + jac_affine_inv_1_0_GREEN_UP*0.35284634870858678 + jac_affine_inv_2_0_GREEN_UP*0.35322186373731607)*(jac_affine_inv_0_0_GREEN_UP*0.43070170707783612 + jac_affine_inv_1_0_GREEN_UP*0.43107722210656541 + jac_affine_inv_2_0_GREEN_UP*0.43070170707783612) + (jac_affine_inv_0_1_GREEN_UP*0.35284634870858678 + jac_affine_inv_1_1_GREEN_UP*0.35284634870858678 + jac_affine_inv_2_1_GREEN_UP*0.35322186373731607)*(jac_affine_inv_0_1_GREEN_UP*0.43070170707783612 + jac_affine_inv_1_1_GREEN_UP*0.43107722210656541 + jac_affine_inv_2_1_GREEN_UP*0.43070170707783612) + (jac_affine_inv_0_2_GREEN_UP*0.35284634870858678 + jac_affine_inv_1_2_GREEN_UP*0.35284634870858678 + jac_affine_inv_2_2_GREEN_UP*0.35322186373731607)*(jac_affine_inv_0_2_GREEN_UP*0.43070170707783612 + jac_affine_inv_1_2_GREEN_UP*0.43107722210656541 + jac_affine_inv_2_2_GREEN_UP*0.43070170707783612)), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.21645194421357716 + jac_affine_inv_1_0_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_0_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_0_GREEN_UP*0.35284634870858678 + jac_affine_inv_1_0_GREEN_UP*0.35284634870858678 + jac_affine_inv_2_0_GREEN_UP*0.35322186373731607) + (jac_affine_inv_0_1_GREEN_UP*0.21645194421357716 + jac_affine_inv_1_1_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_1_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_1_GREEN_UP*0.35284634870858678 + jac_affine_inv_1_1_GREEN_UP*0.35284634870858678 + jac_affine_inv_2_1_GREEN_UP*0.35322186373731607) + (jac_affine_inv_0_2_GREEN_UP*0.21645194421357716 + jac_affine_inv_1_2_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_2_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_2_GREEN_UP*0.35284634870858678 + jac_affine_inv_1_2_GREEN_UP*0.35284634870858678 + jac_affine_inv_2_2_GREEN_UP*0.35322186373731607)), abs_det_jac_affine_GREEN_UP*(((jac_affine_inv_0_0_GREEN_UP*0.99912889150836071 + jac_affine_inv_1_0_GREEN_UP + jac_affine_inv_2_0_GREEN_UP*0.99912889150836071)*(jac_affine_inv_0_0_GREEN_UP*0.99912889150836071 + jac_affine_inv_1_0_GREEN_UP + jac_affine_inv_2_0_GREEN_UP*0.99912889150836071))*0.18582757141911313 + ((jac_affine_inv_0_1_GREEN_UP*0.99912889150836071 + jac_affine_inv_1_1_GREEN_UP + jac_affine_inv_2_1_GREEN_UP*0.99912889150836071)*(jac_affine_inv_0_1_GREEN_UP*0.99912889150836071 + jac_affine_inv_1_1_GREEN_UP + jac_affine_inv_2_1_GREEN_UP*0.99912889150836071))*0.18582757141911313 + ((jac_affine_inv_0_2_GREEN_UP*0.99912889150836071 + jac_affine_inv_1_2_GREEN_UP + jac_affine_inv_2_2_GREEN_UP*0.99912889150836071)*(jac_affine_inv_0_2_GREEN_UP*0.99912889150836071 + jac_affine_inv_1_2_GREEN_UP + jac_affine_inv_2_2_GREEN_UP*0.99912889150836071))*0.18582757141911313), abs_det_jac_affine_GREEN_UP*((jac_affine_inv_0_0_GREEN_UP*0.21645194421357716 + jac_affine_inv_1_0_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_0_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_0_GREEN_UP*0.43070170707783612 + jac_affine_inv_1_0_GREEN_UP*0.43107722210656541 + jac_affine_inv_2_0_GREEN_UP*0.43070170707783612) + (jac_affine_inv_0_1_GREEN_UP*0.21645194421357716 + jac_affine_inv_1_1_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_1_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_1_GREEN_UP*0.43070170707783612 + jac_affine_inv_1_1_GREEN_UP*0.43107722210656541 + jac_affine_inv_2_1_GREEN_UP*0.43070170707783612) + (jac_affine_inv_0_2_GREEN_UP*0.21645194421357716 + jac_affine_inv_1_2_GREEN_UP*0.21607642918484779 + jac_affine_inv_2_2_GREEN_UP*0.21607642918484779)*(jac_affine_inv_0_2_GREEN_UP*0.43070170707783612 + jac_affine_inv_1_2_GREEN_UP*0.43107722210656541 + jac_affine_inv_2_2_GREEN_UP*0.43070170707783612)), abs_det_jac_affine_GREEN_UP*(((jac_affine_inv_0_0_GREEN_UP + jac_affine_inv_1_0_GREEN_UP*0.99826513441543008 + jac_affine_inv_2_0_GREEN_UP*0.99826513441543008)*(jac_affine_inv_0_0_GREEN_UP + jac_affine_inv_1_0_GREEN_UP*0.99826513441543008 + jac_affine_inv_2_0_GREEN_UP*0.99826513441543008))*0.046851444153837518 + ((jac_affine_inv_0_1_GREEN_UP + jac_affine_inv_1_1_GREEN_UP*0.99826513441543008 + jac_affine_inv_2_1_GREEN_UP*0.99826513441543008)*(jac_affine_inv_0_1_GREEN_UP + jac_affine_inv_1_1_GREEN_UP*0.99826513441543008 + jac_affine_inv_2_1_GREEN_UP*0.99826513441543008))*0.046851444153837518 + ((jac_affine_inv_0_2_GREEN_UP + jac_affine_inv_1_2_GREEN_UP*0.99826513441543008 + jac_affine_inv_2_2_GREEN_UP*0.99826513441543008)*(jac_affine_inv_0_2_GREEN_UP + jac_affine_inv_1_2_GREEN_UP*0.99826513441543008 + jac_affine_inv_2_2_GREEN_UP*0.99826513441543008))*0.046851444153837518)};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
             const walberla::float64 alpha_dof_0 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 alpha_dof_1 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 alpha_dof_2 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 alpha_dof_3 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 beta_dof_0 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 beta_dof_1 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 beta_dof_2 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 beta_dof_3 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             walberla::float64 q_acc_0_0 = 0.0;
             walberla::float64 q_acc_0_1 = 0.0;
             walberla::float64 q_acc_0_2 = 0.0;
             walberla::float64 q_acc_0_3 = 0.0;
             walberla::float64 q_acc_0_4 = 0.0;
             walberla::float64 q_acc_0_5 = 0.0;
             walberla::float64 q_acc_1_1 = 0.0;
             walberla::float64 q_acc_1_2 = 0.0;
             walberla::float64 q_acc_1_3 = 0.0;
             walberla::float64 q_acc_1_4 = 0.0;
             walberla::float64 q_acc_1_5 = 0.0;
             walberla::float64 q_acc_2_2 = 0.0;
             walberla::float64 q_acc_2_3 = 0.0;
             walberla::float64 q_acc_2_4 = 0.0;
             walberla::float64 q_acc_2_5 = 0.0;
             walberla::float64 q_acc_3_3 = 0.0;
             walberla::float64 q_acc_3_4 = 0.0;
             walberla::float64 q_acc_3_5 = 0.0;
             walberla::float64 q_acc_4_4 = 0.0;
             walberla::float64 q_acc_4_5 = 0.0;
             walberla::float64 q_acc_5_5 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const walberla::float64 tmp_qloop_0 = alpha_dof_0*_data_phi_0_0_GREEN_UP[4*q] + alpha_dof_1*_data_phi_0_0_GREEN_UP[4*q + 1] + alpha_dof_2*_data_phi_0_0_GREEN_UP[4*q + 2] + alpha_dof_3*_data_phi_0_0_GREEN_UP[4*q + 3];
                const walberla::float64 tmp_qloop_1 = beta_dof_0*_data_phi_0_0_GREEN_UP[4*q] + beta_dof_1*_data_phi_0_0_GREEN_UP[4*q + 1] + beta_dof_2*_data_phi_0_0_GREEN_UP[4*q + 2] + beta_dof_3*_data_phi_0_0_GREEN_UP[4*q + 3];
                const walberla::float64 q_tmp_0_0 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_UP[21*q] + tmp_qloop_1*_data_mass_det_0_0_GREEN_UP[21*q])*_data_q_w[q];
                const walberla::float64 q_tmp_0_1 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_UP[21*q + 1] + tmp_qloop_1*_data_mass_det_0_0_GREEN_UP[21*q + 1])*_data_q_w[q];
                const walberla::float64 q_tmp_0_2 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_UP[21*q + 2] + tmp_qloop_1*_data_mass_det_0_0_GREEN_UP[21*q + 2])*_data_q_w[q];
                const walberla::float64 q_tmp_0_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_UP[21*q + 3] + tmp_qloop_1*_data_mass_det_0_0_GREEN_UP[21*q + 3])*_data_q_w[q];
                const walberla::float64 q_tmp_0_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_UP[21*q + 4] + tmp_qloop_1*_data_mass_det_0_0_GREEN_UP[21*q + 4])*_data_q_w[q];
                const walberla::float64 q_tmp_0_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_UP[21*q + 5] + tmp_qloop_1*_data_mass_det_0_0_GREEN_UP[21*q + 5])*_data_q_w[q];
                const walberla::float64 q_tmp_1_1 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_UP[21*q + 6] + tmp_qloop_1*_data_mass_det_0_0_GREEN_UP[21*q + 6])*_data_q_w[q];
                const walberla::float64 q_tmp_1_2 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_UP[21*q + 7] + tmp_qloop_1*_data_mass_det_0_0_GREEN_UP[21*q + 7])*_data_q_w[q];
                const walberla::float64 q_tmp_1_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_UP[21*q + 8] + tmp_qloop_1*_data_mass_det_0_0_GREEN_UP[21*q + 8])*_data_q_w[q];
                const walberla::float64 q_tmp_1_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_UP[21*q + 9] + tmp_qloop_1*_data_mass_det_0_0_GREEN_UP[21*q + 9])*_data_q_w[q];
                const walberla::float64 q_tmp_1_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_UP[21*q + 10] + tmp_qloop_1*_data_mass_det_0_0_GREEN_UP[21*q + 10])*_data_q_w[q];
                const walberla::float64 q_tmp_2_2 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_UP[21*q + 11] + tmp_qloop_1*_data_mass_det_0_0_GREEN_UP[21*q + 11])*_data_q_w[q];
                const walberla::float64 q_tmp_2_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_UP[21*q + 12] + tmp_qloop_1*_data_mass_det_0_0_GREEN_UP[21*q + 12])*_data_q_w[q];
                const walberla::float64 q_tmp_2_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_UP[21*q + 13] + tmp_qloop_1*_data_mass_det_0_0_GREEN_UP[21*q + 13])*_data_q_w[q];
                const walberla::float64 q_tmp_2_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_UP[21*q + 14] + tmp_qloop_1*_data_mass_det_0_0_GREEN_UP[21*q + 14])*_data_q_w[q];
                const walberla::float64 q_tmp_3_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_UP[21*q + 15] + tmp_qloop_1*_data_mass_det_0_0_GREEN_UP[21*q + 15])*_data_q_w[q];
                const walberla::float64 q_tmp_3_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_UP[21*q + 16] + tmp_qloop_1*_data_mass_det_0_0_GREEN_UP[21*q + 16])*_data_q_w[q];
                const walberla::float64 q_tmp_3_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_UP[21*q + 17] + tmp_qloop_1*_data_mass_det_0_0_GREEN_UP[21*q + 17])*_data_q_w[q];
                const walberla::float64 q_tmp_4_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_UP[21*q + 18] + tmp_qloop_1*_data_mass_det_0_0_GREEN_UP[21*q + 18])*_data_q_w[q];
                const walberla::float64 q_tmp_4_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_UP[21*q + 19] + tmp_qloop_1*_data_mass_det_0_0_GREEN_UP[21*q + 19])*_data_q_w[q];
                const walberla::float64 q_tmp_5_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_UP[21*q + 20] + tmp_qloop_1*_data_mass_det_0_0_GREEN_UP[21*q + 20])*_data_q_w[q];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
             }
             const walberla::float64 elMat_0_0 = q_acc_0_0;
             const walberla::float64 elMat_0_1 = q_acc_0_1;
             const walberla::float64 elMat_0_2 = q_acc_0_2;
             const walberla::float64 elMat_0_3 = q_acc_0_3;
             const walberla::float64 elMat_0_4 = q_acc_0_4;
             const walberla::float64 elMat_0_5 = q_acc_0_5;
             const walberla::float64 elMat_1_0 = q_acc_0_1;
             const walberla::float64 elMat_1_1 = q_acc_1_1;
             const walberla::float64 elMat_1_2 = q_acc_1_2;
             const walberla::float64 elMat_1_3 = q_acc_1_3;
             const walberla::float64 elMat_1_4 = q_acc_1_4;
             const walberla::float64 elMat_1_5 = q_acc_1_5;
             const walberla::float64 elMat_2_0 = q_acc_0_2;
             const walberla::float64 elMat_2_1 = q_acc_1_2;
             const walberla::float64 elMat_2_2 = q_acc_2_2;
             const walberla::float64 elMat_2_3 = q_acc_2_3;
             const walberla::float64 elMat_2_4 = q_acc_2_4;
             const walberla::float64 elMat_2_5 = q_acc_2_5;
             const walberla::float64 elMat_3_0 = q_acc_0_3;
             const walberla::float64 elMat_3_1 = q_acc_1_3;
             const walberla::float64 elMat_3_2 = q_acc_2_3;
             const walberla::float64 elMat_3_3 = q_acc_3_3;
             const walberla::float64 elMat_3_4 = q_acc_3_4;
             const walberla::float64 elMat_3_5 = q_acc_3_5;
             const walberla::float64 elMat_4_0 = q_acc_0_4;
             const walberla::float64 elMat_4_1 = q_acc_1_4;
             const walberla::float64 elMat_4_2 = q_acc_2_4;
             const walberla::float64 elMat_4_3 = q_acc_3_4;
             const walberla::float64 elMat_4_4 = q_acc_4_4;
             const walberla::float64 elMat_4_5 = q_acc_4_5;
             const walberla::float64 elMat_5_0 = q_acc_0_5;
             const walberla::float64 elMat_5_1 = q_acc_1_5;
             const walberla::float64 elMat_5_2 = q_acc_2_5;
             const walberla::float64 elMat_5_3 = q_acc_3_5;
             const walberla::float64 elMat_5_4 = q_acc_4_5;
             const walberla::float64 elMat_5_5 = q_acc_5_5;
         
             std::vector< uint_t > _data_rowIdx( 6 );
             std::vector< uint_t > _data_colIdx( 6 );
             std::vector< walberla::float64 > _data_mat( 36 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[1] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[2] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[3] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[4] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[1] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[2] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[3] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[4] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[5] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
         
             /* Apply basis transformation */
         
             const Eigen::DiagonalMatrix< real_t, 6 > basisTransformation = n1e1::macrocell::basisTransformation( level, cell, {ctr_0, ctr_1, ctr_2}, celldof::CellType::GREEN_UP );
         
             _data_mat[0] = ((walberla::float64)((basisTransformation.diagonal()(0)*basisTransformation.diagonal()(0))*elMat_0_0));
             _data_mat[1] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(1)*elMat_0_1));
             _data_mat[2] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(2)*elMat_0_2));
             _data_mat[3] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(3)*elMat_0_3));
             _data_mat[4] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(4)*elMat_0_4));
             _data_mat[5] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(5)*elMat_0_5));
             _data_mat[6] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(1)*elMat_1_0));
             _data_mat[7] = ((walberla::float64)((basisTransformation.diagonal()(1)*basisTransformation.diagonal()(1))*elMat_1_1));
             _data_mat[8] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(2)*elMat_1_2));
             _data_mat[9] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(3)*elMat_1_3));
             _data_mat[10] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(4)*elMat_1_4));
             _data_mat[11] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(5)*elMat_1_5));
             _data_mat[12] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(2)*elMat_2_0));
             _data_mat[13] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(2)*elMat_2_1));
             _data_mat[14] = ((walberla::float64)((basisTransformation.diagonal()(2)*basisTransformation.diagonal()(2))*elMat_2_2));
             _data_mat[15] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(3)*elMat_2_3));
             _data_mat[16] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(4)*elMat_2_4));
             _data_mat[17] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(5)*elMat_2_5));
             _data_mat[18] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(3)*elMat_3_0));
             _data_mat[19] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(3)*elMat_3_1));
             _data_mat[20] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(3)*elMat_3_2));
             _data_mat[21] = ((walberla::float64)((basisTransformation.diagonal()(3)*basisTransformation.diagonal()(3))*elMat_3_3));
             _data_mat[22] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(4)*elMat_3_4));
             _data_mat[23] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(5)*elMat_3_5));
             _data_mat[24] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(4)*elMat_4_0));
             _data_mat[25] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(4)*elMat_4_1));
             _data_mat[26] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(4)*elMat_4_2));
             _data_mat[27] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(4)*elMat_4_3));
             _data_mat[28] = ((walberla::float64)((basisTransformation.diagonal()(4)*basisTransformation.diagonal()(4))*elMat_4_4));
             _data_mat[29] = ((walberla::float64)(basisTransformation.diagonal()(4)*basisTransformation.diagonal()(5)*elMat_4_5));
             _data_mat[30] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(5)*elMat_5_0));
             _data_mat[31] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(5)*elMat_5_1));
             _data_mat[32] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(5)*elMat_5_2));
             _data_mat[33] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(5)*elMat_5_3));
             _data_mat[34] = ((walberla::float64)(basisTransformation.diagonal()(4)*basisTransformation.diagonal()(5)*elMat_5_4));
             _data_mat[35] = ((walberla::float64)((basisTransformation.diagonal()(5)*basisTransformation.diagonal()(5))*elMat_5_5));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const walberla::float64 tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const walberla::float64 tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const walberla::float64 tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const walberla::float64 tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const walberla::float64 tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const walberla::float64 tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const walberla::float64 tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const walberla::float64 tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const walberla::float64 tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const walberla::float64 tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const walberla::float64 p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const walberla::float64 p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const walberla::float64 p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const walberla::float64 p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const walberla::float64 p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const walberla::float64 p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const walberla::float64 p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const walberla::float64 p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const walberla::float64 p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const walberla::float64 p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const walberla::float64 p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const walberla::float64 p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const walberla::float64 jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const walberla::float64 jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const walberla::float64 jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const walberla::float64 jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const walberla::float64 jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const walberla::float64 tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const walberla::float64 jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const walberla::float64 tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const walberla::float64 jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const walberla::float64 jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const walberla::float64 tmp_coords_jac_11_GREEN_DOWN = jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
       const walberla::float64 jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const walberla::float64 tmp_coords_jac_10_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const walberla::float64 tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const walberla::float64 tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_0_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
       const walberla::float64 tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_0_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_0_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_1_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_1_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_2_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_2_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const walberla::float64 abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       {
          /* CellType.GREEN_DOWN */
          const walberla::float64 _data_phi_0_0_GREEN_DOWN [] = {0.12366680032845842, 0.82157254096761978, 0.039933048641498423, 0.01482761006242336, 0.45746158708559548, 0.15593312049918601, 0.3817653560693467, 0.0048399363458717648, 0.36531451881463445, 0.18002969351036541, 0.0069232355736274674, 0.44773255210137269, 0.00037551502872928966, 0.21607642918484779, 0.43070170707783612, 0.35284634870858678};
      
          const walberla::float64 _data_curl_curl_det_0_0_GREEN_DOWN [] = {1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_0_GREEN_DOWN*jac_affine_0_0_GREEN_DOWN)*4.0 + (jac_affine_1_0_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN)*4.0 + (jac_affine_2_0_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN)*4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_0_GREEN_DOWN*jac_affine_0_1_GREEN_DOWN*-4.0 + jac_affine_1_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN*-4.0 + jac_affine_2_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN*-4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_0_GREEN_DOWN*jac_affine_0_2_GREEN_DOWN*4.0 + jac_affine_1_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN*4.0 + jac_affine_2_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN*4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_0_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*2.0 + jac_affine_1_0_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*2.0 + jac_affine_2_0_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_0_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)*2.0 + jac_affine_1_0_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)*2.0 + jac_affine_2_0_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_0_GREEN_DOWN*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0)*2.0 + jac_affine_1_0_GREEN_DOWN*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0)*2.0 + jac_affine_2_0_GREEN_DOWN*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_1_GREEN_DOWN*jac_affine_0_1_GREEN_DOWN)*4.0 + (jac_affine_1_1_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN)*4.0 + (jac_affine_2_1_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN)*4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_1_GREEN_DOWN*jac_affine_0_2_GREEN_DOWN*-4.0 + jac_affine_1_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN*-4.0 + jac_affine_2_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN*-4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_1_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*-2.0 + jac_affine_1_1_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*-2.0 + jac_affine_2_1_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_1_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)*-2.0 + jac_affine_1_1_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)*-2.0 + jac_affine_2_1_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_1_GREEN_DOWN*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0)*-2.0 + jac_affine_1_1_GREEN_DOWN*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0)*-2.0 + jac_affine_2_1_GREEN_DOWN*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_2_GREEN_DOWN*jac_affine_0_2_GREEN_DOWN)*4.0 + (jac_affine_1_2_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN)*4.0 + (jac_affine_2_2_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN)*4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_2_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*2.0 + jac_affine_1_2_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*2.0 + jac_affine_2_2_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_2_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)*2.0 + jac_affine_1_2_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)*2.0 + jac_affine_2_2_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_2_GREEN_DOWN*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0)*2.0 + jac_affine_1_2_GREEN_DOWN*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0)*2.0 + jac_affine_2_2_GREEN_DOWN*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(((jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*(jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)) + ((jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*(jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)) + ((jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*(jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0))), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*(jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0) + (jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*(jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0) + (jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*(jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0) + (jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0) + (jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(((jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)*(jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)) + ((jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)*(jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)) + ((jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)*(jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0))), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0) + (jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0) + (jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(((jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0)*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0)) + ((jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0)*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0)) + ((jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0))), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_0_GREEN_DOWN*jac_affine_0_0_GREEN_DOWN)*4.0 + (jac_affine_1_0_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN)*4.0 + (jac_affine_2_0_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN)*4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_0_GREEN_DOWN*jac_affine_0_1_GREEN_DOWN*-4.0 + jac_affine_1_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN*-4.0 + jac_affine_2_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN*-4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_0_GREEN_DOWN*jac_affine_0_2_GREEN_DOWN*4.0 + jac_affine_1_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN*4.0 + jac_affine_2_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN*4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_0_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*2.0 + jac_affine_1_0_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*2.0 + jac_affine_2_0_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_0_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)*2.0 + jac_affine_1_0_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)*2.0 + jac_affine_2_0_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_0_GREEN_DOWN*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0)*2.0 + jac_affine_1_0_GREEN_DOWN*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0)*2.0 + jac_affine_2_0_GREEN_DOWN*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_1_GREEN_DOWN*jac_affine_0_1_GREEN_DOWN)*4.0 + (jac_affine_1_1_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN)*4.0 + (jac_affine_2_1_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN)*4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_1_GREEN_DOWN*jac_affine_0_2_GREEN_DOWN*-4.0 + jac_affine_1_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN*-4.0 + jac_affine_2_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN*-4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_1_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*-2.0 + jac_affine_1_1_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*-2.0 + jac_affine_2_1_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_1_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)*-2.0 + jac_affine_1_1_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)*-2.0 + jac_affine_2_1_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_1_GREEN_DOWN*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0)*-2.0 + jac_affine_1_1_GREEN_DOWN*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0)*-2.0 + jac_affine_2_1_GREEN_DOWN*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_2_GREEN_DOWN*jac_affine_0_2_GREEN_DOWN)*4.0 + (jac_affine_1_2_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN)*4.0 + (jac_affine_2_2_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN)*4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_2_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*2.0 + jac_affine_1_2_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*2.0 + jac_affine_2_2_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_2_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)*2.0 + jac_affine_1_2_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)*2.0 + jac_affine_2_2_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_2_GREEN_DOWN*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0)*2.0 + jac_affine_1_2_GREEN_DOWN*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0)*2.0 + jac_affine_2_2_GREEN_DOWN*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(((jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*(jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)) + ((jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*(jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)) + ((jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*(jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0))), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*(jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0) + (jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*(jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0) + (jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*(jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0) + (jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0) + (jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(((jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)*(jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)) + ((jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)*(jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)) + ((jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)*(jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0))), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0) + (jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0) + (jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(((jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0)*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0)) + ((jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0)*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0)) + ((jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0))), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_0_GREEN_DOWN*jac_affine_0_0_GREEN_DOWN)*4.0 + (jac_affine_1_0_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN)*4.0 + (jac_affine_2_0_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN)*4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_0_GREEN_DOWN*jac_affine_0_1_GREEN_DOWN*-4.0 + jac_affine_1_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN*-4.0 + jac_affine_2_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN*-4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_0_GREEN_DOWN*jac_affine_0_2_GREEN_DOWN*4.0 + jac_affine_1_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN*4.0 + jac_affine_2_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN*4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_0_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*2.0 + jac_affine_1_0_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*2.0 + jac_affine_2_0_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_0_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)*2.0 + jac_affine_1_0_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)*2.0 + jac_affine_2_0_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_0_GREEN_DOWN*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0)*2.0 + jac_affine_1_0_GREEN_DOWN*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0)*2.0 + jac_affine_2_0_GREEN_DOWN*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_1_GREEN_DOWN*jac_affine_0_1_GREEN_DOWN)*4.0 + (jac_affine_1_1_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN)*4.0 + (jac_affine_2_1_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN)*4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_1_GREEN_DOWN*jac_affine_0_2_GREEN_DOWN*-4.0 + jac_affine_1_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN*-4.0 + jac_affine_2_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN*-4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_1_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*-2.0 + jac_affine_1_1_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*-2.0 + jac_affine_2_1_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_1_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)*-2.0 + jac_affine_1_1_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)*-2.0 + jac_affine_2_1_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_1_GREEN_DOWN*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0)*-2.0 + jac_affine_1_1_GREEN_DOWN*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0)*-2.0 + jac_affine_2_1_GREEN_DOWN*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_2_GREEN_DOWN*jac_affine_0_2_GREEN_DOWN)*4.0 + (jac_affine_1_2_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN)*4.0 + (jac_affine_2_2_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN)*4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_2_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*2.0 + jac_affine_1_2_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*2.0 + jac_affine_2_2_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_2_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)*2.0 + jac_affine_1_2_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)*2.0 + jac_affine_2_2_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_2_GREEN_DOWN*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0)*2.0 + jac_affine_1_2_GREEN_DOWN*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0)*2.0 + jac_affine_2_2_GREEN_DOWN*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(((jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*(jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)) + ((jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*(jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)) + ((jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*(jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0))), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*(jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0) + (jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*(jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0) + (jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*(jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0) + (jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0) + (jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(((jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)*(jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)) + ((jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)*(jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)) + ((jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)*(jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0))), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0) + (jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0) + (jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(((jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0)*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0)) + ((jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0)*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0)) + ((jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0))), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_0_GREEN_DOWN*jac_affine_0_0_GREEN_DOWN)*4.0 + (jac_affine_1_0_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN)*4.0 + (jac_affine_2_0_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN)*4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_0_GREEN_DOWN*jac_affine_0_1_GREEN_DOWN*-4.0 + jac_affine_1_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN*-4.0 + jac_affine_2_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN*-4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_0_GREEN_DOWN*jac_affine_0_2_GREEN_DOWN*4.0 + jac_affine_1_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN*4.0 + jac_affine_2_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN*4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_0_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*2.0 + jac_affine_1_0_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*2.0 + jac_affine_2_0_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_0_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)*2.0 + jac_affine_1_0_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)*2.0 + jac_affine_2_0_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_0_GREEN_DOWN*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0)*2.0 + jac_affine_1_0_GREEN_DOWN*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0)*2.0 + jac_affine_2_0_GREEN_DOWN*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_1_GREEN_DOWN*jac_affine_0_1_GREEN_DOWN)*4.0 + (jac_affine_1_1_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN)*4.0 + (jac_affine_2_1_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN)*4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_1_GREEN_DOWN*jac_affine_0_2_GREEN_DOWN*-4.0 + jac_affine_1_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN*-4.0 + jac_affine_2_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN*-4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_1_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*-2.0 + jac_affine_1_1_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*-2.0 + jac_affine_2_1_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_1_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)*-2.0 + jac_affine_1_1_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)*-2.0 + jac_affine_2_1_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_1_GREEN_DOWN*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0)*-2.0 + jac_affine_1_1_GREEN_DOWN*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0)*-2.0 + jac_affine_2_1_GREEN_DOWN*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)*-2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_2_GREEN_DOWN*jac_affine_0_2_GREEN_DOWN)*4.0 + (jac_affine_1_2_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN)*4.0 + (jac_affine_2_2_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN)*4.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_2_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*2.0 + jac_affine_1_2_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*2.0 + jac_affine_2_2_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_2_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)*2.0 + jac_affine_1_2_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)*2.0 + jac_affine_2_2_GREEN_DOWN*(jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(jac_affine_0_2_GREEN_DOWN*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0)*2.0 + jac_affine_1_2_GREEN_DOWN*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0)*2.0 + jac_affine_2_2_GREEN_DOWN*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)*2.0), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(((jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*(jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)) + ((jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*(jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)) + ((jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*(jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0))), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*(jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0) + (jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*(jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0) + (jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*(jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_0_GREEN_DOWN*-2.0 + jac_affine_0_1_GREEN_DOWN*2.0)*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0) + (jac_affine_1_0_GREEN_DOWN*-2.0 + jac_affine_1_1_GREEN_DOWN*2.0)*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0) + (jac_affine_2_0_GREEN_DOWN*-2.0 + jac_affine_2_1_GREEN_DOWN*2.0)*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(((jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)*(jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)) + ((jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)*(jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)) + ((jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)*(jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0))), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*((jac_affine_0_0_GREEN_DOWN*2.0 + jac_affine_0_2_GREEN_DOWN*-2.0)*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0) + (jac_affine_1_0_GREEN_DOWN*2.0 + jac_affine_1_2_GREEN_DOWN*-2.0)*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0) + (jac_affine_2_0_GREEN_DOWN*2.0 + jac_affine_2_2_GREEN_DOWN*-2.0)*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)), 1.0 / (abs_det_jac_affine_GREEN_DOWN)*(((jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0)*(jac_affine_0_1_GREEN_DOWN*-2.0 + jac_affine_0_2_GREEN_DOWN*2.0)) + ((jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0)*(jac_affine_1_1_GREEN_DOWN*-2.0 + jac_affine_1_2_GREEN_DOWN*2.0)) + ((jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)*(jac_affine_2_1_GREEN_DOWN*-2.0 + jac_affine_2_2_GREEN_DOWN*2.0)))};
      
          const walberla::float64 _data_mass_det_0_0_GREEN_DOWN [] = {abs_det_jac_affine_GREEN_DOWN*(((jac_affine_inv_1_0_GREEN_DOWN*-0.37131174720816351 + jac_affine_inv_2_0_GREEN_DOWN)*(jac_affine_inv_1_0_GREEN_DOWN*-0.37131174720816351 + jac_affine_inv_2_0_GREEN_DOWN))*0.0015946483738042789 + ((jac_affine_inv_1_1_GREEN_DOWN*-0.37131174720816351 + jac_affine_inv_2_1_GREEN_DOWN)*(jac_affine_inv_1_1_GREEN_DOWN*-0.37131174720816351 + jac_affine_inv_2_1_GREEN_DOWN))*0.0015946483738042789 + ((jac_affine_inv_1_2_GREEN_DOWN*-0.37131174720816351 + jac_affine_inv_2_2_GREEN_DOWN)*(jac_affine_inv_1_2_GREEN_DOWN*-0.37131174720816351 + jac_affine_inv_2_2_GREEN_DOWN))*0.0015946483738042789), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_1_0_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_GREEN_DOWN*0.039933048641498423) + (jac_affine_inv_0_1_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_1_1_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_GREEN_DOWN*0.039933048641498423) + (jac_affine_inv_0_2_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_1_2_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_GREEN_DOWN*0.039933048641498423)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.039933048641498423 + jac_affine_inv_1_0_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_1_0_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_GREEN_DOWN*0.039933048641498423) + (jac_affine_inv_0_1_GREEN_DOWN*-0.039933048641498423 + jac_affine_inv_1_1_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_1_1_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_GREEN_DOWN*0.039933048641498423) + (jac_affine_inv_0_2_GREEN_DOWN*-0.039933048641498423 + jac_affine_inv_1_2_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_1_2_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_GREEN_DOWN*0.039933048641498423)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_GREEN_DOWN*0.039933048641498423)*(jac_affine_inv_0_0_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_1_0_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_2_0_GREEN_DOWN*0.13849441039088178) + (jac_affine_inv_1_1_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_GREEN_DOWN*0.039933048641498423)*(jac_affine_inv_0_1_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_1_1_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_2_1_GREEN_DOWN*0.13849441039088178) + (jac_affine_inv_1_2_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_GREEN_DOWN*0.039933048641498423)*(jac_affine_inv_0_2_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_1_2_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_2_2_GREEN_DOWN*0.13849441039088178)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_GREEN_DOWN*0.039933048641498423)*(jac_affine_inv_0_0_GREEN_DOWN*0.039933048641498423 + jac_affine_inv_1_0_GREEN_DOWN*0.16359984896995686 + jac_affine_inv_2_0_GREEN_DOWN*0.039933048641498423) + (jac_affine_inv_1_1_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_GREEN_DOWN*0.039933048641498423)*(jac_affine_inv_0_1_GREEN_DOWN*0.039933048641498423 + jac_affine_inv_1_1_GREEN_DOWN*0.16359984896995686 + jac_affine_inv_2_1_GREEN_DOWN*0.039933048641498423) + (jac_affine_inv_1_2_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_GREEN_DOWN*0.039933048641498423)*(jac_affine_inv_0_2_GREEN_DOWN*0.039933048641498423 + jac_affine_inv_1_2_GREEN_DOWN*0.16359984896995686 + jac_affine_inv_2_2_GREEN_DOWN*0.039933048641498423)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_GREEN_DOWN*0.039933048641498423)*(jac_affine_inv_0_0_GREEN_DOWN*0.94523934129607823 + jac_affine_inv_1_0_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_0_GREEN_DOWN*0.82157254096761978) + (jac_affine_inv_1_1_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_GREEN_DOWN*0.039933048641498423)*(jac_affine_inv_0_1_GREEN_DOWN*0.94523934129607823 + jac_affine_inv_1_1_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_1_GREEN_DOWN*0.82157254096761978) + (jac_affine_inv_1_2_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_GREEN_DOWN*0.039933048641498423)*(jac_affine_inv_0_2_GREEN_DOWN*0.94523934129607823 + jac_affine_inv_1_2_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_2_GREEN_DOWN*0.82157254096761978)), abs_det_jac_affine_GREEN_DOWN*(((jac_affine_inv_0_0_GREEN_DOWN*-0.018047840358637001 + jac_affine_inv_2_0_GREEN_DOWN)*(jac_affine_inv_0_0_GREEN_DOWN*-0.018047840358637001 + jac_affine_inv_2_0_GREEN_DOWN))*0.67498144007199123 + ((jac_affine_inv_0_1_GREEN_DOWN*-0.018047840358637001 + jac_affine_inv_2_1_GREEN_DOWN)*(jac_affine_inv_0_1_GREEN_DOWN*-0.018047840358637001 + jac_affine_inv_2_1_GREEN_DOWN))*0.67498144007199123 + ((jac_affine_inv_0_2_GREEN_DOWN*-0.018047840358637001 + jac_affine_inv_2_2_GREEN_DOWN)*(jac_affine_inv_0_2_GREEN_DOWN*-0.018047840358637001 + jac_affine_inv_2_2_GREEN_DOWN))*0.67498144007199123), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_GREEN_DOWN*-0.039933048641498423 + jac_affine_inv_1_0_GREEN_DOWN*0.82157254096761978) + (jac_affine_inv_0_1_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_GREEN_DOWN*-0.039933048641498423 + jac_affine_inv_1_1_GREEN_DOWN*0.82157254096761978) + (jac_affine_inv_0_2_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_GREEN_DOWN*-0.039933048641498423 + jac_affine_inv_1_2_GREEN_DOWN*0.82157254096761978)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_1_0_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_2_0_GREEN_DOWN*0.13849441039088178) + (jac_affine_inv_0_1_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_1_1_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_2_1_GREEN_DOWN*0.13849441039088178) + (jac_affine_inv_0_2_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_1_2_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_2_2_GREEN_DOWN*0.13849441039088178)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_GREEN_DOWN*0.039933048641498423 + jac_affine_inv_1_0_GREEN_DOWN*0.16359984896995686 + jac_affine_inv_2_0_GREEN_DOWN*0.039933048641498423) + (jac_affine_inv_0_1_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_GREEN_DOWN*0.039933048641498423 + jac_affine_inv_1_1_GREEN_DOWN*0.16359984896995686 + jac_affine_inv_2_1_GREEN_DOWN*0.039933048641498423) + (jac_affine_inv_0_2_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_GREEN_DOWN*0.039933048641498423 + jac_affine_inv_1_2_GREEN_DOWN*0.16359984896995686 + jac_affine_inv_2_2_GREEN_DOWN*0.039933048641498423)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_0_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_GREEN_DOWN*0.94523934129607823 + jac_affine_inv_1_0_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_0_GREEN_DOWN*0.82157254096761978) + (jac_affine_inv_0_1_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_1_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_GREEN_DOWN*0.94523934129607823 + jac_affine_inv_1_1_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_1_GREEN_DOWN*0.82157254096761978) + (jac_affine_inv_0_2_GREEN_DOWN*-0.01482761006242336 + jac_affine_inv_2_2_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_GREEN_DOWN*0.94523934129607823 + jac_affine_inv_1_2_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_2_GREEN_DOWN*0.82157254096761978)), abs_det_jac_affine_GREEN_DOWN*(((jac_affine_inv_0_0_GREEN_DOWN*-0.048605627196920013 + jac_affine_inv_1_0_GREEN_DOWN)*(jac_affine_inv_0_0_GREEN_DOWN*-0.048605627196920013 + jac_affine_inv_1_0_GREEN_DOWN))*0.67498144007199123 + ((jac_affine_inv_0_1_GREEN_DOWN*-0.048605627196920013 + jac_affine_inv_1_1_GREEN_DOWN)*(jac_affine_inv_0_1_GREEN_DOWN*-0.048605627196920013 + jac_affine_inv_1_1_GREEN_DOWN))*0.67498144007199123 + ((jac_affine_inv_0_2_GREEN_DOWN*-0.048605627196920013 + jac_affine_inv_1_2_GREEN_DOWN)*(jac_affine_inv_0_2_GREEN_DOWN*-0.048605627196920013 + jac_affine_inv_1_2_GREEN_DOWN))*0.67498144007199123), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.039933048641498423 + jac_affine_inv_1_0_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_1_0_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_2_0_GREEN_DOWN*0.13849441039088178) + (jac_affine_inv_0_1_GREEN_DOWN*-0.039933048641498423 + jac_affine_inv_1_1_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_1_1_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_2_1_GREEN_DOWN*0.13849441039088178) + (jac_affine_inv_0_2_GREEN_DOWN*-0.039933048641498423 + jac_affine_inv_1_2_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_1_2_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_2_2_GREEN_DOWN*0.13849441039088178)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.039933048641498423 + jac_affine_inv_1_0_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_GREEN_DOWN*0.039933048641498423 + jac_affine_inv_1_0_GREEN_DOWN*0.16359984896995686 + jac_affine_inv_2_0_GREEN_DOWN*0.039933048641498423) + (jac_affine_inv_0_1_GREEN_DOWN*-0.039933048641498423 + jac_affine_inv_1_1_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_GREEN_DOWN*0.039933048641498423 + jac_affine_inv_1_1_GREEN_DOWN*0.16359984896995686 + jac_affine_inv_2_1_GREEN_DOWN*0.039933048641498423) + (jac_affine_inv_0_2_GREEN_DOWN*-0.039933048641498423 + jac_affine_inv_1_2_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_GREEN_DOWN*0.039933048641498423 + jac_affine_inv_1_2_GREEN_DOWN*0.16359984896995686 + jac_affine_inv_2_2_GREEN_DOWN*0.039933048641498423)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.039933048641498423 + jac_affine_inv_1_0_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_0_GREEN_DOWN*0.94523934129607823 + jac_affine_inv_1_0_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_0_GREEN_DOWN*0.82157254096761978) + (jac_affine_inv_0_1_GREEN_DOWN*-0.039933048641498423 + jac_affine_inv_1_1_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_1_GREEN_DOWN*0.94523934129607823 + jac_affine_inv_1_1_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_1_GREEN_DOWN*0.82157254096761978) + (jac_affine_inv_0_2_GREEN_DOWN*-0.039933048641498423 + jac_affine_inv_1_2_GREEN_DOWN*0.82157254096761978)*(jac_affine_inv_0_2_GREEN_DOWN*0.94523934129607823 + jac_affine_inv_1_2_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_2_GREEN_DOWN*0.82157254096761978)), abs_det_jac_affine_GREEN_DOWN*(((jac_affine_inv_0_0_GREEN_DOWN*0.10706287727117962 + jac_affine_inv_1_0_GREEN_DOWN*0.10706287727117962 + jac_affine_inv_2_0_GREEN_DOWN)*(jac_affine_inv_0_0_GREEN_DOWN*0.10706287727117962 + jac_affine_inv_1_0_GREEN_DOWN*0.10706287727117962 + jac_affine_inv_2_0_GREEN_DOWN))*0.019180701709517984 + ((jac_affine_inv_0_1_GREEN_DOWN*0.10706287727117962 + jac_affine_inv_1_1_GREEN_DOWN*0.10706287727117962 + jac_affine_inv_2_1_GREEN_DOWN)*(jac_affine_inv_0_1_GREEN_DOWN*0.10706287727117962 + jac_affine_inv_1_1_GREEN_DOWN*0.10706287727117962 + jac_affine_inv_2_1_GREEN_DOWN))*0.019180701709517984 + ((jac_affine_inv_0_2_GREEN_DOWN*0.10706287727117962 + jac_affine_inv_1_2_GREEN_DOWN*0.10706287727117962 + jac_affine_inv_2_2_GREEN_DOWN)*(jac_affine_inv_0_2_GREEN_DOWN*0.10706287727117962 + jac_affine_inv_1_2_GREEN_DOWN*0.10706287727117962 + jac_affine_inv_2_2_GREEN_DOWN))*0.019180701709517984), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_1_0_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_2_0_GREEN_DOWN*0.13849441039088178)*(jac_affine_inv_0_0_GREEN_DOWN*0.039933048641498423 + jac_affine_inv_1_0_GREEN_DOWN*0.16359984896995686 + jac_affine_inv_2_0_GREEN_DOWN*0.039933048641498423) + (jac_affine_inv_0_1_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_1_1_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_2_1_GREEN_DOWN*0.13849441039088178)*(jac_affine_inv_0_1_GREEN_DOWN*0.039933048641498423 + jac_affine_inv_1_1_GREEN_DOWN*0.16359984896995686 + jac_affine_inv_2_1_GREEN_DOWN*0.039933048641498423) + (jac_affine_inv_0_2_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_1_2_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_2_2_GREEN_DOWN*0.13849441039088178)*(jac_affine_inv_0_2_GREEN_DOWN*0.039933048641498423 + jac_affine_inv_1_2_GREEN_DOWN*0.16359984896995686 + jac_affine_inv_2_2_GREEN_DOWN*0.039933048641498423)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_1_0_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_2_0_GREEN_DOWN*0.13849441039088178)*(jac_affine_inv_0_0_GREEN_DOWN*0.94523934129607823 + jac_affine_inv_1_0_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_0_GREEN_DOWN*0.82157254096761978) + (jac_affine_inv_0_1_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_1_1_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_2_1_GREEN_DOWN*0.13849441039088178)*(jac_affine_inv_0_1_GREEN_DOWN*0.94523934129607823 + jac_affine_inv_1_1_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_1_GREEN_DOWN*0.82157254096761978) + (jac_affine_inv_0_2_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_1_2_GREEN_DOWN*0.01482761006242336 + jac_affine_inv_2_2_GREEN_DOWN*0.13849441039088178)*(jac_affine_inv_0_2_GREEN_DOWN*0.94523934129607823 + jac_affine_inv_1_2_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_2_GREEN_DOWN*0.82157254096761978)), abs_det_jac_affine_GREEN_DOWN*(((jac_affine_inv_0_0_GREEN_DOWN*0.2440897647089616 + jac_affine_inv_1_0_GREEN_DOWN + jac_affine_inv_2_0_GREEN_DOWN*0.2440897647089616)*(jac_affine_inv_0_0_GREEN_DOWN*0.2440897647089616 + jac_affine_inv_1_0_GREEN_DOWN + jac_affine_inv_2_0_GREEN_DOWN*0.2440897647089616))*0.026764910582992695 + ((jac_affine_inv_0_1_GREEN_DOWN*0.2440897647089616 + jac_affine_inv_1_1_GREEN_DOWN + jac_affine_inv_2_1_GREEN_DOWN*0.2440897647089616)*(jac_affine_inv_0_1_GREEN_DOWN*0.2440897647089616 + jac_affine_inv_1_1_GREEN_DOWN + jac_affine_inv_2_1_GREEN_DOWN*0.2440897647089616))*0.026764910582992695 + ((jac_affine_inv_0_2_GREEN_DOWN*0.2440897647089616 + jac_affine_inv_1_2_GREEN_DOWN + jac_affine_inv_2_2_GREEN_DOWN*0.2440897647089616)*(jac_affine_inv_0_2_GREEN_DOWN*0.2440897647089616 + jac_affine_inv_1_2_GREEN_DOWN + jac_affine_inv_2_2_GREEN_DOWN*0.2440897647089616))*0.026764910582992695), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.039933048641498423 + jac_affine_inv_1_0_GREEN_DOWN*0.16359984896995686 + jac_affine_inv_2_0_GREEN_DOWN*0.039933048641498423)*(jac_affine_inv_0_0_GREEN_DOWN*0.94523934129607823 + jac_affine_inv_1_0_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_0_GREEN_DOWN*0.82157254096761978) + (jac_affine_inv_0_1_GREEN_DOWN*0.039933048641498423 + jac_affine_inv_1_1_GREEN_DOWN*0.16359984896995686 + jac_affine_inv_2_1_GREEN_DOWN*0.039933048641498423)*(jac_affine_inv_0_1_GREEN_DOWN*0.94523934129607823 + jac_affine_inv_1_1_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_1_GREEN_DOWN*0.82157254096761978) + (jac_affine_inv_0_2_GREEN_DOWN*0.039933048641498423 + jac_affine_inv_1_2_GREEN_DOWN*0.16359984896995686 + jac_affine_inv_2_2_GREEN_DOWN*0.039933048641498423)*(jac_affine_inv_0_2_GREEN_DOWN*0.94523934129607823 + jac_affine_inv_1_2_GREEN_DOWN*0.82157254096761978 + jac_affine_inv_2_2_GREEN_DOWN*0.82157254096761978)), abs_det_jac_affine_GREEN_DOWN*(((jac_affine_inv_0_0_GREEN_DOWN + jac_affine_inv_1_0_GREEN_DOWN*0.86916879680558901 + jac_affine_inv_2_0_GREEN_DOWN*0.86916879680558901)*(jac_affine_inv_0_0_GREEN_DOWN + jac_affine_inv_1_0_GREEN_DOWN*0.86916879680558901 + jac_affine_inv_2_0_GREEN_DOWN*0.86916879680558901))*0.89347741233384381 + ((jac_affine_inv_0_1_GREEN_DOWN + jac_affine_inv_1_1_GREEN_DOWN*0.86916879680558901 + jac_affine_inv_2_1_GREEN_DOWN*0.86916879680558901)*(jac_affine_inv_0_1_GREEN_DOWN + jac_affine_inv_1_1_GREEN_DOWN*0.86916879680558901 + jac_affine_inv_2_1_GREEN_DOWN*0.86916879680558901))*0.89347741233384381 + ((jac_affine_inv_0_2_GREEN_DOWN + jac_affine_inv_1_2_GREEN_DOWN*0.86916879680558901 + jac_affine_inv_2_2_GREEN_DOWN*0.86916879680558901)*(jac_affine_inv_0_2_GREEN_DOWN + jac_affine_inv_1_2_GREEN_DOWN*0.86916879680558901 + jac_affine_inv_2_2_GREEN_DOWN*0.86916879680558901))*0.89347741233384381), abs_det_jac_affine_GREEN_DOWN*(((jac_affine_inv_1_0_GREEN_DOWN*-0.012677777773509136 + jac_affine_inv_2_0_GREEN_DOWN)*(jac_affine_inv_1_0_GREEN_DOWN*-0.012677777773509136 + jac_affine_inv_2_0_GREEN_DOWN))*0.14574478709475508 + ((jac_affine_inv_1_1_GREEN_DOWN*-0.012677777773509136 + jac_affine_inv_2_1_GREEN_DOWN)*(jac_affine_inv_1_1_GREEN_DOWN*-0.012677777773509136 + jac_affine_inv_2_1_GREEN_DOWN))*0.14574478709475508 + ((jac_affine_inv_1_2_GREEN_DOWN*-0.012677777773509136 + jac_affine_inv_2_2_GREEN_DOWN)*(jac_affine_inv_1_2_GREEN_DOWN*-0.012677777773509136 + jac_affine_inv_2_2_GREEN_DOWN))*0.14574478709475508), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_1_0_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_GREEN_DOWN*0.3817653560693467) + (jac_affine_inv_0_1_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_1_1_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_GREEN_DOWN*0.3817653560693467) + (jac_affine_inv_0_2_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_1_2_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_GREEN_DOWN*0.3817653560693467)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.3817653560693467 + jac_affine_inv_1_0_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_1_0_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_GREEN_DOWN*0.3817653560693467) + (jac_affine_inv_0_1_GREEN_DOWN*-0.3817653560693467 + jac_affine_inv_1_1_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_1_1_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_GREEN_DOWN*0.3817653560693467) + (jac_affine_inv_0_2_GREEN_DOWN*-0.3817653560693467 + jac_affine_inv_1_2_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_1_2_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_GREEN_DOWN*0.3817653560693467)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_GREEN_DOWN*0.3817653560693467)*(jac_affine_inv_0_0_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_1_0_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_2_0_GREEN_DOWN*0.46230152343146724) + (jac_affine_inv_1_1_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_GREEN_DOWN*0.3817653560693467)*(jac_affine_inv_0_1_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_1_1_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_2_1_GREEN_DOWN*0.46230152343146724) + (jac_affine_inv_1_2_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_GREEN_DOWN*0.3817653560693467)*(jac_affine_inv_0_2_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_1_2_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_2_2_GREEN_DOWN*0.46230152343146724)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_GREEN_DOWN*0.3817653560693467)*(jac_affine_inv_0_0_GREEN_DOWN*0.3817653560693467 + jac_affine_inv_1_0_GREEN_DOWN*0.83922694315494217 + jac_affine_inv_2_0_GREEN_DOWN*0.3817653560693467) + (jac_affine_inv_1_1_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_GREEN_DOWN*0.3817653560693467)*(jac_affine_inv_0_1_GREEN_DOWN*0.3817653560693467 + jac_affine_inv_1_1_GREEN_DOWN*0.83922694315494217 + jac_affine_inv_2_1_GREEN_DOWN*0.3817653560693467) + (jac_affine_inv_1_2_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_GREEN_DOWN*0.3817653560693467)*(jac_affine_inv_0_2_GREEN_DOWN*0.3817653560693467 + jac_affine_inv_1_2_GREEN_DOWN*0.83922694315494217 + jac_affine_inv_2_2_GREEN_DOWN*0.3817653560693467)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_GREEN_DOWN*0.3817653560693467)*(jac_affine_inv_0_0_GREEN_DOWN*0.61339470758478154 + jac_affine_inv_1_0_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_0_GREEN_DOWN*0.15593312049918601) + (jac_affine_inv_1_1_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_GREEN_DOWN*0.3817653560693467)*(jac_affine_inv_0_1_GREEN_DOWN*0.61339470758478154 + jac_affine_inv_1_1_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_1_GREEN_DOWN*0.15593312049918601) + (jac_affine_inv_1_2_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_GREEN_DOWN*0.3817653560693467)*(jac_affine_inv_0_2_GREEN_DOWN*0.61339470758478154 + jac_affine_inv_1_2_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_2_GREEN_DOWN*0.15593312049918601)), abs_det_jac_affine_GREEN_DOWN*(((jac_affine_inv_0_0_GREEN_DOWN*-0.031038539666093771 + jac_affine_inv_2_0_GREEN_DOWN)*(jac_affine_inv_0_0_GREEN_DOWN*-0.031038539666093771 + jac_affine_inv_2_0_GREEN_DOWN))*0.024315138068613663 + ((jac_affine_inv_0_1_GREEN_DOWN*-0.031038539666093771 + jac_affine_inv_2_1_GREEN_DOWN)*(jac_affine_inv_0_1_GREEN_DOWN*-0.031038539666093771 + jac_affine_inv_2_1_GREEN_DOWN))*0.024315138068613663 + ((jac_affine_inv_0_2_GREEN_DOWN*-0.031038539666093771 + jac_affine_inv_2_2_GREEN_DOWN)*(jac_affine_inv_0_2_GREEN_DOWN*-0.031038539666093771 + jac_affine_inv_2_2_GREEN_DOWN))*0.024315138068613663), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_GREEN_DOWN*-0.3817653560693467 + jac_affine_inv_1_0_GREEN_DOWN*0.15593312049918601) + (jac_affine_inv_0_1_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_GREEN_DOWN*-0.3817653560693467 + jac_affine_inv_1_1_GREEN_DOWN*0.15593312049918601) + (jac_affine_inv_0_2_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_GREEN_DOWN*-0.3817653560693467 + jac_affine_inv_1_2_GREEN_DOWN*0.15593312049918601)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_1_0_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_2_0_GREEN_DOWN*0.46230152343146724) + (jac_affine_inv_0_1_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_1_1_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_2_1_GREEN_DOWN*0.46230152343146724) + (jac_affine_inv_0_2_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_1_2_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_2_2_GREEN_DOWN*0.46230152343146724)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_GREEN_DOWN*0.3817653560693467 + jac_affine_inv_1_0_GREEN_DOWN*0.83922694315494217 + jac_affine_inv_2_0_GREEN_DOWN*0.3817653560693467) + (jac_affine_inv_0_1_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_GREEN_DOWN*0.3817653560693467 + jac_affine_inv_1_1_GREEN_DOWN*0.83922694315494217 + jac_affine_inv_2_1_GREEN_DOWN*0.3817653560693467) + (jac_affine_inv_0_2_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_GREEN_DOWN*0.3817653560693467 + jac_affine_inv_1_2_GREEN_DOWN*0.83922694315494217 + jac_affine_inv_2_2_GREEN_DOWN*0.3817653560693467)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_0_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_GREEN_DOWN*0.61339470758478154 + jac_affine_inv_1_0_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_0_GREEN_DOWN*0.15593312049918601) + (jac_affine_inv_0_1_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_1_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_GREEN_DOWN*0.61339470758478154 + jac_affine_inv_1_1_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_1_GREEN_DOWN*0.15593312049918601) + (jac_affine_inv_0_2_GREEN_DOWN*-0.0048399363458717648 + jac_affine_inv_2_2_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_GREEN_DOWN*0.61339470758478154 + jac_affine_inv_1_2_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_2_GREEN_DOWN*0.15593312049918601)), abs_det_jac_affine_GREEN_DOWN*(((-jac_affine_inv_0_0_GREEN_DOWN + jac_affine_inv_1_0_GREEN_DOWN*0.40845277870331731)*(-jac_affine_inv_0_0_GREEN_DOWN + jac_affine_inv_1_0_GREEN_DOWN*0.40845277870331731))*0.14574478709475508 + ((-jac_affine_inv_0_1_GREEN_DOWN + jac_affine_inv_1_1_GREEN_DOWN*0.40845277870331731)*(-jac_affine_inv_0_1_GREEN_DOWN + jac_affine_inv_1_1_GREEN_DOWN*0.40845277870331731))*0.14574478709475508 + ((-jac_affine_inv_0_2_GREEN_DOWN + jac_affine_inv_1_2_GREEN_DOWN*0.40845277870331731)*(-jac_affine_inv_0_2_GREEN_DOWN + jac_affine_inv_1_2_GREEN_DOWN*0.40845277870331731))*0.14574478709475508), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.3817653560693467 + jac_affine_inv_1_0_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_1_0_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_2_0_GREEN_DOWN*0.46230152343146724) + (jac_affine_inv_0_1_GREEN_DOWN*-0.3817653560693467 + jac_affine_inv_1_1_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_1_1_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_2_1_GREEN_DOWN*0.46230152343146724) + (jac_affine_inv_0_2_GREEN_DOWN*-0.3817653560693467 + jac_affine_inv_1_2_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_1_2_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_2_2_GREEN_DOWN*0.46230152343146724)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.3817653560693467 + jac_affine_inv_1_0_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_GREEN_DOWN*0.3817653560693467 + jac_affine_inv_1_0_GREEN_DOWN*0.83922694315494217 + jac_affine_inv_2_0_GREEN_DOWN*0.3817653560693467) + (jac_affine_inv_0_1_GREEN_DOWN*-0.3817653560693467 + jac_affine_inv_1_1_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_GREEN_DOWN*0.3817653560693467 + jac_affine_inv_1_1_GREEN_DOWN*0.83922694315494217 + jac_affine_inv_2_1_GREEN_DOWN*0.3817653560693467) + (jac_affine_inv_0_2_GREEN_DOWN*-0.3817653560693467 + jac_affine_inv_1_2_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_GREEN_DOWN*0.3817653560693467 + jac_affine_inv_1_2_GREEN_DOWN*0.83922694315494217 + jac_affine_inv_2_2_GREEN_DOWN*0.3817653560693467)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.3817653560693467 + jac_affine_inv_1_0_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_0_GREEN_DOWN*0.61339470758478154 + jac_affine_inv_1_0_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_0_GREEN_DOWN*0.15593312049918601) + (jac_affine_inv_0_1_GREEN_DOWN*-0.3817653560693467 + jac_affine_inv_1_1_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_1_GREEN_DOWN*0.61339470758478154 + jac_affine_inv_1_1_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_1_GREEN_DOWN*0.15593312049918601) + (jac_affine_inv_0_2_GREEN_DOWN*-0.3817653560693467 + jac_affine_inv_1_2_GREEN_DOWN*0.15593312049918601)*(jac_affine_inv_0_2_GREEN_DOWN*0.61339470758478154 + jac_affine_inv_1_2_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_2_GREEN_DOWN*0.15593312049918601)), abs_det_jac_affine_GREEN_DOWN*(((jac_affine_inv_0_0_GREEN_DOWN*0.010469219979953731 + jac_affine_inv_1_0_GREEN_DOWN*0.010469219979953731 + jac_affine_inv_2_0_GREEN_DOWN)*(jac_affine_inv_0_0_GREEN_DOWN*0.010469219979953731 + jac_affine_inv_1_0_GREEN_DOWN*0.010469219979953731 + jac_affine_inv_2_0_GREEN_DOWN))*0.21372269856705545 + ((jac_affine_inv_0_1_GREEN_DOWN*0.010469219979953731 + jac_affine_inv_1_1_GREEN_DOWN*0.010469219979953731 + jac_affine_inv_2_1_GREEN_DOWN)*(jac_affine_inv_0_1_GREEN_DOWN*0.010469219979953731 + jac_affine_inv_1_1_GREEN_DOWN*0.010469219979953731 + jac_affine_inv_2_1_GREEN_DOWN))*0.21372269856705545 + ((jac_affine_inv_0_2_GREEN_DOWN*0.010469219979953731 + jac_affine_inv_1_2_GREEN_DOWN*0.010469219979953731 + jac_affine_inv_2_2_GREEN_DOWN)*(jac_affine_inv_0_2_GREEN_DOWN*0.010469219979953731 + jac_affine_inv_1_2_GREEN_DOWN*0.010469219979953731 + jac_affine_inv_2_2_GREEN_DOWN))*0.21372269856705545), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_1_0_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_2_0_GREEN_DOWN*0.46230152343146724)*(jac_affine_inv_0_0_GREEN_DOWN*0.3817653560693467 + jac_affine_inv_1_0_GREEN_DOWN*0.83922694315494217 + jac_affine_inv_2_0_GREEN_DOWN*0.3817653560693467) + (jac_affine_inv_0_1_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_1_1_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_2_1_GREEN_DOWN*0.46230152343146724)*(jac_affine_inv_0_1_GREEN_DOWN*0.3817653560693467 + jac_affine_inv_1_1_GREEN_DOWN*0.83922694315494217 + jac_affine_inv_2_1_GREEN_DOWN*0.3817653560693467) + (jac_affine_inv_0_2_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_1_2_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_2_2_GREEN_DOWN*0.46230152343146724)*(jac_affine_inv_0_2_GREEN_DOWN*0.3817653560693467 + jac_affine_inv_1_2_GREEN_DOWN*0.83922694315494217 + jac_affine_inv_2_2_GREEN_DOWN*0.3817653560693467)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_1_0_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_2_0_GREEN_DOWN*0.46230152343146724)*(jac_affine_inv_0_0_GREEN_DOWN*0.61339470758478154 + jac_affine_inv_1_0_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_0_GREEN_DOWN*0.15593312049918601) + (jac_affine_inv_0_1_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_1_1_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_2_1_GREEN_DOWN*0.46230152343146724)*(jac_affine_inv_0_1_GREEN_DOWN*0.61339470758478154 + jac_affine_inv_1_1_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_1_GREEN_DOWN*0.15593312049918601) + (jac_affine_inv_0_2_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_1_2_GREEN_DOWN*0.0048399363458717648 + jac_affine_inv_2_2_GREEN_DOWN*0.46230152343146724)*(jac_affine_inv_0_2_GREEN_DOWN*0.61339470758478154 + jac_affine_inv_1_2_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_2_GREEN_DOWN*0.15593312049918601)), abs_det_jac_affine_GREEN_DOWN*(((jac_affine_inv_0_0_GREEN_DOWN*0.45490121496118757 + jac_affine_inv_1_0_GREEN_DOWN + jac_affine_inv_2_0_GREEN_DOWN*0.45490121496118757)*(jac_affine_inv_0_0_GREEN_DOWN*0.45490121496118757 + jac_affine_inv_1_0_GREEN_DOWN + jac_affine_inv_2_0_GREEN_DOWN*0.45490121496118757))*0.70430186211718859 + ((jac_affine_inv_0_1_GREEN_DOWN*0.45490121496118757 + jac_affine_inv_1_1_GREEN_DOWN + jac_affine_inv_2_1_GREEN_DOWN*0.45490121496118757)*(jac_affine_inv_0_1_GREEN_DOWN*0.45490121496118757 + jac_affine_inv_1_1_GREEN_DOWN + jac_affine_inv_2_1_GREEN_DOWN*0.45490121496118757))*0.70430186211718859 + ((jac_affine_inv_0_2_GREEN_DOWN*0.45490121496118757 + jac_affine_inv_1_2_GREEN_DOWN + jac_affine_inv_2_2_GREEN_DOWN*0.45490121496118757)*(jac_affine_inv_0_2_GREEN_DOWN*0.45490121496118757 + jac_affine_inv_1_2_GREEN_DOWN + jac_affine_inv_2_2_GREEN_DOWN*0.45490121496118757))*0.70430186211718859), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.3817653560693467 + jac_affine_inv_1_0_GREEN_DOWN*0.83922694315494217 + jac_affine_inv_2_0_GREEN_DOWN*0.3817653560693467)*(jac_affine_inv_0_0_GREEN_DOWN*0.61339470758478154 + jac_affine_inv_1_0_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_0_GREEN_DOWN*0.15593312049918601) + (jac_affine_inv_0_1_GREEN_DOWN*0.3817653560693467 + jac_affine_inv_1_1_GREEN_DOWN*0.83922694315494217 + jac_affine_inv_2_1_GREEN_DOWN*0.3817653560693467)*(jac_affine_inv_0_1_GREEN_DOWN*0.61339470758478154 + jac_affine_inv_1_1_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_1_GREEN_DOWN*0.15593312049918601) + (jac_affine_inv_0_2_GREEN_DOWN*0.3817653560693467 + jac_affine_inv_1_2_GREEN_DOWN*0.83922694315494217 + jac_affine_inv_2_2_GREEN_DOWN*0.3817653560693467)*(jac_affine_inv_0_2_GREEN_DOWN*0.61339470758478154 + jac_affine_inv_1_2_GREEN_DOWN*0.15593312049918601 + jac_affine_inv_2_2_GREEN_DOWN*0.15593312049918601)), abs_det_jac_affine_GREEN_DOWN*(((jac_affine_inv_0_0_GREEN_DOWN + jac_affine_inv_1_0_GREEN_DOWN*0.25421334512840316 + jac_affine_inv_2_0_GREEN_DOWN*0.25421334512840316)*(jac_affine_inv_0_0_GREEN_DOWN + jac_affine_inv_1_0_GREEN_DOWN*0.25421334512840316 + jac_affine_inv_2_0_GREEN_DOWN*0.25421334512840316))*0.37625306729301966 + ((jac_affine_inv_0_1_GREEN_DOWN + jac_affine_inv_1_1_GREEN_DOWN*0.25421334512840316 + jac_affine_inv_2_1_GREEN_DOWN*0.25421334512840316)*(jac_affine_inv_0_1_GREEN_DOWN + jac_affine_inv_1_1_GREEN_DOWN*0.25421334512840316 + jac_affine_inv_2_1_GREEN_DOWN*0.25421334512840316))*0.37625306729301966 + ((jac_affine_inv_0_2_GREEN_DOWN + jac_affine_inv_1_2_GREEN_DOWN*0.25421334512840316 + jac_affine_inv_2_2_GREEN_DOWN*0.25421334512840316)*(jac_affine_inv_0_2_GREEN_DOWN + jac_affine_inv_1_2_GREEN_DOWN*0.25421334512840316 + jac_affine_inv_2_2_GREEN_DOWN*0.25421334512840316))*0.37625306729301966), abs_det_jac_affine_GREEN_DOWN*(((-jac_affine_inv_1_0_GREEN_DOWN + jac_affine_inv_2_0_GREEN_DOWN*0.015462881894859308)*(-jac_affine_inv_1_0_GREEN_DOWN + jac_affine_inv_2_0_GREEN_DOWN*0.015462881894859308))*0.20046443821120841 + ((-jac_affine_inv_1_1_GREEN_DOWN + jac_affine_inv_2_1_GREEN_DOWN*0.015462881894859308)*(-jac_affine_inv_1_1_GREEN_DOWN + jac_affine_inv_2_1_GREEN_DOWN*0.015462881894859308))*0.20046443821120841 + ((-jac_affine_inv_1_2_GREEN_DOWN + jac_affine_inv_2_2_GREEN_DOWN*0.015462881894859308)*(-jac_affine_inv_1_2_GREEN_DOWN + jac_affine_inv_2_2_GREEN_DOWN*0.015462881894859308))*0.20046443821120841), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_1_0_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_GREEN_DOWN*0.0069232355736274674) + (jac_affine_inv_0_1_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_1_1_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_GREEN_DOWN*0.0069232355736274674) + (jac_affine_inv_0_2_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_1_2_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_GREEN_DOWN*0.0069232355736274674)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.0069232355736274674 + jac_affine_inv_1_0_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_1_0_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_GREEN_DOWN*0.0069232355736274674) + (jac_affine_inv_0_1_GREEN_DOWN*-0.0069232355736274674 + jac_affine_inv_1_1_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_1_1_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_GREEN_DOWN*0.0069232355736274674) + (jac_affine_inv_0_2_GREEN_DOWN*-0.0069232355736274674 + jac_affine_inv_1_2_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_1_2_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_GREEN_DOWN*0.0069232355736274674)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_GREEN_DOWN*0.0069232355736274674)*(jac_affine_inv_0_0_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_1_0_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_2_0_GREEN_DOWN*0.81304707091600714) + (jac_affine_inv_1_1_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_GREEN_DOWN*0.0069232355736274674)*(jac_affine_inv_0_1_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_1_1_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_2_1_GREEN_DOWN*0.81304707091600714) + (jac_affine_inv_1_2_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_GREEN_DOWN*0.0069232355736274674)*(jac_affine_inv_0_2_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_1_2_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_2_2_GREEN_DOWN*0.81304707091600714)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_GREEN_DOWN*0.0069232355736274674)*(jac_affine_inv_0_0_GREEN_DOWN*0.0069232355736274674 + jac_affine_inv_1_0_GREEN_DOWN*0.37223775438826195 + jac_affine_inv_2_0_GREEN_DOWN*0.0069232355736274674) + (jac_affine_inv_1_1_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_GREEN_DOWN*0.0069232355736274674)*(jac_affine_inv_0_1_GREEN_DOWN*0.0069232355736274674 + jac_affine_inv_1_1_GREEN_DOWN*0.37223775438826195 + jac_affine_inv_2_1_GREEN_DOWN*0.0069232355736274674) + (jac_affine_inv_1_2_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_GREEN_DOWN*0.0069232355736274674)*(jac_affine_inv_0_2_GREEN_DOWN*0.0069232355736274674 + jac_affine_inv_1_2_GREEN_DOWN*0.37223775438826195 + jac_affine_inv_2_2_GREEN_DOWN*0.0069232355736274674)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_GREEN_DOWN*0.0069232355736274674)*(jac_affine_inv_0_0_GREEN_DOWN*0.54534421232499986 + jac_affine_inv_1_0_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_0_GREEN_DOWN*0.18002969351036541) + (jac_affine_inv_1_1_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_GREEN_DOWN*0.0069232355736274674)*(jac_affine_inv_0_1_GREEN_DOWN*0.54534421232499986 + jac_affine_inv_1_1_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_1_GREEN_DOWN*0.18002969351036541) + (jac_affine_inv_1_2_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_GREEN_DOWN*0.0069232355736274674)*(jac_affine_inv_0_2_GREEN_DOWN*0.54534421232499986 + jac_affine_inv_1_2_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_2_GREEN_DOWN*0.18002969351036541)), abs_det_jac_affine_GREEN_DOWN*(((-jac_affine_inv_0_0_GREEN_DOWN + jac_affine_inv_2_0_GREEN_DOWN*0.40209203611714223)*(-jac_affine_inv_0_0_GREEN_DOWN + jac_affine_inv_2_0_GREEN_DOWN*0.40209203611714223))*0.20046443821120841 + ((-jac_affine_inv_0_1_GREEN_DOWN + jac_affine_inv_2_1_GREEN_DOWN*0.40209203611714223)*(-jac_affine_inv_0_1_GREEN_DOWN + jac_affine_inv_2_1_GREEN_DOWN*0.40209203611714223))*0.20046443821120841 + ((-jac_affine_inv_0_2_GREEN_DOWN + jac_affine_inv_2_2_GREEN_DOWN*0.40209203611714223)*(-jac_affine_inv_0_2_GREEN_DOWN + jac_affine_inv_2_2_GREEN_DOWN*0.40209203611714223))*0.20046443821120841), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.0069232355736274674 + jac_affine_inv_1_0_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_GREEN_DOWN*0.18002969351036541) + (jac_affine_inv_0_1_GREEN_DOWN*-0.0069232355736274674 + jac_affine_inv_1_1_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_GREEN_DOWN*0.18002969351036541) + (jac_affine_inv_0_2_GREEN_DOWN*-0.0069232355736274674 + jac_affine_inv_1_2_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_GREEN_DOWN*0.18002969351036541)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_1_0_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_2_0_GREEN_DOWN*0.81304707091600714) + (jac_affine_inv_0_1_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_1_1_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_2_1_GREEN_DOWN*0.81304707091600714) + (jac_affine_inv_0_2_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_1_2_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_2_2_GREEN_DOWN*0.81304707091600714)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_GREEN_DOWN*0.0069232355736274674 + jac_affine_inv_1_0_GREEN_DOWN*0.37223775438826195 + jac_affine_inv_2_0_GREEN_DOWN*0.0069232355736274674) + (jac_affine_inv_0_1_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_GREEN_DOWN*0.0069232355736274674 + jac_affine_inv_1_1_GREEN_DOWN*0.37223775438826195 + jac_affine_inv_2_1_GREEN_DOWN*0.0069232355736274674) + (jac_affine_inv_0_2_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_GREEN_DOWN*0.0069232355736274674 + jac_affine_inv_1_2_GREEN_DOWN*0.37223775438826195 + jac_affine_inv_2_2_GREEN_DOWN*0.0069232355736274674)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_0_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_GREEN_DOWN*0.54534421232499986 + jac_affine_inv_1_0_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_0_GREEN_DOWN*0.18002969351036541) + (jac_affine_inv_0_1_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_1_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_GREEN_DOWN*0.54534421232499986 + jac_affine_inv_1_1_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_1_GREEN_DOWN*0.18002969351036541) + (jac_affine_inv_0_2_GREEN_DOWN*-0.44773255210137269 + jac_affine_inv_2_2_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_GREEN_DOWN*0.54534421232499986 + jac_affine_inv_1_2_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_2_GREEN_DOWN*0.18002969351036541)), abs_det_jac_affine_GREEN_DOWN*(((jac_affine_inv_0_0_GREEN_DOWN*-0.03845607598742512 + jac_affine_inv_1_0_GREEN_DOWN)*(jac_affine_inv_0_0_GREEN_DOWN*-0.03845607598742512 + jac_affine_inv_1_0_GREEN_DOWN))*0.032410690545436105 + ((jac_affine_inv_0_1_GREEN_DOWN*-0.03845607598742512 + jac_affine_inv_1_1_GREEN_DOWN)*(jac_affine_inv_0_1_GREEN_DOWN*-0.03845607598742512 + jac_affine_inv_1_1_GREEN_DOWN))*0.032410690545436105 + ((jac_affine_inv_0_2_GREEN_DOWN*-0.03845607598742512 + jac_affine_inv_1_2_GREEN_DOWN)*(jac_affine_inv_0_2_GREEN_DOWN*-0.03845607598742512 + jac_affine_inv_1_2_GREEN_DOWN))*0.032410690545436105), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.0069232355736274674 + jac_affine_inv_1_0_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_1_0_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_2_0_GREEN_DOWN*0.81304707091600714) + (jac_affine_inv_0_1_GREEN_DOWN*-0.0069232355736274674 + jac_affine_inv_1_1_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_1_1_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_2_1_GREEN_DOWN*0.81304707091600714) + (jac_affine_inv_0_2_GREEN_DOWN*-0.0069232355736274674 + jac_affine_inv_1_2_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_1_2_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_2_2_GREEN_DOWN*0.81304707091600714)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.0069232355736274674 + jac_affine_inv_1_0_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_GREEN_DOWN*0.0069232355736274674 + jac_affine_inv_1_0_GREEN_DOWN*0.37223775438826195 + jac_affine_inv_2_0_GREEN_DOWN*0.0069232355736274674) + (jac_affine_inv_0_1_GREEN_DOWN*-0.0069232355736274674 + jac_affine_inv_1_1_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_GREEN_DOWN*0.0069232355736274674 + jac_affine_inv_1_1_GREEN_DOWN*0.37223775438826195 + jac_affine_inv_2_1_GREEN_DOWN*0.0069232355736274674) + (jac_affine_inv_0_2_GREEN_DOWN*-0.0069232355736274674 + jac_affine_inv_1_2_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_GREEN_DOWN*0.0069232355736274674 + jac_affine_inv_1_2_GREEN_DOWN*0.37223775438826195 + jac_affine_inv_2_2_GREEN_DOWN*0.0069232355736274674)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.0069232355736274674 + jac_affine_inv_1_0_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_0_GREEN_DOWN*0.54534421232499986 + jac_affine_inv_1_0_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_0_GREEN_DOWN*0.18002969351036541) + (jac_affine_inv_0_1_GREEN_DOWN*-0.0069232355736274674 + jac_affine_inv_1_1_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_1_GREEN_DOWN*0.54534421232499986 + jac_affine_inv_1_1_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_1_GREEN_DOWN*0.18002969351036541) + (jac_affine_inv_0_2_GREEN_DOWN*-0.0069232355736274674 + jac_affine_inv_1_2_GREEN_DOWN*0.18002969351036541)*(jac_affine_inv_0_2_GREEN_DOWN*0.54534421232499986 + jac_affine_inv_1_2_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_2_GREEN_DOWN*0.18002969351036541)), abs_det_jac_affine_GREEN_DOWN*(((jac_affine_inv_0_0_GREEN_DOWN*0.55068466281655948 + jac_affine_inv_1_0_GREEN_DOWN*0.55068466281655948 + jac_affine_inv_2_0_GREEN_DOWN)*(jac_affine_inv_0_0_GREEN_DOWN*0.55068466281655948 + jac_affine_inv_1_0_GREEN_DOWN*0.55068466281655948 + jac_affine_inv_2_0_GREEN_DOWN))*0.6610455395250987 + ((jac_affine_inv_0_1_GREEN_DOWN*0.55068466281655948 + jac_affine_inv_1_1_GREEN_DOWN*0.55068466281655948 + jac_affine_inv_2_1_GREEN_DOWN)*(jac_affine_inv_0_1_GREEN_DOWN*0.55068466281655948 + jac_affine_inv_1_1_GREEN_DOWN*0.55068466281655948 + jac_affine_inv_2_1_GREEN_DOWN))*0.6610455395250987 + ((jac_affine_inv_0_2_GREEN_DOWN*0.55068466281655948 + jac_affine_inv_1_2_GREEN_DOWN*0.55068466281655948 + jac_affine_inv_2_2_GREEN_DOWN)*(jac_affine_inv_0_2_GREEN_DOWN*0.55068466281655948 + jac_affine_inv_1_2_GREEN_DOWN*0.55068466281655948 + jac_affine_inv_2_2_GREEN_DOWN))*0.6610455395250987), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.0069232355736274674 + jac_affine_inv_1_0_GREEN_DOWN*0.37223775438826195 + jac_affine_inv_2_0_GREEN_DOWN*0.0069232355736274674)*(jac_affine_inv_0_0_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_1_0_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_2_0_GREEN_DOWN*0.81304707091600714) + (jac_affine_inv_0_1_GREEN_DOWN*0.0069232355736274674 + jac_affine_inv_1_1_GREEN_DOWN*0.37223775438826195 + jac_affine_inv_2_1_GREEN_DOWN*0.0069232355736274674)*(jac_affine_inv_0_1_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_1_1_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_2_1_GREEN_DOWN*0.81304707091600714) + (jac_affine_inv_0_2_GREEN_DOWN*0.0069232355736274674 + jac_affine_inv_1_2_GREEN_DOWN*0.37223775438826195 + jac_affine_inv_2_2_GREEN_DOWN*0.0069232355736274674)*(jac_affine_inv_0_2_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_1_2_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_2_2_GREEN_DOWN*0.81304707091600714)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_1_0_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_2_0_GREEN_DOWN*0.81304707091600714)*(jac_affine_inv_0_0_GREEN_DOWN*0.54534421232499986 + jac_affine_inv_1_0_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_0_GREEN_DOWN*0.18002969351036541) + (jac_affine_inv_0_1_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_1_1_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_2_1_GREEN_DOWN*0.81304707091600714)*(jac_affine_inv_0_1_GREEN_DOWN*0.54534421232499986 + jac_affine_inv_1_1_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_1_GREEN_DOWN*0.18002969351036541) + (jac_affine_inv_0_2_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_1_2_GREEN_DOWN*0.44773255210137269 + jac_affine_inv_2_2_GREEN_DOWN*0.81304707091600714)*(jac_affine_inv_0_2_GREEN_DOWN*0.54534421232499986 + jac_affine_inv_1_2_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_2_GREEN_DOWN*0.18002969351036541)), abs_det_jac_affine_GREEN_DOWN*(((jac_affine_inv_0_0_GREEN_DOWN*0.01859896126067373 + jac_affine_inv_1_0_GREEN_DOWN + jac_affine_inv_2_0_GREEN_DOWN*0.01859896126067373)*(jac_affine_inv_0_0_GREEN_DOWN*0.01859896126067373 + jac_affine_inv_1_0_GREEN_DOWN + jac_affine_inv_2_0_GREEN_DOWN*0.01859896126067373))*0.13856094579201603 + ((jac_affine_inv_0_1_GREEN_DOWN*0.01859896126067373 + jac_affine_inv_1_1_GREEN_DOWN + jac_affine_inv_2_1_GREEN_DOWN*0.01859896126067373)*(jac_affine_inv_0_1_GREEN_DOWN*0.01859896126067373 + jac_affine_inv_1_1_GREEN_DOWN + jac_affine_inv_2_1_GREEN_DOWN*0.01859896126067373))*0.13856094579201603 + ((jac_affine_inv_0_2_GREEN_DOWN*0.01859896126067373 + jac_affine_inv_1_2_GREEN_DOWN + jac_affine_inv_2_2_GREEN_DOWN*0.01859896126067373)*(jac_affine_inv_0_2_GREEN_DOWN*0.01859896126067373 + jac_affine_inv_1_2_GREEN_DOWN + jac_affine_inv_2_2_GREEN_DOWN*0.01859896126067373))*0.13856094579201603), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.0069232355736274674 + jac_affine_inv_1_0_GREEN_DOWN*0.37223775438826195 + jac_affine_inv_2_0_GREEN_DOWN*0.0069232355736274674)*(jac_affine_inv_0_0_GREEN_DOWN*0.54534421232499986 + jac_affine_inv_1_0_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_0_GREEN_DOWN*0.18002969351036541) + (jac_affine_inv_0_1_GREEN_DOWN*0.0069232355736274674 + jac_affine_inv_1_1_GREEN_DOWN*0.37223775438826195 + jac_affine_inv_2_1_GREEN_DOWN*0.0069232355736274674)*(jac_affine_inv_0_1_GREEN_DOWN*0.54534421232499986 + jac_affine_inv_1_1_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_1_GREEN_DOWN*0.18002969351036541) + (jac_affine_inv_0_2_GREEN_DOWN*0.0069232355736274674 + jac_affine_inv_1_2_GREEN_DOWN*0.37223775438826195 + jac_affine_inv_2_2_GREEN_DOWN*0.0069232355736274674)*(jac_affine_inv_0_2_GREEN_DOWN*0.54534421232499986 + jac_affine_inv_1_2_GREEN_DOWN*0.18002969351036541 + jac_affine_inv_2_2_GREEN_DOWN*0.18002969351036541)), abs_det_jac_affine_GREEN_DOWN*(((jac_affine_inv_0_0_GREEN_DOWN + jac_affine_inv_1_0_GREEN_DOWN*0.33012121416459822 + jac_affine_inv_2_0_GREEN_DOWN*0.33012121416459822)*(jac_affine_inv_0_0_GREEN_DOWN + jac_affine_inv_1_0_GREEN_DOWN*0.33012121416459822 + jac_affine_inv_2_0_GREEN_DOWN*0.33012121416459822))*0.29740030991637451 + ((jac_affine_inv_0_1_GREEN_DOWN + jac_affine_inv_1_1_GREEN_DOWN*0.33012121416459822 + jac_affine_inv_2_1_GREEN_DOWN*0.33012121416459822)*(jac_affine_inv_0_1_GREEN_DOWN + jac_affine_inv_1_1_GREEN_DOWN*0.33012121416459822 + jac_affine_inv_2_1_GREEN_DOWN*0.33012121416459822))*0.29740030991637451 + ((jac_affine_inv_0_2_GREEN_DOWN + jac_affine_inv_1_2_GREEN_DOWN*0.33012121416459822 + jac_affine_inv_2_2_GREEN_DOWN*0.33012121416459822)*(jac_affine_inv_0_2_GREEN_DOWN + jac_affine_inv_1_2_GREEN_DOWN*0.33012121416459822 + jac_affine_inv_2_2_GREEN_DOWN*0.33012121416459822))*0.29740030991637451), abs_det_jac_affine_GREEN_DOWN*(((jac_affine_inv_1_0_GREEN_DOWN*-0.81923601162978588 + jac_affine_inv_2_0_GREEN_DOWN)*(jac_affine_inv_1_0_GREEN_DOWN*-0.81923601162978588 + jac_affine_inv_2_0_GREEN_DOWN))*0.18550396047976214 + ((jac_affine_inv_1_1_GREEN_DOWN*-0.81923601162978588 + jac_affine_inv_2_1_GREEN_DOWN)*(jac_affine_inv_1_1_GREEN_DOWN*-0.81923601162978588 + jac_affine_inv_2_1_GREEN_DOWN))*0.18550396047976214 + ((jac_affine_inv_1_2_GREEN_DOWN*-0.81923601162978588 + jac_affine_inv_2_2_GREEN_DOWN)*(jac_affine_inv_1_2_GREEN_DOWN*-0.81923601162978588 + jac_affine_inv_2_2_GREEN_DOWN))*0.18550396047976214), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_1_0_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_GREEN_DOWN*0.43070170707783612) + (jac_affine_inv_0_1_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_1_1_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_GREEN_DOWN*0.43070170707783612) + (jac_affine_inv_0_2_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_1_2_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_GREEN_DOWN*0.43070170707783612)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.43070170707783612 + jac_affine_inv_1_0_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_1_0_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_GREEN_DOWN*0.43070170707783612) + (jac_affine_inv_0_1_GREEN_DOWN*-0.43070170707783612 + jac_affine_inv_1_1_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_1_1_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_GREEN_DOWN*0.43070170707783612) + (jac_affine_inv_0_2_GREEN_DOWN*-0.43070170707783612 + jac_affine_inv_1_2_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_1_2_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_GREEN_DOWN*0.43070170707783612)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_GREEN_DOWN*0.43070170707783612)*(jac_affine_inv_0_0_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_1_0_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_2_0_GREEN_DOWN*0.35322186373731607) + (jac_affine_inv_1_1_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_GREEN_DOWN*0.43070170707783612)*(jac_affine_inv_0_1_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_1_1_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_2_1_GREEN_DOWN*0.35322186373731607) + (jac_affine_inv_1_2_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_GREEN_DOWN*0.43070170707783612)*(jac_affine_inv_0_2_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_1_2_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_2_2_GREEN_DOWN*0.35322186373731607)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_GREEN_DOWN*0.43070170707783612)*(jac_affine_inv_0_0_GREEN_DOWN*0.43070170707783612 + jac_affine_inv_1_0_GREEN_DOWN*0.43107722210656541 + jac_affine_inv_2_0_GREEN_DOWN*0.43070170707783612) + (jac_affine_inv_1_1_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_GREEN_DOWN*0.43070170707783612)*(jac_affine_inv_0_1_GREEN_DOWN*0.43070170707783612 + jac_affine_inv_1_1_GREEN_DOWN*0.43107722210656541 + jac_affine_inv_2_1_GREEN_DOWN*0.43070170707783612) + (jac_affine_inv_1_2_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_GREEN_DOWN*0.43070170707783612)*(jac_affine_inv_0_2_GREEN_DOWN*0.43070170707783612 + jac_affine_inv_1_2_GREEN_DOWN*0.43107722210656541 + jac_affine_inv_2_2_GREEN_DOWN*0.43070170707783612)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_1_0_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_GREEN_DOWN*0.43070170707783612)*(jac_affine_inv_0_0_GREEN_DOWN*0.21645194421357716 + jac_affine_inv_1_0_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_0_GREEN_DOWN*0.21607642918484779) + (jac_affine_inv_1_1_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_GREEN_DOWN*0.43070170707783612)*(jac_affine_inv_0_1_GREEN_DOWN*0.21645194421357716 + jac_affine_inv_1_1_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_1_GREEN_DOWN*0.21607642918484779) + (jac_affine_inv_1_2_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_GREEN_DOWN*0.43070170707783612)*(jac_affine_inv_0_2_GREEN_DOWN*0.21645194421357716 + jac_affine_inv_1_2_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_2_GREEN_DOWN*0.21607642918484779)), abs_det_jac_affine_GREEN_DOWN*(((-jac_affine_inv_0_0_GREEN_DOWN + jac_affine_inv_2_0_GREEN_DOWN*0.61238108308527162)*(-jac_affine_inv_0_0_GREEN_DOWN + jac_affine_inv_2_0_GREEN_DOWN*0.61238108308527162))*0.12450054579698162 + ((-jac_affine_inv_0_1_GREEN_DOWN + jac_affine_inv_2_1_GREEN_DOWN*0.61238108308527162)*(-jac_affine_inv_0_1_GREEN_DOWN + jac_affine_inv_2_1_GREEN_DOWN*0.61238108308527162))*0.12450054579698162 + ((-jac_affine_inv_0_2_GREEN_DOWN + jac_affine_inv_2_2_GREEN_DOWN*0.61238108308527162)*(-jac_affine_inv_0_2_GREEN_DOWN + jac_affine_inv_2_2_GREEN_DOWN*0.61238108308527162))*0.12450054579698162), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_GREEN_DOWN*-0.43070170707783612 + jac_affine_inv_1_0_GREEN_DOWN*0.21607642918484779) + (jac_affine_inv_0_1_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_GREEN_DOWN*-0.43070170707783612 + jac_affine_inv_1_1_GREEN_DOWN*0.21607642918484779) + (jac_affine_inv_0_2_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_GREEN_DOWN*-0.43070170707783612 + jac_affine_inv_1_2_GREEN_DOWN*0.21607642918484779)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_1_0_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_2_0_GREEN_DOWN*0.35322186373731607) + (jac_affine_inv_0_1_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_1_1_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_2_1_GREEN_DOWN*0.35322186373731607) + (jac_affine_inv_0_2_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_1_2_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_2_2_GREEN_DOWN*0.35322186373731607)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_GREEN_DOWN*0.43070170707783612 + jac_affine_inv_1_0_GREEN_DOWN*0.43107722210656541 + jac_affine_inv_2_0_GREEN_DOWN*0.43070170707783612) + (jac_affine_inv_0_1_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_GREEN_DOWN*0.43070170707783612 + jac_affine_inv_1_1_GREEN_DOWN*0.43107722210656541 + jac_affine_inv_2_1_GREEN_DOWN*0.43070170707783612) + (jac_affine_inv_0_2_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_GREEN_DOWN*0.43070170707783612 + jac_affine_inv_1_2_GREEN_DOWN*0.43107722210656541 + jac_affine_inv_2_2_GREEN_DOWN*0.43070170707783612)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_0_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_GREEN_DOWN*0.21645194421357716 + jac_affine_inv_1_0_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_0_GREEN_DOWN*0.21607642918484779) + (jac_affine_inv_0_1_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_1_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_GREEN_DOWN*0.21645194421357716 + jac_affine_inv_1_1_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_1_GREEN_DOWN*0.21607642918484779) + (jac_affine_inv_0_2_GREEN_DOWN*-0.35284634870858678 + jac_affine_inv_2_2_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_GREEN_DOWN*0.21645194421357716 + jac_affine_inv_1_2_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_2_GREEN_DOWN*0.21607642918484779)), abs_det_jac_affine_GREEN_DOWN*(((-jac_affine_inv_0_0_GREEN_DOWN + jac_affine_inv_1_0_GREEN_DOWN*0.50168463610430647)*(-jac_affine_inv_0_0_GREEN_DOWN + jac_affine_inv_1_0_GREEN_DOWN*0.50168463610430647))*0.18550396047976214 + ((-jac_affine_inv_0_1_GREEN_DOWN + jac_affine_inv_1_1_GREEN_DOWN*0.50168463610430647)*(-jac_affine_inv_0_1_GREEN_DOWN + jac_affine_inv_1_1_GREEN_DOWN*0.50168463610430647))*0.18550396047976214 + ((-jac_affine_inv_0_2_GREEN_DOWN + jac_affine_inv_1_2_GREEN_DOWN*0.50168463610430647)*(-jac_affine_inv_0_2_GREEN_DOWN + jac_affine_inv_1_2_GREEN_DOWN*0.50168463610430647))*0.18550396047976214), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.43070170707783612 + jac_affine_inv_1_0_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_1_0_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_2_0_GREEN_DOWN*0.35322186373731607) + (jac_affine_inv_0_1_GREEN_DOWN*-0.43070170707783612 + jac_affine_inv_1_1_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_1_1_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_2_1_GREEN_DOWN*0.35322186373731607) + (jac_affine_inv_0_2_GREEN_DOWN*-0.43070170707783612 + jac_affine_inv_1_2_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_1_2_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_2_2_GREEN_DOWN*0.35322186373731607)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.43070170707783612 + jac_affine_inv_1_0_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_GREEN_DOWN*0.43070170707783612 + jac_affine_inv_1_0_GREEN_DOWN*0.43107722210656541 + jac_affine_inv_2_0_GREEN_DOWN*0.43070170707783612) + (jac_affine_inv_0_1_GREEN_DOWN*-0.43070170707783612 + jac_affine_inv_1_1_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_GREEN_DOWN*0.43070170707783612 + jac_affine_inv_1_1_GREEN_DOWN*0.43107722210656541 + jac_affine_inv_2_1_GREEN_DOWN*0.43070170707783612) + (jac_affine_inv_0_2_GREEN_DOWN*-0.43070170707783612 + jac_affine_inv_1_2_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_GREEN_DOWN*0.43070170707783612 + jac_affine_inv_1_2_GREEN_DOWN*0.43107722210656541 + jac_affine_inv_2_2_GREEN_DOWN*0.43070170707783612)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*-0.43070170707783612 + jac_affine_inv_1_0_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_GREEN_DOWN*0.21645194421357716 + jac_affine_inv_1_0_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_0_GREEN_DOWN*0.21607642918484779) + (jac_affine_inv_0_1_GREEN_DOWN*-0.43070170707783612 + jac_affine_inv_1_1_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_GREEN_DOWN*0.21645194421357716 + jac_affine_inv_1_1_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_1_GREEN_DOWN*0.21607642918484779) + (jac_affine_inv_0_2_GREEN_DOWN*-0.43070170707783612 + jac_affine_inv_1_2_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_GREEN_DOWN*0.21645194421357716 + jac_affine_inv_1_2_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_2_GREEN_DOWN*0.21607642918484779)), abs_det_jac_affine_GREEN_DOWN*(((jac_affine_inv_0_0_GREEN_DOWN*0.99893688622568233 + jac_affine_inv_1_0_GREEN_DOWN*0.99893688622568233 + jac_affine_inv_2_0_GREEN_DOWN)*(jac_affine_inv_0_0_GREEN_DOWN*0.99893688622568233 + jac_affine_inv_1_0_GREEN_DOWN*0.99893688622568233 + jac_affine_inv_2_0_GREEN_DOWN))*0.12476568502206307 + ((jac_affine_inv_0_1_GREEN_DOWN*0.99893688622568233 + jac_affine_inv_1_1_GREEN_DOWN*0.99893688622568233 + jac_affine_inv_2_1_GREEN_DOWN)*(jac_affine_inv_0_1_GREEN_DOWN*0.99893688622568233 + jac_affine_inv_1_1_GREEN_DOWN*0.99893688622568233 + jac_affine_inv_2_1_GREEN_DOWN))*0.12476568502206307 + ((jac_affine_inv_0_2_GREEN_DOWN*0.99893688622568233 + jac_affine_inv_1_2_GREEN_DOWN*0.99893688622568233 + jac_affine_inv_2_2_GREEN_DOWN)*(jac_affine_inv_0_2_GREEN_DOWN*0.99893688622568233 + jac_affine_inv_1_2_GREEN_DOWN*0.99893688622568233 + jac_affine_inv_2_2_GREEN_DOWN))*0.12476568502206307), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_1_0_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_2_0_GREEN_DOWN*0.35322186373731607)*(jac_affine_inv_0_0_GREEN_DOWN*0.43070170707783612 + jac_affine_inv_1_0_GREEN_DOWN*0.43107722210656541 + jac_affine_inv_2_0_GREEN_DOWN*0.43070170707783612) + (jac_affine_inv_0_1_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_1_1_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_2_1_GREEN_DOWN*0.35322186373731607)*(jac_affine_inv_0_1_GREEN_DOWN*0.43070170707783612 + jac_affine_inv_1_1_GREEN_DOWN*0.43107722210656541 + jac_affine_inv_2_1_GREEN_DOWN*0.43070170707783612) + (jac_affine_inv_0_2_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_1_2_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_2_2_GREEN_DOWN*0.35322186373731607)*(jac_affine_inv_0_2_GREEN_DOWN*0.43070170707783612 + jac_affine_inv_1_2_GREEN_DOWN*0.43107722210656541 + jac_affine_inv_2_2_GREEN_DOWN*0.43070170707783612)), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.21645194421357716 + jac_affine_inv_1_0_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_0_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_1_0_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_2_0_GREEN_DOWN*0.35322186373731607) + (jac_affine_inv_0_1_GREEN_DOWN*0.21645194421357716 + jac_affine_inv_1_1_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_1_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_1_1_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_2_1_GREEN_DOWN*0.35322186373731607) + (jac_affine_inv_0_2_GREEN_DOWN*0.21645194421357716 + jac_affine_inv_1_2_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_2_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_1_2_GREEN_DOWN*0.35284634870858678 + jac_affine_inv_2_2_GREEN_DOWN*0.35322186373731607)), abs_det_jac_affine_GREEN_DOWN*(((jac_affine_inv_0_0_GREEN_DOWN*0.99912889150836071 + jac_affine_inv_1_0_GREEN_DOWN + jac_affine_inv_2_0_GREEN_DOWN*0.99912889150836071)*(jac_affine_inv_0_0_GREEN_DOWN*0.99912889150836071 + jac_affine_inv_1_0_GREEN_DOWN + jac_affine_inv_2_0_GREEN_DOWN*0.99912889150836071))*0.18582757141911313 + ((jac_affine_inv_0_1_GREEN_DOWN*0.99912889150836071 + jac_affine_inv_1_1_GREEN_DOWN + jac_affine_inv_2_1_GREEN_DOWN*0.99912889150836071)*(jac_affine_inv_0_1_GREEN_DOWN*0.99912889150836071 + jac_affine_inv_1_1_GREEN_DOWN + jac_affine_inv_2_1_GREEN_DOWN*0.99912889150836071))*0.18582757141911313 + ((jac_affine_inv_0_2_GREEN_DOWN*0.99912889150836071 + jac_affine_inv_1_2_GREEN_DOWN + jac_affine_inv_2_2_GREEN_DOWN*0.99912889150836071)*(jac_affine_inv_0_2_GREEN_DOWN*0.99912889150836071 + jac_affine_inv_1_2_GREEN_DOWN + jac_affine_inv_2_2_GREEN_DOWN*0.99912889150836071))*0.18582757141911313), abs_det_jac_affine_GREEN_DOWN*((jac_affine_inv_0_0_GREEN_DOWN*0.21645194421357716 + jac_affine_inv_1_0_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_0_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_0_GREEN_DOWN*0.43070170707783612 + jac_affine_inv_1_0_GREEN_DOWN*0.43107722210656541 + jac_affine_inv_2_0_GREEN_DOWN*0.43070170707783612) + (jac_affine_inv_0_1_GREEN_DOWN*0.21645194421357716 + jac_affine_inv_1_1_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_1_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_1_GREEN_DOWN*0.43070170707783612 + jac_affine_inv_1_1_GREEN_DOWN*0.43107722210656541 + jac_affine_inv_2_1_GREEN_DOWN*0.43070170707783612) + (jac_affine_inv_0_2_GREEN_DOWN*0.21645194421357716 + jac_affine_inv_1_2_GREEN_DOWN*0.21607642918484779 + jac_affine_inv_2_2_GREEN_DOWN*0.21607642918484779)*(jac_affine_inv_0_2_GREEN_DOWN*0.43070170707783612 + jac_affine_inv_1_2_GREEN_DOWN*0.43107722210656541 + jac_affine_inv_2_2_GREEN_DOWN*0.43070170707783612)), abs_det_jac_affine_GREEN_DOWN*(((jac_affine_inv_0_0_GREEN_DOWN + jac_affine_inv_1_0_GREEN_DOWN*0.99826513441543008 + jac_affine_inv_2_0_GREEN_DOWN*0.99826513441543008)*(jac_affine_inv_0_0_GREEN_DOWN + jac_affine_inv_1_0_GREEN_DOWN*0.99826513441543008 + jac_affine_inv_2_0_GREEN_DOWN*0.99826513441543008))*0.046851444153837518 + ((jac_affine_inv_0_1_GREEN_DOWN + jac_affine_inv_1_1_GREEN_DOWN*0.99826513441543008 + jac_affine_inv_2_1_GREEN_DOWN*0.99826513441543008)*(jac_affine_inv_0_1_GREEN_DOWN + jac_affine_inv_1_1_GREEN_DOWN*0.99826513441543008 + jac_affine_inv_2_1_GREEN_DOWN*0.99826513441543008))*0.046851444153837518 + ((jac_affine_inv_0_2_GREEN_DOWN + jac_affine_inv_1_2_GREEN_DOWN*0.99826513441543008 + jac_affine_inv_2_2_GREEN_DOWN*0.99826513441543008)*(jac_affine_inv_0_2_GREEN_DOWN + jac_affine_inv_1_2_GREEN_DOWN*0.99826513441543008 + jac_affine_inv_2_2_GREEN_DOWN*0.99826513441543008))*0.046851444153837518)};
      
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
             const walberla::float64 alpha_dof_0 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 alpha_dof_1 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 alpha_dof_2 = _data_alpha[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 alpha_dof_3 = _data_alpha[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 beta_dof_0 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 beta_dof_1 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 beta_dof_2 = _data_beta[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 beta_dof_3 = _data_beta[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             walberla::float64 q_acc_0_0 = 0.0;
             walberla::float64 q_acc_0_1 = 0.0;
             walberla::float64 q_acc_0_2 = 0.0;
             walberla::float64 q_acc_0_3 = 0.0;
             walberla::float64 q_acc_0_4 = 0.0;
             walberla::float64 q_acc_0_5 = 0.0;
             walberla::float64 q_acc_1_1 = 0.0;
             walberla::float64 q_acc_1_2 = 0.0;
             walberla::float64 q_acc_1_3 = 0.0;
             walberla::float64 q_acc_1_4 = 0.0;
             walberla::float64 q_acc_1_5 = 0.0;
             walberla::float64 q_acc_2_2 = 0.0;
             walberla::float64 q_acc_2_3 = 0.0;
             walberla::float64 q_acc_2_4 = 0.0;
             walberla::float64 q_acc_2_5 = 0.0;
             walberla::float64 q_acc_3_3 = 0.0;
             walberla::float64 q_acc_3_4 = 0.0;
             walberla::float64 q_acc_3_5 = 0.0;
             walberla::float64 q_acc_4_4 = 0.0;
             walberla::float64 q_acc_4_5 = 0.0;
             walberla::float64 q_acc_5_5 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const walberla::float64 tmp_qloop_0 = alpha_dof_0*_data_phi_0_0_GREEN_DOWN[4*q] + alpha_dof_1*_data_phi_0_0_GREEN_DOWN[4*q + 1] + alpha_dof_2*_data_phi_0_0_GREEN_DOWN[4*q + 2] + alpha_dof_3*_data_phi_0_0_GREEN_DOWN[4*q + 3];
                const walberla::float64 tmp_qloop_1 = beta_dof_0*_data_phi_0_0_GREEN_DOWN[4*q] + beta_dof_1*_data_phi_0_0_GREEN_DOWN[4*q + 1] + beta_dof_2*_data_phi_0_0_GREEN_DOWN[4*q + 2] + beta_dof_3*_data_phi_0_0_GREEN_DOWN[4*q + 3];
                const walberla::float64 q_tmp_0_0 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_DOWN[21*q] + tmp_qloop_1*_data_mass_det_0_0_GREEN_DOWN[21*q])*_data_q_w[q];
                const walberla::float64 q_tmp_0_1 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_DOWN[21*q + 1] + tmp_qloop_1*_data_mass_det_0_0_GREEN_DOWN[21*q + 1])*_data_q_w[q];
                const walberla::float64 q_tmp_0_2 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_DOWN[21*q + 2] + tmp_qloop_1*_data_mass_det_0_0_GREEN_DOWN[21*q + 2])*_data_q_w[q];
                const walberla::float64 q_tmp_0_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_DOWN[21*q + 3] + tmp_qloop_1*_data_mass_det_0_0_GREEN_DOWN[21*q + 3])*_data_q_w[q];
                const walberla::float64 q_tmp_0_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_DOWN[21*q + 4] + tmp_qloop_1*_data_mass_det_0_0_GREEN_DOWN[21*q + 4])*_data_q_w[q];
                const walberla::float64 q_tmp_0_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_DOWN[21*q + 5] + tmp_qloop_1*_data_mass_det_0_0_GREEN_DOWN[21*q + 5])*_data_q_w[q];
                const walberla::float64 q_tmp_1_1 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_DOWN[21*q + 6] + tmp_qloop_1*_data_mass_det_0_0_GREEN_DOWN[21*q + 6])*_data_q_w[q];
                const walberla::float64 q_tmp_1_2 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_DOWN[21*q + 7] + tmp_qloop_1*_data_mass_det_0_0_GREEN_DOWN[21*q + 7])*_data_q_w[q];
                const walberla::float64 q_tmp_1_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_DOWN[21*q + 8] + tmp_qloop_1*_data_mass_det_0_0_GREEN_DOWN[21*q + 8])*_data_q_w[q];
                const walberla::float64 q_tmp_1_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_DOWN[21*q + 9] + tmp_qloop_1*_data_mass_det_0_0_GREEN_DOWN[21*q + 9])*_data_q_w[q];
                const walberla::float64 q_tmp_1_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_DOWN[21*q + 10] + tmp_qloop_1*_data_mass_det_0_0_GREEN_DOWN[21*q + 10])*_data_q_w[q];
                const walberla::float64 q_tmp_2_2 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_DOWN[21*q + 11] + tmp_qloop_1*_data_mass_det_0_0_GREEN_DOWN[21*q + 11])*_data_q_w[q];
                const walberla::float64 q_tmp_2_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_DOWN[21*q + 12] + tmp_qloop_1*_data_mass_det_0_0_GREEN_DOWN[21*q + 12])*_data_q_w[q];
                const walberla::float64 q_tmp_2_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_DOWN[21*q + 13] + tmp_qloop_1*_data_mass_det_0_0_GREEN_DOWN[21*q + 13])*_data_q_w[q];
                const walberla::float64 q_tmp_2_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_DOWN[21*q + 14] + tmp_qloop_1*_data_mass_det_0_0_GREEN_DOWN[21*q + 14])*_data_q_w[q];
                const walberla::float64 q_tmp_3_3 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_DOWN[21*q + 15] + tmp_qloop_1*_data_mass_det_0_0_GREEN_DOWN[21*q + 15])*_data_q_w[q];
                const walberla::float64 q_tmp_3_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_DOWN[21*q + 16] + tmp_qloop_1*_data_mass_det_0_0_GREEN_DOWN[21*q + 16])*_data_q_w[q];
                const walberla::float64 q_tmp_3_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_DOWN[21*q + 17] + tmp_qloop_1*_data_mass_det_0_0_GREEN_DOWN[21*q + 17])*_data_q_w[q];
                const walberla::float64 q_tmp_4_4 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_DOWN[21*q + 18] + tmp_qloop_1*_data_mass_det_0_0_GREEN_DOWN[21*q + 18])*_data_q_w[q];
                const walberla::float64 q_tmp_4_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_DOWN[21*q + 19] + tmp_qloop_1*_data_mass_det_0_0_GREEN_DOWN[21*q + 19])*_data_q_w[q];
                const walberla::float64 q_tmp_5_5 = (tmp_qloop_0*_data_curl_curl_det_0_0_GREEN_DOWN[21*q + 20] + tmp_qloop_1*_data_mass_det_0_0_GREEN_DOWN[21*q + 20])*_data_q_w[q];
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
             }
             const walberla::float64 elMat_0_0 = q_acc_0_0;
             const walberla::float64 elMat_0_1 = q_acc_0_1;
             const walberla::float64 elMat_0_2 = q_acc_0_2;
             const walberla::float64 elMat_0_3 = q_acc_0_3;
             const walberla::float64 elMat_0_4 = q_acc_0_4;
             const walberla::float64 elMat_0_5 = q_acc_0_5;
             const walberla::float64 elMat_1_0 = q_acc_0_1;
             const walberla::float64 elMat_1_1 = q_acc_1_1;
             const walberla::float64 elMat_1_2 = q_acc_1_2;
             const walberla::float64 elMat_1_3 = q_acc_1_3;
             const walberla::float64 elMat_1_4 = q_acc_1_4;
             const walberla::float64 elMat_1_5 = q_acc_1_5;
             const walberla::float64 elMat_2_0 = q_acc_0_2;
             const walberla::float64 elMat_2_1 = q_acc_1_2;
             const walberla::float64 elMat_2_2 = q_acc_2_2;
             const walberla::float64 elMat_2_3 = q_acc_2_3;
             const walberla::float64 elMat_2_4 = q_acc_2_4;
             const walberla::float64 elMat_2_5 = q_acc_2_5;
             const walberla::float64 elMat_3_0 = q_acc_0_3;
             const walberla::float64 elMat_3_1 = q_acc_1_3;
             const walberla::float64 elMat_3_2 = q_acc_2_3;
             const walberla::float64 elMat_3_3 = q_acc_3_3;
             const walberla::float64 elMat_3_4 = q_acc_3_4;
             const walberla::float64 elMat_3_5 = q_acc_3_5;
             const walberla::float64 elMat_4_0 = q_acc_0_4;
             const walberla::float64 elMat_4_1 = q_acc_1_4;
             const walberla::float64 elMat_4_2 = q_acc_2_4;
             const walberla::float64 elMat_4_3 = q_acc_3_4;
             const walberla::float64 elMat_4_4 = q_acc_4_4;
             const walberla::float64 elMat_4_5 = q_acc_4_5;
             const walberla::float64 elMat_5_0 = q_acc_0_5;
             const walberla::float64 elMat_5_1 = q_acc_1_5;
             const walberla::float64 elMat_5_2 = q_acc_2_5;
             const walberla::float64 elMat_5_3 = q_acc_3_5;
             const walberla::float64 elMat_5_4 = q_acc_4_5;
             const walberla::float64 elMat_5_5 = q_acc_5_5;
         
             std::vector< uint_t > _data_rowIdx( 6 );
             std::vector< uint_t > _data_colIdx( 6 );
             std::vector< walberla::float64 > _data_mat( 36 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[1] = ((uint64_t)(_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[2] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[3] = ((uint64_t)(_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dst[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dst[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[1] = ((uint64_t)(_data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[2] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[3] = ((uint64_t)(_data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[4] = ((uint64_t)(_data_src[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[5] = ((uint64_t)(_data_src[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
         
             /* Apply basis transformation */
         
             const Eigen::DiagonalMatrix< real_t, 6 > basisTransformation = n1e1::macrocell::basisTransformation( level, cell, {ctr_0, ctr_1, ctr_2}, celldof::CellType::GREEN_DOWN );
         
             _data_mat[0] = ((walberla::float64)((basisTransformation.diagonal()(0)*basisTransformation.diagonal()(0))*elMat_0_0));
             _data_mat[1] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(1)*elMat_0_1));
             _data_mat[2] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(2)*elMat_0_2));
             _data_mat[3] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(3)*elMat_0_3));
             _data_mat[4] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(4)*elMat_0_4));
             _data_mat[5] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(5)*elMat_0_5));
             _data_mat[6] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(1)*elMat_1_0));
             _data_mat[7] = ((walberla::float64)((basisTransformation.diagonal()(1)*basisTransformation.diagonal()(1))*elMat_1_1));
             _data_mat[8] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(2)*elMat_1_2));
             _data_mat[9] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(3)*elMat_1_3));
             _data_mat[10] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(4)*elMat_1_4));
             _data_mat[11] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(5)*elMat_1_5));
             _data_mat[12] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(2)*elMat_2_0));
             _data_mat[13] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(2)*elMat_2_1));
             _data_mat[14] = ((walberla::float64)((basisTransformation.diagonal()(2)*basisTransformation.diagonal()(2))*elMat_2_2));
             _data_mat[15] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(3)*elMat_2_3));
             _data_mat[16] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(4)*elMat_2_4));
             _data_mat[17] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(5)*elMat_2_5));
             _data_mat[18] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(3)*elMat_3_0));
             _data_mat[19] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(3)*elMat_3_1));
             _data_mat[20] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(3)*elMat_3_2));
             _data_mat[21] = ((walberla::float64)((basisTransformation.diagonal()(3)*basisTransformation.diagonal()(3))*elMat_3_3));
             _data_mat[22] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(4)*elMat_3_4));
             _data_mat[23] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(5)*elMat_3_5));
             _data_mat[24] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(4)*elMat_4_0));
             _data_mat[25] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(4)*elMat_4_1));
             _data_mat[26] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(4)*elMat_4_2));
             _data_mat[27] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(4)*elMat_4_3));
             _data_mat[28] = ((walberla::float64)((basisTransformation.diagonal()(4)*basisTransformation.diagonal()(4))*elMat_4_4));
             _data_mat[29] = ((walberla::float64)(basisTransformation.diagonal()(4)*basisTransformation.diagonal()(5)*elMat_4_5));
             _data_mat[30] = ((walberla::float64)(basisTransformation.diagonal()(0)*basisTransformation.diagonal()(5)*elMat_5_0));
             _data_mat[31] = ((walberla::float64)(basisTransformation.diagonal()(1)*basisTransformation.diagonal()(5)*elMat_5_1));
             _data_mat[32] = ((walberla::float64)(basisTransformation.diagonal()(2)*basisTransformation.diagonal()(5)*elMat_5_2));
             _data_mat[33] = ((walberla::float64)(basisTransformation.diagonal()(3)*basisTransformation.diagonal()(5)*elMat_5_3));
             _data_mat[34] = ((walberla::float64)(basisTransformation.diagonal()(4)*basisTransformation.diagonal()(5)*elMat_5_4));
             _data_mat[35] = ((walberla::float64)((basisTransformation.diagonal()(5)*basisTransformation.diagonal()(5))*elMat_5_5));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
