/*
* Copyright (c) 2017-2024 Nils Kohl, Daniel Bauer, Fabian Böhm.
*
* This file is part of HyTeG
* (see https://i10git.cs.fau.de/hyteg/hyteg).
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
* The entire file was generated with the HyTeG form generator.
*
* Avoid modifying this file. If buggy, consider fixing the generator itself.
*/

























#include "../P2ElementwiseDivKGrad.hpp"

#define FUNC_PREFIX  

namespace hyteg {

namespace operatorgeneration {

void P2ElementwiseDivKGrad::toMatrix_macro_3D( idx_t * RESTRICT  _data_dstEdge, idx_t * RESTRICT  _data_dstVertex, walberla::float64 * RESTRICT  _data_kEdge, walberla::float64 * RESTRICT  _data_kVertex, idx_t * RESTRICT  _data_srcEdge, idx_t * RESTRICT  _data_srcVertex, walberla::float64 macro_vertex_coord_id_0comp0, walberla::float64 macro_vertex_coord_id_0comp1, walberla::float64 macro_vertex_coord_id_0comp2, walberla::float64 macro_vertex_coord_id_1comp0, walberla::float64 macro_vertex_coord_id_1comp1, walberla::float64 macro_vertex_coord_id_1comp2, walberla::float64 macro_vertex_coord_id_2comp0, walberla::float64 macro_vertex_coord_id_2comp1, walberla::float64 macro_vertex_coord_id_2comp2, walberla::float64 macro_vertex_coord_id_3comp0, walberla::float64 macro_vertex_coord_id_3comp1, walberla::float64 macro_vertex_coord_id_3comp2, std::shared_ptr< SparseMatrixProxy > mat, int64_t micro_edges_per_macro_edge, walberla::float64 micro_edges_per_macro_edge_float ) const
{
    {
       const walberla::float64 _data_q_w [] = {0.041666666666666657, 0.041666666666666657, 0.041666666666666657, 0.041666666666666657};
   
       const walberla::float64 _data_q_p_0 [] = {0.1381966011250105, 0.1381966011250105, 0.5854101966249684, 0.1381966011250105};
   
       const walberla::float64 _data_q_p_1 [] = {0.1381966011250105, 0.5854101966249684, 0.1381966011250105, 0.1381966011250105};
   
       const walberla::float64 _data_q_p_2 [] = {0.5854101966249684, 0.1381966011250105, 0.1381966011250105, 0.1381966011250105};
   
       const walberla::float64 tmp_coords_jac_0_WHITE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const walberla::float64 p_affine_const_0_0_WHITE_UP = macro_vertex_coord_id_0comp0;
       const walberla::float64 p_affine_const_0_1_WHITE_UP = macro_vertex_coord_id_0comp1;
       const walberla::float64 p_affine_const_0_2_WHITE_UP = macro_vertex_coord_id_0comp2;
       const walberla::float64 p_affine_const_1_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const walberla::float64 p_affine_const_1_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const walberla::float64 p_affine_const_1_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const walberla::float64 p_affine_const_2_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const walberla::float64 p_affine_const_2_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const walberla::float64 p_affine_const_2_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const walberla::float64 p_affine_const_3_0_WHITE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const walberla::float64 p_affine_const_3_1_WHITE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const walberla::float64 p_affine_const_3_2_WHITE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const walberla::float64 jac_affine_0_0_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_1_0_WHITE_UP;
       const walberla::float64 jac_affine_0_1_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_2_0_WHITE_UP;
       const walberla::float64 jac_affine_0_2_WHITE_UP = -p_affine_const_0_0_WHITE_UP + p_affine_const_3_0_WHITE_UP;
       const walberla::float64 jac_affine_1_0_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_1_1_WHITE_UP;
       const walberla::float64 jac_affine_1_1_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_2_1_WHITE_UP;
       const walberla::float64 tmp_coords_jac_5_WHITE_UP = jac_affine_0_2_WHITE_UP*jac_affine_1_1_WHITE_UP;
       const walberla::float64 jac_affine_1_2_WHITE_UP = -p_affine_const_0_1_WHITE_UP + p_affine_const_3_1_WHITE_UP;
       const walberla::float64 tmp_coords_jac_3_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_1_2_WHITE_UP;
       const walberla::float64 jac_affine_2_0_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_1_2_WHITE_UP;
       const walberla::float64 jac_affine_2_1_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_2_2_WHITE_UP;
       const walberla::float64 tmp_coords_jac_2_WHITE_UP = jac_affine_1_2_WHITE_UP*jac_affine_2_1_WHITE_UP;
       const walberla::float64 jac_affine_2_2_WHITE_UP = -p_affine_const_0_2_WHITE_UP + p_affine_const_3_2_WHITE_UP;
       const walberla::float64 tmp_coords_jac_1_WHITE_UP = jac_affine_1_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const walberla::float64 tmp_coords_jac_4_WHITE_UP = jac_affine_0_1_WHITE_UP*jac_affine_2_2_WHITE_UP;
       const walberla::float64 tmp_coords_jac_6_WHITE_UP = jac_affine_0_0_WHITE_UP*tmp_coords_jac_1_WHITE_UP - jac_affine_0_0_WHITE_UP*tmp_coords_jac_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_0_WHITE_UP*tmp_coords_jac_4_WHITE_UP + jac_affine_2_0_WHITE_UP*tmp_coords_jac_3_WHITE_UP - jac_affine_2_0_WHITE_UP*tmp_coords_jac_5_WHITE_UP;
       const walberla::float64 tmp_coords_jac_7_WHITE_UP = 1.0 / (tmp_coords_jac_6_WHITE_UP);
       const walberla::float64 jac_affine_inv_0_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_1_WHITE_UP - tmp_coords_jac_2_WHITE_UP);
       const walberla::float64 jac_affine_inv_0_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_2_WHITE_UP*jac_affine_2_1_WHITE_UP - tmp_coords_jac_4_WHITE_UP);
       const walberla::float64 jac_affine_inv_0_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(tmp_coords_jac_3_WHITE_UP - tmp_coords_jac_5_WHITE_UP);
       const walberla::float64 jac_affine_inv_1_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_1_0_WHITE_UP*jac_affine_2_2_WHITE_UP + jac_affine_1_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const walberla::float64 jac_affine_inv_1_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_2_2_WHITE_UP - jac_affine_0_2_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const walberla::float64 jac_affine_inv_1_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_1_2_WHITE_UP + jac_affine_0_2_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const walberla::float64 jac_affine_inv_2_0_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_1_0_WHITE_UP*jac_affine_2_1_WHITE_UP - jac_affine_1_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const walberla::float64 jac_affine_inv_2_1_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(-jac_affine_0_0_WHITE_UP*jac_affine_2_1_WHITE_UP + jac_affine_0_1_WHITE_UP*jac_affine_2_0_WHITE_UP);
       const walberla::float64 jac_affine_inv_2_2_WHITE_UP = tmp_coords_jac_7_WHITE_UP*(jac_affine_0_0_WHITE_UP*jac_affine_1_1_WHITE_UP - jac_affine_0_1_WHITE_UP*jac_affine_1_0_WHITE_UP);
       const walberla::float64 abs_det_jac_affine_WHITE_UP = abs(tmp_coords_jac_6_WHITE_UP);
       {
          /* CellType.WHITE_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge; ctr_0 += 1)
          {
             const walberla::float64 k_dof_0 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 k_dof_1 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 k_dof_2 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 k_dof_3 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 k_dof_4 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const walberla::float64 k_dof_5 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const walberla::float64 k_dof_6 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const walberla::float64 k_dof_7 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const walberla::float64 k_dof_8 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const walberla::float64 k_dof_9 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             walberla::float64 q_acc_0_0 = 0.0;
             walberla::float64 q_acc_0_1 = 0.0;
             walberla::float64 q_acc_0_2 = 0.0;
             walberla::float64 q_acc_0_3 = 0.0;
             walberla::float64 q_acc_0_4 = 0.0;
             walberla::float64 q_acc_0_5 = 0.0;
             walberla::float64 q_acc_0_6 = 0.0;
             walberla::float64 q_acc_0_7 = 0.0;
             walberla::float64 q_acc_0_8 = 0.0;
             walberla::float64 q_acc_0_9 = 0.0;
             walberla::float64 q_acc_1_1 = 0.0;
             walberla::float64 q_acc_1_2 = 0.0;
             walberla::float64 q_acc_1_3 = 0.0;
             walberla::float64 q_acc_1_4 = 0.0;
             walberla::float64 q_acc_1_5 = 0.0;
             walberla::float64 q_acc_1_6 = 0.0;
             walberla::float64 q_acc_1_7 = 0.0;
             walberla::float64 q_acc_1_8 = 0.0;
             walberla::float64 q_acc_1_9 = 0.0;
             walberla::float64 q_acc_2_2 = 0.0;
             walberla::float64 q_acc_2_3 = 0.0;
             walberla::float64 q_acc_2_4 = 0.0;
             walberla::float64 q_acc_2_5 = 0.0;
             walberla::float64 q_acc_2_6 = 0.0;
             walberla::float64 q_acc_2_7 = 0.0;
             walberla::float64 q_acc_2_8 = 0.0;
             walberla::float64 q_acc_2_9 = 0.0;
             walberla::float64 q_acc_3_3 = 0.0;
             walberla::float64 q_acc_3_4 = 0.0;
             walberla::float64 q_acc_3_5 = 0.0;
             walberla::float64 q_acc_3_6 = 0.0;
             walberla::float64 q_acc_3_7 = 0.0;
             walberla::float64 q_acc_3_8 = 0.0;
             walberla::float64 q_acc_3_9 = 0.0;
             walberla::float64 q_acc_4_4 = 0.0;
             walberla::float64 q_acc_4_5 = 0.0;
             walberla::float64 q_acc_4_6 = 0.0;
             walberla::float64 q_acc_4_7 = 0.0;
             walberla::float64 q_acc_4_8 = 0.0;
             walberla::float64 q_acc_4_9 = 0.0;
             walberla::float64 q_acc_5_5 = 0.0;
             walberla::float64 q_acc_5_6 = 0.0;
             walberla::float64 q_acc_5_7 = 0.0;
             walberla::float64 q_acc_5_8 = 0.0;
             walberla::float64 q_acc_5_9 = 0.0;
             walberla::float64 q_acc_6_6 = 0.0;
             walberla::float64 q_acc_6_7 = 0.0;
             walberla::float64 q_acc_6_8 = 0.0;
             walberla::float64 q_acc_6_9 = 0.0;
             walberla::float64 q_acc_7_7 = 0.0;
             walberla::float64 q_acc_7_8 = 0.0;
             walberla::float64 q_acc_7_9 = 0.0;
             walberla::float64 q_acc_8_8 = 0.0;
             walberla::float64 q_acc_8_9 = 0.0;
             walberla::float64 q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const walberla::float64 tmp_qloop_0 = 4.0*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_1 = 4.0*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_2 = 4.0*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_3 = tmp_qloop_1 + tmp_qloop_2;
                const walberla::float64 tmp_qloop_4 = tmp_qloop_0 + tmp_qloop_3 - 3.0;
                const walberla::float64 tmp_qloop_5 = jac_affine_inv_0_0_WHITE_UP*tmp_qloop_4 + jac_affine_inv_1_0_WHITE_UP*tmp_qloop_4 + jac_affine_inv_2_0_WHITE_UP*tmp_qloop_4;
                const walberla::float64 tmp_qloop_6 = jac_affine_inv_0_1_WHITE_UP*tmp_qloop_4 + jac_affine_inv_1_1_WHITE_UP*tmp_qloop_4 + jac_affine_inv_2_1_WHITE_UP*tmp_qloop_4;
                const walberla::float64 tmp_qloop_7 = jac_affine_inv_0_2_WHITE_UP*tmp_qloop_4 + jac_affine_inv_1_2_WHITE_UP*tmp_qloop_4 + jac_affine_inv_2_2_WHITE_UP*tmp_qloop_4;
                const walberla::float64 tmp_qloop_8 = tmp_qloop_1*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_9 = tmp_qloop_1*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_10 = tmp_qloop_2*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_11 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const walberla::float64 tmp_qloop_12 = tmp_qloop_11*2.0;
                const walberla::float64 tmp_qloop_13 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const walberla::float64 tmp_qloop_14 = tmp_qloop_13*2.0;
                const walberla::float64 tmp_qloop_15 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const walberla::float64 tmp_qloop_16 = tmp_qloop_15*2.0;
                const walberla::float64 tmp_qloop_17 = tmp_qloop_8 + tmp_qloop_9;
                const walberla::float64 tmp_qloop_18 = abs_det_jac_affine_WHITE_UP*(k_dof_0*(tmp_qloop_10 + tmp_qloop_12 + tmp_qloop_14 + tmp_qloop_16 + tmp_qloop_17 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0) + k_dof_1*(tmp_qloop_12 - _data_q_p_0[q]) + k_dof_2*(tmp_qloop_14 - _data_q_p_1[q]) + k_dof_3*(tmp_qloop_16 - _data_q_p_2[q]) + k_dof_4*tmp_qloop_10 + k_dof_5*tmp_qloop_9 + k_dof_6*tmp_qloop_8 + k_dof_7*(tmp_qloop_0 - tmp_qloop_10 + tmp_qloop_15*-4.0 - tmp_qloop_9) + k_dof_8*(-tmp_qloop_10 + tmp_qloop_13*-4.0 + tmp_qloop_2 - tmp_qloop_8) + k_dof_9*(tmp_qloop_1 + tmp_qloop_11*-4.0 - tmp_qloop_17))*_data_q_w[q];
                const walberla::float64 tmp_qloop_19 = tmp_qloop_1 - 1.0;
                const walberla::float64 tmp_qloop_20 = jac_affine_inv_0_0_WHITE_UP*tmp_qloop_19;
                const walberla::float64 tmp_qloop_21 = jac_affine_inv_0_1_WHITE_UP*tmp_qloop_19;
                const walberla::float64 tmp_qloop_22 = jac_affine_inv_0_2_WHITE_UP*tmp_qloop_19;
                const walberla::float64 tmp_qloop_23 = tmp_qloop_2 - 1.0;
                const walberla::float64 tmp_qloop_24 = jac_affine_inv_1_0_WHITE_UP*tmp_qloop_23;
                const walberla::float64 tmp_qloop_25 = jac_affine_inv_1_1_WHITE_UP*tmp_qloop_23;
                const walberla::float64 tmp_qloop_26 = jac_affine_inv_1_2_WHITE_UP*tmp_qloop_23;
                const walberla::float64 tmp_qloop_27 = tmp_qloop_0 - 1.0;
                const walberla::float64 tmp_qloop_28 = jac_affine_inv_2_0_WHITE_UP*tmp_qloop_27;
                const walberla::float64 tmp_qloop_29 = jac_affine_inv_2_1_WHITE_UP*tmp_qloop_27;
                const walberla::float64 tmp_qloop_30 = jac_affine_inv_2_2_WHITE_UP*tmp_qloop_27;
                const walberla::float64 tmp_qloop_31 = jac_affine_inv_2_0_WHITE_UP*tmp_qloop_2;
                const walberla::float64 tmp_qloop_32 = jac_affine_inv_1_0_WHITE_UP*tmp_qloop_0;
                const walberla::float64 tmp_qloop_33 = tmp_qloop_31 + tmp_qloop_32;
                const walberla::float64 tmp_qloop_34 = jac_affine_inv_2_1_WHITE_UP*tmp_qloop_2;
                const walberla::float64 tmp_qloop_35 = jac_affine_inv_1_1_WHITE_UP*tmp_qloop_0;
                const walberla::float64 tmp_qloop_36 = tmp_qloop_34 + tmp_qloop_35;
                const walberla::float64 tmp_qloop_37 = jac_affine_inv_2_2_WHITE_UP*tmp_qloop_2;
                const walberla::float64 tmp_qloop_38 = jac_affine_inv_1_2_WHITE_UP*tmp_qloop_0;
                const walberla::float64 tmp_qloop_39 = tmp_qloop_37 + tmp_qloop_38;
                const walberla::float64 tmp_qloop_40 = jac_affine_inv_2_0_WHITE_UP*tmp_qloop_1;
                const walberla::float64 tmp_qloop_41 = jac_affine_inv_0_0_WHITE_UP*tmp_qloop_0;
                const walberla::float64 tmp_qloop_42 = tmp_qloop_40 + tmp_qloop_41;
                const walberla::float64 tmp_qloop_43 = jac_affine_inv_2_1_WHITE_UP*tmp_qloop_1;
                const walberla::float64 tmp_qloop_44 = jac_affine_inv_0_1_WHITE_UP*tmp_qloop_0;
                const walberla::float64 tmp_qloop_45 = tmp_qloop_43 + tmp_qloop_44;
                const walberla::float64 tmp_qloop_46 = jac_affine_inv_2_2_WHITE_UP*tmp_qloop_1;
                const walberla::float64 tmp_qloop_47 = jac_affine_inv_0_2_WHITE_UP*tmp_qloop_0;
                const walberla::float64 tmp_qloop_48 = tmp_qloop_46 + tmp_qloop_47;
                const walberla::float64 tmp_qloop_49 = jac_affine_inv_1_0_WHITE_UP*tmp_qloop_1;
                const walberla::float64 tmp_qloop_50 = jac_affine_inv_0_0_WHITE_UP*tmp_qloop_2;
                const walberla::float64 tmp_qloop_51 = tmp_qloop_49 + tmp_qloop_50;
                const walberla::float64 tmp_qloop_52 = jac_affine_inv_1_1_WHITE_UP*tmp_qloop_1;
                const walberla::float64 tmp_qloop_53 = jac_affine_inv_0_1_WHITE_UP*tmp_qloop_2;
                const walberla::float64 tmp_qloop_54 = tmp_qloop_52 + tmp_qloop_53;
                const walberla::float64 tmp_qloop_55 = jac_affine_inv_1_2_WHITE_UP*tmp_qloop_1;
                const walberla::float64 tmp_qloop_56 = jac_affine_inv_0_2_WHITE_UP*tmp_qloop_2;
                const walberla::float64 tmp_qloop_57 = tmp_qloop_55 + tmp_qloop_56;
                const walberla::float64 tmp_qloop_58 = -tmp_qloop_3 - 8.0*_data_q_p_2[q] + 4.0;
                const walberla::float64 tmp_qloop_59 = jac_affine_inv_2_0_WHITE_UP*tmp_qloop_58 - tmp_qloop_32 - tmp_qloop_41;
                const walberla::float64 tmp_qloop_60 = jac_affine_inv_2_1_WHITE_UP*tmp_qloop_58 - tmp_qloop_35 - tmp_qloop_44;
                const walberla::float64 tmp_qloop_61 = jac_affine_inv_2_2_WHITE_UP*tmp_qloop_58 - tmp_qloop_38 - tmp_qloop_47;
                const walberla::float64 tmp_qloop_62 = tmp_qloop_0 - 4.0;
                const walberla::float64 tmp_qloop_63 = -tmp_qloop_1 - tmp_qloop_62 - 8.0*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_64 = jac_affine_inv_1_0_WHITE_UP*tmp_qloop_63 - tmp_qloop_31 - tmp_qloop_50;
                const walberla::float64 tmp_qloop_65 = jac_affine_inv_1_1_WHITE_UP*tmp_qloop_63 - tmp_qloop_34 - tmp_qloop_53;
                const walberla::float64 tmp_qloop_66 = jac_affine_inv_1_2_WHITE_UP*tmp_qloop_63 - tmp_qloop_37 - tmp_qloop_56;
                const walberla::float64 tmp_qloop_67 = -tmp_qloop_2 - tmp_qloop_62 - 8.0*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_68 = jac_affine_inv_0_0_WHITE_UP*tmp_qloop_67 - tmp_qloop_40 - tmp_qloop_49;
                const walberla::float64 tmp_qloop_69 = jac_affine_inv_0_1_WHITE_UP*tmp_qloop_67 - tmp_qloop_43 - tmp_qloop_52;
                const walberla::float64 tmp_qloop_70 = jac_affine_inv_0_2_WHITE_UP*tmp_qloop_67 - tmp_qloop_46 - tmp_qloop_55;
                const walberla::float64 tmp_qloop_71 = ((-0.25 + _data_q_p_0[q])*(-0.25 + _data_q_p_0[q]))*16.0;
                const walberla::float64 tmp_qloop_72 = ((-0.25 + _data_q_p_1[q])*(-0.25 + _data_q_p_1[q]))*16.0;
                const walberla::float64 tmp_qloop_73 = ((-0.25 + _data_q_p_2[q])*(-0.25 + _data_q_p_2[q]))*16.0;
                const walberla::float64 tmp_qloop_74 = jac_affine_inv_2_0_WHITE_UP*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_75 = jac_affine_inv_1_0_WHITE_UP*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_76 = jac_affine_inv_2_1_WHITE_UP*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_77 = jac_affine_inv_1_1_WHITE_UP*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_78 = jac_affine_inv_2_2_WHITE_UP*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_79 = jac_affine_inv_1_2_WHITE_UP*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_80 = jac_affine_inv_2_0_WHITE_UP*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_81 = jac_affine_inv_0_0_WHITE_UP*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_82 = jac_affine_inv_2_1_WHITE_UP*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_83 = jac_affine_inv_0_1_WHITE_UP*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_84 = jac_affine_inv_2_2_WHITE_UP*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_85 = jac_affine_inv_0_2_WHITE_UP*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_86 = jac_affine_inv_1_0_WHITE_UP*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_87 = jac_affine_inv_0_0_WHITE_UP*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_88 = jac_affine_inv_1_1_WHITE_UP*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_89 = jac_affine_inv_0_1_WHITE_UP*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_90 = jac_affine_inv_1_2_WHITE_UP*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_91 = jac_affine_inv_0_2_WHITE_UP*_data_q_p_1[q];
                const walberla::float64 q_tmp_0_0 = tmp_qloop_18*((tmp_qloop_5*tmp_qloop_5) + (tmp_qloop_6*tmp_qloop_6) + (tmp_qloop_7*tmp_qloop_7));
                const walberla::float64 q_tmp_0_1 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_5 + tmp_qloop_21*tmp_qloop_6 + tmp_qloop_22*tmp_qloop_7);
                const walberla::float64 q_tmp_0_2 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_5 + tmp_qloop_25*tmp_qloop_6 + tmp_qloop_26*tmp_qloop_7);
                const walberla::float64 q_tmp_0_3 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_5 + tmp_qloop_29*tmp_qloop_6 + tmp_qloop_30*tmp_qloop_7);
                const walberla::float64 q_tmp_0_4 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_5 + tmp_qloop_36*tmp_qloop_6 + tmp_qloop_39*tmp_qloop_7);
                const walberla::float64 q_tmp_0_5 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_5 + tmp_qloop_45*tmp_qloop_6 + tmp_qloop_48*tmp_qloop_7);
                const walberla::float64 q_tmp_0_6 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_51 + tmp_qloop_54*tmp_qloop_6 + tmp_qloop_57*tmp_qloop_7);
                const walberla::float64 q_tmp_0_7 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_59 + tmp_qloop_6*tmp_qloop_60 + tmp_qloop_61*tmp_qloop_7);
                const walberla::float64 q_tmp_0_8 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_64 + tmp_qloop_6*tmp_qloop_65 + tmp_qloop_66*tmp_qloop_7);
                const walberla::float64 q_tmp_0_9 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_68 + tmp_qloop_6*tmp_qloop_69 + tmp_qloop_7*tmp_qloop_70);
                const walberla::float64 q_tmp_1_1 = tmp_qloop_18*((jac_affine_inv_0_0_WHITE_UP*jac_affine_inv_0_0_WHITE_UP)*tmp_qloop_71 + (jac_affine_inv_0_1_WHITE_UP*jac_affine_inv_0_1_WHITE_UP)*tmp_qloop_71 + (jac_affine_inv_0_2_WHITE_UP*jac_affine_inv_0_2_WHITE_UP)*tmp_qloop_71);
                const walberla::float64 q_tmp_1_2 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_24 + tmp_qloop_21*tmp_qloop_25 + tmp_qloop_22*tmp_qloop_26);
                const walberla::float64 q_tmp_1_3 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_28 + tmp_qloop_21*tmp_qloop_29 + tmp_qloop_22*tmp_qloop_30);
                const walberla::float64 q_tmp_1_4 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_33 + tmp_qloop_21*tmp_qloop_36 + tmp_qloop_22*tmp_qloop_39);
                const walberla::float64 q_tmp_1_5 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_42 + tmp_qloop_21*tmp_qloop_45 + tmp_qloop_22*tmp_qloop_48);
                const walberla::float64 q_tmp_1_6 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_51 + tmp_qloop_21*tmp_qloop_54 + tmp_qloop_22*tmp_qloop_57);
                const walberla::float64 q_tmp_1_7 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_59 + tmp_qloop_21*tmp_qloop_60 + tmp_qloop_22*tmp_qloop_61);
                const walberla::float64 q_tmp_1_8 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_64 + tmp_qloop_21*tmp_qloop_65 + tmp_qloop_22*tmp_qloop_66);
                const walberla::float64 q_tmp_1_9 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_68 + tmp_qloop_21*tmp_qloop_69 + tmp_qloop_22*tmp_qloop_70);
                const walberla::float64 q_tmp_2_2 = tmp_qloop_18*((jac_affine_inv_1_0_WHITE_UP*jac_affine_inv_1_0_WHITE_UP)*tmp_qloop_72 + (jac_affine_inv_1_1_WHITE_UP*jac_affine_inv_1_1_WHITE_UP)*tmp_qloop_72 + (jac_affine_inv_1_2_WHITE_UP*jac_affine_inv_1_2_WHITE_UP)*tmp_qloop_72);
                const walberla::float64 q_tmp_2_3 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_28 + tmp_qloop_25*tmp_qloop_29 + tmp_qloop_26*tmp_qloop_30);
                const walberla::float64 q_tmp_2_4 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_33 + tmp_qloop_25*tmp_qloop_36 + tmp_qloop_26*tmp_qloop_39);
                const walberla::float64 q_tmp_2_5 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_42 + tmp_qloop_25*tmp_qloop_45 + tmp_qloop_26*tmp_qloop_48);
                const walberla::float64 q_tmp_2_6 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_51 + tmp_qloop_25*tmp_qloop_54 + tmp_qloop_26*tmp_qloop_57);
                const walberla::float64 q_tmp_2_7 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_59 + tmp_qloop_25*tmp_qloop_60 + tmp_qloop_26*tmp_qloop_61);
                const walberla::float64 q_tmp_2_8 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_64 + tmp_qloop_25*tmp_qloop_65 + tmp_qloop_26*tmp_qloop_66);
                const walberla::float64 q_tmp_2_9 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_68 + tmp_qloop_25*tmp_qloop_69 + tmp_qloop_26*tmp_qloop_70);
                const walberla::float64 q_tmp_3_3 = tmp_qloop_18*((jac_affine_inv_2_0_WHITE_UP*jac_affine_inv_2_0_WHITE_UP)*tmp_qloop_73 + (jac_affine_inv_2_1_WHITE_UP*jac_affine_inv_2_1_WHITE_UP)*tmp_qloop_73 + (jac_affine_inv_2_2_WHITE_UP*jac_affine_inv_2_2_WHITE_UP)*tmp_qloop_73);
                const walberla::float64 q_tmp_3_4 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_33 + tmp_qloop_29*tmp_qloop_36 + tmp_qloop_30*tmp_qloop_39);
                const walberla::float64 q_tmp_3_5 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_42 + tmp_qloop_29*tmp_qloop_45 + tmp_qloop_30*tmp_qloop_48);
                const walberla::float64 q_tmp_3_6 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_51 + tmp_qloop_29*tmp_qloop_54 + tmp_qloop_30*tmp_qloop_57);
                const walberla::float64 q_tmp_3_7 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_59 + tmp_qloop_29*tmp_qloop_60 + tmp_qloop_30*tmp_qloop_61);
                const walberla::float64 q_tmp_3_8 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_64 + tmp_qloop_29*tmp_qloop_65 + tmp_qloop_30*tmp_qloop_66);
                const walberla::float64 q_tmp_3_9 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_68 + tmp_qloop_29*tmp_qloop_69 + tmp_qloop_30*tmp_qloop_70);
                const walberla::float64 q_tmp_4_4 = tmp_qloop_18*(((tmp_qloop_74 + tmp_qloop_75)*(tmp_qloop_74 + tmp_qloop_75))*16.0 + ((tmp_qloop_76 + tmp_qloop_77)*(tmp_qloop_76 + tmp_qloop_77))*16.0 + ((tmp_qloop_78 + tmp_qloop_79)*(tmp_qloop_78 + tmp_qloop_79))*16.0);
                const walberla::float64 q_tmp_4_5 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_42 + tmp_qloop_36*tmp_qloop_45 + tmp_qloop_39*tmp_qloop_48);
                const walberla::float64 q_tmp_4_6 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_51 + tmp_qloop_36*tmp_qloop_54 + tmp_qloop_39*tmp_qloop_57);
                const walberla::float64 q_tmp_4_7 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_59 + tmp_qloop_36*tmp_qloop_60 + tmp_qloop_39*tmp_qloop_61);
                const walberla::float64 q_tmp_4_8 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_64 + tmp_qloop_36*tmp_qloop_65 + tmp_qloop_39*tmp_qloop_66);
                const walberla::float64 q_tmp_4_9 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_68 + tmp_qloop_36*tmp_qloop_69 + tmp_qloop_39*tmp_qloop_70);
                const walberla::float64 q_tmp_5_5 = tmp_qloop_18*(((tmp_qloop_80 + tmp_qloop_81)*(tmp_qloop_80 + tmp_qloop_81))*16.0 + ((tmp_qloop_82 + tmp_qloop_83)*(tmp_qloop_82 + tmp_qloop_83))*16.0 + ((tmp_qloop_84 + tmp_qloop_85)*(tmp_qloop_84 + tmp_qloop_85))*16.0);
                const walberla::float64 q_tmp_5_6 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_51 + tmp_qloop_45*tmp_qloop_54 + tmp_qloop_48*tmp_qloop_57);
                const walberla::float64 q_tmp_5_7 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_59 + tmp_qloop_45*tmp_qloop_60 + tmp_qloop_48*tmp_qloop_61);
                const walberla::float64 q_tmp_5_8 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_64 + tmp_qloop_45*tmp_qloop_65 + tmp_qloop_48*tmp_qloop_66);
                const walberla::float64 q_tmp_5_9 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_68 + tmp_qloop_45*tmp_qloop_69 + tmp_qloop_48*tmp_qloop_70);
                const walberla::float64 q_tmp_6_6 = tmp_qloop_18*(((tmp_qloop_86 + tmp_qloop_87)*(tmp_qloop_86 + tmp_qloop_87))*16.0 + ((tmp_qloop_88 + tmp_qloop_89)*(tmp_qloop_88 + tmp_qloop_89))*16.0 + ((tmp_qloop_90 + tmp_qloop_91)*(tmp_qloop_90 + tmp_qloop_91))*16.0);
                const walberla::float64 q_tmp_6_7 = tmp_qloop_18*(tmp_qloop_51*tmp_qloop_59 + tmp_qloop_54*tmp_qloop_60 + tmp_qloop_57*tmp_qloop_61);
                const walberla::float64 q_tmp_6_8 = tmp_qloop_18*(tmp_qloop_51*tmp_qloop_64 + tmp_qloop_54*tmp_qloop_65 + tmp_qloop_57*tmp_qloop_66);
                const walberla::float64 q_tmp_6_9 = tmp_qloop_18*(tmp_qloop_51*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_57*tmp_qloop_70);
                const walberla::float64 q_tmp_7_7 = tmp_qloop_18*(((jac_affine_inv_2_0_WHITE_UP*tmp_qloop_58*0.25 - tmp_qloop_75 - tmp_qloop_81)*(jac_affine_inv_2_0_WHITE_UP*tmp_qloop_58*0.25 - tmp_qloop_75 - tmp_qloop_81))*16.0 + ((jac_affine_inv_2_1_WHITE_UP*tmp_qloop_58*0.25 - tmp_qloop_77 - tmp_qloop_83)*(jac_affine_inv_2_1_WHITE_UP*tmp_qloop_58*0.25 - tmp_qloop_77 - tmp_qloop_83))*16.0 + ((jac_affine_inv_2_2_WHITE_UP*tmp_qloop_58*0.25 - tmp_qloop_79 - tmp_qloop_85)*(jac_affine_inv_2_2_WHITE_UP*tmp_qloop_58*0.25 - tmp_qloop_79 - tmp_qloop_85))*16.0);
                const walberla::float64 q_tmp_7_8 = tmp_qloop_18*(tmp_qloop_59*tmp_qloop_64 + tmp_qloop_60*tmp_qloop_65 + tmp_qloop_61*tmp_qloop_66);
                const walberla::float64 q_tmp_7_9 = tmp_qloop_18*(tmp_qloop_59*tmp_qloop_68 + tmp_qloop_60*tmp_qloop_69 + tmp_qloop_61*tmp_qloop_70);
                const walberla::float64 q_tmp_8_8 = tmp_qloop_18*(((jac_affine_inv_1_0_WHITE_UP*tmp_qloop_63*0.25 - tmp_qloop_74 - tmp_qloop_87)*(jac_affine_inv_1_0_WHITE_UP*tmp_qloop_63*0.25 - tmp_qloop_74 - tmp_qloop_87))*16.0 + ((jac_affine_inv_1_1_WHITE_UP*tmp_qloop_63*0.25 - tmp_qloop_76 - tmp_qloop_89)*(jac_affine_inv_1_1_WHITE_UP*tmp_qloop_63*0.25 - tmp_qloop_76 - tmp_qloop_89))*16.0 + ((jac_affine_inv_1_2_WHITE_UP*tmp_qloop_63*0.25 - tmp_qloop_78 - tmp_qloop_91)*(jac_affine_inv_1_2_WHITE_UP*tmp_qloop_63*0.25 - tmp_qloop_78 - tmp_qloop_91))*16.0);
                const walberla::float64 q_tmp_8_9 = tmp_qloop_18*(tmp_qloop_64*tmp_qloop_68 + tmp_qloop_65*tmp_qloop_69 + tmp_qloop_66*tmp_qloop_70);
                const walberla::float64 q_tmp_9_9 = tmp_qloop_18*(((jac_affine_inv_0_0_WHITE_UP*tmp_qloop_67*0.25 - tmp_qloop_80 - tmp_qloop_86)*(jac_affine_inv_0_0_WHITE_UP*tmp_qloop_67*0.25 - tmp_qloop_80 - tmp_qloop_86))*16.0 + ((jac_affine_inv_0_1_WHITE_UP*tmp_qloop_67*0.25 - tmp_qloop_82 - tmp_qloop_88)*(jac_affine_inv_0_1_WHITE_UP*tmp_qloop_67*0.25 - tmp_qloop_82 - tmp_qloop_88))*16.0 + ((jac_affine_inv_0_2_WHITE_UP*tmp_qloop_67*0.25 - tmp_qloop_84 - tmp_qloop_90)*(jac_affine_inv_0_2_WHITE_UP*tmp_qloop_67*0.25 - tmp_qloop_84 - tmp_qloop_90))*16.0);
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const walberla::float64 elMat_0_0 = q_acc_0_0;
             const walberla::float64 elMat_0_1 = q_acc_0_1;
             const walberla::float64 elMat_0_2 = q_acc_0_2;
             const walberla::float64 elMat_0_3 = q_acc_0_3;
             const walberla::float64 elMat_0_4 = q_acc_0_4;
             const walberla::float64 elMat_0_5 = q_acc_0_5;
             const walberla::float64 elMat_0_6 = q_acc_0_6;
             const walberla::float64 elMat_0_7 = q_acc_0_7;
             const walberla::float64 elMat_0_8 = q_acc_0_8;
             const walberla::float64 elMat_0_9 = q_acc_0_9;
             const walberla::float64 elMat_1_0 = q_acc_0_1;
             const walberla::float64 elMat_1_1 = q_acc_1_1;
             const walberla::float64 elMat_1_2 = q_acc_1_2;
             const walberla::float64 elMat_1_3 = q_acc_1_3;
             const walberla::float64 elMat_1_4 = q_acc_1_4;
             const walberla::float64 elMat_1_5 = q_acc_1_5;
             const walberla::float64 elMat_1_6 = q_acc_1_6;
             const walberla::float64 elMat_1_7 = q_acc_1_7;
             const walberla::float64 elMat_1_8 = q_acc_1_8;
             const walberla::float64 elMat_1_9 = q_acc_1_9;
             const walberla::float64 elMat_2_0 = q_acc_0_2;
             const walberla::float64 elMat_2_1 = q_acc_1_2;
             const walberla::float64 elMat_2_2 = q_acc_2_2;
             const walberla::float64 elMat_2_3 = q_acc_2_3;
             const walberla::float64 elMat_2_4 = q_acc_2_4;
             const walberla::float64 elMat_2_5 = q_acc_2_5;
             const walberla::float64 elMat_2_6 = q_acc_2_6;
             const walberla::float64 elMat_2_7 = q_acc_2_7;
             const walberla::float64 elMat_2_8 = q_acc_2_8;
             const walberla::float64 elMat_2_9 = q_acc_2_9;
             const walberla::float64 elMat_3_0 = q_acc_0_3;
             const walberla::float64 elMat_3_1 = q_acc_1_3;
             const walberla::float64 elMat_3_2 = q_acc_2_3;
             const walberla::float64 elMat_3_3 = q_acc_3_3;
             const walberla::float64 elMat_3_4 = q_acc_3_4;
             const walberla::float64 elMat_3_5 = q_acc_3_5;
             const walberla::float64 elMat_3_6 = q_acc_3_6;
             const walberla::float64 elMat_3_7 = q_acc_3_7;
             const walberla::float64 elMat_3_8 = q_acc_3_8;
             const walberla::float64 elMat_3_9 = q_acc_3_9;
             const walberla::float64 elMat_4_0 = q_acc_0_4;
             const walberla::float64 elMat_4_1 = q_acc_1_4;
             const walberla::float64 elMat_4_2 = q_acc_2_4;
             const walberla::float64 elMat_4_3 = q_acc_3_4;
             const walberla::float64 elMat_4_4 = q_acc_4_4;
             const walberla::float64 elMat_4_5 = q_acc_4_5;
             const walberla::float64 elMat_4_6 = q_acc_4_6;
             const walberla::float64 elMat_4_7 = q_acc_4_7;
             const walberla::float64 elMat_4_8 = q_acc_4_8;
             const walberla::float64 elMat_4_9 = q_acc_4_9;
             const walberla::float64 elMat_5_0 = q_acc_0_5;
             const walberla::float64 elMat_5_1 = q_acc_1_5;
             const walberla::float64 elMat_5_2 = q_acc_2_5;
             const walberla::float64 elMat_5_3 = q_acc_3_5;
             const walberla::float64 elMat_5_4 = q_acc_4_5;
             const walberla::float64 elMat_5_5 = q_acc_5_5;
             const walberla::float64 elMat_5_6 = q_acc_5_6;
             const walberla::float64 elMat_5_7 = q_acc_5_7;
             const walberla::float64 elMat_5_8 = q_acc_5_8;
             const walberla::float64 elMat_5_9 = q_acc_5_9;
             const walberla::float64 elMat_6_0 = q_acc_0_6;
             const walberla::float64 elMat_6_1 = q_acc_1_6;
             const walberla::float64 elMat_6_2 = q_acc_2_6;
             const walberla::float64 elMat_6_3 = q_acc_3_6;
             const walberla::float64 elMat_6_4 = q_acc_4_6;
             const walberla::float64 elMat_6_5 = q_acc_5_6;
             const walberla::float64 elMat_6_6 = q_acc_6_6;
             const walberla::float64 elMat_6_7 = q_acc_6_7;
             const walberla::float64 elMat_6_8 = q_acc_6_8;
             const walberla::float64 elMat_6_9 = q_acc_6_9;
             const walberla::float64 elMat_7_0 = q_acc_0_7;
             const walberla::float64 elMat_7_1 = q_acc_1_7;
             const walberla::float64 elMat_7_2 = q_acc_2_7;
             const walberla::float64 elMat_7_3 = q_acc_3_7;
             const walberla::float64 elMat_7_4 = q_acc_4_7;
             const walberla::float64 elMat_7_5 = q_acc_5_7;
             const walberla::float64 elMat_7_6 = q_acc_6_7;
             const walberla::float64 elMat_7_7 = q_acc_7_7;
             const walberla::float64 elMat_7_8 = q_acc_7_8;
             const walberla::float64 elMat_7_9 = q_acc_7_9;
             const walberla::float64 elMat_8_0 = q_acc_0_8;
             const walberla::float64 elMat_8_1 = q_acc_1_8;
             const walberla::float64 elMat_8_2 = q_acc_2_8;
             const walberla::float64 elMat_8_3 = q_acc_3_8;
             const walberla::float64 elMat_8_4 = q_acc_4_8;
             const walberla::float64 elMat_8_5 = q_acc_5_8;
             const walberla::float64 elMat_8_6 = q_acc_6_8;
             const walberla::float64 elMat_8_7 = q_acc_7_8;
             const walberla::float64 elMat_8_8 = q_acc_8_8;
             const walberla::float64 elMat_8_9 = q_acc_8_9;
             const walberla::float64 elMat_9_0 = q_acc_0_9;
             const walberla::float64 elMat_9_1 = q_acc_1_9;
             const walberla::float64 elMat_9_2 = q_acc_2_9;
             const walberla::float64 elMat_9_3 = q_acc_3_9;
             const walberla::float64 elMat_9_4 = q_acc_4_9;
             const walberla::float64 elMat_9_5 = q_acc_5_9;
             const walberla::float64 elMat_9_6 = q_acc_6_9;
             const walberla::float64 elMat_9_7 = q_acc_7_9;
             const walberla::float64 elMat_9_8 = q_acc_8_9;
             const walberla::float64 elMat_9_9 = q_acc_9_9;
         
             std::vector< uint_t > _data_rowIdx( 10 );
             std::vector< uint_t > _data_colIdx( 10 );
             std::vector< walberla::float64 > _data_mat( 100 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[1] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[2] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[3] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[7] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[8] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[9] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[3] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[7] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((walberla::float64)(elMat_0_0));
             _data_mat[1] = ((walberla::float64)(elMat_0_1));
             _data_mat[2] = ((walberla::float64)(elMat_0_2));
             _data_mat[3] = ((walberla::float64)(elMat_0_3));
             _data_mat[4] = ((walberla::float64)(elMat_0_4));
             _data_mat[5] = ((walberla::float64)(elMat_0_5));
             _data_mat[6] = ((walberla::float64)(elMat_0_6));
             _data_mat[7] = ((walberla::float64)(elMat_0_7));
             _data_mat[8] = ((walberla::float64)(elMat_0_8));
             _data_mat[9] = ((walberla::float64)(elMat_0_9));
             _data_mat[10] = ((walberla::float64)(elMat_1_0));
             _data_mat[11] = ((walberla::float64)(elMat_1_1));
             _data_mat[12] = ((walberla::float64)(elMat_1_2));
             _data_mat[13] = ((walberla::float64)(elMat_1_3));
             _data_mat[14] = ((walberla::float64)(elMat_1_4));
             _data_mat[15] = ((walberla::float64)(elMat_1_5));
             _data_mat[16] = ((walberla::float64)(elMat_1_6));
             _data_mat[17] = ((walberla::float64)(elMat_1_7));
             _data_mat[18] = ((walberla::float64)(elMat_1_8));
             _data_mat[19] = ((walberla::float64)(elMat_1_9));
             _data_mat[20] = ((walberla::float64)(elMat_2_0));
             _data_mat[21] = ((walberla::float64)(elMat_2_1));
             _data_mat[22] = ((walberla::float64)(elMat_2_2));
             _data_mat[23] = ((walberla::float64)(elMat_2_3));
             _data_mat[24] = ((walberla::float64)(elMat_2_4));
             _data_mat[25] = ((walberla::float64)(elMat_2_5));
             _data_mat[26] = ((walberla::float64)(elMat_2_6));
             _data_mat[27] = ((walberla::float64)(elMat_2_7));
             _data_mat[28] = ((walberla::float64)(elMat_2_8));
             _data_mat[29] = ((walberla::float64)(elMat_2_9));
             _data_mat[30] = ((walberla::float64)(elMat_3_0));
             _data_mat[31] = ((walberla::float64)(elMat_3_1));
             _data_mat[32] = ((walberla::float64)(elMat_3_2));
             _data_mat[33] = ((walberla::float64)(elMat_3_3));
             _data_mat[34] = ((walberla::float64)(elMat_3_4));
             _data_mat[35] = ((walberla::float64)(elMat_3_5));
             _data_mat[36] = ((walberla::float64)(elMat_3_6));
             _data_mat[37] = ((walberla::float64)(elMat_3_7));
             _data_mat[38] = ((walberla::float64)(elMat_3_8));
             _data_mat[39] = ((walberla::float64)(elMat_3_9));
             _data_mat[40] = ((walberla::float64)(elMat_4_0));
             _data_mat[41] = ((walberla::float64)(elMat_4_1));
             _data_mat[42] = ((walberla::float64)(elMat_4_2));
             _data_mat[43] = ((walberla::float64)(elMat_4_3));
             _data_mat[44] = ((walberla::float64)(elMat_4_4));
             _data_mat[45] = ((walberla::float64)(elMat_4_5));
             _data_mat[46] = ((walberla::float64)(elMat_4_6));
             _data_mat[47] = ((walberla::float64)(elMat_4_7));
             _data_mat[48] = ((walberla::float64)(elMat_4_8));
             _data_mat[49] = ((walberla::float64)(elMat_4_9));
             _data_mat[50] = ((walberla::float64)(elMat_5_0));
             _data_mat[51] = ((walberla::float64)(elMat_5_1));
             _data_mat[52] = ((walberla::float64)(elMat_5_2));
             _data_mat[53] = ((walberla::float64)(elMat_5_3));
             _data_mat[54] = ((walberla::float64)(elMat_5_4));
             _data_mat[55] = ((walberla::float64)(elMat_5_5));
             _data_mat[56] = ((walberla::float64)(elMat_5_6));
             _data_mat[57] = ((walberla::float64)(elMat_5_7));
             _data_mat[58] = ((walberla::float64)(elMat_5_8));
             _data_mat[59] = ((walberla::float64)(elMat_5_9));
             _data_mat[60] = ((walberla::float64)(elMat_6_0));
             _data_mat[61] = ((walberla::float64)(elMat_6_1));
             _data_mat[62] = ((walberla::float64)(elMat_6_2));
             _data_mat[63] = ((walberla::float64)(elMat_6_3));
             _data_mat[64] = ((walberla::float64)(elMat_6_4));
             _data_mat[65] = ((walberla::float64)(elMat_6_5));
             _data_mat[66] = ((walberla::float64)(elMat_6_6));
             _data_mat[67] = ((walberla::float64)(elMat_6_7));
             _data_mat[68] = ((walberla::float64)(elMat_6_8));
             _data_mat[69] = ((walberla::float64)(elMat_6_9));
             _data_mat[70] = ((walberla::float64)(elMat_7_0));
             _data_mat[71] = ((walberla::float64)(elMat_7_1));
             _data_mat[72] = ((walberla::float64)(elMat_7_2));
             _data_mat[73] = ((walberla::float64)(elMat_7_3));
             _data_mat[74] = ((walberla::float64)(elMat_7_4));
             _data_mat[75] = ((walberla::float64)(elMat_7_5));
             _data_mat[76] = ((walberla::float64)(elMat_7_6));
             _data_mat[77] = ((walberla::float64)(elMat_7_7));
             _data_mat[78] = ((walberla::float64)(elMat_7_8));
             _data_mat[79] = ((walberla::float64)(elMat_7_9));
             _data_mat[80] = ((walberla::float64)(elMat_8_0));
             _data_mat[81] = ((walberla::float64)(elMat_8_1));
             _data_mat[82] = ((walberla::float64)(elMat_8_2));
             _data_mat[83] = ((walberla::float64)(elMat_8_3));
             _data_mat[84] = ((walberla::float64)(elMat_8_4));
             _data_mat[85] = ((walberla::float64)(elMat_8_5));
             _data_mat[86] = ((walberla::float64)(elMat_8_6));
             _data_mat[87] = ((walberla::float64)(elMat_8_7));
             _data_mat[88] = ((walberla::float64)(elMat_8_8));
             _data_mat[89] = ((walberla::float64)(elMat_8_9));
             _data_mat[90] = ((walberla::float64)(elMat_9_0));
             _data_mat[91] = ((walberla::float64)(elMat_9_1));
             _data_mat[92] = ((walberla::float64)(elMat_9_2));
             _data_mat[93] = ((walberla::float64)(elMat_9_3));
             _data_mat[94] = ((walberla::float64)(elMat_9_4));
             _data_mat[95] = ((walberla::float64)(elMat_9_5));
             _data_mat[96] = ((walberla::float64)(elMat_9_6));
             _data_mat[97] = ((walberla::float64)(elMat_9_7));
             _data_mat[98] = ((walberla::float64)(elMat_9_8));
             _data_mat[99] = ((walberla::float64)(elMat_9_9));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const walberla::float64 tmp_coords_jac_0_WHITE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const walberla::float64 tmp_coords_jac_1_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const walberla::float64 tmp_coords_jac_2_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const walberla::float64 tmp_coords_jac_3_WHITE_DOWN = tmp_coords_jac_1_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_4_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const walberla::float64 tmp_coords_jac_5_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const walberla::float64 tmp_coords_jac_6_WHITE_DOWN = tmp_coords_jac_4_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_7_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const walberla::float64 tmp_coords_jac_8_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const walberla::float64 tmp_coords_jac_9_WHITE_DOWN = tmp_coords_jac_7_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_10_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const walberla::float64 tmp_coords_jac_11_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const walberla::float64 tmp_coords_jac_12_WHITE_DOWN = tmp_coords_jac_0_WHITE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const walberla::float64 p_affine_const_0_0_WHITE_DOWN = tmp_coords_jac_3_WHITE_DOWN;
       const walberla::float64 p_affine_const_0_1_WHITE_DOWN = tmp_coords_jac_6_WHITE_DOWN;
       const walberla::float64 p_affine_const_0_2_WHITE_DOWN = tmp_coords_jac_9_WHITE_DOWN;
       const walberla::float64 p_affine_const_1_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_2_WHITE_DOWN;
       const walberla::float64 p_affine_const_1_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_5_WHITE_DOWN;
       const walberla::float64 p_affine_const_1_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_8_WHITE_DOWN;
       const walberla::float64 p_affine_const_2_0_WHITE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_1_WHITE_DOWN;
       const walberla::float64 p_affine_const_2_1_WHITE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_4_WHITE_DOWN;
       const walberla::float64 p_affine_const_2_2_WHITE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_7_WHITE_DOWN;
       const walberla::float64 p_affine_const_3_0_WHITE_DOWN = tmp_coords_jac_10_WHITE_DOWN + tmp_coords_jac_3_WHITE_DOWN;
       const walberla::float64 p_affine_const_3_1_WHITE_DOWN = tmp_coords_jac_11_WHITE_DOWN + tmp_coords_jac_6_WHITE_DOWN;
       const walberla::float64 p_affine_const_3_2_WHITE_DOWN = tmp_coords_jac_12_WHITE_DOWN + tmp_coords_jac_9_WHITE_DOWN;
       const walberla::float64 jac_affine_0_0_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_1_0_WHITE_DOWN;
       const walberla::float64 jac_affine_0_1_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_2_0_WHITE_DOWN;
       const walberla::float64 jac_affine_0_2_WHITE_DOWN = -p_affine_const_0_0_WHITE_DOWN + p_affine_const_3_0_WHITE_DOWN;
       const walberla::float64 jac_affine_1_0_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_1_1_WHITE_DOWN;
       const walberla::float64 jac_affine_1_1_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_2_1_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_17_WHITE_DOWN = jac_affine_0_2_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN;
       const walberla::float64 jac_affine_1_2_WHITE_DOWN = -p_affine_const_0_1_WHITE_DOWN + p_affine_const_3_1_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_15_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN;
       const walberla::float64 jac_affine_2_0_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_1_2_WHITE_DOWN;
       const walberla::float64 jac_affine_2_1_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_2_2_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_14_WHITE_DOWN = jac_affine_1_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN;
       const walberla::float64 jac_affine_2_2_WHITE_DOWN = -p_affine_const_0_2_WHITE_DOWN + p_affine_const_3_2_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_13_WHITE_DOWN = jac_affine_1_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_16_WHITE_DOWN = jac_affine_0_1_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_18_WHITE_DOWN = jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_13_WHITE_DOWN - jac_affine_0_0_WHITE_DOWN*tmp_coords_jac_14_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_0_WHITE_DOWN*tmp_coords_jac_16_WHITE_DOWN + jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_15_WHITE_DOWN - jac_affine_2_0_WHITE_DOWN*tmp_coords_jac_17_WHITE_DOWN;
       const walberla::float64 tmp_coords_jac_19_WHITE_DOWN = 1.0 / (tmp_coords_jac_18_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_0_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_13_WHITE_DOWN - tmp_coords_jac_14_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_0_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_2_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - tmp_coords_jac_16_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_0_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(tmp_coords_jac_15_WHITE_DOWN - tmp_coords_jac_17_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_1_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_1_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN + jac_affine_1_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_1_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_2_2_WHITE_DOWN - jac_affine_0_2_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_1_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_1_2_WHITE_DOWN + jac_affine_0_2_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_2_0_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_1_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN - jac_affine_1_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_2_1_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(-jac_affine_0_0_WHITE_DOWN*jac_affine_2_1_WHITE_DOWN + jac_affine_0_1_WHITE_DOWN*jac_affine_2_0_WHITE_DOWN);
       const walberla::float64 jac_affine_inv_2_2_WHITE_DOWN = tmp_coords_jac_19_WHITE_DOWN*(jac_affine_0_0_WHITE_DOWN*jac_affine_1_1_WHITE_DOWN - jac_affine_0_1_WHITE_DOWN*jac_affine_1_0_WHITE_DOWN);
       const walberla::float64 abs_det_jac_affine_WHITE_DOWN = abs(tmp_coords_jac_18_WHITE_DOWN);
       {
          /* CellType.WHITE_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 2; ctr_0 += 1)
          {
             const walberla::float64 k_dof_0 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 k_dof_1 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 k_dof_2 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 k_dof_3 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 k_dof_4 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const walberla::float64 k_dof_5 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1];
             const walberla::float64 k_dof_6 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const walberla::float64 k_dof_7 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const walberla::float64 k_dof_8 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const walberla::float64 k_dof_9 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             walberla::float64 q_acc_0_0 = 0.0;
             walberla::float64 q_acc_0_1 = 0.0;
             walberla::float64 q_acc_0_2 = 0.0;
             walberla::float64 q_acc_0_3 = 0.0;
             walberla::float64 q_acc_0_4 = 0.0;
             walberla::float64 q_acc_0_5 = 0.0;
             walberla::float64 q_acc_0_6 = 0.0;
             walberla::float64 q_acc_0_7 = 0.0;
             walberla::float64 q_acc_0_8 = 0.0;
             walberla::float64 q_acc_0_9 = 0.0;
             walberla::float64 q_acc_1_1 = 0.0;
             walberla::float64 q_acc_1_2 = 0.0;
             walberla::float64 q_acc_1_3 = 0.0;
             walberla::float64 q_acc_1_4 = 0.0;
             walberla::float64 q_acc_1_5 = 0.0;
             walberla::float64 q_acc_1_6 = 0.0;
             walberla::float64 q_acc_1_7 = 0.0;
             walberla::float64 q_acc_1_8 = 0.0;
             walberla::float64 q_acc_1_9 = 0.0;
             walberla::float64 q_acc_2_2 = 0.0;
             walberla::float64 q_acc_2_3 = 0.0;
             walberla::float64 q_acc_2_4 = 0.0;
             walberla::float64 q_acc_2_5 = 0.0;
             walberla::float64 q_acc_2_6 = 0.0;
             walberla::float64 q_acc_2_7 = 0.0;
             walberla::float64 q_acc_2_8 = 0.0;
             walberla::float64 q_acc_2_9 = 0.0;
             walberla::float64 q_acc_3_3 = 0.0;
             walberla::float64 q_acc_3_4 = 0.0;
             walberla::float64 q_acc_3_5 = 0.0;
             walberla::float64 q_acc_3_6 = 0.0;
             walberla::float64 q_acc_3_7 = 0.0;
             walberla::float64 q_acc_3_8 = 0.0;
             walberla::float64 q_acc_3_9 = 0.0;
             walberla::float64 q_acc_4_4 = 0.0;
             walberla::float64 q_acc_4_5 = 0.0;
             walberla::float64 q_acc_4_6 = 0.0;
             walberla::float64 q_acc_4_7 = 0.0;
             walberla::float64 q_acc_4_8 = 0.0;
             walberla::float64 q_acc_4_9 = 0.0;
             walberla::float64 q_acc_5_5 = 0.0;
             walberla::float64 q_acc_5_6 = 0.0;
             walberla::float64 q_acc_5_7 = 0.0;
             walberla::float64 q_acc_5_8 = 0.0;
             walberla::float64 q_acc_5_9 = 0.0;
             walberla::float64 q_acc_6_6 = 0.0;
             walberla::float64 q_acc_6_7 = 0.0;
             walberla::float64 q_acc_6_8 = 0.0;
             walberla::float64 q_acc_6_9 = 0.0;
             walberla::float64 q_acc_7_7 = 0.0;
             walberla::float64 q_acc_7_8 = 0.0;
             walberla::float64 q_acc_7_9 = 0.0;
             walberla::float64 q_acc_8_8 = 0.0;
             walberla::float64 q_acc_8_9 = 0.0;
             walberla::float64 q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const walberla::float64 tmp_qloop_0 = 4.0*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_1 = 4.0*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_2 = 4.0*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_3 = tmp_qloop_1 + tmp_qloop_2;
                const walberla::float64 tmp_qloop_4 = tmp_qloop_0 + tmp_qloop_3 - 3.0;
                const walberla::float64 tmp_qloop_5 = jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_4 + jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_4 + jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_4;
                const walberla::float64 tmp_qloop_6 = jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_4 + jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_4 + jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_4;
                const walberla::float64 tmp_qloop_7 = jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_4 + jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_4 + jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_4;
                const walberla::float64 tmp_qloop_8 = tmp_qloop_1*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_9 = tmp_qloop_1*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_10 = tmp_qloop_2*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_11 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const walberla::float64 tmp_qloop_12 = tmp_qloop_11*2.0;
                const walberla::float64 tmp_qloop_13 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const walberla::float64 tmp_qloop_14 = tmp_qloop_13*2.0;
                const walberla::float64 tmp_qloop_15 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const walberla::float64 tmp_qloop_16 = tmp_qloop_15*2.0;
                const walberla::float64 tmp_qloop_17 = tmp_qloop_8 + tmp_qloop_9;
                const walberla::float64 tmp_qloop_18 = abs_det_jac_affine_WHITE_DOWN*(k_dof_0*(tmp_qloop_10 + tmp_qloop_12 + tmp_qloop_14 + tmp_qloop_16 + tmp_qloop_17 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0) + k_dof_1*(tmp_qloop_12 - _data_q_p_0[q]) + k_dof_2*(tmp_qloop_14 - _data_q_p_1[q]) + k_dof_3*(tmp_qloop_16 - _data_q_p_2[q]) + k_dof_4*tmp_qloop_10 + k_dof_5*tmp_qloop_9 + k_dof_6*tmp_qloop_8 + k_dof_7*(tmp_qloop_0 - tmp_qloop_10 + tmp_qloop_15*-4.0 - tmp_qloop_9) + k_dof_8*(-tmp_qloop_10 + tmp_qloop_13*-4.0 + tmp_qloop_2 - tmp_qloop_8) + k_dof_9*(tmp_qloop_1 + tmp_qloop_11*-4.0 - tmp_qloop_17))*_data_q_w[q];
                const walberla::float64 tmp_qloop_19 = tmp_qloop_1 - 1.0;
                const walberla::float64 tmp_qloop_20 = jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_19;
                const walberla::float64 tmp_qloop_21 = jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_19;
                const walberla::float64 tmp_qloop_22 = jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_19;
                const walberla::float64 tmp_qloop_23 = tmp_qloop_2 - 1.0;
                const walberla::float64 tmp_qloop_24 = jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_23;
                const walberla::float64 tmp_qloop_25 = jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_23;
                const walberla::float64 tmp_qloop_26 = jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_23;
                const walberla::float64 tmp_qloop_27 = tmp_qloop_0 - 1.0;
                const walberla::float64 tmp_qloop_28 = jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_27;
                const walberla::float64 tmp_qloop_29 = jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_27;
                const walberla::float64 tmp_qloop_30 = jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_27;
                const walberla::float64 tmp_qloop_31 = jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_2;
                const walberla::float64 tmp_qloop_32 = jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_0;
                const walberla::float64 tmp_qloop_33 = tmp_qloop_31 + tmp_qloop_32;
                const walberla::float64 tmp_qloop_34 = jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_2;
                const walberla::float64 tmp_qloop_35 = jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_0;
                const walberla::float64 tmp_qloop_36 = tmp_qloop_34 + tmp_qloop_35;
                const walberla::float64 tmp_qloop_37 = jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_2;
                const walberla::float64 tmp_qloop_38 = jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_0;
                const walberla::float64 tmp_qloop_39 = tmp_qloop_37 + tmp_qloop_38;
                const walberla::float64 tmp_qloop_40 = jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_1;
                const walberla::float64 tmp_qloop_41 = jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_0;
                const walberla::float64 tmp_qloop_42 = tmp_qloop_40 + tmp_qloop_41;
                const walberla::float64 tmp_qloop_43 = jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_1;
                const walberla::float64 tmp_qloop_44 = jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_0;
                const walberla::float64 tmp_qloop_45 = tmp_qloop_43 + tmp_qloop_44;
                const walberla::float64 tmp_qloop_46 = jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_1;
                const walberla::float64 tmp_qloop_47 = jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_0;
                const walberla::float64 tmp_qloop_48 = tmp_qloop_46 + tmp_qloop_47;
                const walberla::float64 tmp_qloop_49 = jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_1;
                const walberla::float64 tmp_qloop_50 = jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_2;
                const walberla::float64 tmp_qloop_51 = tmp_qloop_49 + tmp_qloop_50;
                const walberla::float64 tmp_qloop_52 = jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_1;
                const walberla::float64 tmp_qloop_53 = jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_2;
                const walberla::float64 tmp_qloop_54 = tmp_qloop_52 + tmp_qloop_53;
                const walberla::float64 tmp_qloop_55 = jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_1;
                const walberla::float64 tmp_qloop_56 = jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_2;
                const walberla::float64 tmp_qloop_57 = tmp_qloop_55 + tmp_qloop_56;
                const walberla::float64 tmp_qloop_58 = -tmp_qloop_3 - 8.0*_data_q_p_2[q] + 4.0;
                const walberla::float64 tmp_qloop_59 = jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_58 - tmp_qloop_32 - tmp_qloop_41;
                const walberla::float64 tmp_qloop_60 = jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_58 - tmp_qloop_35 - tmp_qloop_44;
                const walberla::float64 tmp_qloop_61 = jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_58 - tmp_qloop_38 - tmp_qloop_47;
                const walberla::float64 tmp_qloop_62 = tmp_qloop_0 - 4.0;
                const walberla::float64 tmp_qloop_63 = -tmp_qloop_1 - tmp_qloop_62 - 8.0*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_64 = jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_63 - tmp_qloop_31 - tmp_qloop_50;
                const walberla::float64 tmp_qloop_65 = jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_63 - tmp_qloop_34 - tmp_qloop_53;
                const walberla::float64 tmp_qloop_66 = jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_63 - tmp_qloop_37 - tmp_qloop_56;
                const walberla::float64 tmp_qloop_67 = -tmp_qloop_2 - tmp_qloop_62 - 8.0*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_68 = jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_67 - tmp_qloop_40 - tmp_qloop_49;
                const walberla::float64 tmp_qloop_69 = jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_67 - tmp_qloop_43 - tmp_qloop_52;
                const walberla::float64 tmp_qloop_70 = jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_67 - tmp_qloop_46 - tmp_qloop_55;
                const walberla::float64 tmp_qloop_71 = ((-0.25 + _data_q_p_0[q])*(-0.25 + _data_q_p_0[q]))*16.0;
                const walberla::float64 tmp_qloop_72 = ((-0.25 + _data_q_p_1[q])*(-0.25 + _data_q_p_1[q]))*16.0;
                const walberla::float64 tmp_qloop_73 = ((-0.25 + _data_q_p_2[q])*(-0.25 + _data_q_p_2[q]))*16.0;
                const walberla::float64 tmp_qloop_74 = jac_affine_inv_2_0_WHITE_DOWN*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_75 = jac_affine_inv_1_0_WHITE_DOWN*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_76 = jac_affine_inv_2_1_WHITE_DOWN*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_77 = jac_affine_inv_1_1_WHITE_DOWN*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_78 = jac_affine_inv_2_2_WHITE_DOWN*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_79 = jac_affine_inv_1_2_WHITE_DOWN*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_80 = jac_affine_inv_2_0_WHITE_DOWN*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_81 = jac_affine_inv_0_0_WHITE_DOWN*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_82 = jac_affine_inv_2_1_WHITE_DOWN*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_83 = jac_affine_inv_0_1_WHITE_DOWN*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_84 = jac_affine_inv_2_2_WHITE_DOWN*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_85 = jac_affine_inv_0_2_WHITE_DOWN*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_86 = jac_affine_inv_1_0_WHITE_DOWN*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_87 = jac_affine_inv_0_0_WHITE_DOWN*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_88 = jac_affine_inv_1_1_WHITE_DOWN*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_89 = jac_affine_inv_0_1_WHITE_DOWN*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_90 = jac_affine_inv_1_2_WHITE_DOWN*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_91 = jac_affine_inv_0_2_WHITE_DOWN*_data_q_p_1[q];
                const walberla::float64 q_tmp_0_0 = tmp_qloop_18*((tmp_qloop_5*tmp_qloop_5) + (tmp_qloop_6*tmp_qloop_6) + (tmp_qloop_7*tmp_qloop_7));
                const walberla::float64 q_tmp_0_1 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_5 + tmp_qloop_21*tmp_qloop_6 + tmp_qloop_22*tmp_qloop_7);
                const walberla::float64 q_tmp_0_2 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_5 + tmp_qloop_25*tmp_qloop_6 + tmp_qloop_26*tmp_qloop_7);
                const walberla::float64 q_tmp_0_3 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_5 + tmp_qloop_29*tmp_qloop_6 + tmp_qloop_30*tmp_qloop_7);
                const walberla::float64 q_tmp_0_4 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_5 + tmp_qloop_36*tmp_qloop_6 + tmp_qloop_39*tmp_qloop_7);
                const walberla::float64 q_tmp_0_5 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_5 + tmp_qloop_45*tmp_qloop_6 + tmp_qloop_48*tmp_qloop_7);
                const walberla::float64 q_tmp_0_6 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_51 + tmp_qloop_54*tmp_qloop_6 + tmp_qloop_57*tmp_qloop_7);
                const walberla::float64 q_tmp_0_7 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_59 + tmp_qloop_6*tmp_qloop_60 + tmp_qloop_61*tmp_qloop_7);
                const walberla::float64 q_tmp_0_8 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_64 + tmp_qloop_6*tmp_qloop_65 + tmp_qloop_66*tmp_qloop_7);
                const walberla::float64 q_tmp_0_9 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_68 + tmp_qloop_6*tmp_qloop_69 + tmp_qloop_7*tmp_qloop_70);
                const walberla::float64 q_tmp_1_1 = tmp_qloop_18*((jac_affine_inv_0_0_WHITE_DOWN*jac_affine_inv_0_0_WHITE_DOWN)*tmp_qloop_71 + (jac_affine_inv_0_1_WHITE_DOWN*jac_affine_inv_0_1_WHITE_DOWN)*tmp_qloop_71 + (jac_affine_inv_0_2_WHITE_DOWN*jac_affine_inv_0_2_WHITE_DOWN)*tmp_qloop_71);
                const walberla::float64 q_tmp_1_2 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_24 + tmp_qloop_21*tmp_qloop_25 + tmp_qloop_22*tmp_qloop_26);
                const walberla::float64 q_tmp_1_3 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_28 + tmp_qloop_21*tmp_qloop_29 + tmp_qloop_22*tmp_qloop_30);
                const walberla::float64 q_tmp_1_4 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_33 + tmp_qloop_21*tmp_qloop_36 + tmp_qloop_22*tmp_qloop_39);
                const walberla::float64 q_tmp_1_5 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_42 + tmp_qloop_21*tmp_qloop_45 + tmp_qloop_22*tmp_qloop_48);
                const walberla::float64 q_tmp_1_6 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_51 + tmp_qloop_21*tmp_qloop_54 + tmp_qloop_22*tmp_qloop_57);
                const walberla::float64 q_tmp_1_7 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_59 + tmp_qloop_21*tmp_qloop_60 + tmp_qloop_22*tmp_qloop_61);
                const walberla::float64 q_tmp_1_8 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_64 + tmp_qloop_21*tmp_qloop_65 + tmp_qloop_22*tmp_qloop_66);
                const walberla::float64 q_tmp_1_9 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_68 + tmp_qloop_21*tmp_qloop_69 + tmp_qloop_22*tmp_qloop_70);
                const walberla::float64 q_tmp_2_2 = tmp_qloop_18*((jac_affine_inv_1_0_WHITE_DOWN*jac_affine_inv_1_0_WHITE_DOWN)*tmp_qloop_72 + (jac_affine_inv_1_1_WHITE_DOWN*jac_affine_inv_1_1_WHITE_DOWN)*tmp_qloop_72 + (jac_affine_inv_1_2_WHITE_DOWN*jac_affine_inv_1_2_WHITE_DOWN)*tmp_qloop_72);
                const walberla::float64 q_tmp_2_3 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_28 + tmp_qloop_25*tmp_qloop_29 + tmp_qloop_26*tmp_qloop_30);
                const walberla::float64 q_tmp_2_4 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_33 + tmp_qloop_25*tmp_qloop_36 + tmp_qloop_26*tmp_qloop_39);
                const walberla::float64 q_tmp_2_5 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_42 + tmp_qloop_25*tmp_qloop_45 + tmp_qloop_26*tmp_qloop_48);
                const walberla::float64 q_tmp_2_6 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_51 + tmp_qloop_25*tmp_qloop_54 + tmp_qloop_26*tmp_qloop_57);
                const walberla::float64 q_tmp_2_7 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_59 + tmp_qloop_25*tmp_qloop_60 + tmp_qloop_26*tmp_qloop_61);
                const walberla::float64 q_tmp_2_8 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_64 + tmp_qloop_25*tmp_qloop_65 + tmp_qloop_26*tmp_qloop_66);
                const walberla::float64 q_tmp_2_9 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_68 + tmp_qloop_25*tmp_qloop_69 + tmp_qloop_26*tmp_qloop_70);
                const walberla::float64 q_tmp_3_3 = tmp_qloop_18*((jac_affine_inv_2_0_WHITE_DOWN*jac_affine_inv_2_0_WHITE_DOWN)*tmp_qloop_73 + (jac_affine_inv_2_1_WHITE_DOWN*jac_affine_inv_2_1_WHITE_DOWN)*tmp_qloop_73 + (jac_affine_inv_2_2_WHITE_DOWN*jac_affine_inv_2_2_WHITE_DOWN)*tmp_qloop_73);
                const walberla::float64 q_tmp_3_4 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_33 + tmp_qloop_29*tmp_qloop_36 + tmp_qloop_30*tmp_qloop_39);
                const walberla::float64 q_tmp_3_5 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_42 + tmp_qloop_29*tmp_qloop_45 + tmp_qloop_30*tmp_qloop_48);
                const walberla::float64 q_tmp_3_6 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_51 + tmp_qloop_29*tmp_qloop_54 + tmp_qloop_30*tmp_qloop_57);
                const walberla::float64 q_tmp_3_7 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_59 + tmp_qloop_29*tmp_qloop_60 + tmp_qloop_30*tmp_qloop_61);
                const walberla::float64 q_tmp_3_8 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_64 + tmp_qloop_29*tmp_qloop_65 + tmp_qloop_30*tmp_qloop_66);
                const walberla::float64 q_tmp_3_9 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_68 + tmp_qloop_29*tmp_qloop_69 + tmp_qloop_30*tmp_qloop_70);
                const walberla::float64 q_tmp_4_4 = tmp_qloop_18*(((tmp_qloop_74 + tmp_qloop_75)*(tmp_qloop_74 + tmp_qloop_75))*16.0 + ((tmp_qloop_76 + tmp_qloop_77)*(tmp_qloop_76 + tmp_qloop_77))*16.0 + ((tmp_qloop_78 + tmp_qloop_79)*(tmp_qloop_78 + tmp_qloop_79))*16.0);
                const walberla::float64 q_tmp_4_5 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_42 + tmp_qloop_36*tmp_qloop_45 + tmp_qloop_39*tmp_qloop_48);
                const walberla::float64 q_tmp_4_6 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_51 + tmp_qloop_36*tmp_qloop_54 + tmp_qloop_39*tmp_qloop_57);
                const walberla::float64 q_tmp_4_7 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_59 + tmp_qloop_36*tmp_qloop_60 + tmp_qloop_39*tmp_qloop_61);
                const walberla::float64 q_tmp_4_8 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_64 + tmp_qloop_36*tmp_qloop_65 + tmp_qloop_39*tmp_qloop_66);
                const walberla::float64 q_tmp_4_9 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_68 + tmp_qloop_36*tmp_qloop_69 + tmp_qloop_39*tmp_qloop_70);
                const walberla::float64 q_tmp_5_5 = tmp_qloop_18*(((tmp_qloop_80 + tmp_qloop_81)*(tmp_qloop_80 + tmp_qloop_81))*16.0 + ((tmp_qloop_82 + tmp_qloop_83)*(tmp_qloop_82 + tmp_qloop_83))*16.0 + ((tmp_qloop_84 + tmp_qloop_85)*(tmp_qloop_84 + tmp_qloop_85))*16.0);
                const walberla::float64 q_tmp_5_6 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_51 + tmp_qloop_45*tmp_qloop_54 + tmp_qloop_48*tmp_qloop_57);
                const walberla::float64 q_tmp_5_7 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_59 + tmp_qloop_45*tmp_qloop_60 + tmp_qloop_48*tmp_qloop_61);
                const walberla::float64 q_tmp_5_8 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_64 + tmp_qloop_45*tmp_qloop_65 + tmp_qloop_48*tmp_qloop_66);
                const walberla::float64 q_tmp_5_9 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_68 + tmp_qloop_45*tmp_qloop_69 + tmp_qloop_48*tmp_qloop_70);
                const walberla::float64 q_tmp_6_6 = tmp_qloop_18*(((tmp_qloop_86 + tmp_qloop_87)*(tmp_qloop_86 + tmp_qloop_87))*16.0 + ((tmp_qloop_88 + tmp_qloop_89)*(tmp_qloop_88 + tmp_qloop_89))*16.0 + ((tmp_qloop_90 + tmp_qloop_91)*(tmp_qloop_90 + tmp_qloop_91))*16.0);
                const walberla::float64 q_tmp_6_7 = tmp_qloop_18*(tmp_qloop_51*tmp_qloop_59 + tmp_qloop_54*tmp_qloop_60 + tmp_qloop_57*tmp_qloop_61);
                const walberla::float64 q_tmp_6_8 = tmp_qloop_18*(tmp_qloop_51*tmp_qloop_64 + tmp_qloop_54*tmp_qloop_65 + tmp_qloop_57*tmp_qloop_66);
                const walberla::float64 q_tmp_6_9 = tmp_qloop_18*(tmp_qloop_51*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_57*tmp_qloop_70);
                const walberla::float64 q_tmp_7_7 = tmp_qloop_18*(((jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_58*0.25 - tmp_qloop_75 - tmp_qloop_81)*(jac_affine_inv_2_0_WHITE_DOWN*tmp_qloop_58*0.25 - tmp_qloop_75 - tmp_qloop_81))*16.0 + ((jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_58*0.25 - tmp_qloop_77 - tmp_qloop_83)*(jac_affine_inv_2_1_WHITE_DOWN*tmp_qloop_58*0.25 - tmp_qloop_77 - tmp_qloop_83))*16.0 + ((jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_58*0.25 - tmp_qloop_79 - tmp_qloop_85)*(jac_affine_inv_2_2_WHITE_DOWN*tmp_qloop_58*0.25 - tmp_qloop_79 - tmp_qloop_85))*16.0);
                const walberla::float64 q_tmp_7_8 = tmp_qloop_18*(tmp_qloop_59*tmp_qloop_64 + tmp_qloop_60*tmp_qloop_65 + tmp_qloop_61*tmp_qloop_66);
                const walberla::float64 q_tmp_7_9 = tmp_qloop_18*(tmp_qloop_59*tmp_qloop_68 + tmp_qloop_60*tmp_qloop_69 + tmp_qloop_61*tmp_qloop_70);
                const walberla::float64 q_tmp_8_8 = tmp_qloop_18*(((jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_63*0.25 - tmp_qloop_74 - tmp_qloop_87)*(jac_affine_inv_1_0_WHITE_DOWN*tmp_qloop_63*0.25 - tmp_qloop_74 - tmp_qloop_87))*16.0 + ((jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_63*0.25 - tmp_qloop_76 - tmp_qloop_89)*(jac_affine_inv_1_1_WHITE_DOWN*tmp_qloop_63*0.25 - tmp_qloop_76 - tmp_qloop_89))*16.0 + ((jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_63*0.25 - tmp_qloop_78 - tmp_qloop_91)*(jac_affine_inv_1_2_WHITE_DOWN*tmp_qloop_63*0.25 - tmp_qloop_78 - tmp_qloop_91))*16.0);
                const walberla::float64 q_tmp_8_9 = tmp_qloop_18*(tmp_qloop_64*tmp_qloop_68 + tmp_qloop_65*tmp_qloop_69 + tmp_qloop_66*tmp_qloop_70);
                const walberla::float64 q_tmp_9_9 = tmp_qloop_18*(((jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_67*0.25 - tmp_qloop_80 - tmp_qloop_86)*(jac_affine_inv_0_0_WHITE_DOWN*tmp_qloop_67*0.25 - tmp_qloop_80 - tmp_qloop_86))*16.0 + ((jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_67*0.25 - tmp_qloop_82 - tmp_qloop_88)*(jac_affine_inv_0_1_WHITE_DOWN*tmp_qloop_67*0.25 - tmp_qloop_82 - tmp_qloop_88))*16.0 + ((jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_67*0.25 - tmp_qloop_84 - tmp_qloop_90)*(jac_affine_inv_0_2_WHITE_DOWN*tmp_qloop_67*0.25 - tmp_qloop_84 - tmp_qloop_90))*16.0);
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const walberla::float64 elMat_0_0 = q_acc_0_0;
             const walberla::float64 elMat_0_1 = q_acc_0_1;
             const walberla::float64 elMat_0_2 = q_acc_0_2;
             const walberla::float64 elMat_0_3 = q_acc_0_3;
             const walberla::float64 elMat_0_4 = q_acc_0_4;
             const walberla::float64 elMat_0_5 = q_acc_0_5;
             const walberla::float64 elMat_0_6 = q_acc_0_6;
             const walberla::float64 elMat_0_7 = q_acc_0_7;
             const walberla::float64 elMat_0_8 = q_acc_0_8;
             const walberla::float64 elMat_0_9 = q_acc_0_9;
             const walberla::float64 elMat_1_0 = q_acc_0_1;
             const walberla::float64 elMat_1_1 = q_acc_1_1;
             const walberla::float64 elMat_1_2 = q_acc_1_2;
             const walberla::float64 elMat_1_3 = q_acc_1_3;
             const walberla::float64 elMat_1_4 = q_acc_1_4;
             const walberla::float64 elMat_1_5 = q_acc_1_5;
             const walberla::float64 elMat_1_6 = q_acc_1_6;
             const walberla::float64 elMat_1_7 = q_acc_1_7;
             const walberla::float64 elMat_1_8 = q_acc_1_8;
             const walberla::float64 elMat_1_9 = q_acc_1_9;
             const walberla::float64 elMat_2_0 = q_acc_0_2;
             const walberla::float64 elMat_2_1 = q_acc_1_2;
             const walberla::float64 elMat_2_2 = q_acc_2_2;
             const walberla::float64 elMat_2_3 = q_acc_2_3;
             const walberla::float64 elMat_2_4 = q_acc_2_4;
             const walberla::float64 elMat_2_5 = q_acc_2_5;
             const walberla::float64 elMat_2_6 = q_acc_2_6;
             const walberla::float64 elMat_2_7 = q_acc_2_7;
             const walberla::float64 elMat_2_8 = q_acc_2_8;
             const walberla::float64 elMat_2_9 = q_acc_2_9;
             const walberla::float64 elMat_3_0 = q_acc_0_3;
             const walberla::float64 elMat_3_1 = q_acc_1_3;
             const walberla::float64 elMat_3_2 = q_acc_2_3;
             const walberla::float64 elMat_3_3 = q_acc_3_3;
             const walberla::float64 elMat_3_4 = q_acc_3_4;
             const walberla::float64 elMat_3_5 = q_acc_3_5;
             const walberla::float64 elMat_3_6 = q_acc_3_6;
             const walberla::float64 elMat_3_7 = q_acc_3_7;
             const walberla::float64 elMat_3_8 = q_acc_3_8;
             const walberla::float64 elMat_3_9 = q_acc_3_9;
             const walberla::float64 elMat_4_0 = q_acc_0_4;
             const walberla::float64 elMat_4_1 = q_acc_1_4;
             const walberla::float64 elMat_4_2 = q_acc_2_4;
             const walberla::float64 elMat_4_3 = q_acc_3_4;
             const walberla::float64 elMat_4_4 = q_acc_4_4;
             const walberla::float64 elMat_4_5 = q_acc_4_5;
             const walberla::float64 elMat_4_6 = q_acc_4_6;
             const walberla::float64 elMat_4_7 = q_acc_4_7;
             const walberla::float64 elMat_4_8 = q_acc_4_8;
             const walberla::float64 elMat_4_9 = q_acc_4_9;
             const walberla::float64 elMat_5_0 = q_acc_0_5;
             const walberla::float64 elMat_5_1 = q_acc_1_5;
             const walberla::float64 elMat_5_2 = q_acc_2_5;
             const walberla::float64 elMat_5_3 = q_acc_3_5;
             const walberla::float64 elMat_5_4 = q_acc_4_5;
             const walberla::float64 elMat_5_5 = q_acc_5_5;
             const walberla::float64 elMat_5_6 = q_acc_5_6;
             const walberla::float64 elMat_5_7 = q_acc_5_7;
             const walberla::float64 elMat_5_8 = q_acc_5_8;
             const walberla::float64 elMat_5_9 = q_acc_5_9;
             const walberla::float64 elMat_6_0 = q_acc_0_6;
             const walberla::float64 elMat_6_1 = q_acc_1_6;
             const walberla::float64 elMat_6_2 = q_acc_2_6;
             const walberla::float64 elMat_6_3 = q_acc_3_6;
             const walberla::float64 elMat_6_4 = q_acc_4_6;
             const walberla::float64 elMat_6_5 = q_acc_5_6;
             const walberla::float64 elMat_6_6 = q_acc_6_6;
             const walberla::float64 elMat_6_7 = q_acc_6_7;
             const walberla::float64 elMat_6_8 = q_acc_6_8;
             const walberla::float64 elMat_6_9 = q_acc_6_9;
             const walberla::float64 elMat_7_0 = q_acc_0_7;
             const walberla::float64 elMat_7_1 = q_acc_1_7;
             const walberla::float64 elMat_7_2 = q_acc_2_7;
             const walberla::float64 elMat_7_3 = q_acc_3_7;
             const walberla::float64 elMat_7_4 = q_acc_4_7;
             const walberla::float64 elMat_7_5 = q_acc_5_7;
             const walberla::float64 elMat_7_6 = q_acc_6_7;
             const walberla::float64 elMat_7_7 = q_acc_7_7;
             const walberla::float64 elMat_7_8 = q_acc_7_8;
             const walberla::float64 elMat_7_9 = q_acc_7_9;
             const walberla::float64 elMat_8_0 = q_acc_0_8;
             const walberla::float64 elMat_8_1 = q_acc_1_8;
             const walberla::float64 elMat_8_2 = q_acc_2_8;
             const walberla::float64 elMat_8_3 = q_acc_3_8;
             const walberla::float64 elMat_8_4 = q_acc_4_8;
             const walberla::float64 elMat_8_5 = q_acc_5_8;
             const walberla::float64 elMat_8_6 = q_acc_6_8;
             const walberla::float64 elMat_8_7 = q_acc_7_8;
             const walberla::float64 elMat_8_8 = q_acc_8_8;
             const walberla::float64 elMat_8_9 = q_acc_8_9;
             const walberla::float64 elMat_9_0 = q_acc_0_9;
             const walberla::float64 elMat_9_1 = q_acc_1_9;
             const walberla::float64 elMat_9_2 = q_acc_2_9;
             const walberla::float64 elMat_9_3 = q_acc_3_9;
             const walberla::float64 elMat_9_4 = q_acc_4_9;
             const walberla::float64 elMat_9_5 = q_acc_5_9;
             const walberla::float64 elMat_9_6 = q_acc_6_9;
             const walberla::float64 elMat_9_7 = q_acc_7_9;
             const walberla::float64 elMat_9_8 = q_acc_8_9;
             const walberla::float64 elMat_9_9 = q_acc_9_9;
         
             std::vector< uint_t > _data_rowIdx( 10 );
             std::vector< uint_t > _data_colIdx( 10 );
             std::vector< walberla::float64 > _data_mat( 100 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[1] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[2] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[3] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[4] = ((uint64_t)(_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]));
             _data_rowIdx[6] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[7] = ((uint64_t)(_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[8] = ((uint64_t)(_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[9] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[3] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6)) + 1]));
             _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[7] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((walberla::float64)(elMat_0_0));
             _data_mat[1] = ((walberla::float64)(elMat_0_1));
             _data_mat[2] = ((walberla::float64)(elMat_0_2));
             _data_mat[3] = ((walberla::float64)(elMat_0_3));
             _data_mat[4] = ((walberla::float64)(elMat_0_4));
             _data_mat[5] = ((walberla::float64)(elMat_0_5));
             _data_mat[6] = ((walberla::float64)(elMat_0_6));
             _data_mat[7] = ((walberla::float64)(elMat_0_7));
             _data_mat[8] = ((walberla::float64)(elMat_0_8));
             _data_mat[9] = ((walberla::float64)(elMat_0_9));
             _data_mat[10] = ((walberla::float64)(elMat_1_0));
             _data_mat[11] = ((walberla::float64)(elMat_1_1));
             _data_mat[12] = ((walberla::float64)(elMat_1_2));
             _data_mat[13] = ((walberla::float64)(elMat_1_3));
             _data_mat[14] = ((walberla::float64)(elMat_1_4));
             _data_mat[15] = ((walberla::float64)(elMat_1_5));
             _data_mat[16] = ((walberla::float64)(elMat_1_6));
             _data_mat[17] = ((walberla::float64)(elMat_1_7));
             _data_mat[18] = ((walberla::float64)(elMat_1_8));
             _data_mat[19] = ((walberla::float64)(elMat_1_9));
             _data_mat[20] = ((walberla::float64)(elMat_2_0));
             _data_mat[21] = ((walberla::float64)(elMat_2_1));
             _data_mat[22] = ((walberla::float64)(elMat_2_2));
             _data_mat[23] = ((walberla::float64)(elMat_2_3));
             _data_mat[24] = ((walberla::float64)(elMat_2_4));
             _data_mat[25] = ((walberla::float64)(elMat_2_5));
             _data_mat[26] = ((walberla::float64)(elMat_2_6));
             _data_mat[27] = ((walberla::float64)(elMat_2_7));
             _data_mat[28] = ((walberla::float64)(elMat_2_8));
             _data_mat[29] = ((walberla::float64)(elMat_2_9));
             _data_mat[30] = ((walberla::float64)(elMat_3_0));
             _data_mat[31] = ((walberla::float64)(elMat_3_1));
             _data_mat[32] = ((walberla::float64)(elMat_3_2));
             _data_mat[33] = ((walberla::float64)(elMat_3_3));
             _data_mat[34] = ((walberla::float64)(elMat_3_4));
             _data_mat[35] = ((walberla::float64)(elMat_3_5));
             _data_mat[36] = ((walberla::float64)(elMat_3_6));
             _data_mat[37] = ((walberla::float64)(elMat_3_7));
             _data_mat[38] = ((walberla::float64)(elMat_3_8));
             _data_mat[39] = ((walberla::float64)(elMat_3_9));
             _data_mat[40] = ((walberla::float64)(elMat_4_0));
             _data_mat[41] = ((walberla::float64)(elMat_4_1));
             _data_mat[42] = ((walberla::float64)(elMat_4_2));
             _data_mat[43] = ((walberla::float64)(elMat_4_3));
             _data_mat[44] = ((walberla::float64)(elMat_4_4));
             _data_mat[45] = ((walberla::float64)(elMat_4_5));
             _data_mat[46] = ((walberla::float64)(elMat_4_6));
             _data_mat[47] = ((walberla::float64)(elMat_4_7));
             _data_mat[48] = ((walberla::float64)(elMat_4_8));
             _data_mat[49] = ((walberla::float64)(elMat_4_9));
             _data_mat[50] = ((walberla::float64)(elMat_5_0));
             _data_mat[51] = ((walberla::float64)(elMat_5_1));
             _data_mat[52] = ((walberla::float64)(elMat_5_2));
             _data_mat[53] = ((walberla::float64)(elMat_5_3));
             _data_mat[54] = ((walberla::float64)(elMat_5_4));
             _data_mat[55] = ((walberla::float64)(elMat_5_5));
             _data_mat[56] = ((walberla::float64)(elMat_5_6));
             _data_mat[57] = ((walberla::float64)(elMat_5_7));
             _data_mat[58] = ((walberla::float64)(elMat_5_8));
             _data_mat[59] = ((walberla::float64)(elMat_5_9));
             _data_mat[60] = ((walberla::float64)(elMat_6_0));
             _data_mat[61] = ((walberla::float64)(elMat_6_1));
             _data_mat[62] = ((walberla::float64)(elMat_6_2));
             _data_mat[63] = ((walberla::float64)(elMat_6_3));
             _data_mat[64] = ((walberla::float64)(elMat_6_4));
             _data_mat[65] = ((walberla::float64)(elMat_6_5));
             _data_mat[66] = ((walberla::float64)(elMat_6_6));
             _data_mat[67] = ((walberla::float64)(elMat_6_7));
             _data_mat[68] = ((walberla::float64)(elMat_6_8));
             _data_mat[69] = ((walberla::float64)(elMat_6_9));
             _data_mat[70] = ((walberla::float64)(elMat_7_0));
             _data_mat[71] = ((walberla::float64)(elMat_7_1));
             _data_mat[72] = ((walberla::float64)(elMat_7_2));
             _data_mat[73] = ((walberla::float64)(elMat_7_3));
             _data_mat[74] = ((walberla::float64)(elMat_7_4));
             _data_mat[75] = ((walberla::float64)(elMat_7_5));
             _data_mat[76] = ((walberla::float64)(elMat_7_6));
             _data_mat[77] = ((walberla::float64)(elMat_7_7));
             _data_mat[78] = ((walberla::float64)(elMat_7_8));
             _data_mat[79] = ((walberla::float64)(elMat_7_9));
             _data_mat[80] = ((walberla::float64)(elMat_8_0));
             _data_mat[81] = ((walberla::float64)(elMat_8_1));
             _data_mat[82] = ((walberla::float64)(elMat_8_2));
             _data_mat[83] = ((walberla::float64)(elMat_8_3));
             _data_mat[84] = ((walberla::float64)(elMat_8_4));
             _data_mat[85] = ((walberla::float64)(elMat_8_5));
             _data_mat[86] = ((walberla::float64)(elMat_8_6));
             _data_mat[87] = ((walberla::float64)(elMat_8_7));
             _data_mat[88] = ((walberla::float64)(elMat_8_8));
             _data_mat[89] = ((walberla::float64)(elMat_8_9));
             _data_mat[90] = ((walberla::float64)(elMat_9_0));
             _data_mat[91] = ((walberla::float64)(elMat_9_1));
             _data_mat[92] = ((walberla::float64)(elMat_9_2));
             _data_mat[93] = ((walberla::float64)(elMat_9_3));
             _data_mat[94] = ((walberla::float64)(elMat_9_4));
             _data_mat[95] = ((walberla::float64)(elMat_9_5));
             _data_mat[96] = ((walberla::float64)(elMat_9_6));
             _data_mat[97] = ((walberla::float64)(elMat_9_7));
             _data_mat[98] = ((walberla::float64)(elMat_9_8));
             _data_mat[99] = ((walberla::float64)(elMat_9_9));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const walberla::float64 tmp_coords_jac_0_BLUE_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const walberla::float64 tmp_coords_jac_1_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const walberla::float64 tmp_coords_jac_2_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const walberla::float64 tmp_coords_jac_3_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const walberla::float64 tmp_coords_jac_4_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const walberla::float64 tmp_coords_jac_5_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const walberla::float64 tmp_coords_jac_6_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const walberla::float64 p_affine_const_0_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP;
       const walberla::float64 p_affine_const_0_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP;
       const walberla::float64 p_affine_const_0_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP;
       const walberla::float64 p_affine_const_1_0_BLUE_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_UP;
       const walberla::float64 p_affine_const_1_1_BLUE_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_BLUE_UP;
       const walberla::float64 p_affine_const_1_2_BLUE_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_BLUE_UP;
       const walberla::float64 p_affine_const_2_0_BLUE_UP = tmp_coords_jac_1_BLUE_UP + tmp_coords_jac_4_BLUE_UP;
       const walberla::float64 p_affine_const_2_1_BLUE_UP = tmp_coords_jac_2_BLUE_UP + tmp_coords_jac_5_BLUE_UP;
       const walberla::float64 p_affine_const_2_2_BLUE_UP = tmp_coords_jac_3_BLUE_UP + tmp_coords_jac_6_BLUE_UP;
       const walberla::float64 p_affine_const_3_0_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0) + tmp_coords_jac_1_BLUE_UP;
       const walberla::float64 p_affine_const_3_1_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1) + tmp_coords_jac_2_BLUE_UP;
       const walberla::float64 p_affine_const_3_2_BLUE_UP = tmp_coords_jac_0_BLUE_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2) + tmp_coords_jac_3_BLUE_UP;
       const walberla::float64 jac_affine_0_0_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_1_0_BLUE_UP;
       const walberla::float64 jac_affine_0_1_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_2_0_BLUE_UP;
       const walberla::float64 jac_affine_0_2_BLUE_UP = -p_affine_const_0_0_BLUE_UP + p_affine_const_3_0_BLUE_UP;
       const walberla::float64 jac_affine_1_0_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_1_1_BLUE_UP;
       const walberla::float64 jac_affine_1_1_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_2_1_BLUE_UP;
       const walberla::float64 tmp_coords_jac_11_BLUE_UP = jac_affine_0_2_BLUE_UP*jac_affine_1_1_BLUE_UP;
       const walberla::float64 jac_affine_1_2_BLUE_UP = -p_affine_const_0_1_BLUE_UP + p_affine_const_3_1_BLUE_UP;
       const walberla::float64 tmp_coords_jac_9_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_1_2_BLUE_UP;
       const walberla::float64 jac_affine_2_0_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_1_2_BLUE_UP;
       const walberla::float64 jac_affine_2_1_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_2_2_BLUE_UP;
       const walberla::float64 tmp_coords_jac_8_BLUE_UP = jac_affine_1_2_BLUE_UP*jac_affine_2_1_BLUE_UP;
       const walberla::float64 jac_affine_2_2_BLUE_UP = -p_affine_const_0_2_BLUE_UP + p_affine_const_3_2_BLUE_UP;
       const walberla::float64 tmp_coords_jac_7_BLUE_UP = jac_affine_1_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const walberla::float64 tmp_coords_jac_10_BLUE_UP = jac_affine_0_1_BLUE_UP*jac_affine_2_2_BLUE_UP;
       const walberla::float64 tmp_coords_jac_12_BLUE_UP = jac_affine_0_0_BLUE_UP*tmp_coords_jac_7_BLUE_UP - jac_affine_0_0_BLUE_UP*tmp_coords_jac_8_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_0_BLUE_UP*tmp_coords_jac_10_BLUE_UP - jac_affine_2_0_BLUE_UP*tmp_coords_jac_11_BLUE_UP + jac_affine_2_0_BLUE_UP*tmp_coords_jac_9_BLUE_UP;
       const walberla::float64 tmp_coords_jac_13_BLUE_UP = 1.0 / (tmp_coords_jac_12_BLUE_UP);
       const walberla::float64 jac_affine_inv_0_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(tmp_coords_jac_7_BLUE_UP - tmp_coords_jac_8_BLUE_UP);
       const walberla::float64 jac_affine_inv_0_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_2_BLUE_UP*jac_affine_2_1_BLUE_UP - tmp_coords_jac_10_BLUE_UP);
       const walberla::float64 jac_affine_inv_0_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-tmp_coords_jac_11_BLUE_UP + tmp_coords_jac_9_BLUE_UP);
       const walberla::float64 jac_affine_inv_1_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_1_0_BLUE_UP*jac_affine_2_2_BLUE_UP + jac_affine_1_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const walberla::float64 jac_affine_inv_1_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_2_2_BLUE_UP - jac_affine_0_2_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const walberla::float64 jac_affine_inv_1_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_1_2_BLUE_UP + jac_affine_0_2_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const walberla::float64 jac_affine_inv_2_0_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_1_0_BLUE_UP*jac_affine_2_1_BLUE_UP - jac_affine_1_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const walberla::float64 jac_affine_inv_2_1_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(-jac_affine_0_0_BLUE_UP*jac_affine_2_1_BLUE_UP + jac_affine_0_1_BLUE_UP*jac_affine_2_0_BLUE_UP);
       const walberla::float64 jac_affine_inv_2_2_BLUE_UP = tmp_coords_jac_13_BLUE_UP*(jac_affine_0_0_BLUE_UP*jac_affine_1_1_BLUE_UP - jac_affine_0_1_BLUE_UP*jac_affine_1_0_BLUE_UP);
       const walberla::float64 abs_det_jac_affine_BLUE_UP = abs(tmp_coords_jac_12_BLUE_UP);
       {
          /* CellType.BLUE_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
             const walberla::float64 k_dof_0 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 k_dof_1 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 k_dof_2 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 k_dof_3 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 k_dof_4 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const walberla::float64 k_dof_5 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const walberla::float64 k_dof_6 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const walberla::float64 k_dof_7 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const walberla::float64 k_dof_8 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const walberla::float64 k_dof_9 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             walberla::float64 q_acc_0_0 = 0.0;
             walberla::float64 q_acc_0_1 = 0.0;
             walberla::float64 q_acc_0_2 = 0.0;
             walberla::float64 q_acc_0_3 = 0.0;
             walberla::float64 q_acc_0_4 = 0.0;
             walberla::float64 q_acc_0_5 = 0.0;
             walberla::float64 q_acc_0_6 = 0.0;
             walberla::float64 q_acc_0_7 = 0.0;
             walberla::float64 q_acc_0_8 = 0.0;
             walberla::float64 q_acc_0_9 = 0.0;
             walberla::float64 q_acc_1_1 = 0.0;
             walberla::float64 q_acc_1_2 = 0.0;
             walberla::float64 q_acc_1_3 = 0.0;
             walberla::float64 q_acc_1_4 = 0.0;
             walberla::float64 q_acc_1_5 = 0.0;
             walberla::float64 q_acc_1_6 = 0.0;
             walberla::float64 q_acc_1_7 = 0.0;
             walberla::float64 q_acc_1_8 = 0.0;
             walberla::float64 q_acc_1_9 = 0.0;
             walberla::float64 q_acc_2_2 = 0.0;
             walberla::float64 q_acc_2_3 = 0.0;
             walberla::float64 q_acc_2_4 = 0.0;
             walberla::float64 q_acc_2_5 = 0.0;
             walberla::float64 q_acc_2_6 = 0.0;
             walberla::float64 q_acc_2_7 = 0.0;
             walberla::float64 q_acc_2_8 = 0.0;
             walberla::float64 q_acc_2_9 = 0.0;
             walberla::float64 q_acc_3_3 = 0.0;
             walberla::float64 q_acc_3_4 = 0.0;
             walberla::float64 q_acc_3_5 = 0.0;
             walberla::float64 q_acc_3_6 = 0.0;
             walberla::float64 q_acc_3_7 = 0.0;
             walberla::float64 q_acc_3_8 = 0.0;
             walberla::float64 q_acc_3_9 = 0.0;
             walberla::float64 q_acc_4_4 = 0.0;
             walberla::float64 q_acc_4_5 = 0.0;
             walberla::float64 q_acc_4_6 = 0.0;
             walberla::float64 q_acc_4_7 = 0.0;
             walberla::float64 q_acc_4_8 = 0.0;
             walberla::float64 q_acc_4_9 = 0.0;
             walberla::float64 q_acc_5_5 = 0.0;
             walberla::float64 q_acc_5_6 = 0.0;
             walberla::float64 q_acc_5_7 = 0.0;
             walberla::float64 q_acc_5_8 = 0.0;
             walberla::float64 q_acc_5_9 = 0.0;
             walberla::float64 q_acc_6_6 = 0.0;
             walberla::float64 q_acc_6_7 = 0.0;
             walberla::float64 q_acc_6_8 = 0.0;
             walberla::float64 q_acc_6_9 = 0.0;
             walberla::float64 q_acc_7_7 = 0.0;
             walberla::float64 q_acc_7_8 = 0.0;
             walberla::float64 q_acc_7_9 = 0.0;
             walberla::float64 q_acc_8_8 = 0.0;
             walberla::float64 q_acc_8_9 = 0.0;
             walberla::float64 q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const walberla::float64 tmp_qloop_0 = 4.0*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_1 = 4.0*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_2 = 4.0*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_3 = tmp_qloop_1 + tmp_qloop_2;
                const walberla::float64 tmp_qloop_4 = tmp_qloop_0 + tmp_qloop_3 - 3.0;
                const walberla::float64 tmp_qloop_5 = jac_affine_inv_0_0_BLUE_UP*tmp_qloop_4 + jac_affine_inv_1_0_BLUE_UP*tmp_qloop_4 + jac_affine_inv_2_0_BLUE_UP*tmp_qloop_4;
                const walberla::float64 tmp_qloop_6 = jac_affine_inv_0_1_BLUE_UP*tmp_qloop_4 + jac_affine_inv_1_1_BLUE_UP*tmp_qloop_4 + jac_affine_inv_2_1_BLUE_UP*tmp_qloop_4;
                const walberla::float64 tmp_qloop_7 = jac_affine_inv_0_2_BLUE_UP*tmp_qloop_4 + jac_affine_inv_1_2_BLUE_UP*tmp_qloop_4 + jac_affine_inv_2_2_BLUE_UP*tmp_qloop_4;
                const walberla::float64 tmp_qloop_8 = tmp_qloop_1*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_9 = tmp_qloop_1*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_10 = tmp_qloop_2*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_11 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const walberla::float64 tmp_qloop_12 = tmp_qloop_11*2.0;
                const walberla::float64 tmp_qloop_13 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const walberla::float64 tmp_qloop_14 = tmp_qloop_13*2.0;
                const walberla::float64 tmp_qloop_15 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const walberla::float64 tmp_qloop_16 = tmp_qloop_15*2.0;
                const walberla::float64 tmp_qloop_17 = tmp_qloop_8 + tmp_qloop_9;
                const walberla::float64 tmp_qloop_18 = abs_det_jac_affine_BLUE_UP*(k_dof_0*(tmp_qloop_10 + tmp_qloop_12 + tmp_qloop_14 + tmp_qloop_16 + tmp_qloop_17 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0) + k_dof_1*(tmp_qloop_12 - _data_q_p_0[q]) + k_dof_2*(tmp_qloop_14 - _data_q_p_1[q]) + k_dof_3*(tmp_qloop_16 - _data_q_p_2[q]) + k_dof_4*tmp_qloop_10 + k_dof_5*tmp_qloop_9 + k_dof_6*tmp_qloop_8 + k_dof_7*(tmp_qloop_0 - tmp_qloop_10 + tmp_qloop_15*-4.0 - tmp_qloop_9) + k_dof_8*(-tmp_qloop_10 + tmp_qloop_13*-4.0 + tmp_qloop_2 - tmp_qloop_8) + k_dof_9*(tmp_qloop_1 + tmp_qloop_11*-4.0 - tmp_qloop_17))*_data_q_w[q];
                const walberla::float64 tmp_qloop_19 = tmp_qloop_1 - 1.0;
                const walberla::float64 tmp_qloop_20 = jac_affine_inv_0_0_BLUE_UP*tmp_qloop_19;
                const walberla::float64 tmp_qloop_21 = jac_affine_inv_0_1_BLUE_UP*tmp_qloop_19;
                const walberla::float64 tmp_qloop_22 = jac_affine_inv_0_2_BLUE_UP*tmp_qloop_19;
                const walberla::float64 tmp_qloop_23 = tmp_qloop_2 - 1.0;
                const walberla::float64 tmp_qloop_24 = jac_affine_inv_1_0_BLUE_UP*tmp_qloop_23;
                const walberla::float64 tmp_qloop_25 = jac_affine_inv_1_1_BLUE_UP*tmp_qloop_23;
                const walberla::float64 tmp_qloop_26 = jac_affine_inv_1_2_BLUE_UP*tmp_qloop_23;
                const walberla::float64 tmp_qloop_27 = tmp_qloop_0 - 1.0;
                const walberla::float64 tmp_qloop_28 = jac_affine_inv_2_0_BLUE_UP*tmp_qloop_27;
                const walberla::float64 tmp_qloop_29 = jac_affine_inv_2_1_BLUE_UP*tmp_qloop_27;
                const walberla::float64 tmp_qloop_30 = jac_affine_inv_2_2_BLUE_UP*tmp_qloop_27;
                const walberla::float64 tmp_qloop_31 = jac_affine_inv_2_0_BLUE_UP*tmp_qloop_2;
                const walberla::float64 tmp_qloop_32 = jac_affine_inv_1_0_BLUE_UP*tmp_qloop_0;
                const walberla::float64 tmp_qloop_33 = tmp_qloop_31 + tmp_qloop_32;
                const walberla::float64 tmp_qloop_34 = jac_affine_inv_2_1_BLUE_UP*tmp_qloop_2;
                const walberla::float64 tmp_qloop_35 = jac_affine_inv_1_1_BLUE_UP*tmp_qloop_0;
                const walberla::float64 tmp_qloop_36 = tmp_qloop_34 + tmp_qloop_35;
                const walberla::float64 tmp_qloop_37 = jac_affine_inv_2_2_BLUE_UP*tmp_qloop_2;
                const walberla::float64 tmp_qloop_38 = jac_affine_inv_1_2_BLUE_UP*tmp_qloop_0;
                const walberla::float64 tmp_qloop_39 = tmp_qloop_37 + tmp_qloop_38;
                const walberla::float64 tmp_qloop_40 = jac_affine_inv_2_0_BLUE_UP*tmp_qloop_1;
                const walberla::float64 tmp_qloop_41 = jac_affine_inv_0_0_BLUE_UP*tmp_qloop_0;
                const walberla::float64 tmp_qloop_42 = tmp_qloop_40 + tmp_qloop_41;
                const walberla::float64 tmp_qloop_43 = jac_affine_inv_2_1_BLUE_UP*tmp_qloop_1;
                const walberla::float64 tmp_qloop_44 = jac_affine_inv_0_1_BLUE_UP*tmp_qloop_0;
                const walberla::float64 tmp_qloop_45 = tmp_qloop_43 + tmp_qloop_44;
                const walberla::float64 tmp_qloop_46 = jac_affine_inv_2_2_BLUE_UP*tmp_qloop_1;
                const walberla::float64 tmp_qloop_47 = jac_affine_inv_0_2_BLUE_UP*tmp_qloop_0;
                const walberla::float64 tmp_qloop_48 = tmp_qloop_46 + tmp_qloop_47;
                const walberla::float64 tmp_qloop_49 = jac_affine_inv_1_0_BLUE_UP*tmp_qloop_1;
                const walberla::float64 tmp_qloop_50 = jac_affine_inv_0_0_BLUE_UP*tmp_qloop_2;
                const walberla::float64 tmp_qloop_51 = tmp_qloop_49 + tmp_qloop_50;
                const walberla::float64 tmp_qloop_52 = jac_affine_inv_1_1_BLUE_UP*tmp_qloop_1;
                const walberla::float64 tmp_qloop_53 = jac_affine_inv_0_1_BLUE_UP*tmp_qloop_2;
                const walberla::float64 tmp_qloop_54 = tmp_qloop_52 + tmp_qloop_53;
                const walberla::float64 tmp_qloop_55 = jac_affine_inv_1_2_BLUE_UP*tmp_qloop_1;
                const walberla::float64 tmp_qloop_56 = jac_affine_inv_0_2_BLUE_UP*tmp_qloop_2;
                const walberla::float64 tmp_qloop_57 = tmp_qloop_55 + tmp_qloop_56;
                const walberla::float64 tmp_qloop_58 = -tmp_qloop_3 - 8.0*_data_q_p_2[q] + 4.0;
                const walberla::float64 tmp_qloop_59 = jac_affine_inv_2_0_BLUE_UP*tmp_qloop_58 - tmp_qloop_32 - tmp_qloop_41;
                const walberla::float64 tmp_qloop_60 = jac_affine_inv_2_1_BLUE_UP*tmp_qloop_58 - tmp_qloop_35 - tmp_qloop_44;
                const walberla::float64 tmp_qloop_61 = jac_affine_inv_2_2_BLUE_UP*tmp_qloop_58 - tmp_qloop_38 - tmp_qloop_47;
                const walberla::float64 tmp_qloop_62 = tmp_qloop_0 - 4.0;
                const walberla::float64 tmp_qloop_63 = -tmp_qloop_1 - tmp_qloop_62 - 8.0*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_64 = jac_affine_inv_1_0_BLUE_UP*tmp_qloop_63 - tmp_qloop_31 - tmp_qloop_50;
                const walberla::float64 tmp_qloop_65 = jac_affine_inv_1_1_BLUE_UP*tmp_qloop_63 - tmp_qloop_34 - tmp_qloop_53;
                const walberla::float64 tmp_qloop_66 = jac_affine_inv_1_2_BLUE_UP*tmp_qloop_63 - tmp_qloop_37 - tmp_qloop_56;
                const walberla::float64 tmp_qloop_67 = -tmp_qloop_2 - tmp_qloop_62 - 8.0*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_68 = jac_affine_inv_0_0_BLUE_UP*tmp_qloop_67 - tmp_qloop_40 - tmp_qloop_49;
                const walberla::float64 tmp_qloop_69 = jac_affine_inv_0_1_BLUE_UP*tmp_qloop_67 - tmp_qloop_43 - tmp_qloop_52;
                const walberla::float64 tmp_qloop_70 = jac_affine_inv_0_2_BLUE_UP*tmp_qloop_67 - tmp_qloop_46 - tmp_qloop_55;
                const walberla::float64 tmp_qloop_71 = ((-0.25 + _data_q_p_0[q])*(-0.25 + _data_q_p_0[q]))*16.0;
                const walberla::float64 tmp_qloop_72 = ((-0.25 + _data_q_p_1[q])*(-0.25 + _data_q_p_1[q]))*16.0;
                const walberla::float64 tmp_qloop_73 = ((-0.25 + _data_q_p_2[q])*(-0.25 + _data_q_p_2[q]))*16.0;
                const walberla::float64 tmp_qloop_74 = jac_affine_inv_2_0_BLUE_UP*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_75 = jac_affine_inv_1_0_BLUE_UP*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_76 = jac_affine_inv_2_1_BLUE_UP*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_77 = jac_affine_inv_1_1_BLUE_UP*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_78 = jac_affine_inv_2_2_BLUE_UP*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_79 = jac_affine_inv_1_2_BLUE_UP*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_80 = jac_affine_inv_2_0_BLUE_UP*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_81 = jac_affine_inv_0_0_BLUE_UP*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_82 = jac_affine_inv_2_1_BLUE_UP*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_83 = jac_affine_inv_0_1_BLUE_UP*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_84 = jac_affine_inv_2_2_BLUE_UP*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_85 = jac_affine_inv_0_2_BLUE_UP*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_86 = jac_affine_inv_1_0_BLUE_UP*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_87 = jac_affine_inv_0_0_BLUE_UP*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_88 = jac_affine_inv_1_1_BLUE_UP*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_89 = jac_affine_inv_0_1_BLUE_UP*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_90 = jac_affine_inv_1_2_BLUE_UP*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_91 = jac_affine_inv_0_2_BLUE_UP*_data_q_p_1[q];
                const walberla::float64 q_tmp_0_0 = tmp_qloop_18*((tmp_qloop_5*tmp_qloop_5) + (tmp_qloop_6*tmp_qloop_6) + (tmp_qloop_7*tmp_qloop_7));
                const walberla::float64 q_tmp_0_1 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_5 + tmp_qloop_21*tmp_qloop_6 + tmp_qloop_22*tmp_qloop_7);
                const walberla::float64 q_tmp_0_2 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_5 + tmp_qloop_25*tmp_qloop_6 + tmp_qloop_26*tmp_qloop_7);
                const walberla::float64 q_tmp_0_3 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_5 + tmp_qloop_29*tmp_qloop_6 + tmp_qloop_30*tmp_qloop_7);
                const walberla::float64 q_tmp_0_4 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_5 + tmp_qloop_36*tmp_qloop_6 + tmp_qloop_39*tmp_qloop_7);
                const walberla::float64 q_tmp_0_5 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_5 + tmp_qloop_45*tmp_qloop_6 + tmp_qloop_48*tmp_qloop_7);
                const walberla::float64 q_tmp_0_6 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_51 + tmp_qloop_54*tmp_qloop_6 + tmp_qloop_57*tmp_qloop_7);
                const walberla::float64 q_tmp_0_7 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_59 + tmp_qloop_6*tmp_qloop_60 + tmp_qloop_61*tmp_qloop_7);
                const walberla::float64 q_tmp_0_8 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_64 + tmp_qloop_6*tmp_qloop_65 + tmp_qloop_66*tmp_qloop_7);
                const walberla::float64 q_tmp_0_9 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_68 + tmp_qloop_6*tmp_qloop_69 + tmp_qloop_7*tmp_qloop_70);
                const walberla::float64 q_tmp_1_1 = tmp_qloop_18*((jac_affine_inv_0_0_BLUE_UP*jac_affine_inv_0_0_BLUE_UP)*tmp_qloop_71 + (jac_affine_inv_0_1_BLUE_UP*jac_affine_inv_0_1_BLUE_UP)*tmp_qloop_71 + (jac_affine_inv_0_2_BLUE_UP*jac_affine_inv_0_2_BLUE_UP)*tmp_qloop_71);
                const walberla::float64 q_tmp_1_2 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_24 + tmp_qloop_21*tmp_qloop_25 + tmp_qloop_22*tmp_qloop_26);
                const walberla::float64 q_tmp_1_3 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_28 + tmp_qloop_21*tmp_qloop_29 + tmp_qloop_22*tmp_qloop_30);
                const walberla::float64 q_tmp_1_4 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_33 + tmp_qloop_21*tmp_qloop_36 + tmp_qloop_22*tmp_qloop_39);
                const walberla::float64 q_tmp_1_5 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_42 + tmp_qloop_21*tmp_qloop_45 + tmp_qloop_22*tmp_qloop_48);
                const walberla::float64 q_tmp_1_6 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_51 + tmp_qloop_21*tmp_qloop_54 + tmp_qloop_22*tmp_qloop_57);
                const walberla::float64 q_tmp_1_7 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_59 + tmp_qloop_21*tmp_qloop_60 + tmp_qloop_22*tmp_qloop_61);
                const walberla::float64 q_tmp_1_8 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_64 + tmp_qloop_21*tmp_qloop_65 + tmp_qloop_22*tmp_qloop_66);
                const walberla::float64 q_tmp_1_9 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_68 + tmp_qloop_21*tmp_qloop_69 + tmp_qloop_22*tmp_qloop_70);
                const walberla::float64 q_tmp_2_2 = tmp_qloop_18*((jac_affine_inv_1_0_BLUE_UP*jac_affine_inv_1_0_BLUE_UP)*tmp_qloop_72 + (jac_affine_inv_1_1_BLUE_UP*jac_affine_inv_1_1_BLUE_UP)*tmp_qloop_72 + (jac_affine_inv_1_2_BLUE_UP*jac_affine_inv_1_2_BLUE_UP)*tmp_qloop_72);
                const walberla::float64 q_tmp_2_3 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_28 + tmp_qloop_25*tmp_qloop_29 + tmp_qloop_26*tmp_qloop_30);
                const walberla::float64 q_tmp_2_4 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_33 + tmp_qloop_25*tmp_qloop_36 + tmp_qloop_26*tmp_qloop_39);
                const walberla::float64 q_tmp_2_5 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_42 + tmp_qloop_25*tmp_qloop_45 + tmp_qloop_26*tmp_qloop_48);
                const walberla::float64 q_tmp_2_6 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_51 + tmp_qloop_25*tmp_qloop_54 + tmp_qloop_26*tmp_qloop_57);
                const walberla::float64 q_tmp_2_7 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_59 + tmp_qloop_25*tmp_qloop_60 + tmp_qloop_26*tmp_qloop_61);
                const walberla::float64 q_tmp_2_8 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_64 + tmp_qloop_25*tmp_qloop_65 + tmp_qloop_26*tmp_qloop_66);
                const walberla::float64 q_tmp_2_9 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_68 + tmp_qloop_25*tmp_qloop_69 + tmp_qloop_26*tmp_qloop_70);
                const walberla::float64 q_tmp_3_3 = tmp_qloop_18*((jac_affine_inv_2_0_BLUE_UP*jac_affine_inv_2_0_BLUE_UP)*tmp_qloop_73 + (jac_affine_inv_2_1_BLUE_UP*jac_affine_inv_2_1_BLUE_UP)*tmp_qloop_73 + (jac_affine_inv_2_2_BLUE_UP*jac_affine_inv_2_2_BLUE_UP)*tmp_qloop_73);
                const walberla::float64 q_tmp_3_4 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_33 + tmp_qloop_29*tmp_qloop_36 + tmp_qloop_30*tmp_qloop_39);
                const walberla::float64 q_tmp_3_5 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_42 + tmp_qloop_29*tmp_qloop_45 + tmp_qloop_30*tmp_qloop_48);
                const walberla::float64 q_tmp_3_6 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_51 + tmp_qloop_29*tmp_qloop_54 + tmp_qloop_30*tmp_qloop_57);
                const walberla::float64 q_tmp_3_7 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_59 + tmp_qloop_29*tmp_qloop_60 + tmp_qloop_30*tmp_qloop_61);
                const walberla::float64 q_tmp_3_8 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_64 + tmp_qloop_29*tmp_qloop_65 + tmp_qloop_30*tmp_qloop_66);
                const walberla::float64 q_tmp_3_9 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_68 + tmp_qloop_29*tmp_qloop_69 + tmp_qloop_30*tmp_qloop_70);
                const walberla::float64 q_tmp_4_4 = tmp_qloop_18*(((tmp_qloop_74 + tmp_qloop_75)*(tmp_qloop_74 + tmp_qloop_75))*16.0 + ((tmp_qloop_76 + tmp_qloop_77)*(tmp_qloop_76 + tmp_qloop_77))*16.0 + ((tmp_qloop_78 + tmp_qloop_79)*(tmp_qloop_78 + tmp_qloop_79))*16.0);
                const walberla::float64 q_tmp_4_5 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_42 + tmp_qloop_36*tmp_qloop_45 + tmp_qloop_39*tmp_qloop_48);
                const walberla::float64 q_tmp_4_6 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_51 + tmp_qloop_36*tmp_qloop_54 + tmp_qloop_39*tmp_qloop_57);
                const walberla::float64 q_tmp_4_7 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_59 + tmp_qloop_36*tmp_qloop_60 + tmp_qloop_39*tmp_qloop_61);
                const walberla::float64 q_tmp_4_8 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_64 + tmp_qloop_36*tmp_qloop_65 + tmp_qloop_39*tmp_qloop_66);
                const walberla::float64 q_tmp_4_9 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_68 + tmp_qloop_36*tmp_qloop_69 + tmp_qloop_39*tmp_qloop_70);
                const walberla::float64 q_tmp_5_5 = tmp_qloop_18*(((tmp_qloop_80 + tmp_qloop_81)*(tmp_qloop_80 + tmp_qloop_81))*16.0 + ((tmp_qloop_82 + tmp_qloop_83)*(tmp_qloop_82 + tmp_qloop_83))*16.0 + ((tmp_qloop_84 + tmp_qloop_85)*(tmp_qloop_84 + tmp_qloop_85))*16.0);
                const walberla::float64 q_tmp_5_6 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_51 + tmp_qloop_45*tmp_qloop_54 + tmp_qloop_48*tmp_qloop_57);
                const walberla::float64 q_tmp_5_7 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_59 + tmp_qloop_45*tmp_qloop_60 + tmp_qloop_48*tmp_qloop_61);
                const walberla::float64 q_tmp_5_8 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_64 + tmp_qloop_45*tmp_qloop_65 + tmp_qloop_48*tmp_qloop_66);
                const walberla::float64 q_tmp_5_9 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_68 + tmp_qloop_45*tmp_qloop_69 + tmp_qloop_48*tmp_qloop_70);
                const walberla::float64 q_tmp_6_6 = tmp_qloop_18*(((tmp_qloop_86 + tmp_qloop_87)*(tmp_qloop_86 + tmp_qloop_87))*16.0 + ((tmp_qloop_88 + tmp_qloop_89)*(tmp_qloop_88 + tmp_qloop_89))*16.0 + ((tmp_qloop_90 + tmp_qloop_91)*(tmp_qloop_90 + tmp_qloop_91))*16.0);
                const walberla::float64 q_tmp_6_7 = tmp_qloop_18*(tmp_qloop_51*tmp_qloop_59 + tmp_qloop_54*tmp_qloop_60 + tmp_qloop_57*tmp_qloop_61);
                const walberla::float64 q_tmp_6_8 = tmp_qloop_18*(tmp_qloop_51*tmp_qloop_64 + tmp_qloop_54*tmp_qloop_65 + tmp_qloop_57*tmp_qloop_66);
                const walberla::float64 q_tmp_6_9 = tmp_qloop_18*(tmp_qloop_51*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_57*tmp_qloop_70);
                const walberla::float64 q_tmp_7_7 = tmp_qloop_18*(((jac_affine_inv_2_0_BLUE_UP*tmp_qloop_58*0.25 - tmp_qloop_75 - tmp_qloop_81)*(jac_affine_inv_2_0_BLUE_UP*tmp_qloop_58*0.25 - tmp_qloop_75 - tmp_qloop_81))*16.0 + ((jac_affine_inv_2_1_BLUE_UP*tmp_qloop_58*0.25 - tmp_qloop_77 - tmp_qloop_83)*(jac_affine_inv_2_1_BLUE_UP*tmp_qloop_58*0.25 - tmp_qloop_77 - tmp_qloop_83))*16.0 + ((jac_affine_inv_2_2_BLUE_UP*tmp_qloop_58*0.25 - tmp_qloop_79 - tmp_qloop_85)*(jac_affine_inv_2_2_BLUE_UP*tmp_qloop_58*0.25 - tmp_qloop_79 - tmp_qloop_85))*16.0);
                const walberla::float64 q_tmp_7_8 = tmp_qloop_18*(tmp_qloop_59*tmp_qloop_64 + tmp_qloop_60*tmp_qloop_65 + tmp_qloop_61*tmp_qloop_66);
                const walberla::float64 q_tmp_7_9 = tmp_qloop_18*(tmp_qloop_59*tmp_qloop_68 + tmp_qloop_60*tmp_qloop_69 + tmp_qloop_61*tmp_qloop_70);
                const walberla::float64 q_tmp_8_8 = tmp_qloop_18*(((jac_affine_inv_1_0_BLUE_UP*tmp_qloop_63*0.25 - tmp_qloop_74 - tmp_qloop_87)*(jac_affine_inv_1_0_BLUE_UP*tmp_qloop_63*0.25 - tmp_qloop_74 - tmp_qloop_87))*16.0 + ((jac_affine_inv_1_1_BLUE_UP*tmp_qloop_63*0.25 - tmp_qloop_76 - tmp_qloop_89)*(jac_affine_inv_1_1_BLUE_UP*tmp_qloop_63*0.25 - tmp_qloop_76 - tmp_qloop_89))*16.0 + ((jac_affine_inv_1_2_BLUE_UP*tmp_qloop_63*0.25 - tmp_qloop_78 - tmp_qloop_91)*(jac_affine_inv_1_2_BLUE_UP*tmp_qloop_63*0.25 - tmp_qloop_78 - tmp_qloop_91))*16.0);
                const walberla::float64 q_tmp_8_9 = tmp_qloop_18*(tmp_qloop_64*tmp_qloop_68 + tmp_qloop_65*tmp_qloop_69 + tmp_qloop_66*tmp_qloop_70);
                const walberla::float64 q_tmp_9_9 = tmp_qloop_18*(((jac_affine_inv_0_0_BLUE_UP*tmp_qloop_67*0.25 - tmp_qloop_80 - tmp_qloop_86)*(jac_affine_inv_0_0_BLUE_UP*tmp_qloop_67*0.25 - tmp_qloop_80 - tmp_qloop_86))*16.0 + ((jac_affine_inv_0_1_BLUE_UP*tmp_qloop_67*0.25 - tmp_qloop_82 - tmp_qloop_88)*(jac_affine_inv_0_1_BLUE_UP*tmp_qloop_67*0.25 - tmp_qloop_82 - tmp_qloop_88))*16.0 + ((jac_affine_inv_0_2_BLUE_UP*tmp_qloop_67*0.25 - tmp_qloop_84 - tmp_qloop_90)*(jac_affine_inv_0_2_BLUE_UP*tmp_qloop_67*0.25 - tmp_qloop_84 - tmp_qloop_90))*16.0);
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const walberla::float64 elMat_0_0 = q_acc_0_0;
             const walberla::float64 elMat_0_1 = q_acc_0_1;
             const walberla::float64 elMat_0_2 = q_acc_0_2;
             const walberla::float64 elMat_0_3 = q_acc_0_3;
             const walberla::float64 elMat_0_4 = q_acc_0_4;
             const walberla::float64 elMat_0_5 = q_acc_0_5;
             const walberla::float64 elMat_0_6 = q_acc_0_6;
             const walberla::float64 elMat_0_7 = q_acc_0_7;
             const walberla::float64 elMat_0_8 = q_acc_0_8;
             const walberla::float64 elMat_0_9 = q_acc_0_9;
             const walberla::float64 elMat_1_0 = q_acc_0_1;
             const walberla::float64 elMat_1_1 = q_acc_1_1;
             const walberla::float64 elMat_1_2 = q_acc_1_2;
             const walberla::float64 elMat_1_3 = q_acc_1_3;
             const walberla::float64 elMat_1_4 = q_acc_1_4;
             const walberla::float64 elMat_1_5 = q_acc_1_5;
             const walberla::float64 elMat_1_6 = q_acc_1_6;
             const walberla::float64 elMat_1_7 = q_acc_1_7;
             const walberla::float64 elMat_1_8 = q_acc_1_8;
             const walberla::float64 elMat_1_9 = q_acc_1_9;
             const walberla::float64 elMat_2_0 = q_acc_0_2;
             const walberla::float64 elMat_2_1 = q_acc_1_2;
             const walberla::float64 elMat_2_2 = q_acc_2_2;
             const walberla::float64 elMat_2_3 = q_acc_2_3;
             const walberla::float64 elMat_2_4 = q_acc_2_4;
             const walberla::float64 elMat_2_5 = q_acc_2_5;
             const walberla::float64 elMat_2_6 = q_acc_2_6;
             const walberla::float64 elMat_2_7 = q_acc_2_7;
             const walberla::float64 elMat_2_8 = q_acc_2_8;
             const walberla::float64 elMat_2_9 = q_acc_2_9;
             const walberla::float64 elMat_3_0 = q_acc_0_3;
             const walberla::float64 elMat_3_1 = q_acc_1_3;
             const walberla::float64 elMat_3_2 = q_acc_2_3;
             const walberla::float64 elMat_3_3 = q_acc_3_3;
             const walberla::float64 elMat_3_4 = q_acc_3_4;
             const walberla::float64 elMat_3_5 = q_acc_3_5;
             const walberla::float64 elMat_3_6 = q_acc_3_6;
             const walberla::float64 elMat_3_7 = q_acc_3_7;
             const walberla::float64 elMat_3_8 = q_acc_3_8;
             const walberla::float64 elMat_3_9 = q_acc_3_9;
             const walberla::float64 elMat_4_0 = q_acc_0_4;
             const walberla::float64 elMat_4_1 = q_acc_1_4;
             const walberla::float64 elMat_4_2 = q_acc_2_4;
             const walberla::float64 elMat_4_3 = q_acc_3_4;
             const walberla::float64 elMat_4_4 = q_acc_4_4;
             const walberla::float64 elMat_4_5 = q_acc_4_5;
             const walberla::float64 elMat_4_6 = q_acc_4_6;
             const walberla::float64 elMat_4_7 = q_acc_4_7;
             const walberla::float64 elMat_4_8 = q_acc_4_8;
             const walberla::float64 elMat_4_9 = q_acc_4_9;
             const walberla::float64 elMat_5_0 = q_acc_0_5;
             const walberla::float64 elMat_5_1 = q_acc_1_5;
             const walberla::float64 elMat_5_2 = q_acc_2_5;
             const walberla::float64 elMat_5_3 = q_acc_3_5;
             const walberla::float64 elMat_5_4 = q_acc_4_5;
             const walberla::float64 elMat_5_5 = q_acc_5_5;
             const walberla::float64 elMat_5_6 = q_acc_5_6;
             const walberla::float64 elMat_5_7 = q_acc_5_7;
             const walberla::float64 elMat_5_8 = q_acc_5_8;
             const walberla::float64 elMat_5_9 = q_acc_5_9;
             const walberla::float64 elMat_6_0 = q_acc_0_6;
             const walberla::float64 elMat_6_1 = q_acc_1_6;
             const walberla::float64 elMat_6_2 = q_acc_2_6;
             const walberla::float64 elMat_6_3 = q_acc_3_6;
             const walberla::float64 elMat_6_4 = q_acc_4_6;
             const walberla::float64 elMat_6_5 = q_acc_5_6;
             const walberla::float64 elMat_6_6 = q_acc_6_6;
             const walberla::float64 elMat_6_7 = q_acc_6_7;
             const walberla::float64 elMat_6_8 = q_acc_6_8;
             const walberla::float64 elMat_6_9 = q_acc_6_9;
             const walberla::float64 elMat_7_0 = q_acc_0_7;
             const walberla::float64 elMat_7_1 = q_acc_1_7;
             const walberla::float64 elMat_7_2 = q_acc_2_7;
             const walberla::float64 elMat_7_3 = q_acc_3_7;
             const walberla::float64 elMat_7_4 = q_acc_4_7;
             const walberla::float64 elMat_7_5 = q_acc_5_7;
             const walberla::float64 elMat_7_6 = q_acc_6_7;
             const walberla::float64 elMat_7_7 = q_acc_7_7;
             const walberla::float64 elMat_7_8 = q_acc_7_8;
             const walberla::float64 elMat_7_9 = q_acc_7_9;
             const walberla::float64 elMat_8_0 = q_acc_0_8;
             const walberla::float64 elMat_8_1 = q_acc_1_8;
             const walberla::float64 elMat_8_2 = q_acc_2_8;
             const walberla::float64 elMat_8_3 = q_acc_3_8;
             const walberla::float64 elMat_8_4 = q_acc_4_8;
             const walberla::float64 elMat_8_5 = q_acc_5_8;
             const walberla::float64 elMat_8_6 = q_acc_6_8;
             const walberla::float64 elMat_8_7 = q_acc_7_8;
             const walberla::float64 elMat_8_8 = q_acc_8_8;
             const walberla::float64 elMat_8_9 = q_acc_8_9;
             const walberla::float64 elMat_9_0 = q_acc_0_9;
             const walberla::float64 elMat_9_1 = q_acc_1_9;
             const walberla::float64 elMat_9_2 = q_acc_2_9;
             const walberla::float64 elMat_9_3 = q_acc_3_9;
             const walberla::float64 elMat_9_4 = q_acc_4_9;
             const walberla::float64 elMat_9_5 = q_acc_5_9;
             const walberla::float64 elMat_9_6 = q_acc_6_9;
             const walberla::float64 elMat_9_7 = q_acc_7_9;
             const walberla::float64 elMat_9_8 = q_acc_8_9;
             const walberla::float64 elMat_9_9 = q_acc_9_9;
         
             std::vector< uint_t > _data_rowIdx( 10 );
             std::vector< uint_t > _data_colIdx( 10 );
             std::vector< walberla::float64 > _data_mat( 100 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[1] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[2] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[3] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[4] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[5] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[7] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[8] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[9] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[3] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[7] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((walberla::float64)(elMat_0_0));
             _data_mat[1] = ((walberla::float64)(elMat_0_1));
             _data_mat[2] = ((walberla::float64)(elMat_0_2));
             _data_mat[3] = ((walberla::float64)(elMat_0_3));
             _data_mat[4] = ((walberla::float64)(elMat_0_4));
             _data_mat[5] = ((walberla::float64)(elMat_0_5));
             _data_mat[6] = ((walberla::float64)(elMat_0_6));
             _data_mat[7] = ((walberla::float64)(elMat_0_7));
             _data_mat[8] = ((walberla::float64)(elMat_0_8));
             _data_mat[9] = ((walberla::float64)(elMat_0_9));
             _data_mat[10] = ((walberla::float64)(elMat_1_0));
             _data_mat[11] = ((walberla::float64)(elMat_1_1));
             _data_mat[12] = ((walberla::float64)(elMat_1_2));
             _data_mat[13] = ((walberla::float64)(elMat_1_3));
             _data_mat[14] = ((walberla::float64)(elMat_1_4));
             _data_mat[15] = ((walberla::float64)(elMat_1_5));
             _data_mat[16] = ((walberla::float64)(elMat_1_6));
             _data_mat[17] = ((walberla::float64)(elMat_1_7));
             _data_mat[18] = ((walberla::float64)(elMat_1_8));
             _data_mat[19] = ((walberla::float64)(elMat_1_9));
             _data_mat[20] = ((walberla::float64)(elMat_2_0));
             _data_mat[21] = ((walberla::float64)(elMat_2_1));
             _data_mat[22] = ((walberla::float64)(elMat_2_2));
             _data_mat[23] = ((walberla::float64)(elMat_2_3));
             _data_mat[24] = ((walberla::float64)(elMat_2_4));
             _data_mat[25] = ((walberla::float64)(elMat_2_5));
             _data_mat[26] = ((walberla::float64)(elMat_2_6));
             _data_mat[27] = ((walberla::float64)(elMat_2_7));
             _data_mat[28] = ((walberla::float64)(elMat_2_8));
             _data_mat[29] = ((walberla::float64)(elMat_2_9));
             _data_mat[30] = ((walberla::float64)(elMat_3_0));
             _data_mat[31] = ((walberla::float64)(elMat_3_1));
             _data_mat[32] = ((walberla::float64)(elMat_3_2));
             _data_mat[33] = ((walberla::float64)(elMat_3_3));
             _data_mat[34] = ((walberla::float64)(elMat_3_4));
             _data_mat[35] = ((walberla::float64)(elMat_3_5));
             _data_mat[36] = ((walberla::float64)(elMat_3_6));
             _data_mat[37] = ((walberla::float64)(elMat_3_7));
             _data_mat[38] = ((walberla::float64)(elMat_3_8));
             _data_mat[39] = ((walberla::float64)(elMat_3_9));
             _data_mat[40] = ((walberla::float64)(elMat_4_0));
             _data_mat[41] = ((walberla::float64)(elMat_4_1));
             _data_mat[42] = ((walberla::float64)(elMat_4_2));
             _data_mat[43] = ((walberla::float64)(elMat_4_3));
             _data_mat[44] = ((walberla::float64)(elMat_4_4));
             _data_mat[45] = ((walberla::float64)(elMat_4_5));
             _data_mat[46] = ((walberla::float64)(elMat_4_6));
             _data_mat[47] = ((walberla::float64)(elMat_4_7));
             _data_mat[48] = ((walberla::float64)(elMat_4_8));
             _data_mat[49] = ((walberla::float64)(elMat_4_9));
             _data_mat[50] = ((walberla::float64)(elMat_5_0));
             _data_mat[51] = ((walberla::float64)(elMat_5_1));
             _data_mat[52] = ((walberla::float64)(elMat_5_2));
             _data_mat[53] = ((walberla::float64)(elMat_5_3));
             _data_mat[54] = ((walberla::float64)(elMat_5_4));
             _data_mat[55] = ((walberla::float64)(elMat_5_5));
             _data_mat[56] = ((walberla::float64)(elMat_5_6));
             _data_mat[57] = ((walberla::float64)(elMat_5_7));
             _data_mat[58] = ((walberla::float64)(elMat_5_8));
             _data_mat[59] = ((walberla::float64)(elMat_5_9));
             _data_mat[60] = ((walberla::float64)(elMat_6_0));
             _data_mat[61] = ((walberla::float64)(elMat_6_1));
             _data_mat[62] = ((walberla::float64)(elMat_6_2));
             _data_mat[63] = ((walberla::float64)(elMat_6_3));
             _data_mat[64] = ((walberla::float64)(elMat_6_4));
             _data_mat[65] = ((walberla::float64)(elMat_6_5));
             _data_mat[66] = ((walberla::float64)(elMat_6_6));
             _data_mat[67] = ((walberla::float64)(elMat_6_7));
             _data_mat[68] = ((walberla::float64)(elMat_6_8));
             _data_mat[69] = ((walberla::float64)(elMat_6_9));
             _data_mat[70] = ((walberla::float64)(elMat_7_0));
             _data_mat[71] = ((walberla::float64)(elMat_7_1));
             _data_mat[72] = ((walberla::float64)(elMat_7_2));
             _data_mat[73] = ((walberla::float64)(elMat_7_3));
             _data_mat[74] = ((walberla::float64)(elMat_7_4));
             _data_mat[75] = ((walberla::float64)(elMat_7_5));
             _data_mat[76] = ((walberla::float64)(elMat_7_6));
             _data_mat[77] = ((walberla::float64)(elMat_7_7));
             _data_mat[78] = ((walberla::float64)(elMat_7_8));
             _data_mat[79] = ((walberla::float64)(elMat_7_9));
             _data_mat[80] = ((walberla::float64)(elMat_8_0));
             _data_mat[81] = ((walberla::float64)(elMat_8_1));
             _data_mat[82] = ((walberla::float64)(elMat_8_2));
             _data_mat[83] = ((walberla::float64)(elMat_8_3));
             _data_mat[84] = ((walberla::float64)(elMat_8_4));
             _data_mat[85] = ((walberla::float64)(elMat_8_5));
             _data_mat[86] = ((walberla::float64)(elMat_8_6));
             _data_mat[87] = ((walberla::float64)(elMat_8_7));
             _data_mat[88] = ((walberla::float64)(elMat_8_8));
             _data_mat[89] = ((walberla::float64)(elMat_8_9));
             _data_mat[90] = ((walberla::float64)(elMat_9_0));
             _data_mat[91] = ((walberla::float64)(elMat_9_1));
             _data_mat[92] = ((walberla::float64)(elMat_9_2));
             _data_mat[93] = ((walberla::float64)(elMat_9_3));
             _data_mat[94] = ((walberla::float64)(elMat_9_4));
             _data_mat[95] = ((walberla::float64)(elMat_9_5));
             _data_mat[96] = ((walberla::float64)(elMat_9_6));
             _data_mat[97] = ((walberla::float64)(elMat_9_7));
             _data_mat[98] = ((walberla::float64)(elMat_9_8));
             _data_mat[99] = ((walberla::float64)(elMat_9_9));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const walberla::float64 tmp_coords_jac_0_BLUE_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const walberla::float64 tmp_coords_jac_1_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const walberla::float64 tmp_coords_jac_2_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const walberla::float64 tmp_coords_jac_3_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const walberla::float64 tmp_coords_jac_4_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const walberla::float64 tmp_coords_jac_5_BLUE_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_6_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const walberla::float64 tmp_coords_jac_7_BLUE_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_6_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_8_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const walberla::float64 tmp_coords_jac_9_BLUE_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_8_BLUE_DOWN;
       const walberla::float64 p_affine_const_0_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN;
       const walberla::float64 p_affine_const_0_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN;
       const walberla::float64 p_affine_const_0_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN;
       const walberla::float64 p_affine_const_1_0_BLUE_DOWN = tmp_coords_jac_5_BLUE_DOWN;
       const walberla::float64 p_affine_const_1_1_BLUE_DOWN = tmp_coords_jac_7_BLUE_DOWN;
       const walberla::float64 p_affine_const_1_2_BLUE_DOWN = tmp_coords_jac_9_BLUE_DOWN;
       const walberla::float64 p_affine_const_2_0_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0) + tmp_coords_jac_5_BLUE_DOWN;
       const walberla::float64 p_affine_const_2_1_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1) + tmp_coords_jac_7_BLUE_DOWN;
       const walberla::float64 p_affine_const_2_2_BLUE_DOWN = tmp_coords_jac_0_BLUE_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2) + tmp_coords_jac_9_BLUE_DOWN;
       const walberla::float64 p_affine_const_3_0_BLUE_DOWN = tmp_coords_jac_1_BLUE_DOWN + tmp_coords_jac_4_BLUE_DOWN;
       const walberla::float64 p_affine_const_3_1_BLUE_DOWN = tmp_coords_jac_2_BLUE_DOWN + tmp_coords_jac_6_BLUE_DOWN;
       const walberla::float64 p_affine_const_3_2_BLUE_DOWN = tmp_coords_jac_3_BLUE_DOWN + tmp_coords_jac_8_BLUE_DOWN;
       const walberla::float64 jac_affine_0_0_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_1_0_BLUE_DOWN;
       const walberla::float64 jac_affine_0_1_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_2_0_BLUE_DOWN;
       const walberla::float64 jac_affine_0_2_BLUE_DOWN = -p_affine_const_0_0_BLUE_DOWN + p_affine_const_3_0_BLUE_DOWN;
       const walberla::float64 jac_affine_1_0_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_1_1_BLUE_DOWN;
       const walberla::float64 jac_affine_1_1_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_2_1_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_14_BLUE_DOWN = jac_affine_0_2_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN;
       const walberla::float64 jac_affine_1_2_BLUE_DOWN = -p_affine_const_0_1_BLUE_DOWN + p_affine_const_3_1_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_12_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN;
       const walberla::float64 jac_affine_2_0_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_1_2_BLUE_DOWN;
       const walberla::float64 jac_affine_2_1_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_2_2_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_11_BLUE_DOWN = jac_affine_1_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN;
       const walberla::float64 jac_affine_2_2_BLUE_DOWN = -p_affine_const_0_2_BLUE_DOWN + p_affine_const_3_2_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_10_BLUE_DOWN = jac_affine_1_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_13_BLUE_DOWN = jac_affine_0_1_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_15_BLUE_DOWN = jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_10_BLUE_DOWN - jac_affine_0_0_BLUE_DOWN*tmp_coords_jac_11_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_0_BLUE_DOWN*tmp_coords_jac_13_BLUE_DOWN + jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_12_BLUE_DOWN - jac_affine_2_0_BLUE_DOWN*tmp_coords_jac_14_BLUE_DOWN;
       const walberla::float64 tmp_coords_jac_16_BLUE_DOWN = 1.0 / (tmp_coords_jac_15_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_0_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_10_BLUE_DOWN - tmp_coords_jac_11_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_0_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_2_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - tmp_coords_jac_13_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_0_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(tmp_coords_jac_12_BLUE_DOWN - tmp_coords_jac_14_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_1_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_1_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN + jac_affine_1_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_1_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_2_2_BLUE_DOWN - jac_affine_0_2_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_1_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_1_2_BLUE_DOWN + jac_affine_0_2_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_2_0_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_1_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN - jac_affine_1_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_2_1_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(-jac_affine_0_0_BLUE_DOWN*jac_affine_2_1_BLUE_DOWN + jac_affine_0_1_BLUE_DOWN*jac_affine_2_0_BLUE_DOWN);
       const walberla::float64 jac_affine_inv_2_2_BLUE_DOWN = tmp_coords_jac_16_BLUE_DOWN*(jac_affine_0_0_BLUE_DOWN*jac_affine_1_1_BLUE_DOWN - jac_affine_0_1_BLUE_DOWN*jac_affine_1_0_BLUE_DOWN);
       const walberla::float64 abs_det_jac_affine_BLUE_DOWN = abs(tmp_coords_jac_15_BLUE_DOWN);
       {
          /* CellType.BLUE_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
             const walberla::float64 k_dof_0 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 k_dof_1 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 k_dof_2 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 k_dof_3 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 k_dof_4 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const walberla::float64 k_dof_5 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const walberla::float64 k_dof_6 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const walberla::float64 k_dof_7 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const walberla::float64 k_dof_8 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const walberla::float64 k_dof_9 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             walberla::float64 q_acc_0_0 = 0.0;
             walberla::float64 q_acc_0_1 = 0.0;
             walberla::float64 q_acc_0_2 = 0.0;
             walberla::float64 q_acc_0_3 = 0.0;
             walberla::float64 q_acc_0_4 = 0.0;
             walberla::float64 q_acc_0_5 = 0.0;
             walberla::float64 q_acc_0_6 = 0.0;
             walberla::float64 q_acc_0_7 = 0.0;
             walberla::float64 q_acc_0_8 = 0.0;
             walberla::float64 q_acc_0_9 = 0.0;
             walberla::float64 q_acc_1_1 = 0.0;
             walberla::float64 q_acc_1_2 = 0.0;
             walberla::float64 q_acc_1_3 = 0.0;
             walberla::float64 q_acc_1_4 = 0.0;
             walberla::float64 q_acc_1_5 = 0.0;
             walberla::float64 q_acc_1_6 = 0.0;
             walberla::float64 q_acc_1_7 = 0.0;
             walberla::float64 q_acc_1_8 = 0.0;
             walberla::float64 q_acc_1_9 = 0.0;
             walberla::float64 q_acc_2_2 = 0.0;
             walberla::float64 q_acc_2_3 = 0.0;
             walberla::float64 q_acc_2_4 = 0.0;
             walberla::float64 q_acc_2_5 = 0.0;
             walberla::float64 q_acc_2_6 = 0.0;
             walberla::float64 q_acc_2_7 = 0.0;
             walberla::float64 q_acc_2_8 = 0.0;
             walberla::float64 q_acc_2_9 = 0.0;
             walberla::float64 q_acc_3_3 = 0.0;
             walberla::float64 q_acc_3_4 = 0.0;
             walberla::float64 q_acc_3_5 = 0.0;
             walberla::float64 q_acc_3_6 = 0.0;
             walberla::float64 q_acc_3_7 = 0.0;
             walberla::float64 q_acc_3_8 = 0.0;
             walberla::float64 q_acc_3_9 = 0.0;
             walberla::float64 q_acc_4_4 = 0.0;
             walberla::float64 q_acc_4_5 = 0.0;
             walberla::float64 q_acc_4_6 = 0.0;
             walberla::float64 q_acc_4_7 = 0.0;
             walberla::float64 q_acc_4_8 = 0.0;
             walberla::float64 q_acc_4_9 = 0.0;
             walberla::float64 q_acc_5_5 = 0.0;
             walberla::float64 q_acc_5_6 = 0.0;
             walberla::float64 q_acc_5_7 = 0.0;
             walberla::float64 q_acc_5_8 = 0.0;
             walberla::float64 q_acc_5_9 = 0.0;
             walberla::float64 q_acc_6_6 = 0.0;
             walberla::float64 q_acc_6_7 = 0.0;
             walberla::float64 q_acc_6_8 = 0.0;
             walberla::float64 q_acc_6_9 = 0.0;
             walberla::float64 q_acc_7_7 = 0.0;
             walberla::float64 q_acc_7_8 = 0.0;
             walberla::float64 q_acc_7_9 = 0.0;
             walberla::float64 q_acc_8_8 = 0.0;
             walberla::float64 q_acc_8_9 = 0.0;
             walberla::float64 q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const walberla::float64 tmp_qloop_0 = 4.0*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_1 = 4.0*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_2 = 4.0*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_3 = tmp_qloop_1 + tmp_qloop_2;
                const walberla::float64 tmp_qloop_4 = tmp_qloop_0 + tmp_qloop_3 - 3.0;
                const walberla::float64 tmp_qloop_5 = jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_4 + jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_4 + jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_4;
                const walberla::float64 tmp_qloop_6 = jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_4 + jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_4 + jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_4;
                const walberla::float64 tmp_qloop_7 = jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_4 + jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_4 + jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_4;
                const walberla::float64 tmp_qloop_8 = tmp_qloop_1*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_9 = tmp_qloop_1*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_10 = tmp_qloop_2*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_11 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const walberla::float64 tmp_qloop_12 = tmp_qloop_11*2.0;
                const walberla::float64 tmp_qloop_13 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const walberla::float64 tmp_qloop_14 = tmp_qloop_13*2.0;
                const walberla::float64 tmp_qloop_15 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const walberla::float64 tmp_qloop_16 = tmp_qloop_15*2.0;
                const walberla::float64 tmp_qloop_17 = tmp_qloop_8 + tmp_qloop_9;
                const walberla::float64 tmp_qloop_18 = abs_det_jac_affine_BLUE_DOWN*(k_dof_0*(tmp_qloop_10 + tmp_qloop_12 + tmp_qloop_14 + tmp_qloop_16 + tmp_qloop_17 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0) + k_dof_1*(tmp_qloop_12 - _data_q_p_0[q]) + k_dof_2*(tmp_qloop_14 - _data_q_p_1[q]) + k_dof_3*(tmp_qloop_16 - _data_q_p_2[q]) + k_dof_4*tmp_qloop_10 + k_dof_5*tmp_qloop_9 + k_dof_6*tmp_qloop_8 + k_dof_7*(tmp_qloop_0 - tmp_qloop_10 + tmp_qloop_15*-4.0 - tmp_qloop_9) + k_dof_8*(-tmp_qloop_10 + tmp_qloop_13*-4.0 + tmp_qloop_2 - tmp_qloop_8) + k_dof_9*(tmp_qloop_1 + tmp_qloop_11*-4.0 - tmp_qloop_17))*_data_q_w[q];
                const walberla::float64 tmp_qloop_19 = tmp_qloop_1 - 1.0;
                const walberla::float64 tmp_qloop_20 = jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_19;
                const walberla::float64 tmp_qloop_21 = jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_19;
                const walberla::float64 tmp_qloop_22 = jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_19;
                const walberla::float64 tmp_qloop_23 = tmp_qloop_2 - 1.0;
                const walberla::float64 tmp_qloop_24 = jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_23;
                const walberla::float64 tmp_qloop_25 = jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_23;
                const walberla::float64 tmp_qloop_26 = jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_23;
                const walberla::float64 tmp_qloop_27 = tmp_qloop_0 - 1.0;
                const walberla::float64 tmp_qloop_28 = jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_27;
                const walberla::float64 tmp_qloop_29 = jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_27;
                const walberla::float64 tmp_qloop_30 = jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_27;
                const walberla::float64 tmp_qloop_31 = jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_2;
                const walberla::float64 tmp_qloop_32 = jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_0;
                const walberla::float64 tmp_qloop_33 = tmp_qloop_31 + tmp_qloop_32;
                const walberla::float64 tmp_qloop_34 = jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_2;
                const walberla::float64 tmp_qloop_35 = jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_0;
                const walberla::float64 tmp_qloop_36 = tmp_qloop_34 + tmp_qloop_35;
                const walberla::float64 tmp_qloop_37 = jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_2;
                const walberla::float64 tmp_qloop_38 = jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_0;
                const walberla::float64 tmp_qloop_39 = tmp_qloop_37 + tmp_qloop_38;
                const walberla::float64 tmp_qloop_40 = jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_1;
                const walberla::float64 tmp_qloop_41 = jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_0;
                const walberla::float64 tmp_qloop_42 = tmp_qloop_40 + tmp_qloop_41;
                const walberla::float64 tmp_qloop_43 = jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_1;
                const walberla::float64 tmp_qloop_44 = jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_0;
                const walberla::float64 tmp_qloop_45 = tmp_qloop_43 + tmp_qloop_44;
                const walberla::float64 tmp_qloop_46 = jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_1;
                const walberla::float64 tmp_qloop_47 = jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_0;
                const walberla::float64 tmp_qloop_48 = tmp_qloop_46 + tmp_qloop_47;
                const walberla::float64 tmp_qloop_49 = jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_1;
                const walberla::float64 tmp_qloop_50 = jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_2;
                const walberla::float64 tmp_qloop_51 = tmp_qloop_49 + tmp_qloop_50;
                const walberla::float64 tmp_qloop_52 = jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_1;
                const walberla::float64 tmp_qloop_53 = jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_2;
                const walberla::float64 tmp_qloop_54 = tmp_qloop_52 + tmp_qloop_53;
                const walberla::float64 tmp_qloop_55 = jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_1;
                const walberla::float64 tmp_qloop_56 = jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_2;
                const walberla::float64 tmp_qloop_57 = tmp_qloop_55 + tmp_qloop_56;
                const walberla::float64 tmp_qloop_58 = -tmp_qloop_3 - 8.0*_data_q_p_2[q] + 4.0;
                const walberla::float64 tmp_qloop_59 = jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_58 - tmp_qloop_32 - tmp_qloop_41;
                const walberla::float64 tmp_qloop_60 = jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_58 - tmp_qloop_35 - tmp_qloop_44;
                const walberla::float64 tmp_qloop_61 = jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_58 - tmp_qloop_38 - tmp_qloop_47;
                const walberla::float64 tmp_qloop_62 = tmp_qloop_0 - 4.0;
                const walberla::float64 tmp_qloop_63 = -tmp_qloop_1 - tmp_qloop_62 - 8.0*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_64 = jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_63 - tmp_qloop_31 - tmp_qloop_50;
                const walberla::float64 tmp_qloop_65 = jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_63 - tmp_qloop_34 - tmp_qloop_53;
                const walberla::float64 tmp_qloop_66 = jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_63 - tmp_qloop_37 - tmp_qloop_56;
                const walberla::float64 tmp_qloop_67 = -tmp_qloop_2 - tmp_qloop_62 - 8.0*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_68 = jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_67 - tmp_qloop_40 - tmp_qloop_49;
                const walberla::float64 tmp_qloop_69 = jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_67 - tmp_qloop_43 - tmp_qloop_52;
                const walberla::float64 tmp_qloop_70 = jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_67 - tmp_qloop_46 - tmp_qloop_55;
                const walberla::float64 tmp_qloop_71 = ((-0.25 + _data_q_p_0[q])*(-0.25 + _data_q_p_0[q]))*16.0;
                const walberla::float64 tmp_qloop_72 = ((-0.25 + _data_q_p_1[q])*(-0.25 + _data_q_p_1[q]))*16.0;
                const walberla::float64 tmp_qloop_73 = ((-0.25 + _data_q_p_2[q])*(-0.25 + _data_q_p_2[q]))*16.0;
                const walberla::float64 tmp_qloop_74 = jac_affine_inv_2_0_BLUE_DOWN*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_75 = jac_affine_inv_1_0_BLUE_DOWN*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_76 = jac_affine_inv_2_1_BLUE_DOWN*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_77 = jac_affine_inv_1_1_BLUE_DOWN*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_78 = jac_affine_inv_2_2_BLUE_DOWN*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_79 = jac_affine_inv_1_2_BLUE_DOWN*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_80 = jac_affine_inv_2_0_BLUE_DOWN*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_81 = jac_affine_inv_0_0_BLUE_DOWN*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_82 = jac_affine_inv_2_1_BLUE_DOWN*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_83 = jac_affine_inv_0_1_BLUE_DOWN*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_84 = jac_affine_inv_2_2_BLUE_DOWN*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_85 = jac_affine_inv_0_2_BLUE_DOWN*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_86 = jac_affine_inv_1_0_BLUE_DOWN*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_87 = jac_affine_inv_0_0_BLUE_DOWN*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_88 = jac_affine_inv_1_1_BLUE_DOWN*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_89 = jac_affine_inv_0_1_BLUE_DOWN*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_90 = jac_affine_inv_1_2_BLUE_DOWN*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_91 = jac_affine_inv_0_2_BLUE_DOWN*_data_q_p_1[q];
                const walberla::float64 q_tmp_0_0 = tmp_qloop_18*((tmp_qloop_5*tmp_qloop_5) + (tmp_qloop_6*tmp_qloop_6) + (tmp_qloop_7*tmp_qloop_7));
                const walberla::float64 q_tmp_0_1 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_5 + tmp_qloop_21*tmp_qloop_6 + tmp_qloop_22*tmp_qloop_7);
                const walberla::float64 q_tmp_0_2 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_5 + tmp_qloop_25*tmp_qloop_6 + tmp_qloop_26*tmp_qloop_7);
                const walberla::float64 q_tmp_0_3 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_5 + tmp_qloop_29*tmp_qloop_6 + tmp_qloop_30*tmp_qloop_7);
                const walberla::float64 q_tmp_0_4 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_5 + tmp_qloop_36*tmp_qloop_6 + tmp_qloop_39*tmp_qloop_7);
                const walberla::float64 q_tmp_0_5 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_5 + tmp_qloop_45*tmp_qloop_6 + tmp_qloop_48*tmp_qloop_7);
                const walberla::float64 q_tmp_0_6 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_51 + tmp_qloop_54*tmp_qloop_6 + tmp_qloop_57*tmp_qloop_7);
                const walberla::float64 q_tmp_0_7 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_59 + tmp_qloop_6*tmp_qloop_60 + tmp_qloop_61*tmp_qloop_7);
                const walberla::float64 q_tmp_0_8 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_64 + tmp_qloop_6*tmp_qloop_65 + tmp_qloop_66*tmp_qloop_7);
                const walberla::float64 q_tmp_0_9 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_68 + tmp_qloop_6*tmp_qloop_69 + tmp_qloop_7*tmp_qloop_70);
                const walberla::float64 q_tmp_1_1 = tmp_qloop_18*((jac_affine_inv_0_0_BLUE_DOWN*jac_affine_inv_0_0_BLUE_DOWN)*tmp_qloop_71 + (jac_affine_inv_0_1_BLUE_DOWN*jac_affine_inv_0_1_BLUE_DOWN)*tmp_qloop_71 + (jac_affine_inv_0_2_BLUE_DOWN*jac_affine_inv_0_2_BLUE_DOWN)*tmp_qloop_71);
                const walberla::float64 q_tmp_1_2 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_24 + tmp_qloop_21*tmp_qloop_25 + tmp_qloop_22*tmp_qloop_26);
                const walberla::float64 q_tmp_1_3 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_28 + tmp_qloop_21*tmp_qloop_29 + tmp_qloop_22*tmp_qloop_30);
                const walberla::float64 q_tmp_1_4 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_33 + tmp_qloop_21*tmp_qloop_36 + tmp_qloop_22*tmp_qloop_39);
                const walberla::float64 q_tmp_1_5 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_42 + tmp_qloop_21*tmp_qloop_45 + tmp_qloop_22*tmp_qloop_48);
                const walberla::float64 q_tmp_1_6 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_51 + tmp_qloop_21*tmp_qloop_54 + tmp_qloop_22*tmp_qloop_57);
                const walberla::float64 q_tmp_1_7 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_59 + tmp_qloop_21*tmp_qloop_60 + tmp_qloop_22*tmp_qloop_61);
                const walberla::float64 q_tmp_1_8 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_64 + tmp_qloop_21*tmp_qloop_65 + tmp_qloop_22*tmp_qloop_66);
                const walberla::float64 q_tmp_1_9 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_68 + tmp_qloop_21*tmp_qloop_69 + tmp_qloop_22*tmp_qloop_70);
                const walberla::float64 q_tmp_2_2 = tmp_qloop_18*((jac_affine_inv_1_0_BLUE_DOWN*jac_affine_inv_1_0_BLUE_DOWN)*tmp_qloop_72 + (jac_affine_inv_1_1_BLUE_DOWN*jac_affine_inv_1_1_BLUE_DOWN)*tmp_qloop_72 + (jac_affine_inv_1_2_BLUE_DOWN*jac_affine_inv_1_2_BLUE_DOWN)*tmp_qloop_72);
                const walberla::float64 q_tmp_2_3 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_28 + tmp_qloop_25*tmp_qloop_29 + tmp_qloop_26*tmp_qloop_30);
                const walberla::float64 q_tmp_2_4 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_33 + tmp_qloop_25*tmp_qloop_36 + tmp_qloop_26*tmp_qloop_39);
                const walberla::float64 q_tmp_2_5 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_42 + tmp_qloop_25*tmp_qloop_45 + tmp_qloop_26*tmp_qloop_48);
                const walberla::float64 q_tmp_2_6 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_51 + tmp_qloop_25*tmp_qloop_54 + tmp_qloop_26*tmp_qloop_57);
                const walberla::float64 q_tmp_2_7 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_59 + tmp_qloop_25*tmp_qloop_60 + tmp_qloop_26*tmp_qloop_61);
                const walberla::float64 q_tmp_2_8 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_64 + tmp_qloop_25*tmp_qloop_65 + tmp_qloop_26*tmp_qloop_66);
                const walberla::float64 q_tmp_2_9 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_68 + tmp_qloop_25*tmp_qloop_69 + tmp_qloop_26*tmp_qloop_70);
                const walberla::float64 q_tmp_3_3 = tmp_qloop_18*((jac_affine_inv_2_0_BLUE_DOWN*jac_affine_inv_2_0_BLUE_DOWN)*tmp_qloop_73 + (jac_affine_inv_2_1_BLUE_DOWN*jac_affine_inv_2_1_BLUE_DOWN)*tmp_qloop_73 + (jac_affine_inv_2_2_BLUE_DOWN*jac_affine_inv_2_2_BLUE_DOWN)*tmp_qloop_73);
                const walberla::float64 q_tmp_3_4 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_33 + tmp_qloop_29*tmp_qloop_36 + tmp_qloop_30*tmp_qloop_39);
                const walberla::float64 q_tmp_3_5 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_42 + tmp_qloop_29*tmp_qloop_45 + tmp_qloop_30*tmp_qloop_48);
                const walberla::float64 q_tmp_3_6 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_51 + tmp_qloop_29*tmp_qloop_54 + tmp_qloop_30*tmp_qloop_57);
                const walberla::float64 q_tmp_3_7 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_59 + tmp_qloop_29*tmp_qloop_60 + tmp_qloop_30*tmp_qloop_61);
                const walberla::float64 q_tmp_3_8 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_64 + tmp_qloop_29*tmp_qloop_65 + tmp_qloop_30*tmp_qloop_66);
                const walberla::float64 q_tmp_3_9 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_68 + tmp_qloop_29*tmp_qloop_69 + tmp_qloop_30*tmp_qloop_70);
                const walberla::float64 q_tmp_4_4 = tmp_qloop_18*(((tmp_qloop_74 + tmp_qloop_75)*(tmp_qloop_74 + tmp_qloop_75))*16.0 + ((tmp_qloop_76 + tmp_qloop_77)*(tmp_qloop_76 + tmp_qloop_77))*16.0 + ((tmp_qloop_78 + tmp_qloop_79)*(tmp_qloop_78 + tmp_qloop_79))*16.0);
                const walberla::float64 q_tmp_4_5 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_42 + tmp_qloop_36*tmp_qloop_45 + tmp_qloop_39*tmp_qloop_48);
                const walberla::float64 q_tmp_4_6 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_51 + tmp_qloop_36*tmp_qloop_54 + tmp_qloop_39*tmp_qloop_57);
                const walberla::float64 q_tmp_4_7 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_59 + tmp_qloop_36*tmp_qloop_60 + tmp_qloop_39*tmp_qloop_61);
                const walberla::float64 q_tmp_4_8 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_64 + tmp_qloop_36*tmp_qloop_65 + tmp_qloop_39*tmp_qloop_66);
                const walberla::float64 q_tmp_4_9 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_68 + tmp_qloop_36*tmp_qloop_69 + tmp_qloop_39*tmp_qloop_70);
                const walberla::float64 q_tmp_5_5 = tmp_qloop_18*(((tmp_qloop_80 + tmp_qloop_81)*(tmp_qloop_80 + tmp_qloop_81))*16.0 + ((tmp_qloop_82 + tmp_qloop_83)*(tmp_qloop_82 + tmp_qloop_83))*16.0 + ((tmp_qloop_84 + tmp_qloop_85)*(tmp_qloop_84 + tmp_qloop_85))*16.0);
                const walberla::float64 q_tmp_5_6 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_51 + tmp_qloop_45*tmp_qloop_54 + tmp_qloop_48*tmp_qloop_57);
                const walberla::float64 q_tmp_5_7 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_59 + tmp_qloop_45*tmp_qloop_60 + tmp_qloop_48*tmp_qloop_61);
                const walberla::float64 q_tmp_5_8 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_64 + tmp_qloop_45*tmp_qloop_65 + tmp_qloop_48*tmp_qloop_66);
                const walberla::float64 q_tmp_5_9 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_68 + tmp_qloop_45*tmp_qloop_69 + tmp_qloop_48*tmp_qloop_70);
                const walberla::float64 q_tmp_6_6 = tmp_qloop_18*(((tmp_qloop_86 + tmp_qloop_87)*(tmp_qloop_86 + tmp_qloop_87))*16.0 + ((tmp_qloop_88 + tmp_qloop_89)*(tmp_qloop_88 + tmp_qloop_89))*16.0 + ((tmp_qloop_90 + tmp_qloop_91)*(tmp_qloop_90 + tmp_qloop_91))*16.0);
                const walberla::float64 q_tmp_6_7 = tmp_qloop_18*(tmp_qloop_51*tmp_qloop_59 + tmp_qloop_54*tmp_qloop_60 + tmp_qloop_57*tmp_qloop_61);
                const walberla::float64 q_tmp_6_8 = tmp_qloop_18*(tmp_qloop_51*tmp_qloop_64 + tmp_qloop_54*tmp_qloop_65 + tmp_qloop_57*tmp_qloop_66);
                const walberla::float64 q_tmp_6_9 = tmp_qloop_18*(tmp_qloop_51*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_57*tmp_qloop_70);
                const walberla::float64 q_tmp_7_7 = tmp_qloop_18*(((jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_58*0.25 - tmp_qloop_75 - tmp_qloop_81)*(jac_affine_inv_2_0_BLUE_DOWN*tmp_qloop_58*0.25 - tmp_qloop_75 - tmp_qloop_81))*16.0 + ((jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_58*0.25 - tmp_qloop_77 - tmp_qloop_83)*(jac_affine_inv_2_1_BLUE_DOWN*tmp_qloop_58*0.25 - tmp_qloop_77 - tmp_qloop_83))*16.0 + ((jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_58*0.25 - tmp_qloop_79 - tmp_qloop_85)*(jac_affine_inv_2_2_BLUE_DOWN*tmp_qloop_58*0.25 - tmp_qloop_79 - tmp_qloop_85))*16.0);
                const walberla::float64 q_tmp_7_8 = tmp_qloop_18*(tmp_qloop_59*tmp_qloop_64 + tmp_qloop_60*tmp_qloop_65 + tmp_qloop_61*tmp_qloop_66);
                const walberla::float64 q_tmp_7_9 = tmp_qloop_18*(tmp_qloop_59*tmp_qloop_68 + tmp_qloop_60*tmp_qloop_69 + tmp_qloop_61*tmp_qloop_70);
                const walberla::float64 q_tmp_8_8 = tmp_qloop_18*(((jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_63*0.25 - tmp_qloop_74 - tmp_qloop_87)*(jac_affine_inv_1_0_BLUE_DOWN*tmp_qloop_63*0.25 - tmp_qloop_74 - tmp_qloop_87))*16.0 + ((jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_63*0.25 - tmp_qloop_76 - tmp_qloop_89)*(jac_affine_inv_1_1_BLUE_DOWN*tmp_qloop_63*0.25 - tmp_qloop_76 - tmp_qloop_89))*16.0 + ((jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_63*0.25 - tmp_qloop_78 - tmp_qloop_91)*(jac_affine_inv_1_2_BLUE_DOWN*tmp_qloop_63*0.25 - tmp_qloop_78 - tmp_qloop_91))*16.0);
                const walberla::float64 q_tmp_8_9 = tmp_qloop_18*(tmp_qloop_64*tmp_qloop_68 + tmp_qloop_65*tmp_qloop_69 + tmp_qloop_66*tmp_qloop_70);
                const walberla::float64 q_tmp_9_9 = tmp_qloop_18*(((jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_67*0.25 - tmp_qloop_80 - tmp_qloop_86)*(jac_affine_inv_0_0_BLUE_DOWN*tmp_qloop_67*0.25 - tmp_qloop_80 - tmp_qloop_86))*16.0 + ((jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_67*0.25 - tmp_qloop_82 - tmp_qloop_88)*(jac_affine_inv_0_1_BLUE_DOWN*tmp_qloop_67*0.25 - tmp_qloop_82 - tmp_qloop_88))*16.0 + ((jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_67*0.25 - tmp_qloop_84 - tmp_qloop_90)*(jac_affine_inv_0_2_BLUE_DOWN*tmp_qloop_67*0.25 - tmp_qloop_84 - tmp_qloop_90))*16.0);
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const walberla::float64 elMat_0_0 = q_acc_0_0;
             const walberla::float64 elMat_0_1 = q_acc_0_1;
             const walberla::float64 elMat_0_2 = q_acc_0_2;
             const walberla::float64 elMat_0_3 = q_acc_0_3;
             const walberla::float64 elMat_0_4 = q_acc_0_4;
             const walberla::float64 elMat_0_5 = q_acc_0_5;
             const walberla::float64 elMat_0_6 = q_acc_0_6;
             const walberla::float64 elMat_0_7 = q_acc_0_7;
             const walberla::float64 elMat_0_8 = q_acc_0_8;
             const walberla::float64 elMat_0_9 = q_acc_0_9;
             const walberla::float64 elMat_1_0 = q_acc_0_1;
             const walberla::float64 elMat_1_1 = q_acc_1_1;
             const walberla::float64 elMat_1_2 = q_acc_1_2;
             const walberla::float64 elMat_1_3 = q_acc_1_3;
             const walberla::float64 elMat_1_4 = q_acc_1_4;
             const walberla::float64 elMat_1_5 = q_acc_1_5;
             const walberla::float64 elMat_1_6 = q_acc_1_6;
             const walberla::float64 elMat_1_7 = q_acc_1_7;
             const walberla::float64 elMat_1_8 = q_acc_1_8;
             const walberla::float64 elMat_1_9 = q_acc_1_9;
             const walberla::float64 elMat_2_0 = q_acc_0_2;
             const walberla::float64 elMat_2_1 = q_acc_1_2;
             const walberla::float64 elMat_2_2 = q_acc_2_2;
             const walberla::float64 elMat_2_3 = q_acc_2_3;
             const walberla::float64 elMat_2_4 = q_acc_2_4;
             const walberla::float64 elMat_2_5 = q_acc_2_5;
             const walberla::float64 elMat_2_6 = q_acc_2_6;
             const walberla::float64 elMat_2_7 = q_acc_2_7;
             const walberla::float64 elMat_2_8 = q_acc_2_8;
             const walberla::float64 elMat_2_9 = q_acc_2_9;
             const walberla::float64 elMat_3_0 = q_acc_0_3;
             const walberla::float64 elMat_3_1 = q_acc_1_3;
             const walberla::float64 elMat_3_2 = q_acc_2_3;
             const walberla::float64 elMat_3_3 = q_acc_3_3;
             const walberla::float64 elMat_3_4 = q_acc_3_4;
             const walberla::float64 elMat_3_5 = q_acc_3_5;
             const walberla::float64 elMat_3_6 = q_acc_3_6;
             const walberla::float64 elMat_3_7 = q_acc_3_7;
             const walberla::float64 elMat_3_8 = q_acc_3_8;
             const walberla::float64 elMat_3_9 = q_acc_3_9;
             const walberla::float64 elMat_4_0 = q_acc_0_4;
             const walberla::float64 elMat_4_1 = q_acc_1_4;
             const walberla::float64 elMat_4_2 = q_acc_2_4;
             const walberla::float64 elMat_4_3 = q_acc_3_4;
             const walberla::float64 elMat_4_4 = q_acc_4_4;
             const walberla::float64 elMat_4_5 = q_acc_4_5;
             const walberla::float64 elMat_4_6 = q_acc_4_6;
             const walberla::float64 elMat_4_7 = q_acc_4_7;
             const walberla::float64 elMat_4_8 = q_acc_4_8;
             const walberla::float64 elMat_4_9 = q_acc_4_9;
             const walberla::float64 elMat_5_0 = q_acc_0_5;
             const walberla::float64 elMat_5_1 = q_acc_1_5;
             const walberla::float64 elMat_5_2 = q_acc_2_5;
             const walberla::float64 elMat_5_3 = q_acc_3_5;
             const walberla::float64 elMat_5_4 = q_acc_4_5;
             const walberla::float64 elMat_5_5 = q_acc_5_5;
             const walberla::float64 elMat_5_6 = q_acc_5_6;
             const walberla::float64 elMat_5_7 = q_acc_5_7;
             const walberla::float64 elMat_5_8 = q_acc_5_8;
             const walberla::float64 elMat_5_9 = q_acc_5_9;
             const walberla::float64 elMat_6_0 = q_acc_0_6;
             const walberla::float64 elMat_6_1 = q_acc_1_6;
             const walberla::float64 elMat_6_2 = q_acc_2_6;
             const walberla::float64 elMat_6_3 = q_acc_3_6;
             const walberla::float64 elMat_6_4 = q_acc_4_6;
             const walberla::float64 elMat_6_5 = q_acc_5_6;
             const walberla::float64 elMat_6_6 = q_acc_6_6;
             const walberla::float64 elMat_6_7 = q_acc_6_7;
             const walberla::float64 elMat_6_8 = q_acc_6_8;
             const walberla::float64 elMat_6_9 = q_acc_6_9;
             const walberla::float64 elMat_7_0 = q_acc_0_7;
             const walberla::float64 elMat_7_1 = q_acc_1_7;
             const walberla::float64 elMat_7_2 = q_acc_2_7;
             const walberla::float64 elMat_7_3 = q_acc_3_7;
             const walberla::float64 elMat_7_4 = q_acc_4_7;
             const walberla::float64 elMat_7_5 = q_acc_5_7;
             const walberla::float64 elMat_7_6 = q_acc_6_7;
             const walberla::float64 elMat_7_7 = q_acc_7_7;
             const walberla::float64 elMat_7_8 = q_acc_7_8;
             const walberla::float64 elMat_7_9 = q_acc_7_9;
             const walberla::float64 elMat_8_0 = q_acc_0_8;
             const walberla::float64 elMat_8_1 = q_acc_1_8;
             const walberla::float64 elMat_8_2 = q_acc_2_8;
             const walberla::float64 elMat_8_3 = q_acc_3_8;
             const walberla::float64 elMat_8_4 = q_acc_4_8;
             const walberla::float64 elMat_8_5 = q_acc_5_8;
             const walberla::float64 elMat_8_6 = q_acc_6_8;
             const walberla::float64 elMat_8_7 = q_acc_7_8;
             const walberla::float64 elMat_8_8 = q_acc_8_8;
             const walberla::float64 elMat_8_9 = q_acc_8_9;
             const walberla::float64 elMat_9_0 = q_acc_0_9;
             const walberla::float64 elMat_9_1 = q_acc_1_9;
             const walberla::float64 elMat_9_2 = q_acc_2_9;
             const walberla::float64 elMat_9_3 = q_acc_3_9;
             const walberla::float64 elMat_9_4 = q_acc_4_9;
             const walberla::float64 elMat_9_5 = q_acc_5_9;
             const walberla::float64 elMat_9_6 = q_acc_6_9;
             const walberla::float64 elMat_9_7 = q_acc_7_9;
             const walberla::float64 elMat_9_8 = q_acc_8_9;
             const walberla::float64 elMat_9_9 = q_acc_9_9;
         
             std::vector< uint_t > _data_rowIdx( 10 );
             std::vector< uint_t > _data_colIdx( 10 );
             std::vector< walberla::float64 > _data_mat( 100 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[1] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[2] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[3] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[7] = ((uint64_t)(_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[8] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[9] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[3] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 2*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[7] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((walberla::float64)(elMat_0_0));
             _data_mat[1] = ((walberla::float64)(elMat_0_1));
             _data_mat[2] = ((walberla::float64)(elMat_0_2));
             _data_mat[3] = ((walberla::float64)(elMat_0_3));
             _data_mat[4] = ((walberla::float64)(elMat_0_4));
             _data_mat[5] = ((walberla::float64)(elMat_0_5));
             _data_mat[6] = ((walberla::float64)(elMat_0_6));
             _data_mat[7] = ((walberla::float64)(elMat_0_7));
             _data_mat[8] = ((walberla::float64)(elMat_0_8));
             _data_mat[9] = ((walberla::float64)(elMat_0_9));
             _data_mat[10] = ((walberla::float64)(elMat_1_0));
             _data_mat[11] = ((walberla::float64)(elMat_1_1));
             _data_mat[12] = ((walberla::float64)(elMat_1_2));
             _data_mat[13] = ((walberla::float64)(elMat_1_3));
             _data_mat[14] = ((walberla::float64)(elMat_1_4));
             _data_mat[15] = ((walberla::float64)(elMat_1_5));
             _data_mat[16] = ((walberla::float64)(elMat_1_6));
             _data_mat[17] = ((walberla::float64)(elMat_1_7));
             _data_mat[18] = ((walberla::float64)(elMat_1_8));
             _data_mat[19] = ((walberla::float64)(elMat_1_9));
             _data_mat[20] = ((walberla::float64)(elMat_2_0));
             _data_mat[21] = ((walberla::float64)(elMat_2_1));
             _data_mat[22] = ((walberla::float64)(elMat_2_2));
             _data_mat[23] = ((walberla::float64)(elMat_2_3));
             _data_mat[24] = ((walberla::float64)(elMat_2_4));
             _data_mat[25] = ((walberla::float64)(elMat_2_5));
             _data_mat[26] = ((walberla::float64)(elMat_2_6));
             _data_mat[27] = ((walberla::float64)(elMat_2_7));
             _data_mat[28] = ((walberla::float64)(elMat_2_8));
             _data_mat[29] = ((walberla::float64)(elMat_2_9));
             _data_mat[30] = ((walberla::float64)(elMat_3_0));
             _data_mat[31] = ((walberla::float64)(elMat_3_1));
             _data_mat[32] = ((walberla::float64)(elMat_3_2));
             _data_mat[33] = ((walberla::float64)(elMat_3_3));
             _data_mat[34] = ((walberla::float64)(elMat_3_4));
             _data_mat[35] = ((walberla::float64)(elMat_3_5));
             _data_mat[36] = ((walberla::float64)(elMat_3_6));
             _data_mat[37] = ((walberla::float64)(elMat_3_7));
             _data_mat[38] = ((walberla::float64)(elMat_3_8));
             _data_mat[39] = ((walberla::float64)(elMat_3_9));
             _data_mat[40] = ((walberla::float64)(elMat_4_0));
             _data_mat[41] = ((walberla::float64)(elMat_4_1));
             _data_mat[42] = ((walberla::float64)(elMat_4_2));
             _data_mat[43] = ((walberla::float64)(elMat_4_3));
             _data_mat[44] = ((walberla::float64)(elMat_4_4));
             _data_mat[45] = ((walberla::float64)(elMat_4_5));
             _data_mat[46] = ((walberla::float64)(elMat_4_6));
             _data_mat[47] = ((walberla::float64)(elMat_4_7));
             _data_mat[48] = ((walberla::float64)(elMat_4_8));
             _data_mat[49] = ((walberla::float64)(elMat_4_9));
             _data_mat[50] = ((walberla::float64)(elMat_5_0));
             _data_mat[51] = ((walberla::float64)(elMat_5_1));
             _data_mat[52] = ((walberla::float64)(elMat_5_2));
             _data_mat[53] = ((walberla::float64)(elMat_5_3));
             _data_mat[54] = ((walberla::float64)(elMat_5_4));
             _data_mat[55] = ((walberla::float64)(elMat_5_5));
             _data_mat[56] = ((walberla::float64)(elMat_5_6));
             _data_mat[57] = ((walberla::float64)(elMat_5_7));
             _data_mat[58] = ((walberla::float64)(elMat_5_8));
             _data_mat[59] = ((walberla::float64)(elMat_5_9));
             _data_mat[60] = ((walberla::float64)(elMat_6_0));
             _data_mat[61] = ((walberla::float64)(elMat_6_1));
             _data_mat[62] = ((walberla::float64)(elMat_6_2));
             _data_mat[63] = ((walberla::float64)(elMat_6_3));
             _data_mat[64] = ((walberla::float64)(elMat_6_4));
             _data_mat[65] = ((walberla::float64)(elMat_6_5));
             _data_mat[66] = ((walberla::float64)(elMat_6_6));
             _data_mat[67] = ((walberla::float64)(elMat_6_7));
             _data_mat[68] = ((walberla::float64)(elMat_6_8));
             _data_mat[69] = ((walberla::float64)(elMat_6_9));
             _data_mat[70] = ((walberla::float64)(elMat_7_0));
             _data_mat[71] = ((walberla::float64)(elMat_7_1));
             _data_mat[72] = ((walberla::float64)(elMat_7_2));
             _data_mat[73] = ((walberla::float64)(elMat_7_3));
             _data_mat[74] = ((walberla::float64)(elMat_7_4));
             _data_mat[75] = ((walberla::float64)(elMat_7_5));
             _data_mat[76] = ((walberla::float64)(elMat_7_6));
             _data_mat[77] = ((walberla::float64)(elMat_7_7));
             _data_mat[78] = ((walberla::float64)(elMat_7_8));
             _data_mat[79] = ((walberla::float64)(elMat_7_9));
             _data_mat[80] = ((walberla::float64)(elMat_8_0));
             _data_mat[81] = ((walberla::float64)(elMat_8_1));
             _data_mat[82] = ((walberla::float64)(elMat_8_2));
             _data_mat[83] = ((walberla::float64)(elMat_8_3));
             _data_mat[84] = ((walberla::float64)(elMat_8_4));
             _data_mat[85] = ((walberla::float64)(elMat_8_5));
             _data_mat[86] = ((walberla::float64)(elMat_8_6));
             _data_mat[87] = ((walberla::float64)(elMat_8_7));
             _data_mat[88] = ((walberla::float64)(elMat_8_8));
             _data_mat[89] = ((walberla::float64)(elMat_8_9));
             _data_mat[90] = ((walberla::float64)(elMat_9_0));
             _data_mat[91] = ((walberla::float64)(elMat_9_1));
             _data_mat[92] = ((walberla::float64)(elMat_9_2));
             _data_mat[93] = ((walberla::float64)(elMat_9_3));
             _data_mat[94] = ((walberla::float64)(elMat_9_4));
             _data_mat[95] = ((walberla::float64)(elMat_9_5));
             _data_mat[96] = ((walberla::float64)(elMat_9_6));
             _data_mat[97] = ((walberla::float64)(elMat_9_7));
             _data_mat[98] = ((walberla::float64)(elMat_9_8));
             _data_mat[99] = ((walberla::float64)(elMat_9_9));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const walberla::float64 tmp_coords_jac_0_GREEN_UP = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const walberla::float64 tmp_coords_jac_1_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const walberla::float64 tmp_coords_jac_2_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const walberla::float64 tmp_coords_jac_3_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const walberla::float64 tmp_coords_jac_4_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const walberla::float64 tmp_coords_jac_5_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const walberla::float64 tmp_coords_jac_6_GREEN_UP = tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const walberla::float64 p_affine_const_0_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP;
       const walberla::float64 p_affine_const_0_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP;
       const walberla::float64 p_affine_const_0_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP;
       const walberla::float64 p_affine_const_1_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const walberla::float64 p_affine_const_1_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const walberla::float64 p_affine_const_1_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_UP*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const walberla::float64 p_affine_const_2_0_GREEN_UP = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_UP;
       const walberla::float64 p_affine_const_2_1_GREEN_UP = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_UP;
       const walberla::float64 p_affine_const_2_2_GREEN_UP = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_UP;
       const walberla::float64 p_affine_const_3_0_GREEN_UP = tmp_coords_jac_1_GREEN_UP + tmp_coords_jac_4_GREEN_UP;
       const walberla::float64 p_affine_const_3_1_GREEN_UP = tmp_coords_jac_2_GREEN_UP + tmp_coords_jac_5_GREEN_UP;
       const walberla::float64 p_affine_const_3_2_GREEN_UP = tmp_coords_jac_3_GREEN_UP + tmp_coords_jac_6_GREEN_UP;
       const walberla::float64 jac_affine_0_0_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_1_0_GREEN_UP;
       const walberla::float64 jac_affine_0_1_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_2_0_GREEN_UP;
       const walberla::float64 jac_affine_0_2_GREEN_UP = -p_affine_const_0_0_GREEN_UP + p_affine_const_3_0_GREEN_UP;
       const walberla::float64 jac_affine_1_0_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_1_1_GREEN_UP;
       const walberla::float64 jac_affine_1_1_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_2_1_GREEN_UP;
       const walberla::float64 tmp_coords_jac_11_GREEN_UP = jac_affine_0_2_GREEN_UP*jac_affine_1_1_GREEN_UP;
       const walberla::float64 jac_affine_1_2_GREEN_UP = -p_affine_const_0_1_GREEN_UP + p_affine_const_3_1_GREEN_UP;
       const walberla::float64 tmp_coords_jac_9_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_1_2_GREEN_UP;
       const walberla::float64 jac_affine_2_0_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_1_2_GREEN_UP;
       const walberla::float64 jac_affine_2_1_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_2_2_GREEN_UP;
       const walberla::float64 tmp_coords_jac_8_GREEN_UP = jac_affine_1_2_GREEN_UP*jac_affine_2_1_GREEN_UP;
       const walberla::float64 jac_affine_2_2_GREEN_UP = -p_affine_const_0_2_GREEN_UP + p_affine_const_3_2_GREEN_UP;
       const walberla::float64 tmp_coords_jac_7_GREEN_UP = jac_affine_1_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const walberla::float64 tmp_coords_jac_10_GREEN_UP = jac_affine_0_1_GREEN_UP*jac_affine_2_2_GREEN_UP;
       const walberla::float64 tmp_coords_jac_12_GREEN_UP = jac_affine_0_0_GREEN_UP*tmp_coords_jac_7_GREEN_UP - jac_affine_0_0_GREEN_UP*tmp_coords_jac_8_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_0_GREEN_UP*tmp_coords_jac_10_GREEN_UP - jac_affine_2_0_GREEN_UP*tmp_coords_jac_11_GREEN_UP + jac_affine_2_0_GREEN_UP*tmp_coords_jac_9_GREEN_UP;
       const walberla::float64 tmp_coords_jac_13_GREEN_UP = 1.0 / (tmp_coords_jac_12_GREEN_UP);
       const walberla::float64 jac_affine_inv_0_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(tmp_coords_jac_7_GREEN_UP - tmp_coords_jac_8_GREEN_UP);
       const walberla::float64 jac_affine_inv_0_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_2_GREEN_UP*jac_affine_2_1_GREEN_UP - tmp_coords_jac_10_GREEN_UP);
       const walberla::float64 jac_affine_inv_0_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-tmp_coords_jac_11_GREEN_UP + tmp_coords_jac_9_GREEN_UP);
       const walberla::float64 jac_affine_inv_1_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_1_0_GREEN_UP*jac_affine_2_2_GREEN_UP + jac_affine_1_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const walberla::float64 jac_affine_inv_1_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_2_2_GREEN_UP - jac_affine_0_2_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const walberla::float64 jac_affine_inv_1_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_1_2_GREEN_UP + jac_affine_0_2_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const walberla::float64 jac_affine_inv_2_0_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_1_0_GREEN_UP*jac_affine_2_1_GREEN_UP - jac_affine_1_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const walberla::float64 jac_affine_inv_2_1_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(-jac_affine_0_0_GREEN_UP*jac_affine_2_1_GREEN_UP + jac_affine_0_1_GREEN_UP*jac_affine_2_0_GREEN_UP);
       const walberla::float64 jac_affine_inv_2_2_GREEN_UP = tmp_coords_jac_13_GREEN_UP*(jac_affine_0_0_GREEN_UP*jac_affine_1_1_GREEN_UP - jac_affine_0_1_GREEN_UP*jac_affine_1_0_GREEN_UP);
       const walberla::float64 abs_det_jac_affine_GREEN_UP = abs(tmp_coords_jac_12_GREEN_UP);
       {
          /* CellType.GREEN_UP */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
             const walberla::float64 k_dof_0 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 k_dof_1 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 k_dof_2 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 k_dof_3 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 k_dof_4 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const walberla::float64 k_dof_5 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const walberla::float64 k_dof_6 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const walberla::float64 k_dof_7 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const walberla::float64 k_dof_8 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const walberla::float64 k_dof_9 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             walberla::float64 q_acc_0_0 = 0.0;
             walberla::float64 q_acc_0_1 = 0.0;
             walberla::float64 q_acc_0_2 = 0.0;
             walberla::float64 q_acc_0_3 = 0.0;
             walberla::float64 q_acc_0_4 = 0.0;
             walberla::float64 q_acc_0_5 = 0.0;
             walberla::float64 q_acc_0_6 = 0.0;
             walberla::float64 q_acc_0_7 = 0.0;
             walberla::float64 q_acc_0_8 = 0.0;
             walberla::float64 q_acc_0_9 = 0.0;
             walberla::float64 q_acc_1_1 = 0.0;
             walberla::float64 q_acc_1_2 = 0.0;
             walberla::float64 q_acc_1_3 = 0.0;
             walberla::float64 q_acc_1_4 = 0.0;
             walberla::float64 q_acc_1_5 = 0.0;
             walberla::float64 q_acc_1_6 = 0.0;
             walberla::float64 q_acc_1_7 = 0.0;
             walberla::float64 q_acc_1_8 = 0.0;
             walberla::float64 q_acc_1_9 = 0.0;
             walberla::float64 q_acc_2_2 = 0.0;
             walberla::float64 q_acc_2_3 = 0.0;
             walberla::float64 q_acc_2_4 = 0.0;
             walberla::float64 q_acc_2_5 = 0.0;
             walberla::float64 q_acc_2_6 = 0.0;
             walberla::float64 q_acc_2_7 = 0.0;
             walberla::float64 q_acc_2_8 = 0.0;
             walberla::float64 q_acc_2_9 = 0.0;
             walberla::float64 q_acc_3_3 = 0.0;
             walberla::float64 q_acc_3_4 = 0.0;
             walberla::float64 q_acc_3_5 = 0.0;
             walberla::float64 q_acc_3_6 = 0.0;
             walberla::float64 q_acc_3_7 = 0.0;
             walberla::float64 q_acc_3_8 = 0.0;
             walberla::float64 q_acc_3_9 = 0.0;
             walberla::float64 q_acc_4_4 = 0.0;
             walberla::float64 q_acc_4_5 = 0.0;
             walberla::float64 q_acc_4_6 = 0.0;
             walberla::float64 q_acc_4_7 = 0.0;
             walberla::float64 q_acc_4_8 = 0.0;
             walberla::float64 q_acc_4_9 = 0.0;
             walberla::float64 q_acc_5_5 = 0.0;
             walberla::float64 q_acc_5_6 = 0.0;
             walberla::float64 q_acc_5_7 = 0.0;
             walberla::float64 q_acc_5_8 = 0.0;
             walberla::float64 q_acc_5_9 = 0.0;
             walberla::float64 q_acc_6_6 = 0.0;
             walberla::float64 q_acc_6_7 = 0.0;
             walberla::float64 q_acc_6_8 = 0.0;
             walberla::float64 q_acc_6_9 = 0.0;
             walberla::float64 q_acc_7_7 = 0.0;
             walberla::float64 q_acc_7_8 = 0.0;
             walberla::float64 q_acc_7_9 = 0.0;
             walberla::float64 q_acc_8_8 = 0.0;
             walberla::float64 q_acc_8_9 = 0.0;
             walberla::float64 q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const walberla::float64 tmp_qloop_0 = 4.0*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_1 = 4.0*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_2 = 4.0*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_3 = tmp_qloop_1 + tmp_qloop_2;
                const walberla::float64 tmp_qloop_4 = tmp_qloop_0 + tmp_qloop_3 - 3.0;
                const walberla::float64 tmp_qloop_5 = jac_affine_inv_0_0_GREEN_UP*tmp_qloop_4 + jac_affine_inv_1_0_GREEN_UP*tmp_qloop_4 + jac_affine_inv_2_0_GREEN_UP*tmp_qloop_4;
                const walberla::float64 tmp_qloop_6 = jac_affine_inv_0_1_GREEN_UP*tmp_qloop_4 + jac_affine_inv_1_1_GREEN_UP*tmp_qloop_4 + jac_affine_inv_2_1_GREEN_UP*tmp_qloop_4;
                const walberla::float64 tmp_qloop_7 = jac_affine_inv_0_2_GREEN_UP*tmp_qloop_4 + jac_affine_inv_1_2_GREEN_UP*tmp_qloop_4 + jac_affine_inv_2_2_GREEN_UP*tmp_qloop_4;
                const walberla::float64 tmp_qloop_8 = tmp_qloop_1*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_9 = tmp_qloop_1*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_10 = tmp_qloop_2*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_11 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const walberla::float64 tmp_qloop_12 = tmp_qloop_11*2.0;
                const walberla::float64 tmp_qloop_13 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const walberla::float64 tmp_qloop_14 = tmp_qloop_13*2.0;
                const walberla::float64 tmp_qloop_15 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const walberla::float64 tmp_qloop_16 = tmp_qloop_15*2.0;
                const walberla::float64 tmp_qloop_17 = tmp_qloop_8 + tmp_qloop_9;
                const walberla::float64 tmp_qloop_18 = abs_det_jac_affine_GREEN_UP*(k_dof_0*(tmp_qloop_10 + tmp_qloop_12 + tmp_qloop_14 + tmp_qloop_16 + tmp_qloop_17 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0) + k_dof_1*(tmp_qloop_12 - _data_q_p_0[q]) + k_dof_2*(tmp_qloop_14 - _data_q_p_1[q]) + k_dof_3*(tmp_qloop_16 - _data_q_p_2[q]) + k_dof_4*tmp_qloop_10 + k_dof_5*tmp_qloop_9 + k_dof_6*tmp_qloop_8 + k_dof_7*(tmp_qloop_0 - tmp_qloop_10 + tmp_qloop_15*-4.0 - tmp_qloop_9) + k_dof_8*(-tmp_qloop_10 + tmp_qloop_13*-4.0 + tmp_qloop_2 - tmp_qloop_8) + k_dof_9*(tmp_qloop_1 + tmp_qloop_11*-4.0 - tmp_qloop_17))*_data_q_w[q];
                const walberla::float64 tmp_qloop_19 = tmp_qloop_1 - 1.0;
                const walberla::float64 tmp_qloop_20 = jac_affine_inv_0_0_GREEN_UP*tmp_qloop_19;
                const walberla::float64 tmp_qloop_21 = jac_affine_inv_0_1_GREEN_UP*tmp_qloop_19;
                const walberla::float64 tmp_qloop_22 = jac_affine_inv_0_2_GREEN_UP*tmp_qloop_19;
                const walberla::float64 tmp_qloop_23 = tmp_qloop_2 - 1.0;
                const walberla::float64 tmp_qloop_24 = jac_affine_inv_1_0_GREEN_UP*tmp_qloop_23;
                const walberla::float64 tmp_qloop_25 = jac_affine_inv_1_1_GREEN_UP*tmp_qloop_23;
                const walberla::float64 tmp_qloop_26 = jac_affine_inv_1_2_GREEN_UP*tmp_qloop_23;
                const walberla::float64 tmp_qloop_27 = tmp_qloop_0 - 1.0;
                const walberla::float64 tmp_qloop_28 = jac_affine_inv_2_0_GREEN_UP*tmp_qloop_27;
                const walberla::float64 tmp_qloop_29 = jac_affine_inv_2_1_GREEN_UP*tmp_qloop_27;
                const walberla::float64 tmp_qloop_30 = jac_affine_inv_2_2_GREEN_UP*tmp_qloop_27;
                const walberla::float64 tmp_qloop_31 = jac_affine_inv_2_0_GREEN_UP*tmp_qloop_2;
                const walberla::float64 tmp_qloop_32 = jac_affine_inv_1_0_GREEN_UP*tmp_qloop_0;
                const walberla::float64 tmp_qloop_33 = tmp_qloop_31 + tmp_qloop_32;
                const walberla::float64 tmp_qloop_34 = jac_affine_inv_2_1_GREEN_UP*tmp_qloop_2;
                const walberla::float64 tmp_qloop_35 = jac_affine_inv_1_1_GREEN_UP*tmp_qloop_0;
                const walberla::float64 tmp_qloop_36 = tmp_qloop_34 + tmp_qloop_35;
                const walberla::float64 tmp_qloop_37 = jac_affine_inv_2_2_GREEN_UP*tmp_qloop_2;
                const walberla::float64 tmp_qloop_38 = jac_affine_inv_1_2_GREEN_UP*tmp_qloop_0;
                const walberla::float64 tmp_qloop_39 = tmp_qloop_37 + tmp_qloop_38;
                const walberla::float64 tmp_qloop_40 = jac_affine_inv_2_0_GREEN_UP*tmp_qloop_1;
                const walberla::float64 tmp_qloop_41 = jac_affine_inv_0_0_GREEN_UP*tmp_qloop_0;
                const walberla::float64 tmp_qloop_42 = tmp_qloop_40 + tmp_qloop_41;
                const walberla::float64 tmp_qloop_43 = jac_affine_inv_2_1_GREEN_UP*tmp_qloop_1;
                const walberla::float64 tmp_qloop_44 = jac_affine_inv_0_1_GREEN_UP*tmp_qloop_0;
                const walberla::float64 tmp_qloop_45 = tmp_qloop_43 + tmp_qloop_44;
                const walberla::float64 tmp_qloop_46 = jac_affine_inv_2_2_GREEN_UP*tmp_qloop_1;
                const walberla::float64 tmp_qloop_47 = jac_affine_inv_0_2_GREEN_UP*tmp_qloop_0;
                const walberla::float64 tmp_qloop_48 = tmp_qloop_46 + tmp_qloop_47;
                const walberla::float64 tmp_qloop_49 = jac_affine_inv_1_0_GREEN_UP*tmp_qloop_1;
                const walberla::float64 tmp_qloop_50 = jac_affine_inv_0_0_GREEN_UP*tmp_qloop_2;
                const walberla::float64 tmp_qloop_51 = tmp_qloop_49 + tmp_qloop_50;
                const walberla::float64 tmp_qloop_52 = jac_affine_inv_1_1_GREEN_UP*tmp_qloop_1;
                const walberla::float64 tmp_qloop_53 = jac_affine_inv_0_1_GREEN_UP*tmp_qloop_2;
                const walberla::float64 tmp_qloop_54 = tmp_qloop_52 + tmp_qloop_53;
                const walberla::float64 tmp_qloop_55 = jac_affine_inv_1_2_GREEN_UP*tmp_qloop_1;
                const walberla::float64 tmp_qloop_56 = jac_affine_inv_0_2_GREEN_UP*tmp_qloop_2;
                const walberla::float64 tmp_qloop_57 = tmp_qloop_55 + tmp_qloop_56;
                const walberla::float64 tmp_qloop_58 = -tmp_qloop_3 - 8.0*_data_q_p_2[q] + 4.0;
                const walberla::float64 tmp_qloop_59 = jac_affine_inv_2_0_GREEN_UP*tmp_qloop_58 - tmp_qloop_32 - tmp_qloop_41;
                const walberla::float64 tmp_qloop_60 = jac_affine_inv_2_1_GREEN_UP*tmp_qloop_58 - tmp_qloop_35 - tmp_qloop_44;
                const walberla::float64 tmp_qloop_61 = jac_affine_inv_2_2_GREEN_UP*tmp_qloop_58 - tmp_qloop_38 - tmp_qloop_47;
                const walberla::float64 tmp_qloop_62 = tmp_qloop_0 - 4.0;
                const walberla::float64 tmp_qloop_63 = -tmp_qloop_1 - tmp_qloop_62 - 8.0*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_64 = jac_affine_inv_1_0_GREEN_UP*tmp_qloop_63 - tmp_qloop_31 - tmp_qloop_50;
                const walberla::float64 tmp_qloop_65 = jac_affine_inv_1_1_GREEN_UP*tmp_qloop_63 - tmp_qloop_34 - tmp_qloop_53;
                const walberla::float64 tmp_qloop_66 = jac_affine_inv_1_2_GREEN_UP*tmp_qloop_63 - tmp_qloop_37 - tmp_qloop_56;
                const walberla::float64 tmp_qloop_67 = -tmp_qloop_2 - tmp_qloop_62 - 8.0*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_68 = jac_affine_inv_0_0_GREEN_UP*tmp_qloop_67 - tmp_qloop_40 - tmp_qloop_49;
                const walberla::float64 tmp_qloop_69 = jac_affine_inv_0_1_GREEN_UP*tmp_qloop_67 - tmp_qloop_43 - tmp_qloop_52;
                const walberla::float64 tmp_qloop_70 = jac_affine_inv_0_2_GREEN_UP*tmp_qloop_67 - tmp_qloop_46 - tmp_qloop_55;
                const walberla::float64 tmp_qloop_71 = ((-0.25 + _data_q_p_0[q])*(-0.25 + _data_q_p_0[q]))*16.0;
                const walberla::float64 tmp_qloop_72 = ((-0.25 + _data_q_p_1[q])*(-0.25 + _data_q_p_1[q]))*16.0;
                const walberla::float64 tmp_qloop_73 = ((-0.25 + _data_q_p_2[q])*(-0.25 + _data_q_p_2[q]))*16.0;
                const walberla::float64 tmp_qloop_74 = jac_affine_inv_2_0_GREEN_UP*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_75 = jac_affine_inv_1_0_GREEN_UP*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_76 = jac_affine_inv_2_1_GREEN_UP*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_77 = jac_affine_inv_1_1_GREEN_UP*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_78 = jac_affine_inv_2_2_GREEN_UP*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_79 = jac_affine_inv_1_2_GREEN_UP*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_80 = jac_affine_inv_2_0_GREEN_UP*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_81 = jac_affine_inv_0_0_GREEN_UP*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_82 = jac_affine_inv_2_1_GREEN_UP*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_83 = jac_affine_inv_0_1_GREEN_UP*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_84 = jac_affine_inv_2_2_GREEN_UP*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_85 = jac_affine_inv_0_2_GREEN_UP*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_86 = jac_affine_inv_1_0_GREEN_UP*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_87 = jac_affine_inv_0_0_GREEN_UP*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_88 = jac_affine_inv_1_1_GREEN_UP*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_89 = jac_affine_inv_0_1_GREEN_UP*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_90 = jac_affine_inv_1_2_GREEN_UP*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_91 = jac_affine_inv_0_2_GREEN_UP*_data_q_p_1[q];
                const walberla::float64 q_tmp_0_0 = tmp_qloop_18*((tmp_qloop_5*tmp_qloop_5) + (tmp_qloop_6*tmp_qloop_6) + (tmp_qloop_7*tmp_qloop_7));
                const walberla::float64 q_tmp_0_1 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_5 + tmp_qloop_21*tmp_qloop_6 + tmp_qloop_22*tmp_qloop_7);
                const walberla::float64 q_tmp_0_2 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_5 + tmp_qloop_25*tmp_qloop_6 + tmp_qloop_26*tmp_qloop_7);
                const walberla::float64 q_tmp_0_3 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_5 + tmp_qloop_29*tmp_qloop_6 + tmp_qloop_30*tmp_qloop_7);
                const walberla::float64 q_tmp_0_4 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_5 + tmp_qloop_36*tmp_qloop_6 + tmp_qloop_39*tmp_qloop_7);
                const walberla::float64 q_tmp_0_5 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_5 + tmp_qloop_45*tmp_qloop_6 + tmp_qloop_48*tmp_qloop_7);
                const walberla::float64 q_tmp_0_6 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_51 + tmp_qloop_54*tmp_qloop_6 + tmp_qloop_57*tmp_qloop_7);
                const walberla::float64 q_tmp_0_7 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_59 + tmp_qloop_6*tmp_qloop_60 + tmp_qloop_61*tmp_qloop_7);
                const walberla::float64 q_tmp_0_8 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_64 + tmp_qloop_6*tmp_qloop_65 + tmp_qloop_66*tmp_qloop_7);
                const walberla::float64 q_tmp_0_9 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_68 + tmp_qloop_6*tmp_qloop_69 + tmp_qloop_7*tmp_qloop_70);
                const walberla::float64 q_tmp_1_1 = tmp_qloop_18*((jac_affine_inv_0_0_GREEN_UP*jac_affine_inv_0_0_GREEN_UP)*tmp_qloop_71 + (jac_affine_inv_0_1_GREEN_UP*jac_affine_inv_0_1_GREEN_UP)*tmp_qloop_71 + (jac_affine_inv_0_2_GREEN_UP*jac_affine_inv_0_2_GREEN_UP)*tmp_qloop_71);
                const walberla::float64 q_tmp_1_2 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_24 + tmp_qloop_21*tmp_qloop_25 + tmp_qloop_22*tmp_qloop_26);
                const walberla::float64 q_tmp_1_3 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_28 + tmp_qloop_21*tmp_qloop_29 + tmp_qloop_22*tmp_qloop_30);
                const walberla::float64 q_tmp_1_4 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_33 + tmp_qloop_21*tmp_qloop_36 + tmp_qloop_22*tmp_qloop_39);
                const walberla::float64 q_tmp_1_5 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_42 + tmp_qloop_21*tmp_qloop_45 + tmp_qloop_22*tmp_qloop_48);
                const walberla::float64 q_tmp_1_6 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_51 + tmp_qloop_21*tmp_qloop_54 + tmp_qloop_22*tmp_qloop_57);
                const walberla::float64 q_tmp_1_7 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_59 + tmp_qloop_21*tmp_qloop_60 + tmp_qloop_22*tmp_qloop_61);
                const walberla::float64 q_tmp_1_8 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_64 + tmp_qloop_21*tmp_qloop_65 + tmp_qloop_22*tmp_qloop_66);
                const walberla::float64 q_tmp_1_9 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_68 + tmp_qloop_21*tmp_qloop_69 + tmp_qloop_22*tmp_qloop_70);
                const walberla::float64 q_tmp_2_2 = tmp_qloop_18*((jac_affine_inv_1_0_GREEN_UP*jac_affine_inv_1_0_GREEN_UP)*tmp_qloop_72 + (jac_affine_inv_1_1_GREEN_UP*jac_affine_inv_1_1_GREEN_UP)*tmp_qloop_72 + (jac_affine_inv_1_2_GREEN_UP*jac_affine_inv_1_2_GREEN_UP)*tmp_qloop_72);
                const walberla::float64 q_tmp_2_3 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_28 + tmp_qloop_25*tmp_qloop_29 + tmp_qloop_26*tmp_qloop_30);
                const walberla::float64 q_tmp_2_4 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_33 + tmp_qloop_25*tmp_qloop_36 + tmp_qloop_26*tmp_qloop_39);
                const walberla::float64 q_tmp_2_5 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_42 + tmp_qloop_25*tmp_qloop_45 + tmp_qloop_26*tmp_qloop_48);
                const walberla::float64 q_tmp_2_6 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_51 + tmp_qloop_25*tmp_qloop_54 + tmp_qloop_26*tmp_qloop_57);
                const walberla::float64 q_tmp_2_7 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_59 + tmp_qloop_25*tmp_qloop_60 + tmp_qloop_26*tmp_qloop_61);
                const walberla::float64 q_tmp_2_8 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_64 + tmp_qloop_25*tmp_qloop_65 + tmp_qloop_26*tmp_qloop_66);
                const walberla::float64 q_tmp_2_9 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_68 + tmp_qloop_25*tmp_qloop_69 + tmp_qloop_26*tmp_qloop_70);
                const walberla::float64 q_tmp_3_3 = tmp_qloop_18*((jac_affine_inv_2_0_GREEN_UP*jac_affine_inv_2_0_GREEN_UP)*tmp_qloop_73 + (jac_affine_inv_2_1_GREEN_UP*jac_affine_inv_2_1_GREEN_UP)*tmp_qloop_73 + (jac_affine_inv_2_2_GREEN_UP*jac_affine_inv_2_2_GREEN_UP)*tmp_qloop_73);
                const walberla::float64 q_tmp_3_4 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_33 + tmp_qloop_29*tmp_qloop_36 + tmp_qloop_30*tmp_qloop_39);
                const walberla::float64 q_tmp_3_5 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_42 + tmp_qloop_29*tmp_qloop_45 + tmp_qloop_30*tmp_qloop_48);
                const walberla::float64 q_tmp_3_6 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_51 + tmp_qloop_29*tmp_qloop_54 + tmp_qloop_30*tmp_qloop_57);
                const walberla::float64 q_tmp_3_7 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_59 + tmp_qloop_29*tmp_qloop_60 + tmp_qloop_30*tmp_qloop_61);
                const walberla::float64 q_tmp_3_8 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_64 + tmp_qloop_29*tmp_qloop_65 + tmp_qloop_30*tmp_qloop_66);
                const walberla::float64 q_tmp_3_9 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_68 + tmp_qloop_29*tmp_qloop_69 + tmp_qloop_30*tmp_qloop_70);
                const walberla::float64 q_tmp_4_4 = tmp_qloop_18*(((tmp_qloop_74 + tmp_qloop_75)*(tmp_qloop_74 + tmp_qloop_75))*16.0 + ((tmp_qloop_76 + tmp_qloop_77)*(tmp_qloop_76 + tmp_qloop_77))*16.0 + ((tmp_qloop_78 + tmp_qloop_79)*(tmp_qloop_78 + tmp_qloop_79))*16.0);
                const walberla::float64 q_tmp_4_5 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_42 + tmp_qloop_36*tmp_qloop_45 + tmp_qloop_39*tmp_qloop_48);
                const walberla::float64 q_tmp_4_6 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_51 + tmp_qloop_36*tmp_qloop_54 + tmp_qloop_39*tmp_qloop_57);
                const walberla::float64 q_tmp_4_7 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_59 + tmp_qloop_36*tmp_qloop_60 + tmp_qloop_39*tmp_qloop_61);
                const walberla::float64 q_tmp_4_8 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_64 + tmp_qloop_36*tmp_qloop_65 + tmp_qloop_39*tmp_qloop_66);
                const walberla::float64 q_tmp_4_9 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_68 + tmp_qloop_36*tmp_qloop_69 + tmp_qloop_39*tmp_qloop_70);
                const walberla::float64 q_tmp_5_5 = tmp_qloop_18*(((tmp_qloop_80 + tmp_qloop_81)*(tmp_qloop_80 + tmp_qloop_81))*16.0 + ((tmp_qloop_82 + tmp_qloop_83)*(tmp_qloop_82 + tmp_qloop_83))*16.0 + ((tmp_qloop_84 + tmp_qloop_85)*(tmp_qloop_84 + tmp_qloop_85))*16.0);
                const walberla::float64 q_tmp_5_6 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_51 + tmp_qloop_45*tmp_qloop_54 + tmp_qloop_48*tmp_qloop_57);
                const walberla::float64 q_tmp_5_7 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_59 + tmp_qloop_45*tmp_qloop_60 + tmp_qloop_48*tmp_qloop_61);
                const walberla::float64 q_tmp_5_8 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_64 + tmp_qloop_45*tmp_qloop_65 + tmp_qloop_48*tmp_qloop_66);
                const walberla::float64 q_tmp_5_9 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_68 + tmp_qloop_45*tmp_qloop_69 + tmp_qloop_48*tmp_qloop_70);
                const walberla::float64 q_tmp_6_6 = tmp_qloop_18*(((tmp_qloop_86 + tmp_qloop_87)*(tmp_qloop_86 + tmp_qloop_87))*16.0 + ((tmp_qloop_88 + tmp_qloop_89)*(tmp_qloop_88 + tmp_qloop_89))*16.0 + ((tmp_qloop_90 + tmp_qloop_91)*(tmp_qloop_90 + tmp_qloop_91))*16.0);
                const walberla::float64 q_tmp_6_7 = tmp_qloop_18*(tmp_qloop_51*tmp_qloop_59 + tmp_qloop_54*tmp_qloop_60 + tmp_qloop_57*tmp_qloop_61);
                const walberla::float64 q_tmp_6_8 = tmp_qloop_18*(tmp_qloop_51*tmp_qloop_64 + tmp_qloop_54*tmp_qloop_65 + tmp_qloop_57*tmp_qloop_66);
                const walberla::float64 q_tmp_6_9 = tmp_qloop_18*(tmp_qloop_51*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_57*tmp_qloop_70);
                const walberla::float64 q_tmp_7_7 = tmp_qloop_18*(((jac_affine_inv_2_0_GREEN_UP*tmp_qloop_58*0.25 - tmp_qloop_75 - tmp_qloop_81)*(jac_affine_inv_2_0_GREEN_UP*tmp_qloop_58*0.25 - tmp_qloop_75 - tmp_qloop_81))*16.0 + ((jac_affine_inv_2_1_GREEN_UP*tmp_qloop_58*0.25 - tmp_qloop_77 - tmp_qloop_83)*(jac_affine_inv_2_1_GREEN_UP*tmp_qloop_58*0.25 - tmp_qloop_77 - tmp_qloop_83))*16.0 + ((jac_affine_inv_2_2_GREEN_UP*tmp_qloop_58*0.25 - tmp_qloop_79 - tmp_qloop_85)*(jac_affine_inv_2_2_GREEN_UP*tmp_qloop_58*0.25 - tmp_qloop_79 - tmp_qloop_85))*16.0);
                const walberla::float64 q_tmp_7_8 = tmp_qloop_18*(tmp_qloop_59*tmp_qloop_64 + tmp_qloop_60*tmp_qloop_65 + tmp_qloop_61*tmp_qloop_66);
                const walberla::float64 q_tmp_7_9 = tmp_qloop_18*(tmp_qloop_59*tmp_qloop_68 + tmp_qloop_60*tmp_qloop_69 + tmp_qloop_61*tmp_qloop_70);
                const walberla::float64 q_tmp_8_8 = tmp_qloop_18*(((jac_affine_inv_1_0_GREEN_UP*tmp_qloop_63*0.25 - tmp_qloop_74 - tmp_qloop_87)*(jac_affine_inv_1_0_GREEN_UP*tmp_qloop_63*0.25 - tmp_qloop_74 - tmp_qloop_87))*16.0 + ((jac_affine_inv_1_1_GREEN_UP*tmp_qloop_63*0.25 - tmp_qloop_76 - tmp_qloop_89)*(jac_affine_inv_1_1_GREEN_UP*tmp_qloop_63*0.25 - tmp_qloop_76 - tmp_qloop_89))*16.0 + ((jac_affine_inv_1_2_GREEN_UP*tmp_qloop_63*0.25 - tmp_qloop_78 - tmp_qloop_91)*(jac_affine_inv_1_2_GREEN_UP*tmp_qloop_63*0.25 - tmp_qloop_78 - tmp_qloop_91))*16.0);
                const walberla::float64 q_tmp_8_9 = tmp_qloop_18*(tmp_qloop_64*tmp_qloop_68 + tmp_qloop_65*tmp_qloop_69 + tmp_qloop_66*tmp_qloop_70);
                const walberla::float64 q_tmp_9_9 = tmp_qloop_18*(((jac_affine_inv_0_0_GREEN_UP*tmp_qloop_67*0.25 - tmp_qloop_80 - tmp_qloop_86)*(jac_affine_inv_0_0_GREEN_UP*tmp_qloop_67*0.25 - tmp_qloop_80 - tmp_qloop_86))*16.0 + ((jac_affine_inv_0_1_GREEN_UP*tmp_qloop_67*0.25 - tmp_qloop_82 - tmp_qloop_88)*(jac_affine_inv_0_1_GREEN_UP*tmp_qloop_67*0.25 - tmp_qloop_82 - tmp_qloop_88))*16.0 + ((jac_affine_inv_0_2_GREEN_UP*tmp_qloop_67*0.25 - tmp_qloop_84 - tmp_qloop_90)*(jac_affine_inv_0_2_GREEN_UP*tmp_qloop_67*0.25 - tmp_qloop_84 - tmp_qloop_90))*16.0);
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const walberla::float64 elMat_0_0 = q_acc_0_0;
             const walberla::float64 elMat_0_1 = q_acc_0_1;
             const walberla::float64 elMat_0_2 = q_acc_0_2;
             const walberla::float64 elMat_0_3 = q_acc_0_3;
             const walberla::float64 elMat_0_4 = q_acc_0_4;
             const walberla::float64 elMat_0_5 = q_acc_0_5;
             const walberla::float64 elMat_0_6 = q_acc_0_6;
             const walberla::float64 elMat_0_7 = q_acc_0_7;
             const walberla::float64 elMat_0_8 = q_acc_0_8;
             const walberla::float64 elMat_0_9 = q_acc_0_9;
             const walberla::float64 elMat_1_0 = q_acc_0_1;
             const walberla::float64 elMat_1_1 = q_acc_1_1;
             const walberla::float64 elMat_1_2 = q_acc_1_2;
             const walberla::float64 elMat_1_3 = q_acc_1_3;
             const walberla::float64 elMat_1_4 = q_acc_1_4;
             const walberla::float64 elMat_1_5 = q_acc_1_5;
             const walberla::float64 elMat_1_6 = q_acc_1_6;
             const walberla::float64 elMat_1_7 = q_acc_1_7;
             const walberla::float64 elMat_1_8 = q_acc_1_8;
             const walberla::float64 elMat_1_9 = q_acc_1_9;
             const walberla::float64 elMat_2_0 = q_acc_0_2;
             const walberla::float64 elMat_2_1 = q_acc_1_2;
             const walberla::float64 elMat_2_2 = q_acc_2_2;
             const walberla::float64 elMat_2_3 = q_acc_2_3;
             const walberla::float64 elMat_2_4 = q_acc_2_4;
             const walberla::float64 elMat_2_5 = q_acc_2_5;
             const walberla::float64 elMat_2_6 = q_acc_2_6;
             const walberla::float64 elMat_2_7 = q_acc_2_7;
             const walberla::float64 elMat_2_8 = q_acc_2_8;
             const walberla::float64 elMat_2_9 = q_acc_2_9;
             const walberla::float64 elMat_3_0 = q_acc_0_3;
             const walberla::float64 elMat_3_1 = q_acc_1_3;
             const walberla::float64 elMat_3_2 = q_acc_2_3;
             const walberla::float64 elMat_3_3 = q_acc_3_3;
             const walberla::float64 elMat_3_4 = q_acc_3_4;
             const walberla::float64 elMat_3_5 = q_acc_3_5;
             const walberla::float64 elMat_3_6 = q_acc_3_6;
             const walberla::float64 elMat_3_7 = q_acc_3_7;
             const walberla::float64 elMat_3_8 = q_acc_3_8;
             const walberla::float64 elMat_3_9 = q_acc_3_9;
             const walberla::float64 elMat_4_0 = q_acc_0_4;
             const walberla::float64 elMat_4_1 = q_acc_1_4;
             const walberla::float64 elMat_4_2 = q_acc_2_4;
             const walberla::float64 elMat_4_3 = q_acc_3_4;
             const walberla::float64 elMat_4_4 = q_acc_4_4;
             const walberla::float64 elMat_4_5 = q_acc_4_5;
             const walberla::float64 elMat_4_6 = q_acc_4_6;
             const walberla::float64 elMat_4_7 = q_acc_4_7;
             const walberla::float64 elMat_4_8 = q_acc_4_8;
             const walberla::float64 elMat_4_9 = q_acc_4_9;
             const walberla::float64 elMat_5_0 = q_acc_0_5;
             const walberla::float64 elMat_5_1 = q_acc_1_5;
             const walberla::float64 elMat_5_2 = q_acc_2_5;
             const walberla::float64 elMat_5_3 = q_acc_3_5;
             const walberla::float64 elMat_5_4 = q_acc_4_5;
             const walberla::float64 elMat_5_5 = q_acc_5_5;
             const walberla::float64 elMat_5_6 = q_acc_5_6;
             const walberla::float64 elMat_5_7 = q_acc_5_7;
             const walberla::float64 elMat_5_8 = q_acc_5_8;
             const walberla::float64 elMat_5_9 = q_acc_5_9;
             const walberla::float64 elMat_6_0 = q_acc_0_6;
             const walberla::float64 elMat_6_1 = q_acc_1_6;
             const walberla::float64 elMat_6_2 = q_acc_2_6;
             const walberla::float64 elMat_6_3 = q_acc_3_6;
             const walberla::float64 elMat_6_4 = q_acc_4_6;
             const walberla::float64 elMat_6_5 = q_acc_5_6;
             const walberla::float64 elMat_6_6 = q_acc_6_6;
             const walberla::float64 elMat_6_7 = q_acc_6_7;
             const walberla::float64 elMat_6_8 = q_acc_6_8;
             const walberla::float64 elMat_6_9 = q_acc_6_9;
             const walberla::float64 elMat_7_0 = q_acc_0_7;
             const walberla::float64 elMat_7_1 = q_acc_1_7;
             const walberla::float64 elMat_7_2 = q_acc_2_7;
             const walberla::float64 elMat_7_3 = q_acc_3_7;
             const walberla::float64 elMat_7_4 = q_acc_4_7;
             const walberla::float64 elMat_7_5 = q_acc_5_7;
             const walberla::float64 elMat_7_6 = q_acc_6_7;
             const walberla::float64 elMat_7_7 = q_acc_7_7;
             const walberla::float64 elMat_7_8 = q_acc_7_8;
             const walberla::float64 elMat_7_9 = q_acc_7_9;
             const walberla::float64 elMat_8_0 = q_acc_0_8;
             const walberla::float64 elMat_8_1 = q_acc_1_8;
             const walberla::float64 elMat_8_2 = q_acc_2_8;
             const walberla::float64 elMat_8_3 = q_acc_3_8;
             const walberla::float64 elMat_8_4 = q_acc_4_8;
             const walberla::float64 elMat_8_5 = q_acc_5_8;
             const walberla::float64 elMat_8_6 = q_acc_6_8;
             const walberla::float64 elMat_8_7 = q_acc_7_8;
             const walberla::float64 elMat_8_8 = q_acc_8_8;
             const walberla::float64 elMat_8_9 = q_acc_8_9;
             const walberla::float64 elMat_9_0 = q_acc_0_9;
             const walberla::float64 elMat_9_1 = q_acc_1_9;
             const walberla::float64 elMat_9_2 = q_acc_2_9;
             const walberla::float64 elMat_9_3 = q_acc_3_9;
             const walberla::float64 elMat_9_4 = q_acc_4_9;
             const walberla::float64 elMat_9_5 = q_acc_5_9;
             const walberla::float64 elMat_9_6 = q_acc_6_9;
             const walberla::float64 elMat_9_7 = q_acc_7_9;
             const walberla::float64 elMat_9_8 = q_acc_8_9;
             const walberla::float64 elMat_9_9 = q_acc_9_9;
         
             std::vector< uint_t > _data_rowIdx( 10 );
             std::vector< uint_t > _data_colIdx( 10 );
             std::vector< walberla::float64 > _data_mat( 100 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[1] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[2] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[3] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[4] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[7] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[8] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[9] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 2) - ((ctr_1*(ctr_1 + 1)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[3] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[7] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((walberla::float64)(elMat_0_0));
             _data_mat[1] = ((walberla::float64)(elMat_0_1));
             _data_mat[2] = ((walberla::float64)(elMat_0_2));
             _data_mat[3] = ((walberla::float64)(elMat_0_3));
             _data_mat[4] = ((walberla::float64)(elMat_0_4));
             _data_mat[5] = ((walberla::float64)(elMat_0_5));
             _data_mat[6] = ((walberla::float64)(elMat_0_6));
             _data_mat[7] = ((walberla::float64)(elMat_0_7));
             _data_mat[8] = ((walberla::float64)(elMat_0_8));
             _data_mat[9] = ((walberla::float64)(elMat_0_9));
             _data_mat[10] = ((walberla::float64)(elMat_1_0));
             _data_mat[11] = ((walberla::float64)(elMat_1_1));
             _data_mat[12] = ((walberla::float64)(elMat_1_2));
             _data_mat[13] = ((walberla::float64)(elMat_1_3));
             _data_mat[14] = ((walberla::float64)(elMat_1_4));
             _data_mat[15] = ((walberla::float64)(elMat_1_5));
             _data_mat[16] = ((walberla::float64)(elMat_1_6));
             _data_mat[17] = ((walberla::float64)(elMat_1_7));
             _data_mat[18] = ((walberla::float64)(elMat_1_8));
             _data_mat[19] = ((walberla::float64)(elMat_1_9));
             _data_mat[20] = ((walberla::float64)(elMat_2_0));
             _data_mat[21] = ((walberla::float64)(elMat_2_1));
             _data_mat[22] = ((walberla::float64)(elMat_2_2));
             _data_mat[23] = ((walberla::float64)(elMat_2_3));
             _data_mat[24] = ((walberla::float64)(elMat_2_4));
             _data_mat[25] = ((walberla::float64)(elMat_2_5));
             _data_mat[26] = ((walberla::float64)(elMat_2_6));
             _data_mat[27] = ((walberla::float64)(elMat_2_7));
             _data_mat[28] = ((walberla::float64)(elMat_2_8));
             _data_mat[29] = ((walberla::float64)(elMat_2_9));
             _data_mat[30] = ((walberla::float64)(elMat_3_0));
             _data_mat[31] = ((walberla::float64)(elMat_3_1));
             _data_mat[32] = ((walberla::float64)(elMat_3_2));
             _data_mat[33] = ((walberla::float64)(elMat_3_3));
             _data_mat[34] = ((walberla::float64)(elMat_3_4));
             _data_mat[35] = ((walberla::float64)(elMat_3_5));
             _data_mat[36] = ((walberla::float64)(elMat_3_6));
             _data_mat[37] = ((walberla::float64)(elMat_3_7));
             _data_mat[38] = ((walberla::float64)(elMat_3_8));
             _data_mat[39] = ((walberla::float64)(elMat_3_9));
             _data_mat[40] = ((walberla::float64)(elMat_4_0));
             _data_mat[41] = ((walberla::float64)(elMat_4_1));
             _data_mat[42] = ((walberla::float64)(elMat_4_2));
             _data_mat[43] = ((walberla::float64)(elMat_4_3));
             _data_mat[44] = ((walberla::float64)(elMat_4_4));
             _data_mat[45] = ((walberla::float64)(elMat_4_5));
             _data_mat[46] = ((walberla::float64)(elMat_4_6));
             _data_mat[47] = ((walberla::float64)(elMat_4_7));
             _data_mat[48] = ((walberla::float64)(elMat_4_8));
             _data_mat[49] = ((walberla::float64)(elMat_4_9));
             _data_mat[50] = ((walberla::float64)(elMat_5_0));
             _data_mat[51] = ((walberla::float64)(elMat_5_1));
             _data_mat[52] = ((walberla::float64)(elMat_5_2));
             _data_mat[53] = ((walberla::float64)(elMat_5_3));
             _data_mat[54] = ((walberla::float64)(elMat_5_4));
             _data_mat[55] = ((walberla::float64)(elMat_5_5));
             _data_mat[56] = ((walberla::float64)(elMat_5_6));
             _data_mat[57] = ((walberla::float64)(elMat_5_7));
             _data_mat[58] = ((walberla::float64)(elMat_5_8));
             _data_mat[59] = ((walberla::float64)(elMat_5_9));
             _data_mat[60] = ((walberla::float64)(elMat_6_0));
             _data_mat[61] = ((walberla::float64)(elMat_6_1));
             _data_mat[62] = ((walberla::float64)(elMat_6_2));
             _data_mat[63] = ((walberla::float64)(elMat_6_3));
             _data_mat[64] = ((walberla::float64)(elMat_6_4));
             _data_mat[65] = ((walberla::float64)(elMat_6_5));
             _data_mat[66] = ((walberla::float64)(elMat_6_6));
             _data_mat[67] = ((walberla::float64)(elMat_6_7));
             _data_mat[68] = ((walberla::float64)(elMat_6_8));
             _data_mat[69] = ((walberla::float64)(elMat_6_9));
             _data_mat[70] = ((walberla::float64)(elMat_7_0));
             _data_mat[71] = ((walberla::float64)(elMat_7_1));
             _data_mat[72] = ((walberla::float64)(elMat_7_2));
             _data_mat[73] = ((walberla::float64)(elMat_7_3));
             _data_mat[74] = ((walberla::float64)(elMat_7_4));
             _data_mat[75] = ((walberla::float64)(elMat_7_5));
             _data_mat[76] = ((walberla::float64)(elMat_7_6));
             _data_mat[77] = ((walberla::float64)(elMat_7_7));
             _data_mat[78] = ((walberla::float64)(elMat_7_8));
             _data_mat[79] = ((walberla::float64)(elMat_7_9));
             _data_mat[80] = ((walberla::float64)(elMat_8_0));
             _data_mat[81] = ((walberla::float64)(elMat_8_1));
             _data_mat[82] = ((walberla::float64)(elMat_8_2));
             _data_mat[83] = ((walberla::float64)(elMat_8_3));
             _data_mat[84] = ((walberla::float64)(elMat_8_4));
             _data_mat[85] = ((walberla::float64)(elMat_8_5));
             _data_mat[86] = ((walberla::float64)(elMat_8_6));
             _data_mat[87] = ((walberla::float64)(elMat_8_7));
             _data_mat[88] = ((walberla::float64)(elMat_8_8));
             _data_mat[89] = ((walberla::float64)(elMat_8_9));
             _data_mat[90] = ((walberla::float64)(elMat_9_0));
             _data_mat[91] = ((walberla::float64)(elMat_9_1));
             _data_mat[92] = ((walberla::float64)(elMat_9_2));
             _data_mat[93] = ((walberla::float64)(elMat_9_3));
             _data_mat[94] = ((walberla::float64)(elMat_9_4));
             _data_mat[95] = ((walberla::float64)(elMat_9_5));
             _data_mat[96] = ((walberla::float64)(elMat_9_6));
             _data_mat[97] = ((walberla::float64)(elMat_9_7));
             _data_mat[98] = ((walberla::float64)(elMat_9_8));
             _data_mat[99] = ((walberla::float64)(elMat_9_9));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
       const walberla::float64 tmp_coords_jac_0_GREEN_DOWN = 1.0 / (micro_edges_per_macro_edge_float)*1.0;
       const walberla::float64 tmp_coords_jac_1_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_2comp0);
       const walberla::float64 tmp_coords_jac_2_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_2comp1);
       const walberla::float64 tmp_coords_jac_3_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_2comp2);
       const walberla::float64 tmp_coords_jac_4_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_1comp0);
       const walberla::float64 tmp_coords_jac_5_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_1comp1);
       const walberla::float64 tmp_coords_jac_6_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_1comp2);
       const walberla::float64 tmp_coords_jac_7_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp0 + macro_vertex_coord_id_3comp0);
       const walberla::float64 tmp_coords_jac_8_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp1 + macro_vertex_coord_id_3comp1);
       const walberla::float64 tmp_coords_jac_9_GREEN_DOWN = tmp_coords_jac_0_GREEN_DOWN*(-macro_vertex_coord_id_0comp2 + macro_vertex_coord_id_3comp2);
       const walberla::float64 p_affine_const_0_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN;
       const walberla::float64 p_affine_const_0_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN;
       const walberla::float64 p_affine_const_0_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN;
       const walberla::float64 p_affine_const_1_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_4_GREEN_DOWN;
       const walberla::float64 p_affine_const_1_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_5_GREEN_DOWN;
       const walberla::float64 p_affine_const_1_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_6_GREEN_DOWN;
       const walberla::float64 p_affine_const_2_0_GREEN_DOWN = macro_vertex_coord_id_0comp0 + tmp_coords_jac_4_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const walberla::float64 p_affine_const_2_1_GREEN_DOWN = macro_vertex_coord_id_0comp1 + tmp_coords_jac_5_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const walberla::float64 p_affine_const_2_2_GREEN_DOWN = macro_vertex_coord_id_0comp2 + tmp_coords_jac_6_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const walberla::float64 p_affine_const_3_0_GREEN_DOWN = tmp_coords_jac_1_GREEN_DOWN + tmp_coords_jac_7_GREEN_DOWN;
       const walberla::float64 p_affine_const_3_1_GREEN_DOWN = tmp_coords_jac_2_GREEN_DOWN + tmp_coords_jac_8_GREEN_DOWN;
       const walberla::float64 p_affine_const_3_2_GREEN_DOWN = tmp_coords_jac_3_GREEN_DOWN + tmp_coords_jac_9_GREEN_DOWN;
       const walberla::float64 jac_affine_0_0_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_1_0_GREEN_DOWN;
       const walberla::float64 jac_affine_0_1_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_2_0_GREEN_DOWN;
       const walberla::float64 jac_affine_0_2_GREEN_DOWN = -p_affine_const_0_0_GREEN_DOWN + p_affine_const_3_0_GREEN_DOWN;
       const walberla::float64 jac_affine_1_0_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_1_1_GREEN_DOWN;
       const walberla::float64 jac_affine_1_1_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_2_1_GREEN_DOWN;
       const walberla::float64 tmp_coords_jac_14_GREEN_DOWN = jac_affine_0_2_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN;
       const walberla::float64 jac_affine_1_2_GREEN_DOWN = -p_affine_const_0_1_GREEN_DOWN + p_affine_const_3_1_GREEN_DOWN;
       const walberla::float64 tmp_coords_jac_12_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN;
       const walberla::float64 jac_affine_2_0_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_1_2_GREEN_DOWN;
       const walberla::float64 jac_affine_2_1_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_2_2_GREEN_DOWN;
       const walberla::float64 tmp_coords_jac_11_GREEN_DOWN = jac_affine_1_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN;
       const walberla::float64 jac_affine_2_2_GREEN_DOWN = -p_affine_const_0_2_GREEN_DOWN + p_affine_const_3_2_GREEN_DOWN;
       const walberla::float64 tmp_coords_jac_10_GREEN_DOWN = jac_affine_1_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const walberla::float64 tmp_coords_jac_13_GREEN_DOWN = jac_affine_0_1_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN;
       const walberla::float64 tmp_coords_jac_15_GREEN_DOWN = jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_10_GREEN_DOWN - jac_affine_0_0_GREEN_DOWN*tmp_coords_jac_11_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_0_GREEN_DOWN*tmp_coords_jac_13_GREEN_DOWN + jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_12_GREEN_DOWN - jac_affine_2_0_GREEN_DOWN*tmp_coords_jac_14_GREEN_DOWN;
       const walberla::float64 tmp_coords_jac_16_GREEN_DOWN = 1.0 / (tmp_coords_jac_15_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_0_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_10_GREEN_DOWN - tmp_coords_jac_11_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_0_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_2_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - tmp_coords_jac_13_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_0_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(tmp_coords_jac_12_GREEN_DOWN - tmp_coords_jac_14_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_1_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_1_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN + jac_affine_1_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_1_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_2_2_GREEN_DOWN - jac_affine_0_2_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_1_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_1_2_GREEN_DOWN + jac_affine_0_2_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_2_0_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_1_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN - jac_affine_1_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_2_1_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(-jac_affine_0_0_GREEN_DOWN*jac_affine_2_1_GREEN_DOWN + jac_affine_0_1_GREEN_DOWN*jac_affine_2_0_GREEN_DOWN);
       const walberla::float64 jac_affine_inv_2_2_GREEN_DOWN = tmp_coords_jac_16_GREEN_DOWN*(jac_affine_0_0_GREEN_DOWN*jac_affine_1_1_GREEN_DOWN - jac_affine_0_1_GREEN_DOWN*jac_affine_1_0_GREEN_DOWN);
       const walberla::float64 abs_det_jac_affine_GREEN_DOWN = abs(tmp_coords_jac_15_GREEN_DOWN);
       {
          /* CellType.GREEN_DOWN */
          for (int64_t ctr_2 = 0; ctr_2 < micro_edges_per_macro_edge; ctr_2 += 1)
          for (int64_t ctr_1 = 0; ctr_1 < -ctr_2 + micro_edges_per_macro_edge; ctr_1 += 1)
          for (int64_t ctr_0 = 0; ctr_0 < -ctr_1 - ctr_2 + micro_edges_per_macro_edge - 1; ctr_0 += 1)
          {
             const walberla::float64 k_dof_0 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 k_dof_1 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 k_dof_2 = _data_kVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1];
             const walberla::float64 k_dof_3 = _data_kVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))];
             const walberla::float64 k_dof_4 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const walberla::float64 k_dof_5 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const walberla::float64 k_dof_6 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1];
             const walberla::float64 k_dof_7 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             const walberla::float64 k_dof_8 = _data_kEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))];
             const walberla::float64 k_dof_9 = _data_kEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))];
             walberla::float64 q_acc_0_0 = 0.0;
             walberla::float64 q_acc_0_1 = 0.0;
             walberla::float64 q_acc_0_2 = 0.0;
             walberla::float64 q_acc_0_3 = 0.0;
             walberla::float64 q_acc_0_4 = 0.0;
             walberla::float64 q_acc_0_5 = 0.0;
             walberla::float64 q_acc_0_6 = 0.0;
             walberla::float64 q_acc_0_7 = 0.0;
             walberla::float64 q_acc_0_8 = 0.0;
             walberla::float64 q_acc_0_9 = 0.0;
             walberla::float64 q_acc_1_1 = 0.0;
             walberla::float64 q_acc_1_2 = 0.0;
             walberla::float64 q_acc_1_3 = 0.0;
             walberla::float64 q_acc_1_4 = 0.0;
             walberla::float64 q_acc_1_5 = 0.0;
             walberla::float64 q_acc_1_6 = 0.0;
             walberla::float64 q_acc_1_7 = 0.0;
             walberla::float64 q_acc_1_8 = 0.0;
             walberla::float64 q_acc_1_9 = 0.0;
             walberla::float64 q_acc_2_2 = 0.0;
             walberla::float64 q_acc_2_3 = 0.0;
             walberla::float64 q_acc_2_4 = 0.0;
             walberla::float64 q_acc_2_5 = 0.0;
             walberla::float64 q_acc_2_6 = 0.0;
             walberla::float64 q_acc_2_7 = 0.0;
             walberla::float64 q_acc_2_8 = 0.0;
             walberla::float64 q_acc_2_9 = 0.0;
             walberla::float64 q_acc_3_3 = 0.0;
             walberla::float64 q_acc_3_4 = 0.0;
             walberla::float64 q_acc_3_5 = 0.0;
             walberla::float64 q_acc_3_6 = 0.0;
             walberla::float64 q_acc_3_7 = 0.0;
             walberla::float64 q_acc_3_8 = 0.0;
             walberla::float64 q_acc_3_9 = 0.0;
             walberla::float64 q_acc_4_4 = 0.0;
             walberla::float64 q_acc_4_5 = 0.0;
             walberla::float64 q_acc_4_6 = 0.0;
             walberla::float64 q_acc_4_7 = 0.0;
             walberla::float64 q_acc_4_8 = 0.0;
             walberla::float64 q_acc_4_9 = 0.0;
             walberla::float64 q_acc_5_5 = 0.0;
             walberla::float64 q_acc_5_6 = 0.0;
             walberla::float64 q_acc_5_7 = 0.0;
             walberla::float64 q_acc_5_8 = 0.0;
             walberla::float64 q_acc_5_9 = 0.0;
             walberla::float64 q_acc_6_6 = 0.0;
             walberla::float64 q_acc_6_7 = 0.0;
             walberla::float64 q_acc_6_8 = 0.0;
             walberla::float64 q_acc_6_9 = 0.0;
             walberla::float64 q_acc_7_7 = 0.0;
             walberla::float64 q_acc_7_8 = 0.0;
             walberla::float64 q_acc_7_9 = 0.0;
             walberla::float64 q_acc_8_8 = 0.0;
             walberla::float64 q_acc_8_9 = 0.0;
             walberla::float64 q_acc_9_9 = 0.0;
             for (int64_t q = 0; q < 4; q += 1)
             {
                const walberla::float64 tmp_qloop_0 = 4.0*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_1 = 4.0*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_2 = 4.0*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_3 = tmp_qloop_1 + tmp_qloop_2;
                const walberla::float64 tmp_qloop_4 = tmp_qloop_0 + tmp_qloop_3 - 3.0;
                const walberla::float64 tmp_qloop_5 = jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_4 + jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_4 + jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_4;
                const walberla::float64 tmp_qloop_6 = jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_4 + jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_4 + jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_4;
                const walberla::float64 tmp_qloop_7 = jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_4 + jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_4 + jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_4;
                const walberla::float64 tmp_qloop_8 = tmp_qloop_1*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_9 = tmp_qloop_1*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_10 = tmp_qloop_2*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_11 = (_data_q_p_0[q]*_data_q_p_0[q]);
                const walberla::float64 tmp_qloop_12 = tmp_qloop_11*2.0;
                const walberla::float64 tmp_qloop_13 = (_data_q_p_1[q]*_data_q_p_1[q]);
                const walberla::float64 tmp_qloop_14 = tmp_qloop_13*2.0;
                const walberla::float64 tmp_qloop_15 = (_data_q_p_2[q]*_data_q_p_2[q]);
                const walberla::float64 tmp_qloop_16 = tmp_qloop_15*2.0;
                const walberla::float64 tmp_qloop_17 = tmp_qloop_8 + tmp_qloop_9;
                const walberla::float64 tmp_qloop_18 = abs_det_jac_affine_GREEN_DOWN*(k_dof_0*(tmp_qloop_10 + tmp_qloop_12 + tmp_qloop_14 + tmp_qloop_16 + tmp_qloop_17 - 3.0*_data_q_p_0[q] - 3.0*_data_q_p_1[q] - 3.0*_data_q_p_2[q] + 1.0) + k_dof_1*(tmp_qloop_12 - _data_q_p_0[q]) + k_dof_2*(tmp_qloop_14 - _data_q_p_1[q]) + k_dof_3*(tmp_qloop_16 - _data_q_p_2[q]) + k_dof_4*tmp_qloop_10 + k_dof_5*tmp_qloop_9 + k_dof_6*tmp_qloop_8 + k_dof_7*(tmp_qloop_0 - tmp_qloop_10 + tmp_qloop_15*-4.0 - tmp_qloop_9) + k_dof_8*(-tmp_qloop_10 + tmp_qloop_13*-4.0 + tmp_qloop_2 - tmp_qloop_8) + k_dof_9*(tmp_qloop_1 + tmp_qloop_11*-4.0 - tmp_qloop_17))*_data_q_w[q];
                const walberla::float64 tmp_qloop_19 = tmp_qloop_1 - 1.0;
                const walberla::float64 tmp_qloop_20 = jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_19;
                const walberla::float64 tmp_qloop_21 = jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_19;
                const walberla::float64 tmp_qloop_22 = jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_19;
                const walberla::float64 tmp_qloop_23 = tmp_qloop_2 - 1.0;
                const walberla::float64 tmp_qloop_24 = jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_23;
                const walberla::float64 tmp_qloop_25 = jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_23;
                const walberla::float64 tmp_qloop_26 = jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_23;
                const walberla::float64 tmp_qloop_27 = tmp_qloop_0 - 1.0;
                const walberla::float64 tmp_qloop_28 = jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_27;
                const walberla::float64 tmp_qloop_29 = jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_27;
                const walberla::float64 tmp_qloop_30 = jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_27;
                const walberla::float64 tmp_qloop_31 = jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_2;
                const walberla::float64 tmp_qloop_32 = jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_0;
                const walberla::float64 tmp_qloop_33 = tmp_qloop_31 + tmp_qloop_32;
                const walberla::float64 tmp_qloop_34 = jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_2;
                const walberla::float64 tmp_qloop_35 = jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_0;
                const walberla::float64 tmp_qloop_36 = tmp_qloop_34 + tmp_qloop_35;
                const walberla::float64 tmp_qloop_37 = jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_2;
                const walberla::float64 tmp_qloop_38 = jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_0;
                const walberla::float64 tmp_qloop_39 = tmp_qloop_37 + tmp_qloop_38;
                const walberla::float64 tmp_qloop_40 = jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_1;
                const walberla::float64 tmp_qloop_41 = jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_0;
                const walberla::float64 tmp_qloop_42 = tmp_qloop_40 + tmp_qloop_41;
                const walberla::float64 tmp_qloop_43 = jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_1;
                const walberla::float64 tmp_qloop_44 = jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_0;
                const walberla::float64 tmp_qloop_45 = tmp_qloop_43 + tmp_qloop_44;
                const walberla::float64 tmp_qloop_46 = jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_1;
                const walberla::float64 tmp_qloop_47 = jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_0;
                const walberla::float64 tmp_qloop_48 = tmp_qloop_46 + tmp_qloop_47;
                const walberla::float64 tmp_qloop_49 = jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_1;
                const walberla::float64 tmp_qloop_50 = jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_2;
                const walberla::float64 tmp_qloop_51 = tmp_qloop_49 + tmp_qloop_50;
                const walberla::float64 tmp_qloop_52 = jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_1;
                const walberla::float64 tmp_qloop_53 = jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_2;
                const walberla::float64 tmp_qloop_54 = tmp_qloop_52 + tmp_qloop_53;
                const walberla::float64 tmp_qloop_55 = jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_1;
                const walberla::float64 tmp_qloop_56 = jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_2;
                const walberla::float64 tmp_qloop_57 = tmp_qloop_55 + tmp_qloop_56;
                const walberla::float64 tmp_qloop_58 = -tmp_qloop_3 - 8.0*_data_q_p_2[q] + 4.0;
                const walberla::float64 tmp_qloop_59 = jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_58 - tmp_qloop_32 - tmp_qloop_41;
                const walberla::float64 tmp_qloop_60 = jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_58 - tmp_qloop_35 - tmp_qloop_44;
                const walberla::float64 tmp_qloop_61 = jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_58 - tmp_qloop_38 - tmp_qloop_47;
                const walberla::float64 tmp_qloop_62 = tmp_qloop_0 - 4.0;
                const walberla::float64 tmp_qloop_63 = -tmp_qloop_1 - tmp_qloop_62 - 8.0*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_64 = jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_63 - tmp_qloop_31 - tmp_qloop_50;
                const walberla::float64 tmp_qloop_65 = jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_63 - tmp_qloop_34 - tmp_qloop_53;
                const walberla::float64 tmp_qloop_66 = jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_63 - tmp_qloop_37 - tmp_qloop_56;
                const walberla::float64 tmp_qloop_67 = -tmp_qloop_2 - tmp_qloop_62 - 8.0*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_68 = jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_67 - tmp_qloop_40 - tmp_qloop_49;
                const walberla::float64 tmp_qloop_69 = jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_67 - tmp_qloop_43 - tmp_qloop_52;
                const walberla::float64 tmp_qloop_70 = jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_67 - tmp_qloop_46 - tmp_qloop_55;
                const walberla::float64 tmp_qloop_71 = ((-0.25 + _data_q_p_0[q])*(-0.25 + _data_q_p_0[q]))*16.0;
                const walberla::float64 tmp_qloop_72 = ((-0.25 + _data_q_p_1[q])*(-0.25 + _data_q_p_1[q]))*16.0;
                const walberla::float64 tmp_qloop_73 = ((-0.25 + _data_q_p_2[q])*(-0.25 + _data_q_p_2[q]))*16.0;
                const walberla::float64 tmp_qloop_74 = jac_affine_inv_2_0_GREEN_DOWN*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_75 = jac_affine_inv_1_0_GREEN_DOWN*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_76 = jac_affine_inv_2_1_GREEN_DOWN*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_77 = jac_affine_inv_1_1_GREEN_DOWN*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_78 = jac_affine_inv_2_2_GREEN_DOWN*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_79 = jac_affine_inv_1_2_GREEN_DOWN*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_80 = jac_affine_inv_2_0_GREEN_DOWN*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_81 = jac_affine_inv_0_0_GREEN_DOWN*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_82 = jac_affine_inv_2_1_GREEN_DOWN*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_83 = jac_affine_inv_0_1_GREEN_DOWN*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_84 = jac_affine_inv_2_2_GREEN_DOWN*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_85 = jac_affine_inv_0_2_GREEN_DOWN*_data_q_p_2[q];
                const walberla::float64 tmp_qloop_86 = jac_affine_inv_1_0_GREEN_DOWN*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_87 = jac_affine_inv_0_0_GREEN_DOWN*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_88 = jac_affine_inv_1_1_GREEN_DOWN*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_89 = jac_affine_inv_0_1_GREEN_DOWN*_data_q_p_1[q];
                const walberla::float64 tmp_qloop_90 = jac_affine_inv_1_2_GREEN_DOWN*_data_q_p_0[q];
                const walberla::float64 tmp_qloop_91 = jac_affine_inv_0_2_GREEN_DOWN*_data_q_p_1[q];
                const walberla::float64 q_tmp_0_0 = tmp_qloop_18*((tmp_qloop_5*tmp_qloop_5) + (tmp_qloop_6*tmp_qloop_6) + (tmp_qloop_7*tmp_qloop_7));
                const walberla::float64 q_tmp_0_1 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_5 + tmp_qloop_21*tmp_qloop_6 + tmp_qloop_22*tmp_qloop_7);
                const walberla::float64 q_tmp_0_2 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_5 + tmp_qloop_25*tmp_qloop_6 + tmp_qloop_26*tmp_qloop_7);
                const walberla::float64 q_tmp_0_3 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_5 + tmp_qloop_29*tmp_qloop_6 + tmp_qloop_30*tmp_qloop_7);
                const walberla::float64 q_tmp_0_4 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_5 + tmp_qloop_36*tmp_qloop_6 + tmp_qloop_39*tmp_qloop_7);
                const walberla::float64 q_tmp_0_5 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_5 + tmp_qloop_45*tmp_qloop_6 + tmp_qloop_48*tmp_qloop_7);
                const walberla::float64 q_tmp_0_6 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_51 + tmp_qloop_54*tmp_qloop_6 + tmp_qloop_57*tmp_qloop_7);
                const walberla::float64 q_tmp_0_7 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_59 + tmp_qloop_6*tmp_qloop_60 + tmp_qloop_61*tmp_qloop_7);
                const walberla::float64 q_tmp_0_8 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_64 + tmp_qloop_6*tmp_qloop_65 + tmp_qloop_66*tmp_qloop_7);
                const walberla::float64 q_tmp_0_9 = tmp_qloop_18*(tmp_qloop_5*tmp_qloop_68 + tmp_qloop_6*tmp_qloop_69 + tmp_qloop_7*tmp_qloop_70);
                const walberla::float64 q_tmp_1_1 = tmp_qloop_18*((jac_affine_inv_0_0_GREEN_DOWN*jac_affine_inv_0_0_GREEN_DOWN)*tmp_qloop_71 + (jac_affine_inv_0_1_GREEN_DOWN*jac_affine_inv_0_1_GREEN_DOWN)*tmp_qloop_71 + (jac_affine_inv_0_2_GREEN_DOWN*jac_affine_inv_0_2_GREEN_DOWN)*tmp_qloop_71);
                const walberla::float64 q_tmp_1_2 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_24 + tmp_qloop_21*tmp_qloop_25 + tmp_qloop_22*tmp_qloop_26);
                const walberla::float64 q_tmp_1_3 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_28 + tmp_qloop_21*tmp_qloop_29 + tmp_qloop_22*tmp_qloop_30);
                const walberla::float64 q_tmp_1_4 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_33 + tmp_qloop_21*tmp_qloop_36 + tmp_qloop_22*tmp_qloop_39);
                const walberla::float64 q_tmp_1_5 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_42 + tmp_qloop_21*tmp_qloop_45 + tmp_qloop_22*tmp_qloop_48);
                const walberla::float64 q_tmp_1_6 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_51 + tmp_qloop_21*tmp_qloop_54 + tmp_qloop_22*tmp_qloop_57);
                const walberla::float64 q_tmp_1_7 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_59 + tmp_qloop_21*tmp_qloop_60 + tmp_qloop_22*tmp_qloop_61);
                const walberla::float64 q_tmp_1_8 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_64 + tmp_qloop_21*tmp_qloop_65 + tmp_qloop_22*tmp_qloop_66);
                const walberla::float64 q_tmp_1_9 = tmp_qloop_18*(tmp_qloop_20*tmp_qloop_68 + tmp_qloop_21*tmp_qloop_69 + tmp_qloop_22*tmp_qloop_70);
                const walberla::float64 q_tmp_2_2 = tmp_qloop_18*((jac_affine_inv_1_0_GREEN_DOWN*jac_affine_inv_1_0_GREEN_DOWN)*tmp_qloop_72 + (jac_affine_inv_1_1_GREEN_DOWN*jac_affine_inv_1_1_GREEN_DOWN)*tmp_qloop_72 + (jac_affine_inv_1_2_GREEN_DOWN*jac_affine_inv_1_2_GREEN_DOWN)*tmp_qloop_72);
                const walberla::float64 q_tmp_2_3 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_28 + tmp_qloop_25*tmp_qloop_29 + tmp_qloop_26*tmp_qloop_30);
                const walberla::float64 q_tmp_2_4 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_33 + tmp_qloop_25*tmp_qloop_36 + tmp_qloop_26*tmp_qloop_39);
                const walberla::float64 q_tmp_2_5 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_42 + tmp_qloop_25*tmp_qloop_45 + tmp_qloop_26*tmp_qloop_48);
                const walberla::float64 q_tmp_2_6 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_51 + tmp_qloop_25*tmp_qloop_54 + tmp_qloop_26*tmp_qloop_57);
                const walberla::float64 q_tmp_2_7 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_59 + tmp_qloop_25*tmp_qloop_60 + tmp_qloop_26*tmp_qloop_61);
                const walberla::float64 q_tmp_2_8 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_64 + tmp_qloop_25*tmp_qloop_65 + tmp_qloop_26*tmp_qloop_66);
                const walberla::float64 q_tmp_2_9 = tmp_qloop_18*(tmp_qloop_24*tmp_qloop_68 + tmp_qloop_25*tmp_qloop_69 + tmp_qloop_26*tmp_qloop_70);
                const walberla::float64 q_tmp_3_3 = tmp_qloop_18*((jac_affine_inv_2_0_GREEN_DOWN*jac_affine_inv_2_0_GREEN_DOWN)*tmp_qloop_73 + (jac_affine_inv_2_1_GREEN_DOWN*jac_affine_inv_2_1_GREEN_DOWN)*tmp_qloop_73 + (jac_affine_inv_2_2_GREEN_DOWN*jac_affine_inv_2_2_GREEN_DOWN)*tmp_qloop_73);
                const walberla::float64 q_tmp_3_4 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_33 + tmp_qloop_29*tmp_qloop_36 + tmp_qloop_30*tmp_qloop_39);
                const walberla::float64 q_tmp_3_5 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_42 + tmp_qloop_29*tmp_qloop_45 + tmp_qloop_30*tmp_qloop_48);
                const walberla::float64 q_tmp_3_6 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_51 + tmp_qloop_29*tmp_qloop_54 + tmp_qloop_30*tmp_qloop_57);
                const walberla::float64 q_tmp_3_7 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_59 + tmp_qloop_29*tmp_qloop_60 + tmp_qloop_30*tmp_qloop_61);
                const walberla::float64 q_tmp_3_8 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_64 + tmp_qloop_29*tmp_qloop_65 + tmp_qloop_30*tmp_qloop_66);
                const walberla::float64 q_tmp_3_9 = tmp_qloop_18*(tmp_qloop_28*tmp_qloop_68 + tmp_qloop_29*tmp_qloop_69 + tmp_qloop_30*tmp_qloop_70);
                const walberla::float64 q_tmp_4_4 = tmp_qloop_18*(((tmp_qloop_74 + tmp_qloop_75)*(tmp_qloop_74 + tmp_qloop_75))*16.0 + ((tmp_qloop_76 + tmp_qloop_77)*(tmp_qloop_76 + tmp_qloop_77))*16.0 + ((tmp_qloop_78 + tmp_qloop_79)*(tmp_qloop_78 + tmp_qloop_79))*16.0);
                const walberla::float64 q_tmp_4_5 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_42 + tmp_qloop_36*tmp_qloop_45 + tmp_qloop_39*tmp_qloop_48);
                const walberla::float64 q_tmp_4_6 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_51 + tmp_qloop_36*tmp_qloop_54 + tmp_qloop_39*tmp_qloop_57);
                const walberla::float64 q_tmp_4_7 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_59 + tmp_qloop_36*tmp_qloop_60 + tmp_qloop_39*tmp_qloop_61);
                const walberla::float64 q_tmp_4_8 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_64 + tmp_qloop_36*tmp_qloop_65 + tmp_qloop_39*tmp_qloop_66);
                const walberla::float64 q_tmp_4_9 = tmp_qloop_18*(tmp_qloop_33*tmp_qloop_68 + tmp_qloop_36*tmp_qloop_69 + tmp_qloop_39*tmp_qloop_70);
                const walberla::float64 q_tmp_5_5 = tmp_qloop_18*(((tmp_qloop_80 + tmp_qloop_81)*(tmp_qloop_80 + tmp_qloop_81))*16.0 + ((tmp_qloop_82 + tmp_qloop_83)*(tmp_qloop_82 + tmp_qloop_83))*16.0 + ((tmp_qloop_84 + tmp_qloop_85)*(tmp_qloop_84 + tmp_qloop_85))*16.0);
                const walberla::float64 q_tmp_5_6 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_51 + tmp_qloop_45*tmp_qloop_54 + tmp_qloop_48*tmp_qloop_57);
                const walberla::float64 q_tmp_5_7 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_59 + tmp_qloop_45*tmp_qloop_60 + tmp_qloop_48*tmp_qloop_61);
                const walberla::float64 q_tmp_5_8 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_64 + tmp_qloop_45*tmp_qloop_65 + tmp_qloop_48*tmp_qloop_66);
                const walberla::float64 q_tmp_5_9 = tmp_qloop_18*(tmp_qloop_42*tmp_qloop_68 + tmp_qloop_45*tmp_qloop_69 + tmp_qloop_48*tmp_qloop_70);
                const walberla::float64 q_tmp_6_6 = tmp_qloop_18*(((tmp_qloop_86 + tmp_qloop_87)*(tmp_qloop_86 + tmp_qloop_87))*16.0 + ((tmp_qloop_88 + tmp_qloop_89)*(tmp_qloop_88 + tmp_qloop_89))*16.0 + ((tmp_qloop_90 + tmp_qloop_91)*(tmp_qloop_90 + tmp_qloop_91))*16.0);
                const walberla::float64 q_tmp_6_7 = tmp_qloop_18*(tmp_qloop_51*tmp_qloop_59 + tmp_qloop_54*tmp_qloop_60 + tmp_qloop_57*tmp_qloop_61);
                const walberla::float64 q_tmp_6_8 = tmp_qloop_18*(tmp_qloop_51*tmp_qloop_64 + tmp_qloop_54*tmp_qloop_65 + tmp_qloop_57*tmp_qloop_66);
                const walberla::float64 q_tmp_6_9 = tmp_qloop_18*(tmp_qloop_51*tmp_qloop_68 + tmp_qloop_54*tmp_qloop_69 + tmp_qloop_57*tmp_qloop_70);
                const walberla::float64 q_tmp_7_7 = tmp_qloop_18*(((jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_58*0.25 - tmp_qloop_75 - tmp_qloop_81)*(jac_affine_inv_2_0_GREEN_DOWN*tmp_qloop_58*0.25 - tmp_qloop_75 - tmp_qloop_81))*16.0 + ((jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_58*0.25 - tmp_qloop_77 - tmp_qloop_83)*(jac_affine_inv_2_1_GREEN_DOWN*tmp_qloop_58*0.25 - tmp_qloop_77 - tmp_qloop_83))*16.0 + ((jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_58*0.25 - tmp_qloop_79 - tmp_qloop_85)*(jac_affine_inv_2_2_GREEN_DOWN*tmp_qloop_58*0.25 - tmp_qloop_79 - tmp_qloop_85))*16.0);
                const walberla::float64 q_tmp_7_8 = tmp_qloop_18*(tmp_qloop_59*tmp_qloop_64 + tmp_qloop_60*tmp_qloop_65 + tmp_qloop_61*tmp_qloop_66);
                const walberla::float64 q_tmp_7_9 = tmp_qloop_18*(tmp_qloop_59*tmp_qloop_68 + tmp_qloop_60*tmp_qloop_69 + tmp_qloop_61*tmp_qloop_70);
                const walberla::float64 q_tmp_8_8 = tmp_qloop_18*(((jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_63*0.25 - tmp_qloop_74 - tmp_qloop_87)*(jac_affine_inv_1_0_GREEN_DOWN*tmp_qloop_63*0.25 - tmp_qloop_74 - tmp_qloop_87))*16.0 + ((jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_63*0.25 - tmp_qloop_76 - tmp_qloop_89)*(jac_affine_inv_1_1_GREEN_DOWN*tmp_qloop_63*0.25 - tmp_qloop_76 - tmp_qloop_89))*16.0 + ((jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_63*0.25 - tmp_qloop_78 - tmp_qloop_91)*(jac_affine_inv_1_2_GREEN_DOWN*tmp_qloop_63*0.25 - tmp_qloop_78 - tmp_qloop_91))*16.0);
                const walberla::float64 q_tmp_8_9 = tmp_qloop_18*(tmp_qloop_64*tmp_qloop_68 + tmp_qloop_65*tmp_qloop_69 + tmp_qloop_66*tmp_qloop_70);
                const walberla::float64 q_tmp_9_9 = tmp_qloop_18*(((jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_67*0.25 - tmp_qloop_80 - tmp_qloop_86)*(jac_affine_inv_0_0_GREEN_DOWN*tmp_qloop_67*0.25 - tmp_qloop_80 - tmp_qloop_86))*16.0 + ((jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_67*0.25 - tmp_qloop_82 - tmp_qloop_88)*(jac_affine_inv_0_1_GREEN_DOWN*tmp_qloop_67*0.25 - tmp_qloop_82 - tmp_qloop_88))*16.0 + ((jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_67*0.25 - tmp_qloop_84 - tmp_qloop_90)*(jac_affine_inv_0_2_GREEN_DOWN*tmp_qloop_67*0.25 - tmp_qloop_84 - tmp_qloop_90))*16.0);
                q_acc_0_0 = q_acc_0_0 + q_tmp_0_0;
                q_acc_0_1 = q_acc_0_1 + q_tmp_0_1;
                q_acc_0_2 = q_acc_0_2 + q_tmp_0_2;
                q_acc_0_3 = q_acc_0_3 + q_tmp_0_3;
                q_acc_0_4 = q_acc_0_4 + q_tmp_0_4;
                q_acc_0_5 = q_acc_0_5 + q_tmp_0_5;
                q_acc_0_6 = q_acc_0_6 + q_tmp_0_6;
                q_acc_0_7 = q_acc_0_7 + q_tmp_0_7;
                q_acc_0_8 = q_acc_0_8 + q_tmp_0_8;
                q_acc_0_9 = q_acc_0_9 + q_tmp_0_9;
                q_acc_1_1 = q_acc_1_1 + q_tmp_1_1;
                q_acc_1_2 = q_acc_1_2 + q_tmp_1_2;
                q_acc_1_3 = q_acc_1_3 + q_tmp_1_3;
                q_acc_1_4 = q_acc_1_4 + q_tmp_1_4;
                q_acc_1_5 = q_acc_1_5 + q_tmp_1_5;
                q_acc_1_6 = q_acc_1_6 + q_tmp_1_6;
                q_acc_1_7 = q_acc_1_7 + q_tmp_1_7;
                q_acc_1_8 = q_acc_1_8 + q_tmp_1_8;
                q_acc_1_9 = q_acc_1_9 + q_tmp_1_9;
                q_acc_2_2 = q_acc_2_2 + q_tmp_2_2;
                q_acc_2_3 = q_acc_2_3 + q_tmp_2_3;
                q_acc_2_4 = q_acc_2_4 + q_tmp_2_4;
                q_acc_2_5 = q_acc_2_5 + q_tmp_2_5;
                q_acc_2_6 = q_acc_2_6 + q_tmp_2_6;
                q_acc_2_7 = q_acc_2_7 + q_tmp_2_7;
                q_acc_2_8 = q_acc_2_8 + q_tmp_2_8;
                q_acc_2_9 = q_acc_2_9 + q_tmp_2_9;
                q_acc_3_3 = q_acc_3_3 + q_tmp_3_3;
                q_acc_3_4 = q_acc_3_4 + q_tmp_3_4;
                q_acc_3_5 = q_acc_3_5 + q_tmp_3_5;
                q_acc_3_6 = q_acc_3_6 + q_tmp_3_6;
                q_acc_3_7 = q_acc_3_7 + q_tmp_3_7;
                q_acc_3_8 = q_acc_3_8 + q_tmp_3_8;
                q_acc_3_9 = q_acc_3_9 + q_tmp_3_9;
                q_acc_4_4 = q_acc_4_4 + q_tmp_4_4;
                q_acc_4_5 = q_acc_4_5 + q_tmp_4_5;
                q_acc_4_6 = q_acc_4_6 + q_tmp_4_6;
                q_acc_4_7 = q_acc_4_7 + q_tmp_4_7;
                q_acc_4_8 = q_acc_4_8 + q_tmp_4_8;
                q_acc_4_9 = q_acc_4_9 + q_tmp_4_9;
                q_acc_5_5 = q_acc_5_5 + q_tmp_5_5;
                q_acc_5_6 = q_acc_5_6 + q_tmp_5_6;
                q_acc_5_7 = q_acc_5_7 + q_tmp_5_7;
                q_acc_5_8 = q_acc_5_8 + q_tmp_5_8;
                q_acc_5_9 = q_acc_5_9 + q_tmp_5_9;
                q_acc_6_6 = q_acc_6_6 + q_tmp_6_6;
                q_acc_6_7 = q_acc_6_7 + q_tmp_6_7;
                q_acc_6_8 = q_acc_6_8 + q_tmp_6_8;
                q_acc_6_9 = q_acc_6_9 + q_tmp_6_9;
                q_acc_7_7 = q_acc_7_7 + q_tmp_7_7;
                q_acc_7_8 = q_acc_7_8 + q_tmp_7_8;
                q_acc_7_9 = q_acc_7_9 + q_tmp_7_9;
                q_acc_8_8 = q_acc_8_8 + q_tmp_8_8;
                q_acc_8_9 = q_acc_8_9 + q_tmp_8_9;
                q_acc_9_9 = q_acc_9_9 + q_tmp_9_9;
             }
             const walberla::float64 elMat_0_0 = q_acc_0_0;
             const walberla::float64 elMat_0_1 = q_acc_0_1;
             const walberla::float64 elMat_0_2 = q_acc_0_2;
             const walberla::float64 elMat_0_3 = q_acc_0_3;
             const walberla::float64 elMat_0_4 = q_acc_0_4;
             const walberla::float64 elMat_0_5 = q_acc_0_5;
             const walberla::float64 elMat_0_6 = q_acc_0_6;
             const walberla::float64 elMat_0_7 = q_acc_0_7;
             const walberla::float64 elMat_0_8 = q_acc_0_8;
             const walberla::float64 elMat_0_9 = q_acc_0_9;
             const walberla::float64 elMat_1_0 = q_acc_0_1;
             const walberla::float64 elMat_1_1 = q_acc_1_1;
             const walberla::float64 elMat_1_2 = q_acc_1_2;
             const walberla::float64 elMat_1_3 = q_acc_1_3;
             const walberla::float64 elMat_1_4 = q_acc_1_4;
             const walberla::float64 elMat_1_5 = q_acc_1_5;
             const walberla::float64 elMat_1_6 = q_acc_1_6;
             const walberla::float64 elMat_1_7 = q_acc_1_7;
             const walberla::float64 elMat_1_8 = q_acc_1_8;
             const walberla::float64 elMat_1_9 = q_acc_1_9;
             const walberla::float64 elMat_2_0 = q_acc_0_2;
             const walberla::float64 elMat_2_1 = q_acc_1_2;
             const walberla::float64 elMat_2_2 = q_acc_2_2;
             const walberla::float64 elMat_2_3 = q_acc_2_3;
             const walberla::float64 elMat_2_4 = q_acc_2_4;
             const walberla::float64 elMat_2_5 = q_acc_2_5;
             const walberla::float64 elMat_2_6 = q_acc_2_6;
             const walberla::float64 elMat_2_7 = q_acc_2_7;
             const walberla::float64 elMat_2_8 = q_acc_2_8;
             const walberla::float64 elMat_2_9 = q_acc_2_9;
             const walberla::float64 elMat_3_0 = q_acc_0_3;
             const walberla::float64 elMat_3_1 = q_acc_1_3;
             const walberla::float64 elMat_3_2 = q_acc_2_3;
             const walberla::float64 elMat_3_3 = q_acc_3_3;
             const walberla::float64 elMat_3_4 = q_acc_3_4;
             const walberla::float64 elMat_3_5 = q_acc_3_5;
             const walberla::float64 elMat_3_6 = q_acc_3_6;
             const walberla::float64 elMat_3_7 = q_acc_3_7;
             const walberla::float64 elMat_3_8 = q_acc_3_8;
             const walberla::float64 elMat_3_9 = q_acc_3_9;
             const walberla::float64 elMat_4_0 = q_acc_0_4;
             const walberla::float64 elMat_4_1 = q_acc_1_4;
             const walberla::float64 elMat_4_2 = q_acc_2_4;
             const walberla::float64 elMat_4_3 = q_acc_3_4;
             const walberla::float64 elMat_4_4 = q_acc_4_4;
             const walberla::float64 elMat_4_5 = q_acc_4_5;
             const walberla::float64 elMat_4_6 = q_acc_4_6;
             const walberla::float64 elMat_4_7 = q_acc_4_7;
             const walberla::float64 elMat_4_8 = q_acc_4_8;
             const walberla::float64 elMat_4_9 = q_acc_4_9;
             const walberla::float64 elMat_5_0 = q_acc_0_5;
             const walberla::float64 elMat_5_1 = q_acc_1_5;
             const walberla::float64 elMat_5_2 = q_acc_2_5;
             const walberla::float64 elMat_5_3 = q_acc_3_5;
             const walberla::float64 elMat_5_4 = q_acc_4_5;
             const walberla::float64 elMat_5_5 = q_acc_5_5;
             const walberla::float64 elMat_5_6 = q_acc_5_6;
             const walberla::float64 elMat_5_7 = q_acc_5_7;
             const walberla::float64 elMat_5_8 = q_acc_5_8;
             const walberla::float64 elMat_5_9 = q_acc_5_9;
             const walberla::float64 elMat_6_0 = q_acc_0_6;
             const walberla::float64 elMat_6_1 = q_acc_1_6;
             const walberla::float64 elMat_6_2 = q_acc_2_6;
             const walberla::float64 elMat_6_3 = q_acc_3_6;
             const walberla::float64 elMat_6_4 = q_acc_4_6;
             const walberla::float64 elMat_6_5 = q_acc_5_6;
             const walberla::float64 elMat_6_6 = q_acc_6_6;
             const walberla::float64 elMat_6_7 = q_acc_6_7;
             const walberla::float64 elMat_6_8 = q_acc_6_8;
             const walberla::float64 elMat_6_9 = q_acc_6_9;
             const walberla::float64 elMat_7_0 = q_acc_0_7;
             const walberla::float64 elMat_7_1 = q_acc_1_7;
             const walberla::float64 elMat_7_2 = q_acc_2_7;
             const walberla::float64 elMat_7_3 = q_acc_3_7;
             const walberla::float64 elMat_7_4 = q_acc_4_7;
             const walberla::float64 elMat_7_5 = q_acc_5_7;
             const walberla::float64 elMat_7_6 = q_acc_6_7;
             const walberla::float64 elMat_7_7 = q_acc_7_7;
             const walberla::float64 elMat_7_8 = q_acc_7_8;
             const walberla::float64 elMat_7_9 = q_acc_7_9;
             const walberla::float64 elMat_8_0 = q_acc_0_8;
             const walberla::float64 elMat_8_1 = q_acc_1_8;
             const walberla::float64 elMat_8_2 = q_acc_2_8;
             const walberla::float64 elMat_8_3 = q_acc_3_8;
             const walberla::float64 elMat_8_4 = q_acc_4_8;
             const walberla::float64 elMat_8_5 = q_acc_5_8;
             const walberla::float64 elMat_8_6 = q_acc_6_8;
             const walberla::float64 elMat_8_7 = q_acc_7_8;
             const walberla::float64 elMat_8_8 = q_acc_8_8;
             const walberla::float64 elMat_8_9 = q_acc_8_9;
             const walberla::float64 elMat_9_0 = q_acc_0_9;
             const walberla::float64 elMat_9_1 = q_acc_1_9;
             const walberla::float64 elMat_9_2 = q_acc_2_9;
             const walberla::float64 elMat_9_3 = q_acc_3_9;
             const walberla::float64 elMat_9_4 = q_acc_4_9;
             const walberla::float64 elMat_9_5 = q_acc_5_9;
             const walberla::float64 elMat_9_6 = q_acc_6_9;
             const walberla::float64 elMat_9_7 = q_acc_7_9;
             const walberla::float64 elMat_9_8 = q_acc_8_9;
             const walberla::float64 elMat_9_9 = q_acc_9_9;
         
             std::vector< uint_t > _data_rowIdx( 10 );
             std::vector< uint_t > _data_colIdx( 10 );
             std::vector< walberla::float64 > _data_mat( 100 );
         
             _data_rowIdx[0] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[1] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[2] = ((uint64_t)(_data_dstVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_rowIdx[3] = ((uint64_t)(_data_dstVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_rowIdx[4] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[5] = ((uint64_t)(_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[6] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_rowIdx[7] = ((uint64_t)(_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_rowIdx[8] = ((uint64_t)(_data_dstEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_rowIdx[9] = ((uint64_t)(_data_dstEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[0] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[1] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)*(-ctr_2 + micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[2] = ((uint64_t)(_data_srcVertex[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6)) + 1]));
             _data_colIdx[3] = ((uint64_t)(_data_srcVertex[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + (((micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)*(micro_edges_per_macro_edge + 3)) / (6))]));
             _data_colIdx[4] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + 4*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[5] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 5*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[6] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge + 1) - ((ctr_1*(ctr_1 + 1)) / (2)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6)) + 1]));
             _data_colIdx[7] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + 3*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
             _data_colIdx[8] = ((uint64_t)(_data_srcEdge[ctr_0 + ctr_1*(-ctr_2 + micro_edges_per_macro_edge) - ((ctr_1*(ctr_1 + 1)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge - 1)*(micro_edges_per_macro_edge + 1)) / (6)) + 6*((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge - 1)*(-ctr_2 + micro_edges_per_macro_edge + 1)) / (6))]));
             _data_colIdx[9] = ((uint64_t)(_data_srcEdge[ctr_0 + (ctr_1 + 1)*(-ctr_2 + micro_edges_per_macro_edge + 1) - (((ctr_1 + 1)*(ctr_1 + 2)) / (2)) + ((micro_edges_per_macro_edge*(micro_edges_per_macro_edge + 1)*(micro_edges_per_macro_edge + 2)) / (6)) - (((-ctr_2 + micro_edges_per_macro_edge)*(-ctr_2 + micro_edges_per_macro_edge + 1)*(-ctr_2 + micro_edges_per_macro_edge + 2)) / (6))]));
         
             /* Apply basis transformation */
         
         
         
             _data_mat[0] = ((walberla::float64)(elMat_0_0));
             _data_mat[1] = ((walberla::float64)(elMat_0_1));
             _data_mat[2] = ((walberla::float64)(elMat_0_2));
             _data_mat[3] = ((walberla::float64)(elMat_0_3));
             _data_mat[4] = ((walberla::float64)(elMat_0_4));
             _data_mat[5] = ((walberla::float64)(elMat_0_5));
             _data_mat[6] = ((walberla::float64)(elMat_0_6));
             _data_mat[7] = ((walberla::float64)(elMat_0_7));
             _data_mat[8] = ((walberla::float64)(elMat_0_8));
             _data_mat[9] = ((walberla::float64)(elMat_0_9));
             _data_mat[10] = ((walberla::float64)(elMat_1_0));
             _data_mat[11] = ((walberla::float64)(elMat_1_1));
             _data_mat[12] = ((walberla::float64)(elMat_1_2));
             _data_mat[13] = ((walberla::float64)(elMat_1_3));
             _data_mat[14] = ((walberla::float64)(elMat_1_4));
             _data_mat[15] = ((walberla::float64)(elMat_1_5));
             _data_mat[16] = ((walberla::float64)(elMat_1_6));
             _data_mat[17] = ((walberla::float64)(elMat_1_7));
             _data_mat[18] = ((walberla::float64)(elMat_1_8));
             _data_mat[19] = ((walberla::float64)(elMat_1_9));
             _data_mat[20] = ((walberla::float64)(elMat_2_0));
             _data_mat[21] = ((walberla::float64)(elMat_2_1));
             _data_mat[22] = ((walberla::float64)(elMat_2_2));
             _data_mat[23] = ((walberla::float64)(elMat_2_3));
             _data_mat[24] = ((walberla::float64)(elMat_2_4));
             _data_mat[25] = ((walberla::float64)(elMat_2_5));
             _data_mat[26] = ((walberla::float64)(elMat_2_6));
             _data_mat[27] = ((walberla::float64)(elMat_2_7));
             _data_mat[28] = ((walberla::float64)(elMat_2_8));
             _data_mat[29] = ((walberla::float64)(elMat_2_9));
             _data_mat[30] = ((walberla::float64)(elMat_3_0));
             _data_mat[31] = ((walberla::float64)(elMat_3_1));
             _data_mat[32] = ((walberla::float64)(elMat_3_2));
             _data_mat[33] = ((walberla::float64)(elMat_3_3));
             _data_mat[34] = ((walberla::float64)(elMat_3_4));
             _data_mat[35] = ((walberla::float64)(elMat_3_5));
             _data_mat[36] = ((walberla::float64)(elMat_3_6));
             _data_mat[37] = ((walberla::float64)(elMat_3_7));
             _data_mat[38] = ((walberla::float64)(elMat_3_8));
             _data_mat[39] = ((walberla::float64)(elMat_3_9));
             _data_mat[40] = ((walberla::float64)(elMat_4_0));
             _data_mat[41] = ((walberla::float64)(elMat_4_1));
             _data_mat[42] = ((walberla::float64)(elMat_4_2));
             _data_mat[43] = ((walberla::float64)(elMat_4_3));
             _data_mat[44] = ((walberla::float64)(elMat_4_4));
             _data_mat[45] = ((walberla::float64)(elMat_4_5));
             _data_mat[46] = ((walberla::float64)(elMat_4_6));
             _data_mat[47] = ((walberla::float64)(elMat_4_7));
             _data_mat[48] = ((walberla::float64)(elMat_4_8));
             _data_mat[49] = ((walberla::float64)(elMat_4_9));
             _data_mat[50] = ((walberla::float64)(elMat_5_0));
             _data_mat[51] = ((walberla::float64)(elMat_5_1));
             _data_mat[52] = ((walberla::float64)(elMat_5_2));
             _data_mat[53] = ((walberla::float64)(elMat_5_3));
             _data_mat[54] = ((walberla::float64)(elMat_5_4));
             _data_mat[55] = ((walberla::float64)(elMat_5_5));
             _data_mat[56] = ((walberla::float64)(elMat_5_6));
             _data_mat[57] = ((walberla::float64)(elMat_5_7));
             _data_mat[58] = ((walberla::float64)(elMat_5_8));
             _data_mat[59] = ((walberla::float64)(elMat_5_9));
             _data_mat[60] = ((walberla::float64)(elMat_6_0));
             _data_mat[61] = ((walberla::float64)(elMat_6_1));
             _data_mat[62] = ((walberla::float64)(elMat_6_2));
             _data_mat[63] = ((walberla::float64)(elMat_6_3));
             _data_mat[64] = ((walberla::float64)(elMat_6_4));
             _data_mat[65] = ((walberla::float64)(elMat_6_5));
             _data_mat[66] = ((walberla::float64)(elMat_6_6));
             _data_mat[67] = ((walberla::float64)(elMat_6_7));
             _data_mat[68] = ((walberla::float64)(elMat_6_8));
             _data_mat[69] = ((walberla::float64)(elMat_6_9));
             _data_mat[70] = ((walberla::float64)(elMat_7_0));
             _data_mat[71] = ((walberla::float64)(elMat_7_1));
             _data_mat[72] = ((walberla::float64)(elMat_7_2));
             _data_mat[73] = ((walberla::float64)(elMat_7_3));
             _data_mat[74] = ((walberla::float64)(elMat_7_4));
             _data_mat[75] = ((walberla::float64)(elMat_7_5));
             _data_mat[76] = ((walberla::float64)(elMat_7_6));
             _data_mat[77] = ((walberla::float64)(elMat_7_7));
             _data_mat[78] = ((walberla::float64)(elMat_7_8));
             _data_mat[79] = ((walberla::float64)(elMat_7_9));
             _data_mat[80] = ((walberla::float64)(elMat_8_0));
             _data_mat[81] = ((walberla::float64)(elMat_8_1));
             _data_mat[82] = ((walberla::float64)(elMat_8_2));
             _data_mat[83] = ((walberla::float64)(elMat_8_3));
             _data_mat[84] = ((walberla::float64)(elMat_8_4));
             _data_mat[85] = ((walberla::float64)(elMat_8_5));
             _data_mat[86] = ((walberla::float64)(elMat_8_6));
             _data_mat[87] = ((walberla::float64)(elMat_8_7));
             _data_mat[88] = ((walberla::float64)(elMat_8_8));
             _data_mat[89] = ((walberla::float64)(elMat_8_9));
             _data_mat[90] = ((walberla::float64)(elMat_9_0));
             _data_mat[91] = ((walberla::float64)(elMat_9_1));
             _data_mat[92] = ((walberla::float64)(elMat_9_2));
             _data_mat[93] = ((walberla::float64)(elMat_9_3));
             _data_mat[94] = ((walberla::float64)(elMat_9_4));
             _data_mat[95] = ((walberla::float64)(elMat_9_5));
             _data_mat[96] = ((walberla::float64)(elMat_9_6));
             _data_mat[97] = ((walberla::float64)(elMat_9_7));
             _data_mat[98] = ((walberla::float64)(elMat_9_8));
             _data_mat[99] = ((walberla::float64)(elMat_9_9));
         
         
             mat->addValues( _data_rowIdx, _data_colIdx, _data_mat );
          }
       }
    }
}
} // namespace operatorgeneration

} // namespace hyteg
